#include <stdio.h>
#include <stdlib.h>
#include <unistd.h> /* defines STDIN_FILENO */
#include <readline/readline.h>
#include <readline/history.h>

#include <string.h>
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <termios.h>
#include <unctrl.h>

static struct termios stored_settings;
#define window window_

#define readaline readaline_ 
#define addhist addhist_ 
#define clearhist clearhist_ 
#define key key_
#define term term_

static struct termios stored_settings;

extern struct term{
      int id1,npl,ncol[8],nrows[8],xpixel[8],ypixel[8];
      char winfile[16];
} term;

/* Simple example of using gnu readline to get lines of input from
   a user. Needs to be linked with -lreadline -lncurses
  add_history tells the readline library to add the line to it's
  internal history, so that using up-arrow (or ^p) will allows the user
  to see/edit previous lines.
*/

int readaline(int k[], char *prompt) {
    int i; char *s;
    s=readline(prompt);    
    if(s[0]=='\0'){i=0;} 
    else{for(i=0;s[i]!='\0';i++)k[i]=s[i];
    free(s);}          /* clean up! */ 
    return(i);	
}
void addhist( char *s) {
   add_history(s);	
}
void clearhist() {
   clear_history();
   	
}

void set_keypress(void)
{
    struct termios new_settings;
    tcgetattr(0,&stored_settings);
    new_settings = stored_settings;
    /* Disable canonical mode, and set buffer size to 1 byte */
    new_settings.c_lflag &= (~ICANON);
    new_settings.c_cc[VTIME] = 0;
    new_settings.c_cc[VMIN] = 1;
    new_settings.c_cc[VINTR]='#';
    /*new_settings.c_lflag &= (~ECHO);*/
    tcsetattr(0,TCSANOW,&new_settings);
    return;
}

void reset_keypress(void)
{
    tcsetattr(0,TCSANOW,&stored_settings);
    return;
}


int key(){
   unsigned int c,is;
   char ch; 
   set_keypress();
   c=getchar(); ch=*unctrl(c);
   if(c==10) ch='@';
   if(ch=='@'){is=0;c=ch;}else{is=iscntrl(c);}
   if(is>0){
   c=getchar(); 
   c=getchar(); c=-c;}   
   reset_keypress();
   return c;
}


static int pr_winsize(int fd, int it)
{
 struct winsize size;
 int i;

 if (isatty(fd) != 0){ i=1;
  if (ioctl(fd, TIOCGWINSZ, (char *) &size) < 0) i=0; 
/* printf("pr_winsize i=%d npl=%d \n",i, size.ws_col);*/
 }
 if(i==1){
  term.ncol[it]=size.ws_col;
  term.nrows[it]=size.ws_row;
  term.xpixel[it]=size.ws_xpixel;  
  term.ypixel[it]=size.ws_ypixel;
  if(size.ws_col==0){
   term.ncol[it]=80;
  term.npl=80;
  term.nrows[it]=24;  } 
 }else{
  term.ncol[it]=80;
  term.npl=80;
  term.nrows[it]=24;  }
 return(i); 
}

void window(int *i)
{char *tm;
 int it,ifile,j;
 it=*i-1;

 if(*i==1){
   pr_winsize(STDIN_FILENO,it);
   term.npl=term.ncol[it];
   if(term.npl>130)term.npl=130;
 }else{
   tm=term.winfile;     
   for (j=0; j<16; j++){if(tm[j]==' '){term.winfile[j] = 0;}
   else{term.winfile[j] = tm[j];}}
   /*printf(" tm=%s\n",tm);*/
   ifile = open(term.winfile,O_WRONLY,0); 
   pr_winsize(ifile,it);
   close(ifile);
   /* printf(" ifile=%d ncol(%d)=%d\n",ifile,it,term.ncol[it]);*/
 }
 return ; 
}
