
/* Load this file only once */
#ifndef  _U_PLOT_DEFS_
#define _U_PLOT_DEFS_ 1

#ifndef TRUE
#define TRUE  1
#define FALSE 0
#endif

/* Supported devices, do not change values, only add new devices */
#define PLOT_DEV_DEFAULT -1          /* use default, system dependent */
#define PLOT_DEV_NO      0           /* no plot                       */
#define PLOT_DEV_REGIS   1           /* Regis: DECterm, VT230,...     */
#define PLOT_DEV_TEK     2           /* Tektronix: VT100,...          */
#define PLOT_DEV_BGI     3           /* IBM PC, Borland C             */
#define PLOT_DEV_HPGL    4           /* Output for HP7550 Plotter     */
#define PLOT_DEV_X11     5           /* Output for XWindow            */
#define PLOT_DEV_GNUPC   6           /* IBM PC, Gnu C                 */
#define PLOT_DEV_PS      7           /* Postscript                    */
#define PLOT_DEV_VWS     8           /* VWS (VAX only)                */
#define PLOT_DEV_LASTDEV 9           /* Terminate the list...         */

/* Special Initialization for HPGL-Devices, pass as posx in plot_open() */
#define PLOT_DEV_HPGL_UNKNOWN 0  /* No special initialization */
#define PLOT_DEV_HPGL_LJ4    1   /* HP-Laserjet 4 */
#define PLOT_DEV_HPGL_LJ2PP  2   /* HP-Laserjet 2 with PacificPage Cartridge */
#define PLOT_DEV_HPGL_7550   3   /* HP7550-Plotter */

/* Paper specification for HPGL-Devices, pass as posy in plot_open()  */
#define PLOT_PAPER_DEFAULT   0  /* Calculate according to sizex,sizey */
#define PLOT_PAPER_A4P_AUTO  1  /* DIN A4, Portrait,  Autofeed        */
#define PLOT_PAPER_A4L_AUTO  2  /* DIN A4, Landscape, Autofeed        */
#define PLOT_PAPER_A4P       3  /* DIN A4, Portrait,  no Autofeed     */
#define PLOT_PAPER_A4L       4  /* DIN A4, Landscape, no Autofeed     */
#define PLOT_PAPER_A3P       5  /* DIN A3, Portrait,  no Autofeed     */
#define PLOT_PAPER_A3L       6  /* DIN A3, Landscape, no Autofeed     */
#define PLOT_PAPER_FREE      7  /* Free Format, no checks at all      */
                                /* sizex and sizey are used directly  */


/* It would be nice to have the following devices */
/* UIS: VAXStation with VWS */
/* Various Printers         */

/* Use this constant to get best visible results, e.g. for colors */
#define PLOT_USEDEFAULT -1

/* Writing modes, not all modes supported by all devices */
#define PLOT_MODE_REPLACE 1
#define PLOT_MODE_COMP    2
#define PLOT_MODE_OVER    3
#define PLOT_MODE_ERASE   4

/* If we detect a mouse button as terminator on graphic input, */
/* we return one of these codes (taken from REGIS VT330 etc.)  */
/* REPLOT: Output device requests new plot (e.g. XWindow)      */
/* ABORT : Operation aborted or pure output-device (Plotter)   */
/*         Coordinates returned are undetermined               */
/* ACTIVE: Another part of the program already waits for input */
/*         from this routine. This should only happen on       */
/*         systems with GUI, eg. Motif.                        */
#define PLOT_TRM_MB_LEFT        241
#define PLOT_TRM_MB_CENTER      243
#define PLOT_TRM_MB_RIGHT       245
#define PLOT_TRM_REPLOT         255
#define PLOT_TRM_ALREADY_ACTIVE 256
#define PLOT_TRM_ABORT            0

/* Alignment of Text, only approximately supported on some Devices */
#define PLOT_LEFTTEXT        0
#define PLOT_CENTERTEXT      1
#define PLOT_RIGHTTEXT       2
#define PLOT_BOTTOMTEXT      3
#define PLOT_TOPTEXT         4

/* Capabilities of the device */
#define PLOT_CAPABILITY_NONE     0L         /* For initialization           */
#define PLOT_CAPABILITY_ALL      0L         /* For inquire only             */
#define PLOT_CAPABILITY_POINTER  (1L << 0)  /* Has pointer input            */
#define PLOT_CAPABILITY_EVENT    (1L << 1)  /* Has event handling           */
#define PLOT_CAPABILITY_TRACE    (1L << 2)  /* Can trace cursor             */

#define PLOT_CAPABILITY_WINDOWS  (1L << 28) /* Supports multiple windows    */
#define PLOT_CAPABILITY_HARDCOPY (1L << 29) /* Is Hardcopy Device           */
#define PLOT_CAPABILITY_TEXTEXT  (1L << 30) /* Text extend exact            */
#define PLOT_CAPABILITY_CM       (1L << 31) /* Absolute Dimensions possible */

#endif
