
#ifdef MOTIF
#include "x_inp.h"
#include "v_inp.h"
#include "x_inplib.h"

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <ctype.h>

static int MOTIF_used = FALSE;

void MOTIF_interface_switch(int onoff){
  MOTIF_used = onoff;
}

int MOTIF_interface_enabled(){
  return MOTIF_used;
}


#undef get_filename 
#undef lesefile_oeffnen
#undef schreibfile_oeffnen
#undef entscheidung
#undef entscheidung_a 

void MOTIF_get_filename(char filnam[], char frage[], char wildcard[]){
/* ask for filename, by entering a "?", you get the directory   */
/* The filename is returned in "filename"                       */
/* "frage" passes a question to be displayed, "wildcard" passes */
/* the mask for the files to be displayed by "?", e.g. "*.PAR"  */
   if (! MOTIF_used) get_filename(filnam,frage,wildcard);
   else MOTIF_get_the_filename(filnam,frage,wildcard); 
}

FILE *MOTIF_lesefile_oeffnen(char frage[], char wildcard[]){
/* Open textfile for reading                                    */
/* If successfull, ok is true, else ok is false                 */
/* "frage" passes a question to be displayed, "wildcard" passes */
/* the mask for the files to be displayed by "?", e.g. "*.PAR"  */
   char name[80];
   FILE *infile;
   if (! MOTIF_used) return lesefile_oeffnen(frage,wildcard);
   do {
       MOTIF_get_the_filename(name,frage,wildcard);
       if (name[0] == '\0') return(NULL);
       if (!(infile = fopen(name,"r"))){
	  newline();
	  printf("    Error opening %s for input",name);
	  newline();
	  printf(  "    --- %s",mystrerror(errno));
	  newline();
	  newline();
    }} while (!infile);
    return(infile);
}

FILE *MOTIF_schreibfile_oeffnen(char frage[], char wildcard[]){
/* Open textfile for writing                                    */
/* If successfull, ok is true, else ok is false                 */
/* "frage" passes a question to be displayed, "wildcard" passes */
/* the mask for the files to be displayed by "?", e.g. "*.PAR"  */
   char name[80];
   FILE *infile;
   if (! MOTIF_used){ return schreibfile_oeffnen(frage,wildcard);}
   do {
       MOTIF_get_the_filename(name,frage,wildcard);
       if (name[0] == '\0') return(NULL);
       if (!(infile = fopen(name,"w"))){
	  newline();
	  printf("    Error opening %s for output",name);newline();
	  printf(  "    --- %s",mystrerror(errno));newline();newline();
    }} while (!infile);
    return(infile);
}

int MOTIF_entscheidung(char frage[], char def){
/* Question with two possible answers: yes or no         */
/* The question is passed in "frage", the default answer */
/* "y" or "n" in "d". The Function returns "true" if the */
/* answer is "Yes".                                      */
   if (! MOTIF_used){ return entscheidung(frage,def);}
   if ((toupper(def)) == 'N') def = 2; else def = 1;
   if (MOTIF_the_entscheidung_a(frage,def,2)==1) return TRUE;
   return FALSE;
}


int MOTIF_entscheidung_a(char frage[], int def, int anz){
/* Question with two (yes/no) or three (yes/no/exit) possible answers    */
/* the question is passed in "frage", the default in "def" and the       */
/* number of possible answers in "anz". The result returned is           */
/* Res = 1 : "Yes",     Res = 2 : "No",     Res = 3 : "Cancel"           */
/* The name comes from ATARI-GEM, where this Procedure used an Alert-Box */
   if (! MOTIF_used){ return entscheidung_a(frage,def,anz);}
   return MOTIF_the_entscheidung_a(frage,def,anz);
}

void MOTIF_message(char mess[]){
   MOTIF_the_message(mess);
}


#endif
