#ifdef MOTIF
#include "x_inplib.h"
#include "v_inp.h"
#include "x_inp.h"

static Display *display = NULL;
static int initial = TRUE;
/*
 * Forward declarations
 */

#include <Xm/TextF.h>
#include <Xm/List.h>
#include <Xm/ToggleBG.h>

static void MOTIF_DoButton();
static void MOTIF_Entscheidung_Setvalue();
static void MOTIF_Entscheidung_Settext();
static void MOTIF_filesel_proc();
static void MOTIF_message_ok_proc();
static void MOTIF_create_callback();
static void MOTIF_message_create_callback();

/* VUIT routines for the user to call */
static void s_error();
static int HashFunction();
static int HashLookup();
static int HashRegister();

/* Names and addresses of callback routines to register with Mrm */
static MrmRegisterArg reglist [] = {
{"MOTIF_DoButton", (caddr_t)MOTIF_DoButton},
{"MOTIF_Entscheidung_Setvalue", (caddr_t)MOTIF_Entscheidung_Setvalue},
{"MOTIF_Entscheidung_Settext", (caddr_t)MOTIF_Entscheidung_Settext},
{"MOTIF_filesel_proc", (caddr_t)MOTIF_filesel_proc},
{"MOTIF_create_callback", (caddr_t)MOTIF_create_callback},
{"MOTIF_message_ok_proc", (caddr_t)MOTIF_message_ok_proc},
{"MOTIF_message_create_callback", (caddr_t)MOTIF_message_create_callback}
/* {"MOTIF_string_proc",(caddr_t)MOTIF_string_proc},
{"MOTIF_value_proc",(caddr_t)MOTIF_value_proc},
{"MOTIF_set_all_values",(caddr_t)MOTIF_set_all_values}, 
*/
/* {"",(caddr_t)}, */
};

Widget widget_array[MAX_WIDGETS];
int MOTIF_raise_main = FALSE;

static int MOTIF_Error_Handler(Display *display, XErrorEvent *ev){
   char buffer[80];
   if (ev->error_code == BadMatch) return 1;
   XGetErrorText(display, ev->error_code, buffer, 80);
   newline();
   printf(" Model Motif Interface Warning:");
   newline();
   printf(" %s",buffer);
   newline();
   return 1;
}

static void MOTIF_XtErrorHandler(String message){
   if (strstr(message,"RealizeColorTable")) return;
   newline();    
   printf("%s",message);
   newline();
}

/* Global data */
static MrmType class_id;		/* Place to keep class ID*/
static MrmType *dummy_class;            /* and class variable. */

#define hash_table_limit 100
static struct HASH_TABLE_STRUCT    {
    char	*widget_name;
    Widget	id;
    } hash_table[hash_table_limit + 1];


static int reglist_num = (sizeof reglist / sizeof reglist[0]);

/*
 * OS transfer point.  The main routine does all the one-time setup and
 * then calls XtAppMainLoop.
 */

void MOTIF_main(){
  XtAppMainLoop(app_context); /* NEVER returns */
}

int MOTIF_xtoolkit_init(char *db_filename, int argc, char **argv)
{
    Arg arglist[2];
    static int initialized = FALSE;
    int i, n;
    if (initialized) return TRUE;
    for (i=0; i<MAX_WIDGETS; i++) widget_array[i] = NULL;
    MrmInitialize();  /* Initialize MRM before initializing the X Toolkit. */
    DXmInitialize();  /* Initialize additional DEC widgets */
    /* Initialize the X Toolkit. We get back a top level shell widget.*/
    XtToolkitInitialize();
    app_context = XtCreateApplicationContext();
    display = XtOpenDisplay(app_context, NULL, argv[0], "example",
                            NULL, 0, &argc, argv);
    if (display == NULL) {
      fprintf(stderr, "MOTIF Interface: Can't open display\n");
      return FALSE;
    }
    XSetErrorHandler(MOTIF_Error_Handler);
    XtAppSetErrorHandler(app_context,MOTIF_XtErrorHandler);
    XtAppSetWarningHandler(app_context,MOTIF_XtErrorHandler);
    n = 0;
    XtSetArg(arglist[n], XmNallowShellResize, True);  n++;
    toplevel_widget = XtAppCreateShell(argv[0], NULL, 
			      applicationShellWidgetClass,
                              display, arglist, n);
    /* Open the UID files (the output of the UIL compiler) in the hierarchy */
    if (MrmOpenHierarchy(1,&db_filename,NULL,&s_MrmHierarchy) != MrmSUCCESS){	
        s_error("can't open hierarchy");
        return FALSE;
    }
    MrmRegisterNames (reglist, reglist_num);
    VUIT_Manage("MainWindow");
    /* Realize the top level widget.  All managed children now become visible */
    XtRealizeWidget(toplevel_widget);
    initialized = TRUE;
    return TRUE;
}

/*
 * All errors are fatal.
 */
static void s_error(problem_string)
    char *problem_string;
{
    printf("%s", problem_string);
    newline();
}

void VUIT_Manage(widget_name)
    char	*widget_name;
{
    Widget		id;
    Window		pop_window;
    XWindowChanges	values;

    if (HashLookup(widget_name, &id))
	if (XtIsManaged(id))
	    {
	    pop_window = XtWindow(XtParent(id));
	    values.x = values.y = values.width = values.height =
		values.border_width = values.sibling = 0;
	    values.stack_mode = Above;
	    XConfigureWindow(display, pop_window, CWStackMode, &values);
	    }
	else
	    XtManageChild(id);
    else
	{
	MrmFetchWidget(s_MrmHierarchy, widget_name, toplevel_widget, &id, 
	    &class_id);
	XtManageChild(id);
	HashRegister(widget_name, id);
	}
}

void VUIT_Unmanage(widget_name)
    char	*widget_name;
{
    Widget	id;

    if (HashLookup(widget_name, &id))
	XtUnmanageChild(id);
}

static int HashRegister (widget_name, id)
    char		*widget_name;
    Widget		id;    
{
    int			ndx;

    for (ndx = HashFunction(widget_name, hash_table_limit);
	((hash_table[ndx].widget_name != NULL) &&
	    (ndx < hash_table_limit));
	ndx++);
    if (hash_table[ndx].widget_name != NULL)
	for (ndx = 0;
	    hash_table[ndx].widget_name != NULL;
	    ndx++);
    if (ndx > hash_table_limit)
	return (FALSE);
    else
	{
	hash_table[ndx].widget_name = XtCalloc(1, strlen(widget_name) + 1);
	strcpy(hash_table[ndx].widget_name, widget_name);
	hash_table[ndx].id = id;
	return (TRUE);
	}
}


static int HashLookup (name, id)
    char		*name;
    Widget		*id;
{
    int			ndx;

    for (ndx = HashFunction(name, hash_table_limit);
	((hash_table[ndx].widget_name != NULL) &&
	    (ndx <= hash_table_limit));
	ndx++)
	if (strcmp(name, hash_table[ndx].widget_name) == 0)
	    {
	    *id = hash_table[ndx].id;
	    return (TRUE);
	    }

    if (ndx > hash_table_limit)
	for (ndx = 0;
	    ((hash_table[ndx].widget_name != NULL) &&
		(ndx <= hash_table_limit));
	    ndx++)
	    {
	    if (strcmp(name, hash_table[ndx].widget_name) == 0)
		{
	 	*id = hash_table[ndx].id;
		return (TRUE);
		}
	    }

    return (FALSE);
}

static int HashFunction (name, max)
    char		*name;
    int			max;

{
#define HashVecSize		20	/* plenty for 31 character names */
typedef union
    {
    short int		intname[HashVecSize];	 /* name as vector of ints */
    char		charname[2*HashVecSize]; /* name as vector of chars */
    } HashName;

    HashName		locname;	/* aligned name */
    int			namelen;	/* length of name */
    int			namelim;	/* length limit (fullword size) */
    int			namextra;	/* limit factor remainder */
    int			code = 0;	/* hash code value */
    int			ndx;		/* loop index */


    /*
     * Copy the name into the local aligned union.
     * Process the name as a vector of integers, with some remaining characters.
     * The string is copied into a local union in order to force correct
     * alignment for alignment-sensitive processors.
     */
    strcpy (locname.charname, name);
    namelen = strlen (locname.charname);
    namelim = namelen >> 1;		/* divide by 2 */
    namextra = namelen & 1;		/* remainder */

    /*
     * XOR each integer part of the name together, followed by the trailing
     * 0/1 character
     */
    for ( ndx=0 ; ndx<namelim ; ndx++ )
        code = code ^ ((locname.intname[ndx])<<ndx);
    if ( namextra > 0 )
        code = code ^ ((locname.intname[ndx])&0x00FF);

    return (code&0x7FFF) % max;
}

Display *MOTIF_get_main_display(){
  return display;
}

void own_main(int code);

			
void MOTIF_Raise_Widget(Widget w){
   XWindowAttributes xwa;
   if (w==NULL) return;
   if (! XGetWindowAttributes(XtDisplay(w),XtWindow(w),&xwa)) return;
   if (xwa.class == InputOnly) return;
   XSync(display,FALSE);
   XRaiseWindow(XtDisplay(w),XtWindow(w));
   XSetInputFocus(XtDisplay(w),XtWindow(w),RevertToParent,CurrentTime);
}

void MOTIF_Lower_Widget(Widget w){
   if (w==NULL) return;
   XLowerWindow(XtDisplay(w),XtWindow(w));
}

static void MOTIF_DoButton (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{  MOTIF_raise_main = TRUE;
   own_main(*tag);
   printf("Finished");
   newline();
   if (MOTIF_raise_main) 
      MOTIF_Raise_Widget(widget_array[WIDGET_Main_Menu]);
}

static int entscheidung_buffer;

static void MOTIF_Entscheidung_Setvalue (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
   entscheidung_buffer = *tag;
}

static char entsch_str[80];
static int uptodate = 0;
static Widget entsch_win = NULL;
static unsigned char entsch_defbutton = XmDIALOG_OK_BUTTON;

static void MOTIF_Entscheidung_Settext(w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
   Arg args[2];
   static XmString str = NULL;
   if (w == NULL) return;
   if (entsch_win == NULL) entsch_win = w;
   if (uptodate) return;
   uptodate = 1;
   str = XmStringCreate(entsch_str,XmSTRING_DEFAULT_CHARSET);
   XtSetArg(args[1], XmNmessageString , str);
   XtSetArg(args[0], XmNdefaultButtonType, entsch_defbutton);
   XtSetValues(w,args,2);
   XmStringFree(str);
   str = NULL;
}

int MOTIF_the_entscheidung_a(char txt[],int def, int anz){
   XEvent event;
   uptodate = 0;
   strcpy(entsch_str,txt);   
   switch(def){   
      case 1 : entsch_defbutton = XmDIALOG_OK_BUTTON;
      case 2 : entsch_defbutton = XmDIALOG_CANCEL_BUTTON;
      case 3 : entsch_defbutton = XmDIALOG_HELP_BUTTON;
   }
   entscheidung_buffer = 0;
   MOTIF_Entscheidung_Settext(entsch_win,NULL,NULL);
   VUIT_Manage("Entscheidung_3");
   MOTIF_Raise_Widget(widget_array[WIDGET_Entscheidung_3]);
   do {
     XtAppNextEvent(app_context, &event);
     XtDispatchEvent(&event);
   } while(entscheidung_buffer==0);
   VUIT_Unmanage("Entscheidung_3");
   return entscheidung_buffer;
}

static int filesel_buffer, filesel_uptodate = 0;
static char filesel_filnam[200], filesel_mask[40];
static char filesel_str[40] = "";
static Widget filesel_win = NULL;

static void Filesel_Settext(w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
   Arg args;
   static XmString str = NULL;
   if (w == NULL) return;
   if (filesel_win == NULL) filesel_win = w;
   if (filesel_uptodate) return;
   filesel_uptodate = 1;
   str = XmStringCreate(filesel_str,XmSTRING_DEFAULT_CHARSET);
   XtSetArg(args, XmNdialogTitle , str);
   XtSetValues(filesel_win,&args,1);
   XmStringFree(str);
   str = NULL;
   str = XmStringCreate(filesel_mask,XmSTRING_DEFAULT_CHARSET);
   XtSetArg(args, XmNpattern, str);
   XtSetValues(filesel_win,&args,1);
   XmStringFree(str);
}


void MOTIF_get_the_filename(char filnam[], char frage[], char wildcard[]){
   XEvent event;
    static int i = 0;
   filesel_buffer = 0;
   filesel_uptodate = 0;
   i++;
   strcpy(filesel_str,frage);
   strcpy(filesel_mask,wildcard);
   Filesel_Settext(filesel_win,NULL,NULL);
   VUIT_Manage("filesel");
   do {
     XtAppNextEvent(app_context, &event);
     XtDispatchEvent(&event);
   } while(filesel_buffer==0);
   VUIT_Unmanage("filesel");
   if (filesel_buffer==1){ 
     strcpy(filnam,filesel_filnam);
     add_default_extension(filnam,wildcard,FALSE);
   }
   else filnam[0] = '\0';
}


/* get normal string from XmString **/
/* Reine Empirie... */
static char *extract_first_xms_segment(cs,len)
XmString cs;
int len;
{
  char *tmp;
  int cnt, l;
  cs[len] = 0; 
  tmp = (char *)cs; cnt = 0;
  while (cnt < len){
     tmp = (char *)cs + cnt;
     l = strlen(tmp); 
     cnt = cnt+l+1; 
  }
  return(tmp);
}

/* Fileselector Callback */
static void MOTIF_filesel_proc (widget, tag, callback_data)
Widget widget;
int *tag;
XmFileSelectionBoxCallbackStruct *callback_data;
{ if (filesel_win == NULL){
     filesel_win = widget;
     Filesel_Settext(widget,NULL,NULL);
  } 
  switch (*tag) {
    case 1 : filesel_buffer = 2; break;       /* Cancel */
    case 2 : filesel_buffer = 1;              /* Ok     */
             strcpy(filesel_filnam,extract_first_xms_segment(
                       callback_data->value,callback_data->length)); break;
    case 3 :                                  /* Map    */ 
    case 4 : break;                           /* Create */
  }
}

static void MOTIF_create_callback (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
   if (( *tag < 0) || ( *tag >= MAX_WIDGETS)){
      printf(" MOTIF Error: Widget out of range: %d",*tag);newline(); return;}
   if (widget_array[*tag] != NULL){
     printf(" MOTIF Error: Widget number %d already in use");newline(); return;   }
   widget_array[*tag] = w;
/*   MOTIF_set_value(*tag); */
}

static char MOTIF_msg_string[255];

static void MOTIF_message_settext(){
   Arg args;
   int i;
   static XmString str = NULL;
   str = XmStringCreate(MOTIF_msg_string,XmSTRING_DEFAULT_CHARSET);
   XtSetArg(args, XmNlabelString , str);
   XtSetValues(widget_array[WIDGET_Message_Label],&args,1);
   XmStringFree(str);
   str = NULL;
}

static void MOTIF_message_create_callback (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
   if (( *tag < 0) || ( *tag >= MAX_WIDGETS)){
      printf(" MOTIF Error: Widget out of range: %d",*tag);newline(); return;}
   if (widget_array[*tag] != NULL){
     printf(" MOTIF Error: Widget number %d already in use");newline(); return; }
   widget_array[*tag] = w;
   MOTIF_message_settext();
}
      
static void MOTIF_message_ok_proc (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
   VUIT_Unmanage("messagewin"); 
   MOTIF_Lower_Widget(widget_array[WIDGET_Message_Box]);
   if (initial){ 
      initial = FALSE;
        MOTIF_Raise_Widget(widget_array[WIDGET_Main_Menu]); 
   }
}



void MOTIF_the_message(char msg[]){
   strcpy(MOTIF_msg_string, msg);
   if (widget_array[WIDGET_Message_Label]!=NULL)
     MOTIF_message_settext();
   VUIT_Manage("messagewin");
}

#endif
