
#include "xb_menu.h"
#include "xb_buff.h"
#include "v_inp.h"

#include <stdlib.h>
#include <math.h>

#define ALLOCITEMS   10000

#define DEBUG 0

#ifndef PI
#define PI 3.1412
#endif

                
int move_origin(plotinfo *plot, datatype move_x, datatype move_y){
   plot->shift_x = plot->shift_x + move_x;
   plot->shift_y = plot->shift_y + move_y;
   return XB_STAT_OK;
}
   
int rotate_buffer(plotinfo *plot, double phi){
/* Add new angle to actual angle, and reduce result to the */
/* range between -180.0 and 180.0 degrees                  */
   plot->angle = plot->angle + phi;
   while(plot->angle < -180.0) plot->angle = plot->angle + 360.0; 
   while(plot->angle >  180.0) plot->angle = plot->angle - 360.0; 
   return XB_STAT_OK;
}
  
int scale_buffer(plotinfo *plot, double factor_x, double factor_y){
   plot->factor_x = plot->factor_x * factor_x;
   plot->factor_y = plot->factor_y * factor_y;
   return XB_STAT_OK;
}
   
int add_item(plotinfo *plot, int item, double arguments[]){
/* Add one item to buffer */
   bufferptr buf;
   long int bufmm[3];
   buf = buffers[plot->bufnum];
    if (! buf){/*XBEN_message("Buffer not allocated");*/ return XB_STAT_NOBUFF; }
   if (item==XB_ITEM_NONE) return XB_STAT_OK;
   if ((item==XB_ITEM_DRAW_REL)||(item==XB_ITEM_DRAW_ABS)){
     if (buf->first){
        buf->first = FALSE;        
        buf->xmin = buf->xmax = buf->xakt; 
        buf->ymin = buf->ymax = buf->yakt;
        plot->xmin=buf->xmin;plot->ymin=buf->ymin;}

     if (buf->aktitem==XB_ITEM_POLYLINE){  /* Add to existing Polyline */
     } else {                              /* Start new Polyline */
       buf->akt->header.item = XB_ITEM_POLYLINE;
       buf->aktitem = XB_ITEM_POLYLINE;
       buf->size = buf->akt;
       buf->size->header.args = 1;
       buf->akt[1].x = buf->xakt; 
       buf->akt[2].y = buf->yakt; 
       buf->akt = buf->akt+3;
       buf->free_items = buf->free_items - 3;
     }
     if (item==XB_ITEM_DRAW_REL){          
       buf->xakt = buf->xakt + (datatype)arguments[0];  
       buf->yakt = buf->yakt + (datatype)arguments[1];  
     } else {
       buf->xakt = (datatype)arguments[0];  
       buf->yakt = (datatype)arguments[1];  
     } 
     buf->akt[0].x = buf->xakt; 
     buf->akt[1].y = buf->yakt; 
     /* Check if maximal coordinates have changed */
     if (buf->xmin > buf->xakt)buf->xmin = buf->xakt;
     if (buf->ymin > buf->yakt)buf->ymin = buf->yakt;
     if (buf->xmax < buf->xakt)buf->xmax = buf->xakt;
     if (buf->ymax < buf->yakt)buf->ymax = buf->yakt;

     /*     if (buf->xmin > buf->xakt) 
       {buf->xmin = buf->xakt;plot->xmin=buf->xmin;};
     if (buf->ymin > buf->yakt)
       {buf->ymin = buf->yakt;plot->ymin=buf->ymin;};
     if (buf->xmax < buf->xakt) 
       {buf->xmax = buf->xakt;plot->xmax=buf->xmax;};
     if (buf->ymax < buf->yakt)
     {buf->ymax = buf->yakt;plot->ymax=buf->ymax;};*/
     buf->akt = buf->akt+2;
     buf->size->header.args++; 
     buf->free_items = buf->free_items - 2;   
   } else if (item==XB_ITEM_MOVE_ABS) { 
       buf->aktitem = item;
       buf->xakt = (datatype)arguments[0];  
       buf->yakt = (datatype)arguments[1]; 
   } else if (item==XB_ITEM_MOVE_REL) { 
       buf->aktitem = item;
       buf->xakt = buf->xakt + (datatype)arguments[0];  
       buf->yakt = buf->yakt + (datatype)arguments[1];  
   } else {
     buf->aktitem = item;
     if (item==XB_ITEM_END) { buf->write_allowed=FALSE; 
                              if (DEBUG) {printf("Item: END");newline();};
                              buf->akt->header.item = XB_ITEM_END;
                              if ((buf->xmin==buf->xmax) ||
                                  (buf->ymin==buf->ymax)) return XB_STAT_EMPTY;
                              return XB_STAT_OK; } 
     if (item==XB_ITEM_PEN) {
       buf->akt->header.item = XB_ITEM_PEN;
       buf->akt->header.args = (short int)arguments[0];
       buf->akt = buf->akt+1;
       buf->free_items = buf->free_items - 1;
     }
     if (item==XB_ITEM_FILL) {
       buf->akt->header.item = XB_ITEM_FILL;
       buf->akt->header.args = (short int)arguments[0];
       buf->akt = buf->akt+1;
       buf->free_items = buf->free_items - 1;
     }
   }
   if (buf->free_items < 7){
     if (DEBUG) {printf("Item: Allocating");newline();};
 
     buf->akt->header.item = XB_ITEM_CONT;
     buf->akt[1].nextitem = malloc(ALLOCITEMS*sizeof(itemtype));
     if (buf->akt[1].nextitem == NULL){
        buf->akt->header.item = XB_ITEM_END;
        return XB_STAT_NOMEM;
     }
     buf->akt = buf->akt[1].nextitem;
     buf->free_items = ALLOCITEMS;
     if (buf->aktitem==XB_ITEM_POLYLINE){ 
       buf->akt->header.item = XB_ITEM_POLYLINE;
       buf->size = buf->akt; 
       buf->size->header.args = 1;
       buf->akt[1].x = buf->xakt; 
       buf->akt[2].y = buf->yakt; 
       buf->akt = buf->akt+3;
       buf->free_items = buf->free_items - 3;
   }}
   return XB_STAT_OK;
}
      
     
int get_item(plotinfo *plot, int *item, int *nargs, datatype **arguments){
/* get one item from buffer */
   bufferptr buf;
   if (! buffers[plot->bufnum]) return XB_STAT_NOBUFF;
   if (buffers[plot->bufnum]->write_allowed) return XB_STAT_NOREAD;
   buf = buffers[plot->bufnum];
   do {
     *item = buf->akt->header.item;
     switch (buf->akt->header.item){
       case XB_ITEM_END      : return XB_STAT_END; 
       case XB_ITEM_NONE     : *nargs = 0;
                               buf->akt = buf->akt 
                                        + 2*(buf->akt->header.args) + 1; 
                               return XB_STAT_OK;
       case XB_ITEM_PEN      : *nargs = buf->akt->header.args; 
                               buf->akt++;
                               return XB_STAT_OK;
       case XB_ITEM_FILL      : *nargs = buf->akt->header.args; 
                               buf->akt++; return XB_STAT_OK;
       case XB_ITEM_START    : buf->akt++; 
                               /*printf(" nargs=%d",buf->akt->header.args);*/ 
                               continue;
       case XB_ITEM_POLYLINE : *nargs = buf->akt->header.args;
                               *arguments = &buf->akt[1].x;
                               buf->akt = buf->akt + 2*(*nargs) + 1; 
                               return XB_STAT_OK;
       case XB_ITEM_CONT     : buf->akt = buf->akt[1].nextitem; continue;
   }} while (TRUE); 
}
   

int create_buffer(plotinfo *plot){
/* Create buffer for one plot, returns XB_STAT_NOBUFF if no more buffers */
   int i,n;
   n = -1;
   for (i=0; i<MAXBUF; i++) if (buffers[i] == NULL) { n=i; break;}
   if (n<0){ plot->bufnum = XB_STAT_NOBUFF;
         return XB_STAT_NOBUFF;}
   plot->bufnum = n;
   buffers[n] = malloc(sizeof(buffertype));
   buffers[n]->items = malloc(ALLOCITEMS*sizeof(itemtype));
   buffers[n]->free_items = ALLOCITEMS;
   buffers[n]->aktitem = XB_ITEM_START;
   buffers[n]->akt = buffers[n]->items;
   buffers[n]->xakt = 0;
   buffers[n]->yakt = 0;
   buffers[n]->xmin = buffers[n]->xmax = 0.0; 
   buffers[n]->ymin = buffers[n]->ymax = 0.0; 
   buffers[n]->write_allowed = TRUE; 
   buffers[n]->first = TRUE;
   return XB_STAT_OK;
}

int start_buffer(plotinfo *plot){
/* Makes buffer ready for output, returns status */
   if (! buffers[plot->bufnum]) return XB_STAT_NOBUFF;
   buffers[plot->bufnum]->akt = buffers[plot->bufnum]->items;
   buffers[plot->bufnum]->write_allowed = FALSE;
   return XB_STAT_OK;
}

static void delete_items(itemptr item, int level){
   itemptr tmp;
   tmp = item;
   if (DEBUG) {printf("Deleting Items: level");newline();};
   do {
     switch (tmp->header.item){
       case XB_ITEM_END      : free(item); return;
       case XB_ITEM_PEN      : tmp++; break;
       case XB_ITEM_START    : tmp++; break;
       case XB_ITEM_NONE     :
       case XB_ITEM_POLYLINE : tmp = tmp + 2*(tmp->header.args) + 1; break;
       case XB_ITEM_CONT     : delete_items(tmp[1].nextitem,level++); return;
   }} while (TRUE); 
}

void delete_buffer(plotinfo *plot){
/* Delete one Buffer */

   if (! buffers[plot->bufnum]) return;
   delete_items(buffers[plot->bufnum]->items,0);
   free(buffers[plot->bufnum]);
   buffers[plot->bufnum] = NULL;
   plot->bufnum = XB_STAT_NOBUFF;
}       

void xb_buff_init(){
   int i;
   for (i=0; i<MAXBUF; i++) buffers[i] = NULL;
}

int get_minmax(plotinfo *plot, datatype *xmin, datatype *xmax, 
                               datatype *ymin, datatype *ymax){
   datatype tmp1, tmp2, x[4],y[4];
   double phi;
   int i;
#define MINMAX(x,y) { if (x>y){ tmp1=x; x=y; y=tmp1;}}
#define ROTATE(x,y) { tmp1 = x*cos(phi) - y*sin(phi);\
                      tmp2 = y*cos(phi) + x*sin(phi);\
                      x = tmp1; y = tmp2; }
   if (plot->bufnum==XB_STAT_NOBUFF) return XB_STAT_NOBUFF;
   if (! buffers[plot->bufnum]) return XB_STAT_NOBUFF;
   phi = plot->angle / 180.0 * PI;
   x[0] = x[3] = buffers[plot->bufnum]->xmin;
   x[1] = x[2] = buffers[plot->bufnum]->xmax;
   y[0] = y[1] = buffers[plot->bufnum]->ymin;
   y[2] = y[3] = buffers[plot->bufnum]->ymax;
   for (i=0; i<4; i++) ROTATE (x[i],y[i]);
   MINMAX(x[0],x[1]);MINMAX(x[2],x[3]);MINMAX(x[0],x[2]);MINMAX(x[1],x[3]);
   MINMAX(y[0],y[1]);MINMAX(y[2],y[3]);MINMAX(y[0],y[2]);MINMAX(y[1],y[3]);
   x[0] = x[0] * plot->factor_x + plot->shift_x;
   y[0] = y[0] * plot->factor_y + plot->shift_y;
   x[3] = x[3] * plot->factor_x + plot->shift_x;
   y[3] = y[3] * plot->factor_y + plot->shift_y;
   *xmin = x[0]; *xmax = x[3];
   *ymin = y[0]; *ymax = y[3];
   return XB_STAT_OK;
#undef MINMAX
#undef ROTATE
}

static void transform_args(plotinfo *plot, int nargs, datatype coord[]){
   double phi, tmp1, tmp2;
   int i;
   phi = plot->angle / 180 * PI;
   for (i=0; i<nargs; i++){
     tmp1 = (double)coord[2*i] * cos(phi) - (double)coord[2*i+1] * sin(phi); 
     tmp2 = (double)coord[2*i+1] * cos(phi) + (double)coord[2*i] * sin(phi); 
     coord[2*i]   = (datatype)(tmp1 * plot->factor_x + plot->shift_x);
     coord[2*i+1] = (datatype)(tmp2 * plot->factor_y + plot->shift_y);
   }
}

void reset_scaling(plotinfo *plot){
   plot->factor_x = 1.0;   plot->factor_y = 1.0;
   plot->angle = 0.0;
   plot->shift_x = 0;   plot->shift_y = 0;
}

int transform_buffer(FILE *volterm,plotinfo *plot){
   bufferptr buf;
   itemptr akt;
   int fertig, nargs;
   fertig = FALSE;
   if (! entscheidung(volterm,
          "Transform actual Buffer: Make scaling permanent",'Y')) 
      return fertig;
   if (! buffers[plot->bufnum]) return XB_STAT_NOBUFF;
   if (buffers[plot->bufnum]->write_allowed) return XB_STAT_NOREAD;
   buf = buffers[plot->bufnum];
   akt = buf->items;
   do {
     switch (akt->header.item){
       case XB_ITEM_END      : fertig = TRUE; break;
       case XB_ITEM_PEN      : 
       case XB_ITEM_START    : akt++; break;
       case XB_ITEM_NONE     : nargs = akt->header.args;
                               akt = akt + 2*(nargs) + 1; 
                               break;
       case XB_ITEM_POLYLINE : nargs = akt->header.args;
                               transform_args(plot,nargs,&akt[1].x);
                               akt = akt + 2*(nargs) + 1; 
                               break;
       case XB_ITEM_CONT     : akt = akt[1].nextitem; break;
       default : ;
   }} while (! fertig); 
   reset_scaling(plot);
}
