
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "xben.h"
#include "xb_menu.h"
#include "v_inp.h"
   
void save_layout(FILE *volterm,struct deviceinfo *devinfo,
                 struct plotinfo plots[]){
  FILE *outfile;
  int i;
  if ((outfile=schreibfile_oeffnen(
       volterm,"File for layout","format.lay"))==NULL) return;
  fprintf(outfile,"**XBEN-CONFIG**%s**\n",VERSION);  
  fprintf(outfile,"%d %d %d %d\n",devinfo->paper,devinfo->device,
                                  devinfo->deviceclass,devinfo->screentype);
  fprintf(outfile,"%ld %ld %ld %ld\n",devinfo->paper_dimx,devinfo->paper_dimy,
                                  devinfo->xoffset,devinfo->yoffset);
  for (i=0; i<MAXPLOTS; i++){
    fprintf(outfile,"%d %ld %ld\n",plots[i].visible,
            plots[i].shift_x, plots[i].shift_y);
    fprintf(outfile,"%10g %10g %10g\n",plots[i].factor_x,
            plots[i].factor_y, plots[i].angle);
  }
  fclose(outfile);
}

static void load_the_layout(FILE *infile,
                     struct deviceinfo *devinfo,
                     struct plotinfo plots[]){
  int ok, vers_h, vers_l, i;
  char instr[81], *ptr, *p;

  readlinevef(instr,80,infile);
  ok = TRUE;
  if (strlen(instr) < 20) ok = FALSE; 
  else { 
    ptr = instr+15; 
    if (*ptr != 'V') ok = FALSE;
    *ptr = '\0'; ptr++;
    if (strcmp(instr,"**XBEN-CONFIG**") != 0) ok = FALSE;
    p = strchr(ptr,'*'); if (p==NULL) ok = FALSE;
    else {
      i = sscanf(ptr,"%d.%d",&vers_h,&vers_l);
      if (i != 2) ok = FALSE;
    }
  }
  if (! ok){
    /*XBEN_message(" Error: Invalid configuration file ");*/
    fclose(infile); return;
  }
  /*printf(" configuration file produced by XBEN V %d.%d",vers_h,vers_l);
  newline();*/
  fscanf(infile,"%d %d %d %d",&devinfo->paper,&devinfo->device,
                                 &devinfo->deviceclass,&devinfo->screentype);
  fscanf(infile,"%ld %ld %ld %ld",&devinfo->paper_dimx,&devinfo->paper_dimy,
                                 &devinfo->xoffset,&devinfo->yoffset);
  for (i=0; i<MAXPLOTS; i++){
    fscanf(infile,"%d %ld %ld",&plots[i].visible,
           &plots[i].shift_x, &plots[i].shift_y);
    fscanf(infile,"%lf %lf %lf",&plots[i].factor_x,
           &plots[i].factor_y, &plots[i].angle);
  }
 
  fclose(infile);  
}


void load_layout_by_name(char fname[],
                 struct deviceinfo *devinfo,
                 struct plotinfo plots[]){
  FILE *infile;
  char outstr[80];
  if (strlen(fname)==0) return;
  add_default_extension(fname,"*.lay",FALSE);
  if (!(infile = fopen(fname,"r"))) {
    newline();
    printf("    Error opening configuration file %s ",fname);
    newline();
    printf(  "    --- %s",mystrerror(errno));
    newline();
    newline(); 
    /*XBEN_taste_warten(TRUE);*/ return; }
  load_the_layout(infile,devinfo,plots); 
}

void load_layout(FILE *volterm,struct deviceinfo *devinfo,
                 struct plotinfo plots[]){
  FILE *infile;
  /*infile = fopen("format.lay","r");*/
  if ((infile=lesefile_oeffnen(volterm,"File for layout","format.lay"))==NULL)
      return;
  load_the_layout(infile,devinfo,plots); 
}
