
#include "xben.h"
#include "xb_plot.h"
#include "u_plot.h"
#include "xb_buff.h"

#include <ctype.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#ifndef PI
#define PI 3.1412
#endif

struct deviceinfo zoomconfig, *the_config;
static int holdzoom=FALSE;
static int is_window;
static int handle = -1;
#define INFO_POSX 0.5
#define INFO_POSY 0.99
void help1_(FILE *volterm,char chcom[]);
static int size=0;

static void draw_frame(int handle, datatype xmin, datatype ymin, 
                                   datatype xmax, datatype ymax){
   double x[5], y[5], x1, x2, y1, y2, delta, len, base_len;
   int cnt;
   delta = (double)UNITS_PER_CM;
   base_len = (double)UNITS_PER_CM * 0.1;
   x[0] = x[3] = x[4] = (double)xmin;
   x[1] = x[2] = (double)xmax;
   y[0] = y[1] = y[4] = (double)ymin;
   y[2] = y[3] = (double)ymax;
   plot_polyline(handle,5,x,y);
   /* Draw cm-tics */
   cnt = 0;
   x1 = delta; y1 = y[0]; y2 = y[2];
   while (x1 < x[1]) {
     cnt++; 
     len = base_len;
     if ((cnt %  5) == 0) len = base_len*2; 
     if ((cnt % 10) == 0) len = base_len*3; 
     plot_line(handle, x1, y1, x1, y1+len);
     plot_line(handle, x1, y2, x1, y2-len);
     x1 = x1 + delta;
   }
   cnt = 0;
   y1 = delta; x1 = x[0]; x2 = x[2];
   while (y1 < y[2]) {
     cnt++; 
     len = base_len;
     if ((cnt %  5) == 0) len = base_len*2; 
     if ((cnt % 10) == 0) len = base_len*3; 
     plot_line(handle, x1, y1, x1+len, y1);
     plot_line(handle, x2, y1, x2-len, y1);
     y1 = y1 + delta;
   }
}

static void plot_a_polyline(int handle, plotinfo *plot, 
                            int npoints, datatype coord[]){
   double *x, *y, phi, fact_x, fact_y;
   int i;
   x = malloc(npoints * sizeof(double));   
   y = malloc(npoints * sizeof(double));   
   phi = plot->angle / 180 * PI;;
   for (i=0; i<npoints; i++){
      x[i] = coord[2*i] * cos(phi) - coord[2*i+1] * sin(phi); 
      y[i] = coord[2*i+1] * cos(phi) + coord[2*i] * sin(phi); 
      x[i] = x[i] * plot->factor_x + plot->shift_x;
      y[i] = y[i] * plot->factor_y + plot->shift_y;
   }
   plot_polyline(handle,npoints,x,y);
   free(x); free(y);
}
static void plot_a_fillpolygon(int handle, plotinfo *plot, 
                            int npoints, datatype coord[]){
   double *x, *y, phi, fact_x, fact_y;
   int i;
   x = malloc(npoints * sizeof(double));   
   y = malloc(npoints * sizeof(double));   
   phi = plot->angle / 180 * PI;;
   for (i=0; i<npoints; i++){
      x[i] = coord[2*i] * cos(phi) - coord[2*i+1] * sin(phi); 
      y[i] = coord[2*i+1] * cos(phi) + coord[2*i] * sin(phi); 
      x[i] = x[i] * plot->factor_x + plot->shift_x;
      y[i] = y[i] * plot->factor_y + plot->shift_y;
   }
   plot_fillpolygon(handle,npoints,x,y);
   free(x); free(y);
}


static int convert_term(int term){
   term = toupper(term);
   switch (term){
      case PLOT_TRM_MB_CENTER : return 'Z';
      case '*' :
      case PLOT_TRM_MB_RIGHT  : return 'R';
      case 18  :
      case 23                 : return PLOT_TRM_REPLOT;
      default : return term;
   }
}

int output_plot(int handle, plotinfo plot[], 
                deviceinfo *config, int with_frame){
   int buf,item,nargs,i, nplot,stat, sizex,sizey, term,b_fill;
   double xmin,xmax,ymin,ymax, xdim, ydim;
   datatype *argptr,xdim_z,ydim_z, hx,hy;   
   double screen_ratio, data_ratio;
   double dummy; 
  
   xmin = config->xoffset; ymin = config->yoffset; 
   xdim = config->paper_dimx; ydim = config->paper_dimy;
   xmax = xmin + xdim; ymax = ymin + ydim;
    i=config->paper/2; i=2*i;
   if(plot[0].ips==0){
    if(i==config->paper){
     /*     printf("xmin=%10.1f xmax=%10.1f ymin=%10.1f ymax=%10.1f\n",
	    xmin,xmax,ymin,ymax);*/ 
     plot[0].xmin=190000-(long int)ymax; plot[0].xmax=190000-(long int)ymin;
     plot[0].ymin=(long int)xmin; plot[0].ymax=(long int)xmax;
    }else{
     plot[0].xmin=(long int)xmin; plot[0].xmax=(long int)xmax;
     plot[0].ymin=(long int)ymin; plot[0].ymax=(long int)ymax;
    }; 
   }else{
     if(i==config->paper){
      xmin=plot[0].ymin; xmax=plot[0].ymax;
      ymin=-(plot[0].xmax-190000); ymax=-(plot[0].xmin-190000);
     }else{
      xmin=plot[0].xmin; xmax=plot[0].xmax;
      ymin=plot[0].ymin; ymax=plot[0].ymax;
     };
   };
   plot_setclip(handle,TRUE);

   plot_getdev(handle,&sizex,&sizey);
   if(size!=sizex) i=plotd_sel_font(handle,sizex);
   size=sizex;
   //printf("i=%d  sizex=%d sizey=%d \n",i,sizex,sizey);  


   if (with_frame)
     plot_setview(handle,0.005*sizex,0.005*sizey,0.995*sizex,sizey);
   else
    if(plot[0].ips==0)plot_setview(handle,0.0,0.0,sizex,sizey);
   if (plot_capabilities(handle,PLOT_CAPABILITY_CM)){
    if(plot[0].ips==0){  
     plot_getdev_cm(handle,&xdim,&ydim);
     xmax = xmin + UNITS_PER_CM*xdim; 
     ymax = ymin + UNITS_PER_CM*ydim; 
    }else{
     plot_setview(handle,xmin,ymin,xmax,ymax);
    };
     plot_setwin(handle,xmin,ymin,xmax,ymax); 
   }else{
     screen_ratio = (double)sizey/(double)sizex;
     if (xdim != 0) data_ratio = (double)ydim/(double)xdim;
               else data_ratio = 1;
     if (screen_ratio > data_ratio)
       plot_setwin(handle,xmin,ymin,xmax,ymax);
     /*plot_setwin(handle,xmin,ymin,xmax,ymin+screen_ratio*xdim);*/
     else
       plot_setwin(handle,xmin,ymin,xmax,ymax);
     /*plot_setwin(handle,xmin,ymin,xmin+ydim/screen_ratio,ymax);*/
   }
   plot_setfg(handle,0);
   if (with_frame)  draw_frame(handle,xmin,ymin,xmax,ymax);
   for (nplot=0; nplot<MAXPLOTS; nplot++){
      if (plot[nplot].bufnum == XB_STAT_NOBUFF) continue;
      if (! plot[nplot].visible) continue;
      if (start_buffer(&plot[nplot]) != XB_STAT_OK) continue;

      b_fill=0;
      while (stat=get_item(&plot[nplot],&item,&nargs,&argptr) != XB_STAT_END){
        term = plot_checkevent(handle,&dummy,&dummy);
        term = convert_term(term);
        if ((term == 'Q') || (term == PLOT_TRM_REPLOT) || (term == 'Z'))
          return term;
        switch (item){
            case XB_ITEM_PEN :plot_setfg(handle,nargs);break;
	    case XB_ITEM_FILL:b_fill=1;break;
	    case XB_ITEM_POLYLINE : 
             if(b_fill) plot_a_fillpolygon(handle,&plot[nplot],nargs,argptr);
             else 
             plot_a_polyline(handle,&plot[nplot],nargs,argptr); b_fill=0;break;
           case XB_ITEM_NONE : break;
        }
   }}
   /*if (is_window) {printf("Finished");newline();};*/
   return 1;
}

static void writetext(char info[]){
    static char savetext[80] = "";
    int posx, posy, sizex, sizey;
    plot_getdev(handle,&sizex,&sizey);
    /*if (is_window) {printf("%s",info);newline();};*/
    plot_settextalign(handle,PLOT_CENTERTEXT,PLOT_TOPTEXT); 
    posx = sizex*INFO_POSX; posy = sizey*INFO_POSY;
    if (savetext[0]!=0) plot_erasetext(handle,FALSE,posx, posy, savetext);
    plot_writetext(handle,FALSE,posx,posy,info);
    strcpy(savetext,info);
}

int in_plot(beninfo *fromapl, double x, double y, int i)
{
    /*printf("x=%10.1f  fromapl[%d].*  %10.1f %10.1f\n",
               x,i,fromapl[i].a_xanf,fromapl[i].a_xend); 
 printf("y=%10.1f  fromapl[%d].*  %10.1f %10.1f\n",
 y,i,fromapl[i].a_yanf,fromapl[i].a_yend);*/ 
if (x > fromapl[i].a_xanf && x < fromapl[i].a_xend 
   && y > fromapl[i].a_yanf && y < fromapl[i].a_yend) return(i);
  return(-1);
}


int  plot_to_screen(beninfo fromapl[],plotinfo plot[], deviceinfo *config){
#define MINMAX(x,y) { if (x>y){ tmp=x; x=y; y=tmp;}}
  FILE *volterm;
  char vterm[16],killcmd[32];
   int term,i,j,i_run,ix,iy;
   char outstr[80];
   char filnam[80],chcom[132];
   double x, y, x1, y1, tmp, xl,yl, x_c,y_c,dx_c,dy_c,dx,dy;
   /*struct deviceinfo zoomconfig, *the_config;*/

   if (config->screentype==PLOT_DEV_DEFAULT)
       config->screentype = PLOT_DEV_X11;
   if(holdzoom==0) the_config = config;
   i=(*config).paper/2; i=2*i;   
   /*printf("handle=%d config->paper=%d config->screentype=%d\n",
     handle,config->paper,config->screentype);*/
   sleep(1); /* program crashes without this hold time of 1s*/ 
   plot[0].ips=0;
   if (handle < 0){
     ix=(*config).xwidth;
     iy=(int)(1.409 *(float)ix);
     if(i==(*config).paper){
     handle = plot_open(config->screentype,iy,ix,10,10,
	                          "Plotwindow for allplo",NULL);}
     else{handle = plot_open(config->screentype,ix,iy,10,10,
    	                          "Plotwindow for allplo",NULL);}
   }
   if (handle < 0) {
      printf("%s",plot_message());newline();
      return(handle);}
   is_window = plot_capabilities(handle,PLOT_CAPABILITY_WINDOWS);
   i_run=-1;
   
  do {
      plot_graphmode();
      plot_clear(handle);
      term = output_plot(handle,plot,the_config,TRUE);
      //printf("term=%d\n",term);

       while ((term != PLOT_TRM_REPLOT)&& (term != 'Z') && (term != 'R')&&
        term != 'Q'&& term != 'A'&& term != 'S'&& term != 'P'&&
        term != 'G'&& term != 'L'&& term != 'F'&& term != 'I'&& term != 'M')
       {
         term = plot_getpointer(handle,&x,&y);
         /*printf("## x=%10.1f y=%10.1f \n",x,y);*/
         if(term != 'h') term = convert_term(term);
         /*printf("term:%c\n",term);*/

          i=-1;
         if(i_run>-1)i=in_plot(&fromapl[i_run],x,y,i_run);

         if(i==-1){
	   i=0;j=0;
          while(fromapl[i].iplot==i){
          if(j==in_plot(fromapl,x,y,i))i_run=i;
          i++;j=i;};
	 };
         /*printf("i_run=%d\n",i_run);*/
         if(i_run>-1){
          x_c=x-fromapl[i_run].a_xanf;
          y_c=y-fromapl[i_run].a_yanf;
	  dx_c=fromapl[i_run].a_xend-fromapl[i_run].a_xanf;
	  dy_c=fromapl[i_run].a_yend-fromapl[i_run].a_yanf;
	  dx=fromapl[i_run].xend-fromapl[i_run].xanf;
	  dy=fromapl[i_run].yend-fromapl[i_run].yanf;
          xl=dx/dx_c*x_c+fromapl[i_run].xanf;
          yl=dy/dy_c*y_c+fromapl[i_run].yanf;

	  /*printf("#\n");         
	  printf("# x=%8.1f y=%8.1f xl=%8.1f yl=%8.1f\n",x,y,xl,yl);
	  printf("# a_xanf=%8.1f a_xend=%8.1f \n",
                  fromapl[i_run].a_xanf,fromapl[i_run].a_xend); 
	  printf("# a_yanf=%8.1f a_yend=%8.1f \n",
                  fromapl[i_run].a_yanf,fromapl[i_run].a_yend); 
	  printf("# xanf=%8.1f xend=%8.1f yanf=%8.1f yend=%8.1f\n",
		 fromapl[i_run].xanf,fromapl[i_run].xend, 
                  fromapl[i_run].yanf,fromapl[i_run].yend); 
          printf("# x_c=%8.1f y_c=%8.1f dx_c=%8.1f dy_c=%8.1f\n", 
	  x_c,y_c,dx_c,dy_c);*/


	  sprintf(outstr,"h=help; x,y=(%7.2fcm,%7.2fcm),(%7.2f,%7.2f)",
	     x/UNITS_PER_CM,y/UNITS_PER_CM,xl/UNITS_PER_CM,yl/UNITS_PER_CM);
         
         }else{ 
	  sprintf(outstr,"h=help; x,y=(%7.2fcm,%7.2fcm),(--,--)",
	     x/UNITS_PER_CM,y/UNITS_PER_CM);
         };
         plot_setfg(handle,0);
      	 writetext(outstr);
         if (term=='h') {
         newterm("help_plot_allplo","48x19+900+20","yellow",vterm,killcmd);
         volterm = fopen(vterm,"r+");
         fprintf(volterm,"\n optional arguments of xapl:\n");
         fprintf(volterm," width (pixel>50)  plotfile.ps (as default)\n\n");
         fprintf(volterm," commands (keys and mouse buttons):\n\n");
         fprintf(volterm," a: execute allplo and plot benson file\n");
         fprintf(volterm," c: conserve zoom (toggle)\n");
         fprintf(volterm," f: format of the paper - portrait/landscape\n");
         fprintf(volterm," g: geometry of the plot \n");
         fprintf(volterm," i: fit to paper format (choice:1 in command g)\n");
         fprintf(volterm," m: midway of paper (choice:6 in command g)\n");
         fprintf(volterm," l: load layout file  \n");
         fprintf(volterm," p: print postcript file\n");
         fprintf(volterm," q: quit the program \n");
         fprintf(volterm," r: restore, right mouse button = r \n");
         fprintf(volterm," s: store layout file\n");
         fprintf(volterm," z: zoom , middle mouse button = z\n");
         fprintf(volterm," H: more help (for batchfile and more)\n");

         system("rm help_plot_allplo");
         };
         if (term=='C') holdzoom= !holdzoom;
         if (term=='H'){
	   sprintf(chcom,"batchfile");
           /*printf("chcom=%s\n",chcom);*/
           for(i=9;i<132;i++)chcom[i]=' ';chcom[131]='\0';
           help_(chcom);
           break;
         }
       }
       plot[0].ips=0; 
       if (term=='P')  plot[0].ips=1;
       if (term=='F') {
	if(config->paper ==1)config->paper =2;
        else
	if(config->paper ==2)config->paper =1;
        use_paper_format(config);
        plot_close(handle);handle=-1;
        /*term='I'newterm("paper_format","60x26+850+20","Yellow1",vterm,killcmd);
        volterm = fopen(vterm,"r+");
        i=set_format(volterm,config);sleep(1); 
        if(i) {plot_close(handle);handle=-1;};
        system("rm paper_format");system(killcmd);*/
       };
       
       /*if (term=='R') the_config = config;*/
       if (term=='Z'){
         if (the_config == config){
           the_config = &zoomconfig;
           memcpy(the_config,config,sizeof(deviceinfo));
         }
         writetext(" Zoom: Mark first corner\n");
         term = plot_getpointer(handle,&x,&y);
         writetext(" Zoom: Mark second corner\n");
         term = plot_getpointer(handle,&x1,&y1);
         MINMAX(x,x1);
         MINMAX(y,y1);
         if ((x != x1) && (y != y1)){
	  /*printf("x=%10.2f y=%10.2f x1=%10.2f y1=%10.2f\n",x,y,x1,y1); 
	  printf("x=%10.2f y=%10.2f x1=%d y1=%d\n",
          plot[0].factor_x, plot[0].factor_y,plot[0].shift_x, plot[0].shift_y);*/
          
          the_config->xoffset = x; the_config->yoffset = y;
          the_config->paper_dimx = x1-x;
          the_config->paper_dimy = y1-y;
         }
       }
    } while (term != 'Q' && term != 'A' && term != 'S' && term != 'P'&&
             term != 'G'&& term != 'L'&& term != 'F'&& term != 'R'&& 
             term != 'I'&& term != 'M');
   /*plot_textmode();*/
   /*clrscr();*/
   return (term);
#undef MINMAX
}
