#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "v_inp.h"
#include "u_pl_def.h"
#include "u_plot.h"
#include "xben.h"
#include "xb_menu.h"
#include "xb_plot.h"
#include "xb_buff.h"
#include "xb_write.h"
#include "xb_util.h"
#include "xb_comb.h"
#include "xb_apl.h"
#include "xb_lay.h"


#ifndef EXIT_SUCCESS
#define EXIT_SUCCESS 0
#endif

#define bat bat_ 
extern struct bat{ 
      char  plobat[80],plotout[80]; 
} bat; 

static struct beninfo fromapl[MAXPLOTAPL];
static struct plotinfo the_plots[MAXPLOTS];

static struct deviceinfo configuration;

static int akt_plot;

static int warning;
static int holdzoom=FALSE;

static void init_configuration(){
   configuration.screentype = PLOT_DEV_X11;
   configuration.deviceclass = PLOT_DEV_PS;
   configuration.device      = PLOT_DEV_HPGL_7550;
   configuration.paper       = 1;
   configuration.xwidth      = 500;
   use_paper_format(&configuration); 
}

static void init_the_plots(plotinfo *plot){
  char file[10]; int i;
   file[0]='p';file[1]='l';file[2]='o';file[3]='t';
   file[4]='.';file[5]='p';file[6]='s';file[7]='\0';
   plot->bufnum  = XB_STAT_NOBUFF;
   plot->visible = FALSE;
   plot->filename[0] = 0;
   for(i=0;i<8;i++)plot->outfile[i]=file[i];
   plot->filetype = FILETYPE_DETECT;
   reset_scaling(plot);
}
static void init_fromapl(beninfo *fromapl){
   fromapl->iplot=-1;
   fromapl->xanf=1.0;
   fromapl->xend=1.0;
   fromapl->yanf=1.0;
   fromapl->yend=1.0;
   fromapl->a_xanf=1.0;
   fromapl->a_xend=1.0;
   fromapl->a_yanf=1.0;
   fromapl->a_yend=1.0;
}
static void print2_fromapl(beninfo *fromapl){
    printf("print_fromapl a_xanf=%12.2f a_xend=%12.2f  \n",
           fromapl[0].a_xanf,fromapl[0].a_xend);
    printf("print_fromapl a_xanf=%12.2f a_xend=%12.2f  \n",
           fromapl[1].a_xanf,fromapl[1].a_xend);
}


static void init(){
   int i;
   akt_plot = 0;
   warning = FALSE;
   for (i=0; i<MAXPLOTS; i++) init_the_plots(&the_plots[i]);
   for (i=0; i<MAXPLOTAPL; i++) init_fromapl(&fromapl[i]);
}


int wr_beninfo(beninfo *fromapl,int i)
{printf("fromapl[%d].*%f   %f\n",i,fromapl[i].xanf,fromapl[i].a_yend); 
  return(i);
}


void newterm(char *name,char *geometry, char *bgcolor, 
                            char term[],char killcmd[])
{  
   FILE *dfile;
   char opencmd[96],str[32];
   char *c; int i,ic;
 strcpy(opencmd,"xterm -geo ");
 strcat(opencmd,geometry); strcat(opencmd," -bg ");strcat(opencmd,bgcolor);
strcat(opencmd," -fg black");
strcat(opencmd," -e ./");strcat(opencmd,name);strcat(opencmd," & ");
/*printf("opencmd= %s\n",opencmd);*/

   dfile = fopen("terminfo","r");
   if(dfile!=0)system("rm terminfo");
   dfile = fopen(name, "wr");
   strcpy(str, "tty > terminfo");
   fprintf(dfile, "%s\n",str);
   strcpy(str, "sleep 100");
   fprintf(dfile, "%s\n",str);
   fclose(dfile);
   strcpy(str, "chmod +x ");
   strcat(str,name);
   system(str);
   system(opencmd);

   do{
     sleep(1); 
   dfile = fopen("terminfo","r");
   }while(dfile==0);

   i = fscanf(dfile, "%s", term); 
   fclose(dfile);
   /*printf("i=%d term=%s\n",i,term);*/

   str[0]=0;
   strcat(str,"ps t"); /* system dependent*/
   strcat(str,&term[5]);
   strcat(str," > terminfo");
   system(str);

   do{
     sleep(1); 
   dfile = fopen("terminfo","r");
   }while(dfile==0);

   while((ic= getc(dfile))!='\n'); 
   i = fscanf(dfile, "%s", str); 
   fclose(dfile);
   /*printf("i=%d\n%s\n",i,str);*/
   strcpy(killcmd, "kill ");strcat(killcmd,str);
   strcpy(str,"rm terminfo"); system(str);
 return;
}


void main(int argc, char *argv[]){
  int i,j,ix,scrcom,ibegin;
  FILE *volterm;
  double angle,out[16];
  plotinfo *plot;
  deviceinfo *config;
  datatype move_x, move_y;
  char name[20],geometry[60],bgcolor[20],term[16],killcmd[32];
  datatype xx1,xx2,xx3,xx4;

  //printf("argc=%d  argv=%s\n",argc,argv[1]);
  if(argc==2){
   i=0;do{bat.plobat[i]=argv[1][i];i++;} while(argv[1][i] != '\0');
  }else{
   bat.plobat[0]='$'; 
   };
  init();
  xb_buff_init();
  i=plot_init();
  if(i>0){printf(" Error initializing Plot\n %s\n",plot_message());
    return;}

  init_configuration();
  /*printf("argc=%d\n",argc);
    printf("argv[1]=%s\n",argv[1]); 
    printf("argv[2]=%s\n",argv[2]);*/
    if(argc>1){
     i=trans(argv[1],out); ix=(int)out[0];
     if(ix>50)configuration.xwidth=ix;
    };
    if(argc>2){
     i=0;
     while(argv[2][i]!='\0'){the_plots[0].outfile[i]=argv[2][i];i++;};
     the_plots[0].outfile[i]='\0';
     j=0;
     while(the_plots[0].outfile[j]!='.' && j<i)j++;
     if(j == i)the_plots[0].outfile[j]='.';
     the_plots[0].outfile[j+1]='p';the_plots[0].outfile[j+2]='s';
             the_plots[0].outfile[j+3]='\0';
    };

  strcpy(bgcolor,"Yellow1");
   /* fprintf(volterm,"term=%s\n",term);*/   
  use_allplo(fromapl,&the_plots[akt_plot],"allplo");
  if(argc <3 )   strcpy(the_plots[0].outfile,bat.plotout);

  ibegin=0;
  do{ 
    ibegin=ibegin+1; 
    if(ibegin==1) scale1(fromapl,&the_plots[akt_plot],&configuration);
    scrcom= plot_to_screen(fromapl,the_plots,&configuration);
    if(scrcom<0) return;
    if(scrcom!='P')scale5(fromapl,&the_plots[akt_plot],&configuration);
    if(scrcom=='R'){
       reset_fromxben(fromapl,&the_plots[akt_plot],&configuration);
       ibegin=0;}
    if(scrcom=='M')
      center_fromxben(fromapl,&the_plots[akt_plot],&configuration);
    if (scrcom=='A'){
        init();
        xb_buff_init();
	use_allplo(fromapl,&the_plots[akt_plot],"allplo");
        ibegin=0;}
    if (scrcom=='I') ibegin=0;
    if (scrcom=='S'){
       strcpy(geometry,"50x5+450+20");
       strcpy(name,"load_layout");
       newterm(name,geometry,bgcolor,term,killcmd);
       volterm = fopen(term,"r+");
       save_layout(volterm,&configuration,the_plots); 
       system("rm load_layout");system(killcmd); };
    if (scrcom=='L'){ 
       strcpy(geometry,"50x5+450+20");
       strcpy(name,"load_layout");
       newterm(name,geometry,bgcolor,term,killcmd);
       volterm = fopen(term,"r+");
       load_layout(volterm,&configuration,the_plots);
       scale_lay(fromapl,the_plots);
       system("rm load_layout");system(killcmd); };
    if (scrcom=='G'){
	strcpy(geometry,"50x15+450+20");
       strcpy(name,"plot_goemetry");
       newterm(name,geometry,bgcolor,term,killcmd);
       volterm = fopen(term,"r+");
       scale(volterm,fromapl,&the_plots[akt_plot],&configuration);
       system("rm plot_goemetry");system(killcmd);}
    if (scrcom=='P'){
       strcpy(geometry,"50x5+450+20");
       strcpy(name,"Postscript_file");
       newterm(name,geometry,bgcolor,term,killcmd);
       volterm = fopen(term,"r+");
       write_plotfile(volterm,the_plots,&configuration,FILETYPE_PS);
       system("rm Postscript_file");system(killcmd); };
    if (scrcom=='F')ibegin=0;
  }while(scrcom!='Q');
  rmbencom();
  
}
