
#ifndef __XBEN__H__
#define __XBEN__H__

#define VERSION "V4.6beta"
#define VERSIONDATE "27.06.1997"

#define XB_STAT_NOFILE  -2        /* File not found                          */
#define XB_STAT_NOBUFF  -1        /* Buffer does not exist/cannot be created */
#define XB_STAT_OK       0        /* ok                                      */
#define XB_STAT_NOWRITE  1        /* Buffer is not in writing mode           */
#define XB_STAT_NOMEM    2        /* out of memory                           */
#define XB_STAT_BADITEM  3        /* Invalid item code, should not occur     */
#define XB_STAT_NOREAD   4        /* Buffer is not in reading mode           */
#define XB_STAT_END      5        /* End of Buffer                           */
#define XB_STAT_NONSENS  6        /* Operation correct, but stupid           */
#define XB_STAT_EMPTY    7        /* Operation correct, but stupid           */

#define FILETYPE_DETECT 0
#define FILETYPE_ALLPLO 1
#define FILETYPE_XPL    2
#define FILETYPE_HPGL   3
#define FILETYPE_PS     4     
#define MAXBUF          2 

#define MAXPLOTS 1               /* maximum number of plots in memory */
#define MAXPLOTAPL 8                            
#define UNITS_PER_CM 10000        /* Resolution: 1 mu-m  */

/* Type of coordinates, measured in mu-m */
typedef long int datatype;

typedef struct deviceinfo{
   int paper, xwidth, device, deviceclass, screentype;
   datatype paper_dimx, paper_dimy;
   datatype xoffset, yoffset;
} deviceinfo;
   

typedef struct plotinfo{
   int filetype, bufnum, visible, ips;
   datatype shift_x, shift_y;   
   datatype   xmin, xmax,ymin, ymax;
   double factor_x, factor_y, angle;
   char filename[80];
   char outfile[80];
} plotinfo;

typedef struct beninfo{
   int iplot;
   double xanf,xend,yanf,yend;
   double a_xanf,a_xend,a_yanf,a_yend;
   double r_xanf,r_xend,r_yanf,r_yend;
} beninfo;
 
typedef struct itemhead {
   short int item, args;
} itemhead;

typedef long int coord_t;

typedef union itemtype {
   struct itemhead header;
   coord_t x,y;   
   void *nextitem;
} itemtype;

typedef itemtype* itemptr;

typedef struct buffertype {
  itemptr items, size, akt;
  int aktitem, free_items, write_allowed, first;
  datatype xakt, yakt, xmin, xmax, ymin, ymax;
} buffertype;

typedef buffertype *bufferptr;

static bufferptr buffers[MAXBUF];

#endif
