#include <stdio.h>
#include <stdlib.h>
#include <unistd.h> /* defines STDIN_FILENO */
#include <readline/readline.h>
#include <readline/history.h>

#include <string.h>
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <termios.h>



#define readaline readaline_ 
#define addhist addhist_ 
#define clearhist clearhist_ 
#define key key_

static struct termios stored_settings;
/* Simple example of using gnu readline to get lines of input from
   a user. Needs to be linked with -lreadline -lncurses
  add_history tells the readline library to add the line to it's
  internal history, so that using up-arrow (or ^p) will allows the user
  to see/edit previous lines.
*/

int readaline(int k[], char *prompt) {
    int i; char *s;
    s=readline(prompt);    
    if(s[0]=='\0'){i=0;} 
    else{for(i=0;s[i]!='\0';i++)k[i]=s[i];
    free(s);}          /* clean up! */ 
    return(i);	
}
void addhist( char *s) {
   add_history(s);	
}
void clearhist() {
   clear_history();
   	
}

void set_keypress(void)
{
    struct termios new_settings;
    tcgetattr(0,&stored_settings);
    new_settings = stored_settings;
    /* Disable canonical mode, and set buffer size to 1 byte */
    new_settings.c_lflag &= (~ICANON);
    new_settings.c_cc[VTIME] = 0;
    new_settings.c_cc[VMIN] = 1;
    new_settings.c_cc[VINTR]='#';
    /*new_settings.c_lflag &= (~ECHO);*/
    tcsetattr(0,TCSANOW,&new_settings);
    return;
}

void reset_keypress(void)
{
    tcsetattr(0,TCSANOW,&stored_settings);
    return;
}


int key(){
   unsigned int c,is;
   char ch; 
   set_keypress();
   c=getchar(); ch=unctrl(c);
   if(c==10) ch='@';
   if(ch=='@'){is=0;c=ch;}else{is=iscntrl(c);}
   if(is>0){
   c=getchar(); 
   c=getchar(); c=-c;}   
   reset_keypress();
   return c;
}
