#include <X11/Xutil.h>   /*includes Xlib.h*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define geom geom_
#define geompointsc geompointsc_
#define geomextendsc geomextendsc_

typedef struct geo {
   float akt_x, akt_y, symbol_factor;
   char name[80];
   int devtype;
   unsigned long capabilities;
   void (* ploth_line_geo)(int,int,int,int,int);
   void (* ploth_point_geo)(int,int,int);
   void (* ploth_fillrectangle_geo)(int,int,int,int,int);
   void (* ploth_fillpolygon_geo)(int,int,XPoint*);
   void (* ploth_forgrcolor_geo)(int,int,XColor*,unsigned long);
   void (* ploth_drawstring_geo)(int,int,int,char*);
} geotype;
typedef geotype *geoptr;

static    int xscreen;
static    Colormap cmap;
static    XColor color;
static    Display *xdisplay;
static    Window xwindow;
static    GC xgc;

static geoptr hand[2];
extern void plotd_func_psgeo(geotype *geo, XColor colaray[],int colnum, 
                       int vector,int trm, int numpl,int numplot,
			     int winh, int winw);

extern struct geom{
  float BoverF,AoverF,SoverF,HoverF,DAoverF,DSoverF,sc2aperture,geo;
} geom;


static int doKeyPress(XKeyEvent ep, int *x, int *y)
{   char buffer;
    int nchars;
    int iout;
    nchars = XLookupString(&ep,&buffer,1,NULL,NULL);
    *x = ep.x; *y = ep.y; 
  /*printf("buffer=%d",buffer);
    printf("x=%d y=%d x_root=%d y_root=%d\n",*x,*y,x_root,y_root);*/
       if (nchars==1) iout=buffer; /* normal key --> char */
       if (nchars==0) iout=-ep.keycode;
       return(iout);
}
static int doButtonPress(XButtonEvent ep, int *x, int *y)
{   char buffer;
    int nchars;
 nchars = XLookupString((XKeyEvent*)&ep,&buffer,1,NULL,NULL);
    *x = ep.x; *y = ep.y; 
    switch (ep.button){ /* Mouse buttons 1,2,3 */
       case 1 : return (1); break;
       case 2 : return (2); break;
       case 3 : return (3); break;
       /* No mouse button */
       default : if (nchars==1) return(buffer); /* normal key --> char */
                 return(0);                     /* other key  -->    0 */
    }
}





/*-------plotd functions ---------------------------------------*/

void plotd_line_X11geo(int handle, int X0, int Y0, int X1, int Y1){
/* Draw a line */
   XDrawLine(xdisplay,xwindow,xgc,X0,Y0,X1,Y1);
}

void plotd_point_X11geo(int handle, int X0, int Y0){
/* Draw a point */
    XDrawPoint(xdisplay,xwindow,xgc,X0,Y0);
}
void plotd_fillrectangle_X11geo(int handle, int X0, int Y0, int X1, int Y1){
/* Draw a line */
    XFillRectangle(xdisplay,xwindow,xgc,X0,Y0,X1,Y1);
}
void plotd_fillpolygon_X11geo(int handle, int npoints, XPoint *points){
/* Draw a line */
    XFillPolygon(xdisplay,xwindow,xgc,points,npoints,Convex,CoordModeOrigin);
}
void plotd_forgrcolor_X11geo(int handle,int i,XColor colaray[],unsigned long ipixel){
    color.pixel=ipixel;
              XSetForeground(xdisplay,xgc,color.pixel);
}
void plotd_drawstring_X11geo(int handle,int x, int y,char txt[]){
    XDrawString(xdisplay,xwindow, xgc, x,y, txt, strlen(txt));
}
/*-------plot functions ---------------------------------------*/

void plot_line_geo(int handle,  short int IX0, short int IY0, 
                               short int IX1, short int IY1){
      (*hand[handle]->ploth_line_geo)(handle,IX0,IY0,IX1,IY1);
}

void plot_point_geo(int handle,   short int IX0, short int IY0){
      (*hand[handle]->ploth_point_geo)(handle,IX0,IY0);
}
void plot_fillrectangle_geo(int handle, int X0, int Y0, 
                                        unsigned int X1, unsigned int Y1){
/* fill  rectangle */
      (*hand[handle]->ploth_fillrectangle_geo)(handle,X0,Y0,X1,Y1);
}

void plot_fillpolygon_geo(int handle, int npoints, XPoint *points){
/* fill polygon */
      (*hand[handle]->ploth_fillpolygon_geo)(handle,npoints,points);
}

void plot_forgrcolor_geo(int handle,int i,XColor colaray[],unsigned long ipixel){
      (*hand[handle]->ploth_forgrcolor_geo)(handle,i,colaray,ipixel);
}
void plot_drawstring_geo(int handle,int x, int y,char txt[]){
      (*hand[handle]->ploth_drawstring_geo)(handle,x,y,txt);
}


void plotd_func_x11geo(geotype *geo){
   geo->ploth_line_geo          =   plotd_line_X11geo;
   geo->ploth_point_geo         =   plotd_point_X11geo;
   geo->ploth_fillrectangle_geo =   plotd_fillrectangle_X11geo;
   geo->ploth_fillpolygon_geo   =   plotd_fillpolygon_X11geo;
   geo->ploth_forgrcolor_geo    =   plotd_forgrcolor_X11geo;
   geo->ploth_drawstring_geo    =   plotd_drawstring_X11geo;
}


int geompointsc()
{   int i,iyar[6];
    unsigned long xforeground, xbackground, ipixel[16];
    XEvent xevent;
    XColor colaray[16];
    XPoint *npoly;
    unsigned int npoint, ilog;
    char txt[80],txn[10], trm;
    XWindowAttributes xx;
    KeySym key;		/* a dealie-bob to handle KeyPress Events */	

    int   winx,winy,winw,winh,winf,winb,np,nxr,nwh,iwhile,motx,moty,
	  imin,imax,nadd,nabD,nabDA,nscDS,ndtD,nscD,ndtx,nabx,nscp,
          irecov,move,colnumber,numpl,numplot,x,y;
    float tau,cyp,cy0,Fwidth,scp,h,hp,h0,hx,hy,ratio,RB;
        
      Fwidth=500.;
        winw= Fwidth+80; winb=2;
        winx=0; winy=0;
        nxr=40;
        scp=geom.geo*Fwidth;
        nscp=scp;
              hp=geom.DSoverF-geom.SoverF/2.;
              h0=geom.DSoverF+geom.SoverF/2.;
              tau=(float)(Fwidth+nscp)/(geom.HoverF*Fwidth+nscp);
	      cyp=(h0*(1.0-tau)+
                (geom.DAoverF - geom.AoverF/2.0)*tau)*Fwidth;
	      cy0=(hp*(1.0-tau)+
                  (geom.DAoverF + geom.AoverF/2.0)*tau)*Fwidth;
              iyar[0]=h0*Fwidth;
              iyar[1]=hp*Fwidth;
              iyar[2]=cy0;
              iyar[3]=cyp;
              iyar[4]=geom.BoverF/2.0*Fwidth+40;
              imin=1000; imax=-imin;
	      for(i=0;i<5;i++){
               if(imin>iyar[i])imin=iyar[i];
               if(imax<iyar[i])imax=iyar[i];};
	      winf=imax-imin;
        if(geom.BoverF<0.)winf=winf-geom.BoverF/2.*Fwidth;
        np=winf*500;
        winh=winf+120;
        ilog=1;
        npoly=NULL;
    /*  connect to the x server*/
    xdisplay= XOpenDisplay("");
    
    if (xdisplay== NULL){
	fprintf(stderr,"cannot connect to server\n");
        exit(EXIT_FAILURE);
    }

    /*get default screen*/
    xscreen=DefaultScreen(xdisplay);

    /*get black and white representation on current screen*/
    xbackground=WhitePixel(xdisplay,xscreen);
    xforeground=BlackPixel(xdisplay,xscreen);
    
    /*Create Window at (winx,winy), w winw, h winh, border winb,*/ 
    xwindow= XCreateSimpleWindow(xdisplay, DefaultRootWindow(xdisplay),
             winx,winy,winw,winh,winb,xforeground, xbackground);

    if(&xwindow==NULL){
	fprintf(stderr,"cannot open window\n");
        exit(EXIT_FAILURE);
    }

    /*ask for exposure events*/
    XSelectInput(xdisplay, xwindow,ButtonPressMask|ButtonReleaseMask|
     KeyPressMask|ExposureMask|PointerMotionMask);

    /*pop this window up on screen*/
    XMapRaised(xdisplay, xwindow);

    /*set graphics context of rectangle to red*/
    xgc=XCreateGC (xdisplay,xwindow,0,0);
    cmap=DefaultColormap(xdisplay,xscreen);
    strcpy(txt,
    "Mossbauer absorption geometry                    (press h for help)");    
    XStoreName(xdisplay,xwindow, txt);

    ratio=1.0;                                                
    nadd=101;

    npoly = malloc(2000*sizeof(short int));
    move=0;
    numpl=1;
    numplot=0;
    iwhile=1;
    irecov=0;
    hand[0] = malloc(sizeof(geotype));
    plotd_func_x11geo(hand[0]);
	while(iwhile){
        if(nadd<100)iwhile=0; if(numplot==0)numpl=1;else numpl=-1;
	/*wait for next event*/
  
	/*wait for next event*/
 	    if(ilog==1){
	      XCheckWindowEvent(xdisplay,xwindow,ExposureMask|ButtonPressMask|ShiftMask    
          |KeyPressMask|ButtonReleaseMask|PointerMotionMask,&xevent);
	 XNextEvent(xdisplay,&xevent);}
         if(irecov == 1 && xevent.type == ButtonPress)
          { xevent.type=Expose; plotd_func_x11geo(hand[0]);irecov=0;}

        /*printf("switch(xevent.type)=%i\n",xevent.type);*/
        switch(xevent.type){
	/*ignore this event*/
       
	    case Expose: 
          do{} while(XCheckWindowEvent(xdisplay,xwindow,ExposureMask|
          ButtonPressMask|KeyPressMask|PointerMotionMask|ButtonReleaseMask,
      	     &xevent));
          XClearWindow(xdisplay, xwindow);
		ilog=1;       
         XGetWindowAttributes(xdisplay,xwindow,&xx);
         ratio=(float)(xx.height-120)/winf;
        
	 if(move==0){
          tau=1.0/geom.HoverF;
          hp=geom.DSoverF-geom.SoverF/2.;
          h0=geom.DSoverF+geom.SoverF/2.;
          cy0=(hp*(1.0-tau)+
              (geom.DAoverF + geom.AoverF/2.0)*tau)*Fwidth;
          cyp=(h0*(1.0-tau)+
              (geom.DAoverF - geom.AoverF/2.0)*tau)*Fwidth;
          if(hp>=cyp)nadd=-cyp*ratio+60; 
          if(hp<=cyp)nadd=-hp*ratio+60;
          /*printf("geom.AoverF=%f DAoverF=%f  tau=%f\n",geom.AoverF,geom.DAoverF,tau); 
           printf("hp=%f  h0=%f  cyp=%f  cy0=%f\n",hp,h0,cyp,cy0);*/
         }
         ndtx=Fwidth+nxr;   
         nabD=geom.AoverF*Fwidth/2.*ratio;
         nabDA=geom.DAoverF*Fwidth*ratio;
         nscDS=geom.DSoverF*Fwidth*ratio;
         nscD=geom.SoverF*Fwidth/2.*ratio;
         nabx=geom.HoverF*Fwidth+nxr;
         winh=winf*ratio+120;


          nwh=20;
          if(geom.BoverF>0.){        
	    ndtD=geom.BoverF*Fwidth/2.*ratio;  
            if(nadd-ndtD<60) nadd=ndtD+60;
            npoly[0].x=ndtx;
            npoly[0].y=nadd+ndtD;
            npoly[1].x=ndtx+nwh;
            npoly[1].y=nadd+ndtD;
            npoly[2].x=ndtx+nwh;
            npoly[2].y=nadd-ndtD;
            npoly[3].x=ndtx;
	    npoly[3].y=nadd-ndtD;
            npoly[4].x=ndtx;
	    npoly[4].y=nadd+ndtD;
            npoint=5;}
        else{
	   RB=-geom.BoverF*Fwidth/2.*ratio; ndtD=RB;
           if(nadd-3*ndtD/2<60) nadd=3*ndtD/2+60; 
           h=(8./9./RB);h=h*h;
           npoly[0].x=ndtx;
           npoly[0].y=nadd;
           npoly[1].x=ndtx+nwh;
           npoly[1].y=nadd;
           for(i=0;i<ndtD*3/2;i++){
	       npoly[i+2].x=ndtx+nwh*exp(-h*i*i);
	       npoly[i+2].y=nadd+i+ndtD*3/4;
	    };
            npoly[i+2].x=ndtx+nwh*exp(-h*i*i);
	    npoly[i+2].y=nadd+i+ndtD*3/4;
            npoly[i+3].x=ndtx;
	    npoly[i+3].y=nadd+i+ndtD*3/4;
            npoly[i+4].x=ndtx;
	    npoly[i+4].y=nadd;
            npoint=i+5;
             for(i=0;i<npoint;i++){npoly[i+npoint].x=npoly[i].x;
	     npoly[i+npoint].y=-npoly[i].y+2*nadd;}
             npoint=npoint*2;
          };

             for( i=0;i<16;i++){
		     colaray[i].red=0;
		     colaray[i].green=0;
		     colaray[i].blue=0;
              }

              /* the foolowing colors are used later*/
              colaray[1].green=65000;
              colaray[2].blue=65000;
              colaray[3].red=65000;
              colaray[4].red=35000;
              colaray[5].red=65535;
 	      colaray[5].green=65535;
 	      colaray[5].blue=65535;
              colnumber=5;
              for(i=0;i<colnumber+1;i++){             
	       color.red=colaray[i].red; 
               color.green=colaray[i].green;
               color.blue=colaray[i].blue;
               if(XAllocColor(xdisplay,cmap,&color))
               XSetForeground(xdisplay,xgc,color.pixel);
               ipixel[i]=color.pixel;
              }

              plot_forgrcolor_geo(0,0,colaray,ipixel[0]);
              strcpy(txt,"source");    
              plot_drawstring_geo(0,nxr-10,25, txt);
              strcpy(txt,"s=0");    
              plot_drawstring_geo(0,nxr-5,40, txt);
              sprintf(txn,"%5.3f",abs((float)nscp)/Fwidth);
              strcpy(txt,"|geo|="); strcat(txt,txn);
              plot_drawstring_geo(0,nxr-5,nadd+100, txt);


              /*absorber position*/
              strcpy(txt,"absorber");    
              plot_drawstring_geo(0,nabx-20,25, txt);
              strcpy(txt,"aperture");
              plot_drawstring_geo(0,ndtx-25,25, txt);
              strcpy(txt,"(detector)");    
              plot_drawstring_geo(0,ndtx-29,38, txt);
              /*optical axis*/  
              plot_line_geo(0,15,nadd,ndtx+25,nadd);
              plot_line_geo(0,15,nadd+1,ndtx+25,nadd+1);
              plot_line_geo(0,nxr,50,nxr,nadd-50*ratio);

              /*absorber*/
              plot_forgrcolor_geo(0,1,colaray,ipixel[1]);
              plot_fillrectangle_geo(0,nabx,nadd+nabDA-nabD,2,nabD*2);

              plot_forgrcolor_geo(0,4,colaray,ipixel[4]);

              tau=(float)(Fwidth+nscp)/(geom.HoverF*Fwidth+nscp);
	      cyp=(h0*(1.0-tau)+
                (geom.DAoverF - geom.AoverF/2.0)*tau)*Fwidth*ratio;
	      cy0=(hp*(1.0-tau)+
                  (geom.DAoverF + geom.AoverF/2.0)*tau)*Fwidth*ratio;

              plot_line_geo(0,nxr-nscp,nadd+nscDS,ndtx,nadd+cyp);
              plot_line_geo(0,nxr-nscp,nadd+nscDS,ndtx,nadd+cy0);

              plot_forgrcolor_geo(0,3,colaray,ipixel[3]);

	      tau=(float)(Fwidth-nscp)/(geom.HoverF*Fwidth-nscp);
	      cyp=(h0*(1.0-tau)+
                (geom.DAoverF - geom.AoverF/2.0)*tau)*Fwidth*ratio;
	      cy0=(hp*(1.0-tau)+
                  (geom.DAoverF + geom.AoverF/2.0)*tau)*Fwidth*ratio;
              plot_line_geo(0,nxr+nscp,nadd+nscDS,ndtx,nadd+cyp);
              plot_line_geo(0,nxr+nscp,nadd+nscDS,ndtx,nadd+cy0);

              /*detector,aperture*/
              plot_forgrcolor_geo(0,2,colaray,ipixel[2]);
              plot_fillrectangle_geo(0,ndtx,nadd-ndtD,4,ndtD*2);
              plot_fillpolygon_geo(0,npoint,npoly);

              plot_forgrcolor_geo(0,0,colaray,ipixel[0]);              
              plot_line_geo(0,ndtx,50,ndtx,winh-10);
              /*source*/
              plot_forgrcolor_geo(0,3,colaray,ipixel[3]);     
              plot_fillrectangle_geo(0,nxr-nscp,nadd-nscD,2,nscD*2);
              plot_fillrectangle_geo(0,nxr+nscp,nadd-nscD,2,nscD*2);
 		break;

            case KeyPress   :   trm = doKeyPress(xevent.xkey,&x,&y);
		/*printf("KeyPress x=%d y=%d trm=%c \n",x,y,trm);*/
              if( trm == 'q'){ iwhile=0; break;}
              if( trm == 'h'){printf(" \n");
              printf("exit window        : key=q or mouse button right\n");
              printf("source position    : press mouse button left with cursor\n");
              printf("                     around s=0 and optical axis\n");
              printf("curse position     : the units of the constants (sc2aperture,...)\n");
              printf("absorber position  : may be altered by tracking with mouse button left\n");
              printf("detector efficiency: represented by the thickness of the blue area\n");
              printf("                     (why the smooth edge look for detailed help) \n");
              printf("plotfile .ps       : pp for 1 plot, pi i=1,2 for i plots to an A4 format\n");
              printf("                     (there is no allplo plot)\n");
              printf("detailed help      : by calling for help inside the pa/co command\n");
              printf("                     for example {he ci], {he pi} of the constants\n"); 
              printf("                     and parameters defining the geometry\n");
               }
	      if( trm == 'p' || trm == 'r'){
                  ilog=0;
                  xevent.type=Expose;
		  if( trm == 'p'){
                  XNextEvent(xdisplay,&xevent);
                  trm = doKeyPress(xevent.xkey,&x,&y);
	          /*printf("KeyPress key=%d trm=%c \n",xevent.xkey.keycode,trm);*/
                    if(trm > 48 && trm<57 && numpl == 1)numplot=trm-48; 
                     plotd_func_psgeo(hand[0],colaray,colnumber,
                                 1,trm,numpl,numplot,winh,winw);
                    if(numplot < 0){numplot=0;xevent.type=ButtonPress;}
                    else xevent.type=Expose; 
                    irecov=1;
		    if(numplot>0)numplot=numplot-1;
               }else plotd_func_x11geo(hand[0]);
              }

               break; 
            case ButtonRelease  : 
		/*printf("KeyRelease  switch(xevent.type)=%i\n",xevent.type);*/
		move=0;
	     break;
            
            case MotionNotify:
		/*printf("MotionNotify  switch(xevent.type)=%i\n",xevent.type);*/
                plot_forgrcolor_geo(0,5,colaray,ipixel[5]);
                plot_fillrectangle_geo(0,nxr+50,60,120,14);
                plot_forgrcolor_geo(0,0,colaray,ipixel[0]);
		motx=xevent.xbutton.x;moty=xevent.xbutton.y;
		hx=(float)(motx-nxr)/Fwidth*geom.sc2aperture;
		hy=(float)(moty-nadd)/Fwidth/ratio*geom.sc2aperture;
                sprintf(txt,"x=%5.2f  y=%5.2f",hx,hy);
                plot_drawstring_geo(0,nxr+50,70, txt);
                if (move==1)
                {   geom.HoverF=1./Fwidth*(motx-nxr);
                    geom.DAoverF=1./Fwidth/ratio*(moty-nadd);
                    ilog=0;
                    xevent.type=Expose;
                    /*printf("x=%d  y=%d\n",xevent.xbutton.x,xevent.xbutton.y);
                    printf("motx=%d  moty=%d nadd=%d\n",motx,moty,nadd);
                    printf("A=%5.1f  DA=%5.1f\n",geom.HoverF,geom.DAoverF);*/
                }
                break;
            case ButtonPress:  trm = doButtonPress(xevent.xbutton,&x,&y);
		if( trm==3){ iwhile=0; break;}
                move=0; 
                /*xp=xevent.xbutton.x;*yp=xevent.xbutton.y;*/
               if ((x>=nabx-10) && (x<=nabx+10) &&
                 (y>=nadd+nabDA-nabD) && (y<=nadd+nabDA+nabD*2))move=1;

                 if ((x>=0) && (x<=nxr+50) && (y>=60) && (y<=nadd+60))
                 {nscp=nxr-x; if(nscp>30) nscp=30;if(nscp<-30) nscp=-30;
                 XClearWindow(xdisplay, xwindow);
                 ilog=0; xevent.type=Expose;
                }

                break;
	}
    }
    free(npoly);
    XDestroyWindow(xdisplay,xwindow); XCloseDisplay(xdisplay);
    return(iwhile);
}

int geomextendsc()
{
    int i, iyar[6];
    unsigned long xforeground, xbackground, ipixel[16];
    XEvent xevent;
    XColor colaray[16];
    XPoint *npoly;
    unsigned short int npoint, ilog, *colar, *iyu, *iyl,height;
    char txt[80],txn[10];
    XWindowAttributes xx;

    int    winx,winy,winw,winh,winf,winb,np,nxr,nwh,iwhile,nwidth,
           nadd,nabD,nabDA,nscDS,ndtD,nscD,ndtx,nabx,nscp,nscp0,
	imin,imax,idelta,idcol,l,j,iyp,iy0,irecov,
           motx,moty,move,colnumber,numpl,numplot,trm,x,y;
    float tau,cyp,cy0,Fwidth,scp,h,hp,h0,hx,hy,ratio,RB;
    float slopep,slope0;
        
        Fwidth=500.;
        winw= Fwidth+80; winb=2;
        winx=0; winy=0;
        nxr=40;
        nabx=geom.HoverF*Fwidth+nxr;
        scp=geom.geo*Fwidth;
        nscp=scp;
              hp=geom.DSoverF-geom.SoverF/2.;
              h0=geom.DSoverF+geom.SoverF/2.;
              tau=(float)(Fwidth+nscp)/(geom.HoverF*Fwidth+nscp);
	      cyp=(h0*(1.0-tau)+
                (geom.DAoverF - geom.AoverF/2.0)*tau)*Fwidth;
	      cy0=(hp*(1.0-tau)+
                  (geom.DAoverF + geom.AoverF/2.0)*tau)*Fwidth;
              iyar[0]=h0*Fwidth;
              iyar[1]=hp*Fwidth;
              iyar[2]=cy0;
              iyar[3]=cyp;
              iyar[4]=geom.BoverF/2.0*Fwidth+60;
              imin=1000; imax=-imin;
	      for(i=0;i<5;i++){
               if(imin>iyar[i])imin=iyar[i];
               if(imax<iyar[i])imax=iyar[i];};
	      winf=imax-imin;
        if(geom.BoverF<0.)winf=winf-geom.BoverF/2.*Fwidth;
        np=winf*500;
        winh=winf+120;
        ilog=1;
        npoly=NULL;

    /*  connect to the x server*/
    xdisplay= XOpenDisplay("");
    
    if (xdisplay== NULL){
	fprintf(stderr,"cannot connect to server\n");
        exit(EXIT_FAILURE);
    }

    /*get default screen*/
    xscreen=DefaultScreen(xdisplay);

    /*get black and white representation on current screen*/
    xbackground=WhitePixel(xdisplay,xscreen);
    xforeground=BlackPixel(xdisplay,xscreen);
    
    /*Create Window at (winx,winy), w winw, h winh, border winb,*/ 
    xwindow= XCreateSimpleWindow(xdisplay, DefaultRootWindow(xdisplay),
             winx,winy,winw,winh,winb,xforeground, xbackground);

    if(&xwindow==NULL){
	fprintf(stderr,"cannot open window\n");
        exit(EXIT_FAILURE);
    }

    /*ask for exposure events*/
     XSelectInput(xdisplay, xwindow,ButtonPressMask|ButtonReleaseMask|
     KeyPressMask|ExposureMask|PointerMotionMask);

    /*pop this window up on screen*/
    XMapRaised(xdisplay, xwindow);

    /*set graphics context of rectangle to red*/
    xgc=XCreateGC (xdisplay,xwindow,0,0);
    cmap=DefaultColormap(xdisplay,xscreen);
    strcpy(txt,
    "Mossbauer absorption geometry                    (press h for help)");    
    XStoreName(xdisplay,xwindow, txt);


    ratio=1.0;                                                
    nadd=400000;

    colar = malloc(nadd*sizeof(short int));
    npoly = malloc(2000*sizeof(short int));
    iyu = malloc(1000*sizeof(short int));
    iyl = malloc(1000*sizeof(short int));
    for(i = 0;i<nadd;i++){colar[i]=0;};
    move=0;
    numpl=1;
    numplot=0;
    iwhile=1;
    irecov=0;
    hand[0] = malloc(sizeof(geotype));
    plotd_func_x11geo(hand[0]);
	while(iwhile){
        if(nadd<100)iwhile=0; if(numplot==0)numpl=1;else numpl=-1;
	/*wait for next event*/
     
        if(ilog==1){
         XCheckWindowEvent(xdisplay,xwindow,ExposureMask|ButtonPressMask    
          |KeyPressMask|ButtonReleaseMask|PointerMotionMask,&xevent);
	 XNextEvent(xdisplay,&xevent);
          }
	    if(irecov == 1 && xevent.type == ButtonPress)
            { xevent.type=Expose; plotd_func_x11geo(hand[0]);irecov=0;}
	    /*printf("xevent.type=%d \n",xevent.type); */
      switch(xevent.type){
       
      case Expose: 
         do{} while(XCheckWindowEvent(xdisplay,xwindow,ExposureMask|
         ButtonPressMask|KeyPressMask|PointerMotionMask|ButtonReleaseMask,
          &xevent));
         XClearWindow(xdisplay, xwindow);
	 ilog=1;       
         XGetWindowAttributes(xdisplay,xwindow,&xx);
         height=xx.height;
         if(height>700)height=700;
	 /*printf("window w=%d  h=%d winf=%d\n",xx.width,xx.height,winf);*/
         ratio=(float)(height-120)/winf;
        
        for(i = 0;i<400000;i++){colar[i]=0;};
	if(move==0){
          tau=1.0/geom.HoverF;
          hp=geom.DSoverF-geom.SoverF/2.;
          h0=geom.DSoverF+geom.SoverF/2.;
          cy0=(hp*(1.0-tau)+
              (geom.DAoverF + geom.AoverF/2.0)*tau)*Fwidth;
          cyp=(h0*(1.0-tau)+
              (geom.DAoverF - geom.AoverF/2.0)*tau)*Fwidth;
          if(hp>=cyp)nadd=-cyp*ratio+60; 
          if(hp<=cyp)nadd=-hp*ratio+60;
          /*printf("geom.AoverF=%f DAoverF=%f  tau=%f\n",geom.AoverF,geom.DAoverF,tau); 
           printf("hp=%f  h0=%f  cyp=%f  cy0=%f\n",hp,h0,cyp,cy0);*/
	 }

         ndtx=Fwidth+nxr;   
         nabD=geom.AoverF*Fwidth/2.*ratio;
         nabDA=geom.DAoverF*Fwidth*ratio;
         nscDS=geom.DSoverF*Fwidth*ratio;
         nscD=geom.SoverF*Fwidth/2.*ratio;
         nabx=geom.HoverF*Fwidth+nxr;
         winh=winf*ratio+120;


          nwh=20;
          if(geom.BoverF>0.){        
	    ndtD=geom.BoverF*Fwidth/2.*ratio;  
            if(nadd-ndtD<60) nadd=ndtD+60;
            npoly[0].x=ndtx;
            npoly[0].y=nadd+ndtD;
            npoly[1].x=ndtx+nwh;
            npoly[1].y=nadd+ndtD;
            npoly[2].x=ndtx+nwh;
            npoly[2].y=nadd-ndtD;
            npoly[3].x=ndtx;
	    npoly[3].y=nadd-ndtD;
            npoly[4].x=ndtx;
	    npoly[4].y=nadd+ndtD;
            npoint=5;}
        else{
	   RB=-geom.BoverF*Fwidth/2.*ratio; ndtD=RB;
           if(nadd-3*ndtD/2<60) nadd=3*ndtD/2+60; 
           h=0.0;
           npoly[0].x=ndtx;
           npoly[0].y=nadd;
           npoly[1].x=ndtx+nwh;
           npoly[1].y=nadd;
           for(i=0;i<ndtD*3/2;i++){
	       npoly[i+2].x=ndtx+nwh*exp(-h*i*i);
	       npoly[i+2].y=nadd-i-ndtD*3/4;
	    };
            npoly[i+2].x=ndtx+nwh*exp(-h*i*i);
	    npoly[i+2].y=nadd-i-ndtD*3/4;
            npoly[i+3].x=ndtx;
	    npoly[i+3].y=nadd-i-ndtD*3/4;
            npoly[i+4].x=ndtx;
	    npoly[i+4].y=nadd;
            npoint=i+5;
             for(i=0;i<npoint;i++){npoly[i+npoint].x=npoly[i].x;
	     npoly[i+npoint].y=-npoly[i].y+2*nadd;}
             npoint=npoint*2;
          };

              hp=geom.DSoverF-geom.SoverF/2.;
              h0=geom.DSoverF+geom.SoverF/2.;
              tau=(float)(Fwidth+nscp)/(geom.HoverF*Fwidth+nscp);
	      cyp=(h0*(1.0-tau)+
                (geom.DAoverF - geom.AoverF/2.0)*tau)*Fwidth*ratio;
	      cy0=(hp*(1.0-tau)+
                  (geom.DAoverF + geom.AoverF/2.0)*tau)*Fwidth*ratio;
              iyar[0]=h0*Fwidth*ratio;
              iyar[1]=hp*Fwidth*ratio;
              iyar[2]=cy0;
              iyar[3]=cyp;
              imin=1000; imax=-imin;
	      for(i=0;i<4;i++){
               if(imin>iyar[i])imin=iyar[i];
               if(imax<iyar[i])imax=iyar[i];};
	      idelta=imax-imin;

              nwidth=ndtx-(nxr-nscp);
              nscp0=nscDS-nscD;
              hp=geom.DSoverF-geom.SoverF/2.;

	      cyp=(hp*(1.0-tau)+
                (geom.DAoverF - geom.AoverF/2.0)*tau)*Fwidth*ratio;
	      cy0=(hp*(1.0-tau)+
                  (geom.DAoverF + geom.AoverF/2.0)*tau)*Fwidth*ratio;
              slopep=-(float)(nscp0-cyp)/nwidth;
              slope0=-(float)(nscp0-cy0)/nwidth;

              idcol=5000;
              for(i=0;i<6;i++){
                color.red=65535-i*idcol; color.blue=0; color.green=0;
                XAllocColor(xdisplay,cmap,&color);
                XSetForeground(xdisplay,xgc,color.pixel);
                colaray[i]=color;
                ipixel[i]=color.pixel;
              }
              for( i=6;i<16;i++){
		     colaray[i].red=0;
		     colaray[i].green=0;
		     colaray[i].blue=0;
              }

              /* the foolowing colors are used later*/
              colaray[7].green=65000;
              colaray[8].blue=65000;
              colaray[10].red=35000;
              colaray[11].red=65535;
 	      colaray[11].green=65535;
 	      colaray[11].blue=65535;
              colnumber=11;
               for(i=6;i<colnumber+1;i++){             
	       color.red=colaray[i].red; 
               color.green=colaray[i].green;
               color.blue=colaray[i].blue;
               if(XAllocColor(xdisplay,cmap,&color))
               XSetForeground(xdisplay,xgc,color.pixel);
               ipixel[i]=color.pixel;
	      }

/*--------------------------------------------------------------------*/

              plot_forgrcolor_geo(0,9,colaray,ipixel[9]);
              strcpy(txt,"source");    
              plot_drawstring_geo(0,nxr-10,25, txt);
              strcpy(txt,"s=0");    
              plot_drawstring_geo(0,nxr-5,40, txt);
              sprintf(txn,"%5.3f",abs((float)nscp)/Fwidth);
              strcpy(txt,"|geo|="); strcat(txt,txn);
              plot_drawstring_geo(0,nxr-5,nadd+100, txt);

              /*absorber position*/
              strcpy(txt,"absorber");    
              plot_drawstring_geo(0,nabx-20,25, txt);
              strcpy(txt,"aperture");
              plot_drawstring_geo(0,ndtx-25,25, txt);
              strcpy(txt,"(detector)");    
              plot_drawstring_geo(0,ndtx-29,38, txt);


               for(i = 0;i<nabx-(nxr-nscp);i++) 
		  iyu[i]=-imin+nscp0 + slopep*i;
	       for(i = nabx-(nxr-nscp);i<nwidth;i++)
                  iyl[i]=-imin+nscp0 + slope0*i;
             
             for(i = 0;i<nwidth;i++){ 
		  iyp=-imin+nscp0 + slopep*i;
		  iy0=-imin+nscp0 + slope0*i;
               for(l = iyp;l<iy0+1;l++){
		   colar[i*idelta+l]=colar[i*idelta+l]+1;
	       }}

              nscp0=nscDS+nscD;
              hp=geom.DSoverF+geom.SoverF/2.;
	      cyp=(hp*(1.0-tau)+
                (geom.DAoverF - geom.AoverF/2.0)*tau)*Fwidth*ratio;
	      cy0=(hp*(1.0-tau)+
                  (geom.DAoverF + geom.AoverF/2.0)*tau)*Fwidth*ratio;
              slopep=-(float)(nscp0-cyp)/nwidth;
              slope0=-(float)(nscp0-cy0)/nwidth;

               for(i = 0;i<nabx-(nxr-nscp);i++) 
		  iyl[i]=-imin+nscp0 + slope0*i;
	       for(i = nabx-(nxr-nscp);i<nwidth;i++)
                  iyu[i]=-imin+nscp0 + slopep*i;

              
	       for(i = 0;i<nwidth;i++){ 
		  iyp=-imin+nscp0 + slopep*i;
		  iy0=-imin+nscp0 + slope0*i;
               for(l = iyp;l<iy0+1;l++)colar[i*idelta+l]=colar[i*idelta+l]+1;
	       }

              nscp0=nscDS;
              hp=geom.DSoverF;
	      cyp=(hp*(1.0-tau)+
                (geom.DAoverF - geom.AoverF/2.0)*tau)*Fwidth*ratio;
	      cy0=(hp*(1.0-tau)+
                  (geom.DAoverF + geom.AoverF/2.0)*tau)*Fwidth*ratio;
              slopep=-(float)(nscp0-cyp)/nwidth;
              slope0=-(float)(nscp0-cy0)/nwidth;

              for(i = 0;i<nwidth;i++){ 
		  iyp=-imin+nscp0 + slopep*i;
		  iy0=-imin+nscp0 + slope0*i;
               for(l = iyp;l<iy0+1;l++)colar[i*idelta+l]=colar[i*idelta+l]+1;
	       }

              nscp0=nscDS+nscD/2;
              hp=geom.DSoverF+geom.SoverF/4.;
	      cyp=(hp*(1.0-tau)+
                (geom.DAoverF - geom.AoverF/2.0)*tau)*Fwidth*ratio;
	      cy0=(hp*(1.0-tau)+
                  (geom.DAoverF + geom.AoverF/2.0)*tau)*Fwidth*ratio;
              slopep=-(float)(nscp0-cyp)/nwidth;
              slope0=-(float)(nscp0-cy0)/nwidth;

              for(i = 0;i<nwidth;i++){ 
		  iyp=-imin+nscp0 + slopep*i;
		  iy0=-imin+nscp0 + slope0*i;
               for(l = iyp;l<iy0+1;l++)colar[i*idelta+l]=colar[i*idelta+l]+1;
	       }

              nscp0=nscDS-nscD/2;
              hp=geom.DSoverF-geom.SoverF/4.;
	      cyp=(hp*(1.0-tau)+
                (geom.DAoverF - geom.AoverF/2.0)*tau)*Fwidth*ratio;
	      cy0=(hp*(1.0-tau)+
                  (geom.DAoverF + geom.AoverF/2.0)*tau)*Fwidth*ratio;
              slopep=-(float)(nscp0-cyp)/nwidth;
              slope0=-(float)(nscp0-cy0)/nwidth;

              for(i = 0;i<nwidth;i++){ 
		  iyp=-imin+nscp0 + slopep*i;
		  iy0=-imin+nscp0 + slope0*i;
               for(l = iyp;l<iy0+1;l++)colar[i*idelta+l]=colar[i*idelta+l]+1;
	       }
	    
	       for(i = 0;i<nwidth;i++){
               for(l = iyu[i];l<iyl[i]+1;l++){
		   /*color.pixel=ipixel[colar[i*idelta+l]]; 
		     XSetForeground(xdisplay,xgc,color.pixel);*/
                   j=colar[i*idelta+l];
                   plot_forgrcolor_geo(0,j,colaray,ipixel[j]);
                   plot_point_geo(0,i+nxr-nscp,l+nadd+imin);
		}}


              /*optical axis*/  
              plot_forgrcolor_geo(0,6,colaray,ipixel[6]);
              plot_line_geo(0,15,nadd,ndtx+25,nadd);
              plot_line_geo(0,15,nadd+1,ndtx+25,nadd+1);
              plot_line_geo(0,nxr,50,nxr,nadd-50*ratio);

              /*absorber*/
              /*optical axis*/  
              plot_forgrcolor_geo(0,7,colaray,ipixel[7]);
	      plot_fillrectangle_geo(0,nabx,nadd+nabDA-nabD,4,nabD*2);

              /*detector,aperture*/
              plot_forgrcolor_geo(0,8,colaray,ipixel[8]);
              plot_fillrectangle_geo(0,ndtx,nadd-ndtD,4,ndtD*2);
              plot_fillpolygon_geo(0,npoint,npoly);

              plot_forgrcolor_geo(0,9,colaray,ipixel[9]);              
              plot_line_geo(0,ndtx,50,ndtx,winh-10);
              /*source*/
              plot_forgrcolor_geo(0,10,colaray,ipixel[10]);
	      plot_fillrectangle_geo(0,nxr-nscp,nadd+nscDS-nscD,2,nscD*2);
	      plot_fillrectangle_geo(0,nxr+nscp,nadd+nscDS-nscD,2,nscD*2);
 		break;
      case KeyPress   : trm = doKeyPress(xevent.xkey,&x,&y);  
	  /*printf("KeyPress x=%d y=%d trm=%c \n",x,y,trm);*/
	      /*printf("KeyPress key=%d trm=%c \n",xevent.xkey.keycode,trm);*/
              if( trm == 'q'){ iwhile=0; break;}
              if( trm == 'h'){printf(" \n");
              printf("exit window        : key=q or mouse button right\n");
              printf("source position    : press mouse button left with cursor\n");
              printf("                     around s=0 and optical axis\n");
              printf("curse position     : the units of the constants (sc2aperture,...)\n");
              printf("absorber position  : may be altered by tracking with mouse button left\n");
              printf("detector efficiency: represented by the thickness of the blue area\n");
              printf("                     (why the smooth edge look for detailed help) \n");
              printf("plotfile .ps       : Pp for 1 plot, Pi i=1,2 for i plots to an A4 format\n");
              printf("                     (there is no allplo plot)\n");
              printf("detailed help      : by calling for help inside the pa/co command\n");
              printf("                     for example {he ci], {he pi} of the constants\n"); 
              printf("                     and parameters defining the geometry\n");
              }
	      if( trm == 'P' || trm == 'r'){
                  ilog=0;
                  xevent.type=Expose;
		  if( trm == 'P'){
                  XNextEvent(xdisplay,&xevent);
                  trm = doKeyPress(xevent.xkey,&x,&y);
	          printf("KeyPress key=%d trm=%c \n",xevent.xkey.keycode,trm);
                    if(trm > 48 && trm<57 && numpl == 1)numplot=trm-48; 
                     plotd_func_psgeo(hand[0],colaray,colnumber,
                                 1,trm,numpl,numplot,winh,winw);
                    if(numplot < 0){numplot=0;xevent.type=ButtonPress;}
                    else xevent.type=Expose; 
                    irecov=1;
		    if(numplot>0)numplot=numplot-1;
               }else plotd_func_x11geo(hand[0]);
              }
               break; 
      case ButtonRelease  : 
		/*printf("KeyRelease  switch(xevent.type)=%i\n",xevent.type);*/
	       move=0;
	       break;
      case MotionNotify:
               plot_forgrcolor_geo(0,11,colaray,ipixel[11]);
               plot_fillrectangle_geo(0,nxr+50,60,120,14);
               plot_forgrcolor_geo(0,9,colaray,ipixel[9]);
	       motx=xevent.xbutton.x; moty=xevent.xbutton.y;
	       hx=(float)(xevent.xbutton.x-nxr)/Fwidth*geom.sc2aperture;
	       hy=(float)(xevent.xbutton.y-nadd)/Fwidth/ratio*geom.sc2aperture;
               sprintf(txt,"x=%5.2f  y=%5.2f",hx,hy);
               plot_drawstring_geo(0,nxr+50,70, txt);
               if (move==1)
                {   geom.HoverF=1./Fwidth*(motx-nxr);
                    geom.DAoverF=1./Fwidth/ratio*(moty-nadd);
                    ilog=0;
                    xevent.type=Expose;
                    /*printf("x=%d  y=%d\n",xevent.xbutton.x,xevent.xbutton.y);
                    printf("motx=%d  moty=%d nadd=%d\n",motx,moty,nadd);
                    printf("A=%5.1f  DA=%5.1f\n",geom.HoverF,geom.DAoverF);*/
                }
                break;
     case ButtonPress:  trm = doButtonPress(xevent.xbutton,&x,&y);
        	 /*printf("ButtonPress key=%d x=%d y=%d\n",trm,*x,*y); */
		if( trm==3){ iwhile=0; break;}
                move=0; 
                if ((x>=nabx-10) && (x<=nabx+10) &&
                 (y>=nadd+nabDA-nabD) && (y<=nadd+nabDA+nabD*2))move=1;
                
                if ((x>=0) && (x<=nxr+50) && (y>=60) && (y<=nadd+60))
                 {nscp=nxr-x; if(nscp>30) nscp=30;if(nscp<-30) nscp=-30;
                 XClearWindow(xdisplay, xwindow);
                 ilog=0; xevent.type=Expose;
                }
                break;
	}
    }
     free(colar);
     free(npoly);
     free(iyu);
     free(iyl);
     XDestroyWindow(xdisplay,xwindow); XCloseDisplay(xdisplay);
 
    return(iwhile);
}

