
/* Definition Module V_INP   */
/* Version of 17-JUL-1992    */

#ifndef __V_INP_LOADED__
#define __V_INP_LOADED__ 1
#include <stdio.h>

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

/* Definitions to avoid collisions with names in MOSFUN */
#define trans __ctrans
#define directory __cdirectory


#define MENU_SIZE 20

/* Character constants for cursor keys */
/* must be compiled with -unsigned     */
#define SMG_K_TRM_UP    255
#define SMG_K_TRM_DOWN  254
#define SMG_K_TRM_LEFT  253
#define SMG_K_TRM_RIGHT 252

/* Im Definition-Modul von V_INP benoetigte Typen */
/* Input fuer GET_GLOBALS                         */

#define real float

typedef char anystring[81];

typedef struct name_rec  {
                   anystring fname;
                   struct name_rec *next;
     } name_rec;


typedef struct MenuType {
                   int anz;
                   anystring titel, items[MENU_SIZE];
                   char abbrevs[MENU_SIZE], vital[MENU_SIZE];
                 } MenuType;


void init_v_inp();

char *mystrerror(int code);

/* ============= WRK:[VEF.PASCAL.V_LIB]V_EDITLIB.PAS;1 ================ */

void edit_line(char line[], char item[], int y, char **hilfe);

/* ============= WRK:[VEF.PASCAL.V_LIB]V_FILELIB.PAS;1 ================ */

void get_dir(char dirname[]);
/* Get the default directory and returns it in "dirname" */

void show_dir();
/* Displays the default directory on terminal */

int change_dir(char newdir[]);
/* Sets Default Device and Directory to "newdir" */
/* Returns TRUE if successfull, FALSE on error   */
/* To get actual path, call with newdir = ''     */

void set_dir();
/* Asks for a new default directory and sets it */

void parse_file(char name[]);
/* Convert an incomplete filespecification to a full filespecification */

name_rec *read_wildcard_list(char name[]);
/* Create a list of files matching to the (maybe wildcard) specification "name" */
/* "Start" is the pointer to the record with the first file                     */
/* If no files are found, "start" will be set to "NIL"                          */

void delete_file_list(name_rec **start);
/* delete the list of files created by "read_file_list" */

void dir(char name[], int  long, int dir_only);
/* List all Files matching to (maybe wildcard) specification "name"              */
/* If long, the full path will be shown, e.g. ALFI$DUA0:[VEF.PASCAL]V_INP.OBJ;6, */
/* one per Line                                                                  */
/* If not long, only the filename will be shown, e.g. V_INP.OBJ;6, four per line */
/* If dir_only is true, only the subdirectories will be displayed                */

void add_default_ext(char filename[], char default_name[]);
/* Insert the Extension from Default-Name into Filename if Filename */
/* does not contain an extension                                    */

char *last_filename();
/* Returns a pointer to the last non-empty filename read by get_filename */

void get_filename(char filnam[], char frage[], char wildcard[]);
/* ask for filename, by entering a "?", you get the directory   */
/* The filename is returned in "filename"                       */
/* "frage" passes a question to be displayed, "wildcard" passes */
/* the mask for the files to be displayed by "?", e.g. "*.PAR"  */

name_rec *read_file_list(char frage[], char default_extension[]);
/* Create the list of file names, and return the pointer */
/* to the first element                                  */

FILE *lesefile_oeffnen(char frage[], char wildcard[]);
/* Open textfile for reading                                    */
/* If successfull, ok is true, else ok is false                 */
/* "frage" passes a question to be displayed, "wildcard" passes */
/* the mask for the files to be displayed by "?", e.g. "*.PAR"  */

FILE *schreibfile_oeffnen(char frage[], char wildcard[]);
/* open textfile for writing                                    */
/* If successfull, ok is true, else ok is false                 */
/* "frage" passes a question to be displayed, "wildcard" passes */
/* the mask for the files to be displayed by "?", e.g. "*.PAR", */
/* and the Default-Extension.                                   */
/* Check if file already exists (only if it's not the terminal) */

int entscheidung(char frage[], char def);
/* Question with two possible answers: yes or no         */
/* The question is passed in "frage", the default answer */
/* "y" or "n" in "d". The Function returns "true" if the */
/* answer is "Yes".                                      */

int entscheidung_a(char frage[], int def, int anz);
/* Question with two (yes/no) or three (yes/no/exit) possible answers    */
/* the question is passed in "frage", the default in "def" and the       */
/* number of possible answers in "anz". The result returned is           */
/* Res = 1 : "Yes",     Res = 2 : "No",     Res = 3 : "Exit"             */
/* The name comes from ATARI-GEM, where this Procedure used an Alert-Box */

int trans(char instr[], float out[]);
/* This procedure looks how many numerical values are in "inx" */
/* It returns the number of values and the values in "out"     */

int strans(char instr[], float out[]);
/* "trans" for single precision */

int translate_logical(char logical[], char table[]);
/* get environment variable, logical name on VMS */

float real_lesen();
/* Read a real value, try until a correct value is read */

long integer_lesen();
/* Read an integer value, try until a correct value is read */

float real_default(float def);
/* Read a real value, if no correct value is entered, the default */
/* value is taken                                                 */

long integer_default(long def);
/* Read an integer value, if no correct value is entered, the default */
/* value is taken                                                     */

char *string_default(char def[]);
/* Read a string, if an empty string is entered, the default is taken */
/* To enter an empty string, enter a blank                            */

char *readl(char *s, int max, FILE *inf);
/* Read a line from file using fgets(), eliminate CR and/or LF */

/* ============= WRK:[VEF.PASCAL.V_LIB]V_MESSAGELIB.PAS;1 ================ */

char *io_message(int res);
/* Returns the Message according to the I/O-error "res" */

void message(char mess[]);
/* print message and wait for keypress */

int selection_menu(char *title, char *shorts,
                   char **items, int n_items, int def);
/* Displays a selector box and returns the selection.  */


/* ============= WRK:[VEF.PASCAL.V_LIB]V_SONSTIGLIB.PAS;1 ================ */

int command_status();
/* Return the Status of the last Subprocess spawned by Command     */
/* This may be the Termination status of the process or the status */
/* returned by lib$spawn if the process could not be created       */

void command(char comline[], int wait);
/* This procedure spawns a DCL-subprocess.                 */
/* If no commandline is passed, the subprocess will prompt */
/* for a command. In this case you have to terminate the   */
/* subprocess by "logout".                                 */
/* System handling of Control-Characters is enabled before */
/* starting the process, after it finished, the old        */
/* handling is restored                                    */
/* Does not work in Batch Mode because of Byte Limit       */

void evaluate_commandline(int argc, char **argv,
                          int *anzq, int *anzp,
                          char **qual, char **para);
/* Evaluate the arguments of main and return the */
/* Parameters and Qualifiers.                    */


/* ============= WRK:[VEF.PASCAL.V_LIB]V_STRINGLIB.PAS;1 ================ */

int strerase(char str[], int index, int count);
/* The Procedure erase deletes count characters of Stringvar, */
/* starting at position index                                 */

#define upcase toupper
/* Converts a character to its uppercase equivalent */

void upstring (char text[]);
/* Converts a string to uppercase letters */

int insert(char source[], char target[], int index);
/* procedure insert inserts source at position index into target */


/* ============= WRK:[VEF.PASCAL.V_LIB]V_SYSLIB.PAS;1 ================ */

int read_key();
/* Waits for a keypress and returns the SMG-Keycode */

int smg_key_pressed();
/* Returns TRUE if a key is pressed */

int proc_mode();
/* returns the process mode, e.g. Interactive, Batch */

long proc_owner();
/* returns the pid of the owner process, or zero if ter is no */

long proc_pid();
/* returns the pid of the actual process */

char *proc_name();
/* returns the name of the actual process, without trailing blanks */

char *proc_username();
/* returns the username of the actual process, without trailing blanks */

char *proc_terminal();
/* returns the terminal of the actual process, without trailing blanks */

int vws_workstation();
/* Returns TRUE if you are running in a vt200 window on a VWS-Workstation */
/* This is recognized by terminal name WTAn                               */

void WriteString(char s[]);
/* writes a string by QIO and waits until the string is written */

int KeyPress();
/* Test if a key is pressed; returns FALSE if not implemented */

void ReadChar(char ch);
/* Reads on character from Terminal,                            */
/* if no character is present, it waits until a key is pressed  */

char consilent();
/* Reads one character from terminal without echoing it */

#define cstat keypress
/* The same as keypress, only for compatibility with ProPascal on Atari */

char consingle();
/* Reads one character from terminal and echoes it */

void taste_warten(int warten);
/* Wait until a key is pressed, if the boolean-paraneter is true */

void puffer_leeren();
/* empties the keyboard-buffer by reading all characters present */

void clreol();
/* Deletes the screen from the cursor-position to the end of the line */

void delline();
/* deletes the line in which the cursor is placed */

void clreol();

int page_length();
/* Returns the actual page-length of the terminal */
/* On error, -1 is returned                       */

int terminal_width();
/* Returns the actual width of the terminal */
/* On error, -1 is returned                 */

long proc_cputime();
/* Returns the used CPU-Time in 1/100 seconds, */
/* or -1 if an error occurs                    */

void show_memory();
/* Display some Information about the current process: */
/* workingset, CPU-Time, Virtual Memory, etc.          */

void text_invers();
void text_normal();

void lib_wait(float t);

#endif
