#include <stdio.h>
#include <stdlib.h>
#include <unistd.h> /* defines STDIN_FILENO */
#include <string.h>
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <termios.h>
#include <X11/Xutil.h>   /*includes Xlib.h*/
#include <unctrl.h>
#include <ctype.h>

static struct termios stored_settings;
#define askq askq_
#define term term_
#define winid winid_
#define store store_
#define whichwindow whichwindow_
#define whichprogram whichprogram_
#define opensto opensto_
#define rmsea rmsea_
#define cpsea cpsea_
#define rmsto rmsto_
#define rmfile rmfile_
#define writear writear_
#define readar readar_
#define readef readef_
#define help help_
#define window window_
#define openterm openterm_
#define killwin killwin_
#define key key_
#define askquit askquit_

#define maxn 1024
#define STRL maxn*8
#define STR  768       /* appl_mod.f90:  marray_sp=maxn*768 */
#define BUFL STRL*STR 

extern struct winid{
   char retwindowfocus[64];
} winid;

extern struct askq{
   char quit;
} askq;

extern struct term{
      int id1,npl,ncol[8],nrows[8],xpixel[8],ypixel[8];
   char winfile[16],quit;
} term;

extern struct store{
      char  string_fr[STRL][STR];
} store;

void readar(int *set){
   int dfile;
   long int iset;
   dfile = open("storage.am",O_RDONLY);
   iset=*set-1;
/*printf("read_file iset= %d\n",iset);*/
   lseek(dfile, BUFL*iset,0);
/*printf("read_file set= %d ,BUFL*iset=%d\n",*set,BUFL*iset);*/   
   read(dfile,store.string_fr[0],BUFL);
   close(dfile);
}
void writear(int *set){
   int dfile;
   long int iset;
   dfile = open("storage.am",O_WRONLY);
   iset=*set-1;
/*printf("write_file set= %d ,BUFL*iset=%d\n",*set,BUFL*iset);*/   
   lseek(dfile,BUFL*iset,0);
   write(dfile,store.string_fr[0],BUFL);
   close(dfile);
}
void rmsto(){
   char str[16];
   strcpy(str,"rm storage.am");
   system(str);
}
void rmfile(char *str){
   char string[32];
   strcpy(string,"rm ");
   strcat(string,str);
   system(string);
}
void rmsea(){
   char str[16];
   strcpy(str,"rm _search.sea");
   system(str);
   strcpy(str,"rm search.sea");
   system(str);
}


static int pr_winsize(int fd, int it)
{
 struct winsize size;
 int i;

 if (isatty(fd) != 0){ i=1;
  if (ioctl(fd, TIOCGWINSZ, (char *) &size) < 0) i=0; 
/* printf("pr_winsize i=%d npl=%d \n",i, size.ws_col);*/
 }
 if(i==1){
  term.ncol[it]=size.ws_col;
  term.nrows[it]=size.ws_row;
  term.xpixel[it]=size.ws_xpixel;  
  term.ypixel[it]=size.ws_ypixel;
  if(size.ws_col==0){
   term.ncol[it]=80;
  term.npl=80;
  term.nrows[it]=24;  } 
 }else{
  term.ncol[it]=80;
  term.npl=80;
  term.nrows[it]=24;  }
 return(i); 
}

void window(int *i)
{char *tm;
 int it,ifile,j;
 it=*i-1;

 if(*i==1){
   pr_winsize(STDIN_FILENO,it);
   term.npl=term.ncol[it];
   if(term.npl>130)term.npl=130;
 }else{
   tm=term.winfile;     
   for (j=0; j<16; j++){if(tm[j]==' '){term.winfile[j] = 0;}
   else{term.winfile[j] = tm[j];}}
   //printf(" tm=%s\n",tm);
   ifile = open(term.winfile,O_WRONLY,0); 
   pr_winsize(ifile,it);
   close(ifile);
   //printf(" ifile=%d ncol(%d)=%d\n",ifile,it,term.ncol[it]);
 }
 return ; 
}  
 

void openterm(char term[]){
   FILE *dfile;
   char str[64],tm[16];
   char c;
   int i,j;
   Window win;
   Display *disp;
   int ret;
   disp = XOpenDisplay(NULL);
   XGetInputFocus(disp,&win,&ret);

   term[63]='\0';
   dfile = fopen("terminfo","r");
   if(dfile!=0)system("rm terminfo");
   i=63;
   do {c = term[i];i=i-1;} while (c != '-'); 
   i=i+4;j=0;              
   do {c = term[i];tm[j]=c; i++; j++;} while (c != '&');                
   tm[j-2]='\0';               
   dfile = fopen(tm, "wr");
   //printf(" wr  tm=%s\n",tm);
   strcpy(str, "tty > terminfo");
   fprintf(dfile, "%s\n",str);
   strcpy(str, "sleep 1d");
   fprintf(dfile, "%s\n",str);
   fclose(dfile);
   strcpy(str, "chmod +x ");
   strcat(str,tm);
   system(str);
   //printf("term=%s\n",term);
   system(term);

   do{
     sleep(1); 
   dfile = fopen("terminfo","r");
   }while(dfile==0);
   fclose(dfile);

   strcpy(str,"rm ");
   strcat(str,tm);
   system(str);

   dfile = fopen("terminfo","r");
   do {c = fscanf(dfile, "%s", tm); 
   } while (c != EOF);                
   fclose(dfile);

   str[0]=0;
   strcat(str,"ps t"); /* system dependent*/
   strcat(str,&tm[5]);
   strcat(str," >> terminfo");
   //printf(" str=%s\n",str);
   system(str);
   sync;
   XSetInputFocus(disp,win,0,CurrentTime);
   XGetInputFocus(disp,&win,&ret);
   //printf("Focus bei Window %x    %x\n" ,win,ret);
   //printf("RevertTo %x%x%x\n" ,RevertToParent,RevertToPointerRoot,RevertToNone);
  }

 void whichwindow() { 
 Window win;
 Display *disp;
 int ret;
 disp = XOpenDisplay(NULL);
        XGetInputFocus(disp,&win,&ret);
        //printf(" Window focus %lx\n" ,win);
	sprintf(winid.retwindowfocus,"%lx\n" ,win);
 }

int whichprogram(char pg[]) {
     FILE *dfile;
      char str[64], tm[32];
      char c;
      int i;
      i=-1;
      //    printf( "%d  %s\n",i, pg);
      str[0]=0;
   strcat(str,"which "); strcat(str,pg);  strcat(str, " > fpgram");
   printf( "%d  %s\n",i, str);
   system(str);
   dfile = fopen("fpgram","r");
   if(dfile!=0){
     do {c = fscanf(dfile, "%s", tm); i++;
        } while (c != EOF);                
        fclose(dfile);
        system("rm fpgram");
   }
   //printf( "%d  %s",i, tm);
   return i;
}

void killwin(char chkill[]){
   FILE *dfile;
   char str[24];

   dfile = fopen("killterm", "w");   
   chkill[7]='\0';
   strcpy(str, "kill -15 ");
   strcat(str,chkill);
   fprintf(dfile, "%s\n",str);
   /*   chkill[15]='\0';
   strcpy(str, "kill -9 ");
   strcat(str,&chkill[8]);
   fprintf(dfile, "%s\n",str);*/
   fclose(dfile);
   system("chmod +x killterm");
   system("./killterm");
  }

void set_keypress(void)
{
    struct termios new_settings;
    tcgetattr(0,&stored_settings);
    new_settings = stored_settings;
    /* Disable canonical mode, and set buffer size to 1 byte */
    new_settings.c_lflag &= (~ICANON);
    new_settings.c_cc[VTIME] = 0;
    new_settings.c_cc[VMIN] = 1;
    new_settings.c_cc[VINTR]='#';
    /*new_settings.c_lflag &= (~ECHO);*/
    tcsetattr(0,TCSANOW,&new_settings);
    return;
}

void reset_keypress(void)
{
    tcsetattr(0,TCSANOW,&stored_settings);
    return;
}


int key(){
   unsigned int c,is;
   char ch; 
   set_keypress();
   c=getchar(); ch=*unctrl(c);
   if(c==10) ch='@';
   if(ch=='@'){is=0;c=ch;}else{is=iscntrl(c);}
   if(is>0){
   c=getchar(); 
   c=getchar(); c=-c;}   
   reset_keypress();
   return c;
}

void askquit(char nametty[])
{  char buf[10];
  int j, fd;
  //printf("nametty= %s\n",nametty);

  fd = open(nametty,O_RDWR); /*, O_RDWR ); /*| O_NOCTTY);*/
// Initialize file descriptor sets
fd_set read_fds, write_fds, except_fds;
FD_ZERO(&read_fds);
FD_ZERO(&write_fds);
FD_ZERO(&except_fds);
FD_SET(fd, &read_fds);

// Set timeout to 1.0 seconds= 1000000 usec
struct timeval timeout;
timeout.tv_sec = 0.0;
timeout.tv_usec = 100000; 
//printf("- ");
// Wait for input to become ready or until the time out; the first parameter is
// 1 more than the largest file descriptor in any of the sets
/*printf("tty=%i ",fd);  printf("  nametty=%s\n",nametty);*/  
 
if (select(fd + 1, &read_fds, &write_fds, &except_fds, &timeout) == 1)
{
// fd is ready for reading
  j=read(fd, &buf, 10); 
  /*printf("j=%i",j);  printf("  yy=%c\n",buf[0]);*/ 
  askq.quit=buf[0];  
}
   close(fd);
return;
}




