
MODULE glbconst
implicit none
integer, parameter :: maxfr1=10,maxfr2=48,                               &
                      maxn=1024,maxpf=48,maxs=32,maxss=32,               & 
                      maxsub=8,mplot=6,maxco=64,maxthsl=16,maxthlv=16,   &
                      maxvaco=96,maxcom=48,maxnth=32,maxcvsp=32,         &
                      maxtrf =512,maxthfrcase=16
integer, parameter :: maxprd=maxs*8,maxthss=maxss*7,infplot=maxsub+mplot,&
                      maxpl=maxs*maxvaco,maxc_sp=maxpl,maxp_sp=maxpl,    &
                      maxc=maxpl,maxp=maxpl/4,max8=8*maxn,               &
                      maxdimco=maxthss/2    

integer, parameter :: MDBPLFT=maxn*388, marray_sp=maxn*768,              &
                      maxscr=3*maxc+2*maxp,maxsto=4*maxco**2,            &
                      icstrf=maxvaco*2, ivstrf=maxvaco*2,                &
                      icfr1trf=maxvaco, ivfr1trf=maxvaco,                &
                      icfr2trf=maxvaco, ivfr2trf=maxvaco,                &
                      icsstrf=maxvaco,  ivsstrf=maxvaco,                 &
                      max_ctrf=maxs*(icstrf+maxfr1*icfr1trf+             &
                              maxfr2*icfr2trf+maxthss/12*icsstrf)/8,     &
                      max_vtrf=maxs*(ivstrf+maxfr1*ivfr1trf+             &
                              maxfr2*ivfr2trf+maxthss/12*ivsstrf)/8,     &
                      ii_scrd=maxscr+2*maxpl+2*maxp+maxc+4*maxco+1+      &
                              3*maxdimco+maxvaco,                        &
                      ir_scrd=2*maxvaco+maxsto+maxdimco,                 &
                      ic_scrd=3*maxco*33+4*maxco+maxsto+10*maxvaco+      &
                              9*maxdimco+8*33*maxs+20*maxvaco+128,       &
                      is_scrd=ii_scrd+ir_scrd+ic_scrd,                   &
!                     maxscrd=(int(is_scrd/16)+1)*16,                    &
                      maxscrd=maxn*74+16,                                &
                      jc_scrd=maxscrd-is_scrd
! maxscrd: 8*nTH(<=4*maxn) complexe Zahlen: 32*2*maxn tranfer complex to real 
!                    in subroutine fourier4r(NN)  

! MDBPLFT*2 size of common/plot/, also used in fit.f90 as scratch
!                        external structure in xmosplo.c
! marray_sp  size of complex array_sp storing the complete information of 
!                        each spectrum
!                                 see cc_appl/v_plotstr.h
! maxn  = maximum number of experimental values
! maxpf =     "     "    of free fit parameters
!  maxs =     "     "    of spectra, sets
!  axss =     "     "    of sub-spectra

! maxvaco   =  "     "    of elements (constants or parameter) taken over
!                         from frtheory or theory each call
!  maxsub   =  "     "    of subspectra for the plot block
!  maxthsp  =  "     "    of frame theories to be linked to the program
!  maxthss  =  "     "    of theories to be linked to the program

real, public :: proplow,concent   

logical, public :: b_noask,b_vers,b_re
integer, public :: nwr,nrd,ncl,iseed,iwritear,ipostxtu,n_binom
character(len=132), public :: infotext(8),sessfile
character(len=4),   public :: enwr(16)
character(len=64),  public :: pathvariable

character(len=1),   public :: quit
    common/askq/quit

END MODULE glbconst

MODULE comthe
use glbconst, only: maxn,max8,marray_sp,max_vtrf,maxthfrcase

!     ## effi defined quantities ##
!     ifrcase,ifrsubcase determines the branch of theory
!     ifrsto is used to communicate the storage requirement defined in 
!     frtheoryxx to communicate to effi
!     iarray_sp,nstorFR are an address and storage used by effi
!     the complex array: array_fr stores results of theories handled
!     by the user according a list of pointers
!     (array_fr is also handled by effi to provide the aktuell set)

integer,parameter, public :: mGa=maxn/2,mLG=6*maxn
character(len=72), public :: theoryname,thfrcase(maxthfrcase),type_version
integer,           public :: iarray_sp,nstorFR,ifrcase,lstr1case,ifrsto
complex, public  :: array_fr
      common/store/array_fr(marray_sp)      

real, public     :: real_fr(2*marray_sp)
      equivalence (array_fr(1),real_fr(1))

!     ## user defined quantities ##
!     mLG and mGa determine the array size of Lorentz curves (convolution 
!     with a Gaussian distribution) needed in frame and theories       
real,    dimension(max_vtrf),public :: vartrf,ovartrf
integer, public     :: ib_df,kana,ibmisfit,nproc 
real,    public     :: ddpk,thetaz,phiz,thsum 
real,    dimension(max8), public:: thfk,dfdp
common/fr2fi/thfk,dfdp

END MODULE comthe

MODULE comths
use glbconst, only: maxpf,maxs,maxp,maxvaco,maxco, maxthss
implicit none
integer, public:: nstorSP,iterations,limit,idf_min,iterbrake,iBR_DBR,    &
                  ibx_calc,i_confine
integer, public:: kf(maxp),ntest(0:maxs),nfit(0:maxs),                   &
                  idfdpk(maxpf,maxs),i_opgtup(maxpf)
real,    public:: covar(maxpf,maxpf),dp(maxpf),hopmp(maxpf),hupmp(maxpf),&
                  chitest(0:maxs),tolimit,fixf,boundary,ftol
END MODULE comths

MODULE comstr
use glbconst,only : maxfr1,maxfr2,maxthss,maxthsl,maxthlv,maxnth,maxs,maxvaco,maxco
implicit none

integer,parameter, public:: istruct=4*(maxfr1+maxfr2)+3*maxthss+6+32+8,&
                            mvc2=maxvaco/2,mco4=maxco/4
integer,           public:: itheory(maxthsl,2),kssthe(0:maxthlv),lp_handbook,&
                            m_device,device_n,mdevf,nu_device(12),nfrtheo,jtheory
character(len=80), public:: namepg(maxnth),nameth_as,                   &
                            strcmt(0:maxthss),thco(mvc2),thpa(mvc2),    &
                            thvr(mvc2),ntrmt(mco4),ctrmt(mco4)
character(len=64), public:: ndevice(3),ndev(3) 
character(len=132),public:: ntheory(maxnth),nameth(0:maxnth),nstruct
integer, dimension(0:27),public:: i_theoset
integer, dimension(0:27,4),public:: itheoset
END MODULE comstr


MODULE comdat
use glbconst, only: maxs,maxcvsp
implicit none
integer, parameter:: maxbaddata=64

integer, public :: mfpt,mdfpt,mxpt,mdxpt,mypt,mdypt,mgrpt,mvpt,mgpt, &
                   mdgpt,msdpt,mlpt,                                &
                   nchannelsp,nuofdatas,nuofdata,ichan,i3dgroup,ibadchan, &
                   ichanks,i3dgroupks,nunitdata,nchandata

   common/datai/mfpt,mdfpt,mxpt,mdxpt,mypt,mdypt,mgrpt,mvpt,mgpt,mdgpt,&
                nchannelsp,nuofdatas,nuofdata(maxs),ichan(0:256,maxs), &
                i3dgroup(0:256,maxs),ibadchan(0:maxbaddata,maxs),      &
                ichanks(0:256),i3dgroupks(0:256),nunitdata,nchandata(maxs)

character(len=132),public :: name_data,name_theory,checic
character(len=4),  public :: cdumdatac
character(len=80), public :: file_data
character(len=24), public :: data_str,cdata_str
character(len=16), public :: formdata
      common/datac/name_data,name_theory,checic,file_data,             &
                   data_str,cdata_str,formdata(8),cdumdatac(13)

logical, public :: b_data,b_theory,b_datset,b_theoset,b_3dgroup,       &
                   b_procstore,b_dumdatab
      common/datab/b_data,b_theory,b_datset(maxs),b_theoset(maxs),     &
                   b_3dgroup(128,maxs),b_procstore,b_dumdatab(29)

character(len=24), public :: n_cdatas(maxcvsp),n_vdatas(maxcvsp)
character(len=64), public :: readform	
real,              public :: cdatas(maxcvsp),vdatas(maxcvsp)
integer,           public :: ks_set
REAL, DIMENSION(:), ALLOCATABLE :: realfr

END MODULE comdat
 
MODULE complt
use glbconst, only: maxss,maxsub,maxthss
implicit none
character(len=64),  public:: display_mode(16)
character(len=132), public:: chpunchstr(4)
integer, public  :: n_subset,n_sub(0:2,0:maxss),n_int(maxsub,0:maxthss),  &
                    ndisplay_mode,icolor_sub(maxsub)        
END MODULE complt

MODULE comfrm
use glbconst, only: maxc,maxp,maxpl,maxs,maxco,maxthss,maxprd,    &
                    maxc_sp,maxp_sp,maxsto
implicit none
integer, public :: mp,mprd,mprds,mprdn,kp,minsets,                    &
             mco,mcon,kco,kcof,mr,mc,mrs,mcs,mrcet,mrce,mrces,kcp,    &
             mpl,mpart,mplthsp,mplthss,mpaddsp,mpaddss,		      &
             mvaddsp,mvaddss,					      &
             mcl,mconcor,					      &
             mcthsp,mcthss,mcaddsp,mcaddss,mkaddsp,mkaddss,	      &
             mplths,mpadds,mcths,mkadds,mtrp,mtpl,kpl,		      &
             ivadd,ipladd,ivaddsp,icadd,icladd,icaddsp,idumfrm
! 1+maxco*2+maxprd+maxp+1+maxs+2+6*maxco+1+2*maxco+maxp+2+
! 3*(1+maxs)+3*maxs*(1+maxthss)+1+maxc+3*(1+maxs)+7*maxs*(1+maxthss)+
! maxp+4*maxpl+2*maxc+maxs*(1+maxp_sp)+maxs*(1+maxc_sp)+18
      common/frmi/mp,mprd(maxco),mprds(maxco),mprdn(maxprd),          &
                 kp(maxp),minsets(0:maxs),			      &
                 mco,mcon,kco(maxco),kcof(maxco),		      &
                 mr(maxco),mc(maxco),mrs(maxco),mcs(maxco),	      &
                 mrcet,mrce(maxco),mrces(maxco),kcp(maxp),	      &
                 mpl,mpart,					      &
                 mplthsp(0:maxs),mplthss(maxs,0:maxthss),	      &
                 mpaddsp(0:maxs),mpaddss(maxs,0:maxthss),	      &
                 mvaddsp(0:maxs),mvaddss(maxs,0:maxthss),	      &
                 mcl,mconcor(maxc),				      &
                 mcthsp(0:maxs), mcthss(maxs,0:maxthss),	      &
                 mcaddsp(0:maxs),mcaddss(maxs,0:maxthss),	      &
                 mkaddsp(0:maxs),mkaddss(maxs,0:maxthss),	      &
                 mplths(maxs,0:maxthss),mpadds(maxs,0:maxthss),	      &
                 mcths(maxs,0:maxthss), mkadds(maxs,0:maxthss),	      &
                 mtrp(maxp),mtpl(maxpl),kpl(maxpl),		      &
                 ivadd(maxpl),ipladd(maxpl),ivaddsp(maxs,0:maxp_sp),  &
                 icadd(maxc), icladd(maxc), icaddsp(maxs,0:maxc_sp),  &
                 idumfrm(18)
real, public ::  p,up,op,ddp,pold,pmin,plast,pst,pabsmin,cpstor,pl,con
!                 nfrmr=9*maxp+6+maxsto+maxpl+maxc                
      common/frmr/p(0:maxp),up(maxp),op(maxp),ddp(maxp),              &
                  pold(0:maxp),pmin(0:maxp),plast(0:maxp),pst(0:maxp),&
                  pabsmin(0:maxp),cpstor(maxsto),pl(maxpl),con(maxc)

character(len=32), public :: nthpl
character(len=60), public :: np
character(len=40), public :: ncon
character(len=16), public :: ncor
character(len=4),  public :: fpstor
character(len=24), public :: nstructfr
! 8*maxpl+15*maxp+10*maxc+4*maxco+maxsto+6*6*maxs
      common/frmc/nthpl(maxpl),np(maxp),ncon(maxc),ncor(maxco),       &
                  fpstor(maxsto),nstructfr(maxs,6)

!     mp           = actual number of fit parameters
!     mpf          = number of free fit parameters (varied at the same time)
!     mprd(maxco)  = number of product parameters belonging to the
!                    correlation matrix
!     mprds(maxco) = (analog to mcs() in cor )
!    mprdn(maxpdr) = contains groups of i,j,k such that p(i)=p(j)*p(k)
!     kp(maxp)     = indicator; kp(i)=0 if p(i) is fixed
!                               kp(i)=i if p(i) is free
!     np(maxp)     = names of fit parameters (a16)
!     p(maxp)      = values of the fit parameters
!     up(maxp)     = lower (untere) limit of parameter value
!     op(maxp)     = upper (obere)    "         "        "
!     ddp(maxp)    = stepwidths of the fit parameters used for numerical
!                    differentiation
!     pst(maxp)    = array for the last read values of p
!     pold(maxp)   = array for p of the last but one iteration
!     pmin(maxp)   = array for p with the smallest chi-square value


!            mco    = largest number of a correlation matrices
!            mcon   = number of correlation matrices dim>0
!        kco(maxco) = correlation matrix (dim>0) number
!       kcof(maxco) = correlation matrix (dim>0) number where at least
!                     one parameter is not fixed
!         mr(maxco) = number of rows of the actual correlation matrix
!         mc(maxco) =   "       columns             "
!        mrs(maxco) = sum of rows of the actual correlation matrix
!                     including matrix k-1
!        c maxsto=     "     "    of elements of the storage vector for the
!                                                 correlation matrices
!        mcs(maxco) = sum of columns             "
!
!             mrcet = total number of elements of all correlation matrices
!       mrce(maxco) = number of elements of a correlation matrix
!      mrces(maxco) = sum of number of elements including matrix k-1
!                     mrces(1)=0; mrces(j)=mrces(j-1)+mrce(j-1)
!                                mrcet=mrcs(mco)+mrc(mco)
!       ncor(maxco) = names (a16) of correlation matrix
!         kcp(maxp) = kcp(i) is the parameter number naturally given by the
!                         increasing number of subspectra attached to the
!                         fit-parameter i.
!                         (maxp maximum number of fit-parameters)
!    cpstor(maxsto) = storage vector for correlation matrices
!
!
!          maxthss = maximal number of theories to be linked
!           maxthsp = maximal number of frame theories to be linked =maxs*4
!             maxpl = maximum number of theory parameters
!
!               mpl = actual number of theory parameters
!   mplthsp(0:maxs)= number of variables of frame theory i
! mplthss(maxs,0:maxthss)= number of variables of theory i of a subspectrum
! mplths(maxs,0:maxthss) = sum of variables including ssp k-1 of spectrum j
!                 mplths(1,0)=0
!                 mplths(j,0)=mplths(j-1,msspsp(j-1))+mplthss(j-1,msspsp(j-1))
!                 mplths(j,k)=mplths(j,k-1)+mplthss(j,k-1)
!
! ktheo(ks,0:maxthss,0:4) = theory number of (sub,sub)theory
! ktheo(ks,0,0) = 2 array ktheo(maxs,0,i=0,1,2) members
! ktheo(ks,0,1) =j framestructur0j is called
! ktheo(ks,0,2) =k case k in framestructur0j is called
!                m odd
! ktheo(ks,kss,m) =j in step m theory0j is called
!                m+1 even
! ktheo(ks,kss,m) =k in step m case k of theory0j is called
!  ntheossp(0:maxthss) = text (a80) specifying  theory n for a  subspectrum
!    ntheosp(0:maxthsp) = text (a80) specifying the frame theory for
!                         organization a spectrum
! istrss(maxs,0:maxthss) = mss numbers defining "subspectra" containing
!                             global variables
!     nstructfr(maxthsp,3)*24 = name of the frame theory (singular,plural)
!
!        kpl(maxpl) = kpl(i) is the theory parameter number naturally
!                     given by increasing number of subspectra
!                     attached to theory-parameter i.
!      nthpl(maxpl) = names (a16) of theory parameters attached to pl
!         pl(maxpl) = parameter values of the theories
!     pllast(maxpl) = values before last change
!        bpl(maxpl) = logical bpl = pl.ne.pllast
!
!
!             maxc = maximum number of constants
!              mcl = actual number of constants
!   mcthsp(0:maxs) = number of global constants defined in frame theory i
! mcthss(0:maxs,0:maxthss)= number of constants defined in theory k
!   mcths(maxs,0:maxthss) = sum of constants including ssp k-1 of spectrum j
!                 mcths(1,0)=0
!                 mcths(j,0)=mcths(j-1,msspsp(j-1))+mcthss(msspsp(j-1))
!                 mcths(j,k)=mcths(j,k-1)+mcthss(k-1)
!
!       con(maxc)  = values of the constants 
!       ncon(maxc) = names (a16) of the constants 
!

END MODULE comfrm




