     subroutine replace_helpfile(helpfile) 
     implicit none

!    the user may collect help information in files of his choice      
     character(len=132):: helpfile 
     integer   j         
     j=LEN_TRIM(helpfile)
     if(helpfile(:j).eq.'Mossbauer_radioactive_source.help'.or.        &
        helpfile(:j).eq.'2x2_density_matrix_of_the_source.help'.or.    &
        helpfile(:j).eq.'Mossbauer_geometry.help'.or.                  &
        helpfile(:j).eq.'texture.help'.or.                             &
        helpfile(:j).eq.'Single_polarized_Line.help')then
      helpfile='Mossbauer_spectrum.help' 
      return 
     end if 
                                                                       
     if(helpfile(:j).eq.'scalar_ref.index(stat)-Hi,DEQ.help'.or.       &
        helpfile(:j).eq.'scalar_ref.index(stat)-l1_l2_l6.help'.or.     &
        helpfile(:j).eq.'22ref.index(stat)-H_DEQ.help'.or.             &
        helpfile(:j).eq.'22ref.index(stat)-H_DEQ_f.help'.or.           &
        helpfile(:j).eq.'2x2_index_f_spinham.help' ) then              
      helpfile='theory_nucleus.help' 
      return 
     end if 
                                                                       
     if(helpfile(:j).eq.'scalar_refraction_index_(sad).help'.or.       &
        helpfile(:j).eq.'scalar_refraction_index_MB.help'.or.          &
        helpfile(:j).eq.'2x2_refraction_index_(sad).help'.or.          &
        helpfile(:j).eq.'2x2_refraction_index_MB.help'.or.             &
        helpfile(:j).eq.'2x2_refraction_index_f_(sad).help'.or.        &
        helpfile(:j).eq.'2x2_refraction_index_reflection.help'.or.     &
        helpfile(:j).eq.'2x2_refraction_index_transmission.help')then  
      helpfile='refraction_index.help' 
      return 
     end if 
     if(helpfile(:j).eq.'offspecular_correlation_function.help'.or.    &
        helpfile(:j).eq.'offspecular_correlation_matrix.help'.or.      &
        helpfile(:j).eq.'offspecular_scanmodes.help'.or.               &
        helpfile(:j).eq.'X-ray_offspecular_reflection.help'.or.        &
        helpfile(:j).eq.'offspecular_omegascan.help') then             
      helpfile='Synchrotron_offspecular.help' 
      return 
     end if 
                                                                       
     if(helpfile(:j).eq.'scalar_ref.index(dyn)-halfint.help'.or.       &
        helpfile(:j).eq.'scalar_refraction_index_(dynamic).help'.or.  &
        helpfile(:j).eq.'scalar_ref.index(dyn)-twostate.help'.or.     &
        helpfile(:j).eq.'22ref-index(RELAX)_H-DEQ-f.help')     then    
      helpfile='Mossbauer_relaxation.help' 
      return 
     end if 

   
     if(helpfile(:j).eq.'spin_Hamiltonian_one_field.help'.or.          &
        helpfile(:j).eq.'spin_Hamiltonian_two_fields.help') then       
      helpfile='spin_Hamiltonian.help' 
      return 
     end if 
                                                                       
     return 
     END                                           
                                                                        
     subroutine gethdb(ihdb,nhandbook) 
     implicit none
     integer  ihdb
     character(len=32):: nhandbook 
                                                                       
     if(ihdb.eq.0) then 
      if(nhandbook.eq.'nucleus.hdb') then 
        ihdb=1 
      else if(nhandbook.eq.'material.hdb') then 
        ihdb=2         ! not yet used
      end if 
     else 
      if(ihdb.eq.1) then 
        nhandbook='nucleus.hdb' 
      else if(ihdb.eq.2) then 
       nhandbook='material.hdb'  ! not yet used
      end if 
     end if 
     return 
     END                                           
                                                                       
                                                                       
                                                                       
     subroutine getfrstring(nfrtheo,l_nfrtheo,lstruct1,lstruct2,       &
                                                   cmch,nhelpentry) 
     implicit none
     integer   nfrtheo,l_nfrtheo,lstruct1,lstruct2  
     character(len=132):: nhelpentry
     character(len=4)  :: cmch
     character(len=6)  :: chentry 

     nhelpentry(1:6)=chentry(nfrtheo,l_nfrtheo)
     select case(nfrtheo) 
      case(4)
       call frstr_stroboscopy(l_nfrtheo,lstruct1,lstruct2,cmch,nhelpentry) 
      case(2)
       call frstr_synchrotron(l_nfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
      case(1)
       call frstr_mossbauer(l_nfrtheo,lstruct1,lstruct2,cmch,nhelpentry)        
      case(6)
       call frstr_neutron(l_nfrtheo,lstruct1,lstruct2,cmch,nhelpentry)        
      case(3)
       call frstr_syndoubleSC(l_nfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
      case(5)
       call frstr_texture(l_nfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
      end select
     if(nfrtheo.gt.6) l_nfrtheo=0 
     nfrtheo=6           ! loop nfrtheo will end at nfrtheo instead   

     nhelpentry=ADJUSTL(nhelpentry)
     return               ! at maxs=16  
     END                                           
                                                                       
     subroutine distribthfr(iframe,cmch,iss,info) 
     implicit none
     integer   iframe,iss,info 
     character(len=4):: cmch 
     select case(iframe)                           
       case(4)   
         call fr_stroboscopy(cmch,iss,info) 
       case(2)   
         call fr_synchrotron(cmch,iss,info) 
       case(1)   
         call fr_mossbauer(cmch,iss,info) 
       case(3)   
         call fr_syndoubleSC(cmch,iss,info) 
       case(5)   
          call fr_neutron(cmch,iss,info) 
       case(6)   
          call fr_texture(cmch,iss,info)
       end select
     iframe=6 
     return 
     END                                           
                                                                       
                                                                       
     subroutine getthstring(jth,l_jth,cmch,nhelpentry) 
     implicit none
     integer  jth,l_jth
     character(len=132):: nhelpentry
     character(len=4)  :: cmch 
     character(len=6)  :: chentry       ! function

     nhelpentry(1:6)=chentry(jth,l_jth)
     select case(jth)
      case(1) 
       call thstr_11indexmoss(l_jth,cmch,nhelpentry) 
      case(2) 
       call thstr_11indexmossdyn(l_jth,cmch,nhelpentry) 
      case(3)
       call thstr_relaxhalfintegral(l_jth,cmch,nhelpentry) 
      case(4)
       call thstr_lines126(l_jth,cmch,nhelpentry) 
      case(5) 
       call thstr_hdeqmiscil(l_jth,cmch,nhelpentry) 
      case(6)  
       call thstr_22indexmoss(l_jth,cmch,nhelpentry) 
      case(7)  
       call thstr_22indexfmoss(l_jth,cmch,nhelpentry) 
      case(8)  
       call thstr_22indexrefl(l_jth,cmch,nhelpentry) 
      case(9)  
       call thstr_hdeq(l_jth,cmch,nhelpentry) 
      case(10)  
       call thstr_hdeqf(l_jth,cmch,nhelpentry) 
      case(11)  
       call thstr_mossbauer(l_jth,cmch,nhelpentry) 
      case(12)  
       call thstr_sampleorient(l_jth,cmch,nhelpentry) 
      case(13)  
       call thstr_synstrob(l_jth,cmch,nhelpentry) 
      case(14)  
       call thstr_synstrobtrans(l_jth,cmch,nhelpentry) 
      case(15)  
       call thstr_strobwindow(l_jth,cmch,nhelpentry) 
      case(16)  
       call thstr_synstrobrefl(l_jth,cmch,nhelpentry) 
      case(17)  
       call thstr_synsource(l_jth,cmch,nhelpentry) 
      case(18)  
       call thstr_syntransmission(l_jth,cmch,nhelpentry) 
      case(19)  
       call thstr_synreflection(l_jth,cmch,nhelpentry) 
      case(20)  
       call thstr_neutron(l_jth,cmch,nhelpentry) 
      case(21)  
       call thstr_neutronspec(l_jth,cmch,nhelpentry) 
      case(22)  
       call thstr_neutronoffspec(l_jth,cmch,nhelpentry) 
      case(23)  
       call thstr_22indextrm(l_jth,cmch,nhelpentry) 
      case(24)  
       call thstr_synoffspec(l_jth,cmch,nhelpentry) 
      case(25)  
       call thstr_offspeccorrelation(l_jth,cmch,nhelpentry) 
      case(26)  
       call thstr_offspeccorrelfunc(l_jth,cmch,nhelpentry) 
      case(27)  
       call thstr_22indexreflnosampl(l_jth,cmch,nhelpentry) 
      case(28)  
       call thstr_scanmode(l_jth,cmch,nhelpentry) 
      case(29)  
       call thstr_relaxtwostate(l_jth,cmch,nhelpentry) 
      case(30) 
       call thstr_aperture(l_jth,cmch,nhelpentry) 
      case(31)  
       call thstr_hyperfineft(l_jth,cmch,nhelpentry) 
      case(32)  
       call thstr_hyperfield(l_jth,cmch,nhelpentry) 
      case(33)  
       call thstr_sH05slowrelax(l_jth,cmch,nhelpentry) 
      case(34)  
       call thstr_11indexMB(l_jth,cmch,nhelpentry) 
      case(35)  
       call thstr_22indexMB(l_jth,cmch,nhelpentry) 
      case(36)  
       call thstr_xrayreflection(l_jth,cmch,nhelpentry) 
      case(37)  
       call thstr_syndoubleSC(l_jth,cmch,nhelpentry) 
      case(38)  
       call thstr_synFGscattering(l_jth,cmch,nhelpentry) 
      case(39)  
       call thstr_synGFscattering(l_jth,cmch,nhelpentry) 
      case(40)  
       call thstr_22indextrm2(l_jth,cmch,nhelpentry) 
      case(41)  
       call thstr_11index(l_jth,cmch,nhelpentry) 
      case(42)  
       call thstr_synFFscattering(l_jth,cmch,nhelpentry) 
      case(43)  
       call thstr_22source(l_jth,cmch,nhelpentry) 
      case(44)  
       call thstr_hdeqfRELAX(l_jth,cmch,nhelpentry)
      case(45) 
       call thstr_rhoSingleLine(l_jth,cmch,nhelpentry)
      case(46) 
         call thstr_22indexSPL(l_jth,cmch,nhelpentry)
      case(47) 
         call thstr_detector(l_jth,cmch,nhelpentry)
      case(48) 
         call thstr_texture(l_jth,cmch,nhelpentry)
      case(49) 
         call thstr_direction(l_jth,cmch,nhelpentry)
      case(50) 
         call thstr_geoshape(l_jth,cmch,nhelpentry)
      end select
     jth=50 ! neccessary 
     nhelpentry=ADJUSTL(nhelpentry)
     return 
     END                                           
                                                                       
     subroutine distribth(isubthe_n,ntheo,icase,iput,iget,nath,info) 
     implicit none
     integer isubthe_n,ntheo,icase,iput,iget,info 
     character(len=80):: nath 

     select case(ntheo)
      case(1)  
      call th_22index(isubthe_n,icase,iput,iget,info) 
      nath='th_22index' 
     case(2)  
      call th_hdeq(isubthe_n,icase,iput,iget,info) 
      nath='th_hdeq' 
     case(3)  
      call th_timewindows(isubthe_n,icase,iput,iget,info) 
      nath='th_timewindows' 
     case(4)  
      call th_sampleorient(isubthe_n,icase,iput,iget,info) 
      nath='th_sampleorient' 
     case(5)  
      call th_lines126(isubthe_n,icase,iput,iget,info) 
      nath='th_lines126' 
     case(6)  
      call th_22indexsad(isubthe_n,icase,iput,iget,info) 
      nath='th_22indexsad' 
     case(7)  
      call th_11indexsad(isubthe_n,icase,iput,iget,info) 
      nath='th_11indexsad' 
     case(8)  
      call th_hdeqmiscellaneous(isubthe_n,icase,iput,iget,info) 
      nath='th_hdeqmiscellaneous' 
     case(9)   
      call th_relaxglobalsad(isubthe_n,icase,iput,iget,info) 
      nath='th_relaxglobalsad' 
     case(10)  
      call th_relaxspinhalfsad(isubthe_n,icase,iput,iget,info) 
      nath='th_relaxspinhalfsad' 
     case(11)  
      call th_hdeqf(isubthe_n,icase,iput,iget,info) 
      nath='th_hdeqf' 
     case(12)  
      call th_11index(isubthe_n,icase,iput,iget,info) 
      nath='th_11index' 
     case(13)  
      call th_offspeccorrelfunc(isubthe_n,icase,iput,iget,info) 
      nath='th_offspeccorrelfunc' 
     case(14)  
      call th_offspeccorrelation(isubthe_n,icase,iput,iget,info) 
      nath='th_offspeccorrelation' 
     case(15)  
      call th_scanmode(isubthe_n,icase,iput,iget,info) 
      nath='th_scanmode' 
     case(16)  
      call th_relaxtwostatesad(isubthe_n,icase,iput,iget,info) 
      nath='th_relaxtwostatesad' 
     case(17)  
      call th_hyperfineft(isubthe_n,icase,iput,iget,info) 
      nath='th_hyperfineft' 
     case(18)  
      call th_spinham05(isubthe_n,icase,iput,iget,info) 
      nath='th_spinham05' 
     case(19)  
      call th_sH05slowrelax(isubthe_n,icase,iput,iget,info) 
      nath='th_sH05slowrelax' 
     case(20)  
      call th_22indexsource(isubthe_n,icase,iput,iget,info) 
      nath='th_22indexsource' 
     case(21)  
      call th_hdeqfRELAX(isubthe_n,icase,iput,iget,info) 
      nath='th_hdeqfRELAX'
     case(22)  
      call th_22indexRELAXsad(isubthe_n,icase,iput,iget,info) 
      nath='th_22indexRELAXsad'
     case(23)  
      call th_rhoSingleLine(isubthe_n,icase,iput,iget,info)
      nath='th_rhoSingleLine'
     case(24)  
       call th_poincare(isubthe_n,icase,iput,iget,info)
       nath='th_poincare'       
     case(25)  
       call th_debye(isubthe_n,icase,iput,iget,info)
       nath='th_debye'       
      case(26)  
      call th_sphere(isubthe_n,icase,iput,iget,info) 
      nath='th_sphere'
      case default 
      isubthe_n=-isubthe_n 
     end select 
     ntheo=26   !necessary
     return 
     END                                           
