!     the file hpg_mossbauer.f containes the following subroutines:        
!     subroutine moss_plot(cmch)                                       
!     subroutine drive(mode_drive,nonlinear,nchansp, &
!                is also used by fr_strobmoss.f                        
!     subroutine geometry(ichansp,cosa,a_R,jt)                         
!     subroutine moss_selsubspect(text)                                
!     subroutine moss_selsubtract(text,isub)                           
!     subroutine moss_subspect(cmch,mi,isub,info)                      
!     subroutine moss_subtract(cmch,mi,isub,info)                      
!     subroutine mosstrans_mcarlo(nu_channel)                          

     subroutine moss_plot(cmch) 
     use glbconst, only: maxn,max8,maxsub,infplot,MDBPLFT,    &
                         icstrf,ivstrf
     use comdat, only: file_data,name_data,formdata,b_data,b_theory,   &
                       name_theory,ichanks,mxpt,mfpt,mdfpt,mvpt,mgpt
     use complt, only: display_mode,ndisplay_mode,n_subset,icolor_sub
     use comthe, only: real_fr,thfk
     implicit none  
     character(len=4),intent(in)::  cmch 
                                                                       
     integer      n_subspectra,logx,logy,logf,         &
                  int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor  
     real         xyzdz,vtxt,vtxtp,parray                              

     character(len=132):: plotstrdef,plotstrpu,title
     character(len=24) :: axesname,abscissa,bgcolor,fgcolor,   &  
                          datacolor,thcolor,rescolor,auxcolor1,         & 
                          auxcolor2,auxcolor3
     character(len=80) :: datfile,ordinata
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,ch4d, ch4de
     real              :: datx,errx,sym,subspectrum,varray,yarray,yyarray, &
                          v1array,v3array,vrarray,vdarray,resarray
     integer           :: irarray,i0array,i1array,i2array                  
     logical           :: b_datf
     integer,parameter :: max8subn=maxsub*max8,max4=4*maxn,max16=maxn*16,&
                          maxn0=4*maxn+2,maxnh=4*maxn/2,max112=maxn*112, &
                 idumpl=4*maxn-8*39-5*infplot-maxsub-201,           & 
                 jdumpl=8*maxn0+4*maxnh+max4,                       &
                 kdumpl=3*max4+max4*maxsub,                         &
                 ldumpl=MDBPLFT*2-180*maxn-jdumpl-kdumpl
     common/plot/parray(max112),xyzdz(8),vtxt(2,max16),vtxtp(8,32), &
                 int3d(maxn*16),npnt3d(16),ifeder(max16),ltext(32),   &
                 npntplot(infplot),nchanplot(infplot),ncolor(maxsub),  &
                 n_subspectra,logx,logy,logf,                          &
                 namechan(infplot),kform(infplot),axisformat(3),       &
                 axesname(3),title,plotstrdef,plotstrpu,               &
                 bgcolor,fgcolor,datacolor,thcolor,rescolor,           &
                 auxcolor1,auxcolor2,auxcolor3,datfile,ch4d(idumpl),   &
!  180*maxn =176*maxn+idumpl+8*39+5*infplot+maxsub+201
                 varray(maxn0),yarray(maxn0),yyarray(maxn0),           &
                 v1array(maxn0),v3array(maxn0),vrarray(maxn0),         &
                 vdarray(maxn0),resarray(maxn0),irarray(maxnh),        &
                 i0array(maxnh),i1array(maxnh),i2array(maxnh),         &
                 b_datf(max4),datx(max4),errx(max4),sym(max4),         &
                 subspectrum(max4,maxsub),ch4de(ldumpl) 

!    common/plot/parray(maxn*180+jdumpl),datx(max4),errx(max4),sym(max4),
!                subspectrum(max4,maxsub),ch4de(ldumpl)
                                                                       
     real,dimension(max8):: plotx,ploty,ploterry,plotres,plotxx,plotyy
     real,dimension(max4):: plotdvcorr
     real,dimension(max8subn):: plotsub
     equivalence (parray(1),plotx(1)),(parray(max8+1),ploty(1)),       &
                 (parray(max8*2+1),ploterry(1)),                       &
                 (parray(max8*3+1),plotres(1)),                        &
                 (parray(max8*4+1),plotxx(1)),                         &
                 (parray(max8*5+1),plotyy(1)),                         &
                 (parray(max8*6+1),plotsub(1)),                        &
                 (parray(max8*13+max4+1),plotdvcorr(1))
                        
     real          dum1,channels,dum2,drive_mode,channels_vmax,dumcs
     common/acstrf/dum1(5),channels,dum2(3),drive_mode,channels_vmax,  &
                   dumcs(icstrf-11)

     real          avsp,f_factor,base,bg_fraction,v_max,channel_v0,dumvs
     common/avstrf/avsp,f_factor,base,bg_fraction,v_max,channel_v0,    &
                   dumvs(ivstrf-6)

                   
     logical         b_logx,b_logy,b_vdarray,b_velocityscale
     character(len=1) :: chx,chbx,chlr,chy,chby,chbt,ch0 
     character(len=80):: CTEXT,CXTEXT,CYTEXT
     character(len=24):: frcolor
     character(len=9) :: chsub
     integer         nformx,nformy,i,ii,il,ir,irh,is1,is2,i0,il0,     &
                     il1,il2,ivd,l,k,nbegin,nchansp,nend,nh,nresidue, &
                     j,ns,nsinglev,ny,nyy,iofs
     real            chh,chw,syw,syh,aa,base2,basepl,bb,ff,det,glow,  &
                     fold_point,sqrt2,v1,v1mv3,v3,vil,vil1,vil2,vir,  &
                     vr,xmax,xmin,y1,y2,y3,ymin,ymax,hd,hmin,hmax,    &
                     resmin,resmax,ressum 
     real, dimension(:), allocatable :: velocity,geof 


      ch0=char(0) 
      i0=ichar('0') 
      if(cmch.eq.'dstr') then 
!      the string formdata also defines the sequence of storage of 
!      the y-, dy- (error of y), and x-data on the array real_fr().
!      y,dy is always stored (if dy is not on the data file dy=sqrt(y)) 
       formdata(1)='y' 
       formdata(2)='y,x'
       formdata(3)='y,dy' 
       formdata(4)='y,dy,x' 
       formdata(5)=' '               ! defines end
       return 
      end if 
      if(cmch.eq.'dmod') then 
       display_mode(1)='channel scale, counts' 
       display_mode(2)='channel scale, counts, residual spectrum' 
       display_mode(3)='velocity scale' 
       display_mode(4)='velocity scale, residual spectrum' 
       display_mode(5)='velocity scale, counts' 
       display_mode(6)='velocity scale, counts, residual spectrum' 
       display_mode(7)='channel scale & correction function ' 
       display_mode(8)=' ' 
       namechan(1)='x' 
       namechan(2)='y' 
       namechan(3)='dy' 
       namechan(4)='res' 
       namechan(5)='xt' 
       namechan(6)='yt' 
       namechan(7)='su' 
       namechan(8)=' '               ! defines end
       plotstrdef='(x,y,dy)' 
       if(b_theory)then 
        plotstrdef='(x,y,dy) (xt,yt)' 
        j=21 
        if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4                     &
                             .or.ndisplay_mode.eq.6)then              
         plotstrdef='(x,y,dy) (xt,yt) (x,res)' 
         j=30 
        end if 
        if(n_subset.gt.0)then 
         do i=1,n_subset 
          chsub=' (xt,su'//char(i+i0)//')' 
          k=j+(i-1)*9 
          plotstrdef(k:)=chsub 
         end do 
        end if 
       end if 
       return 
      end if 
                                                                        
      if(ndisplay_mode.eq.3.or.ndisplay_mode.eq.4) then 
       kform(1)='f6.2' 
       kform(2)='f10.6' 
       kform(3)='f10.6' 
       kform(4)='f10.6' 
       kform(5)='f6.2' 
       kform(6)='f10.6' 
       kform(7)='f10.6' 
       nformy=2 
      else if(ndisplay_mode.le.2.or.ndisplay_mode.ge.5) then 
       kform(1)='f8.3,2x' 
       kform(2)='f12.2,2x' 
       kform(3)='f8.1,2x' 
       kform(4)='f12.1,2x' 
       kform(5)='f8.3,2x' 
       kform(6)='f12.0,2x' 
       kform(7)='f12.0,2x' 
       nformy=0 
      end if 
      kform(8)=' ' 
                                                                        
   select case(ndisplay_mode)     
     case(1)
!      display_mode(3)='channel scale'                                 
       abscissa='channel' 
       ordinata='counts' 
       axisformat(1)='%8.2f ' 
       axisformat(2)='%10.2f ' 
       nformx=0 
     case(2)
!      display_mode(4)='-channel scale, residual spectrum'             
       abscissa='channel' 
       ordinata='counts' 
       axisformat(1)='%6.0f ' 
       axisformat(2)='%8.0f ' 
       nformx=0 
     case(3)
!      display_mode(1)='velocity scale'                                
       abscissa='mm/s    ' 
       ordinata='relative transmission' 
       axisformat(1)='%6.2f ' 
       axisformat(2)='%6.2f ' 
       nformx=1 
     case(4)
!      display_mode(2)='-velocity scale, residual spectrum'            
       abscissa='mm/s    ' 
       ordinata='relative transmission' 
       axisformat(1)='%6.2f ' 
       axisformat(2)='%6.2f ' 
       nformx=1 
     case(5,6)
!      display_mode(5,6)='-velocity scale, counts, residual spectrum'   
       abscissa='mm/s    ' 
       ordinata='counts' 
       axisformat(1)='%8.2f ' 
       axisformat(2)='%10.2f ' 
       nformx=0 
     case(7)
!      display_mode(7)='channel scale & correction function'
       abscissa='channel' 
       ordinata= 'velocity correction dv' 
       axisformat(1)='%6.2f ' 
       axisformat(2)='%6.2f ' 
       nformx=0 
   end select
       b_velocityscale=ndisplay_mode.ge.3.and.ndisplay_mode.le.6
       nresidue=1
       if(ndisplay_mode.eq.1.or.ndisplay_mode.eq.3.or.ndisplay_mode.eq.5) nresidue=0 
       if(.not.b_data) title=name_theory 
       if(base.eq.0.) base=1. 
       n_subspectra=0 
       if(b_theory) n_subspectra=n_subset 
       nchansp=channels 
       fold_point=channel_v0+channels_vmax 

      bgcolor='LightYellow'//ch0 
      fgcolor='black'//ch0 
      datacolor=fgcolor 
      thcolor=fgcolor 
      rescolor='blue'//ch0 
      do j=1,maxsub 
         ncolor(j)=icolor_sub(j)
      end do 
      axesname(1)=abscissa 
      axesname(2)=ordinata 
      axesname(3)=' ' 
      title=name_data
      ii=index(file_data,'.') 
      if(ii.eq.0) then 
       datfile='Ptheory_nodata.ps'//char(0) 
      else 
       datfile='P'//file_data(1:ii)//'ps'//char(0) 
      end if 
!     write(6,'(2a)')'datfile=',datfile(1:60)                          

!      write(6,'(a,i4)') ' *****moss_plot*********'                     
!       write(6,'(2(a,l5),a,i5)') ' b_data=',b_data, &                   
!  '  b_theory=',b_theory,' n_subspectra=',n_subspectra           
!       write(6,'(4(a,f10.3))') ' base=',base,'  geo=',geo,             
!     &         '  fold=',fold_point,'  fresonant=',fresonant           
!     if(b_theory) then                                                 
!      write(6,'(4e15.6)') (thfk(i),i=1,nchansp,64)                     
!     else                                                              
!      write(6,'(20L4)') (b_datf(j),j=1,nchansp,16)                     
!     end if                                                            
               
      do j=1,nchansp 
       b_datf(j)=.false. 
      end do 
      do k=2,ichanks(0),2 
       do j=ichanks(k-1),ichanks(k) 
        b_datf(j)=.true. 
       end do 
      end do 
                                                                        
      if (.not.allocated(velocity))allocate(velocity(nchansp),geof(nchansp))
      vr=0.
      if(b_theory) then
       do i=1,nchansp
        velocity(i)=real_fr(mvpt+i)
        geof(i)=real_fr(mgpt+i)
        plotdvcorr(i)=real_fr(mxpt+i)        
        vr=vr+ plotdvcorr(i)
       end do
       vr=vr/nchansp
       do i=1,nchansp
          plotdvcorr(i)= plotdvcorr(i)-vr
          real_fr(mxpt+i)= plotdvcorr(i) 
       end do       
      else
       do i=1,nchansp
        velocity(i)=real_fr(mvpt+i)
        geof(i)=1.
       end do
      end if
      ny=0 
      nyy=0 
      nchanplot=0     ! array
!      write(6,'(8f10.3)') ( velocity(j),j=1,nchansp,16) 
      basepl=base 
      if(ndisplay_mode.eq.5.or.ndisplay_mode.eq.6) basepl=1 
                                                                        
     if(b_data) then 
        nbegin=0 
        i=0 
        do while(nbegin.eq.0.and.i.lt.nchansp) 
         i=i+1 
         if(b_datf(i)) nbegin=i 
        end do 
        nend=0 
        i=nchansp+1 
        do while(nend.eq.0.and.i.gt.1) 
         i=i-1 
         if(b_datf(i)) nend=i 
        end do 
        do i=1,nchansp 
         varray(i)=velocity(i) 
        end do 
        varray(nchansp+1)=varray(1) 
        varray(nchansp+2)=varray(2) 

        iofs=1
        if(drive_mode.eq.2) iofs=10

        nsinglev=1                              ! double/full  spectrum 
        if(nend*0.9.lt.fold_point) nsinglev=-1  ! single/half  spectrum 

        basepl=base 
        if(ndisplay_mode.eq.5.or.ndisplay_mode.eq.6)then 
         basepl=1 
         if(nsinglev.eq.1)basepl=0.5 
        end if 
                                                                        
!        write(6,'(a,2i6)') ' ndisplay_mode=',ndisplay_mode,nchansp     
!        write(6,'(3(a,i7))')' mfpt=',mfpt,' mdfpt=',mdfpt,' sigle_v=',nsinglev

        b_vdarray=.false. 
       if(b_velocityscale) then 

         if(nsinglev.lt.0) then 
          do ii=nbegin,nend 
           if(b_datf(ii)) then 
            ny=ny+1 
            plotx(ny)=velocity(ii) 
            ploty(ny)=real_fr(mfpt+ii)/basepl 
            ploterry(ny)=real_fr(mdfpt+ii)/basepl 
           end if 
          end do 
                                                                        
          if(b_theory) then 
           do ii=nbegin,nend 
            nyy=nyy+1 
            plotxx(nyy)=velocity(ii) 
            plotyy(nyy)=thfk(ii)/basepl 
           end do
                                                           
           if(ndisplay_mode.eq.4.or.ndisplay_mode.eq.6) then 
            ressum=0.0
            ns=0 
            do ii=nbegin,nend 
             if(b_datf(ii)) then 
              ns=ns+1 
              plotres(ns)=ploty(ii)-plotyy(ii)
              ressum=ressum+plotres(ns)
             end if 
            end do 
            ressum=ressum/float(ns)
           end if 

           if(n_subspectra.gt.0) then 
            do j=1,n_subspectra 
             ns=(j-1)*max8 
             nchanplot(6+j)=nend-nbegin+1 
             do ii=1,nchansp 
              ns=ns+1 
              plotsub(ns)=subspectrum(ii,j)/basepl 
             end do 
            end do 
           end if 
          end if  ! b_theory  
          goto 200 
         end if  !  nsinglev < 0  
                                                                        
         sqrt2=sqrt(2.) 
         base2=2*basepl 
                                                                        
         l=3*int(log10(abs(v_max/nchansp*4.))*2.) 
         glow=10**l 
!        write(6,'(a,2i6,l4)') ' lower limit =',nchansp,l,b_theory                           
         if(b_theory) then 
          do i=1,nchansp 
           yyarray(i)=thfk(i)/geof(i) 
          end do
          yyarray(nchansp+1)=thfk(1)/geof(1) 
          yyarray(nchansp+2)=thfk(2)/geof(2) 
         end if 
                                                                        
         do i=1,nchansp 
          resarray(i)=real_fr(mfpt+i)-thfk(i) 
          yarray(i)=real_fr(mfpt+i)/geof(i) 
         end do 
         yarray(nchansp+1)=real_fr(mfpt+1)/geof(1) 
         yarray(nchansp+2)=real_fr(mfpt+2)/geof(2) 
         nh=nchansp/2. 
         irh=int(fold_point)+1 
         il=irh 
         do ii=irh,irh+nh-1 
          ir=ii 
          if(ir.gt.nchansp) ir=ir-nchansp 
          il=il+1 
          il1=il+1 
          vir=varray(ir) 
          vil=varray(il) 
          vil1=varray(il1) 
          ivd=1 
          do while(ivd.gt.0) 
           il2=il1 
           il1=il 
           vil2=vil1 
           vil1=vil 
           ivd=1 
           if(vil2-vir.le.0)  ivd=-1 
           if(vil2-vir.eq.0) goto 18 
           if(vil1-vir.lt.0) then 
            ivd=-ivd 
           else if(vil1-vir.eq.0) then 
            ivd=-1 
           end if 
  18       il=il-1 
           if(il.lt.1) il=il+nchansp 
           vil=varray(il) 
          end do 

          v1=vil-vil1 
          v3=vil2-vil1 
          vr=vir-vil1 
          if(b_theory) then 
           nyy=nyy+1 
           irarray(nyy)=ir 
           i0array(nyy)=il 
           i1array(nyy)=il1 
           i2array(nyy)=il2 
           v1array(nyy)=v1 
           v3array(nyy)=v3 
           vrarray(nyy)=vr 
           vdarray(nyy)=0. 
                                                                        
           v1mv3=v1-v3 
           det=v1*v3*v1mv3 
           if(abs(det).gt.glow) then 
            vdarray(nyy)=det 
            b_vdarray=.true. 
            y1=yyarray(il) 
            y2=yyarray(il1) 
            y3=yyarray(il2) 
            y1=y1-y2 
            y3=y3-y2 
            y1=y1*v3  
            y3=y3*v1 
            aa=y1-y3 
            bb=-y1*v3+y3*v1 
            ff=vr*(vr*aa+bb)/det+y2 
           else 
            ff=yyarray(il1) 
            b_vdarray=.false. 
           end if 
           plotxx(nyy)=vir 
           plotyy(nyy)=(yyarray(ir)+ff)/base2 
          else 
           b_vdarray=.false. 
          end if  ! b_theory   
                                                                        
          if(b_datf(ir)) then 
           y1=yarray(il) 
           y2=yarray(il1) 
           y3=yarray(il2) 
           if(y1.ne.0..and.y2.ne.0..and.y3.ne.0.) then 
            ny=ny+1 
            if(b_vdarray) then 
             ff=(y1+y2+y3)/3.
            else 
             ff=y2 
            end if 
            plotx(ny)=vir 
            ploty(ny)=(yarray(ir)+ff)/base2 
            ploterry(ny)=sqrt2*real_fr(mdfpt+ir)/base2 
            if(ndisplay_mode.eq.4.or.ndisplay_mode.eq.6)                &
                              plotres(ny)=resarray(ir)/base2           
           end if 
          end if 
         end do 
!        ny plot points for the data                                    
!        nyy plot points for the theory                                 
         ns=0                                                               
         if(b_theory.and.n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           do i=1,nchansp 
            yyarray(i)=subspectrum(i,j) 
           end do 
           yyarray(nchansp+1)=yyarray(1) 
           yyarray(nchansp+2)=yyarray(2) 
                                                                        
           ns=(j-1)*max8 
           nchanplot(6+j)=nh 
           do ii=1,nh 
            v1=v1array(ii) 
            v3=v3array(ii) 
            vr=vrarray(ii) 
            det=vdarray(ii) 
            ir=irarray(ii) 
            il0=i0array(ii) 
            il1=i1array(ii) 
            il2=i2array(ii) 
            if(det.ne.0.) then 
             y1=yyarray(il0) 
             y2=yyarray(il1) 
             y3=yyarray(il2) 
             y1=y1-y2 
             y3=y3-y2 
             y1=y1*v3 
             y3=y3*v1 
             aa=y1-y3 
             bb=-y1*v3+y3*v1 
             ff=vr*(vr*aa+bb)/det+y2 
            else 
             ff=yyarray(il1) 
            end if 
            ns=ns+1 
            plotsub(ns)=(subspectrum(ir,j)+ff)/base2 
           end do 
          end do 
         end if 
       else      ! ndisplay_mode: b_velocityscale=true 
         if(ndisplay_mode.eq.7)then
          do i=nbegin,nend 
           if(b_datf(i)) then 
            ny=ny+1 
            plotx(ny)=i 
            ploty(ny)=real_fr(mfpt+i)/basepl 
            ploterry(ny)=real_fr(mdfpt+i)/basepl 
           end if 
          end do 
          if(b_theory) then 
!           do i=nbegin,nend                                             
           do i=1,nchansp 
            nyy=nyy+1 
            plotxx(nyy)=i 
            plotyy(nyy)=thfk(i)/basepl 
            plotdvcorr(nyy)=real_fr(mxpt+i)        
           end do 
           ressum=0.0
           ns=0 
           do ii=nbegin,nend 
            if(b_datf(ii)) then 
             ns=ns+1 
             plotres(ns)=(real_fr(mfpt+ii)-thfk(ii))/basepl 
             ressum=ressum+plotres(ns)
            end if 
           end do 
           ressum=ressum/float(ns)
           if(n_subspectra.gt.0) then 
            do j=1,n_subspectra 
             ns=(j-1)*max8 
             nchanplot(6+j)=nend-nbegin+1 
             do ii=1,nchansp 
              ns=ns+1 
              plotsub(ns)=subspectrum(ii,j)/basepl  
             end do 
            end do 
           end if 
          end if  ! b_theory 
         else   ! ndisplay_mode.eq.7
          do i=nbegin,nend 
           if(b_datf(i)) then 
            ny=ny+1 
            plotx(ny)=i 
            ploty(ny)=real_fr(mfpt+i) 
            ploterry(ny)=real_fr(mdfpt+i) 
           end if 
          end do 
          if(b_theory) then 
!           do i=nbegin,nend                                             
           do i=1,nchansp 
            nyy=nyy+1 
            plotyy(nyy)=thfk(i) 
            plotxx(nyy)=i 
            plotdvcorr(nyy)=real_fr(mxpt+i)        
           end do 
           if(ndisplay_mode.eq.2) then 
            ressum=0.0
            ns=0 
            do ii=nbegin,nend 
             if(b_datf(ii)) then 
              ns=ns+1 
              plotres(ns)=real_fr(mfpt+ii)-thfk(ii) 
              ressum=ressum+plotres(ns)
             end if 
            end do 
            ressum=ressum/float(ns)
           end if 
           if(n_subspectra.gt.0) then 
            do j=1,n_subspectra 
             ns=(j-1)*max8 
             nchanplot(6+j)=nend-nbegin+1 
             do ii=1,nchansp 
              ns=ns+1 
              plotsub(ns)=subspectrum(ii,j) 
             end do 
            end do 
           end if 
          end if  ! b_theory 
         end if
       end if   ! ndisplay_mode.ge.3  
      else      ! b_data   
        if(b_velocityscale) then
         is1=sign(1.,velocity(3)-velocity(1))
         do ii=1,nchansp-3
         is2=is1*sign(1.,velocity(ii+3)-velocity(ii)) 
          if(is2.lt.0) goto 19 
         end do
 19      continue

         nyy=nchansp/2
         if(ii.gt.nchansp-3) nyy=nchansp
         do i=1,nyy 
          plotxx(i)=velocity(i) 
          plotyy(i)=thfk(i)/basepl/geof(i) 
         end do 
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do i=1,nyy 
            plotsub(ns+i)=subspectrum(i,j)/basepl/geof(i) 
           end do 
          end do 
         end if 
        else 
         nyy=nchansp 
         do i=1,nchansp 
          plotxx(i)=nyy-i+1 
          plotyy(i)=thfk(i) 
         end do 
         ns=0
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do i=1,nyy 
            plotsub(ns+i)=subspectrum(i,j) 
           end do 
          end do 
         end if 
        end if 
     end if  ! b_data  
                                                                        
  200 continue 
      xmin=1.e30 
      xmax=-xmin 
      ymin=xmin 
      ymax=0.      ! counts > 0  
      if(b_data) then 
       do ii=1,3 
        nchanplot(ii)=ny 
       end do 
       if(xmin.gt.plotx(1))xmin=plotx(1) 
       if(xmax.lt.plotx(ny))xmax=plotx(ny) 
       if(xmin.gt.plotx(ny))xmin=plotx(ny) 
       if(xmax.lt.plotx(1))xmax=plotx(1) 
       do i=1,ny 
        if(ymin.gt.ploty(i)-ploterry(i))ymin=ploty(i)-ploterry(i) 
       end do 
       do i=1,ny 
        if(ymax.lt.ploty(i)+ploterry(i))ymax=ploty(i)+ploterry(i) 
       end do 
      end if 
      if(b_theory) then 
       nchanplot(5)=nyy 
       nchanplot(6)=nyy 
       if(xmin.gt.plotxx(1))xmin=plotxx(1) 
       if(xmax.lt.plotxx(nyy))xmax=plotxx(nyy) 
       if(xmin.gt.plotxx(nyy))xmin=plotxx(nyy) 
       if(xmax.lt.plotxx(1))xmax=plotxx(1) 

       do i=1,nyy 
        if(ymin.gt.plotyy(i))ymin=plotyy(i) 
       end do 
       do i=1,nyy 
        if(ymax.lt.plotyy(i))ymax=plotyy(i) 
       end do 
      end if 

      if(ndisplay_mode.eq.7) then
       if(ymax.gt.1.1)plotdvcorr= plotdvcorr*10.0 
       hmax=-1.0e10
       hmin=-hmax
       do i=1,nyy 
        if(hmin.gt.plotdvcorr(i))hmin=plotdvcorr(i) 
       end do 
       do i=1,nyy 
        if(hmax.lt.plotdvcorr(i))hmax=plotdvcorr(i) 
       end do
       if(hmax.gt.0.3)hmax=0.3;  if(hmin.lt.-0.3)hmin=-0.3
       vr=ymin-2*hmax+hmin
       i=vr*10. +1
       ymin=float(i)/10.
       if(ymin.gt.0.7)ymin=0.7
       i=(ymin-hmin)*10 +1
       vr=float(i)/10.
       plotdvcorr(1)=vr

       nchanplot(infplot)=2
       do i=2,nyy 
        plotdvcorr(i)=plotdvcorr(i)+vr
       end do 
      end if

      if(nresidue.eq.1.and.b_theory) then 
        nchanplot(4)=ny 
        resmin=0. 
        resmax=0. 
        do i=1,ny 
         hd= plotres(i)-ploterry(i) 
         if(resmin.gt.hd) resmin=hd 
        end do 
        do i=1,ny 
         hd= plotres(i)+ploterry(i) 
         if(resmax.lt.hd) resmax=hd 
        end do 
         hd= resmax-2.0*resmin 
        do i=1,ny 
         plotres(i)=plotres(i)+ymax-resmin 
        end do 
        ymax=ymax-resmin+resmax 
!        print '(a,f10.1)',' average <exp-theo>=',ressum
      end if 

       xyzdz(1)=xmin 
       xyzdz(2)=xmax 
       xyzdz(3)=ymin 
       xyzdz(4)=ymax 

       b_logx=.false. 
       b_logy=.false. 
       logx=0 
       logy=0 
       if(b_logx)logx=1 
       logf=0 
       if(b_logy)logf=1 
                                                                        
!      definitions taken from allplo 
       chx='b'                 ! (none,Both,bottom,top)  [B]            
       chbx='n'                ! (none,bottom,top)  [n]                 
       chlr='l'                ! (left,right)  [r]                      
       chy='l'                 ! (none,Both,left,right)  [B]            
       chby='l'                ! (none,left,right)  [r]                 
       chbt='b'                ! (bottom,top)  [t]                      
       chh=0.3                 !                                        
       chw=0.25                ! character cw,ch  [0.40,0.40]           
       syw=0.1                 !                                        
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]           
       frcolor=fgcolor         ! color frame       [black]              
       frcolor='blue'//ch0 
       CTEXT=title 
       CXTEXT=TRIM(abscissa)//'    .'
       CYTEXT=ordinata 

       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,            &
                  chh,chw,syw,syh,                                      &
                  CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)      
                                                                        
!      write(6,'(a,4g12.6)')' min-max=',xmin,xmax,ymin,ymax             
!      write(6,'(a,10i5)') ' nchanplot=',(nchanplot(ii),ii=1,8)         
!      write(6,'(2(a,i4))')  ' ny=',ny,'    nyy=',nyy                   
!      write(6,'(a)')  ' j,plotx(j),ploty(j)'                           
!      write(6,'(3(2x,i4,1x,2g12.4))') (j,plotx(j),ploty(j),j=1,ny,16)  
!      write(6,'(a)')  ' j,plotres(j),ploty(j)'                         
!      write(6,'(3(2x,i4,1x,2g10.2))') (j,plotres(j),ploty(j),j=1,ny,16)
!      write(6,'(i6,2f15.5)') (j,plotxx(j),plotyy(j),j=1,nyy,16)
       
      return 
      END                                           


subroutine drive(mode_drive,nonlinear,lambda,nchansp,mvpt,mgpt,mdgpt,mxpt,mlpt,&
                       channels_vmax,channel_v0,v_max,geo,vnl,info)
    use glbconst, only: infotext,enwr
    use comthe, only: real_fr 
    implicit none
    integer, intent(in):: mode_drive,nonlinear,nchansp,mxpt,mvpt,mgpt,mdgpt,mlpt
    real,    intent(in):: lambda,channels_vmax,channel_v0,v_max,geo
    integer, parameter :: nlp=18
    real,    dimension(nlp), intent(in):: vnl 
    real,    dimension(nlp):: cnp       
    integer, intent(out):: info
    real,    dimension(nlp):: vl 
    real           arg,fold_point,hperiod,period,    &
                     s,sx,vh,vmax_chan,x,y,chv0per,         &
                     piqp,geof,dfdgeo,h,c1,c4,c5,          &
                     dv,dv0,v1,ph1,penalty
    real, parameter:: pi=atan(1.)*4., rad=pi/180.
    integer        ii,j,mode_case,selectnl,nl
      
    if(abs(nonlinear).gt.7) then
     info=111
     infotext(1)='<Mossbauer_spectrum>/velocity/nonlinear' 
     infotext(2)=' there are only 0-6 cases for nonlinear ' 
     infotext(3)=' ' 
     return
    end if
    selectnl=abs(nonlinear)
    hperiod=channels_vmax*2.0 
    piqp=pi/hperiod
!     calculation  of velocity ,geo, dgeofdk                             
!     nchen mode = +1   triangular wave mode                            
!     nchen mode = +2   sine wave mode 
!     nonlinear= 0-6  (default value is 0)  
!     0: old version with 6 parameter defined in two ways
!         - amplitude and phase shift in channel
!         - amplitude and phase shift in radian
!     1-6: vnl 
!     amplitude and phase shift
    if(enwr(9).eq.'nlco') then
      open(unit=4,file='nlco.dat'         &
                ,status='unknown'         &
                ,access='sequential'      &
                ,form='formatted')   
     write(4,'(2(a,i2))') 'drive_mode=', mode_drive,' case nonlinear=',nonlinear
     write(4,'(a)') 'channel'
     write(4,'(a)') 'dv[mm/s]'
    end if
    vl=vnl; nl=nlp
    if(selectnl.eq.0)nl=6
!   amplitude or phase input (phase as a channel number k0 close to k_vmax)
    h=0.
    do j=1,nl
     h=h+abs(vl(j))
    end do
    if(h.lt.1.0e-5)selectnl=7    ! no correction

    select case(selectnl) 
    ! frequencies
     case(0,1,3)
      do j=1,nl
         cnp(j)=float(j)*piqp
      end do
     case(2,4)
      do j=1,nl
       cnp(j)=float(2*j-1)*piqp
      end do
     case(5,6)
      do j=1,nl
       cnp(j)=float(j)*piqp/2.0 
      end do
     case(7)
    end select 

    ! dv0 offset    
    dv0=0.
    select case(selectnl)
    case(3,4,6)  ! amplitude mode
      do j=1,nl
       dv0=dv0+vl(j)
      end do
    case(0,1,2,5)            ! amplitude/phase 
     if(h.lt.1.)then        !  a*cos+b*sin   (only amplitud parameters)
      do j=1,nl/2
       call sin2phase(vnl(2*j),vnl(2*j-1),v1,ph1)
       vl(2*j-1)=v1;vl(2*j)=ph1/piqp/float(j)
       dv0=dv0+v1*cos(ph1)
      end do
      if(enwr(9).eq.'pham') then
         print'(4x,i3,f10.5,/,4x,i3,f10.2)',    &
              (2*j-1,vl(2*j-1),2*j,vl(2*j),j=1,nl/2)
         enwr(9)='nnnn'
      end if   
     else                    !  a*cos(phi(k-k0))
      do j=1,nl/2
       dv0=dv0+vl(2*j-1)*cos(vl(2*j)*cnp(j))
      end do
      if(enwr(9).eq.'pham')then
         print'(4x,i3,f10.5,/,4x,i3,f10.5)',   &
        (2*j-1,vl(2*j-1)*cos(cnp(j)*vl(2*j)),   &
         2*j,vl(2*j-1)*sin(cnp(j)*vl(2*j)),j=1,nl/2)    
         enwr(9)='nnnn'
      end if       
     end if
    end select 
    fold_point=channel_v0+channels_vmax
    vmax_chan=v_max/channels_vmax 
    mode_case=abs(mode_drive)
    if(mode_case.gt.3) mode_case=1

    select case(mode_case)
     case(1)
!     triangular wave                                                   
      period=hperiod*2.0 
      chv0per=channel_v0+hperiod 
      do ii=1,nchansp 
       x=float(ii)
       y= x-fold_point
       if(y.gt.0.)goto 30 
!      left side                                                        
       if(y.gt.-hperiod) goto 22 
       x=x+period 
       goto 32 
   22  c1=channel_v0-x
       s=1. 
       goto 40 
!      right side                                                       
   30  if(y.lt.hperiod) goto 32 
       x=x-period 
       goto 22 
   32  c1=chv0per-x
       s=-1.              
   40  c4=s*vmax_chan 
       vh=c4*c1 
       dv=0.; penalty=0.
       select case(selectnl)
        case(0,1,2,5)
         do j=1,nl/2
!            dv=dv-vnl(2*j-1)*cos(cnp(j)*y)-vnl(2*j)*sin(cnp(j)*y)
            dv=dv-vl(2*j-1)*cos(cnp(j)*(y-vl(2*j)))
            penalty=penalty+ vl(2*j-1)*sin(cnp(j)*(y-vl(2*j)))*float(j)
         end do
         dv=dv+dv0   
        case(3,4,6)
         do j=1,nl
          dv=dv-vnl(j)*cos(cnp(j)*y)
          penalty=penalty+ vl(j)*sin(cnp(j)*y)*float(j)
         end do
         dv=dv+dv0
        case(7)
       end select
       if(enwr(9).eq.'nlco')write(4,'(i6,3x,i5,f15.4)')2000,int(y+hperiod),dv

       sx=s*((vh/v_max)**2-1.) 
       c5=1.+geo*sx
       geof=c5**2
       dfdgeo=2.*c5*sx
       real_fr(mvpt+ii) = vh+dv
       real_fr(mgpt+ii) = geof
       real_fr(mdgpt+ii)= dfdgeo
       real_fr(mxpt+ii) =dv
       real_fr(mlpt+ii) =(penalty)**2*lambda
     end do

     case(2)
!     sine wave  
      j=mvpt-3*nchansp                                                       
      do ii=1,nchansp 
       y=float(ii)-fold_point 
       arg=piqp*y                  ! 2*pi/T*t    
       vh=-v_max*cos(arg)
       dv=0.; penalty=0.
       select case(selectnl)
        case(0,1,2,5)
         do j=1,nl/2
!            dv=dv-vnl(2*j-1)*cos(cnp(j)*y)-vnl(2*j)*sin(cnp(j)*y)
            dv=dv-vl(2*j-1)*cos(cnp(j)*(y-vl(2*j)))
            penalty=penalty+ vl(2*j-1)*sin(cnp(j)*(y-vl(2*j)))*float(j)
         end do
         dv=dv+dv0
        case(3,4,6)
         do j=1,nl
          dv=dv-vnl(j)*cos(cnp(j)*y)
          penalty=penalty+ vl(j)*sin(cnp(j)*y)*float(j)
         end do
         dv=dv+dv0       
        case(7)
       end select  
       if(enwr(9).eq.'nlco')write(4,'(i6,3x,i5,f15.4)')2000,int(y+hperiod),dv

       sx=sin(arg)
       c5=1.+geo*sx                ! geo=s_max/F 
       geof=c5**2
       dfdgeo=2.*c5*sx
       real_fr(mvpt+ii) = vh+dv
       real_fr(mgpt+ii) = geof
       real_fr(mdgpt+ii)= dfdgeo
       real_fr(mxpt+ii) = dv
       real_fr(mlpt+ii) =(penalty)**2*lambda
      end do 
    
     case(3)
!     mode_drive=3
      y=abs(real_fr(mvpt+1)-real_fr(mvpt+nchansp))      
      if(abs(y-2.*abs(v_max)).gt.abs(v_max)/nchansp)then
       info=-1 
       infotext(1)='<Mossbauer_spectrum>/velocity/scale' 
       infotext(2)='**warning** x-data do not fit to v_max ' 
       infotext(3)='(abs(abs(v(1)-v(channel)-2.*abs(v_max))>abs(v_max)/nchansp' 
       infotext(4)=' ' 
      end if
      do ii=1,nchansp
       vh=real_fr(mvpt+ii) 
       y=float(ii)-fold_point
       sx=-((vh/v_max)**2-1.)*sign(1.0,y) 
       c5=1.+geo*sx 
       geof=c5**2
       dfdgeo=2.*c5*sx
       real_fr(mgpt+ii) = geof
       real_fr(mdgpt+ii)= dfdgeo
       real_fr(mlpt+ii) =(penalty)**2*lambda
      end do
    
    end select
    if(enwr(9).eq.'nlco')close(unit=4)
       
    return 
  End  subroutine drive
  
  
    subroutine sin2phase(vsn,vcs,v,p) 
    real, intent(in)::vsn,vcs
    real, intent(out):: v,p  
    real(kind=8), parameter:: pi=ATAN(1.d0)*4.d0
    real(kind=8) ::vsin,vcos,vh,ph
    vcos=vcs; vsin=vsn
     if(vcos.eq.0.) then
      ph=pi/2.0
      if(vsin.lt.0)ph=-ph
     else
      ph=ATAN(vsin/vcos); 
     end if
     vh=sqrt(vcos**2+vsin**2)
     if(vcos.lt.0.and.vsin.lt.0)then
      vh=-vh
     else
      if(vcos.lt.0)ph=ph+pi; if(vsin.lt.0)ph=ph+2.d0*pi
     end if 
     v=vh; p=ph
    return
  END subroutine sin2phase

    real function solidangle(AdQ,theta,nn)
      implicit none
      real, intent(in)  :: AdQ,theta
      integer,intent(in):: nn
      real*8,dimension(0:nn):: arr
      real*8 rz,ry,hr,hh,x2,yx,dx,  &
          rQxy2,ryx
      integer k,n

      rz=cos(theta);  ry=sin(theta)      
      dx=sqrt(Adq)/dfloat(nn)

      do k=0,nn
       x2=(dfloat(k)*dx)**2
       yx=sqrt(abs(AdQ-x2))/rz; rQxy2=1.+x2+yx**2; ryx=2.d0*ry*yx
       hh=(yx+ry)/sqrt(rQxy2+ryx)+(yx-ry)/sqrt(rQxy2-ryx)
       arr(k)=hh/(x2+rz**2)
      end do
      hr=0.d0 
      do n=1,nn-1,2 
       hr=hr+ arr(n)*2.d0  
      end do 
      do n=2,nn-2,2 
       hr=hr+arr(n)
      end do 
      hr=hr*2.d0 + arr(0)+arr(nn)
      solidangle=2.*hr/3.d0*dx*rz
     return    
    end function solidangle

   subroutine geometryDIM(enpr,nom_samp,iring,Dabsorber,sc2absorber,Daperture, &
                         sc2aperture,A_aperture,B_aperture,Dtube,alpha,Dsource,&
                                           geo,b_file,igeo,Apt,Spt,Dpt,BdA,ndim)
 
      implicit none 
                                                                       
     integer,             intent(in) :: nom_samp
     real,                intent(in) :: alpha,Dsource,Dabsorber,Daperture, &
                                        sc2absorber,sc2aperture,           &
                                        A_aperture,B_aperture,Dtube,geo
     logical,              intent(in)::b_file
     integer,              intent(in):: iring
     integer,             intent(out):: igeo
     character(len=4) , intent(inout):: enpr
     integer,             intent(out):: ndim
     real,                intent(out):: Apt,Spt,Dpt,BdA
!    extern struct geom{} in mosgeowin.c
     real, dimension(8) :: argeo
     common/geom/argeo

     real HoverF,D_aperture,D_absorber,Pabs_m,Sdet_m,Pabs_p,Sdet_p,bl
   
     real, parameter :: pi=3.141592654, pi2=pi/2.0, rad=pi/180.
                                                                       
!    1-4 (r=3), 1-11 (2*sq3+1), 1-20 (2*sq7+1) 1-33 (2*sq13+1)         
!    integer,dimension(7)::nph0=(/1,6,12,18,24,30,36/)
     integer,dimension(7)::jdim=(/1,7,19,37,61,91,127/)
     integer nomsamp,N_r,N_q,k,iringr
     real    delr
     logical b_abs,b_det           

    iringr=iring
    if(iring.gt.7)then
      print'(a,i2,a)',' iring=',iring,' is reduced to its maximal value of 7' 
      iringr=7
    end if
     
    nomsamp=abs(nom_samp)
!   enpr           : enable print a4-format
!   nomsamp        : number of rings in case of circular symmetry [~10]
!   nom_samp<0     :  1-7 rings and  1-127 (theta,phi) values -single crystal-
!                     used for rotation matrix in  (theta,phi) direction    
!   iring          : number of rings, non circular symmetry [1-7] 
!   Dsource        : diameter of circular source            [0.5]           
!   Dabsorber      : diameter of circular absorber/tube of the cone  [1.6]  
!   sc2absorber    : distance source absorber               [5.0]           
!   sc2aperture    : distance source aperture               [10.0]          
!   Daperture      : diameter of circular aperture          [2.5]           
!   A-aperture     : length A of a rectangular aperture (AxB)
!   B-aperture     : length B of a rectangular aperture (AxB)
!   alpha          : alpha [<90°]    
!   geo            : =vmax/8/f/Ap (triangular mode)         [1^-3]       
!                  : =vmax/2pi/f/Ap (sinusoidal mode)
!   geof(v)        : 1/(1+delta(v))**2
!                  : delta(v)=+-geo*(1-(v/vmax)^2)        sinus
!                  : delta(v)=+-geo*sqrt(1-(v/vmax)^2)    triangle
!   ndim           : ndim=size(cosa) , entry with ndim=-1
!   cosa(ndim)     : cosine of optical path
!   OmR(dim)       : Omega_i belonging to path_i      
!   ndim           : in +-1 ; out ndim

!      igeo=0 : calculation of ndim, the number of members of the sum        
!      point source  
!      igeo=1 circular absorber holder and  detector window/diaphragm
!          =2 circular absorber holder - quadratic detector window/diaphragm
!          =3 rectangular absorber holder - large enough detector window
!          =4 cone section as absorber holder - large enough detector window
!      extended circular source igeo=igeo+4

!   Apt            : distance source diaphragm
!   Spt            : radius of the circular source
!   Dpt            : radius of the diaphragm
!   b_file=.true.  : no rotational symmetry (2 times iring partitioning)

      if(sc2aperture.lt.sc2absorber) then
         print'(2(a,f6.2))', 'source-aperture =',sc2aperture,  &
         ' is expected to be equal or greater source-absorber',sc2absorber    
         enpr='<><>'
         return
      end if
      D_absorber=Dabsorber 
      D_aperture=Daperture
      if(Dtube.gt.0) then
         D_aperture=Dtube
         D_absorber=2.0*Dtube
      end if
      igeo=1
      if(B_aperture.gt.0.0)then
         D_aperture=sqrt(A_aperture**2+B_aperture**2)
         if(abs(A_aperture-B_aperture)/(A_aperture+B_aperture).gt.0.01)then
          igeo=3
         else
          igeo=2
         end if
       else
        if(A_aperture.gt.0.)igeo=2    
       end if
      if(alpha.gt.0.0)igeo=4
      if(Dsource.gt.0.0.and.iring.gt.1)igeo=igeo+4
      if(nom_samp.lt.0) igeo=igeo+20
      if(b_file.and.Dsource.gt.0.0) igeo=igeo+6

      ! geo=S_max/sc2absorber,  Pabs<1
      Pabs_p=(Dsource+D_absorber)/(Dsource+Daperture)*  &
           (sc2aperture/sc2absorber+geo)/(1.0+geo)
      Pabs_m=(Dsource+D_absorber)/(Dsource+Daperture)*  &
           (sc2aperture/sc2absorber-geo)/(1.0-geo)
      ! geo=S_max/sc2aperture,  Sdet<!
      Sdet_p=(D_aperture-Dsource)/(D_absorber-Dsource)*  &
             (sc2absorber/sc2aperture+geo)/(1.0+geo)
      Sdet_m=(D_aperture-Dsource)/(D_absorber-Dsource)*  &
           (sc2absorber/sc2aperture-geo)/(1.0-geo)
      bl=0.95
      b_abs=Pabs_p.lt.bl.and.Pabs_m.lt.bl
      b_det=Sdet_p.lt.bl.and.Sdet_m.lt.bl 
      

      if(enpr.eq.'geom') then
       print'(a,4i4)','   nomsamp,iring,ndim,ndim=',nomsamp,iringr,ndim,ndim
       print'(a,/,6f11.2)',&
       '   D_absorber sc2absorber D_aperture sc2aperture A_aperture B_aperture',&
        D_absorber,sc2absorber,D_aperture,sc2aperture,A_aperture,B_aperture
       print'(a,3f11.2)','       alpha,Dsource=',alpha,Dsource
       print'(a,2(2x,2f6.2))','   Pabs_p,Pabs_m,Sdet_p,Sdet_m=',    &
                                  Pabs_p,Pabs_m,Sdet_p,Sdet_m       
       print'(a,i3,2L,/)','igeo   b_abs,b_det=',igeo,b_abs,b_det
      end if

       HoverF=sc2absorber/sc2aperture;
       argeo(1)=D_aperture/sc2aperture;      argeo(2)=D_absorber/sc2aperture
       argeo(3)=Dsource/sc2aperture ;       argeo(4)=HoverF 
       argeo(5)=0.0; argeo(6)=0.0;  argeo(7)=sc2aperture; argeo(8)=abs(geo) 

       if(.not.b_abs.and..not.b_det)then
        ! Apt undefined
        print '(a)', 'undefined:image of absorber holder </> aperture ?'
        call geompointsc         
        enpr='<><>'
        return
       end if

       if(enpr.eq.'plot') then 
        if( b_abs) then 
         print '(a,/a)', '  image of circular absorber is smaller/equal',&
           '  than the diaphragm/detector'
        else 
         print '(a,/)',&
         'image of circular absorber is larger than the diaphragm/detector'
        end if     
        if(igeo.le.2) call geompointsc
        if(igeo.ge.5) call geomextendsc
        enpr='nnnn'
       end if

       Spt=Dsource/2.0
       if(b_abs) then      
        Apt=sc2absorber  !  absorber is the diaphragm
        Dpt=D_absorber/2.0
       else 
        Apt=sc2aperture   ! aperture/detector  is the diaphragm
        Dpt=D_aperture/2.0
       end if

       N_r=nomsamp+1  

     select case(igeo)
     ! 1-4 point source     
     case(1)         !  rings of the absorber holder/diaphragm  
         ndim=N_r      
     case(2)         !  rings/quarter of rings of the quadratic detector
         N_q=int(Dpt*0.414214/delr)+1
         ndim=N_r+N_q 
      case(3)        !  elements of a rectangular absorber holder
                     !  A_aperture.gt.B_aperture
         Dpt=A_aperture/2.0
         BdA=B_aperture/A_aperture
         N_q= int(BdA*float(N_r))  ! N_B, N_A=N_r
         ndim=N_r*N_q 
     case(4)         !  elements of an elliptical (cone section) absorber holder
         k=7
         if(nomsamp.lt.7)k=nomsamp
         ndim=jdim(k)
     ! 5-8 extended circular source   
      case(5)      ! jp source elements of equal size directed to circular
                     ! aperture(absorber/detector) 
                     ! element at phi (=0) of ring 1..i..N_r
       ndim=N_r*jdim(iringr)  
     case(6,7)     ! N_q extra elements of a rectangular/quadratic aperture
                   ! rectangular absorber holder/quadratic detector  
       Dpt=A_aperture/2.0
       if(igeo.eq.6) then    ! quadratic detector
        BdA=1.0; N_q=N_r
       else   
        BdA=B_aperture/A_aperture
        N_q= int(BdA*float(N_r))
      end if
       ndim=N_r*N_q*jdim(iringr)
     case(8)          ! elements of an elliptical (cone section) absorber holder
     case(11)         ! extended source with non-rotational partitioning
                      ! file source.scan exist, circular aperture
        if(N_r.gt.7)N_r=7
        ndim=jdim(iringr)*jdim(N_r)
     case(12)         ! extended source with non-rotational partitioning
                      ! file source.scan exist, quadratic aperture
        ndim=jdim(iringr)*N_r**2
        Dpt=A_aperture/2.0
     case(21,24)      ! single crystal for case 1,4
       k=7
       if(nomsamp.lt.7)k=nomsamp
       ndim=jdim(k)
!       print*,'  ####### nomsamp,ndim=',nomsamp,ndim
    end select
    return 
   END subroutine geometryDIM        

   !-------------------

   subroutine geometry(igeo,nom_samp,iring,phicone,alpha,Apt,Spt,Dpt,BdA, &
                       soint,doint,ndim,phia,cosa,OmR)
      implicit none 
     integer,              intent(in) :: igeo,nom_samp,iring,ndim
     real,                 intent(in) :: phicone,alpha,Apt,Spt,Dpt,BdA
     real, dimension(127), intent(in) :: soint,doint
     real, dimension(ndim),intent(out):: phia,cosa,OmR
     
  real, parameter :: pi=3.141592654, pi2=pi/2.0, rad=pi/180.
  real, save:: Omega0,delr,delqr,delx,dely
  integer, save:: N_q,nx,ny
  real, dimension(0:7)::rho0=(/-1.0,1.0,sqrt(7.0),sqrt(19.0),sqrt(37.0),&
                        sqrt(61.0),sqrt(91.0),sqrt(127.0)/),rhA,dph
  integer,dimension(7)::nph0=(/1,6,12,18,24,30,36/)
  integer,dimension(7)::jdim=(/1,7,19,37,61,91,127/)
  integer nomsamp,N_r,jt,j,jr,k,l,jphi,iph,js,jd,jphr,iphr,iringr
  real    beta,cosjt,Azjt,phjt,rjt,ta,ca,x,ra,rat,rhot,rhoj,xx,yy, &
          phjr,rhojr,cosdjt,g2jt,rsp,sa,sqg2jt

     iringr=iring
    if(iring.gt.7)then
      print'(a,i2,a)',' iring=',iring,' is reduced to its maximal value of 7' 
      iringr=7
    end if
    
    nomsamp=abs(nom_samp)
!   enpr           : enable print a4-format
!   nomsamp        : number of rings in case of circular symmetry [~10]
!   nom_samp<0     :  1-7 rings and  1-127 (theta,phi) values
!                     used for rotation matrix in  (theta,phi) direction    
!   iring          : number of rings, non circular symmetry [1-7] 
!   Dabsorber      : diameter of circular absorber/tube of the cone  [1.6]  
!   Ab=sc2absorber : distance source absorber               [5.0]           
!   Daperture      : diameter of circular aperture          [2.5]           
!   Ap=sc2aperture : distance source aperture               [10.0]          
!   A-aperture     : length A of a rectangular aperture (AxB)
!   B-aperture     : length B of a rectangular aperture (AxB)
!   alpha          : alpha [<90°]    
!   Dsource        : diameter of circular source            [0.5]           
!   geo            : =vmax/8/f/Ap (triangular mode)         [1^-3]       
!                  : =vmax/2pi/f/Ap (sinusoidal mode)
!   geof(v)        : 1/(1+delta(v))**2
!                  : delta(v)=+-geo*(1-(v/vmax)^2)        sinus
!                  : delta(v)=+-geo*sqrt(1-(v/vmax)^2)    triangle
!   ndim           : ndim=size(cosa) , entry with ndim=-1
!   cosa(ndim)     : cosine of optical path
!   OmR(dim)       : Omega_i belonging to path_i      
!   ndim             : in +-1 ; out ndim

!      igeo=0 : calculation of ndim, the number of members of the sum        
!      point source  
!      igeo=1 circular absorber holder and  detector window/diaphragm
!          =2 circular absorber holder - quadratic detector window/diaphragm
!          =3 rectangular absorber holder - large enough detector window
!          =4 cone section as absorber holder - large enough detector window
!      extended circular source igeo=igeo+4
     phia=0.0
     N_r=abs(nom_samp)+1  
     select case(igeo)
     case(1)         !  rings of the absorber holder/diaphragm 
        delr=Dpt/2.0/float(N_r)
        Omega0=0.0
        do k=1,N_r
          ra=delr*(2*k-1);  rat=ra/Apt
          cosa(k)=1.0/sqrt(1+rat**2)
          OmR(k)=ra*cosa(k)**3            ! 2pi*delr/Apt**2 
          Omega0=Omega0 + OmR(k) 
!          cosa(k)=1.0/sqrt(1+rat**2*geof)
!         OmR(k)=ra*cosa(k)**3/Omega0*geof         
       end do
       do k=1,ndim
          OmR(k)=OmR(k)/Omega0 ! factor 2*2pi/Apt**2 omitted
       end do
     case(2)         !  rings/quarter of rings of the quadratic detector
         delr=Dpt/2.0/float(N_r)
         N_q=int(Dpt*0.414214/delr)+1;  delqr=Dpt*0.414214/float(N_q)
         Omega0=0.0
         do k=1,N_r 
          ra=delr*(2*k-1);  rat=ra/Apt
          cosa(k)=1.0/sqrt(1+rat**2)
          OmR(k)=ra*delr*cosa(k)**3            ! 2pi/Apt**2 
          Omega0=Omega0 + OmR(k) 
         end do
         do k=1,N_q
          jt=N_r+k  
          ra=Dpt+delqr*(2*k-1)
          x=Dpt/ra; x=sqrt(1-x**2)/x; beta=1.0 -2.0*atan(x)/pi2 
          cosa(jt)=1.0/sqrt(1.0+(ra/Apt)**2)
          OmR(jt)=ra*delqr*cosa(jt)**3*beta      
          Omega0=Omega0+OmR(jt)  
         end do
         do k=1,ndim 
          OmR(k)=OmR(k)/Omega0 ! factor 2*2pi/Apt**2 omitted
         end do
      case(3)         !  rectangulat apertur, large detector 0<x<B; 0<y<A
         N_q=ndim/N_r
         delx=Dpt/2.0/N_r; dely=Dpt*BdA/2.0/N_q
         Omega0=0.0
         do k=1,N_r
          xx=delx*(2*k-1);
          do l=1,N_q
           yy=dely*(2*l-1);
           rat=sqrt(xx**2+yy**2)/Apt
           jt=jt+1
           cosa(jt)=1.0/sqrt(1+rat**2)
           OmR(jt)=cosa(k)**3            ! delx*dely/Apt**2 
           Omega0=Omega0 + OmR(jt)
          end do
         end do
         do k=1,ndim 
          OmR(k)=OmR(k)/Omega0 ! factor 2*2pi/Apt**2 omitted
         end do       
      case(4,24)     !  elements of an elliptical (cone section) absorber holder
         !  single crystal for case 4 by use of phia
         !  Dpt=D_aperture/2.0 or D_absorber/2.0
         !  Apt=sc2aperture    or sc2absorber
         ta=tan(alpha*rad); ca=cos(alpha*rad); sa=sin(alpha*rad)
         iph=7
         if(nomsamp.lt.7)iph=nomsamp
         do jphi=1,iph
           dph(jphi)=2.0*pi/nph0(jphi)
          end do
          do j=1,iph
           rhA(j)=(rho0(j-1)+rho0(j))/2.0/rho0(iph)*Dpt
          end do
          Omega0=0.0; jt=0  
          do k=1,iph               ! nomsamp ringe
           do jphi=1,nph0(k)       ! nph0(i) section
            jt=jt+1
            phjt=-dph(k)/2.0+dph(k)*float(jphi)+phicone*rad
            ! g*(-ez)    
            rsp=rhA(k)*sin(phjt)
            ! g**2
            Azjt=Apt+rsp*ta
            g2jt=rhA(k)**2+Azjt**2; sqg2jt=sqrt(g2jt)
            ! cos chi, v_g=v*cos chi
            cosjt=Azjt/sqg2jt
            ! cos delta, d_g=d/cos delta
            cosdjt=(sa*rsp+ca*Azjt)/sqg2jt
            OmR(jt)=cosjt/g2jt
            Omega0=Omega0+OmR(jt) ! factor 2*2pi/Apt**2 omitted       
            phia(jt)=phjt             ! phi angle, OmR=1/ndim
            cosa(jt)=cosjt            ! 
!            cosd(jt)=cosdjt
!write(6,'(a,8f12.4)')'1/cosdjt=',1.0/cosdjt,1./cosjt,phjt/rad,rhA(k),phjt/rad,cosjt 
         end do
         end do
         do k=1,ndim        
           OmR(k)=OmR(k)/Omega0 ! factor 2*2pi/Apt**2 omitted
         end do
         
      case(5)     ! extended circular source, circular aperture diaphragm
                  ! nph0(1..iring<=7), rho0(0:7) of the source
                  ! N_r rings of the circular aperture diaphragm with radii
                  ! ra=delr*(2*k-1), delr=Dpt/2.0/float(N_r), Dpt=Daperture/2.0
         jt=0;  rhot=Spt/Apt
         Omega0=0.0
         delr=Dpt/2.0/float(N_r)        
         do k=1,N_r
          ra=delr*(2*k-1);  rat=ra/Apt       ! Apt=sc2aperture
          do j=1,iringr  
           iph=nph0(j)
           do jphi=1,iph
            phjt=2.*pi/iph*float(jphi)  
            rhoj=(rho0(j-1)+rho0(j))/2.0/rho0(iringr)*rhot
            jt=jt+1         
            cosa(jt)=1./sqrt(1.0+rat**2+rhoj**2-2.0*rat*rhoj*cos(phjt))
            OmR(jt)=ra*cosa(jt)**3            ! 2pi*delr/Apt**2 
            Omega0=Omega0 + OmR(jt)
           end do
          end do
         end do
         do k=1,ndim        
            OmR(k)=OmR(k)/Omega0  ! factor 2*2pi/Apt**2 cancels
         end do
      case(6,7)     ! extended circular source, quadratic aperture diaphragm
                    ! rectangular aperture
        
        nx=N_r;ny=ndim/N_r/jdim(iringr)
        delx=Dpt/2.0/float(nx)/Apt; dely=Dpt/2.0*BdA/float(ny)/Apt
        Omega0=0.0; rhot=Spt/Apt
        jt=0
        do j=1,iringr  
         iph=nph0(j)
         do jphi=1,iph
          phjt=2.*pi/iph*float(jphi)  
          rhoj=(rho0(j-1)+rho0(j))/2.0/rho0(j)*rhot        
          do k=1,nx
           xx=delx*(2*k-1);
           do l=1,ny
            yy=dely*(2*l-1);
            rat=sqrt(1.0+xx**2+yy**2+rhoj**2-    &
                                   2.0*rhoj*(xx*cos(phjt)+yy*sin(phjt)))
            jt=jt+1
            cosa(jt)=1.0/rat
            OmR(jt)=cosa(jt)**3           !  rhoj*pi/iph*delx*dely/Apt**2 
            Omega0=Omega0 + OmR(jt)
           end do
          end do
         end do
        end do
        do k=1,ndim        
         OmR(k)=OmR(k)/Omega0  
        end do
      
      case(11)         ! extended source with non-rotational partitioning
        if(N_r.gt.7)N_r=7
        jt=0; jd=0;  rhot=Spt/Apt; rat=Dpt/Apt
         Omega0=0.0
        do jr=1,N_r 
         iphr=nph0(jr)
         do jphr=1,iphr
          jd=jd+1
          phjr=2.*pi/iphr*float(jphr)+pi/4.  
          rhojr=(rho0(jr-1)+rho0(jr))/2.0/rho0(N_r)*rat
          js=0
          do j=1,iringr  
           iph=nph0(j)
           do jphi=1,iph
            phjt=2.*pi/iph*float(jphi)  
            rhoj=(rho0(j-1)+rho0(j))/2.0/rho0(iringr)*rhot
            jt=jt+1;js=js+1
            cosa(jt)=1./sqrt(1.0+rhojr**2+rhoj**2-2.0*rhojr*rhoj*cos(phjt-phjr))
            OmR(jt)=cosa(jt)**3*soint(js)*doint(jd)           ! 2pi*delr/Apt**2 
            Omega0=Omega0 + OmR(jt)
           end do
          end do
         end do
        end do
        do k=1,ndim        
          OmR(k)=OmR(k)/Omega0  ! factor 2*2pi/Apt**2 cancels
        end do
     case(12)
        nx=N_r; ny=ndim/N_r/jdim(iringr)
        delx=Dpt/float(nx)/Apt; dely=Dpt/float(ny)/Apt; rhot=Spt/Apt

        Omega0=0.0
        jt=0; js=0
        do j=1,iringr  
         iph=nph0(j)
         do jphi=1,iph
          phjt=2.*pi/iph*float(jphi)  
          rhoj=(rho0(j-1)+rho0(j))/2.0/rho0(j)*rhot
          js=js+1

          do k=1,nx
           xx=-Dpt+delx*(2*k-1);
           do l=1,ny
            yy=-Dpt+dely*(2*l-1);
            rat=sqrt(1.0+xx**2+yy**2+rhoj**2-    &
                                   2.0*rhoj*(xx*cos(phjt)+yy*sin(phjt)))
            jt=jt+1
            cosa(jt)=1.0/rat
            OmR(jt)=cosa(jt)**3*soint(js)     !  rhoj*pi/iph*delx*dely/Apt**2 
            Omega0=Omega0 + OmR(jt)
           end do
          end do
         end do
        end do
        do k=1,ndim        
         OmR(k)=OmR(k)/Omega0  
        end do
        
      case(21)         ! single crystal for case 1
         iph=7
         if(nomsamp.lt.7)iph=nomsamp
         do jphi=1,iph
           dph(jphi)=2.0*pi/nph0(jphi)
          end do
          do j=1,iph
           rhA(j)=(rho0(j-1)+rho0(j))/2.0/rho0(iph)*Dpt
          end do
          Omega0=0.0; jt=0  
          do k=1,iph        ! nomsamp ringe
           do jphi=1,nph0(k)       ! nph0(i) section
              jt=jt+1
            phjt=-dph(k)/2.0+dph(k)*float(jphi)
            Azjt=Apt 
            rjt=sqrt(Apt**2+rhA(k)**2)
            cosjt=Apt/rjt
            OmR(jt)=1.0/rjt**3
            Omega0=Omega0+OmR(jt) ! factor 2*2pi/Apt**2 omitted
            phia(jt)=phjt             ! phi angle, OmR=1/ndim
            cosa(jt)=cosjt
           end do
          end do
          do k=1,ndim        
           OmR(k)=OmR(k)/Omega0 ! factor 2*2pi/Apt**2 omitted
        end do

       end select
!       print*,'###### igeo,jt,ndim=',igeo,jt,ndim
     return
    END subroutine geometry
                                                                         
    subroutine moss_selsubspect(text) 
      use glbconst, only: maxfr1,maxfr2,maxscr,maxss,maxthss,maxsub,nrd,nwr
      use complt, only: n_int,n_subset
      implicit none  

      character(len=40),intent(in):: text(3)
      character(len=4)  :: c_array 
      integer, parameter:: illc=3*(maxfr1+1+maxfr2+maxthss) 
      integer           :: mstruct1,istruct1,istruct2,iaddr
      character(len=64) :: frthname
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                    c_array(illc),frthname(2),iaddr(8) 

      character(len=40) :: htext,text1,text2
      character(len=132):: ch132,cp132,chcom
      character(len=1)  :: ch1
      logical   bs_and_a 
      real,   dimension(32)     :: out
      integer   i,ik,ipos,iout,is,is_a,is_and_a,is_e,iset,j,         &
                j_int,jabsorber,jsource,ji,jj,kk,lay,mlay,n_ssub,nn, &
                ia,ii
      integer, parameter :: max=4*maxss
      integer, dimension(max):: npanum

      
      mlay=istruct1(mstruct1) 
!     mlay : number of layers                                           
!     subspectra for the plot, calculating subspectrum(1024,12)         

      text1=adjustl(text(1))
      text2=adjustl(text(2))
                                                                              
      is=0 
      do lay=1,mlay 
       is_a=istruct2(lay-1)+1 
       is_e=istruct2(lay) 
       htext=text2 
       if(lay.eq.1) htext=text1 
       if(lay.eq.mlay.and.mstruct1.eq.3) htext=text(3) 
       if(is_e.ge.is_a) then 
                                                                        
        write(nwr,'(a,i2,a2,2a,i2,a,i2)') ' layer(',lay,'):',           &
            TRIM(htext),' sites from ',is_a,' to ',is_e                 
        is=is+is_e-is_a+1 
       end if 
      end do 
!      if((index(text(1),'source').gt.0.and.istruct2(mlay).lt.3)        
      if(is.lt.3) then 
         write(nwr,'(a)') '**  there are no sub-spectra ** '
         n_subset=0
       goto 1000 
      end if 
      is_and_a=0 
      bs_and_a=.true. 
!      if(index(text(1),'source').gt.0.and.istruct2(1).eq.1) then       
      if(istruct2(1).eq.1) then 
!      no source sub-spectrum                                           
       bs_and_a=.false. 
       is_and_a=1 
      end if 
      if(istruct2(mlay)-istruct2(1).eq.1) then 
!      no absorber  sub-spectrum                                        
       bs_and_a=.false. 
       is_and_a=2 
      end if 
                                                                        
                                                                        
  809  if(bs_and_a) then 
        write(nwr,'(/,6a)') ' sub-spectrum_j of ',                      &
        TRIM(text1),'(ji) and ',TRIM(text2),'(ki).',                      &
         ' Number j (h-ide), sites: j1...jn k1...kn'                   
                                                                        
       else if(is_and_a.eq.1)then 
        write(nwr,'(/,3a)') ' sub-spectrum_j of the ',                  &
       TRIM(text2),'  Number j (h-hide),  site: k1...kn'                
                                                                        
       else if(is_and_a.eq.2)then 
        write(nwr,'(/,3a)') ' sub-spectrum_j of the ',                  &
       TRIM(text1),'  Number j (h-ide), site: j1...jn '                 
       end if 
                                                                        
       i=1 
       do while(i.le.maxsub.and.abs(n_int(i,0)).gt.0) 
        i=i+1 
        if(i-1.eq.maxsub) goto 8091 
       end do 
 8091  ik=i-1 
                                                                        
       i=0 
  805  i=i+1 
        j_int=abs(n_int(i,0)) 
        kk=0 
        do jj=1,j_int 
         if(n_int(i,jj).gt.is_e) kk=kk+1 
        end do 
        if(kk.gt.0)then 
         do kk=i,ik 
          j_int=abs(n_int(kk+1,0)) 
          if(j_int.gt.0) then 
           do jj=0,j_int 
            n_int(kk,jj)=n_int(kk+1,jj) 
           end do 
          else 
           do jj=0,maxss 
            n_int(ik,jj)=0 
           end do 
          end if 
         end do 
         ik=ik-1 
         i=i-1 
        end if 
        if(i.lt.ik)goto 805 
                                                                        
  810  i=1 
       n_subset=0 
       do while(i.le.maxsub.and.abs(n_int(i,0)).gt.0) 
        ch1=' ' 
        if(n_int(i,0).lt.0) ch1='h' 
        j_int=abs(n_int(i,0)) 
        kk=0 
        do jj=1,j_int 
         if(n_int(i,jj).gt.is_e) kk=kk+1 
        end do 
        if(kk.gt.0)then 
         n_int(i,0)= 0 
         j_int=0 
         i=i-1 
        end if 
        if(is_and_a.eq.0) then 
         if(i.le.9) write(nwr,'(a,i1,a1,1x,32i3)')                      &
         ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=1,j_int)               
         if(i.gt.9) write(nwr,'(a,i2,a1,32i3)')                         &
         ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=1,j_int)               
        end if 
        if(is_and_a.eq.1) then 
         if(i.le.9) write(nwr,'(a,i1,a1,1x,32i3)')                      &
         ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=2,j_int)               
         if(i.gt.9) write(nwr,'(a,i2,a1,32i3)')                         &
         ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=2,j_int)               
        end if 
        if(is_and_a.eq.2) then 
         if(i.le.9) write(nwr,'(a,i1,a1,1x,32i3)')                      &
         ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=1,j_int-1)             
         if(i.gt.9) write(nwr,'(a,i2,a1,32i3)')                         &
         ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=1,j_int-1)             
        end if 
        if(ch1.eq.' ')  n_subset=i 
        i=i+1 
        if(i-1.eq.maxsub) goto 811 
       end do 
  811  n_ssub=i-1 
                                                                        
  820  read(nrd,'(a)') ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        i=index(frthname(1),' ') 
        chcom='<'//frthname(1)(1:i-1)//'>/sub-spectra/input' 
        call help(chcom) 
        goto 809 
       end if 
       if (ch132(1:1).ne.'*'.and.ch132(1:1).ne.'q') then 
        if (ch132(1:1).eq.'#') goto 810 
        call nextchar(ch132,0,ipos,cp132,ii) 
        call nextchar(cp132,ii,ipos,ch132,ia)
        call trlch(80,cp132,iout,out)
        if(iout.gt.0) then
          i=1                                                               
          call seqnum(ch132,max,npanum,i)
        else
         goto 820
        end if
!        write(6,'(a)')' npanum(1-npanum(2))'                           
!        write(6,'(20i3)')(npanum(j),j=1,npanum(2)+2)                   
        iset=out(1) 
        if(iset.gt.maxsub) then 
          write(nwr,'(a,i3)') ' maximal number of sub-spectra ',maxsub 
          goto 810 
        end if 
        if(iout.lt.1) then 
          write(nwr,'(a)')                                              &
         ' at least the number of the sub-spectrum (or *)'             
          goto 820 
        end if 
        if(iout.eq.1) then 
!        hide a sub-spectrum                                            
         if(ch132(1:1).eq.'h') then 
          if(n_int(iset,0).lt.0) then 
           n_int(iset,0)= abs(n_int(iset,0)) 
           do j=maxsub,2,-1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(j-1,ji) 
            end do 
           end do 
           if(iset.lt.maxsub) then 
            do ji=0,maxss 
             n_int(1,ji)=n_int(iset+1,ji) 
             n_int(iset+1,ji)=0 
            end do 
           end if 
          else 
           n_int(iset,0)=-abs(n_int(iset,0)) 
           if(iset.lt.n_ssub) then 
            j=n_ssub+1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(iset,ji) 
             n_int(iset,ji)=0 
            end do 
           end if 
          end if 
         end if 
!        remove a sub-spectrum                                          
         if(ch132(1:2).eq.'rm') then 
          if(iset.lt.maxsub) then 
           do j=iset,maxsub-1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(j+1,ji) 
            end do 
           end do 
          end if 
          do ji=0,maxss 
           n_int(maxsub,ji)=0 
          end do 
!          write(6,'(8i3)')n_int                                        
         end if 
        end if 
!       write(6,'(a,10i4)') ' 1 out=',(int(out(j)),j=1,iout)            
                                                                        
        if(iout.eq.2.and.bs_and_a) then 
         write(nwr,'(a)')                                               &
         '**** at least one source and absorber sub-spectrum'          
          goto 820 
        end if 
                                                                        
        if(iout.ge.2) then 
         nn=out(2) 
         if(nn.gt.istruct2(1).and.bs_and_a) then 
          write(nwr,'(a,i2)')                                           &
         '**** at least one source sub-spectrum  <=',istruct2(1)       
          goto 820 
         end if 
!        write(6,'(a,10i4)') ' 2 out=',(int(out(j)),j=1,iout)           
         n_int(iset,0)=0 
         jsource=0 
         jabsorber=0 
         iout=npanum(2)+1 
!         do j=2,iout                                                   
!          nn=out(j)                                                    
          do j=2,iout 
          nn=npanum(1+j) 
          if(nn.gt.is_e) then 
           write(nwr,'(a,i5,a)') ' ***',nn,' is not a sub-spectrum' 
          else 
           if(nn.le.istruct2(1)) jsource=jsource+1 
           if(nn.gt.istruct2(1)) jabsorber=jabsorber+1 
           if(is_and_a.eq.0) then 
            n_int(iset,0)=j-1 
            n_int(iset,j-1)=nn 
           end if 
           if(is_and_a.eq.1) then 
            n_int(iset,0)=j 
            n_int(iset,1)=1 
            n_int(iset,j)=nn 
            jsource=1 
           end if 
           if(is_and_a.eq.2) then 
            n_int(iset,0)=j 
            n_int(iset,j-1)=nn 
            n_int(iset,j)=istruct2(mlay) 
            jabsorber=1 
           end if 
          end if 
         end do 
         if(jsource.eq.0.and.bs_and_a) then 
           write(nwr,'(a)')                                             &
          '****  at least one sub-spectrum of the source '             
           goto 820 
          end if 
          if(jabsorber.eq.0.and.bs_and_a) then 
           write(nwr,'(a)')                                             &
          '****  at least one sub-spectrum of the absorber'            
           goto 820 
          end if 
         end if 
!        write(6,'(a,10i4)')'n_int(1,0)=',(n_int(1,ji),ji=0,5)          
!        write(6,'(a,10i4)')'n_int(2,0)=',(n_int(2,ji),ji=0,5)          
!        write(6,'(a,10i4)')'n_int(3,0)=',(n_int(3,ji),ji=0,5)          
         jj=n_ssub 
         do i=1,maxsub-1 
          if(n_int(i,1).lt.0.and.n_int(i+1,1).gt.0) then 
           jj=jj+1 
           if(jj.le.maxsub) then 
            do ji=0,maxss 
             n_int(jj,ji)=n_int(i,ji) 
            end do 
           else 
            do ji=0,maxss 
             n_int(i,ji)=0 
            end do 
           end if 
          end if 
         end do 
         do i=1,maxsub 
          if(n_int(i,1).eq.0) then 
           do j=i,maxsub-1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(j+1,ji) 
            end do 
           end do 
          end if 
         end do 
         goto 810 
       end if  ! * out
 1000  continue
       return 
      END                                           

     subroutine moss_subspect(cmch,mi,info) 
     use glbconst, only: maxn,maxthss,maxsub,icstrf,ivstrf,MDBPLFT
     use complt, only: n_subset,n_int
     use comthe, only: thfk
     implicit none 
     character(len=4),intent(in) :: cmch 
     integer,         intent(in) :: mi
     integer,         intent(out):: info 

     real    dum,channels,avsp,f_factor,base,dumcsp,dumcvs
     common/acstrf/ dum(5),channels,dumcsp(icstrf-6)                          
     common/avstrf/ avsp,f_factor,base,dumcvs(ivstrf-3) 
    
     real             :: datx,errx,sym,subspectrum,parray,thfkd
     integer,parameter:: max4=4*maxn, jdumpl=8*(max4+2)+4*(max4/2)+max4, &
                         idumpl= maxn*180+jdumpl,                        &
                         kdumpl=3*max4+max4*maxsub,                      &
                         ldumpl=MDBPLFT*2-180*maxn-jdumpl-kdumpl
    common/plot/parray(idumpl),datx(max4),errx(max4),sym(max4),          &
                subspectrum(max4,maxsub),thfkd(ldumpl)

     real        p0 
     real,dimension(maxthss):: plold 
     integer nchansp,i,ip,l,ll,j,k1                                 

      nchansp=channels 
      do i=1,max4 
       thfkd(i)=thfk(i) 
      end do 
                                                                        
       call calpl('test') 
                                                                        
       do  i=1,mi 
        plold(i)=0.0 
        call replace_wi(-i,plold(i),info)  ! - take out and write on plo
       end do 
!       write(6,'(i3,a,16f10.3)')mi,' subsp-plold(1..)=',(plold(i),i=1,mi)
       nchansp=channels 
                                                                        
       do  l=1,n_subset 
        p0=0.0 
        do j=1,mi 
         call replace_wi(j,p0,info)  ! + write 0 to wi values 
        end do 
!       write(6,'(a,i4,a,30i3)')' l_subsp=',l,  &                        
!            ' n_int(l,ll)=',(n_int(l,ll),ll=0,n_int(l,0))           
        do ll=1,n_int(l,0) 
         ip=n_int(l,ll) 
         call replace_wi(ip,plold(ip),info)  ! + write plold(ip) to wi v
        end do 

        k1=3 
        call sel_the2exp(cmch,k1,info) 
        do  i=1,nchansp 
         subspectrum(i,l)=thfk(i) 
        end do 
!       write(6,'(a,i4)') '  sub-spectrum i=',l                        
!      write(6,'(4e15.6)') (thfk(i),i=1,nchansp,64)                   
       end do 
                                                                        
       do  i=1,mi 
        call replace_wi(i,plold(i),info)  ! + write plold(i) to wi value
       end do 
                                                                        
      do i=1,max4 
       thfk(i)=thfkd(i) 
      end do 
      return 

    END subroutine moss_subspect
                                                                        
!------------------------------------------------------------------     
                                                                        
      subroutine moss_selsubtract(text,isub) 
      use glbconst, only: maxfr1,maxfr2,maxscr,maxss,maxthss,maxsub,nrd,nwr
      use complt, only:   n_sub
      use comthe, only:   array_fr
      implicit none
                                                                        
      character(len=40),intent(in) :: text(3)
      integer,          intent(out):: isub 

      integer,parameter :: maxsouab=5
      character(len=4)  :: c_array 
      integer, parameter:: illc=3*(maxfr1+1+maxfr2+maxthss)      
      integer     mstruct1,istruct1,istruct2,iaddr,idum,ipSI
      character(len=64):: frthname
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                    c_array(illc),frthname(2),                          &
                    idum(4),ipSI,iaddr(3)
                                                                        
      real,dimension(32):: out 
      character(len=40) :: htext,texta
      character(len=132):: ch132,cp132,chcom
      character(len=1)  :: ch1
                                                                        
      integer,parameter :: jSI=maxsub*(maxss+1)
      integer,dimension(2*jSI)  :: i_int
      integer,dimension(maxsub,0:maxss):: n_source,n_absorber 
      equivalence (i_int(1),n_source), (i_int(jSI+1),n_absorber) 

      integer   i,ia,ii,is_a,is_e,iset,j,jab,ji,jj,jsou,jsource,        &
                lay,laye,mlay,n_ssub,nn,iout,ipos,lch
      integer, parameter :: max=4*maxss
      integer, dimension(max):: npanum


      do i=1,jSI 
       i_int(i)=real(array_fr(ipSI+i)) 
       i_int(i+jSI)=aimag(array_fr(ipSI+i)) 
      end do

      do i=1,maxsub 
       n_source(i,0)=0 
       n_absorber(i,0)=0 
      end do 

!     mlay : number of layers                                           
      mlay=istruct1(mstruct1) 
                                                                        
      laye=mlay 
      if(mstruct1.eq.3) laye=mlay-1 
      n_source(1,0)=0 
      if(istruct2(1).eq.1) goto 875 
       is_a=1 
       is_e=istruct2(1) 
       htext=text(1) 
       write(nwr,'(a,2(a,i2))')                                         &
         htext(:24),' sites from ',is_a,' to ',is_e                     
        cp132=htext 
        call nextchar(cp132,0,ipos,ch132,lch) 
        write(nwr,'(/,2a)')ch132(1:lch),                                &
            '_subsp_j      j1   j2 ...  [j=1]'                         
  860  i=1 
       do while(abs(n_source(i,0)).gt.0) 
        ch1=' ' 
        if(n_source(i,0).lt.0) ch1='h' 
        write(nwr,'(a,i1,a1,1x,32i3)') ' source_subsp_',                &
            i,ch1,(n_source(i,jj),jj=1,abs(n_source(i,0)))             
        i=i+1 
        if(i.gt.maxsouab) goto 861 
       end do 
  861  n_ssub=i-1 
                                                                        
  870  read(nrd,'(a)') ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        i=index(frthname(1),' ') 
        chcom='<'//frthname(1)(1:i-1)//'>/sub-spectra/subtract/source' 
         call help(chcom) 
         goto 860 
       end if 
       if (ch132(1:1).ne.'*'.and.ch132(1:1).ne.'q') then 
        if (ch132(1:1).eq.'#') goto 860 
        call nextchar(ch132,0,ipos,cp132,ii) 
        call nextchar(cp132,ii,ipos,ch132,ia) 
        i=1
        call seqnum(ch132,max,npanum,i) 
        if(i.ne.1) goto 870  
        call trlch(80,cp132,iout,out) 
        iset=out(1) 
        if(iset.gt.maxsub) then 
          write(nwr,'(a)') ' maximal number of sub-spectra reached' 
          goto 860 
        end if 
        if(iout.lt.1) then 
          write(nwr,'(a)')                                              &
         ' at least the number of the sub-spectrum (or *)'             
          goto 870 
        end if 
        if(iout.eq.1) then 
         if(ch132(1:1).eq.'h') then 
          if(n_source(iset,0).lt.0) then 
           n_source(iset,0)= abs(n_source(iset,0)) 
           do j=maxsouab,2,-1 
            do ji=0,maxss 
             n_source(j,ji)=n_source(j-1,ji) 
            end do 
           end do 
           if(iset.lt.maxsub)then 
            do ji=0,maxss 
             n_source(1,ji)=n_source(iset+1,ji) 
             n_source(iset+1,ji)=0 
            end do 
           end if 
          else 
           n_source(iset,0)=-abs(n_source(iset,0)) 
           if(iset.lt.n_ssub) then 
            j=n_ssub+1 
            do ji=0,maxss 
             n_source(j,ji)=n_source(iset,ji) 
             n_source(iset,ji)=0 
            end do 
           end if 
          end if 
         end if 
         if(ch132(1:2).eq.'rm') then 
          if(iset.lt.maxsub) then 
           do j=iset,maxsub-1 
            do ji=0,maxss 
             n_source(j,ji)=n_source(j+1,ji) 
            end do 
           end do 
          end if 
          do ji=0,maxss 
           n_source(maxsub,ji)=0 
          end do 
         end if 
        end if 
                                                                        
        if(iout.ge.2) then 
        n_source(iset,0)=0 
        jsource=0 
        iout=npanum(2)+1 
                                                                        
        do j=2,iout 
!        nn=out(j)                                                      
         nn=npanum(1+j) 
         if(nn.gt.istruct2(1)) then 
         write(nwr,'(a,i2,a)')                                          &
         '**** ',nn,' is not a source sub-spectrum  '                  
         else 
          jsource=jsource+1 
          n_source(iset,0)=j-1 
          n_source(iset,j-1)=nn 
         end if 
        end do 
         if(jsource.eq.0) then 
         write(nwr,'(a)')                                               &
         '****  no source sub-spectrum  '                              
         goto 870 
         end if 
        end if 
                                                                        
        jj=n_ssub 
        do i=1,maxsouab-1 
         if(n_source(i,1).lt.0.and.n_source(i+1,1).gt.0) then 
          jj=jj+1 
          if(jj.le.maxsouab) then 
           do ji=0,maxss 
            n_source(jj,ji)=n_source(i,ji) 
           end do 
          else 
           do ji=0,maxss 
            n_source(i,ji)=0 
           end do 
          end if 
         end if 
        end do 
        do i=1,maxsouab 
         if(n_source(i,1).eq.0) then 
          do j=i,maxsouab-1 
           do ji=0,maxss 
            n_source(j,ji)=n_source(j+1,ji) 
           end do 
          end do 
         end if 
        end do 
        goto 860 
               ! * out                                                  
       end if 
                                                                        
                                                                        
  875 do lay=2,mlay 
       is_a=istruct2(lay-1)+1 
       is_e=istruct2(lay) 
       htext=text(2) 
       if(lay.eq.mlay.and.mstruct1.eq.3) htext=text(3) 
       if(is_a.le.is_e)                                                 &
       write(nwr,'(a,i2,a2,2a,i2,a,i2)') ' layer(',lay,'):',           &
                  htext(1:24),' sites from ',is_a,' to ',is_e          
      end do 
                                                                        
  879 cp132=htext 
      call nextchar(cp132,0,ipos,ch132,lch) 
      texta=ch132 
      write(nwr,'(/,2a)')ch132(1:lch),                                  &
            '_subsp_j      j1   j2 ...  [j=1]'                         
  880 i=1 
      do while(abs(n_absorber(i,0)).gt.0) 
       ch1=' ' 
       if(n_absorber(i,0).lt.0) ch1='h' 
       write(nwr,'(2a,i1,a1,1x,32i3)') texta(:lch),'_subsp_',           &
          i,ch1,(n_absorber(i,jj),jj=1,abs(n_absorber(i,0)))           
       i=i+1 
       if(i.gt.maxsouab) goto 881 
      end do 
  881 n_ssub=i-1 
                                                                        
  890  read(nrd,'(a)') ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        i=index(frthname(1),' ') 
        chcom='<'//frthname(1)(1:i-1)//'>/sub-spectra/subtract/absorber' 
         call help(chcom) 
         goto 879 
       end if 
       if (ch132(1:1).ne.'*'.and.ch132(1:1).ne.'q') then 
        if (ch132(1:1).eq.'#') goto 880 
        call nextchar(ch132,0,ipos,cp132,ii) 
        call nextchar(cp132,ii,ipos,ch132,ia) 
        i=1
        call seqnum(ch132,max,npanum,i) 
        if(i.ne.1) goto 890           
        call trlch(80,cp132,iout,out) 
        iset=out(1) 
        if(iset.gt.maxsub) then 
          write(nwr,'(a)') ' maximal number of sub-spectra reached' 
          goto 880 
        end if 
        if(iout.lt.1) then 
          write(nwr,'(a)')                                              &
         ' at least the number of the sub-spectrum (or *)'             
          goto 890 
        end if 
        if(iout.eq.1) then 
         if(ch132(1:1).eq.'h') then 
          if(n_absorber(iset,0).lt.0) then 
           n_absorber(iset,0)= abs(n_absorber(iset,0)) 
           do j=maxsouab,2,-1 
            do ji=0,maxss 
             n_absorber(j,ji)=n_absorber(j-1,ji) 
            end do 
           end do 
           if(iset.lt.maxsub)then 
            do ji=0,maxss 
             n_absorber(1,ji)=n_absorber(iset+1,ji) 
             n_absorber(iset+1,ji)=0 
            end do 
           end if 
          else 
           n_absorber(iset,0)=-abs(n_absorber(iset,0)) 
           if(iset.lt.n_ssub) then 
            j=n_ssub+1 
            do ji=0,maxss 
             n_absorber(j,ji)=n_absorber(iset,ji) 
             n_absorber(iset,ji)=0 
            end do 
           end if 
          end if 
         end if 
         if(ch132(1:2).eq.'rm') then 
          if(iset.lt.maxsub) then 
           do j=iset,maxsub-1 
            do ji=0,maxss 
             n_absorber(j,ji)=n_absorber(j+1,ji) 
            end do 
           end do 
          end if 
          do ji=0,maxss 
           n_absorber(maxsub,ji)=0 
          end do 
         end if 
        end if 
                                                                        
        if(iout.ge.2) then 
        n_absorber(iset,0)=0 
        iout=npanum(2)+1 
        do j=2,iout 
!        nn=out(j)                                                      
         nn=npanum(1+j) 
        if(nn.le.istruct2(1).or.nn.gt.istruct2(laye)) then 
         write(nwr,'(a,i2,a)')                                          &
         '**** ',nn,' is not an absorber sub-spectrum  '               
         else 
          n_absorber(iset,0)=j-1 
          n_absorber(iset,j-1)=nn 
         end if 
        end do 
        end if 
                                                                        
        jj=n_ssub 
        do i=1,maxsouab-1 
         if(n_absorber(i,1).lt.0.and.n_absorber(i+1,1).gt.0)then             
          jj=jj+1 
          if(jj.le.maxsouab) then 
           do ji=0,maxss 
            n_absorber(jj,ji)=n_absorber(i,ji) 
           end do 
          else 
           do ji=0,maxss 
            n_absorber(i,ji)=0 
           end do 
          end if 
         end if 
        end do 
        do i=1,maxsouab 
         if(n_absorber(i,1).eq.0) then 
          do j=i,maxsouab-1 
           do ji=0,maxss 
            n_absorber(j,ji)=n_absorber(j+1,ji) 
           end do 
          end do 
         end if 
        end do 
        goto 880 
               ! * out                                                  
       end if 
                                                                        
!      source sub-spectra (and all absorber sub-spectra)                
       isub=1 
       if(n_source(1,0).gt.0) then 
        isub=2 
        n_sub(1,0)=n_source(1,0)+istruct2(laye)-istruct2(1) 
        do j=1,n_source(1,0) 
         n_sub(1,j)=n_source(1,j) 
        end do 
        do j=1,n_sub(1,0)-n_source(1,0) 
         n_sub(1,j+n_source(1,0))=istruct2(1)+j 
        end do 
                ! source sub-spectra                                    
       end if 
                                                                        
!      absorber sub-spectra (and remaining source sub-spectra)          
                                                                        
       jsou=0 
       do j=1,istruct2(1) 
        jj=0 
        do i=1,abs(n_source(1,0)) 
         if(abs(n_source(1,i)).eq.j) jj=1 
        end do 
        if(jj.eq.0) then 
         jsou=jsou+1 
         n_sub(0,jsou)=j 
        end if 
       end do 
                                                                        
        do j=1,jsou 
         n_sub(isub,j)=n_sub(0,j) 
        end do 
                                                                        
        jj=jsou 
        do j=1,n_absorber(1,0) 
          jj=jj+1 
          n_sub(isub,jj)=n_absorber(1,j) 
        end do 
        n_sub(isub,0)=jj 
                                                                        
!    reaining sub-spectrum stored in n_sub(0,j)                         
                                                                        
       jab=0 
       do j=istruct2(1)+1,istruct2(laye) 
        jj=0 
        do i=1,n_sub(isub,0) 
         if(n_sub(isub,i).eq.j) jj=1 
        end do 
        if(jj.eq.0) then 
         jab=jab+1 
         n_sub(0,jsou+jab)=j 
        end if 
       end do 
       n_sub(0,0)=jsou+jab 
                                                                        
      do i=1,jSI 
       array_fr(ipSI+i)=cmplx(i_int(i),i_int(i+jSI)) 
      end do 
                                                                        
!       do i=1,isub                                                     
!       write(nwr,'(a,i1,2x,32i3)')                                     
!     &    ' sub-spectrum_',i,(n_sub(i,jj),jj=1,abs(n_sub(i,0)))        
!       end do                                                          
       write(nwr,'(a,1x,2x,32i3)')                                      &
         ' residual spectrum sites',(n_sub(0,jj),jj=1,abs(n_sub(0,0))) 
                                                                        
       print '(a)',' ' 
       print '(a)','                         **** CALCULATING ****' 
       return 
     END subroutine moss_selsubtract
                                                                        
                                                                        
                                                                        
      subroutine moss_subtract(cmch,mi,isub,info) 
      use glbconst, only: maxn,maxthss,maxsub,icstrf,ivstrf,MDBPLFT
      use comdat, only: ichanks,mxpt,mfpt,mvpt,mgpt,mdgpt,mlpt
      use complt, only: n_sub
      use comthe, only: real_fr,thfk
      implicit none 
      character(len=4), intent(in) :: cmch 
      integer,          intent(in) :: mi,isub
      integer,          intent(out):: info  
      integer, parameter:: nl=18

     real         dum,channels,dum1,lambda,drive_mode,channels_vmax,c_nonlinear,dumcs
     common/acstrf/dum(5),channels,dum1(2),lambda,drive_mode,channels_vmax, &
                   c_nonlinear,dumcs(icstrf-12)            
     real          avsp,f_factor,base,bg_fraction,v_max,               &
                   channel_v0,geo,vnl,dumvs
     common/avstrf/avsp,f_factor,base,bg_fraction,v_max,channel_v0,geo,vnl(nl),    &
                   dumvs(ivstrf-7-nl)         

     real             :: datx,errx,sym,subspectrum,parray,thfkd  
     integer,parameter:: max4=4*maxn, jdumpl=8*(max4+2)+4*(max4/2)+max4, &
                         idumpl= maxn*180+jdumpl,                        &
                         kdumpl=3*max4+max4*maxsub,                      &
                         ldumpl=MDBPLFT*2-180*maxn-jdumpl-kdumpl
    common/plot/parray(idumpl),datx(max4),errx(max4),sym(max4),          &
                subspectrum(max4,maxsub),thfkd(ldumpl)

!      real velocity,geof,dfdgeo,p0 
!      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn) 
      real p0
      real, dimension(maxthss) :: plold 
      integer nchansp,i,j,jj,k,k1                                     
                                                                        
      nchansp=channels 
      call drive(int(drive_mode),int(c_nonlinear),lambda,nchansp,mvpt,mgpt,mdgpt,&    
                 mxpt,mlpt,channels_vmax,channel_v0,v_max,geo,vnl,info)
      if(info.gt.0)return

      do i=1,max4 
       thfkd(i)=thfk(i) 
      end do 
                                                                        
!     write(6,'(a,i4)') ' ********** mi=',mi                            
                                                                        
       call calpl('test') 
       do  i=1,mi 
        plold(i)=0.0 
        call replace_wi(-i,plold(i),info)  ! - take out and write on plold
       end do 
!      subtract y - yy                                                  
                                                                        
!      absorber complete , source and detector window subtracted        
                                                                        
       p0=0.0 
       do j=1,isub 
        do i=1,mi 
         call replace_wi(i,p0,info)  ! + write 0 to wi values  
        end do 
                                                                        
        do i=1,n_sub(j,0) 
         jj=abs(n_sub(j,i)) 
         call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi v
        end do  
                                                                        
        k1=3 
        call sel_the2exp(cmch,k1,info) 
                                                                        
!      write(6,'(a)') ' ------1----back in subtract----------------'    
                                                                        
        do k=2,ichanks(0),2 
         do i=ichanks(k-1),ichanks(k) 
          real_fr(mfpt+i)=real_fr(mfpt+i)-(thfk(i)-base*real_fr(mgpt+i)) 
         end do 
        end do 
       end do ! isub
                                                                        
!      calculation of the theory of the stripped spectrum               
       p0=0.0 
       do i=1,mi 
        call replace_wi(i,p0,info)   ! + write 0.0 to wi values   
       end do 
                                                                        
       do i=1,n_sub(0,0) 
        jj=n_sub(0,i) 
        call replace_wi(jj,plold(jj),info)   ! + write plold(jj) to wi va
       end do 
                                                                        
       k1=3 
         ! values are not reset by calpl, written on theory-array       
       call sel_the2exp(cmch,k1,info) 
                                                                        
!      write(6,'(a)') ' ------2----back in subtract----------------'    
!      restore parameters                                               
       call calpl('test') 
                                                                        
      do i=1,max4 
       thfk(i)=thfkd(i) 
      end do 
      return 

    END subroutine moss_subtract
                                                                        
!      subroutine forstruct                                             
!      implicit none                                                    
!      use glbconst                                             
!      integer      istruct,idum                                        
!      parameter   (istruct=2+4*maxfr1+4+4*maxfr2+3*maxthss+32+8)  
!      common/struct/idum(istruct)                                      
!      return                                                           
!      end                                                              

                                                                        
      subroutine channel_content(mode_drive,vm,v0,vp,ym,y0,yp,dv,cc)
      implicit none
      integer, intent(in):: mode_drive
      real, intent(in):: vm,v0,vp,ym,y0,yp,dv
      real, intent(out):: cc
      
      real  fm,f0,fp,dm,d0,dp,det1,det2,alpha,beta,gamma,vm2,v02,vp2,ypm,yp0m,h
      integer        i

!     known : i=int(v0/dv)  -> ym=yth(i-1), y0=yth(i), yp=yth(i+1) 
      h=vm/dv; i=int(h); dm= h-float(i)
      h=v0/dv; i=int(h); d0= h-float(i)
      h=vp/dv; i=int(h); dp= h-float(i)

!     theory values at vm,vo,vp
      ypm=yp-ym; yp0m=yp-2.0*y0+ym
      fm=y0+dm*(ypm+dm*yp0m)/2.0
      f0=y0+d0*(ypm+d0*yp0m)/2.0
      fp=y0+dp*(ypm+dp*yp0m)/2.0
      
     if(mode_drive.eq.1) then
!     delta_v constant
       cc=f0+(fp-fm)/4.+(fp-2*f0+fm)/6.
     else
!     v0-vm # vp-v0;
!     f(v) = alpha* v**2 +beta*v +gamma
!     the 3 equations for fm,f0,fp determine alpha,beta,gamma 
      if(abs(vp-vm).lt.1.e-5)then
       cc=f0+(fp-fm)/4.+(fp-2*f0+fm)/6.
       return
      end if
      det1=(v0-vm)*(vp-vm)
      det2=(vp-v0)*(vp-vm)
      vm2=vm**2; v02=v0**2; vp2=vp**2
      alpha=(fp-f0)/det2-(f0-fm)/det1
      beta= (vp+v0)*(f0-fm)/det1-(v0+vm)*(fp-f0)/det2

      gamma=f0-alpha*v02-beta*v0
!     integration from v0 till vp
      cc=gamma+alpha*(vp2+vp*v0+v02)/3. + beta*(vp+v0)/2.
     end if
     return
   end subroutine channel_content


    subroutine areascan(filearea,iring,Radius,areaint)
     implicit none
     character(len=132), intent(in)::filearea      
     integer, intent(in):: iring
     real,    intent(in):: Radius
     real, dimension(127), intent(out)::areaint

     real, dimension(0:7)::rho0=(/-1.0,1.0,sqrt(7.0),sqrt(19.0),sqrt(37.0),&
                        sqrt(61.0),sqrt(91.0),sqrt(127.0)/)
    integer,dimension(7)::nph0=(/1,6,12,18,24,30,36/)
    integer  jt,j,k,l,jphi,iph,km,lm,ic,icc,ir,irc
    character(len=512)::ch512
    character(len=132)::ch132
    character(len=1)::ch1
    character(len=10)::ch10
    character(len=8)::ch8
    
    real xr,yr,xx,yy,rhoj,phjt,h,hm,sum,step  
    real, parameter :: pi=3.141592654, pi2=pi/2.0, rad=pi/180.
    integer iringr
    integer, dimension(0:512):: kint
    real, dimension(:,:), allocatable:: mapsc

    iringr=iring
    if(iring.gt.7)then
      print'(a,i2,a)',' iring=',iring,' is reduced to its maximal value of 7' 
      iringr=7
    end if
   
    open(unit=2,file=filearea                                & 
               ,status='old'                                  &       
               ,access='sequential'                           &       
               ,form='formatted')

      read(2,'(a)') ch512
      !     rows=51  center-row=26 columns=51 center-column=26  stepwiths=0.2
      j=1
      do k=1,5
         l=index(ch512(j:),'='); ch132=ch512(l+1:)
         if(k.lt.5) then
            ch8=ch512(l+1:l+3); call c8toi(ch8,jt)
         end if
         if(k.eq.1)ir=jt
         if(k.eq.2)irc=jt
         if(k.eq.3)ic=jt
         if(k.eq.4)icc=jt
         if(k.eq.5) then
          ch10=ch512(l+1:l+5);   read(ch10,*) step
         end if
         ch512=ch132         
      end do
     allocate(mapsc(ir,ic))
      
      do l=1,ir
       read(2,'(a)') ch512
       k=1;j=0;kint(0)=1
       do while(k.lt.512.and.j.lt.ir)
        ch1=ch512(k:k)
        if(ch1.eq.' ')then
         j=j+1; kint(j)=k
         ch10=ch512(kint(j-1):kint(j))
         read(ch10,*) mapsc(l,j)
        end if
        k=k+1
       end do
      end do
    close(unit=2)
      
      jt=0; sum=0.
      do j=1,iringr  
        iph=nph0(j)
        do jphi=1,iph
          jt=jt+1         
          phjt=2.*pi/iph*float(jphi)  
          rhoj=(rho0(j-1)+rho0(j))/2.0/rho0(iringr)*Radius
          hm=1000.
          do k=1,ic
           do l=1,ir
            if(mapsc(l,k).gt.1)then
             xx=(k-icc)*step; yy=(l-irc)*step
             xr= rhoj*cos(phjt); yr=rhoj*sin(phjt)
             h=(xx-xr)**2+(yy-yr)**2
             if(hm.gt.h)then
              hm=h;km=k;lm=l
             end if
            end if  
           end do
          end do
          areaint(jt)=mapsc(lm,km)
          sum=sum+mapsc(lm,km)
        end do
     end do
     do k=1,jt
       areaint(k)=  areaint(k)/sum*float(jt)
     end do
    deallocate(mapsc)    
    return
  end subroutine areascan
  
   SUBROUTINE INDEX(N,RRIN,INDX)
      implicit none
      integer N,J,L,I,IR,INDXT
      integer,DIMENSION(N):: INDX 
      real,DIMENSION(N):: RRIN
      real    Q
      DO  J=1,N 
        INDX(J)=J 
      END DO 
      L=N/2+1 
      IR=N 
   10 CONTINUE 
        IF(L.GT.1)THEN 
          L=L-1 
          INDXT=INDX(L) 
          Q=RRIN(INDXT) 
        ELSE 
          INDXT=INDX(IR) 
          Q=RRIN(INDXT) 
          INDX(IR)=INDX(1) 
          IR=IR-1 
          IF(IR.EQ.1)THEN 
            INDX(1)=INDXT 
            RETURN 
          ENDIF 
        ENDIF 
        I=L 
        J=L+L 
   20   IF(J.LE.IR)THEN 
          IF(J.LT.IR)THEN 
            IF(RRIN(INDX(J)).LT.RRIN(INDX(J+1)))J=J+1 
          ENDIF 
          IF(Q.LT.RRIN(INDX(J)))THEN 
            INDX(I)=INDX(J) 
            I=J 
            J=J+J 
          ELSE 
            J=IR+1 
          ENDIF 
        GO TO 20 
        ENDIF 
        INDX(I)=INDXT 
      GO TO 10 
      END                                       

   subroutine cosort(ndim,cosa,a_r,jdim)
  integer, intent(in):: ndim 
  real, dimension(ndim), intent(inout):: cosa,a_r
  integer,  intent(out):: jdim 
  integer,DIMENSION(ndim):: INDX
  integer,DIMENSION(0:ndim):: nvb
  !real,DIMENSION(ndim):: ecosa
  integer,DIMENSION(ndim):: icosa
  real,   dimension(ndim):: h_r
!  real sum

     icosa=int(cosa*10000.0)
!     ecosa=float(int(cosa*1000.0))/1000.0
     call INDEXi(ndim,icosa,INDX)
!    call INDEX(ndim,ecosa,INDX)
     j=1; i=1
     do while(i.lt.ndim)
        k=i
        do while(icosa(INDX(k)).eq.icosa(INDX(k+1)))
           k=k+1
           if(k.eq.ndim) goto 10
        end do
 10       i=k+1; nvb(j)=k; j=j+1
     end do
     jdim=j; nvb(0)=0; nvb(j)=ndim

     do k=1,jdim       
      h_r(k)=cosa(INDX(nvb(k)))
     end do
     do k=1,jdim       
      cosa(k)=h_r(k)
     end do   

     do k=0,j-1
     h=0
     do i=nvb(k)+1, nvb(k+1)
       h=h+a_r(INDX(i))
     end do
     h_r(k+1)=h
    end do
    do k=1,jdim       
     a_r(k)=h_r(k)
    end do
    return
  end subroutine cosort

   subroutine cosort1(ndim,cosa,a_r,jdim)
  integer, intent(in):: ndim 
  real, dimension(ndim), intent(inout):: cosa,a_r
  integer,  intent(out):: jdim 
  integer,DIMENSION(ndim):: INDX
  integer,DIMENSION(0:ndim):: nvb
  !real,DIMENSION(ndim):: ecosa
  integer,DIMENSION(ndim):: icosa
  real,   dimension(ndim):: h_r
  real sum

     icosa=int(cosa*10000.0)
!     ecosa=float(int(cosa*1000.0))/1000.0
     call INDEXi(ndim,icosa,INDX)
!    call INDEX(ndim,ecosa,INDX)
     j=1; i=1
     do while(i.lt.ndim)
        k=i
        do while(icosa(INDX(k)).eq.icosa(INDX(k+1)))
           k=k+1
           if(k.eq.ndim) goto 10
        end do
 10       i=k+1; nvb(j)=k; j=j+1
     end do
     jdim=j; nvb(0)=0; nvb(j)=ndim
     
     print'(5i6)',(icosa(INDX(i)),i=1,ndim)
     print*,'INDX'
     print'(15i4)',(INDX(i),i=1,ndim)
     print*,'nvb'
     print'(15i4)',(nvb(i),i=1,jdim)
     
     do k=1,jdim       
      h_r(k)=cosa(INDX(nvb(k)))
     end do
     do k=1,jdim       
      cosa(k)=h_r(k)
     end do   
     print*,'a_r'
     print'(5f10.4)',(a_r(INDX(i)),i=1,ndim)
sum=0.     
     do k=1,ndim       
     sum=sum+a_r(k)
  end do
     print*,'a_r',sum
     print'(5f10.4)',(a_r(INDX(i)),i=1,ndim)  
     do k=0,j-1
     h=0
     do i=nvb(k)+1, nvb(k+1)
       h=h+a_r(INDX(i))
     end do
     h_r(k+1)=h
    end do
    do k=1,jdim       
     a_r(k)=h_r(k)
  end do
sum=0.     
     do k=1,jdim       
     sum=sum+a_r(k)
  end do  
     print*,'a_r',sum
     print'(5f10.4)',(a_r(i),i=1,jdim)
    return
  end subroutine cosort1

  
subroutine cosmset(enpr,nomsamp,iring,igeo,Dabsorber,sc2absorber,Daperture, &
           sc2aperture,A_aperture,B_aperture,Dtube,alpha,Dsource,geo,phicone,&
           b_ring1to7,b_Dsource,b_Daperture,info)
      use glbconst, only: infotext
      use comdat, only: msdpt  
      use comthe, only: real_fr
      implicit none

     integer,             intent(in) :: nomsamp
     real,                intent(in) :: alpha,Dsource,Dabsorber,Daperture, &
                                        sc2absorber,sc2aperture,           &
                                        A_aperture,B_aperture,Dtube,geo,phicone
     logical,              intent(in):: b_ring1to7,b_Dsource,b_Daperture
     integer,              intent(in):: iring
     integer,             intent(out):: igeo,info
     character(len=4) , intent(inout):: enpr



    real, dimension(132):: filearr
    real, dimension(127):: soint,doint
    real, dimension(:), allocatable :: cosa,a_r,phia
     
     character(len=132):: scdtdir    

     real    Apt,Spt,Dpt,BdA
     integer k,ndim,jdim,ipnt
     logical b_so,b_dt,b_file
     
     !  ipnt=msdpt+521  already calculated =1 : jdim,scosa(jdim),sa_r(jdim) 
      if(allocated(cosa))deallocate(cosa,a_r)      

      b_so=int(real_fr(msdpt+1)).eq.1;  b_dt=int(real_fr(msdpt+2)).eq.1
      b_file=b_so.or.b_dt
      call geometryDIM(enpr,nomsamp,iring,Dabsorber,sc2absorber, &
            Daperture,sc2aperture,A_aperture,B_aperture,Dtube,&
            alpha,Dsource,geo,b_file,igeo,Apt,Spt,Dpt,BdA,ndim)
      jdim=ndim
      if(enpr.eq.'<><>')then
       info=1
       infotext(1)='<Mossbauer_spectrum>/s-a-d_geometry'
       infotext(2)='**error** wrong geometry '
       infotext(3)=' '
       return
      end if
      
      ipnt=msdpt+2
      do k=1,132
       filearr(k)=real_fr(ipnt+k)
      end do
      call  realnum2filen(filearr,scdtdir)

!     details of sourceand/or detector area are known : area scan-files
      if(b_so) then
       ipnt=msdpt+2
       do k=1,132
        filearr(k)=real_fr(ipnt+k)
       end do
       call  realnum2filen(filearr,scdtdir)
       ipnt=msdpt+266
       if(b_ring1to7.or.b_Dsource)then
        call areascan(scdtdir,iring,Dsource*5.0,soint)
                          ! Rsource[mm]=Dsource[cm]*5.0
        do k=1,127
         real_fr(ipnt+k)=soint(k)
        end do
       else
        do  k=1,127
         soint(k)=real_fr(ipnt+k)
        end do
       end if 
      else
       soint=1.0
      end if

      if(b_dt) then
       ipnt=msdpt+134
       do k=1,132
        filearr(k)=real_fr(ipnt+k)
       end do
       call  realnum2filen(filearr,scdtdir)
       ipnt=msdpt+393 ! 266+127
       if(b_ring1to7.or.b_Daperture)then
        call areascan(scdtdir,iring,Daperture*5.0,doint)
                               ! Rdetector[mm]=Ddetector[cm]*5.0
        do k=1,127
         real_fr(ipnt+k)=doint(k)
        end do
       else
        do k=1,127
         doint(k)=real_fr(ipnt+k)
        end do
       end if 
      else
       doint=1.0
      end if
      allocate(phia(ndim),cosa(ndim),a_r(ndim))
      call geometry(igeo,nomsamp,iring,phicone,alpha,Apt,Spt,Dpt,BdA, &
                     soint,doint,ndim,phia,cosa,a_r)
      if(igeo.lt.20) call cosort(ndim,cosa,a_r,jdim)
      ! scosa,sa_r become a selection of the output of geometry(,,,scosa,sa_r)
       ipnt=msdpt+522     ! 520=2+2*(127+132), 521, 522,  522-2372
       real_fr(ipnt)=float(jdim)+0.001 
       if (jdim.gt.925) then
          print'(a,i4,a)',' number of cos-values ',jdim,' > storage : 926'
          info=1
          return
       end if
       do k=1,jdim
        real_fr(ipnt+k)=cosa(k)
       end do
       ipnt=ipnt+jdim
       do k=1,jdim
        real_fr(ipnt+k)=a_r(k)
       end do
       deallocate(phia,cosa,a_r)

     return

   end subroutine cosmset
   
