    subroutine hintJgJeRELAX2(itr,icase,r_QUDI,amueg,amuee,QgdQe,cTms,je,jg,jge,  &
                     shift12,pop1,fsx1,fsx2,rate,hv1,efg1,hv2,efg2,Eagd,VV)
!     ------------------------half integral spin----------------       
!   Relaxation between 2 states  (ks=2)
!   hint: half integral spin : 2*j+1 => j+1

    implicit none 
    integer, parameter:: ks=2
    integer, intent(in):: itr,icase,jg,je,jge
    real,    intent(in):: r_QUDI,amueg,amuee,QgdQe,cTms,shift12,pop1,fsx1,fsx2,rate
    complex, intent(in):: hv1(-1:1),efg1(-2:2),hv2(-1:1),efg2(-2:2)

    complex, intent(out):: Eagd(jge*ks)
    complex, intent(out):: VV(-1:1,-1:1,jge*ks)
    complex, dimension(-1:1,-1:1,jge*ks):: V2
    complex, dimension(-2:2,jge*ks):: V2D

    real,    dimension(-je:je,-1:1,-jg:jg):: Vje_1_jg              
    real,    dimension(-je:je,-2:2,-jg:jg):: Vje_2_jg 
    real,    dimension(-jg:jg):: wpjg
    real,    dimension(-je:je):: wpje
    complex, dimension(-1:1):: hv
    complex, dimension(-2:2):: efgm

                                                                
    real(kind=8):: DOUT
    complex(kind=8),dimension(jge,jge,ks):: HXs
    complex(kind=8),dimension(jge*ks,jge*ks):: VL,VR,HXab !,AA,BB,CC
    complex, dimension(je+1,je+1) :: hame
    complex, dimension(jg+1,jg+1) :: hamg
    complex, dimension(jge,jge,jge*ks) :: RLab
!   unit matrices (Kronecker symbol)
    real, dimension(je+1,je+1):: dee
    real, dimension(jg+1,jg+1):: dgg
    real, dimension(ks,ks)    :: dab
    real, dimension(ks)       :: pop
!   wab calculated from pop1 and w12 (wab is added to a complex matrix)
    complex, dimension(ks,ks):: wab
!   indices transformations
    integer, dimension(je+1,jg+1):: iq
    integer, dimension(je+1,jg+1,ks):: iab

    complex  :: C20,C2m1,C2m2,H10,H1m1,h1c,v1mj,v2mj 
    real     :: Qjg,Qje,sq2,sq3d8,hmag,h,hi2im1,q20,q21,q22,delta2,r_delta2
    integer  i,k,kn,l,m,n,j,jm,me,mg,nrot,M1,M2,ji,ml,nstate,iqmj,iabmjn
    complex, parameter:: C0=cmplx(0.,0.), Ci=cmplx(0.,1.)

    complex, dimension(:,:), allocatable :: hm  
    jm=je
    if(jg.gt.jm) jm=jg
    allocate(hm(-jm:jm,-jm:jm))

    dOUT=10000.d1
    pop(1)=pop1; pop(2)=1.-pop1
    if(pop1.ge.1.0)then
     wab=0.
    else
!    w12=t_rate*pop2; w21=t_rate*pop1;  t_rate=w12+w21 => pop1*w12=pop2*w21
     wab(1,2)=cmplx(0.,rate*pop(2)); wab(2,1)=cmplx(0.,rate*pop(1))
     wab(1,1)=-wab(1,2);  wab(2,2)=-wab(2,1)
    end if
     
!   intensity of site i is multiplied by the Lamb-Mossbauer factor fsxi of site i
!   fxx of the crystal is the same for both sites    
    pop(1)=pop(1)*fsx1;    pop(2)=pop(2)*fsx2;

!      write(6,'(a,6f10.2,/,a,10f8.2)')'  hv=',hv,'efgm=',efgm         
!      magnetic energy                                                  
!      E(B)= - mue*(Bx*Ix+By*Iy+Bz*Iz)/I                                
!              (largest moment is mue - not mue*I(=3/2)-)               
!          = - mue*(Bz*Iz-B(+1)/sq2*I(-) + B(-1)/sq2*I(+))/I            
!      electric energy                                                  
!      E(Vik)= 3/4 eQ /I(2I-1) * Sum;ik Vik*Ii*Ik                       
!              Sum;k q2k*C2-k*(-1)**k                                   
!                                                                       
!      Abragam and Bleaney chapter 17 ,p. 680                           
!              q20=eQ/I(2I-1)*1/2*(3*Iz*Iz-I(I+1))                      
!              q21=-eQ/I(2I-1)*(Iz*(I+) + (I+)*Iz)sqrt(3/8)             
!             q2-1= eQ/I(2I-1)*(Iz*(I-) + (I-)*Iz)sqrt(3/8)             
!              q22= eQ/I(2I-1)*(I+)**2*sqrt(3/8)                        
!             q2-2= eQ/I(2I-1)*(I-)**2*sqrt(3/8)                        
!              C20= 1/2*Vzz                                             
!              C21=-2/3*(Vxz+iVyz)*sqrt(3/8)                            
!             C2-1= 2/3*(Vxz-iVyz)*sqrt(3/8)                            
!              C22= (Vxx-Vyy+2iVxy)*sqrt(3/8)/3                         
!             C2-2= (Vxx-Vyy-2iVxy)*sqrt(3/8)/3                         
!     the potential V= -e/|r-R| of a negative charge -e ( e=|e|)        
                                                                        
!     exited state                                                      
      call symbol3j(.false.,je,jg,Vje_1_jg,Vje_2_jg,wpje,wpjg) 

      sq3d8=sqrt(3./8.) 
      sq2=sqrt(2.) 
      if(QgdQe.gt.9999)then 
        Qjg=1. 
        Qje=0. 
      else 
        Qjg=QgdQe 
        Qje=1. 
      end if 

      dab=0.
      do j=1,2
       dab(j,j)=1.
      end do

      dgg=0.
      do j=1,jg+1
       dgg(j,j)=1.
      end do

      dee=0.
      do j=1,je+1
       dee(j,j)=1.
      end do

     m=0
      do i=1,jg+1
       do l=1,je+1
        m=m+1
        iq(l,i)=m
       end do
      end do

      m=0
     do k=1,2
      do i=1,jg+1
       do l=1,je+1
        m=m+1
        iab(l,i,k)=m
       end do
      end do
     end do

     nstate=0
 1111 continue
      nstate=nstate+1
      if(nstate.eq.1) then
       hv=hv1; efgm=efg1
      else if(nstate.eq.2) then
       hv=hv2; efgm=efg2
      end if

       j=je 
       hm=C0                                                                
                                                                        
       hmag=amuee/float(j)/cTms 
       H10=-hmag*hv(0) 
       H1m1=-hmag*hv(-1) 
                                                                        
       if(j.gt.1) then 
        hI2IM1=float(j*(2*j-2))/4. 
        C20=efgm(0)/hI2IM1*Qje 
        C2m1=efgm(-1)/hI2IM1*Qje 
        C2m2=efgm(-2)/hI2IM1*Qje 
        h=float(j*(j+2)) 
        do m=-j,j,2 
         q20=(float(3*m**2)-h)/8. 
         hm(m,m)= C20*q20 + m*H10 
        end do 
                                                                        
        do m=j-2,-j,-2              !  m+1= (m+2 + m)/2 
         q21=-float(m+1)*wpje(m)*sq3d8 
         hm(m+2,m)= -C2m1*q21 + H1m1*wpje(m)*sq2 
        end do 
       else 
         hm(1,1)= H10 
         hm(-1,-1)= -H10 
         hm(1,-1)=H1m1*sq2 
       end if 
                                                                        
       if(j.ge.2) then 
        do m=j-4,-j,-2 
         q22=wpje(m+2)*wpje(m)*sq3d8 
         hm(m+4,m)= C2m2*q22 
        end do 
       end if 

       do m=-j,j,2
        do n=m+2,j,2
         hm(m,n)=conjg(hm(n,m))
        end do            
       end do
       do m=1,j+1
        do n=1,j+1
         hame(m,n)=hm(-j-2+2*n,-j-2+2*m)
        end do            
       end do            
!      do m=1,je+1                                                      
!       write(6,'(8g12.4)') (ham(m,n,nstate),n=1,je+1)
!      end do 
      
!      ground state
       j=jg
       hm=C0 
                                                                      
       hmag=amueg/float(j)/cTms 
       H10=-hmag*hv(0) 
       H1m1=-hmag*hv(-1) 
                                                                      
       if(j.gt.1) then 
        hI2IM1=float(j*(j-1))/2. 
        C20=efgm(0)/hI2IM1*Qjg 
        C2m1=efgm(-1)/hI2IM1*Qjg 
        C2m2=efgm(-2)/hI2IM1*Qjg 
        h=float(j*(j+2)) 
        do m=-j,j,2 
         q20=(float(3*m**2)-h)/8. 
         hm(m,m)= C20*q20 + m*H10 
        end do 
                                                                      
        do m=j-2,-j,-2         !  m+1= (m+2 + m)/2     
         q21=-float(m+1)*wpjg(m)*sq3d8 
         hm(m+2,m)= -C2m1*q21 + H1m1*wpjg(m)*sq2 
        end do 
       else 
         hm(1,1)= H10 
         hm(-1,-1)= -H10 
         hm(1,-1)=H1m1*sq2 
       end if 
                                                                      
       if(j.ge.2) then 
         do m=j-4,-j,-2 
          q22=wpjg(m+2)*wpjg(m)*sq3d8 
          hm(m+4,m)= C2m2*q22 
         end do 
       end if 

       do m=-j,j,2
        do n=m+2,j,2
         hm(m,n)=conjg(hm(n,m))
        end do            
       end do 
!      do m=-j,j,2                                                      
!       write(6,'(8g12.4)') (hm(m,n),n=-j,j,2)
!      end do 
       do m=1,j+1
        do n=1,j+1
         hamg(m,n)=hm(-j-2+2*n,-j-2+2*m)
        end do            
       end do           

!      direct product of heij x hgij       -------------------------------------
!       (hg(ij)*)*dee(lm) -he(lm)*dgg(ij)      ijlm -> pq [p,q=1,...,(je+1)*(jg+1)] 
!       iq(l,i)=1,2,...,
!      the -conjg  of the superoperator HX is calculated

       do i=1,jg+1
        do j=1,jg+1
         do l=1,je+1
          do m=1,je+1
             HXs(iq(l,i),iq(m,j),nstate)= &
                      -hamg(i,j)*dee(l,m) +conjg(hame(l,m))*dgg(i,j)
          end do
         end do
        end do
       end do
      
      if(nstate.eq.1) then
!      shift12 added to state number nstate=1
       do i=1,jge
        HXs(i,i,1)= HXs(i,i,1)+shift12
       end do
       goto 1111
      end if

     do k=1,ks
      do n=1,ks     
       do i=1,jg+1
        do j=1,jg+1
         do l=1,je+1
          do m=1,je+1
           HXab(iab(l,i,k),iab(m,j,n))=HXs(iq(l,i),iq(m,j),k)*dab(k,n)+  &
                                       wab(k,n)*dgg(i,j)*dee(l,m)
          end do
         end do
        end do
       end do
      end do
     end do

!     print*,'aimag HXab'
!     do k=1,2
!      do l=1,je+1
!      do i=1,jg+1
!print'(16f8.2)',(((aimag(HXab(iab(l,i,k),iab(ml,ji,n))),ji=1,jg+1),ml=1,je+1),n=1,2)
!      end do
!      end do
!     end do
!     AA=HXab
!print*,'AA'
!print'(2f10.3,4x,2f10.3)', AA(3,3), AA(3,11)
!print'(2f10.3,4x,2f10.3)', AA(11,3),AA(11,11)
!print*,'AA2'
!print'(2f10.3,4x,2f10.3)', AA(6,6), AA(6,14)
!print'(2f10.3,4x,2f10.3)', AA(14,6),AA(14,14)     
       call jacCmplx16(jge*ks,DOUT,HXab,VL,VR,nrot) 
       do i=1,jge*ks 
          Eagd(i)=HXab(i,i)
       end do 

       
!BB=matmul(VL,AA); CC=matmul(BB,VR)
!print*,'CC'
!print'(2f10.3,4x,2f10.3)', CC(3,3), CC(3,11)
!print'(2f10.3,4x,2f10.3)', CC(11,3),CC(11,11)
!print*,'CC2'
!print'(2f10.3,4x,2f10.3)', CC(6,6), CC(6,14)
!print'(2f10.3,4x,2f10.3)', CC(14,6),CC(14,14)
!print*,'VL'
!print'(2f10.3,4x,2f10.3)', VL(3,3), VL(3,11)
!print'(2f10.3,4x,2f10.3)', VL(11,3),VL(11,11)
!print*,'VR'
!print'(2f10.3,4x,2f10.3)', VR(3,3), VR(3,11)
!print'(2f10.3,4x,2f10.3)', VR(11,3),VR(11,11)

    do m=1,je+1
    do j=1,jg+1
    do n=1,ks
     iabmjn=iab(m,j,n)

     do ml=1,je+1
     do ji=1,jg+1
      iqmj=iq(ml,ji)
      do l=1,je+1
      do i=1,jg+1

!      sum over alpha,beta
       h1c=C0
       do k=1,ks
       do kn=1,ks     
        h1c=h1c+pop(k)*VR(iab(l,i,k),iabmjn)*VL(iabmjn,iab(ml,ji,kn))
       end do
       end do
       RLab(iq(l,i),iqmj,iabmjn)=h1c*Ci
      end do
      end do
     end do
     end do
    end do
    end do
    end do


    VV=C0
    me=je+2; mg=jg+2
    if(itr.eq.1) then
     ! dipole transition 
      do M1=-1,1,2
      do M2=-1,1,2

       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je+1
         do ji=1,jg+1
          v1mj=Vje_1_jg(2*ml-me,M2,2*ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je+1
          do i=1,jg+1
           h1c=h1c+Vje_1_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
          end do
          end do
         end do
         end do
          VV(M1,M2,iabmjn)=h1c
       end do
       end do
       end do

      end do
      end do

      !     for calculation of the ideal powder spectrum: VV(M,M,iabmjn)
     if(icase.eq.2) then
       M1=0
       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je+1
         do ji=1,jg+1
          v1mj=Vje_1_jg(2*ml-me,M1,2*ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je+1
          do i=1,jg+1
           h1c=h1c+Vje_1_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
          end do
          end do
         end do
         end do
         VV(M1,M1,iabmjn)=h1c
       end do
       end do
       end do
    
       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         VV(0,0,iabmjn)=(VV(-1,-1,iabmjn)+VV(0,0,iabmjn)+VV(1,1,iabmjn))/3.
       end do
       end do
      end do
      end if
    else if(itr.eq.3) then

     ! quadrupole transition 
      do M1=-1,1,2
      do M2=-1,1,2

       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je+1
         do ji=1,jg+1
          v2mj=Vje_2_jg(2*ml-me,M2,2*ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je+1
          do i=1,jg+1
           h1c=h1c+Vje_2_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
          end do
          end do
         end do
         end do
          VV(M1,M2,iab(m,j,n))=h1c
       end do
       end do
       end do

      end do
      end do

!     for calculation of the ideal powder spectrum
     if(icase.eq.2) then
      do M1=-2,2,2
       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je+1
         do ji=1,jg+1
          v2mj=Vje_2_jg(2*ml-me,M1,2*ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je+1
          do i=1,jg+1
           h1c=h1c+Vje_2_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
          end do
          end do
         end do
         end do
          V2D(M1,iabmjn)=h1c
       end do
       end do
       end do
      end do

      do m=1,je+1
      do j=1,jg+1
      do n=1,ks
        iabmjn=iab(m,j,n)
        VV(0,0,iabmjn)=(V2D(2,iabmjn)+VV(1,1,iabmjn)+V2D(0,iabmjn)+ &
                        VV(-1,-1,iabmjn)+V2D(-2,iabmjn))/5.
      end do
      end do
      end do
     end if
    else if(itr.eq.2) then
     ! mixed  dipole quadrupole transition 
     delta2=r_QUDI**2 
     r_delta2=1./(1.+delta2) 

     ! dipol part 
     do M1=-1,1,2
      do M2=-1,1,2

       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je+1
         do ji=1,jg+1
          v1mj=Vje_1_jg(2*ml-me,M2,2*ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je+1
          do i=1,jg+1
           h1c=h1c+Vje_1_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
          end do
          end do
         end do
         end do
         VV(M1,M2,iab(m,j,n))=h1c
       end do
       end do
       end do

     end do
     end do

     ! quadrupole part 
      do M1=-1,1,2
      do M2=-1,1,2

       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je+1
         do ji=1,jg+1
          v2mj=Vje_2_jg(2*ml-me,M2,2*ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je+1
          do i=1,jg+1
           h1c=h1c+Vje_2_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
          end do
          end do
         end do
         end do
         V2(M1,M2,iab(m,j,n))=h1c
       end do
       end do
       end do

      end do
      end do
     
     !mixed part

     do M1=-1,1,2
     do M2=-1,1,2

      do m=1,je+1
      do j=1,jg+1
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je+1
        do ji=1,jg+1
         v2mj=Vje_2_jg(2*ml-me,M2,2*ji-mg)  
         v1mj=Vje_1_jg(2*ml-me,M2,2*ji-mg)  
         do l=1,je+1
         do i=1,jg+1
          h1c=h1c+M1*Vje_2_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj+&
                  M2*Vje_1_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
         end do
         end do
        end do
        end do
        VV(M1,M2,iab(m,j,n))=r_delta2*(VV(M1,M2,iab(m,j,n))+    &
                              delta2*M1*M2*V2(M1,M2,iab(m,j,n))-h1c*r_QUDI)
      end do
      end do
      end do
     end do
     end do
     
!     for calculation of the ideal powder spectrum
    if(icase.eq.2) then
     !dipole part
       do M1=-1,1
      do m=1,je+1
      do j=1,jg+1
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je+1
        do ji=1,jg+1
         v1mj=Vje_1_jg(2*ml-me,M1,2*ji-mg)
         iqmj=iq(ml,ji)           
         do l=1,je+1
         do i=1,jg+1
          h1c=h1c+Vje_1_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
         end do
         end do
        end do
        end do
        VV(M1,M1,iabmjn)=h1c
      end do
      end do
      end do
     end do

     !quadrupole  part
     do M2=-2,2
      do m=1,je+1
      do j=1,jg+1
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je+1
        do ji=1,jg+1
         v2mj=Vje_2_jg(2*ml-me,M2,2*ji-mg)
         iqmj=iq(ml,ji)           
         do l=1,je+1
         do i=1,jg+1
          h1c=h1c+Vje_2_jg(2*l-me,M2,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
         end do
         end do
        end do
        end do
        V2D(M2,iabmjn)=h1c
      end do
      end do
      end do
     end do

    if(delta2.ne.0.) then
     do m=1,je+1
      do j=1,jg+1
      do n=1,ks
       iabmjn=iab(m,j,n)
       VV(0,0,iabmjn)=r_delta2*((VV(-1,-1,iabmjn)+VV(0,0,iabmjn)+VV(1,1,iabmjn))/3+&
                        delta2*(V2D(-2,iabmjn)+V2D(-1,iabmjn)+V2D(0,iabmjn)+ &
                                 V2D(1,iabmjn)+V2D(2,iabmjn))/5.)

      end do
      end do
     end do
    else
      do m=1,je+1
      do j=1,jg+1
      do n=1,ks
       iabmjn=iab(m,j,n)
       VV(0,0,iabmjn)=(VV(-1,-1,iabmjn)+VV(0,0,iabmjn)+VV(1,1,iabmjn))/3.
      end do
      end do
      end do
     end if
   
     end if
    end if

   return 
   END subroutine hintJgJeRELAX2
                                                                        

   subroutine intJgJeRELAX2(itr,icase,r_QUDI,amueg,amuee,QgdQe,cTms,je,jg,jge,  &
                     shift12,pop1,fsx1,fsx2,w12,hv1,efg1,hv2,efg2,Eagd,VV)
!      ---------------integral spin -----------------------------       
     implicit none 
     integer, parameter:: ks=2             ! 2 states
     integer, intent(in):: itr,icase,jg,je,jge
     real,    intent(in):: r_QUDI,amueg,amuee,QgdQe,cTms,shift12,pop1,fsx1,fsx2,w12
     complex, intent(in):: hv1(-1:1),efg1(-2:2),hv2(-1:1),efg2(-2:2)

     complex, intent(out):: Eagd(jge*ks)
     complex, intent(out):: VV(-1:1,-1:1,jge*ks)
     complex, dimension(-1:1,-1:1,jge*ks):: V2
     complex, dimension(-2:2,jge*ks):: V2D

     real,    dimension(-je:je,-1:1,-jg:jg):: Vje_1_jg              
     real,    dimension(-je:je,-2:2,-jg:jg):: Vje_2_jg 
     real,    dimension(-jg:jg):: wpjg
     real,    dimension(-je:je):: wpje
     complex, dimension(-1:1):: hv
     complex, dimension(-2:2):: efgm
                                                                 

    real(kind=8):: DOUT
    complex(kind=8),dimension(jge,jge,ks):: HXs
    complex(kind=8),dimension(jge*ks,jge*ks):: VL,VR,HXab
    real, dimension(2*je+1,2*je+1):: dee
    real, dimension(2*jg+1,2*jg+1):: dgg
    real, dimension(ks,ks)    :: dab
    real, dimension(ks)       :: pop
    complex, dimension(ks,ks):: wab
    complex, dimension(2*je+1,2*je+1) :: hame
    complex, dimension(2*jg+1,2*jg+1) :: hamg
    complex, dimension(jge,jge,jge*ks) :: RLab
    integer, dimension(2*je+1,2*jg+1):: iq
    integer, dimension(2*je+1,2*jg+1,ks):: iab

    integer  i,k,kn,l,m,n,j,jm,me,mg,nrot,M1,M2,ji,ml,nstate,   &
             je2,jg2,iabmjn,iqmj
    complex  :: C20,C2m1,C2m2,H10,H1m1,h1c,v1mj,v2mj 
    real     :: Qjg,Qje,sq2,sq3d8,hmag,h,hi2im1,q20,q21,q22,delta2,r_delta2 
    complex, parameter:: C0=cmplx(0.,0.)

    complex, dimension(:,:), allocatable :: hm  
    jm=je
    if(jg.gt.jm) jm=jg
    allocate(hm(-jm:jm,-jm:jm))
    jg2=2*jg+1; je2=2*je+1

    dOUT=10000.d1
    pop(1)=pop1; pop(2)=1.-pop1
    wab(1,1)=cmplx(0.,-w12);             wab(1,2)=-wab(1,1)
    if(pop1.ge.1.0)then
     wab=0.
    else
     wab(2,1)=cmplx(0.,w12*pop1/pop(2));  wab(2,2)=-wab(2,1)
    end if
!   intensity of site i is multiplied by the Lamb-Mossbauer factor fsxi of site i
!   fxx of the crystal is the same for both sites    
    pop(1)=pop(1)*fsx1;    pop(2)=pop(2)*fsx2;

!      write(6,'(a,6f10.2,/,a,10f8.2)')'  hv=',hv,'efgm=',efgm         
!      magnetic energy                                                  
!      E(B)= - mue*(Bx*Ix+By*Iy+Bz*Iz)/I                                
!              (largest moment is mue - not mue*I(=3/2)-)               
!          = - mue*(Bz*Iz-B(+1)/sq2*I(-) + B(-1)/sq2*I(+))/I            
!      electric energy                                                  
!      E(Vik)= 3/4 eQ /I(2I-1) * Sum;ik Vik*Ii*Ik                       
!              Sum;k q2k*C2-k*(-1)**k                                   
!                                                                       
!      Abragam and Bleaney chapter 17 ,p. 680                           
!              q20=eQ/I(2I-1)*1/2*(3*Iz*Iz-I(I+1))                      
!              q21=-eQ/I(2I-1)*(Iz*(I+) + (I+)*Iz)sqrt(3/8)             
!             q2-1= eQ/I(2I-1)*(Iz*(I-) + (I-)*Iz)sqrt(3/8)             
!              q22= eQ/I(2I-1)*(I+)**2*sqrt(3/8)                        
!             q2-2= eQ/I(2I-1)*(I-)**2*sqrt(3/8)                        
!              C20= 1/2*Vzz                                             
!              C21=-2/3*(Vxz+iVyz)*sqrt(3/8)                            
!             C2-1= 2/3*(Vxz-iVyz)*sqrt(3/8)                            
!              C22= (Vxx-Vyy+2iVxy)*sqrt(3/8)/3                         
!             C2-2= (Vxx-Vyy-2iVxy)*sqrt(3/8)/3                         
!     the potential V= -e/|r-R| of a negative charge -e ( e=|e|)        
                                                                        
!     exited state                                                      
      call symbol3j(.true.,je,jg,Vje_1_jg,Vje_2_jg,wpje,wpjg) 

      sq3d8=sqrt(3./8.) 
      sq2=sqrt(2.) 
      if(QgdQe.gt.9999)then 
        Qjg=1. 
        Qje=0. 
      else 
        Qjg=QgdQe 
        Qje=1. 
      end if 

      dab=0.
      do j=1,ks
       dab(j,j)=1.
      end do
 
      dgg=0.
      do j=1,jg2
       dgg(j,j)=1.
      end do

      dee=0.
      do j=1,je2
       dee(j,j)=1.
      end do

      m=0
      do i=1,jg2
       do l=1,je2
        m=m+1
        iq(l,i)=m
       end do
      end do

     m=0
     do k=1,2
      do i=1,jg2
       do l=1,je2
        m=m+1
        iab(l,i,k)=m
       end do
      end do
     end do
     
!  exited state
      nstate=0
  1111 continue
      nstate=nstate+1
      if(nstate.eq.1) then
       hv=hv1; efgm=efg1
      else if(nstate.eq.2) then
       hv=hv2; efgm=efg2
      end if
      
      j=je 
      hm=C0
      if(j.eq.0) goto 10 
                                                                        
       hmag=amuee/float(j)/cTms 
       H10=-hmag*hv(0) 
       H1m1=-hmag*hv(-1) 
                                                                        
       hI2IM1=float(j*(2*j-1)) 
       C20=efgm(0)/hI2IM1*Qje 
       C2m1=efgm(-1)/hI2IM1*Qje 
       C2m2=efgm(-2)/hI2IM1*Qje 
       h=float(j*(j+1)) 
       do m=-j,j,1 
        q20=(float(3*m**2)-h)/2. 
        hm(m,m)= C20*q20 + m*H10 
       end do 
                                                                       
       do m=j-1,-j,-1 
        q21=-float(2*m+1)*wpje(m)*sq3d8        !  m+1+m =< m+1   
        hm(m+1,m)= -C2m1*q21 + H1m1*wpje(m)/sq2 
       end do 
                                                                        
       if(j.ge.2) then 
        do m=j-2,-j,-1 
         q22=wpje(m+1)*wpje(m)*sq3d8 
         hm(m+2,m)= C2m2*q22 
        end do 
        end if 
        do m=-j,j,1
         do n=m+1,j,1
          hm(m,n)=conjg(hm(n,m))
         end do            
        end do 
        do m=1,2*j+1
         do n=1,2*j+1
          hame(m,n)=hm(-j-1+n,-j-1+m)
         end do            
        end do                           
   10  continue 
!      groundstate                                                      
       j=jg 
       if(j.eq.0) goto 20 
       hm=C0
                                                                      
       hmag=amueg/float(j)/cTms 
       H10=-hmag*hv(0) 
       H1m1=-hmag*hv(-1) 
                                                                      
        hI2IM1=float(j*(2*j-1)) 
        C20=efgm(0)/hI2IM1*Qjg 
        C2m1=efgm(-1)/hI2IM1*Qjg 
        C2m2=efgm(-2)/hI2IM1*Qjg 
        h=float(j*(j+1)) 
        do m=-j,j,2 
         q20=(float(3*m**2)-h)/2. 
         hm(m,m)= C20*q20 + m*H10 
        end do 
                                                                      
        do m=j-1,-j,-1 
                                                !  m+1= (m+2 + m)/2   
         q21=-float(2*m+1)*wpjg(m)*sq3d8 
         hm(m+1,m)= -C2m1*q21 + H1m1*wpjg(m)/sq2 
        end do 
                                                                      
        if(j.ge.2) then 
         do m=j-2,-j,-1 
          q22=wpjg(m+1)*wpjg(m)*sq3d8 
          hm(m+2,m)= C2m2*q22 
         end do 
        end if 
        do m=-j,j,1
         do n=m+1,j,1
          hm(m,n)=conjg(hm(n,m))
         end do            
        end do       
        do m=1,2*j+1
         do n=1,2*j+1
          hamg(m,n)=hm(-j-1+n,-j-1+m)
         end do            
        end do           
   20  continue 

!      direct product of heij x hgij       -------------------------------------
!       (hg(ij)*)*dee(lm) -he(lm)*dgg(ij)      ijlm -> pq [p,q=1,...,(je+1)*(jg+1)] 
!       iq(l,i)=1,2,...,
!      the -conjg  of the superoperator HX is calculated

       do i=1,jg2
        do j=1,jg2
         do l=1,je2
          do m=1,je2
           HXs(iq(l,i),iq(m,j),nstate)= -hamg(i,j)*dee(l,m) +conjg(hame(l,m))*dgg(i,j)
          end do
         end do
        end do
       end do
      
      if(nstate.eq.1) then
!      shift12 added to state number nstate=1
       do i=1,jge
        HXs(i,i,1)= HXs(i,i,1)+shift12
       end do
       goto 1111
      end if

      do k=1,ks
      do n=1,ks     
       do i=1,jg2
       do j=1,jg2
        do l=1,je2
        do m=1,je2
         HXab(iab(l,i,k),iab(m,j,n))=HXs(iq(l,i),iq(m,j),k)*dab(k,n)+  &
                                       wab(k,n)*dgg(i,j)*dee(l,m)
        end do
        end do
       end do
       end do
      end do
      end do

!     print*,'HXab'
!     do k=1,2
!      do l=1,je+1
!      do i=1,jg+1
!print'(16f8.2)',(((real(HXab(iab(l,i,k),iab(ml,ji,n))),ji=1,jg+1),ml=1,je+1),n=1,2)
!      end do
!      end do
!     end do

     call jacCmplx16(jge*ks,DOUT,HXab,VL,VR,nrot) 
     do i=1,jge*ks 
      Eagd(i)=HXab(i,i)
     end do 

    do m=1,je2
    do j=1,jg2
    do n=1,ks
     iabmjn=iab(m,j,n)

     do ml=1,je2
     do ji=1,jg2
      iqmj=iq(ml,ji)
      do l=1,je2
      do i=1,jg2
!      sum over alpha,beta
       h1c=C0
       do k=1,ks
       do kn=1,ks     
        h1c=h1c+pop(k)*VR(iab(l,i,k),iabmjn)*VL(iabmjn,iab(ml,ji,kn))
       end do
       end do
       RLab(iq(l,i),iqmj,iabmjn)=h1c
      end do
      end do
     end do
     end do
    end do
    end do
    end do

    VV=C0
    me=je+1; mg=jg+1
    if(itr.eq.1) then
     ! dipole transition 
      do M1=-1,1,2
      do M2=-1,1,2

       do m=1,je2
       do j=1,jg2
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je2
         do ji=1,jg2
          v1mj=Vje_1_jg(ml-me,M2,ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je2
          do i=1,jg2
           h1c=h1c+Vje_1_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
          end do
          end do
         end do
         end do
          VV(M1,M2,iabmjn)=h1c
       end do
       end do
       end do
      end do
      end do
!     for calculation of the ideal powder spectrum: VV(M,M,iabmjn)
!     stored in VV(0,0,iabmjn)
     if(icase.eq.2) then
      M1=0
       do m=1,je2
       do j=1,jg2
       do n=1,ks
         iabmjn=iab(m,j,n)

         h1c=C0
         do ml=1,je2
         do ji=1,jg2
          v1mj=Vje_1_jg(ml-me,M1,ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je2
          do i=1,jg2
           h1c=h1c+Vje_1_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
          end do
          end do
         end do
         end do
          VV(M1,M1,iabmjn)=h1c
       end do
       end do
       end do
       ! trace/(2L+1) is the powder intensity (f isotropic !!)
       do m=1,je2
       do j=1,jg2
       do n=1,ks
         iabmjn=iab(m,j,n)
         VV(0,0,iabmjn)=(VV(-1,-1,iabmjn)+VV(0,0,iabmjn)+VV(1,1,iabmjn))/3.
       end do
       end do
       end do
      end if
    else if(itr.eq.3) then
     ! quadrupole transition 
      do M1=-1,1,2
      do M2=-1,1,2

       do m=1,je2
       do j=1,jg2
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je2
         do ji=1,jg2
          v2mj=Vje_2_jg(ml-me,M2,ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je2
          do i=1,jg2
           h1c=h1c+Vje_2_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
          end do
          end do
         end do
         end do
         VV(M1,M2,iabmjn)=h1c
       end do
       end do
       end do
      end do
      end do

!     for calculation of the ideal powder spectrum
    if(icase.eq.2) then
     do M1=-2,2,2
      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je2
         do ji=1,jg2
          v2mj=Vje_2_jg(ml-me,M2,ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je2
          do i=1,jg2
           h1c=h1c+Vje_2_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
          end do
          end do
         end do
         end do
         V2D(M1,iabmjn)=h1c
       end do
       end do
       end do
      end do

      ! trace/(2L+1) is the powder intensity (f isotropic !!)
      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
        VV(0,0,iabmjn)=(V2D(2,iabmjn)+VV(1,1,iabmjn)+V2D(0,iabmjn)+ &
                        VV(-1,-1,iabmjn)+V2D(-2,iabmjn))/5.
      end do
      end do
      end do
     end if
    else if(itr.eq.2) then
     ! mixed  dipole quadrupole transition 
     delta2=r_QUDI**2 
     r_delta2=1./(1.+delta2) 

     ! dipol part 
     do M1=-1,1,2
     do M2=-1,1,2

      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je2
        do ji=1,jg2
         v1mj=Vje_1_jg(ml-me,M2,ji-mg)
         iqmj=iq(ml,ji) 
         do l=1,je2
         do i=1,jg2
           h1c=h1c+Vje_1_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
         end do
         end do
        end do
        end do
        VV(M1,M2,iab(m,j,n))=h1c
      end do
      end do
      end do
     end do
     end do

     ! quadrupole part 
     do M1=-1,1,2
     do M2=-1,1,2

      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je2
        do ji=1,jg2
         v2mj=Vje_2_jg(ml-me,M2,ji-mg) 
         iqmj=iq(ml,ji)
         do l=1,je2
         do i=1,jg2
          h1c=h1c+Vje_2_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
         end do
         end do
        end do
        end do
         V2(M1,M2,iab(m,j,n))=h1c
      end do
      end do
      end do

     end do
     end do

     !mixed part
     do M1=-1,1,2
     do M2=-1,1,2

      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je2
        do ji=1,jg2
         v2mj=Vje_2_jg(ml-me,M2,ji-mg)  
         v1mj=Vje_1_jg(ml-me,M2,ji-mg)  
         do l=1,je2
         do i=1,jg2
          h1c=h1c+M1*Vje_2_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj+ &
                  M2*Vje_1_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
         end do
         end do
        end do
        end do
        VV(M1,M2,iab(m,j,n))=r_delta2*(VV(M1,M2,iab(m,j,n))+    &
                              delta2*M1*M2*V2(M1,M2,iab(m,j,n))-h1c*r_QUDI)
      end do
      end do
      end do
     end do
     end do

!    for calculation of the ideal powder spectrum
    if(icase.eq.2) then
     !dipole part
     M1=0
      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je2
        do ji=1,jg2
         v1mj=Vje_1_jg(ml-me,M1,ji-mg)  
         do l=1,je2
         do i=1,jg2
            h1c=h1c+Vje_1_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
         end do
         end do
        end do
        end do
        VV(0,0,iabmjn)=h1c
      end do
      end do
      end do

     !quadrupole  part
     do M2=-2,2
      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je2
        do ji=1,jg2
         v2mj=Vje_2_jg(ml-me,M2,ji-mg)  
         do l=1,je2
         do i=1,jg2
          h1c=h1c+Vje_2_jg(l-me,M2,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
         end do
         end do
        end do
        end do
        V2D(M2,iabmjn)=h1c
      end do
      end do
      end do
     end do

      do m=1,je2
      do j=1,jg2
      do n=1,ks
       iabmjn=iab(m,j,n)
       VV(0,0,iabmjn)=r_delta2*((VV(-1,-1,iabmjn)+VV(0,0,iabmjn)+VV(1,1,iabmjn))/3+&
                                 delta2*(V2D(-2,iabmjn)+V2D(-1,iabmjn)+V2D(0,iabmjn)+ &
                                 V2D(1,iabmjn)+V2D(2,iabmjn))/5.)
      end do
      end do
      end do
     end if
    end if

   return 
  END subroutine intJgJeRELAX2



  subroutine allvec(n,ar,ai,wr,wi,vr,vi,vlr,vli,                   &
     &                    fv1,fv2,fv3,n2,z,wm,ipvt)                     
!?>?? logical, parameter :: debug = .false.                             
!-----------------------------------------------------------            
!                                                                       
!    Find Right & Left eigenvalues/ vectors of matrix                   
!       (ar,ai)   - is NOT overwritten !                                
!        (wr,wi)  - eigenvalues                                         
!        (vr,vi)  - Right Eigenvectors (by columns)                     
!        (vlr,vli)  - Left Eigenvectors (by rows)                       
!                                                                       
!          (VLR+i*VLI) * (VR+i*VI) = I (Unit matrix)                    
!                                                                       
!-----------------------------------------------------------            
      implicit none
      integer n,n2
      real(kind=8),dimension(n,n):: ar,ai,vr,vi,vlr,vli
      real(kind=8),dimension(n)  :: wr,wi,fv1,fv2,fv3
      real(kind=8),dimension(n2) :: z
      real(kind=8),dimension(n2,n2) :: wm                    
      integer,dimension(n2):: ipvt
      real(kind=8),dimension(2)::  det

      real(kind=8):: rcond 
      integer i,j,job,ierr,matz !                                                                            
      real(kind=8),parameter:: machep=1.0d-6 
!     machep determines abort condition   
!     Copy initial Matrix to WM - for test purposes only              
!                                                                       
      matz = 1 
      CALL CG(n,ar,ai,wr,wi,matz,vr,vi,fv1,fv2,fv3,machep,ierr) 
      if(ierr.ne.0) then 
        print '(a)', 'CG failed while searching Eigenvectors' 
        stop 
      endif 
!      ar,ai,wr,wi,fv1,fv2,fv3 sind ok                                  
!      print *, 'VR', n                                                 
!      print 1000, ((vr(i,j), j = 1,n), i=1,n )                         
!      print *, 'VI', n                                                 
!      print 1000,((vi(i,j), j = 1,n), i=1,n )                          
!       print 1000,(fv1(i), i=1,n )                                     
!       print 1000,(fv2(i), i=1,n )                                     
!       print 1000,(fv3(i), i=1,n )                                     
!CC   Normalize Eigenvectors                                            
      do  i=1,n 
       call stdvec(n,vr(1,i),vi(1,i)) 
      end do                                                                  
!                                                                       
!    Form Supermatrix                                                   
!                                                                       
!      print *, 'VR', n                                                 
!      print 1000, ((vr(i,j), j = 1,n), i=1,n )                         
!      print *, 'VI', n                                                 
!      print 1000,((vi(i,j), j = 1,n), i=1,n )                          
                                                                        
     do i=1,n 
      do j=1,n 
       wm(i,j)=vr(i,j) 
       wm(i+n,j+n)=vr(i,j) 
       wm(i+n,j)=-vi(i,j) 
       wm(i,j+n)=vi(i,j) 
      end do
     end do 

     job=01 
!                                                                       
!    Invert Matrix of Right Eigenvectors                                
!                                                                       
      call dgeco(n2,wm,ipvt,rcond,z) 
      if(rcond.lt.1.d-4) then 
       print '(a)','rcond=',rcond,' < 1.d-4' 
       print '(a)','Bad conditioned matrix' 
       stop 
      endif 
      call dgedi(n2,wm,ipvt,det,z,job) 
      do i=1,n 
      do j=1,n 
         vlr(i,j)=wm(i,j) 
         vli(i,j)=wm(i,j+n) 
       end do
      end do 
      return 
      END                                           
                                                                        
      subroutine stdvec(n,vr,vi) 
!  'Standardize' complex vector                                         
      implicit none 
      real(kind=8):: norm,h,rotr,roti,vimax
      real(kind=8),dimension(n):: vr,vi
      integer n,i,ih,im                                                                  
!  Find component with max imaginary part                               
                                                                        
      norm=0.d0 
      im=1 
      vimax=0.d0 

      do i=1,n 
       norm=norm+vr(i)**2+vi(i)**2 
       if(dabs(vi(i)).gt.vimax) then 
        vimax=dabs(vi(i)) 
        im=i 
       end if 
      end do 
      norm=dsqrt(norm) 
                                                                        
      h=vr(im)**2+vi(im)**2 
      if(h .gt. norm*1.d-4) then 
        h=dsqrt(h)*norm 
        rotr= vr(im)/h 
        roti=-vi(im)/h 
        ih=1 
      else 
        rotr=1.d0/norm 
        ih=0 
      endif 
!                                                                       
!   Rotate and Normalize                                                
      if(ih.eq.1) then 
       do  i=1,n 
        h=vr(i)*rotr-vi(i)*roti 
        vi(i)=vr(i)*roti+vi(i)*rotr 
        vr(i)=h 
       end do 
      else 
       do  i=1,n 
        vr(i)=vr(i)*rotr 
        vi(i)=vi(i)*rotr 
       end do 
      end if 
      return 
      END                                           
                                                                        
                                                                        
      subroutine cbabk2(n,low,ign,scale,m,zr,zi) 
      implicit none

      integer n,low,ign,m,i,j,k,ii
      real(kind=8),dimension(n):: scale
      real(kind=8),dimension(n,m):: zr,zi
      real(kind=8):: s 
                                                                         
      if(m.eq.0) go to 200 
      if(ign.eq.low) go to 120 
      do i=low,ign 
       s=scale(i) 
!***** left hand eigenvectors are back transformed                      
!      if the foregoing statement is replaced by                        
!      s=1.0/scale(i) *****                                             
       do j=1,m 
        zr(i,j)=zr(i,j)*s 
        zi(i,j)=zi(i,j)*s 
       end do
      end do
!***** for i=low-1 step -1 until 1, ign+1 step 1 until n do -- *****    
  120 continue 
     do ii=1,n 
      i=ii 
      if(i.ge.low.and.i.le.ign) go to 200
      if(i.lt.low) i=low-ii 
      k=scale(i) 
      if(k.eq.i) go to 140 
      do j=1,m 
       s=zr(i,j) 
       zr(i,j)=zr(k,j) 
       zr(k,j)=s 
       s=zi(i,j) 
       zi(i,j)=zi(k,j) 
       zi(k,j)=s 
      end do
  140 continue
     end do
  200 return 
      END                                           
                                                                        
      subroutine cbal(n,ar,ai,low,ign,scale)
      implicit none 
      integer        n,low,ign,i,j,k,l,m,jj,iexc 
      real(kind=8),dimension(n):: scale
      real(kind=8),dimension(n,n):: ar,ai

      real(kind=8):: c,f,g,r,s,b2,radix 
      logical noconv 
!***** radix is a machine dependent parameter specifying                
!***** the base of the machine floating point representation *****      
!*****************************************************************      
      radix=2. 
      b2=radix*radix 
      k=1 
      l=n 
      go to 100 
!***** in-line procedure for row and column exchange *****              
   20 scale(m)=j 
      if(j.eq.m) go to 50 
      do i=1,l 
      f=ar(i,j) 
      ar(i,j)=ar(i,m) 
      ar(i,m)=f 
      f=ai(i,j) 
      ai(i,j)=ai(i,m) 
      ai(i,m)=f 
      end do
      do i=k,n 
      f=ar(j,i) 
      ar(j,i)=ar(m,i) 
      ar(m,i)=f 
      f=ai(j,i) 
      ai(j,i)=ai(m,i) 
      ai(m,i)=f 
      end do
   50 go to (80,130),iexc 
!***** search for rows isolating an eigenvalue                          
!      and push them down *****                                         
   80 if(l.eq.1) go to 280 
      l=l-1 
!***** for j=l step -1 until 1 do -- *****                              
  100 continue 
     do jj=1,l 
      j=l+1-jj 
      do i=1,l 
       if(i.eq.j) goto 110
        if(ar(j,i).ne.0.0d0.or.ai(j,i).ne.0.0d0) go to 120 
110    continue     
      end do
      m=l 
      iexc=1 
      go to 20 
 120  continue
     end do 
     go to 140 
!***** search for columns isolating an eigenvalue                       
!      and push them left *****                                         
 130 k=k+1 
 140 continue 
     do j=k,l 
       do i=k,l 
        if(i.eq.j) go to 150 
        if(ar(i,j).ne.0.0d0.or.ai(i,j).ne.0.0d0) go to 170 
  150   continue 
       end do
       m=k 
       iexc=2 
       go to 20 
  170  continue
      end do 
!***** now balance the submatrix in rows k to l *****                   
      do i=k,l 
       scale(i)=1.0d0 
      end do 
!***** iterative loop for norm reduction *****                          
  190 noconv=.false. 
      do i=k,l 
       c=0.0d0 
       r=0.0d0 
       do j=k,l 
        if(j.eq.i) go to 200 
        c=c+dabs(ar(j,i))+dabs(ai(j,i)) 
        r=r+dabs(ar(i,j))+dabs(ai(i,j)) 
  200   continue
       end do 
!***** guard against zero c or r due to underflow *****                 
       if(c.eq.0.0d0.or.r.eq.0.0d0) go to 270 
       g=r/radix 
       f=1.0d0 
       s=c+r 
  210  if(c.ge.g) go to 220 
       f=f*radix 
       c=c*b2 
       go to 210 
  220  g=r*radix 
  230  if(c.lt.g) go to 240 
       f=f/radix 
       c=c/b2 
       go to 230 
!***** now balance *****                                                
  240  if((c+r)/f.ge.0.95*s) go to 270 
       g=1.0d0/f 
       scale(i)=scale(i)*f 
       noconv=.true. 
       do j=k,n 
        ar(i,j)=ar(i,j)*g 
        ai(i,j)=ai(i,j)*g 
       end do 
       do j=1,l 
        ar(j,i)=ar(j,i)*f 
        ai(j,i)=ai(j,i)*f 
       end do
  270  continue
      end do 
      if(noconv) go to 190 
  280 low=k 
      ign=l 
      return 
      END                                           
                                                                        
      subroutine CG(n,ar,ai,wr,wi,matz,zr,zi,fv1,fv2,fv3,machep,ierr) 
      implicit none
      integer n,ierr,is1,is2,matz 
      real(kind=8) :: ar(n,n),ai(n,n),wr(n),wi(n),zr(n,n),zi(n,n),      &
                      fv1(n),fv2(n),fv3(n),machep                                
                                                                        
      call cbal(n,ar,ai,is1,is2,fv1) 
      call corth(n,is1,is2,ar,ai,fv2,fv3) 
      if(matz.ne.0) go to 20 
!***** find eigenvalues only *****                                      
!      call comqr(nm,n,is1,is2,ar,ai,wr,wi,ierr)                        
      go to 50 
!***** find both eigenvalues and eigenvectors *****                     
   20 call comqr2(n,is1,is2,fv2,fv3,ar,ai,wr,wi,zr,zi,machep,ierr) 
      if(ierr.ne.0) go to 50 
      call cbabk2(n,is1,is2,fv1,n,zr,zi) 
   50 continue 
      return 
      END                                           
                                                                        
                                                                        
      subroutine comqr2(n,low,igh,ortr,orti,hr,hi,wr,wi,zr,zi,          &
                        machep,ierr)                                    
      implicit none                                                                  
      integer n,low,igh,ierr,i,j,k,l,m,en,ii,jj,ll,nn,ip1,              &
              its,lp1,enm1,iend,min0                               
      real(kind=8),dimension(igh):: ortr,orti
      real(kind=8),dimension(n)  :: wr,wi
      real(kind=8),dimension(n,n):: hr,hi,zr,zi

      real(kind=8) :: si,sr,ti,tr,xi,xr,yi,yr,zzi,zzr,norm,machep 
      complex(kind=8) :: z3 
!                                                                       
      ierr=0 
! ********** initialize eigenvector matrix **************               
      nn=n*n 
      call zeroar(nn,zr) 
      call zeroar(nn,zi) 
      do i=1,n 
       zr(i,i)=1.0d0 
      end do 
!  ********* form the matrix of accumulated transformations             
!            from the information left by corth *************           
      iend=igh-low-1 
      if(iend.le.0) goto 150 
! ********** for i=igh-1 step -1 until low+1 do -- **********           
      do ii=1,iend 
       i=igh-ii 
       if(ortr(i).eq.0.0d0.and.orti(i).eq.0.0d0) go to 140 
       if(hr(i,i-1).eq.0.0d0.and.hi(i,i-1).eq.0.0d0) go to 140 
! ********** norm below is negative of h formed in corth ****           
       norm=hr(i,i-1)*ortr(i)+hi(i,i-1)*orti(i) 
       ip1=i+1 
!                                                                       
       do k=ip1,igh 
        ortr(k)=hr(k,i-1) 
        orti(k)=hi(k,i-1) 
       end do                                                                       
       do j=i,igh 
       sr=0.0d0 
        si=0.0d0 
!                                                                       
        do k=i,igh 
         sr=sr+ortr(k)*zr(k,j)+orti(k)*zi(k,j) 
         si=si+ortr(k)*zi(k,j)-orti(k)*zr(k,j) 
        end do                                                                       
        sr=sr/norm 
        si=si/norm 
!                                                                       
        do k=i,igh 
         zr(k,j)=zr(k,j)+sr*ortr(k)-si*orti(k) 
         zi(k,j)=zi(k,j)+sr*orti(k)+si*ortr(k) 
        end do                                                                       
       end do                                                                 
  140 continue 
      end do
! ********** create real subdiagonal elements ***************           
  150 if(iend.lt.0) goto 180 
      l=low+1 
!                                                                       
      do i=l,igh 
       ll=min0(i+1,igh) 
       if(hi(i,i-1).eq.0.0d0) go to 170 
       norm=abs(cmplx(hr(i,i-1),hi(i,i-1))) 
       yr=hr(i,i-1)/norm 
       yi=hi(i,i-1)/norm 
       hr(i,i-1)=norm 
       hi(i,i-1)=0.0d0 
!                                                                        
       do j=i,n 
        si=yr*hi(i,j)-yi*hr(i,j) 
        hr(i,j)=yr*hr(i,j)+yi*hi(i,j) 
        hi(i,j)=si 
       end do                                                                        
       do j=1,ll 
        si=yr*hi(j,i)+yi*hr(j,i) 
        hr(j,i)=yr*hr(j,i)-yi*hi(j,i) 
        hi(j,i)=si 
       end do                                                                        
       do j=low,igh 
        si=yr*zi(j,i)+yi*zr(j,i) 
        zr(j,i)=yr*zr(j,i)-yi*zi(j,i) 
        zi(j,i)=si 
       end do                                                                        
  170  continue
      end do 
!  ********* store roots isolated by cbal *************                 
  180 continue
      do i=1,n 
       if(i.ge.low.and.i.le.igh) go to 200 
       wr(i)=hr(i,i) 
       wi(i)=hi(i,i) 
  200  continue 
      end do                                                                  
      en=igh 
      tr=0.0d0 
      ti=0.0d0 
!  ********** search for next eigenvalue ***************                
  220 if(en.lt.low) go to 680 
      its=0 
      enm1=en-1 
! ******** look for single small sub-diagonal element                   
!          for l=en step -1 until low -- **************                 
 240 continue 
     do ll=low,en 
      l=en+low-ll 
      if(l.eq.low) go to 300 
      if(dabs(hr(l,l-1)).le.                                            &
             machep*(dabs(hr(l-1,l-1))+dabs(hi(l-1,l-1))                &
            +dabs(hr(l,l))+dabs(hi(l,l)))) go to 300                    
     end do
!  ********* form shift ******************************                  
  300 if(l.eq.en) go to 660 
      if(its.eq.30) go to 1000 
      if(its.eq.10.or.its.eq.20) go to 320 
      sr=hr(en,en) 
      si=hi(en,en) 
      xr=hr(enm1,en)*hr(en,enm1) 
      xi=hi(enm1,en)*hr(en,enm1) 
      if(xr.eq.0.0d0.and.xi.eq.0.0d0) go to 340 
      yr=(hr(enm1,enm1)-sr)/2.0d0 
      yi=(hi(enm1,enm1)-si)/2.0d0 
      z3=sqrt(cmplx(yr**2-yi**2+xr,2.0d0*yr*yi+xi)) 
      zzr=dreal(z3) 
      zzi=dimag(z3) 
      if(yr*zzr+yi*zzi.ge.0.0d0) go to 310 
      zzr=-zzr 
      zzi=-zzi 
  310 z3=cmplx(xr,xi)/cmplx(yr+zzr,yi+zzi) 
      sr=sr-dreal(z3) 
      si=si-dimag(z3) 
      go to 340 
! ********* form exeptional shift *************************             
  320 sr=dabs(hr(en,enm1))+dabs(hr(enm1,en-2)) 
      si=0.0d0 
!                                                                       
  340 continue
      do i=low,en 
       hr(i,i)=hr(i,i)-sr 
       hi(i,i)=hi(i,i)-si 
      end do
!                                                                       
      tr=tr+sr 
      ti=ti+si 
      its=its+1 
! *********** reduce to triangle (rows) ********************            
      lp1=l+1 
!                                                                       
      do i=lp1,en 
       sr=hr(i,i-1) 
       hr(i,i-1)=0.0d0 
       norm=dsqrt(hr(i-1,i-1)*hr(i-1,i-1)+hi(i-1,i-1)*hi(i-1,i-1)+sr*sr) 
       xr=hr(i-1,i-1)/norm 
       wr(i-1)=xr 
       xi=hi(i-1,i-1)/norm 
       wi(i-1)=xi 
       hr(i-1,i-1)=norm 
       hi(i-1,i-1)=0.0d0 
       hi(i,i-1)=sr/norm 
                                                                       
       do j=i,n 
       yr=hr(i-1,j) 
       yi=hi(i-1,j) 
       zzr=hr(i,j) 
       zzi=hi(i,j) 
       hr(i-1,j)=xr*yr+xi*yi+hi(i,i-1)*zzr 
       hi(i-1,j)=xr*yi-xi*yr+hi(i,i-1)*zzi 
       hr(i,j)=xr*zzr-xi*zzi-hi(i,i-1)*yr 
       hi(i,j)=xr*zzi+xi*zzr-hi(i,i-1)*yi 
       end do                                                                       
      end do 
!                                                                       
      si=hi(en,en) 
      if(si.eq.0.0d0) go to 540 
      norm=abs(cmplx(hr(en,en),si)) 
      sr=hr(en,en)/norm 
      si=si/norm 
      hr(en,en)=norm 
      hi(en,en)=0.0d0 
      if(en.eq.n) go to 540 
      ip1=en+1 
!                                                                       
      do j=ip1,n 
       yr=hr(en,j) 
       yi=hi(en,j) 
       hr(en,j)=sr*yr+si*yi 
       hi(en,j)=sr*yi-si*yr 
      end do                                                                        
! ********* inverse operation (columns) *****************               
  540 continue
      do j=lp1,en 
      xr=wr(j-1) 
      xi=wi(j-1) 
!                                                                       
      do i=1,j 
       yr=hr(i,j-1) 
       yi=0.0d0 
       zzr=hr(i,j) 
       zzi=hi(i,j) 
       if(i.eq.j) go to 560 
       yi=hi(i,j-1) 
       hi(i,j-1)=xr*yi+xi*yr+hi(j,j-1)*zzi 
  560  hr(i,j-1)=xr*yr-xi*yi+hi(j,j-1)*zzr 
       hr(i,j)=xr*zzr+xi*zzi-hi(j,j-1)*yr 
       hi(i,j)=xr*zzi-xi*zzr-hi(j,j-1)*yi 
      end do                                                                       
      do  i=low,igh 
       yr=zr(i,j-1) 
       yi=zi(i,j-1) 
       zzr=zr(i,j) 
       zzi=zi(i,j) 
       zr(i,j-1)=xr*yr-xi*yi+hi(j,j-1)*zzr 
       zi(i,j-1)=xr*yi+xi*yr+hi(j,j-1)*zzi 
       zr(i,j)=xr*zzr+xi*zzi-hi(j,j-1)*yr 
       zi(i,j)=xr*zzi-xi*zzr-hi(j,j-1)*yi 
      end do                                                                       
     end do                                                                  
     if(si.eq.0.0d0) go to 240 
!                                                                       
      do i=1,en 
       yr=hr(i,en) 
       yi=hi(i,en) 
       hr(i,en)=sr*yr-si*yi 
       hi(i,en)=sr*yi+si*yr 
      end do
                                                                       
      do i=low,igh 
      yr=zr(i,en) 
      yi=zi(i,en) 
      zr(i,en)=sr*yr-si*yi 
      zi(i,en)=sr*yi+si*yr 
      end do
      go to 240 
!  *******  a root found ************************                       
  660 hr(en,en)=hr(en,en)+tr 
      wr(en)=hr(en,en) 
      hi(en,en)=hi(en,en)+ti 
      wi(en)=hi(en,en) 
      en=enm1 
      go to 220 
! ********  all roots found. backsubstitute to find                     
!           vectors of upper triangular form ***********                
  680 norm=0.0d0 
!                                                                       
      do i=1,n 
       do j=1,n 
        norm=norm+dabs(hr(i,j))+dabs(hi(i,j)) 
      end do
     end do  
     if(n.eq.1.or.norm.eq.0.0d0) go to 1001 
!  ********* for en=n step -1 until 2 do -- ******************          
      do nn=2,n 
       en=n+2-nn 
       xr=wr(en) 
       xi=wi(en) 
       enm1=en-1 
!  ********** for i=en-1 step -1 until 1 do -- ****************         
       do ii=1,enm1 
        i=en-ii 
        zzr=hr(i,en) 
        zzi=hi(i,en) 
        if(i.eq.enm1) go to 760 
        ip1=i+1 
        do j=ip1,enm1 
         zzr=zzr+hr(i,j)*hr(j,en)-hi(i,j)*hi(j,en) 
         zzi=zzi+hr(i,j)*hi(j,en)+hi(i,j)*hr(j,en) 
        end do
  760   yr=xr-wr(i) 
        yi=xi-wi(i) 
        if(yr.eq.0.0d0.and.yi.eq.0.0d0) yr=machep*norm 
        z3=cmplx(zzr,zzi)/cmplx(yr,yi) 
        hr(i,en)=dble(z3) 
        hi(i,en)=dimag(z3) 
       end do
      end do
!  ********  end backsubstitution ************************              
      enm1=n-1 
!  ********  vectors of isolated roots *******************              
      do i=1,enm1 
       if(i.ge.low.and.i.le.igh) go to 840 
       ip1=i+1 
!                                                                       
       do j=ip1,n 
       zr(i,j)=hr(i,j) 
       zi(i,j)=hi(i,j) 
       end do
  840  continue
      end do 
! *********  multiply by transformation matrix to give                  
!            vectors of original full matrix.                           
!            for j=n step -1 until low+1 do -- ************             
      do jj=low,enm1 
       j=n+low-jj 
       m=min0(j-1,igh) 
!                                                                       
       do i=low,igh 
        zzr=zr(i,j) 
        zzi=zi(i,j) 
!                                                                       
        do k=low,m 
         zzr=zzr+zr(i,k)*hr(k,j)-zi(i,k)*hi(k,j) 
         zzi=zzi+zr(i,k)*hi(k,j)+zi(i,k)*hr(k,j) 
        end do
        zr(i,j)=zzr 
        zi(i,j)=zzi 
       end do
      end do
      go to 1001 
! *******  set error -- no convergence to an                            
!          eigenvalue after 30 iterations **********                    
 1000 ierr=en 
 1001 continue 
                                                                        
      return 
      END                                           
                                                                        
      subroutine corth(n,low,igh,ar,ai,ortr,orti) 
      implicit none                                                                      
      integer i,j,m,n,ii,jj,la,mpi,igh,kp1,low 
      real(kind=8),dimension(igh):: ortr,orti
      real(kind=8),dimension(n,n):: ar,ai

      real(kind=8) :: f,g,h,fi,fr,scale 
!      real*8 sqrt,abs                                                  
!      complex cmplx                                                    
!                                                                       
      la=igh-1 
      kp1=low+1 
      if(la.lt.kp1) go to 200 
!                                                                       
      do m=kp1,la 
       h=0.0d0 
       ortr(m)=0.0d0 
       orti(m)=0.0d0 
       scale=0.0d0 
!  ** ****** scale column (algol tol then not needed) **********         
       do i=m,igh 
        scale=scale+dabs(ar(i,m-1))+dabs(ai(i,m-1)) 
       end do                                                                  
       if(scale.eq.0.0d0) go to 180 
       mpi=m+igh 
!  ** ****** for i=igh step -1 until m do -- *******************         
       do ii=m,igh 
        i=mpi-ii 
        ortr(i)=ar(i,m-1)/scale 
        orti(i)=ai(i,m-1)/scale 
        h=h+ortr(i)*ortr(i)+orti(i)*orti(i) 
       end do

       g=dsqrt(h) 
       f=abs(cmplx(ortr(m),orti(m))) 
       if(f.eq.0.0d0) go to 103 
       h=h+f*g 
       g=g/f 
       ortr(m)=(1.0d0+g)*ortr(m) 
       orti(m)=(1.0d0+g)*orti(m) 
       go to 105 
!                                                                        
  103  ortr(m)=g 
       ar(m,m-1)=scale 
!  ** ******* form (i-(u*ut)/h)*a *********************                  
  105  continue
       do j=m,n 
        fr=0.0d0 
        fi=0.0d0 
!  ** ******* for i=igh step -1 until m do -- *********                  
        do  ii=m,igh 
         i=mpi-ii 
         fr=fr+ortr(i)*ar(i,j)+orti(i)*ai(i,j) 
         fi=fi+ortr(i)*ai(i,j)-orti(i)*ar(i,j) 
        end do 
        fr=fr/h 
        fi=fi/h 
!                                                                        
        do i=m,igh 
         ar(i,j)=ar(i,j)-fr*ortr(i)+fi*orti(i) 
         ai(i,j)=ai(i,j)-fr*orti(i)-fi*ortr(i) 
        end do
       end do
! *** ****** form (i-(u*ut)/h)*a*(i-(u*ut)/h) ***********                
       do  i=1,igh 
        fr=0.0d0 
        fi=0.0d0 
!  ** ****** for j=igh step -1 until m do -- ************                
        do jj=m,igh 
         j=mpi-jj 
         fr=fr+ortr(j)*ar(i,j)-orti(j)*ai(i,j) 
         fi=fi+ortr(j)*ai(i,j)+orti(j)*ar(i,j) 
        end do  
        fr=fr/h 
        fi=fi/h 
!                                                                       
        do j=m,igh 
         ar(i,j)=ar(i,j)-fr*ortr(j)-fi*orti(j) 
         ai(i,j)=ai(i,j)+fr*orti(j)-fi*ortr(j) 
        end do                                                                       
       end do                                                                      
       ortr(m)=scale*ortr(m) 
       orti(m)=scale*orti(m) 
       ar(m,m-1)=-g*ar(m,m-1) 
       ai(m,m-1)=-g*ai(m,m-1) 
  180  continue 
      end do                                                                       
  200 continue 
                                                                        
      return 
      END                                           
                                                                        
      subroutine dgeco(n,a,ipvt,rcond,z) 
      implicit none
      integer n,ipvt(n) 
      real(kind=8) :: rcond 
      real(kind=8),dimension(n,n):: a
      real(kind=8),dimension(n)  :: z                                                                       
!     dgeco factors a double precision matrix by gaussian elimination   
!     and estimates the condition of the matrix.                        
!                                                                       
!     if  rcond  is not needed, dgefa is slightly faster.               
!     to solve  a*x = b , follow dgeco by dgesl.                        
!     to compute  inverse(a)*c , follow dgeco by dgesl.                 
!     to compute  determinant(a) , follow dgeco by dgedi.               
!     to compute  inverse(a) , follow dgeco by dgedi.                   
!                                                                       
!     on entry                                                          
!                                                                       
!        a       double precision(n, n)                                 
!                the matrix to be factored.                             
!                                                                       
!        n     integer                                                  
!                the leading dimension of the array  a .                
!                                                                       
!        n       integer                                                
!                the order of the matrix  a .                           
!                                                                       
!     on return                                                         
!                                                                       
!        a       an upper triangular matrix and the multipliers         
!                which were used to obtain it.                          
!                the factorization can be written  a = l*u  where       
!                l  is a product of permutation and unit lower          
!                triangular matrices and  u  is upper triangular.       
!                                                                       
!        ipvt    integer(n)                                             
!                an integer vector of pivot indices.                    
!                                                                       
!        rcond   double precision                                       
!                an estimate of the reciprocal condition of  a .        
!                for the system  a*x = b , relative perturbations       
!                in  a  and  b  of size  epsilon  may cause             
!                relative perturbations in  x  of size  epsilon/rcond . 
!                if  rcond  is so small that the logical expression     
!                           1.0 + rcond .eq. 1.0                        
!                is true, then  a  may be singular to working           
!                precision.  in particular,  rcond  is zero  if         
!                exact singularity is detected or the estimate          
!                underflows.                                            
!                                                                       
!        z       double precision(n)                                    
!                a work vector whose contents are usually unimportant.  
!                if  a  is close to a singular matrix, then  z  is      
!                an approximate null vector in the sense that           
!                norm(a*z) = rcond*norm(a)*norm(z) .                    
!                                                                       
!     linpack. this version dated 08/14/78 .                            
!     cleve moler, university of new mexico, argonne national lab.      
!                                                                       
!     subroutines and functions                                         
!                                                                       
!     linpack dgefa                                                     
!     blas daxpy,ddot,dscal,dasum                                       
!     fortran dabs,dmax1,dsign                                          
!                                                                       
!     internal variables                                                
!                                                                       
      real(kind=8) :: ddot,ek,t,wk,wkm 
      real(kind=8) :: anorm,s,dasum,sm,ynorm 
      integer info,j,k,kb,kp1,l 
!                                                                       
!                                                                       
!     compute 1-norm of a                                               
!                                                                       
      anorm = 0.0d0 
      do j = 1, n 
         anorm = dmax1(anorm,dasum(n,a(1,j))) 
      end do
!     factor                                                            
!                                                                       
      call dgefa(n,a,ipvt,info) 
!                                                                       
!     rcond = 1/(norm(a)*(estimate of norm(inverse(a)))) .              
!     estimate = norm(z)/norm(y) where  a*z = y  and  trans(a)*y = e .  
!     trans(a)  is the transpose of a .  the components of  e  are      
!     chosen to cause maximum local growth in the elements of w  where  
!     trans(u)*w = e .  the vectors are frequently rescaled to avoid    
!     overflow.                                                         
!                                                                       
!     solve trans(u)*w = e                                              
!                                                                       
      ek = 1.0d0 
      do j = 1, n 
       z(j) = 0.0d0 
      end do
      do k = 1, n 
         if (z(k) .ne. 0.0d0) ek = dsign(ek,-z(k)) 
         if (dabs(ek-z(k)) .le. dabs(a(k,k))) go to 30 
            s = dabs(a(k,k))/dabs(ek-z(k)) 
            call dscal(n,s,z) 
            ek = s*ek 
   30    continue 
         wk = ek - z(k) 
         wkm = -ek - z(k) 
         s = dabs(wk) 
         sm = dabs(wkm) 
         if (a(k,k) .eq. 0.0d0) go to 40 
            wk = wk/a(k,k) 
            wkm = wkm/a(k,k) 
         go to 50 
   40    continue 
         wk = 1.0d0 
         wkm = 1.0d0 
   50    continue 
         kp1 = k + 1 
         if (kp1 .gt. n) go to 80 
         do j = kp1, n 
          sm = sm + dabs(z(j)+wkm*a(k,j)) 
          z(j) = z(j) + wk*a(k,j) 
          s = s + dabs(z(j)) 
         end do 
         if (s .ge. sm) go to 80 
         t = wkm - wk 
         wk = wkm 
         do j = kp1, n 
          z(j) = z(j) + t*a(k,j) 
         end do 
   80    continue 
         z(k) = wk 
      end do
      s = 1.0d0/dasum(n,z) 
      call dscal(n,s,z) 
!                                                                       
!     solve trans(l)*y = w                                              
!                                                                       
      do kb = 1, n 
         k = n + 1 - kb 
         if (k .lt. n) z(k) =z(k)+ddot(n-k,a(k+1,k),z(k+1)) 
         if (dabs(z(k)) .le. 1.0d0) go to 110 
         s = 1.0d0/dabs(z(k)) 
         call dscal(n,s,z) 
  110    continue 
         l = ipvt(k) 
         t = z(l) 
         z(l) = z(k) 
         z(k) = t 
      end do
      s = 1.0d0/dasum(n,z) 
      call dscal(n,s,z) 
                                                                      
      ynorm = 1.0d0 
!     solve l*v = y                                                     
      do k = 1, n 
         l = ipvt(k) 
         t = z(l) 
         z(l) = z(k) 
         z(k) = t 
         if (k .lt. n) call daxpy(n-k,t,a(k+1,k),z(k+1)) 
         if (dabs(z(k)) .le. 1.0d0) go to 130 
         s = 1.0d0/dabs(z(k)) 
         call dscal(n,s,z) 
         ynorm = s*ynorm 
  130    continue 
      end do
      s = 1.0d0/dasum(n,z) 
      call dscal(n,s,z) 
      ynorm = s*ynorm 
!     solve  u*z = v                                                    
      do kb = 1, n 
         k = n + 1 - kb 
         if (dabs(z(k)) .le. dabs(a(k,k))) go to 150 
         s = dabs(a(k,k))/dabs(z(k)) 
         call dscal(n,s,z) 
         ynorm = s*ynorm 
  150    continue 
         if (a(k,k) .ne. 0.0d0) z(k) = z(k)/a(k,k) 
         if (a(k,k) .eq. 0.0d0) z(k) = 1.0d0 
         t = -z(k) 
         call daxpy(k-1,t,a(1,k),z(1)) 
      end do 
!     make znorm = 1.0                                                  
      s = 1.0d0/dasum(n,z) 
      call dscal(n,s,z) 
      ynorm = s*ynorm 
!                                                                       
      if (anorm .ne. 0.0d0) rcond = ynorm/anorm 
      if (anorm .eq. 0.0d0) rcond = 0.0d0 
      return 
      END                                           
                                                                        
      subroutine dgedi(n,a,ipvt,det,work,job)
      implicit none 
      integer n,ipvt(n),job 
      real(kind=8),dimension(n,n):: a
      real(kind=8),dimension(n)  :: work
      real(kind=8),dimension(2)  :: det  

!                                                                       
!     dgedi computes the determinant and inverse of a matrix            
!     using the factors computed by dgeco or dgefa.                     
!                                                                       
!     on entry                                                          
!                                                                       
!        a       double precision(n, n)                                 
!                the output from dgeco or dgefa.                        
!                                                                       
!        n     integer                                                  
!                the leading dimension of the array  a .                
!                                                                       
!        n       integer                                                
!                the order of the matrix  a .                           
!                                                                       
!        ipvt    integer(n)                                             
!                the pivot vector from dgeco or dgefa.                  
!                                                                       
!        work    double precision(n)                                    
!                work vector.  contents destroyed.                      
!                                                                       
!        job     integer                                                
!                = 11   both determinant and inverse.                   
!                = 01   inverse only.                                   
!                = 10   determinant only.                               
!                                                                       
!     on return                                                         
!                                                                       
!        a       inverse of original matrix if requested.               
!                otherwise unchanged.                                   
!                                                                       
!        det     double precision(2)                                    
!                determinant of original matrix if requested.           
!                otherwise not referenced.                              
!                determinant = det(1) * 10.0**det(2)                    
!                with  1.0 .le. dabs(det(1)) .lt. 10.0                  
!                or  det(1) .eq. 0.0 .                                  
!                                                                       
!     error condition                                                   
!                                                                       
!        a division by zero will occur if the input factor contains     
!        a zero on the diagonal and the inverse is requested.           
!        it will not occur if the subroutines are called correctly      
!        and if dgeco has set rcond .gt. 0.0 or dgefa has set           
!        info .eq. 0 .                                                  
!                                                                       
!     linpack. this version dated 08/14/78 .                            
!     cleve moler, university of new mexico, argonne national lab.      
!                                                                       
!     subroutines and functions                                         
!                                                                       
!     blas daxpy,dscal,dswap                                            
!     fortran dabs,mod                                                  
!                                                                       
!     internal variables                                                
!                                                                       
      real(kind=8) :: t,ten 
      integer i,j,k,kb,kp1,l,nm1 
!                                                                       
!                                                                       
!     compute determinant                                               
!                                                                       
       if (job/10 .eq. 0) go to 60 
       det(1) = 1.0d0 
       det(2) = 0.0d0 
       ten = 10.0d0 
       do i = 1, n 
         if (ipvt(i) .ne. i) det(1) = -det(1) 
         det(1) = a(i,i)*det(1) 
!      ...exit                                                        
         if (det(1) .eq. 0.0d0) go to 60 
   10    if (dabs(det(1)) .ge. 1.0d0) go to 20 
         det(1) = ten*det(1) 
         det(2) = det(2) - 1.0d0 
         go to 10 
   20    continue 
   30    if (dabs(det(1)) .lt. ten) go to 40 
         det(1) = det(1)/ten 
         det(2) = det(2) + 1.0d0 
         go to 30 
   40    continue 
       end do 
   60  continue 
!                                                                       
!     compute inverse(u)                                                
!                                                                       
      if (mod(job,10) .eq. 0) go to 140 
         do k = 1, n 
          a(k,k) = 1.0d0/a(k,k) 
          t = -a(k,k) 
          call dscal(k-1,t,a(1,k)) 
          kp1 = k + 1 
          if (n .lt. kp1) go to 90 
          do j = kp1, n 
           t = a(k,j) 
           a(k,j) = 0.0d0 
           call daxpy(k,t,a(1,k),a(1,j)) 
          end do 
   90     continue 
         end do                                                                       
!        form inverse(u)*inverse(l)                                     
!                                                                       
         nm1 = n - 1 
         if (nm1 .lt. 1) go to 140 
         do kb = 1, nm1 
            k = n - kb 
            kp1 = k + 1 
            do i = kp1, n 
               work(i) = a(i,k) 
               a(i,k) = 0.0d0 
            end do
            do j = kp1, n 
               t = work(j) 
               call daxpy(n,t,a(1,j),a(1,k)) 
            end do
            l = ipvt(k) 
            if (l .ne. k) call dswap(n,a(1,k),a(1,l)) 
         end do 
  140 continue 
      return 
      END                                           
                                                                        
      subroutine dgefa(n,a,ipvt,info) 
      implicit none
      integer n,info 
      real(kind=8),dimension(n,n) :: a 
      integer, dimension(n)::ipvt                                                                 
!     dgefa factors a double precision matrix by gaussian elimination.  
!                                                                       
!     dgefa is usually called by dgeco, but it can be called            
!     directly with a saving in time if  rcond  is not needed.          
!     (time for dgeco) = (1 + 9/n)*(time for dgefa) .                   
!                                                                       
!     on entry                                                          
!                                                                       
!        a       double precision(n, n)                                 
!                the matrix to be factored.                             
!                                                                       
!        n     integer                                                  
!                the leading dimension of the array  a .                
!                                                                       
!        n       integer                                                
!                the order of the matrix  a .                           
!                                                                       
!     on return                                                         
!                                                                       
!        a       an upper triangular matrix and the multipliers         
!                which were used to obtain it.                          
!                the factorization can be written  a = l*u  where       
!                l  is a product of permutation and unit lower          
!                triangular matrices and  u  is upper triangular.       
!                                                                       
!        ipvt    integer(n)                                             
!                an integer vector of pivot indices.                    
!                                                                       
!        info    integer                                                
!                = 0  normal value.                                     
!                = k  if  u(k,k) .eq. 0.0 .  this is not an error       
!                     condition for this subroutine, but it does        
!                     indicate that dgesl or dgedi will divide by zero  
!                     if called.  use  rcond  in dgeco for a reliable   
!                     indication of singularity.                        
!                                                                       
!     linpack. this version dated 08/14/78 .                            
!     cleve moler, university of new mexico, argonne national lab.      
!                                                                       
!     subroutines and functions                                         
!                                                                       
!     blas daxpy,dscal,idamax                                           
!                                                                       
!     internal variables                                                
!                                                                       
      real(kind=8) :: t 
      integer idamax,j,k,kp1,l,nm1 
!                                                                       
!                                                                       
!     gaussian elimination with partial pivoting                        
!                                                                       
      info = 0 
      nm1 = n - 1 
      if (nm1 .lt. 1) go to 70 
      do k = 1, nm1 
         kp1 = k + 1 
!                                                                       
!        find l = pivot index                                           
!                                                                       
         l = idamax(n-k+1,a(k,k)) + k - 1 
         ipvt(k) = l 
!                                                                       
!        zero pivot implies this column already triangularized          
!                                                                       
         if (a(l,k) .eq. 0.0d0) go to 40 
!                                                                       
!           interchange if necessary                                    
!                                                                       
            if (l .eq. k) go to 10 
               t = a(l,k) 
               a(l,k) = a(k,k) 
               a(k,k) = t 
   10       continue 
!                                                                       
!           compute multipliers                                         
!                                                                       
            t = -1.0d0/a(k,k) 
            call dscal(n-k,t,a(k+1,k)) 
!                                                                       
!           row elimination with column indexing                        
!                                                                       
            do j = kp1, n 
               t = a(l,j) 
               if (l .eq. k) go to 20 
                  a(l,j) = a(k,j) 
                  a(k,j) = t 
   20          continue 
               call daxpy(n-k,t,a(k+1,k),a(k+1,j)) 
            end do
         go to 50 
   40    continue 
            info = k 
   50    continue 
      end do
   70 continue 
      ipvt(n) = n 
      if (a(n,n) .eq. 0.0d0) info = n 
      return 
      END                                           
                                                                        
                                                                        
                                                                        
      function dasum(n,dx) 
      implicit none
!     takes the sum of the absolute values.                             
      real(kind=8) :: dasum
      real(kind=8),dimension(n):: dx
      integer i,n 
!                                                                       
      dasum = 0.0d0 
      if(n.le.0) return 
                                                                        
      do i = 1,n 
        dasum = dasum + dabs(dx(i)) 
      end do 
                                                                        
      return 
      END                                           
                                                                        
      subroutine daxpy(n,da,dx,dy) 
      implicit none
!     constant times a vector plus a vector.                            
      real(kind=8),dimension(n):: dx,dy
      real(kind=8) :: da 
      integer i,n 
!                                                                       
      if(n.le.0) return 
      if (da.eq.0.0d0) return 
      do i = 1,n 
        dy(i) = dy(i) + da*dx(i) 
      end do 
      return 
      END                                           
                                                                        
      function ddot(n,dx,dy) 
      implicit none
!     forms the dot product of two vectors.
      real(kind=8) :: ddot                       
      real(kind=8),dimension(n)::  dx,dy 
      integer i,n 
!                                                                       
      ddot = 0.0d0 
      if(n.le.0) return 
                                                                        
      do i = 1,n 
        ddot = ddot + dx(i)*dy(i) 
      end do 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine  dscal(n,da,dx) 
!     scales a vector by a constant.                                    
      implicit none
      real(kind=8) :: da                                                                       
      real(kind=8),dimension(n):: dx 
      integer i,n 
                                                                        
      do i = 1,n 
        dx(i) = da*dx(i) 
      end do 
      return 
      END                                           
                                                                        
                                                                        
      subroutine  dswap (n,dx,dy) 
      implicit none
!     interchanges two vectors.                                         
      real(kind=8) :: dtemp                                                                       
      real(kind=8),dimension(n):: dx,dy 
      integer i,n 
                                                                        
      if(n.le.0) return 
      do i = 1,n 
        dtemp = dx(i) 
        dx(i) = dy(i) 
        dy(i) = dtemp 
      end do 
      return 
      END                                           
                                                                        
      integer function idamax(n,dx) 
      implicit none
!     finds the index of element having max. absolute value.            
!     jack dongarra, linpack, 3/11/78.                                  
!                                                                       
      real(kind=8) :: dmax                                                                       
      real(kind=8),dimension(n):: dx 
      integer i,n 
!                                                                       
      idamax = 0 
      if(n.lt.1) return 
      idamax = 1 
      if(n.eq.1) return 
       dmax = dabs(dx(1)) 
      do 30 i = 2,n 
         if(dabs(dx(i)).le.dmax) go to 30 
         idamax = i 
         dmax = dabs(dx(i)) 
   30 continue 
                                                                        
      return 
      END                                           
                                                                        
      subroutine zeroar(n,x)
      implicit none 
      integer n,i 
      real(kind=8),dimension(n):: x 
      do i=1,n 
       x(i)=0.0d0 
      end do 
      return 
      END                                           
