!    author : h. spiering                                              
!             Am Damsberg 86                                           
!             D-55130 Mainz                                            
!             last version April 200                                   
                                                                       
!    synchrotron                            
     subroutine fr_synchrotron(cmch,jss,info) 
     use glbconst, only: maxfr1,maxfr2,maxn,maxthss,maxscrd,maxsub,& 
                         icstrf,ivstrf,maxs, &
                         infotext,enwr,ncl
     use comdat, only: data_str,formdata,name_data,b_data,b_theory,   &
                       name_theory,nuofdatas,ichanks,mxpt,mypt,mfpt,mdfpt,mlpt
     use complt, only: n_subset,ndisplay_mode
     use comthe, only: real_fr,thfrcase,theoryname,ifrcase,ifrsto,mGa
     implicit none 
     character(len=4), intent(inout):: cmch
     integer, intent(in) :: jss
     integer, intent(out):: info  

     integer       mstruct1,istruct1,istruct2,                        &
                   l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,         &
                   nstorTH,nstorTH1,nstorTHyy,nstorSI,ipTH,mpt,iaddr
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname 
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),                                        &
                   mpt,ipTH,nstorTH,nstorTH1,nstorTHyy,nstorSI,iaddr(2)
!                  istr=38+4*(maxfr1+maxfr2)+3*maxthss

     real          srw8,xb_the,dx_the
     integer       nTH1,nCP,nTH2,nsrw,nstore,nexp,mgrpt,ifrst,         &
                   iflag_basis,lfwscat,nLG,nTH,ith_channels,           &
                   nsampling,ak8,nomega,nstrob_order,jt0_ch,           &
                   iT_max,nvch,nhyperfine,ien   
     common/strLOC/nTH1,nCP,nTH2,nsrw,nstore,nexp,mgrpt,ifrst(5),      &
                   iflag_basis,lfwscat,nLG,nTH,ith_channels,           &
                   nsampling,ak8,nomega,srw8,nstrob_order,jt0_ch,      &
                   iT_max,nvch,nhyperfine,xb_the,dx_the,ien(4)  
                                                                       
     real          acsp,wavelength,uthick,                             &
                   unit_chi,aiT_max,v_max,                             &
                   ak_extension,T_bunch,dastr,channels,                &
                   ch_angle,graz_beg,graz_end,t0_norm,flag_basis,      &
                   th_channels,th_sampling,                            &
                   strob_order,m_window,omega,dumcsp                            
     common/acstrf/acsp,wavelength,uthick,                             &
                   unit_chi,aiT_max,v_max,                             &
                   ak_extension,T_bunch,dastr,channels,                &
                   ch_angle,graz_beg,graz_end,t0_norm,flag_basis,      &
                   th_channels,th_sampling,                            &
                   strob_order,m_window,omega,dumcsp(icstrf-20)                 
 
                                                                       
     real          avsp,counts,background,dum0,Pxsi,Peta,Pzeta,         &
                   PA0,PAxsi,PAeta,PAzeta,t_shift,graz_angle,graz_min,  &
                   phi_z,detekt_eff,counts_bunch,dumvsp                
     common/avstrf/avsp,counts,background,dum0,Pxsi,Peta,Pzeta,         &
                   PA0,PAxsi,PAeta,PAzeta,t_shift,graz_angle,graz_min,  &
                   phi_z,detekt_eff,counts_bunch,dumvsp(ivstrf-17)     
                                                                       
     integer      mdastr,nchansp,                              &
                  iT_max2,lstruct1,lstruct2,lstruct3,ncloc,            &
                  nstorLG,i,j,isub,k1,k2,m1,m3,jshift       
     real         vector_k,cv_ET,schrw 
!*************** user defined common block and definitions ************
     character(len=132):: ch132,cp132
     character(len=1)  :: ch1
     character(len=40),dimension(3):: text 
!     used for subroutine channelnumberall(nvch,nhyperfine,nstrob_order
!                                nomega,iall) , thfrcase(6)            
!     ichall array contains the non eqidistant channel numbers for inte
!     tion over the stroboscopic windows (important for computation tim
      integer, parameter:: idum=maxscrd-1-2*maxn
      integer     ichall,idumscrd 
      common/scrd/ichall(0:maxn*2),idumscrd(idum) 

      integer     iall,nstrob,n_theta,n_angpairs
      integer,dimension(5):: n5_offspec 
      real,parameter :: rad=0.0174533,pi=3.14159         

!***********************************************************************
                                                                        
      if(cmch.eq.'thna') then 
       theoryname='Synchrotron source       v=100' 
       thfrcase(1)='time differential transmission spectrum(11) v=100' 
       thfrcase(2)='time differential reflection spectrum(21)   v=100' 
       thfrcase(3)='time integral - rocking curve-Fourier(22)   v=100' 
       thfrcase(4)='time integral - rocking curve(24)           v=100' 
       thfrcase(5)='time integral - rocking curve_fi(25)        v=100' 
       thfrcase(6)='prompt - rocking curve(23)                  v=100' 
       thfrcase(7)='time integral - offspecular(31)             v=001' 
       return 
      end if 
!***********************************************************************
      ncloc=ncl 
      if(ncloc.gt.132)ncloc=132 
      mdastr=dastr 
      nchansp=channels 
!     write(6,'(2a,5i7)')cmch,' ifrcase,mdastr,nchansp=',ifrcase,mdastr,nchansp
      if(cmch.eq.'arr0') then 
!      ++++++++++++++++++++++++ arr0 +++++++++++++++++++++++++++++++++  
!     storage space
!      Data         th_A     th_exp    str_sub
!     |....:.....|.........|.........|..........|
!     ipt ichanDA  ipTH     ipTHyy    ipSI 
      
      if(ifrcase.eq.31) then      
       ipth=6*((nchansp+1)/2)
      else
       ipth=4*((nchansp+1)/2)
      end if
      mpt=0            ! absolute address incremented in common/struct/

       if(nuofdatas.eq.0) then
        ichanks(0)=2; ichanks(1)=1; ichanks(2)=nchansp
       end if
       nstore=0

       vector_k=2*pi/wavelength    ! /Angstroem  
       cv_ET=100.*wavelength       ! mm/s*ns = 10**-7mmm/(10**-9s)*ns 
       iflag_basis=nint(flag_basis) 
       lfwscat=0 
       if(ifrcase.eq.11) lfwscat=1 
                                                                        
      if(ifrcase.le.22) then 
!       time integral - rocking curve-Fourier -------------------       
        nsampling=8 
                                                                        
        iT_max=nint(aiT_max) 
         iT_max2=2**iT_max 
         schrw=cv_ET/abs(T_bunch*iT_max2) 
         nTH=256*2**int(ak_extension)  
         schrw=schrw*float(nTH-1)/nTH 
         ak8=8*nTH 
         ith_channels=1
         jt0_ch=t0_norm*nTH/abs(T_bunch*iT_max2) 
                                                                        
         if(enwr(6)(1:1).eq.'y') then 
          print'(a,i5,/,a,/a,i3)',                              &
           ' number of channels of the theory=',nTH,            &
          '(in order to fulfil the FFT-conditions)',            &
          '  and number of channels for t0_norm=',jt0_ch                
         end if 
!        write(6,'(a,2f15.5,3i6)')'T_bunch,aiT_max,iT_max,iT_max2,nth=', &
!                                  T_bunch,aiT_max,iT_max,iT_max2,nth
!        write(6,'(a,4i6)') 'jt0_ch,nTH,nth=',jt0_ch,nTH,nth

         if(nTH.gt.4*maxn) then 
          info=nTH 
          if(ifrcase.eq.22) then 
           infotext(1)='<Synchrotron-time_integral>/synmos/channels' 
          else 
           infotext(1)='<Synchrotron-time_differential>/synmos/channels' 
          end if 
          infotext(2)=' number of channels too large' 
          infotext(3)=' ' 
          return 
         end if 
         nCP=0 
         if(ifrcase.eq.11.or.ifrcase.eq.21) then 
          nCP=nTH 
          nsrw=1 
          do while(2*nCP.gt.maxn) 
           nCP=nCP/2 
           nsrw=nsrw*2 
          end do 
         end if 
!        write(6,'(a,3i4)')'fr_synchrotron nTH,nCP,nsrw=',nTH,nCP,nsrw        
                                                                        
         jshift=t_shift/T_bunch*2.*nTH 
         if(abs(jshift).gt.maxn) then 
          info=jshift 
          if(ifrcase.eq.22) then 
           infotext(1)='<Synchrotron-time_integral>/synmos/timeshift' 
          else 
          infotext(1)='<Synchrotron-time_differential>/synmos/timeshift' 
          end if 
          infotext(2)='t_shift channels too large' 
          infotext(3)=' ' 
          return 
         end if 
                                                                        
!        write(6,'(a,2f10.1)')'ch_angle=',ch_angle,schrw                     
         srw8=schrw/8. 
         nLG=nTH*8                     ! nLG <= 32 maxn
                                                                        
         if(ifrcase.lt.22) then 
          nTH1=nTH/iT_max2/2 
          nTH2=0
         end if 
         if(ifrcase.eq.22) then 
          nTH1=int(ch_angle/4.)*2 
          nTH2=int(ch_angle/4.)*2 
         end if 
         nstorLG=0! (nLG+1)   ! Lorentz-Gauss curves iflag_SAMP=1
!        write(6,'(a,/,8i6)')'A ifrcase,nLG,mGA,nstorLG,nTH,nCP=',&
!                             ifrcase,nLG,mGA,nstorLG,nTH,nCP
       else if(ifrcase.eq.23) then 
!       ifrcase=23 prompt  ------------------------------------------   
         nsampling=8 
         nCP=0 
         nTH=0 
         srw8=0. 
         nstorLG=0 
         nTH1=int(ch_angle/4.)*2 
         nTH2=16+nTH1
         nstore=0 
       else if(ifrcase.eq.24) then 
!        time integral - rocking curve--------------------------------   
         nstrob_order=strob_order    ! obtained from subtheory  
!                                        called on level 0              
!        vector_k=2*pi/wavelength    ! /Angstroem                       
!        cv_ET=100.*wavelength       ! mm/s*ns                          
         nsampling=2**th_sampling 
                                                                        
!        indirect definition of nomega by v_max
         schrw=v_max/th_channels 
         nomega=cv_ET/T_bunch/schrw 
         i=nomega/2 
         nomega=2*i 
         schrw= cv_ET/T_bunch/float(nomega) 
                                                                        
!        nTh are the total number of channels needed for the strobo 
!        integration technique
         ith_channels=nint(th_channels) 
         nTH=ith_channels+nomega*nstrob_order 
         ak8=8*nTH 
         nTH=nTH*8/nsampling 
                                                                        
         if(enwr(6)(1:1).eq.'y') then 
          print'(a,f10.2,2(a,i5))',                                &
            ' v_max=',v_max,' nomega=',nomega,                     &
            '  and number of channels of the theory=',nTH                 
         end if 
         if(nTH.gt.2*maxn) then 
          info=nTH 
          infotext(1)='<Synchrotron-time_integral>/synmos//channels' 
          infotext(2)=' number of theory channels too large' 
          infotext(3)=' ' 
          return 
         end if 
                                                                        
         nCP=0 
         srw8=schrw/8 
         nLG=(2*ith_channels+nomega*nstrob_order)*8 
                                                                        
         nTH1=int(ch_angle/4.)*2 
         nTH2=nTH1 
         nstore=0 
         nstorLG= 0! 5+(nLG+1)    ! Lorentz-Gauss curves
!        write(6,'(a,2i8)')'B ifrcase, nstorLG=',ifrcase, nstorLG
       else if(ifrcase.eq.25.or.ifrcase.eq.31) then 
        if(ifrcase.eq.25)then
!        time integral - rocking curve_fi ----------------------------  
!                                              called on level 0        
         nstrob_order=strob_order      ! obtained from subtheory 
         nhyperfine=th_channels
         nstore=0 
         nstorLG=0         ! case=2 (no sampling)-routine is called 
!                            only true if flag_SAMP=0                     
        else if(ifrcase.eq.31) then 
!        time integral - offspecular ---------------------------------  
                                                                        
!        for the theory  "time integral - offspecular" the common block 
!        common/acstrf/ is rearranged (see subroutine thstr_synoffspec i
!        thstr_synmos.f) Some constants are different                   
!        according to the definition of the common block in thstr_synoff

!                   wavelength,uthick,                             &
!                   unit_chi,aiT_max,v_max,                             &
!                   ak_extension,T_bunch,dastr,channels,                &
!                   ch_angle,graz_beg,graz_end,t0_norm,flag_basis,      &
!                   th_channels,th_sampling,                            &
!                   strob_order,m_window,omega,
                                                                       
!        is replaced by (case1)                                                
!               wavelength,uthick,                             &
!               unit_chi,4, vmax_hypf[mm/s],n_TH,T_bunch,8,channels,  
!               10,strob_order,12,t1_window,t2_window,flag_basis,
!               nch_hyperfine,show_angles,Approximation,n_omega,omega_be
!               omega_end,ntheta,theta_begin,delta_theta(24)             
!        We get the numbers for the calculation of reservation of storag
         b_theory=.true.
         nstrob_order=graz_beg 
         n_angpairs=strob_order 
         n_theta=dumcsp(3) 
         nhyperfine=th_sampling
        end if 
!        write(6,'(a,5i5)')'nstrob_order,n_angpairs,n_theta,nhyperfine=',&
!                     nstrob_order,n_angpairs,n_theta,nhyperfine
         
                                                                        
!       vector_k=2*pi/wavelength    ! /Angstroem                        
!       cv_ET=100.*wavelength       ! mm/s*ns                           
!       v_max is the velocity according to the hyperfine energies       
!       for 57Fe H_field=33T ca. 8mm/s                                  

!       th_channels is the number of channels for v_max. The channel    
!       width schrw=v_max/th_channel should not exceed 2*gamma,         
!       gamma is the natural line width (0.097mm/s for 57Fe)            
                                    ! nch_TH                            
        nTH=int(ak_extension) 
!       storage for the Cmatrices of each site                          
        k1=0 
                                                                        
        if(nTH.gt.4*maxn) nTH=4*maxn 
        j=maxn/(1.+float(nstrob_order)*cv_ET/T_bunch/v_max/2.) 
        if(nhyperfine.gt.j)nhyperfine=j 
                                                                        
        schrw=v_max/float(nhyperfine) 
        nomega=cv_ET/T_bunch/schrw 
        i=nomega/2 
        nomega=2*i 
                                                                        
        j=nstrob_order*nomega+nhyperfine 
        if(j.ge.nTH)nTH=j+2 
                                                                        
        j=(nTH-nstrob_order*nomega-nhyperfine)*2 
                                                                        
                                                                        
        i=(sqrt(float(4*j+1))-1.)/2. 
!       write(6,'(a,8i5)')'#nvch,nhyperfine=',i,nhyperfine,nTH         
        if(i.gt.1) then 
         j=nTH-nstrob_order*nomega-nhyperfine-i*(i+1)/2 
         do while(j.lt.0.or.i.gt.95) 
          i=i-1 
          j=nTH-nstrob_order*nomega+nhyperfine-i*(i+1)/2 
!          write(6,'(a,6i6)') ' i,j=',i,j,nomega,                       
!     &            nTH-nstrob_order*nomega-nhyperfine                   
         end do 
         if(i.le.95.and.j.gt.0) then 
          nvch=i 
          goto 10 
         end if 
        end if 
                                                                        
   10   schrw=v_max/float(nhyperfine) 
        nomega=cv_ET/T_bunch/schrw 
        i=nomega/2 
        nomega=2*i 
        schrw= cv_ET/T_bunch/float(nomega) 

!       nvch are the number of channels with increasing stepwidth       
!       .. .  .   .    .     .      .       .       . (=nvch=10)        
        if(nvch.gt.95) nvch=95 
        call channels_adjust(nvch,nhyperfine,nstrob_order,nomega,iall)
!        write(6,'(a,8i5)')'nvch,nhyperfine,nstrob_order,nomega,iall=', &
!        nvch,nhyperfine,nstrob_order,nomega,iall                       
                                                                        
        j=nhyperfine+nvch+nstrob_order*nomega/2 
        if(iall.lt.0.or.j.gt.maxn) then 
         nhyperfine=nhyperfine-2 
         if(nhyperfine.lt.32)then 
          nstrob_order=nstrob_order-1 
          nhyperfine=nhyperfine+2 
          k1=k1+1 
         end if 
         goto 10 
        end if 
                                                                        
        j=ichall(iall) 
        if(j.gt.nTH.or.j.gt.4*maxn)then 
         nvch=nvch-2 
!         write(6,'(a,5i6)') ' nTH,nvch,iall=',j,nTH,nvch,iall          
         k1=k1+1 
         goto 10 
        end if 
                                                                        
        if(k1.eq.0) then 
         k1=k1-1 
         goto 10 
        end if 
        nTH=ichall(iall) 
!        nTH=494                                                        
!        schrw=0.1402                                                   
        ith_channels=nhyperfine 
        srw8=schrw 
        nsampling=1 
!       nhyperfine,nstrob_order,nomega,nvch,nTH determine iall,ichall   
!       iall is limited by maxn -> -maxn:maxn are the size of arrays    
!       these values are transported by common/struct/                  
!                  iflag_basis,lfwscat,nLG,nTH,ith_channels,nsampli
!                   ak8,nomega,srw8,nstrob_order,jt0_ch,iT_max,nvch,   
!                   idex(3)                                            
                                                                        
        if(n_angpairs.eq.0) then 
        print'(a,/,a,i5,2(a,f8.3),/,2(a,i5),/,3(a,i5),a2,i4,/,2a)',     &
         'at least one of the constants have been altered:',            &
         ' nch_hypf    =',nhyperfine,'    v(nTH) =',nTH*schrw,          &
         '     dv =',schrw,                                             &
         ' nstrob_order=',nstrob_order,'    nomega=',nomega,            &
         ' ch_TH       =',nTH,'    ch_used=',iall,'  ch_intr. =',       &
          nhyperfine+nvch,' /',nhyperfine+nvch+nstrob_order*nomega/2,   &
         'these values are compatible with each other',                 &
         ' and all array sizes'                                         
        end if 

        if(ifrcase.eq.25) then 
         nstore=0 
         nstorLG=0         ! case=2 (no sampling)-routine is called 
!                             only true if flag_SAMP=0                     
         nTH1=int(ch_angle/4.)*2 
         nTH2=int(ch_angle/4.)*2 
        else if(ifrcase.eq.31) then 
         k1=(nhyperfine+nvch)*2                   ! used in Gamma_mju()  
         nstore=0                                 ! storage of trace() fo
         do nstrob=0,nstrob_order                 ! nstrob_order loop 
          nstore=nstore+(k1+nstrob*nomega)/2+1 
         end do 
!        write(6,'(a,10f10.2)')'dumcsp=',strob_order,(dumcsp(i),i=1,5)   
         nstorLG=0          ! case=2 (no sampling)-routine is called  
         nTH1=0             ! storage of offspec at l1_get(0)+6 
!        calculated in  th_scanmode(), here only to preserve shape of ifr
         nTH2=0
        end if
       end if    ! ifrcase
                                                                        
!      nTH+1 is the out of synmos , nchansp/2 for thyy in syn_the2exp   
!      both on array_fr, yth is calculated from nTH+1 -> nchansp/2      
!      and linear t_scale with tshift=0                                 
                                                                        
       ifrsto=ipTH+nTH1+nTH2+nstore+(nchansp+1)/2 

!      the relativ addresses are stored after finishing                 
!      the entries arr0,i,e                                             
       nstorTH=ipTH 
       nstorTH1=nstorTH+nTH1 
       nstorTHyy=nstorTH1+nTH2+nstore       ! calculated values (nchansp
!                                             for each measured point   
       nstorSI=0 !nstorTHyy+(nchansp+1)/2   ! the maxsub*(1+maxthss)
!                                             are needed for i_int in ro
!                                             select.f of subspectra    
!      the relativ addresses are reloaded before entering fr_theoryxx   
!      and changed to absolute addresses which are temporarily stored   
!      the 8 integers following c3_prp(maxthss) are considered to be    
!      relative addresses which during reloading are changed to absolute
!      addresses of the complex array  'array_fr(1:marray_sp).  

!   write(6,'(a,/,3x,6i7,4i8)') & 
!  'arr0 ipTH, nTH1, nTH2,nstore,nstorTH,nstorTH1,nstorTHyy,nstorSI,ifrsto',&
!        ipTH,nTH1,nTH2,nstore,nstorTH,nstorTH1,nstorTHyy,nstorSI,ifrsto

       return 
      else if(cmch.eq.'arri')then 
!      ++++++++++++++++++++++++++ arri +++++++++++++++++++++++++++++++++
       ifrsto=0 
       call l_structure(jss,lstruct1,lstruct2,lstruct3) 
!       ifrsto=100+jss                                                  
       if(lstruct3.eq.0) then 
        if(lstruct2.eq.0) then 
!        lstruct1#0 , incoherent sum over mstruct1 members              
         if(mstruct1.gt.1) ifrsto=maxn 
        else 
         if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then 
          ifrsto=8*(nTH+1) 
         end if 
        end if 
       end if 
                                                                        
       return 
      else if(cmch.eq.'arre')then 
!       +++++++++++++++++++++++++++ arre +++++++++++++++++++++++++++++++
       ifrsto=0 
       return 
      end if ! arr0,i,e      
!      write(6,'(a,/,8i8)')                                             
!     &'iarray_sp,nstorFR,l1_put(0),nstorTH,nstorTH1,nstorTHyy,nstorSI='
!     & iarray_sp,nstorFR,l1_put(0),nstorTH,nstorTH1,nstorTHyy,nstorSI  
!      write(6,'(a,/,6i8,f12.3)')                                       
!     & 'nTH,nTH1,ak8,nLG,nsampling,mdastr,srw8=',                      
!     &                   nTH,nTH1,ak8,nLG,nsampling,mdastr,srw8        
!     initializing the array_fr section for nstorint (see subspectra)   
!     (intensity of all subsets are 0)                                  

                                                                        
      n5_offspec(1)=l1_get(0) 
      n5_offspec(2)=channels 
!      n5_offspec(3)=th_sampling 
      n5_offspec(3)= strob_order 
      n5_offspec(4)=counts 
      n5_offspec(5)=background  
!     pointer                                                           
!      write(6,'(a,L5,5i7)')' b_data mdastr=',b_data,mdastr             
      m1=mstruct1 
      m3=istruct2(istruct1(mstruct1)) 
!      storag on real_fr(2*(iarraysp+nstorFR)+m) (array_fr)              
!      corresponds to the i= drive_mode (label 100)                     
      mfpt=2*mpt                  ! measured (function) data  
      if(ifrcase.eq.31) then 
       mdfpt=mfpt+nchansp         ! errors of f data (calculated by sqrt
       mxpt=mfpt+2*nchansp        ! x data (angle)                      
       mypt=mfpt+3*nchansp        ! y data (angle)                      
       mgrpt=mfpt+4*nchansp       ! address for x group of angle        
       mlpt=mgrpt+nchansp
      else                     
       mdfpt=mfpt+nchansp         ! errors of y data (calculated by sqrt
       mxpt=mfpt+2*nchansp        ! x data (angle) mdastr=3             
       mlpt=mxpt+nchansp
      end if
!      write(6,'(a,/,6i7)')' mpt,ipTH,nstorTH,nstorTH1,nstorTHyy,nstorSI=',&
!            mpt,ipTH-mpt,nstorTH-mpt,nstorTH1-mpt,nstorTHyy-mpt,nstorSI-mpt
!      write(6,'(a,5i7)')'mfpt,mdfpt,mxpt=',mfpt/2,mdfpt/2,mxpt/2
!***********************************************************************
    select case(cmch)
    case('dstr')
      if(ifrcase.eq.31) then 
       call offspec_plot(cmch,n5_offspec,info) 
       data_str=formdata(1) 
       call data3dread(0,info) 
      else 
       call syn_plot(cmch) 
       data_str=formdata(mdastr) 
       call data2dread(0,info) 
      end if 
    case('data')
      k1=jss 
      if(ifrcase.eq.31) then 
       call data3dread(k1,info) 
      else 
       call data2dread(k1,info) 
      end if 

    case('ecic') 
      if(ifrcase.eq.31) then 
       call excinc3d(info) 
      else 
       call excinc2d(info) 
      end if 
    case('test')
!     'test': theory function is calculated in subroutine mossbauer     
      k1=1 
      if(ifrcase.eq.31) then 
       call synoffspec_the2exp(k1,info) 
      else 
       call syn_the2exp(k1,info) 
      end if 
!     write(6,'(a)') ' after syn_the2exp  test'                         
    case('dfdp')
!     derivatives df                                                    
      k1=2 
      if(ifrcase.eq.31) then 
       call synoffspec_the2exp(k1,info) 
      else 
       call syn_the2exp(k1,info) 
      end if 
    case('subs')
!     subs, subt                                                        
      text(1)='       scatterer' 
      text(2)=' incoherent part' 
      text(3)='                ' 
      if(info.eq.-1.and.n_subset.ne.0) return 
      print '(a)',' ' 
      print '(a)','           **subspectra** ' 
      print '(a)','  are not additive in the time domain' 
      ch1=' ' 
      if(b_data) then 
       ch132=name_data 
      else 
       ch132=name_theory 
      end if 
      call chcenter(ch132,ch1,ncloc) 
      cp132='plot of subspectra of' 
      call chcenter(cp132,ch1,ncloc) 
      print '(a)',' ' 
      print '(a,/,a)', cp132(:ncloc),ch132(:ncloc) 
      ch132='subspectra /added subspectra of' 
      call chcenter(ch132,ch1,ncloc) 
      print'(/,a)', ch132(:ncloc) 
      call syn_selsubset(text) 

    case('subt')
!     call of subtract                                                     
      print '(a)',' ' 
      print '(a)','          subtraction of subspectra' 
      print '(a)','      has no meaning in the time domain' 
    case('plex') 
      k1=0 
      if(b_theory) k1=1 
      k2=1  ! 0: only plot and return, 1: interactive plot 
       if(ifrcase.eq.31)then
        k2=3
        if(ndisplay_mode.gt.2)k2=1
     end if
      call xmosplo(k1,k2) 
    case('ple2') 
!      plot execute                                                      
       k1=2   ! update test 
       k2=1   ! 0: only plot and return, 1: interactive plot 
       if(ifrcase.eq.31)then
        k2=3
        if(ndisplay_mode.gt.2)k2=1
       end if 
       call xmosplo(k1,k2) 
    case('ple3') 
!      plot execute                                                      
       k1=3   ! update fit 
       k2=1   ! 0: only plot and return, 1: interactive plot 
       if(ifrcase.eq.31)then
        k2=3
        if(ndisplay_mode.gt.2)k2=1
       end if 
      call xmosplo(k1,k2) 
    case('dmod') 
!      display mode , filling of plotarray                               
       if(ifrcase.eq.31) then 
        n5_offspec(1)=l1_get(0) 
        call offspec_plot(cmch,n5_offspec,info) 
       else 
         call syn_plot(cmch) 
       end if 

    case('plot')
       if(b_theory)then 
        k1=1 
        if(ifrcase.eq.31) then 
         call synoffspec_the2exp(k1,info) 
        else 
         call syn_the2exp(k1,info) 
        end if 
        if(n_subset.gt.0)call syn_subset(m1,m3,'subs',isub,info)
        if(info.gt.0) return 
       end if 
!       write(6,'(a,a4,4i6)')' fr_synmoss cmch,ifrcase,dastr=', &        
!                                cmch,ifrcase,int(dastr)          
       if(ifrcase.eq.31) then 
        n5_offspec(1)=l1_get(0) 
        n5_offspec(2)=channels 
        n5_offspec(3)=strob_order
        n5_offspec(4)=counts 
        n5_offspec(5)=background 
        call offspec_plot(cmch,n5_offspec,info) 
       else 
        k1=3 
        call syn_the2exp(k1,info) 
        call syn_plot('plot') 
       end if 

    case('punc')          
      k1=jss 
      if(ifrcase.eq.31) then 
       call punch3d(k1,info) 
      else 
       call punch2d(k1,info)
       cmch='dim2' 
      end if 
    end select 
    return 
    END                                           
                                                                        
                                                                        
                                                                        
     subroutine syn_the2exp(n1,info) 
     use glbconst, only: maxfr1,maxfr2,maxn,maxthss,icstrf,ivstrf,max8,infotext
     use comdat, only: mxpt,mlpt,b_data,b_theory
     use comthe, only: real_fr,ifrcase,thfk,dfdp,ddpk,ib_df,kana
     use complt, only: n_subset
! ****************************************************************     
!    n1 = 0 error return                                               
!    n1 = 1 call of theory                                             
!    n1 = 2 derivatives                                                
!    n1 = 3 call of theory , calpl is not called                       
! ****************************************************************     
     implicit none 
     integer, intent(in) :: n1
     integer, intent(out):: info
                                                                       
     integer, parameter:: istr=38+4*(maxfr1+maxfr2)+3*maxthss
     integer       dstr,nstorTH,idum,nstorTHyy,iaddr
     common/struct/dstr(istr+2),nstorTH,idum,nstorTHyy,iaddr(3)

     integer       nTH1,dum,nexp,ifrth,idum1,idum2,ith_channels,ien 
     real          xb_the,dx_the
     common/strLOC/nTH1,dum(4),nexp,ifrth(6),idum1(4),ith_channels,&
                   idum2(9),xb_the,dx_the,ien(4)                              
                                                                       
     real          acsp,wavelength,uthick,                             &
                   unit_chi,aiT_max,v_max,                             &
                   ak_extension,T_bunch,dastr,channels,                &
                   ch_angle,graz_beg,graz_end,dumcsp                   
     common/acstrf/acsp,wavelength,uthick,                             &
                   unit_chi,aiT_max,v_max,                             &
                   ak_extension,T_bunch,dastr,channels,                &
                   ch_angle,graz_beg,graz_end,dumcsp(icstrf-13)        
                                                                       
     real          avsp,counts,background,Pdum,t_shift,dumvsp 
     common/avstrf/avsp,counts,background,Pdum(8),                     &
                   t_shift,dumvsp(ivstrf-12)                           
                                                                       
     logical       b_vs,b_counts,b_background,b_Pdum,                  &
                   b_t_shift,b_graz_min,b_dumvsp                       
     common/bvstrf/b_vs,b_counts,b_background,b_Pdum(8),               &
                   b_t_shift,b_graz_min,b_dumvsp(ivstrf-13)            
                                                                       
     logical b_total,b_residual 
                                                                       
     real    countsy,dx_exp,xb_exp, y1,y2,yi,ff,hi                   
     integer nthe,iT_max,iT_max2,invers,ipnth,ji,i,k,k1,nn,j,mdastr 
     integer, save:: ipntho=0                                 
     real, dimension(:), allocatable, save:: x_exp                                    
     real, dimension(:), allocatable, save:: yth
!----------------------------------------------------------------------          
       call mapsub(0,0,0)                                               
!----------------------------------------------------------------------
                                                           
      mdastr=dastr 
      nexp=channels   ! number of channels to be displayed
      ! not the number of calculated channels!!
      do i=1,nexp
         real_fr(mlpt+i)=0.0
      end do
      !penalty function required by subroutine fit.f90

      
      nthe=nTH1*2
      if(ifrcase.ge.22) then 
       dx_the=abs(graz_end-graz_beg)/(ch_angle-1.0) 
       dx_exp=abs(graz_end-graz_beg)/(channels-1.0) 
       xb_the=graz_beg+t_shift 
       xb_exp=graz_beg 
       invers=0 
       if(dx_the.lt.0) then 
        invers=nexp+1 
        dx_the=-dx_the 
       end if 
      else 
       if(mdastr.eq.1)then
        xb_the=0.0
        dx_the=abs(T_bunch)/nthe 
        dx_exp=abs(abs(t_shift)+T_bunch)/channels 
        xb_exp=t_shift 
        invers=0 
       else
        xb_the=t_shift 
        dx_the=abs(T_bunch)/nthe 
        dx_exp=abs(T_bunch)/channels 
        xb_exp=0.0 
        invers=0 
        if(T_bunch.lt.0) invers=nexp+1 
       end if
      end if

      if(b_data)then
       if(mdastr.lt.3)then
        hi=xb_exp-dx_exp 
        do k=1,nexp 
         hi=hi+dx_exp 
         real_fr(mxpt+k)=hi 
        end do
       else
        if(ifrcase.gt.21.and.ifrcase.lt.30)then
         if(real_fr(mxpt+1).lt.graz_beg.or.real_fr(mxpt+nexp).gt.graz_end)then
         print '(a,2f10.3)','graz_beg(data),graz_beg=',real_fr(mxpt+1),graz_beg
         print '(a,2f10.3)','graz_end(data),graz_end=',real_fr(mxpt+nexp),graz_end
         info=1 
         infotext(1)='<Synchrotron_spectrum>/grazing_interval' 
         infotext(2)='wrong constants: graz_beg > graz_beg(data) '
         infotext(3)='       or        graz_end < graz_end(data)'
         infotext(4)='change constants {co } , storage change? => {sd }'       
         infotext(5)=' ' 
         return
         end if       
        end if 
       end if
      else
       mdastr=1
       hi=xb_exp-dx_exp 
       do k=1,nexp 
        hi=hi+dx_exp 
        real_fr(mxpt+k)=hi 
       end do 
      end if
!     call x_data(mdastr,b_data,mxpt,nexp,xb_exp,dx_exp) 
!     xb_exp is not correct if x-data are read from file      
!     it is correct after calling x_data()                             
 
      i=size(x_exp)
      if(allocated(x_exp).and.i.lt.nexp)deallocate(x_exp)
      if (.not.allocated(x_exp))allocate(x_exp(nexp))
      do i=1,nexp
       x_exp(i)=real_fr(mxpt+i)
      end do

      i=int((x_exp(1)-xb_the)/dx_the)
      ipnth=abs(i)+1
      ji=abs(int((x_exp(nexp)-xb_the)/dx_the)-nthe)+1
      if(ji.gt.ipnth)ipnth=ji
!      write(6,'(a,/,i8,2x,5f8.2)')'ipnth,x_exp(1),x_exp(nexp),xb_the,dx_the=',&
!                                    ipnth,x_exp(1),x_exp(nexp),xb_the,dx_the 
     
      i=size(yth)
      if(allocated(yth).and.                                          &
        (ipnth.gt.ipntho.or.i-ipntho-1.lt.nthe+ipnth))deallocate(yth)
      if (.not.allocated(yth))allocate(yth(-ipnth:nthe+ipnth))
      ipntho=ipnth

      countsy=counts-background*channels 
      if(ifrcase.ge.22) then 
       countsy=countsy/channels*nTH1 
      else 
       iT_max=aiT_max 
       iT_max2=2**iT_max 
!      write(6,'(a,i6,f15.5)') 'iT_max2=',2**iT_max                     
      end if 

!     write(6,'(8f10.5)') (yth(i)*100.,i=-2,nthe,16)                    
!     write(6,'(8f12.2)') (yth(i)*countsy,i=1,nTH1)                     
!      write(6,'(4(a,f10.5),a,i4)') ' ***synchrotron*** backgr=',       
!     &         background,' aiT_max=',aiT_max,' dx_the=',dx_the,       
!     &         '  t_shift=',t_shift,'  nexp=',nexp                     
!      write(6,'(a,6L5)')',b_total,b_background,b_counts,b_t_shift =',  
!     &             b_total, b_background,b_counts,b_t_shift            
                                                                       
       k1=n1 
      goto (100,200,300),k1 
                                                                        
  100 continue 
!     calculation of thfk                                               
      if(ifrcase.ge.22) then 
       call synrocking(b_total,info) 
      else 
       call synchrotron(b_total,info) 
      end if 
                                                                         
      nn=nstorTH*2 
      do j =1,nthe 
       yth(j)=real_fr(nn+j) 
      end do
      do k=0,ipnth
       yth(-k)=0. 
       yth(nthe+k)=yth(nthe) 
      end do
!      write(6,*)'yth: ipnth,invers,nexp,nthe,xb_the,dx_the=',   &
!                      ipnth,invers,nexp,nthe,xb_the,dx_the
!      write(6,'(a,i8)')'nstorTH*2=',nstorTH*2  
!      write(6,'(8f10.3)') (yth(k),k=1,nthe,16)
                                                                        

      do j=1,nexp 
       ji=abs(invers-j) 
       hi=(x_exp(ji)-xb_the)/dx_the 
       i=int(hi) 
       if(i.le.0)i=i-1 
       hi=hi-float(i) 

!       y2=yth(i-2)+yth(i+2)                                            
!       y1=yth(i-1)+yth(i+1)                                            
!       aa=(2.0*y2-y1-yth(i))/14.0                                      
!       bb=(-2.0*(yth(i-2)-yth(i+2))-yth(i-1)+yth(i+1))/10.0            
!       cc=(-3.0*y2+12.0*y1+17*yth(i))/35.0                             
!       yi=cc+hi*(aa*hi+bb)                                             
       y1=yth(i) 
       y2=yth(i+1) 
       yi=y1+hi*(y2-y1) 
       if(yi.lt.0.)yi=0. 
       thfk(j)=yi*countsy+background 
      end do 
                                                                        
                                                                        
      nn=nstorTHyy*2 
      do j=1,nexp 
       real_fr(nn+j)=thfk(j) 
      end do 
!      write(6,*)' 100 theory thfk(1:nexp)' 
!      write(6,'(6g12.3)')(thfk(j),j=1,nexp,8) 
      b_theory=.true. 
      return 
                                                                        
  200 continue 
      ib_df=0 
!      write(6,'(a,g12.3)')' pg_synmos ddpk=',ddpk                      
                                                                        
!     derivatives                                                       
!     ib_df=1: derivative calculated                                    
!     ib_df=0 happens if a parameter of a set, wich is not currently    
!     fitted, is free. It will be fixed in the routine fit.             
                                                                        
!     analytical and numerical derivatives are handled fdifferently     
!     integer kana (k analytical) = 1 indicates an analytical derivative
                                                                        
!     (the fact that a parameter x can mix up variables type            
!      complicates the situation. An analytical derivative of a variale 
!      can only be calculated, if it is not connected to a different    
!      parameter by the transformation matrix)                          
                                                                        
!     variable background, counts are analytically derived              
!     the total number of variables of the set is contained in b_total  
!     (for all variables of synchrotron, synrock) and the glabal        
!     variables of this routine: counts,background,t_shift              
!     t_shift is numerically derived (enters x_data by xb_the)         
                                                                        
!      common/avstrf/avsp,counts,background,dum0,Pxsi,Peta,Pzeta,            
!     &          PA0,PAxsi,PAeta,PAzeta,t_shift,graz_angle,graz_min,        
!                phi_z,dumvsp(idumvsp)                                  
                                                                        
      b_total=b_total.or.b_t_shift 
                                                                        
      b_residual=.not.(b_total.or.b_counts) 
!     all variables unchanged but background                            
                                                                        
      if(b_background.and.b_residual) then 
!       write(6,'(a)')  '   derivative of background ------------'      
        do j=1,nexp 
         dfdp(j)=1.0 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
      end if 
!     for background derivative the last theory values were not neccessa
      nn=nstorTHyy*2 
      do j=1,nexp 
       thfk(j)=real_fr(nn+j) 
      end do 
!     write(6,'(8f10.5)') (thfk(i),i=1,nexp,18)                         
                                                                        
      b_residual=.not.(b_total.or.b_background) 
!     all variables but counts                                          
      if(b_counts.and.b_residual) then 
!       write(6,'(a)')  '   derivative of counts ------------'          
        do j=1,nexp 
         dfdp(j)=(thfk(j)-background)/countsy 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
      end if 
                                                                        
      if(ifrcase.ge.22) then 
       call synrocking(b_total,info) 
      else 
       call synchrotron(b_total,info) 
      end if 
                                                                        
!     numerical derivatives                                             
      b_residual=.not.(b_total.or.b_background.or.b_counts.or.          &
     &                b_graz_min)                                       
!     (b_residual=.true.: parameter is connected only to variables      
!     of other sets                                                     
!      write(6,'(a,l5,g15.3)')'fr_synmoss b_resid.,ddpk=',b_residual,ddp
      if(b_residual) goto 250 
                                                                        
      kana=0 
      nn=nstorTH*2 
      do j =1,nthe 
       yth(j)=real_fr(nn+j) 
      end do 
      do k=0,ipnth
       yth(-k)=0. 
       yth(nthe+k)=yth(nthe) 
      end do 

      do j=1,nexp 
       ji=abs(invers-j) 
       hi=(x_exp(ji)-xb_the)/dx_the 
       i=int(hi) 
       if(i.le.0)i=i-1 
       hi=hi-float(i) 
       y1=yth(i) 
       y2=yth(i+1) 
       ff=y1+hi*(y2-y1) 
       dfdp(j)=(ff*countsy+background-thfk(j))/ddpk 
      end do  ! j=1,nexp       
      ib_df=1 
                                                                        
  250 continue 
      return 
                                                                        
  300 continue 
!     calculation of thfk 
      if(.not.b_theory) goto 310 
      if(n_subset.gt.0)call synchrotron(b_total,info) 
      nn=nstorTH*2 
      do j =1,nthe 
       yth(j)=real_fr(nn+j) 
      end do 
      do k=0,ipnth
       yth(-k)=0. 
       yth(nthe+k)=yth(nthe) 
      end do 

!      if(ndisplay_mode.gt.1) then 
       do j=1,nexp 
        ji=abs(invers-j) 
        hi=(x_exp(ji)-xb_the)/dx_the 
        i=int(hi) 
        if(i.le.0)i=i-1 
        hi=hi-float(i) 
        y1=yth(i) 
        y2=yth(i+1) 
        yi=y1+hi*(y2-y1) 
        thfk(j)=yi*countsy+background 
       end do
  310 return 
      END                                           
                                                                        
!                                                                       
     subroutine synchrotron(b_total,info) 
!    ifrcase=1  ! forward scattering geometry                          
!    ifrcase=2  ! grazing incidence geometry,time differential         
     use glbconst, only: maxfr1,maxfr2,maxn,maxthss,maxscrd,&
                         icstrf,icfr2trf,&  
                         ivstrf,ivfr1trf,ivfr2trf,ivsstrf,enwr     
     use comthe, only: mLG,array_fr,real_fr,ifrcase
     implicit none 
     logical, intent(out):: b_total 
     integer, intent(out):: info  
                                                                       
     integer     mstruct1,istruct1,istruct2,                           &
                 l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,            &
                 nstorTH,nstorTH1,mpt,ipTH,iaddr
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname 
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),mpt,ipTH,nstorTH,nstorTH1,iaddr(4)


     integer       nTH1,nCP,iduma,nsrw,idumb,nexp,ifrth,                &
                   iflag_basis,lfwscat,idumc,nTH,ith_channels,idumd,    &
                   idum,jt0_ch,iT_max,ien                               
     common/strLOC/nTH1,nCP,iduma,nsrw,idumb,nexp,ifrth(6),             &
                   iflag_basis,lfwscat,idumc,nTH,ith_channels,idumd,    &
                   idum(4),jt0_ch,iT_max,ien(8)                  
                                                                       
     real          acsp,wavelength,uthick,unit_chi,dumcsp 
     common/acstrf/acsp,wavelength,uthick,unit_chi,dumcsp(icstrf-4) 
                                                                       
                                                                       
     real          avsp,counts,background,dum0,Pxsi,Peta,Pzeta,        &
                   PA0,PAxsi,PAeta,PAzeta,t_shift,graz_angle,phi_z,dumvsp  
     common/avstrf/avsp,counts,background,dum0,Pxsi,Peta,Pzeta,        &
                   PA0,PAxsi,PAeta,PAzeta,t_shift,graz_angle,phi_z,    &
                   dumvsp(ivstrf-14)                                   
                                                                       
     logical       b_avsp,b_counts,b_background,b_dum0,b_Pxsi,b_Peta,   &
                   b_Pzeta,b_PA0,b_PAxsi,b_PAeta,b_PAzeta,b_t_shift,    &
                   b_graz_angle,b_phi_z,b_dumvsp  
     common/bvstrf/b_avsp,b_counts,b_background,b_dum0,b_Pxsi,b_Peta,   &
                   b_Pzeta,b_PA0,b_PAxsi,b_PAeta,b_PAzeta,b_t_shift,    &
                   b_graz_angle,b_phi_z,b_dumvsp(ivstrf-14)
                                                                       
     real            avfr1,pvfr1,dumvfr1 
     common/avfr1trf/avfr1,pvfr1,dumvfr1(ivfr1trf-2) 
     logical         b_vfr1,b_pvfr1,b_dumvfr1 
     common/bvfr1trf/b_vfr1,b_pvfr1,b_dumvfr1(ivfr1trf-2) 
                                                                       
     real            acfr2,rep_grp,dumcfr2 
     common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2) 
                                                                       
     real            avfr2,thicklay,re_chilay,ai_chilay,roughness,     &
                     dumvfr2                                           
      common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,    &
                     dumvfr2(ivfr2trf-5)                               
     logical         b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,        &
                     b_roughness,b_dumvfr2                             
     common/bvfr2trf/b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,        &
                     b_roughness,b_dumvfr2(ivfr2trf-5)                 
                                                                       
     real           vsstrf,sftr 
     common/avsstrf/vsstrf(ivsstrf) 
     logical        b_vsstrf,b_sftr 
     common/bvsstrf/b_vsstrf(ivsstrf) 
                                                                       
     logical  b_lay,b_isgt1,b_HeangleLS 
     logical,dimension(maxfr2):: b_sites
     real,dimension(maxfr1) :: winc
     real,dimension(maxfr2) :: vkd
     real,dimension(maxthss):: wi
                                                                       
     integer i,isubthe,icmp,is_a,is_e,isctp,inc_pos,j,jj,jt0,k,     &
             ll,lstruct1,lstruct2,lstruct3,lay,mlay,layb,laye,    &
             lays,mlays,n,nj,nn,npos,nsth2,nt,nTHj 
                                                                       
     real grazing,vector_k,h1,h2,sing,sum,relthick,P0                        
                                                                       
     real,   dimension(maxfr2)    :: thicklayer,roughlay
     integer,dimension(maxfr2)    :: iposlay,laysites
     integer,dimension(2*maxfr2)  :: laystr 
     integer,dimension(0:2*maxfr2):: GEOSTR

                                                                       
     complex hc1,hci,hc0,app,apm,amp,trace,satraceh,R_oo,satrexp

     complex(kind=4),dimension(4)         :: bb,dd,rho,Arho   !,cc,aa
     complex(kind=4),dimension(4,maxfr2)  :: aam
     complex(kind=4),dimension(2,2,maxfr2):: Cmatrix
     complex(kind=4),dimension(maxfr2)    :: chilay
     complex(kind=4),dimension(2,2)       :: Rmatrix 
     complex(kind=8),dimension(4)         :: daa,dbb,dcc 

     real       tthick 
     complex    POC 
     common/scrd/POC(maxscrd/2)
                                                                       
! *** Definitions of structure variables L. Deak 09.10.2002 ***        
     integer POINTER,GRP,MGRP
     logical b_first,b_winc 
! ***                                                       ***
     real,   dimension(:), allocatable :: yth
     complex,dimension(:), allocatable :: carray       

     real,   parameter:: sqrt2r=0.70710678,rad=0.0174533,pi=3.14159 
     complex,parameter:: C0=cmplx(0.,0.)
                                                                    
!      thfrcase(1)='time differential transmission spectrum(11)'       
!      thfrcase(2)='time differential reflection spectrum(21)'         
                                                                       
!c      thfrcase(3)='time integral - rocking curve,Fourier(22)'        
!c      thfrcase(4)='time integral - rocking curve(24)'                
!c      thfrcase(5)='prompt - rocking curve(23)'                       
                                                                       
!      write(6,'(a,2i4)')' th_synmos ifrcase=',ifrcase                 
!      write(6,'(a,f15.3)')' th_synmos t_shift=',t_shift               
       b_total=.false. 
       b_winc=.false.
       b_HeangleLS=.false.  
!------------------------------------------------------------------     
!      L_poincare =0 is used for theories calling optics                
!-------------------------------------------------------------------    

      isubthe=1 
      call get_theory(isubthe,info) 
      b_total= b_total.or.(isubthe.gt.0).or.b_Pxsi.or.b_Peta.or.b_Pzeta   &
                               .or.b_PA0.or.b_PAxsi.or.b_PAeta.or.b_PAzeta
      hc1=cmplx(1.,0.) 
      hci=cmplx(0.,1.) 
      hc0=C0 
                                                                        
      vector_k=2.0*pi/wavelength 
      P0=1.                                                                 
!     fortran notation                                                  
      rho(1)=cmplx(P0+Pzeta,0.)/2. 
      rho(3)=cmplx(Pxsi,-Peta)/2. 
      rho(2)=cmplx(Pxsi,Peta)/2. 
      rho(4)=cmplx(P0-Pzeta,0.)/2. 
                                                                        
      Arho(1)=cmplx(PA0+PAzeta,0.)/2. 
      Arho(3)=cmplx(PAxsi,-PAeta)/2. 
      Arho(2)=cmplx(PAxsi,PAeta)/2. 
      Arho(4)=cmplx(PA0-PAzeta,0.)/2. 

     if(iflag_basis.eq.0) then 
!     if (iflag_basis.eq.0) transformation with TrhoT+
!     T=1/sqrt(2)( 1 -1)
!                (-i -i)   (see iflag_basis.eq.0)
!     Ts_0T+=s_0,Ts_1T+=-s_3, Ts_2T+=s_1, Ts_3T+=-s_2 
      rho(1)= cmplx(P0-Pxsi,0.)/2. 
      rho(3)= cmplx(Peta,Pzeta)/2.  
      rho(2)= cmplx(Peta,-Pzeta)/2.   
      rho(4)= cmplx(P0+Pxsi,0.)/2.  

      Arho(1)= cmplx(PA0-PAxsi,0.)/2. 
      Arho(3)= cmplx(PAeta,PAzeta)/2.  
      Arho(2)= cmplx(PAeta,-PAzeta)/2.   
      Arho(4)= cmplx(PA0+PAxsi,0.)/2. 
     end if

!     write(6,'(a,4f8.2)') ' rho=', rho(1),rho(3)                     
!     write(6,'(a,4f8.2)') '     ', rho(2),rho(4) 

!     write(6,'(a,4f8.2)') ' Arho=', Arho(1),Arho(3)                     
!     write(6,'(a,4f8.2)') '      ', Arho(2),Arho(4) 
!-----------------------------------------------------------            
      relthick=uthick 
      allocate(carray(16*mLG),yth(0:nTH))
                                                                        
      tthick=0. 
      lstruct1=0 
 1000 continue 
      lstruct1=lstruct1+1 
      if(lstruct1.gt.mstruct1) goto 2500 
                                                                        
      call mapsub(lstruct1,0,0) 
                                                                        
      if(ifrcase.gt.11) then 
!      b_HeangleLS change of external field and scatterer orientation   
       do i=1,6 
        b_HeangleLS=b_HeangleLS.or.b_dumvfr1(i) 
       end do 
       b_total=b_total.or.b_HeangleLS 
      end if 
                                                                        
      winc(lstruct1)=pvfr1/float(mstruct1) 
      b_winc=b_winc.or.b_pvfr1 
!      write(6,'(a,i1,a2,i8,L5,f10.2)')'synmos l1_put(',lstruct1,')=',  
!     &   l1_put(lstruct1),b_pvfr1,pvfr1                                
      inc_pos=l1_put(lstruct1) 
                                                                        
!      write(6,'(a,L4,a,g12.4)')' b_graz_angle=',b_graz_angle,          
!     &     ' graz_angle=',graz_angle                                   
      if(lfwscat.eq.0) then 
       grazing=0.001*graz_angle 
       sing=sin(grazing) 
       b_total=b_total.or.b_graz_angle 
      end if 
                                                                        
       layb=istruct1(lstruct1-1) 
       laye=istruct1(lstruct1) 
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
!      ------------------------------------------------------------     
!      layer lay1,2 ... mlay of  absorber                               
!      ---------------------------------------------------------------  
!      The Lorentz curve of the absorber in npq is 1 at resonance so tha
!      for a singl line the exponent at resonance is just -teff (effecti
!      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw
!      normalizes ( to area 1) the Lorentz curve.                       
!                                                                       
!      Sums of absorber curves at the positions Eagd.                   
!                                                                       
!      ----0--------------------------naLG                              
!       naLG--------------------------0-------------        srw8        
!        nTH------------0------------nTH                    srw         
        lay=lstruct2-layb 
                                                                        
        call mapsub(lstruct1,lstruct2,0) 
!        write(6,'(a,3g12.4)')' synmos r,i_chi,unit_chi=',              
!     &        re_chilay,ai_chilay,unit_chi                             
        b_lay=.false.
        if(ifrcase.gt.11) then 
!        external field and scatterer orientation written from fr1 to fr2
!        subr. th_22nuclear routines take the field from common/avfr2trf
         do i=1,6 
          dumvfr2(5+i)=dumvfr1(i) 
          b_dumvfr2(5+i)=b_dumvfr1(i) 
         end do 
         b_lay=b_vfr1
        end if 
                                                                        
                                                                        
         b_lay=b_lay.or.b_vfr2.or.b_HeangleLS.or.b_thicklay 
         b_total=b_total.or.b_lay 
        if(lfwscat.eq.1) then 
         thicklayer(lay)=1. 
         if(thicklay.gt.0.)thicklayer(lay)=thicklay 
        else 
         thicklayer(lay)=thicklay 
         if(abs(re_chilay)+abs(ai_chilay).gt.1.0e-10) then 
          chilay(lay)=cmplx(re_chilay,ai_chilay)*unit_chi 
         else 
          chilay(lay)=C0
         end if 
         i=rep_grp 
         laystr(2*lay-1)=i 
         laystr(2*lay)=10*(rep_grp-float(i)+.01) 
         roughlay(lay)=roughness 
        end if 
                                                                        
        b_isgt1=.false. 
        if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then 
         b_isgt1=.true. 
         iposlay(lay)=l2_put(lstruct2) 
         carray=C0
        end if 
        b_sites(lay)=.false. 
                                                                        
        do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
                                                                        
         icmp=lstruct3 
         b_sites(lay)=.true. 
                                                                        
         call mapsub(lstruct1,lstruct2,lstruct3) 
                                                                        
         sftr=vsstrf(2) 
         b_sftr= b_vsstrf(2) 
         wi(icmp)=sftr*relthick 

!         write(6,'(i3,2x,a,i4,3g10.3)')lstruct1,                       
!     &    'synmos lay,wi,sftr,winc=',lay,wi(icmp),sftr,winc(lstruct1)  
          tthick=tthick+sftr*winc(lstruct1) 
!         if(lstruct1.eq.mstruct1)write(6,'(a,f12.3)')                  
!     &    'average thickness=',tthick/mstruct1                         
                                                                        
         if(lfwscat.eq.0) then 
          if(b_sftr.and.enwr(6).eq.'nynn') then 
           if(wi(icmp).gt.sing/20..or.sing.gt.0.05)               &
           print'(2(a,g8.1),a)',                                  &
          '** f*unit_thickness=',wi(icmp),' << sin(th)=',sing,' << 1 ?'
          end if 
         end if 
                                                                        
         isubthe=0 
         call get_theory(isubthe,info) 
         b_lay=b_lay.or.b_sftr.or.(isubthe.gt.0) 
         b_total=b_total.or.b_lay 

         if(b_isgt1) then 
          isctp=l3_get(lstruct3) 
!         write(6,'(a,2i8,f12.2)') 'isctp,iposlay(lay),wi(icmp)=', &      
!                         isctp,iposlay(lay),wi(icmp)             
          do n=0,nTH 
           nn=isctp+8*n 
           ll=8*n 
            do k=1,8 
            carray(ll+k)=carray(ll+k)+ array_fr(nn+k)*wi(icmp) 
            end do 
           end do 
         else 
          iposlay(lay)=l3_get(lstruct3) 
!          write(6,'(a,i2,a2,i8,f10.2)')   &
!             'synmos  iposlay(',lay,')=',iposlay(lay),wi(icmp)         
         end if 
        end do 
                                                                        
        if(b_isgt1.and.b_lay) then 
         ll=iposlay(lay) 
         do i=1,8*(nTH+1) 
          array_fr(ll+i)=carray(i) 
         end do 
        end if 
                                                                        
       end do 
       mlay=lay 
       laystr(2*lay+2)=-1 
       laystr(2*lay+1)=0 
                                                                       
!-----------------------------------------------------------------------
!     here the matrix R for the layers are given :                      
!     satrlay(n,lay)*1 +  (sapplay(n,lay)  sap(n,lay))                  
!                         (samplay(n,lay) -sapplay(n,lay))              
!                                                                       
!     calculation of the transmittivity matrix T for all channels n     
!     by   T = exp(iR)*rho*exp(-iR+)                                    
                                                                        
!      write(6,'(a,20i3)')'synmos laystr(1..mlay)=',(laystr(i),i=1,mlay)
      if(.not.b_total) goto 2000 
                                                                        
      do k=1,mlay 
       laysites(k)=0 
      end do 
      if(lfwscat.eq.1) then 
       mlays=0 
       do lstruct2=layb+1,laye 
        lay=lstruct2-layb 
        is_a=istruct2(lstruct2-1)+1 
        is_e=istruct2(lstruct2) 
        if(b_sites(lay)) then 
         mlays=mlays+1 
         iposlay(mlays)=iposlay(lay) 
         if(is_e.gt.is_a) thicklayer(mlays)=thicklayer(lay)
!        case of only one nuclear site the effective thicknes wi can be 
!        multiplied here (save multiplications) 
         if(is_e.eq.is_a)thicklayer(mlays)=thicklayer(lay)*wi(is_a)             
!          write(6,'(i2,a,i4,2f10.3)')lstruct1, &                        
!        'synmos lay,wi(is_a),thicklayer',lay,wi(is_a),thicklayer(lay) 
        end if 
       end do 
      else 
       mlays=0 
       do lstruct2=layb+1,laye 
        lay=lstruct2-layb 
        is_a=istruct2(lstruct2-1)+1 
        is_e=istruct2(lstruct2) 
!        write(6,'(i2,a,2i2,f10.3)')lstruct1,' is_a,is_e=',             
!     &                                       is_a,is_e,wi(is_a)        
        vkd(lay)=vector_k*thicklayer(lay) 
        if(is_e.lt.is_a) then 
         thicklayer(lay)=0. 
        else 
         if(is_e.gt.is_a) thicklayer(lay)=1./vector_k 
         if(is_e.eq.is_a) thicklayer(lay)=wi(is_a)/vector_k 
        end if 
       end do 
      end if 
  
                                                                      
!      do lstruct2=layb+1,laye                                          
!       lay=lstruct2-layb                                               
!       write(6,'(i4,2x,L3,a,2g12.4,a,g12.4,a,g12.4)')                  
!     & lay,b_sites(lay),' chilay=',chilay(lay),                        
!     & ' vkd=',vkd(lay),' thicklayer=',thicklayer(lay)                 
!       end do                                                          
                                                                        
      if(lfwscat.eq.0) then 
!     ******************************************************************
!     We reconstruct the layer strucrure from the laystr variabale.     
!     ELEMENT(GRP) is the number of layers in group GRP.                
!     *** L. Deak, 09.10.2002 ***                                       
       GRP         =0 
       GEOSTR(GRP) =0 
       MGRP      =0 
!                                                                       
       b_first     =.true. 
       POINTER=1 
       do lay=2,2*mlay,2 
        if(b_first)then 
         if(GRP.eq.laystr(lay))then 
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1 
         else 
          POINTER         =POINTER+GEOSTR(2*GRP) 
          GRP             =GRP+1 
          MGRP          =GRP 
          GEOSTR(2*GRP)   =1 
          GEOSTR(2*GRP-1) =laystr(lay-1) 
         end if 
!                                                                       
         if(vkd(lay/2).lt.0.) then 
          b_first         =.false. 
          vkd(lay/2)      =1.e30 
          GEOSTR(2*GRP-1) =1 
         end if  ! VKD < 0     
        end if   ! b_first  
       end do 
!      *****************************************************************
       do lay=1,mlay 
        if(b_sites(lay)) then 
         Cmatrix(1,1,lay)= hc0 
         Cmatrix(2,2,lay)= hc0 
         Cmatrix(1,2,lay)= hc0 
         Cmatrix(2,1,lay)= hc0 
        end if 
       end do 
                                                                        
       call optic(mlay,b_sites,MGRP,GEOSTR,grazing,                &
                  Cmatrix,chilay,roughlay,vkd,Rmatrix)              
       R_oo=Rmatrix(1,1) 
      endif 
                                                                        
      do n=-nTH,nTH-1 
!      construction of the input for general optics program             
!      here the matrix R for the layers are given :                     
!      satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))             
!                          (samplay(n,lay) -sapplay(n,lay))             
       npos=8*abs(n) 
       if(n.lt.0)npos=npos+4 
                                                                        
       if(lfwscat.eq.1) then 
         satraceh=cmplx(0.,0.) 
         do lays=1,mlays 
          nn=iposlay(lays)+npos 
          satraceh=satraceh+array_fr(nn+1)*thicklayer(lays) 
          app=array_fr(nn+2)*thicklayer(lays) 
          apm=array_fr(nn+3)*thicklayer(lays) 
          amp=array_fr(nn+4)*thicklayer(lays) 
          call expo_22(app,apm,amp,dd)
!
!         dd(1,..,4) fortran notation
          do k=1,4 
           aam(k,lays)=dd(k) 
          end do
         end do   ! lays=1,mlays  
                                                                        
         satrexp=exp(satraceh*hci) 
                                                                        
!        multiplication of the matrices exp(iR(mlay))*...*exp(iR(1))    
!        laystr(rep,grp,rep,grp,.....)                                  
                                                                        
         if(mlays.gt.1) then 
          do k=1,4 
           dcc(k)=dcmplx(aam(k,mlays)) 
          end do 
                                                                        
          do lays=mlays-1,1,-1 
           do k=1,4 
            daa(k)=dcc(k) 
            dbb(k)=dcmplx(aam(k,lays)) 
           end do 
           call matproD(daa,dbb,dcc) 
          end do 
          do k=1,4 
           dd(k)=dcc(k) 
          end do 
         end if 
                                                                       
         nn=(nTH+n)*4 
         POC(nn+1)=(1.,0.)-dd(1)*satrexp 
         POC(nn+2)=       -dd(2)*satrexp 
         POC(nn+3)=       -dd(3)*satrexp 
         POC(nn+4)=(1.,0.)-dd(4)*satrexp 
      else  ! lfwscat=0 
                                                                        
        do lay=1,mlay 
         if(b_sites(lay)) then 
          nn=iposlay(lay)+npos 
!         effi to Fortran notation                                      
          Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay) 
          Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay) 
          Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay) 
          Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay) 
         end if 
        end do   ! lay=1,mlay  
                                                                        
        call optic(mlay,b_sites,MGRP,GEOSTR,grazing,               &
                    Cmatrix,chilay,roughlay,vkd,Rmatrix)               
                                                                        
!       Fortran notation                                                
        nn=(nTH+n)*4 
        POC(nn+1)=Rmatrix(1,1)-R_oo 
        POC(nn+3)=Rmatrix(1,2) 
        POC(nn+2)=Rmatrix(2,1) 
        POC(nn+4)=Rmatrix(2,2)-R_oo 
       end if    ! reflection (lfwscat=0)   
      end do     ! n=-nTH,nTH 

!      write(6,'(a,4i8)')'nstorTH1,nCP,nCC,nsrw=',nstorTH1,nCP,nsrw   
!      i=nstorTH+nstorTH1+nTH/nsrw*4                                  
      
      nn=2*nTH 

!      call Dfourier_4(nn)            ! D:= discrete Fourier (not FFT)
!      call fourier_4(nn)             ! recipies outer loop
       call fourier4r(nn)              ! recipies inner loop

      j=2
      nTHj=nTH/j
      jt0=2*jt0_ch/j 
      do n=1,nTH,j
!      trace (dd+*dd*rho) is the intensity                            
!      bb=cc+                                                         
        jj=4*(n-1) 
        do i=1,4 
         dd(i)=POC(jj+i) 
        end do

        bb(1)=conjg(dd(1)) 
        bb(4)=conjg(dd(4)) 
        bb(2)=conjg(dd(3)) 
        bb(3)=conjg(dd(2)) 
 
       call tracematpro4(Arho,dd,rho,bb,trace) 

       h1=real(trace) 
        jj=4*(nTH+n-1) 
        do i=1,4 
         dd(i)=POC(jj+i) 
        end do 
        bb(1)=conjg(dd(1)) 
        bb(4)=conjg(dd(4)) 
        bb(2)=conjg(dd(3)) 
        bb(3)=conjg(dd(2)) 
                                                                      
!        call matprof(bb,Arho,cc)                                     
!        call matprof(cc,dd,aa)                                       
!        call matprof(aa,rho,bb)
!        bb(3)=(0.,0.)                                      
!        trace=bb(1)+bb(4)                                            
       call tracematpro4(Arho,dd,rho,bb,trace) 
       h2=real(trace)
       nj=n/j 
       yth(nj)=h1 
       yth(nj+nTHj)=h2 
      end do  ! n  
      yth(0)=yth(1) 
      yth(nTH)=yth(nTH-1) 
                                                           
!     normalization                                                     


      nt=nTH 
      if(iT_max.gt.0) then 
        do k=1,iT_max 
         nt=nt/2 
         do j=1,nt 
          yth(j)=yth(j)+yth(j+nt) 
         end do 
        end do 
      end if

      sum=0.
      do j =jt0,nt
       sum=sum+ yth(j)
      end do
      sum=sum/(nt-jt0)*nexp

      if(sum.lt.0.001) sum=1.0 

      nn=nstorTH*2 
      if(mstruct1.gt.1) nn=inc_pos*2 

      do i=1,nt
       real_fr(nn+i)=yth(i)/sum 
      end do 
!      write(6,'(a,3i6,3f15.5)')'jt0_ch,nt,nstorTH*2,sum=',   &
!           jt0,nt,nn,sum ,float(nexp)  
                                                                    
!      if(mstruct1.eq.1)write(6,'(8f10.4)')(real_fr(nn+i)*100,i=1,16)   
!     end of calculation for incoherent part                            
                                                                        
 2000 continue 
      if(mstruct1.gt.1) goto 1000 
                                                                        
 2500  continue 
      b_total=b_total.or.b_winc 
      if(.not.b_total) return 
                                                                        
      nsth2=nstorTH*2 
      if(mstruct1.gt.1) then 
!      summation of incoherent parts mstruct1                           
       n=nTH 
       if(n.gt.512) n=512 
       do i=1,n*2 
        real_fr(nsth2+i)=0.0 
       end do 
       do k=1,mstruct1 
        nn=l1_put(k)*2 
!        write(6,'(8f10.4)')(real_fr(nn+i)*100,i=1,16)                  
        do i=1,n*2 
         real_fr(nsth2+i)=                                              &
     &       real_fr(nsth2+i)+real_fr(nn+i)*winc(k)                     
        end do 
       end do 
      end if 
      deallocate(carray,yth)
                                                                    
      return 
      END                                           
                                                                        
!  *****************************************************************    
!                                                                       
!                 Fourier-transformation                                
!                   (fortran recipies) 
!   Direct Fourier - very slow 
!  *****************************************************************    
                                                                       
      subroutine Dfourier_4(nTH2) 
      use glbconst, only: maxn,maxscrd
      implicit none
      integer,intent(in):: nTH2
      real  POC 
      common/scrd/POC(maxscrd) 

      real(kind=8), dimension(nTH2):: DATAr,DATAi
      integer N,J,JJ
     
    do JJ=1,8,2
      do N=1,nTH2
       J=8*(N-1) 
       DATAr(N)=POC(J+JJ)
       DATAi(N)=POC(J+JJ+1)
      end do
      
      call dftc(1,nTH2,DATAr,DATAi)  

      do N=1,nTH2
       J=8*(N-1) 
       POC(J+JJ)=DATAr(N)
       POC(J+JJ+1)=DATAi(N)
      end do
    end do
    return 
    END                                           

!  *****************************************************************    
!                                                                       
!                 Fourier-transformation                                
!!  4 arrays. This routine is 50% slower than  fourier4r                                
!  *****************************************************************    
!                                                                       
      subroutine fourier_4(nTH2) 
      use glbconst, only: maxn,maxscrd
      implicit none
      integer,     intent(in):: nTH2
      real, dimension(2*nTH2):: DATA
      real POC 
      common/scrd/POC(maxscrd) 
      integer N,J,JJ

    do JJ=1,8,2
      do N=1,nTH2
         J=8*(N-1) 
         DATA(2*N-1)=POC(J+JJ)
         DATA(2*N)=POC(J+JJ+1)
       end do

      call fourier(DATA,nTH2,nTH2,-1) 

      do N=1,nTH2
         J=8*(N-1) 
         POC(J+JJ)=DATA(2*N-1)
         POC(J+JJ+1)=DATA(2*N)
       end do
    end do
    return 
    END                                           
                                                                        
!  *****************************************************************    
!                                                                       
!                 Fourier-transformation                                
!                   (fortran recipies)                                  
!  *****************************************************************    
                                                                       
      subroutine fourier(DATA,NN,mFF,ISIGN) 
      implicit none
      integer NN,mFF,ISIGN
      real(kind=8) :: WR,WI,WPR,WPI,WTEMP,THETA 
      real DATA(2*mFF),TEMPI,TEMPR 
      integer N,J,M,MMAX,ISTEP,I
                                                                       
      N=2*NN 
      J=1 
                                                                       
      do 11 I=1,N,2 
        if(J.gt.I)then 
          TEMPR=DATA(J) 
          TEMPI=DATA(J+1) 
          DATA(J)=DATA(I) 
          DATA(J+1)=DATA(I+1) 
          DATA(I)=TEMPR 
          DATA(I+1)=TEMPI 
        endif 
        M=N/2 
    1   if ((M.ge.2).and.(J.gt.M)) then 
          J=J-M 
          M=M/2 
        go to 1 
        endif 
        J=J+M 
   11 continue 
!                                                                       
      MMAX=2 
    2 if (N.gt.MMAX) then 
        ISTEP=2*MMAX 
        THETA=6.28318530717959D0/(ISIGN*MMAX) 
        WPR=-2.D0*dsin(0.5D0*THETA)**2 
        WPI=dsin(THETA) 
        WR=1.D0 
        WI=0.D0 
        do 13 M=1,MMAX,2 
          do 12 I=M,N,ISTEP 
            J=I+MMAX 
            TEMPR=WR*DATA(J)-WI*DATA(J+1) 
            TEMPI=WR*DATA(J+1)+WI*DATA(J) 
            DATA(J)=DATA(I)-TEMPR 
            DATA(J+1)=DATA(I+1)-TEMPI 
            DATA(I)=DATA(I)+TEMPR 
            DATA(I+1)=DATA(I+1)+TEMPI 
   12     continue 
          WTEMP=WR 
          WR=WR*WPR-WI*WPI+WR 
          WI=WI*WPR+WTEMP*WPI+WI 
   13   continue 
        MMAX=ISTEP 
      go to 2 
      endif 
      return 
      END                                           
                                                                        
!  *****************************************************************    
!                                                                       
!                 c-Fourier-transformation                              
!                   (fortran recipies)                                  
!  *****************************************************************    
                                                                       
      subroutine cfourier(DATA,NN,mFF,ISIGN) 
      implicit none
      integer NN,ISIGN,mff
      real(kind=8) :: THETA 
      complex DATA(mFF) 
      complex ww,wwp,temp 
      integer N,J,I,ii,jj,M,MMAX,ISTEP
                                                                             
      N=2*NN 
      J=1 
!                                                                       
      do 11 I=1,N,2 
        if(J.gt.I)then 
          ii=(I+1)/2 
          jj=(J+1)/2 
          temp=DATA(jj) 
          DATA(jj)=DATA(ii) 
          DATA(ii)=temp 
        endif 
        M=N/2 
    1   if ((M.ge.2).and.(J.gt.M)) then 
          J=J-M 
          M=M/2 
        go to 1 
        endif 
        J=J+M 
   11 continue 
!                                                                       
      MMAX=2 
    2 if (N.gt.MMAX) then 
        ISTEP=2*MMAX 
        THETA=6.28318530717959D0/(ISIGN*MMAX) 
        wwp=cmplx(-2.D0*dsin(0.5D0*THETA)**2,dsin(THETA)) 
        ww=cmplx(1.0,0.0) 
        do 13 M=1,MMAX,2 
          do 12 I=M,N,ISTEP 
            J=I+MMAX 
          ii=(I+1)/2 
          jj=(J+1)/2 
            temp=ww*DATA(jj) 
            DATA(jj)=DATA(ii)-temp 
            DATA(ii)=DATA(ii)+temp 
   12     continue 
          ww=(wwp+(1.,0.))*ww 
   13   continue 
        MMAX=ISTEP 
      go to 2 
      endif 
      return 
      END                                           
                                                                        
                                                                        
!  *****************************************************************    
!                                                                       
!                 Fourier-transformation                                
!                   (fortran recipies)                                  
!                transform of 4 arrays (l=1-4)                          
!                          6.6.97 
!  adapted to FFT of 4 arrays stored in a special way on POC.
!  -2.D0*dsin(0.5D0*THETA)**2  is replaced by dcos(THETA) 
!  and removing the  1 at lines
!          WR=WR*WPR-WI*WPI+WR      =WR*(WPR+1)-WI*WPI    =>  WR*WPR-WI*WPI 
!          WI=WI*WPR+WTEMP*WPI+WI   =WI*(WPR+1)+WTEMP*WPI =>  WI*WPR+WTEMP*WPI
!  http://stackoverflow.com/questions/2220879/c-numerical-recipies-fft)  
!  *****************************************************************    
                                                                       
      subroutine fourier4r(NN) 
      use glbconst, only: maxn,maxscrd
      implicit none
      integer NN
      real POC 
      common/scrd/POC(maxscrd) 
                                                                        
      real(kind=8) :: THETA 
      real hr,wwr,wwi,wwpr,wwpi,tempr,tempi 
      integer N,JN2,IN2,j,jj,i,ii,M,IMN,ISTEP,l,MMAX 

      N=2*NN 
      JN2=1 
                                                                       
      do 11 IN2=1,N,2 
        if(JN2.gt.IN2)then 
          jj=4*(JN2-1)-1 
          ii=4*(IN2-1)-1 
          do l=2,8,2 
           i=ii+l 
           j=jj+l 
           tempr=POC(j) 
           tempi=POC(j+1) 
           POC(j)=POC(i) 
           POC(j+1)=POC(i+1) 
           POC(i)=tempr 
           POC(i+1)=tempi 
          end do 
        endif 
        M=N/2 
    1   if ((M.ge.2).and.(JN2.gt.M)) then 
          JN2=JN2-M 
          M=M/2 
        go to 1 
        endif 
        JN2=JN2+M 
   11 continue 
!                                                                       
      MMAX=2 
    2 if (N.gt.MMAX) then 
        ISTEP=2*MMAX 
        THETA=6.28318530717959D0/dfloat(MMAX) 
        wwpr=dcos(THETA) 
        wwpi=-dsin(THETA) 
        wwr=1. 
        wwi=0. 
        do 13 M=1,MMAX,2 
          do 12 IMN=M,N,ISTEP 
           ii=4*(IMN-1)-1 
           jj=ii+2*ISTEP 
           do l=2,8,2 
            i=ii+l 
            j=jj+l 
            tempr=wwr*POC(j)-wwi*POC(j+1) 
            tempi=wwr*POC(j+1)+wwi*POC(j) 
            POC(j)=POC(i)-tempr 
            POC(j+1)=POC(i+1)-tempi 
            POC(i)=POC(i)+tempr 
            POC(i+1)=POC(i+1)+tempi 
           end do 
   12     continue 
          hr=wwr 
          wwr=wwpr*wwr-wwpi*wwi 
          wwi=wwpi*hr +wwpr*wwi 
   13   continue 
        MMAX=ISTEP 
      go to 2 
      endif 
      return 
      END                                           
                                                               
                                                                       
!     H. Spiering/Laszlo Deak January,1999 Mainz                                    
!     Jg Je arbitrary spin                                              
!     synchrotron source                                                
!     5.06.05                                                           
     subroutine synrocking(b_total,info) 
     use glbconst, only: maxfr1,maxfr2,maxn,maxthss,maxscrd, &
                         icstrf,icfr1trf,icfr2trf,icsstrf,&  
                         ivstrf,ivfr1trf,ivfr2trf,ivsstrf,enwr
     use comthe, only: array_fr,real_fr,ifrcase
     implicit none 
     logical, intent(out):: b_total 
     integer, intent(out):: info 

     integer     mstruct1,istruct1,istruct2,     &
                 l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,            &
                 nstorTH,nstorTH1,nstorTHyy,nstorSI,mpt,ipTH,iaddr
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname 
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),                                        &
                   mpt,ipTH,nstorTH,nstorTH1,nstorTHyy,nstorSI,iaddr(2)

     real          srw8 
     integer       nTH1,nCP,idum,nsrw,ifrth,                            &
                   iflag_basis,l_trans,nLG,nTH,ith_channels,nsampling,  &
                   ak8,nomega,nstrob_order,jt0_ch,iT_max,nvch,nhyperfine,ien      
     common/strLOC/nTH1,nCP,idum,nsrw,ifrth(8),                         &
                   iflag_basis,l_trans,nLG,nTH,ith_channels,nsampling,  &
                   ak8,nomega,srw8,nstrob_order,jt0_ch,iT_max,nvch,     &
                   nhyperfine,ien(6)                                  
                                                                       
     real          acsp,wavelength,uthick_A,                           &
                   unitchi,dum6,                                       &
                   ch_angle,graz_beg,graz_end,dumcsp                   
     common/acstrf/acsp,wavelength,uthick_A,                           &
                   unitchi,dum6(6),ch_angle,graz_beg,graz_end,         &
                   dumcsp(icstrf-13)                                   
                                                                       
     real          avs,counts,background,dum0,Pxsi,Peta,Pzeta,         &
                   PA0,PAxsi,PAeta,PAzeta,ang_shift,graz_min,phi_z,    &
                   detekt_eff,counts_bunch,dumvsp                      
     common/avstrf/avs,counts,background,dum0,Pxsi,Peta,Pzeta,         &
                   PA0,PAxsi,PAeta,PAzeta,ang_shift,graz_min,phi_z,    &
                   detekt_eff,counts_bunch,dumvsp(ivstrf-16)           
                                                                       
     logical       b_vs,b_counts,b_background,b_dum0,b_Pxsi,b_Peta,    &
                   b_Pzeta,b_PA0,b_PAxsi,b_PAeta,b_PAzeta,b_ang_shift, &
                   b_graz_min,b_phi_z,b_detekt_eff,b_counts_bunch,b_dumvsp
     common/bvstrf/b_vs,b_counts,b_background,b_dum0,b_Pxsi,b_Peta,    &
                   b_Pzeta,b_PA0,b_PAxsi,b_PAeta,b_PAzeta,b_ang_shift, &
                   b_graz_min,b_phi_z,b_detekt_eff,b_counts_bunch,     &
                   b_dumvsp(ivstrf-16)                                 
                                                                       
     real            avfr1,pvfr1,dum1,phiA,thetaA,dvfr1 
     common/avfr1trf/avfr1,pvfr1,dum1(3),phiA,thetaA,dvfr1(ivfr1trf-7) 
     logical         b_vfr1,b_pvfr1,b_dum1,b_dvfr1 
     common/bvfr1trf/b_vfr1,b_pvfr1,b_dum1(3),b_dvfr1(ivfr1trf-5) 
                                                                       
     real            acfr2,rep_grp,dumcfr2 
     common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2) 
                                                                       
     real            avfr2,thicklay,re_chilay,ai_chilay,roughness,     &
                     dumvfr2                                           
     common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,     &
                     dumvfr2(ivfr2trf-5)                               
     logical         b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,        &
                     b_roughness,b_dumvfr2                             
     common/bvfr2trf/b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,        &
                     b_roughness,b_dumvfr2(ivfr2trf-5)                 
                                                                       
     real            vsstrf,sftr 
     common/avsstrf/ vsstrf(ivsstrf) 
     logical         b_vsstrf 
     common/bvsstrf/ b_vsstrf(ivsstrf) 
                                                                       
     logical  b_lay,b_absorber,b_isgt1

     logical,dimension(maxfr2):: b_sites,b_chilay,b_chilaynz
     real,dimension(maxfr1) :: winc
     real,dimension(maxfr2) :: vkd
     real,dimension(maxthss):: wi
                                                                       
     real,   dimension(maxfr2)    :: thicklayer,roughlay
     integer,dimension(maxfr2)    :: iposlay,laysites
     integer,dimension(2*maxfr2+2):: laystr 
     integer,dimension(0:2*maxfr2):: GEOSTR
     integer,dimension(maxfr1)    :: ipos_mstruct1 

     complex,dimension(4)         :: aa,bb,dd,cc,rho
     complex,dimension(2,2,maxfr2):: Cmatrix
     complex,dimension(maxfr2)    :: chilay
     complex,dimension(2,2)       :: Rmatrix    
                                                                       
     integer,parameter:: idumscrd=maxscrd-3-8*maxn-3*32-12*96          &
                         -8-16*maxn-1-2*maxn-4*maxn-1-4*maxn
     integer   ichall,ichstr
     real*8    qn(0:31)
     real      yth,chrock,fn,dn,xn,dumscrd,trc,dumi,                   &
               ap0,ap1,ap2,bp0,bp1,bp2,cp0,cp1,cp2,dx1,dx2,dx3
     complex   pocfi,trace
     common/scrd/ichall(0:maxn*2),ichstr(0:maxn),                      &
                 yth(0:4*maxn),chrock(maxn),fn(0:31),dn(0:31),xn(0:31),&
                 ap0(0:95),ap1(0:95),ap2(0:95),                        &
                 bp0(0:95),bp1(0:95),bp2(0:95),                        &
                 cp0(0:95),cp1(0:95),cp2(0:95),                        &
                 dx1(0:95),dx2(0:95),dx3(0:95),                        &
                 pocfi(4,-maxn:maxn),trc(-maxn:maxn),                  &
                 trace(2*maxn),dumi(0:4*maxn),dumscrd(idumscrd)

                                                                       
     logical b_bunchinf,b_HeangleLS,b_first
! *** Definitions of structure variables L. Deak 09.10.2002 ***        
     integer POINTER,GRP,MAXGRP
! ****                                                       ***        
     integer lstruct1,lstruct2,lstruct3,nt,isubthe,                    &
             icmp,is_a,is_e,inc_pos,                                   &
             i,i4,jj,j,j1,j3,n,nn,n_s,k,ll,nb_ch,ne_ch,                &
             lay,mlay,nch_angle,nchan,nyout,nst16,                     &
             npos,mlays,chT0,iall,neg,isamp,                           &
             ij,mcht,icht,ii,ka,k0,k1,k2,nth8     
      real grazmin,hhoff,ap,bp,cp,det,x0,x1,x2,hh,hhstr,swinr,swini,   &  
           grazing,rd_theta,vector_k,h1,h2,sing,h,sum,start,finish 
      real,parameter :: rad=0.0174533,pi=3.14159 
      complex hc,hc1,hcc,hci,hc0,swin,R_oo
     
      complex, dimension(:), allocatable:: POC,carray 


 
      b_bunchinf=.false. 
!      write(6,'(a,L5,2g12.4)')'b_counts_bunch,counts_bunch=',          
!     &                           b_counts_bunch,counts_bunch           
!      write(6,'(a,3L5,2g12.4)')' b_vs,b_counts,b_graz_min=',           
!     &                    b_vs,b_counts,b_graz_min,counts,graz_min     
!------------------------------------------------------------------     
!-------------------------------------------------------------------    
                                                                        
      call cpu_time(start) 

      nth8=8*(nTH+1)
      allocate(POC(nth8),carray(nth8))

                                                                        
      b_absorber=b_ang_shift.or. b_graz_min.or.b_phi_z 
      b_total=b_Pxsi.or.b_Peta.or.b_Pzeta.or. &
              b_PA0.or.b_PAxsi.or.b_PAeta.or.b_PAzeta
                                                                        
!     calculation of non equidistant energy points                      
      if(ifrcase.eq.25.or.ifrcase.eq.31)&
        call channels_adjust(nvch,nhyperfine,nstrob_order,nomega,iall)                                   
                                                                        
!      the routine calculates channels needed for a nonequidistant      
!      channel numbers for all later shifts +- nomega in the stoboscopic
!      integration                                                      
!---------------------------------------------------------------------- 
!       nvch=0                                                          
!       iall=nTH                                                        
!       do i=0,iall                                                     
!        ichall(i)=i                                                    
!       end do                                                          
!       ichall(nTH+1)=-1                                                
!       write(6,'(a,i5)') ' th_synrock nTH=',nTH                        
!---------------------------------------------------------------------- 
                                                                        
      isubthe=1 
      call get_theory(isubthe,info) 
      b_total= b_total.or.(isubthe.gt.0) 
      hc1=cmplx(1.,0.) 
      hci=cmplx(0.,1.) 
      hc0=cmplx(0.,0.) 
                                                                        
!     write(6,'(a,2i4)')' th_synrock ifrcase=',ifrcase                  
                                                                        
!     thfrcase(1)='time differential transmission spectrum(11)   v=100' 
!     thfrcase(2)='time differential reflection spectrum(21)     v=100' 
!     thfrcase(3)='time integral - rocking curve-Fourier(22)     v=100' 
!     thfrcase(4)='time integral - rocking curve(24)        v=100'      
!     thfrcase(5)='time integral - rocking curve_fi(25)        v=100'   
!     thfrcase(6)='prompt - rocking curve(23)     v=100'                
!     thfrcase(7)='time integral - offspecular(31)          v=001'      
                                                                        
      if(ifrcase.eq.24.or.ifrcase.eq.25) then 
       do n_s=0,nstrob_order 
        swin=array_fr(l1_get(0)+1+n_s) 
!       write(6,'(i5,2x,2f10.3)')n_s,swin                              
       end do 
      end if 
                                                                        
!-------------------------------------------------------------------    
                                                                        
!     write(6,'(3(a,e8.2))')                                            
!    &    ' synmos-- Pxsi=',Pxsi,' Peta=',Peta,' Pzeta=',Pzeta          
                                                                        
!      transformation matrix from spherical basis to (sigma,pi)-basis   
                                                                        
                                    ! /Angstroem                        
      vector_k=2.0*pi/wavelength 
      grazmin=graz_min*0.001 
!-----------------------------------------------------------------------
!     transformation matrix from spherical basis to (sigma,pi)-basis    
!     orientation of the absorber with respect to the beam              
                                                                        
        rho(1)=cmplx(1.+Pzeta,0.)/2. 
        rho(3)=cmplx(Pxsi,-Peta)/2. 
        rho(2)=cmplx(Pxsi,Peta)/2. 
        rho(4)=cmplx(1.-Pzeta,0.)/2. 
!       write(6,'(a,8f8.2)') ' rho=', (rho(k),k=1,4)                    
!       (1 3)     fortran definition                                    
!       (2 4)                                                           
                                                                        
      lstruct1=0 
 1000 continue 
      if(ifrcase.eq.23) b_absorber=                                    &
                      b_absorber.or.b_detekt_eff.or.b_counts_bunch     
                                                                        
      lstruct1=lstruct1+1 
      if(lstruct1.gt.mstruct1) goto 2500 
      inc_pos=l1_put(lstruct1) 
      ipos_mstruct1(lstruct1)=inc_pos 
                                                                        
!       write(6,'(a,i1,a2,i8)')                                         
!     &         'synmos l1_put(',lstruct1,')=',l1_put(lstruct1)         
                                                                        
       call mapsub(lstruct1,0,0) 
                                                                        
!      b_HeangleLS change of external field and scatterer orientation   
       b_HeangleLS=b_phi_z 
       do i=1,3 
        b_HeangleLS=b_HeangleLS.or.b_dum1(i) 
       end do 
                                                                        
       winc(lstruct1)=pvfr1 
       b_total=b_total.or.b_pvfr1.or.b_HeangleLS 
                                                                        
       nch_angle=ch_angle 
       rd_theta=(graz_end-graz_beg)/(ch_angle-1.) 
!      write(6,'(a,g15.5)')'1synrock rd_theta=',rd_theta                
                                                                        
       thetaA=(graz_end-graz_beg)/2. 
       sing=sin(0.001*thetaA) 
                               !  hyperfine fields - fix                
       thetaA=0.001*thetaA/rad 
                                                                        
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
!      ------------------------------------------------------------     
!      layer lay1,2 ... mlay of  absorber                               
!      ---------------------------------------------------------------  
!      The Lorentz curve of the absorber in npq is 1 at resonance so tha
!      for a singl line the exponent at resonance is just -teff (effecti
!      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw
!      normalizes ( to area 1) the Lorentz curve.                       
!                                                                       
!      Sums of absorber curves at the positions Eagd.                   
!                                                                       
!      ----0--------------------------naLG                              
!       naLG--------------------------0-------------        srw8        
!        nTH------------0------------nTH                    srw         
                                                                        
        lay=lstruct2 
                                                                        
        call mapsub(lstruct1,lstruct2,0) 
!       external field and scatterer orientation written on fr2         
!       th_22nuclear routines take the field from common/avfr2trf       
!       mapsub overwrites common/.vfr2trf, therefore                    
        do i=1,3 
         dumvfr2(1+i)=dum1(i) 
         b_dumvfr2(1+i)=b_dum1(i) 
        end do 
        dumvfr2(5)=phi_z 
        dumvfr2(6)=thetaA 
        b_dumvfr2(5)=b_phi_z 
        b_dumvfr2(6)=.false. 
!       end of transfer                                                 
                                                                        
        thicklayer(lay)=thicklay 
        if(abs(re_chilay)+abs(ai_chilay).gt.1.0e-10) then 
         chilay(lay)=cmplx(re_chilay,ai_chilay)*unitchi 
         b_chilaynz(lay)=.true. 
        else 
         chilay(lay)=(0.,0.) 
         b_chilaynz(lay)=.false. 
        end if 
        b_chilay(lay)=b_vfr2.or.b_thicklay 
        b_absorber=b_absorber.or.b_chilay(lay) 
!       write(6,'(a,l5)') '1------b_absorber=', b_absorber              
                                                                        
        i=rep_grp 
        laystr(2*lay-1)=i 
        laystr(2*lay)=10*(rep_grp-float(i)+.01) 
        roughlay(lay)=roughness*vector_k 
                                                                        
        b_isgt1=.false. 
        if(istruct2(lstruct2)-istruct2(lstruct2-1)-1.gt.0)then 
         b_isgt1=.true. 
         iposlay(lay)=l2_put(lstruct2) 
         do i=1,8*(nTH+1) 
          carray(i)=(0.,0.) 
         end do 
        end if 
                                                                        
        b_sites(lay)=.false. 
        b_lay=.false. 
        do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
                                                                        
         icmp=lstruct3 
         b_sites(lay)=.true. 
                                                                        
         call mapsub(lstruct1,lstruct2,lstruct3) 
                                                                        
         b_lay=b_vsstrf(2).or.b_HeangleLS 
!        write(6,'(a,l5)') '2------b_absorber=', b_absorber             
!         write(6,'(a,2i4)') 'synrock lay,icmp=',lay,icmp               
                                                                        
         sftr=vsstrf(2) 
         wi(icmp)=sftr*uthick_A 
         if(b_vsstrf(1)) then 
          if((wi(icmp).gt.sing/20..or.sing.gt.0.05).and.           &
             (ifrcase.eq.22.or.ifrcase.eq.24.or.ifrcase.eq.25))    &
           print'(2(a,g8.1),a)',                                   &
           '** f*unit_thickness=',wi(icmp),' << sin(th)=',sing,' << 1 ?'
         end if 
                                                                        
                                                                        
         if(ifrcase.eq.22.or.ifrcase.eq.24.or.ifrcase.eq.25) then 
          isubthe=0 
          call get_theory(isubthe,info) 
          b_lay=b_lay.or.(isubthe.gt.0) 
         end if 
         b_absorber=b_absorber.or.b_lay 
                                                                        
         if(b_isgt1) then 
          i=l3_get(lstruct3) 
          do n=0,nTH 
           ll=8*n 
           nn=i+ll 
            do k=1,8 
            carray(ll+k)=carray(ll+k)+ array_fr(nn+k)*wi(icmp) 
            end do 
          end do 
         else 
          iposlay(lay)=l3_get(lstruct3) 
         end if 
                                                                        
        end do 
                                                                        
        if(b_isgt1.and.b_lay) then 
         ll=iposlay(lay) 
         do i=1,8*(nTH+1) 
          array_fr(ll+i)=carray(i) 
         end do 
        end if 
!        ll=iposlay(lay) 
!        write(11,'(i8,2g12.5)') (ll,array_fr(ll+i),i=1,5)
                                                              
       end do 
       mlay=lay 
       laystr(2*lay+2)=-1 
       laystr(2*lay+1)=0 
       b_total=b_total.or.b_absorber 
                                                                        
!      write(6,'(a)')'++++++++++++++synrock++++++++++++++++++++++'      
!      write(6,'(a,20i3)') 'laystr(1..lay)=',(laystr(i),i=1,2*lay)      
!-----------------------------------------------------------------------
!     here the matrix R for the layers are given :                      
!     satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))              
!                         (samplay(n,lay) -sapplay(n,lay))              
!                                                                       
!     calculation of the transmittivity matrix T for all channels n     
!     by   T = exp(iR)*rho*exp(-iR+)                                    
                                                                        
                                                                        
      if(.not.(b_total.or.b_graz_min)) goto 1000 
                                                                        
      do k=1,mlay 
       laysites(k)=0 
      end do 
      mlays=0 
      do lay=1,mlay 
       is_a=istruct2(lay-1)+1 
       is_e=istruct2(lay) 
!      write(6,'(a,2i4)') 'synrock is_a,is_e=',is_a,is_e                
       vkd(lay)=vector_k*thicklayer(lay) 
!       write(6,'(i4,a,f15.5)')lay,' synrock vkd(lay)=',vkd(lay)        
       if(is_e.lt.is_a) then 
        thicklayer(lay)=0. 
       else 
        if(is_e.gt.is_a) thicklayer(lay)=1./vector_k 
        if(is_e.eq.is_a) thicklayer(lay)=wi(is_a)/vector_k 
       end if 
!       write(6,'(2i3,a,g15.5,2i6,L5)')is_e,is_a,'thickl,lay,iposlay(lay)=',   &      
!              thicklayer(lay)*1.e6,lay,iposlay(lay),b_sites(lay)            
      end do 
                                                                        
!      **************************************************************** 
!      We reconstarct the layerstrucrure from the laystr variable.      
!      GEOSTR(GRP) is the number of layers in group GRP.                
!      L. Deak, 09.10.2002                                         ***  
       GRP         =0 
       GEOSTR(GRP) =0 
       MAXGRP      =0 
!                                                                       
       b_first     =.true. 
       POINTER=1 
       do lay=2,2*mlay,2 
        if(b_first)then 
         if(GRP.eq.laystr(lay))then 
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1 
         else 
          POINTER         =POINTER+GEOSTR(2*GRP) 
          GRP             =GRP+1 
          MAXGRP          =GRP 
          GEOSTR(2*GRP)   =1 
          GEOSTR(2*GRP-1) =laystr(lay-1) 
         end if 
!                                                                       
         if(vkd(lay/2).lt.0.) then 
          b_first         =.false. 
          vkd(lay/2)      =1.e30 
          GEOSTR(2*GRP-1) =1 
         end if   ! VKD < 0        
        end if ! b_first 
       end do 
!      *****************************************************************
!      write(6,'(a,l5)')'4 synrock b_total=',b_total                    
                                                                        
!------------------------------ifrcase=22-------------------------------
      if(ifrcase.eq.22) then 
!      only b_graz_min=.true.                                           
       if(.not.b_total) goto 800 
                                                                        
       do nchan=1,nch_angle 
!       grazing=0.001*15                                                
!       rd_theta=(graz_end-graz_beg)/(ch_angle-1.)                      
        grazing=0.001*(graz_beg+rd_theta*(nchan-1)) 
!        write(6,'(a,i3,a,4f10.5)') 'synrock nchan=',nchan,             
!     &    ' grazing=',grazing,graz_beg,rd_theta                        
                                                                        
!       ****************************************************************
!       L.Deak 09.10.2002                                               
!                                                                       
         do lay=1,mlay 
          if(b_sites(lay)) then 
           Cmatrix(1,1,lay)= hc0 
           Cmatrix(2,2,lay)= hc0 
           Cmatrix(1,2,lay)= hc0 
           Cmatrix(2,1,lay)= hc0 
          end if 
         end do 
                                                                        
         call optic(mlay,b_sites,MAXGRP,GEOSTR,grazing,            &
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)              
         R_oo=Rmatrix(1,1) 
!         write(6,'(a,4g15.5)') 'synrock  R_oo=', R_oo                  
!        ***************************************************************
                                                                        
         do n=-nTH,nTH-1 
!        do n=-1,1                                                      
                                                                        
!        construction of the input for general optics program           
!        here the matrix R for the ylayers are given :                  
!        satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))           
!                           (samplay(n,lay) -sapplay(n,lay))            
         npos=8*abs(n) 
         if(n.lt.0)npos=npos+4 
!          effi (1 3)  to fortran  ( 1 3 )                              
!               (4 2)              ( 2 4 )                              
         do lay=1,mlay 
          if(b_sites(lay)) then 
           nn=iposlay(lay)+npos 
           Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay) 
           Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay) 
           Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay) 
           Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay) 
          end if 
         end do   ! lay=1,mlay   
                                                                        
!         if(n.lt.1.and.n.gt.-1)                                        
!     &      write(6,'(a,i4,4e15.5,/,20x,4e15.5)')                      
!     &     'synrock Cmatrix=',n,Cmatrix(1,1,1),Cmatrix(2,2,1)          
!     &       Cmatrix(2,1,1),Cmatrix(2,2,1)                             
                                                                        
                                                                        
         call optic(mlay,b_sites,MAXGRP,GEOSTR,grazing,            &
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)              
!        Fortran notation                                               
         nn=(nTH+n)*4 
         POC(nn+1)=Rmatrix(1,1)-R_oo 
         POC(nn+2)=Rmatrix(2,1) 
         POC(nn+3)=Rmatrix(1,2) 
         POC(nn+4)=Rmatrix(2,2)-R_oo 
        end do  ! n=-nTH,nTH 
                                                                        
!        write(6,'(a,i5)') 'nTH=',nTH                                   
                                                                        
!       do n=1,30,9                                                     
!        write(6,'(8f10.5)')(POC(n+i)*1000,i=1,4)                       
!       end do                                                          
        nn=2*nTH 
!       write(6,'(a)') ' synrock bef Fourier POC'                       
        call fourier4(POC,nn,nth8,-1) 
                                                                        
!        write(6,'(a)') ' synrock after Fourier POC'                    
!        write(6,'(8f10.3)') (POC(i),i=1,nn,64)                         
                                                                        
        do n=1,nTH 
!        trace (dd+*dd*rho) is the intensity                            
!        bb=cc+                                                         
         jj=4*(n-1) 
         do i=1,4 
          dd(i)=POC(jj+i) 
         end do 
         bb(1)=conjg(dd(1)) 
         bb(4)=conjg(dd(4)) 
         bb(2)=conjg(dd(3)) 
         bb(3)=conjg(dd(2)) 
         call matprof(bb,dd,aa) 
         call matprof(aa,rho,bb) 
!        aa=cc*cc+ is a Hermitian matrix                                
         h1=real(bb(1)+bb(4)) 
         jj=4*(nTH+n-1) 
         do i=1,4 
          dd(i)=POC(jj+i) 
         end do 
         bb(1)=conjg(dd(1)) 
         bb(4)=conjg(dd(4)) 
         bb(2)=conjg(dd(3)) 
         bb(3)=conjg(dd(2)) 
         call matprof(bb,dd,aa) 
         call matprof(aa,rho,bb) 
         h2=real(bb(1)+bb(4)) 
         yth(n)=h1 
         yth(n+nTH)=h2 
               ! n                                                      
        end do 
!        write(6,'(8g12.3)')( yth(j),j=1,nTH,16)                        
        if(b_bunchinf) then 
         do k=1,2*nTH 
          dumi(k)=0.0 
          do j=k,2*nTH 
           dumi(k)=dumi(k)+yth(j) 
          end do 
         end do 
         do k=1,2*nTH 
           yth(k)=dumi(k) 
         end do 
!         write(6,'(a)')                                                
!         write(6,'(8g12.3)')( yth(j),j=1,nTH,16)                       
         if(iT_max.gt.0) then 
          nt  =nTH*2 
          chT0=jt0_ch*2 
          do k=1,iT_max 
           nt  =nt/2 
           chT0=chT0/2 
          end do 
         else 
          nt  =2*nTH 
          chT0=jt0_ch*2 
         end if 
        else 
         if(iT_max.gt.0) then 
          nt=nTH*2 
          chT0=jt0_ch*2 
          do k=1,iT_max 
           nt  =nt/2 
           chT0=chT0/2 
           do j=1,nt 
            yth(j)=yth(j)+yth(j+nt) 
           end do 
          end do 
         else 
          nt=2*nTH 
          chT0=jt0_ch*2 
         end if 
        end if 
                                                                        
!        integration of yth from nt0 - nth                              
        sum =0. 
! For the SPRING8 experiment the symmetrical time window should be used 
! original:  do j=2*jt0_ch,nt                                           

        do j=chT0,nt-chT0 
         sum=sum+yth(j) 
        end do 
                                                                        
        chrock(nchan)=sum 
                                                                        
!       write(6,'(a,i3,a2,3i5,g15.5,)')                                 
!     &    ' synrock jt0_ch,iT_max,nth,chrock(',nchan,')=',             
!     &    jt0_ch,iT_max,nth,sum                                        
               ! loop over angles by nch_angle                          
       end do 
!       write(6,'(8g10.5)') (chrock(i), i=1,nch_angle)                  
       nn=2*nstorTH1 
       do i=1,nch_angle 
        real_fr(nn+i)=chrock(i) 
       end do 
!------------------------------ifrcase=24-------------------------------
      else if(ifrcase.eq.24) then 
!      only b_graz_min=.true.                                           
       if(.not.b_total) goto 800 
       isamp=8/nsampling
       if(enwr(16).eq.'omeg') print'(2(a,i4),a,f6.2,a,f8.4)',    &
     & ' nomega=',nomega,'    nTH=',nTH,'   v_nTH=',             &
     &  srw8*nsampling*(ith_channels+nstrob_order*nomega+1.5),   &
     &  '    dv=',srw8*nsampling                                        
       do nchan=1,nch_angle 
!       grazing=0.001*15                                                
!       rd_theta=(graz_end-graz_beg)/(ch_angle-1.)                      
        grazing=0.001*(graz_beg+rd_theta*(nchan-1)) 
!        write(6,'(a,i3,a,4f10.5)') 'synrock nchan=',nchan,             
!     &    ' grazing=',grazing,graz_beg,rd_theta                        
                                                                        
!       ****************************************************************
!       L.Deak 09.10.2002                                               
!                                                                       
         do lay=1,mlay 
          if(b_sites(lay)) then 
           Cmatrix(1,1,lay)= hc0 
           Cmatrix(2,2,lay)= hc0 
           Cmatrix(1,2,lay)= hc0 
           Cmatrix(2,1,lay)= hc0 
          end if 
         end do 
                                                                        
         call optic(mlay,b_sites,MAXGRP,GEOSTR,grazing,            &
                      Cmatrix,chilay,roughlay,vkd,Rmatrix)              
         R_oo=Rmatrix(1,1) 
!         write(6,'(a,4g15.5)') 'synrock  R_oo=', Rmatrix(1,1)          
!        ***************************************************************
                                                                        
         do n=-nTH,nTH 
!        do n=-1,1                                                      
                                                                        
!        construction of the input for general optics program           
!        here the matrix R for the ylayers are given :                  
!        satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))           
!                           (samplay(n,lay) -sapplay(n,lay))            
         npos=8*abs(n) 
         if(n.lt.0)npos=npos+4 
!          effi (1 3)  to fortran  ( 1 3 )                              
!               (4 2)              ( 2 4 )                              
         do lay=1,mlay 
          if(b_sites(lay)) then 
           nn=iposlay(lay)+npos 
           Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay) 
           Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay) 
           Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay) 
           Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay) 
          end if 
         end do  ! lay=1,mlay     
                                                                        
!         if(n.lt.1.and.n.gt.-1)                                        
!           write(6,'(a,i4,4e15.5,/,20x,4e15.5)')             &          
!          'synrock Cmatrix=',n,Cmatrix(1,1,3),Cmatrix(2,2,3) &         
!            Cmatrix(2,1,3),Cmatrix(2,2,3)                             
                                                                        
                                                                        
         call optic(mlay,b_sites,MAXGRP,GEOSTR,grazing,            &
                      Cmatrix,chilay,roughlay,vkd,Rmatrix)              
                                                                        
!        Fortran notation                                               
         nn=(nTH+n)*4 
         POC(nn+1)=Rmatrix(1,1)-R_oo 
         POC(nn+3)=Rmatrix(1,2) 
         POC(nn+2)=Rmatrix(2,1) 
         POC(nn+4)=Rmatrix(2,2)-R_oo 
        end do     ! n=-nTH,nTH  
                                                                        
                                                                        
          hh=0. 
          do n_s=0,nstrob_order 
           swin=array_fr(l1_get(0)+1+abs(n_s)) 
           if(n_s.eq.0) swin=swin/2.0
           h1=real(conjg(swin)*swin) 
           if(h1.gt.1.e-5)then 
                                                                        
            j1=4*(n_s*nomega/2) 
            j3=4*(-n_s*nomega/2) 
            nb_ch=((nstrob_order*2-n_s)*nomega/2)*isamp 
            ne_ch=((nstrob_order*2+n_s)*nomega/2+2*ith_channels)*isamp 
                                                                       
            do i=nb_ch,ne_ch 
             i4=4*i 
             j=j1+i4 
             aa(1)=POC(j+1) 
             aa(2)=POC(j+2) 
             aa(3)=POC(j+3) 
             aa(4)=POC(j+4) 
                                                                        
             j=j3+i4 
             cc(1)=conjg(POC(j+1)) 
             cc(3)=conjg(POC(j+2)) 
             cc(2)=conjg(POC(j+3)) 
             cc(4)=conjg(POC(j+4)) 
                                                                        
             call matprof(cc,aa,bb) 
             trace(i)=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+           &
                                                bb(4)*rho(4)            
!             call matprof(bb,rho,aa)                                   
!             hcc=hcc+aa(1)+aa(4)                                       
                    ! nch                                               
            end do 
            hcc=hc0 
            do i=nb_ch+1,ne_ch-1,2 
             hcc=hcc+trace(i)*2 
            end do 
            do i=nb_ch+2,ne_ch-2,2 
             hcc=hcc+trace(i) 
            end do 
            hcc=(hcc*2.0+trace(ne_ch)+trace(ne_ch))/3.0 
            hh=hh+2.0*real(hcc*swin) 
                    ! abs(swin) >0.001                                  
           end if 
                   ! n_s                                                
          end do 
          chrock(nchan)=hh 
               ! loop over angles by nch_angle                          
       end do 
!       write(6,'(8g10.5)') (chrock(i), i=1,nch_angle)                  
       nn=2*nstorTH1 
       do i=1,nch_angle 
        real_fr(nn+i)=chrock(i) 
       end do 
!------------------------------ifrcase=25-------------------------------
      else if(ifrcase.eq.25) then 
!      only b_graz_min=.true.                                           
       if(.not.b_total) goto 800 
                                                                        
       do nchan=1,nch_angle 
        grazing=0.001*(graz_beg+rd_theta*(nchan-1)) 
                                                                        
!       ****************************************************************
!       L.Deak 09.10.2002                                               
!                                                                       
         do lay=1,mlay 
          if(b_sites(lay)) then 
           Cmatrix(1,1,lay)= hc0 
           Cmatrix(2,2,lay)= hc0 
           Cmatrix(1,2,lay)= hc0 
           Cmatrix(2,1,lay)= hc0 
          end if 
         end do 
                                                                        
         call optic(mlay,b_sites,MAXGRP,GEOSTR,grazing,            &
                      Cmatrix,chilay,roughlay,vkd,Rmatrix)              
         R_oo=Rmatrix(1,1) 
!         write(6,'(a,4g15.5)') 'synrock  R_oo=', Rmatrix(1,1)          
!        ***************************************************************
                                                                        
!         do n=-nTH,nTH                                                 
!        do n=-1,1                                                      
                                                                        
!        construction of the input for general optics program           
!        here the matrix R for the ylayers are given :                  
!        satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))           
!                           (samplay(n,lay) -sapplay(n,lay))            
!         npos=8*abs(n)                                                 
!         if(n.lt.0)npos=npos+4                                         
                                                                        
!          write(6,'(a,2i6)')' iall=',iall                              
!          write(6,'(a,3i6)')' nomega,nTH=',nomega,nTH,nsampling        
        do ka=0,iall 
         n=ichall(ka) 
         do neg=-1,1,2 
          npos=8*n+(1-neg)*2 
!        (11 12)    effi (1 3)     fortran  ( 1 3 )                     
!        (21 22)         (4 2)              ( 2 4 )                     
          do lay=1,mlay 
           if(b_sites(lay)) then 
            nn=iposlay(lay)+npos 
            Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay) 
            Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay) 
            Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay) 
            Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay) 
           end if 
          end do   ! lay=1,mlay    
                                                                        
                                                                        
          call optic(mlay,b_sites,MAXGRP,GEOSTR,grazing,           &
                       Cmatrix,chilay,roughlay,vkd,Rmatrix)             
!         Fortran notation                                              
          i=neg*n 
          pocfi(1,i)=Rmatrix(1,1)-R_oo 
          pocfi(3,i)=Rmatrix(1,2) 
          pocfi(2,i)=Rmatrix(2,1) 
          pocfi(4,i)=Rmatrix(2,2)-R_oo 
                                                                        
         end do 
        end do     ! n=-nTH,nTH      
!           write(6,'(8f12.4)')( pocfi(1,i)*1000,i=-nTH,0,16)           
!           write(6,'(8f12.4)')( pocfi(2,i)*1000,i=-nTH,0,16)           
!           write(6,'(8f12.4)')( pocfi(3,i)*1000,i=-nTH,0,16)           
!           write(6,'(8f12.4)')( pocfi(4,i)*1000,i=-nTH,0,16)           
!          read(5,'(a)')                                                
        hhstr=0. 
        hhoff=0. 
        DO n_s=0,nstrob_order 
         swinr=real(array_fr(l1_get(0)+1+abs(n_s))) 
         swini=aimag(array_fr(l1_get(0)+1+abs(n_s))) 
         if(n_s.eq.0) swinr=swinr 
         if(abs(swinr)+abs(swini).gt.0.001)then 
                                                                     
          ij=n_s*nomega/2 
          mcht=ij+nhyperfine 
          do i=0,mcht 
           ichstr(i)=i 
          end do 
          do i=1,nvch 
           ichstr(mcht+i)=mcht+i*(i+1)/2 
          end do 
          icht=mcht+nvch 
                                                                        
          DO ka=0,icht 
           ii=ichstr(ka) 
                                                                        
           i=ii+ij 
           aa(1)=pocfi(1,i) 
           aa(2)=pocfi(2,i) 
           aa(3)=pocfi(3,i) 
           aa(4)=pocfi(4,i) 
                                                                        
           j=ii-ij 
           cc(1)=conjg(pocfi(1,j)) 
           cc(3)=conjg(pocfi(2,j)) 
           cc(2)=conjg(pocfi(3,j)) 
           cc(4)=conjg(pocfi(4,j)) 
           call matprof(cc,aa,bb) 
!          trace(bb*rho)                                                
           hc=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+bb(4)*rho(4) 
           trc(ii)=swinr*real(hc)-swini*aimag(hc) 
          END DO 
                                                                        
          DO ka=1,icht 
           ii=-ichstr(ka) 
                                                                        
           i=ii+ij 
           aa(1)=pocfi(1,i) 
           aa(2)=pocfi(2,i) 
           aa(3)=pocfi(3,i) 
           aa(4)=pocfi(4,i) 
                                                                        
           j=ii-ij 
           cc(1)=conjg(pocfi(1,j)) 
           cc(3)=conjg(pocfi(2,j)) 
           cc(2)=conjg(pocfi(3,j)) 
           cc(4)=conjg(pocfi(4,j)) 
           call matprof(cc,aa,bb) 
!          trace(bb*rho)                                                
           hc=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+bb(4)*rho(4) 
           trc(ii)=swinr*real(hc)-swini*aimag(hc) 
          END DO 
                                                                        
!          write(6,'(8f12.4)')(trc(i)*10000,i=-icht,icht,8)              
!          read(5,'(a)')                                                
          hh=0. 
          do i=-mcht+1,mcht-1,2 
           hh=hh+trc(i)*2 
          end do 
          do i=-mcht+2,mcht-2,2 
           hh=hh+trc(i) 
          end do 
          hh=(hh*2.0+trc(-mcht)+trc(mcht))/3.0 
          h1=hh 
!         if(mcht.ne.iall)then                                          
          do i=0,nvch 
                                        ! -ichstr(icht-i+2)=+ichstr(-ich
           x0 =-ichstr(icht-i+2) 
           x1 =-ichstr(icht-i+1) 
           x2 =-ichstr(icht-i) 
           ap0(i)= (x1-x2) 
           ap1(i)=-(x0-x2) 
           ap2(i)= (x0-x1) 
           bp0(i)=-(x1**2-x2**2) 
           bp1(i)= (x0**2-x2**2) 
           bp2(i)=-(x0**2-x1**2) 
           cp0(i)= (x1-x2)*x1*x2 
           cp1(i)=-(x0-x2)*x0*x2 
           cp2(i)= (x0-x1)*x0*x1 
                                                                        
           det=x0**2*ap0(i)+x0*bp0(i)+cp0(i) 
           dx3(i)=(x2**3-x0**3)/3./det 
           dx2(i)=-bp1(i)/2./det 
           dx1(i)=ap1(i)/det 
          end do 
                                                                        
          do i=2,nvch,2 
           k0 =-(icht-i+2) 
           k1 =-(icht-i+1) 
           k2 =-(icht-i) 
           ap= trc(k0)*ap0(i)+trc(k1)*ap1(i)+trc(k2)*ap2(i) 
           bp= trc(k0)*bp0(i)+trc(k1)*bp1(i)+trc(k2)*bp2(i) 
           cp= trc(k0)*cp0(i)+trc(k1)*cp1(i)+trc(k2)*cp2(i) 
           hh=hh+ap*dx3(i)+bp*dx2(i)+cp*dx1(i) 
          end do 
                                                                        
          do i=0,nvch-2 
           x0 =ichstr(i+mcht) 
           x1 =ichstr(i+mcht+1) 
           x2 =ichstr(i+mcht+2) 
           ap0(i)= (x1-x2) 
           ap1(i)=-(x0-x2) 
           ap2(i)= (x0-x1) 
           bp0(i)=-(x1**2-x2**2) 
           bp1(i)= (x0**2-x2**2) 
           bp2(i)=-(x0**2-x1**2) 
           cp0(i)= (x1-x2)*x1*x2 
           cp1(i)=-(x0-x2)*x0*x2 
           cp2(i)= (x0-x1)*x0*x1 
                                                                        
           det=x0**2*ap0(i)+x0*bp0(i)+cp0(i) 
           dx3(i)=(x2**3-x0**3)/3./det 
           dx2(i)=-bp1(i)/2./det 
           dx1(i)=ap1(i)/det 
          end do 
                                                                        
          do i=0,nvch-2,2 
           k0=(mcht+i) 
           k1=(mcht+i+1) 
           k2=(mcht+i+2) 
           ap= trc(k0)*ap0(i)+trc(k1)*ap1(i)+trc(k2)*ap2(i) 
           bp= trc(k0)*bp0(i)+trc(k1)*bp1(i)+trc(k2)*bp2(i) 
           cp= trc(k0)*cp0(i)+trc(k1)*cp1(i)+trc(k2)*cp2(i) 
           hh=hh+ap*dx3(i)+bp*dx2(i)+cp*dx1(i) 
          end do 
          hhoff=hhoff+hh-h1 
          hhstr=hhstr+hh 
         end if   ! swin >> 0.001 
        END DO     ! nstrob=0,nstrob_order   
!        write(6,'(f10.3,a,2f15.5)')grazing*1000,' hhstr,hhoff=', &      
!                                                 hhstr,hhoff/hhstr    
        chrock(nchan)=hhstr*2.0 
               ! loop over angles by nch_angle                          
       end do 
!      write(6,'(8g10.5)') (chrock(i), i=1,nch_angle)                  
       nn=2*nstorTH1 
       do i=1,nch_angle 
        real_fr(nn+i)=chrock(i) 
       end do 
!-----------------------------ifrcase=23---------------------------     
      else if(ifrcase.eq.23) then 
!      write(6,'(a)') ' synrock roughlay'                               
!      write(6,'(4f12.5)') (roughlay(i),i=1,mlay)                       
!      write(6,'(20i5)') (laystr(i),i=1,2*mlay)                         
!      write(6,'(4e12.5)') (chilay(i),i=1,mlay)                         
!      write(6,'(4e15.5)') (vkd(i),i=1,mlay)                            
!      write(6,'(20L3)') (b_sites(i),i=1,mlay)                          
!      write(6,'(f12.6)') graz_min                                      
!      write(6,'(20i3)')GEOSTR                                          
!      write(6,'(a,20i5)')' mlay,MAXGRP,nch_angle=',mlay,MAXGRP,nch_angle
                  
                                                                        
       do i=1,mlay 
        Cmatrix(1,1,i)=(0.0,0.0) 
        Cmatrix(1,2,i)=(0.0,0.0) 
        Cmatrix(2,1,i)=(0.0,0.0) 
        Cmatrix(2,2,i)=(0.0,0.0) 
       end do 
                                                                        
       do nchan=1,nch_angle 
        grazing=0.001*(graz_beg+rd_theta*(nchan-1)) 
                                                                        
        call optic(mlay,b_sites,MAXGRP,GEOSTR,grazing,             &
                      Cmatrix,chilay,roughlay,vkd,Rmatrix)              
!        if(nchan.eq.2)then                                             
!        write(6,'(i5,a,f15.5)')nchan,' synrock grazing=',grazing       
!        write(6,'(8f10.4)')Rmatrix                                     
!        end if                                                         
!       trace (dd+*dd*rho) is the intensity                             
!       bb=cc+                                                          
        dd(1)=Rmatrix(1,1) 
        dd(3)=Rmatrix(1,2) 
        dd(2)=Rmatrix(2,1) 
        dd(4)=Rmatrix(2,2) 
                                                                        
!       if(nchan.lt.20)write(6,'(8f10.5)') (dd(i),i=1,4)                
        bb(1)=conjg(dd(1)) 
        bb(4)=conjg(dd(4)) 
        bb(2)=conjg(dd(3)) 
        bb(3)=conjg(dd(2)) 
        call matprof(bb,dd,aa) 
        call matprof(aa,rho,bb) 
!       aa=cc*cc+ is a Hermitian matrix                                 
        h1=real(bb(1)+bb(4)) 
                                                                        
        if(grazing.lt.grazmin) then 
         h1=h1*sin(grazing)/sin(grazmin) 
        end if 
        chrock(nchan)=h1 
               ! loop over angles by nch_angle                          
       end do 
!       write(6,'(6g12.5)') (chrock(i),i=1,nch_angle,4)                 
                                                                        
       do j=1,nch_angle 
        chrock(j)=chrock(j)*counts_bunch 
       end do 
!       chrock(1)=counts_bunch                                          
!       write(6,'(a,2f10.3,L5)') 'prompt counts_bunch,det.,b_det.=',    
!     &   counts_bunch,detekt_eff,b_detekt_eff                          
       qn=0.0                                                                 
       qn(0)=1.d0 
       nst16=nstorTH1+nch_angle/2 
       if(b_detekt_eff) then 
        fn(0)=1 
        dn(0)=1 
        do i=1,30 
         dn(i)=dn(i-1)*(1.0-detekt_eff) 
        end do 
        do i=1,30 
         fn(i)=fn(i-1)*float(i) 
        end do 
        do i=1,30 
         dn(i)=(1.0-dn(i))/fn(i) 
        end do 
        do i=1,15 
         array_fr(nst16+i)=cmplx(dn(i),dn(i+15)) 
        end do 
       else 
        do i=1,30 
         dn(i)=(1.0-dn(i))/fn(i) 
        end do 
        do i=1,15 
         dn(i)=real(array_fr(nst16+i)) 
         dn(i+15)=aimag(array_fr(nst16+i)) 
        end do 
       end if 
       if(b_counts_bunch) then 
        do i=1,30 
         qn(i)=qn(i-1)*counts_bunch
        end do 
        k=0 
        h=1 
        do while(h.gt.1.0e-4.and.k.le.29) 
         k=k+1 
         h=qn(k)/fn(k)/counts_bunch 
!        write(6,'(a,i2,a2,g15.5,)') 'prompt qn(k)/fn(',k,')=',h        
        end do 
                                                                        
        array_fr(nst16+16)=cmplx(float(k-1),0.0) 
       else 
        k=real(array_fr(nst16+16)) 
       end if 
       do j=1,nch_angle 
          do i=1,k
           qn(i)=qn(i-1)*chrock(j)
           if(qn(i).lt.1.d-48)qn(i)=0.d0
        end do
        h=0 
        do i=1,k 
         h=h+dn(i)*qn(i)
        end do 
        chrock(j)=h*exp(-chrock(j)) 
       end do 
                                                                        
       goto 900 
      end if  ! ifrcase  

  800 continue 
!     write(6,'(8g10.5)') (chrock(i)*100,i=1,100)                       
      nn=2*nstorTH1 
      do nchan=1,nch_angle 
       chrock(nchan)=real_fr(nn+nchan) 
      end do 
                                                                        
      do nchan=1,nch_angle 
       grazing=0.001*(graz_beg+rd_theta*(nchan-1)) 
       if(grazing.lt.grazmin) then 
        chrock(nchan)=chrock(nchan)*sin(grazing)/sin(grazmin) 
       end if 
      end do 
      b_total=.true. 
                                                                        
  900 sum=0. 
      do nchan=1,nch_angle 
       sum=sum+chrock(nchan) 
      end do 
      sum=sum/nchan
                                                                  
      nn=nstorTH*2 
      if(mstruct1.gt.1) nn=inc_pos*2 
      do i=1,nch_angle 
       real_fr(nn+i)=chrock(i)/sum 
      end do 
      call cpu_time(finish) 
      if(enwr(16).eq.'time')&
       print '(" runtime = ",f15.3," seconds.")',finish-start 
!      write(6,'(8f10.5)') (chrock(i)*100./sum,i=1,100)                 
!      write(6,'(a,i6)')' end of synrocking nstorTH=',nn                
                                                                        
!     end of calculation of absorber function                           
!     end of calculation for incoherent par                             
!      write(6,'(a,2i6)')'synrock lstruct1,mstruct1=',lstruct1,mstruct1 
      if(mstruct1.gt.1) goto 1000 
                                                                        
      if(.not.b_total)then
       if(allocated(POC)) deallocate(carray,POC) 
       return 
      end if
                                                                  
 2500 continue 
      if(mstruct1.gt.1) then 
!      summation of incoherent parts mstruct1                           
       nyout=nch_angle/2 
       do i=1,nyout 
        array_fr(nstorTH+i)=cmplx(0.,0.) 
       end do 
       do k=1,mstruct1 
        nn=ipos_mstruct1(k) 
!       write(6,'(a,3i6,2i8,f10.3)') &                                
!         'nstorTH,k,nthchannel,ipos_mstruct1(k),winc(k)=',  &
!             nstorTH,k,n,nn,winc(k)                         
!       write(6,'(8f10.4)')(array_fr(nn+i)*100,i=1,16)                  
        do i=1,nyout 
         array_fr(nstorTH+i)=                                           &
            array_fr(nstorTH+i)+array_fr(nn+i)*winc(k)                 
        end do 
       end do 
      end if 
      deallocate(carray,POC)                                                                   

      return 
      END                                           

