!    author : h. spiering                                              
!             Am Damsberg 86                                           
!             D-55130 Mainz                                            
!             december 2009                                            
!    synchrotron                                                       
     subroutine fr_syndoubleSC(cmch,iss,info) 
     use glbconst, only: maxfr1,maxfr2,maxn,maxthss,icstrf,ivstrf,     &
                         enwr,infotext,nwr,ncl
     use comdat, only: b_theory,data_str,formdata,mxpt,mfpt,mdfpt,mlpt,&
                       nuofdatas,ichanks
     use complt, only: n_subset
     use comthe, only: ifrsto,mGa,theoryname,thfrcase
     implicit none 
     character(len=4), intent(inout):: cmch
     integer, intent(in) :: iss
     integer, intent(out):: info    

     integer       mstruct1,istruct1,istruct2,                        &
                   l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,         &
                   nstorTH,nstorTH1,nstorTHyy,nstorSI,iposLG,mpt,iaddr
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname 
     real          srw8 
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),                                        &
                   mpt,iposLG,nstorTH,nstorTH1,nstorTHyy,nstorSI,iaddr(2)

     integer       nTH1,nCP,nTH2,nsrw,nstore,iduma,ifrth,         &
                   iflag_basis,lfwscat,nLG,nTH,ith_channels,           &
                   nsampling,ak8,idumb,nstrob_order,jt0_ch,            &
                   iT_max,nvch,ien   
     common/strLOC/nTH1,nCP,nTH2,nsrw,nstore,iduma,ifrth(6),      &
                   iflag_basis,lfwscat,nLG,nTH,ith_channels,           &
                   nsampling,ak8,idumb,srw8,nstrob_order,jt0_ch,       &
                   iT_max,nvch,ien(7)                      
                                                                       
     real          acsp,wavelength,uthick,uthick_A,                    &
                   unit_chi,aiT_max,v_max,                             &
                   ak_extension,T_bunch,dastr,channels,                &
                   ch_angle,graz_beg,graz_end,t0_norm,flag_basis,dumcsp  
     common/acstrf/acsp,wavelength,uthick,uthick_A,                    &
                   unit_chi,aiT_max,v_max,                             &
                   ak_extension,T_bunch,dastr,channels,                &
                   ch_angle,graz_beg,graz_end,t0_norm,flag_basis,      &
                   dumcsp(icstrf-16)
                                                                       
     real      avsp,counts,background,dum0,Pxsi,Peta,Pzeta,            &
               PA0,PAxsi,PAeta,PAzeta,t_shift,graz_angle,phi_z,        &
               detekt_eff,counts_bunch,dumvsp                          
     common/avstrf/avsp,counts,background,dum0,Pxsi,Peta,Pzeta,        &
               PA0,PAxsi,PAeta,PAzeta,t_shift,graz_angle,phi_z,        &
               detekt_eff,counts_bunch,dumvsp(ivstrf-16)               
                                                                       
     integer mdastr,nchansp,moschannel,ichanDA,k_extension,                    &
             iT_max2,lstruct1,lstruct2,lstruct3,ncloc,                 &
             nstorLG,i,k1,k2,m1,m3,jshift                              
     real    vector_k,cv_ET,schrw 
!*************** user defined common block and definitions ************
     character(len=40),dimension(3):: text
     character(len=1):: ch1
!     ichall array contains the non eqidistant channel numbers for inte
!     tion over the stroboscopic windows (important for computation tim
!**********************************************************************
      real,parameter :: rad=0.0174533,pi=3.14159          

                                                                       
      if(cmch.eq.'thna') then 
       theoryname='Synchrotron source-double scattering  v=001' 
       thfrcase(1)='Nuclear double FG scattering(11)     v=001' 
       thfrcase(2)='Nuclear double GF scattering(12)     v=001' 
       thfrcase(3)='Nuclear double Ff scattering(13)     v=001' 
       thfrcase(4)='Nuclear double fF scattering(14)     v=001' 
!      index <= maxthfrcase                                                       
       return 
      end if 
      if(cmch.eq.'dstr') goto 100 
!***********************************************************************
      ncloc=ncl 
      if(ncloc.gt.132)ncloc=132 

      nchansp=channels 
      if(cmch.eq.'arr0') then 
!      ++++++++++++++++++++++++ arr0 +++++++++++++++++++++++++++++++++  
       ichanDA=(nuofdatas+2)*((nchansp+1)/2)
       iposLG=ichanDA+6 ! info=5 Lorentz-Gauss parameter, positon LG
       mpt=0            ! absolute address incremented in common/struct/

       if(nuofdatas.eq.0) then
        ichanks(0)=2; ichanks(1)=1; ichanks(2)=nchansp
       end if

       k_extension=ak_extension 
       vector_k=2*pi/wavelength    ! /Angstroem 
       cv_ET=100.*wavelength       ! mm/s*ns 
       iflag_basis=nint(flag_basis) 
       lfwscat=1 
       nsampling=8 
                                                                        
       iT_max=nint(aiT_max) 
        iT_max2=2**iT_max 
        schrw=cv_ET/abs(T_bunch*iT_max2) 
        i=2*v_max/schrw+1 
        moschannel=1 
        do while(i.gt.0) 
         i=i/2 
         moschannel=moschannel*2 
        end do 
                                                                        
        schrw=schrw*(moschannel-1)/moschannel 
        v_max=schrw/2.0*(moschannel-1) 
                                                                        
        nTH=moschannel*2**k_extension 
        ak8=8*moschannel 
                                                                        
        jt0_ch=t0_norm*moschannel/abs(T_bunch) 
        ith_channels=moschannel 
                                                                        
        if(enwr(6)(1:1).eq.'y') then 
         write(nwr,'(a,f10.3,a,i4,/,a,/a,i3)')                          &
     &     'actual used v_max=',v_max,                                  &
     &   '  and number of channels of the theory=',moschannel,          &
     &   '(in order to fulfil the FFT-conditions)',                     &
     &   '  and number of channels for t0_norm=',jt0_ch                 
        end if 
                                                                        
!       write(6,'(a,2f15.5,3i6)')                                       
!     & 'T_bunch,aiT_max,iT_max,iT_max2,nth=',                          
!     &  T_bunch,aiT_max,iT_max,iT_max2,nth                             
!        write(6,'(a,4i6)') 'jt0_ch,nTH,nth,moschannel=',               
!     &          jt0_ch,nTH,nth,moschannel                              
                                                                        
                                                                        
        if(nTH.gt.2*maxn) then 
         info=nTH 
         infotext(1)='<Synchrotron-time_differential>/synmos/channels' 
         infotext(2)=' number of channels too large' 
         infotext(3)=' ' 
         return 
        end if 
                                                                        
         nCP=nTH 
         nsrw=1 
         do while(2*nCP.gt.maxn) 
          nCP=nCP/2 
          nsrw=nsrw*2 
         end do 
!        write(6,'(a,3i4)')'frame02 nTH,nCP,nsrw=',nTH,nCP,nsrw         
                                                                        
         jshift=abs(t_shift/T_bunch*2.*moschannel)+1 
         if(jshift.gt.maxn/4) then 
          info=jshift/4 
          infotext(1)='<Synchrotron-time_differential>/synmos/timeshift' 
          infotext(2)='t_shift channels too large' 
          infotext(3)=' ' 
          return 
         end if 
                                                                        
!        write(6,'(a,2f10.1)')'ch_angle=',ch_angle                      
         srw8=schrw/8. 
         nLG=(nTH+moschannel)*8 
                                                                        
         nTH1=nTH/iT_max2 
         if(nTH1.gt.512) nTH1=512 
!        nTH2=8*(nCP+1)                                                 
         nTH2=16*maxn    ! storage for POCG    
!                                                   and 8*(nCP+1)       
         nstorLG=nLG+1   ! Lorentz-Gauss curves
                                                                        
                                                                        
!      nTH+1 is the out of synmos , nchansp/2 for thyy in syn_the2exp   
!      both on array_fr, yth is calculated from nTH+1 -> nchansp/2      
!      and linear t_scale with tshift=0                                 
                                                                        
       nstore=0 
       ifrsto=iposLG+nstorLG+nTH1+nTH2+nstore+(nchansp+1)/2 
!       write(6,'(a,8i8)')                                              
!     & 'fr_synmoss ifrsto,iposLG,nstorLG,nTH1,nTH2,nstore,nchansp=',     
!     &             ifrsto,iposLG,nstorLG,nTH1,nTH2,nstore,nchansp        
                                                                        
!      the relativ addresses are stored after finishing                 
!      the entries arr0,i,e                                             
       nstorTH=iposLG+nstorLG 
       nstorTH1=nstorTH+nTH1 
                                            ! calculated values (nchansp
       nstorTHyy=nstorTH1+nTH2+nstore 
!                                             for each measured point   
       nstorSI=0 
!      nstorSI=nstorTHyy+(nchansp+1)/2          ! the maxsub*(1+maxthss)
!                                             are needed for i_int in ro
!                                             select.f of subspectra    
                                                                        
!      the relativ addresses are reloaded before entering fr_theoryxx   
!      and changed to absolute addresses which are temporarily stored   
!      the 8 integers following c3_prp(maxthss) are considered to be    
!      relative addresses which during reloading are changed to absolute
!      addresses of the complex array  'array_fr(1:marray_sp).          
       return 
                                                                        
      else if(cmch.eq.'arri')then 
!      ++++++++++++++++++++++++++ arri +++++++++++++++++++++++++++++++++
       ifrsto=0 
       call l_structure(iss,lstruct1,lstruct2,lstruct3) 
!       ifrsto=100+iss                                                  
       if(lstruct3.eq.0) then 
        if(lstruct2.eq.0) then 
!        lstruct1#0 , incoherent sum over mstruct1 members              
         if(mstruct1.gt.1) ifrsto=maxn 
        else 
         if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then 
          ifrsto=8*(nTH+1) 
         end if 
        end if 
       end if 
                                                                        
       return 
      else if(cmch.eq.'arre')then 
!       +++++++++++++++++++++++++++ arre +++++++++++++++++++++++++++++++
                                                                        
       ifrsto=0 
       return 
      end if   ! arr0,i,e    
      mdastr=dastr 
                                                                        
!      write(6,'(a,/,8i8)')                                             
!     &'iarray_sp,nstorFR,l1_put(0),nstorTH,nstorTH1,nstorTHyy,nstorSI='
!     & iarray_sp,nstorFR,l1_put(0),nstorTH,nstorTH1,nstorTHyy,nstorSI  
                                                                        
!      write(6,'(a,/,6i8,f12.3)')                                       
!     & 'nTH,nTH1,ak8,nLG,nsampling,mdastr,srw8=',                      
!     &                   nTH,nTH1,ak8,nLG,nsampling,mdastr,srw8        
                                                                        
      m1=mstruct1 
      m3=istruct2(istruct1(mstruct1)) 
!      storag on real_fr(2*(iarraysp+nstorFR)+m) (array_f)              
!      corresponds to the i= drive_mode (label 100)                     
      mfpt=2*mpt                 ! measured (function) data
      mdfpt=mfpt+nchansp         ! errors of y data (calculated by sqrt 
      mxpt=mfpt+2*nchansp        ! x data (angle) mdastr=3  
      mlpt=mfpt+3*nchansp 
!     write(6,'(a,5i7)')' mfpt,mxptmdastr=',mfpt,mxpt,mdastr            
!***********************************************************************
!      write(6,'(i4,a,a)') ifrcase,' frame02 entered with=',cmch        
      if(cmch.eq.'data') then 
       k1=1 
      else if(cmch.eq.'ecic') then 
       k1=2 
      else if(cmch.eq.'test') then 
       k1=3 
      else if(cmch.eq.'dfdp') then 
       k1=4 
      else if(cmch.eq.'subs'.or.cmch.eq.'subt') then 
       k1=5 
      else if(cmch(1:3).eq.'ple') then 
       k1=6 
      else if(cmch.eq.'dmod'.or.cmch.eq.'plot') then 
       k1=7 
      else if(cmch.eq.'punc')then 
       k1=8 
      end if 
                                                                        
      goto (110,120,200,300,400,500,600,700),k1 
!********************************************************************** 
  100 continue 
      call syn_plot(cmch) 
      mdastr=dastr 
      data_str=formdata(mdastr) 
      call data2dread(0,info) 
      return 
  110 continue 
      k1=iss 
      call data2dread(k1,info) 
      return 
  120 continue 
      call excinc2d(info) 
      return 
!***********************************************************************
!     'test': theory function is calculated in subroutine mossbauer     
                                                                        
  200 continue 
      k1=1 
      call syn_doublethe2exp(k1,info) 
      return 
!***********************************************************************
!     derivatives df                                                    
  300 continue 
      k1=2 
      call syn_doublethe2exp(k1,info) 
      return 
                                                                        
!***********************************************************************
!     subs, subt                                                        
  400 continue 
      text(1)='       scatterer' 
      text(2)=' incoherent part' 
      text(3)='                ' 
      if(info.eq.-1.and.n_subset.ne.0) return 
      if(cmch.eq.'subt') goto 450 
      print '(a)',' ' 
      print '(a)','      no subspectra calculated ' 
      print '(a)',' subspectra are not additive in the time domain' 
      ch1=' ' 
      return 
!*************************************************************          
!  call of subtract                                                     
  450 continue 
      print '(a)',' ' 
      print '(a)','          subtraction of subspectra' 
      print '(a)','      has no meaning in the time domain' 
      return 
!***********************************************************************
!     plot execute                                                      
!     different plot programs may be called due to a flag constant      
!     to be introduced as global constant                               
  500 continue 
       k1=0 
       if(b_theory) k1=1 
                                   ! update test                        
       if(cmch(4:4).eq.'2') k1=2 
                                   ! update fit                         
       if(cmch(4:4).eq.'3') k1=3 
                                                                        
!              0,1    2d standard plot, 2,3 3d-plot                     
!              0,2: plot and return;  1,3: interactive plot             
       k2=1 
       call xmosplo(k1,k2) 
       return 
!***********************************************************************
!     display mode , filling of plotarray                               
  600 continue 
      if(cmch.eq.'dmod') then 
        call syn_plot(cmch) 
            ! cmch='plot'                                               
      else 
       if(b_theory)then 
        k1=3 
        call syn_doublethe2exp(k1,info) 
       end if 
!       write(6,'(a,a4,4i6)')' fr_synmoss cmch,ifrcase,dastr=',         
!     &                                cmch,ifrcase,int(dastr)          
        k1=4 
        call syn_doublethe2exp(k1,info) 
        call syn_plot(cmch) 
      end if 
      return 
!***********************************************************************
!     punch data and theory                                             
  700 continue 
      k1=iss 
      call punch2d(k1,info) 
      cmch='dim2'
      return 
                                                                        
      END                                           
                                                                        
                                                                        
                                                                        
!    ################################################################  
!              connection between experiment and theory                
!              (also called by the fit routine)                        
                                                                       
     subroutine syn_doublethe2exp(n1,info) 
     use glbconst, only: maxfr1,maxfr2,maxn,max8,maxthss,icstrf,ivstrf
     use comdat, only: mxpt,mlpt,b_data,b_theory
     use comthe, only: real_fr,ifrcase,thfk,dfdp,ddpk,ib_df,kana,ibmisfit
! ****************************************************************     
!    n1 = 0 error return                                               
!    n1 = 1 call of theory                                             
!    n1 = 2 derivatives                                                
!    n1 = 3 call of theory , calpl is not called                       
! ****************************************************************     
     implicit none 
     integer, intent(in) :: n1
     integer, intent(out):: info

                                                                       
     integer,parameter ::istr=38+4*(maxfr1+maxfr2)+3*maxthss 
     integer       dstr,nstorTH,idum1,nstorTHyy,iaddr
     common/struct/dstr(istr+2),nstorTH,idum1,nstorTHyy,iaddr(3)

     integer       nTH1,idum4,nexp,ifrth,iT_max,idum2,ien 
     real          xb_exp,dx_exp
     common/strLOC/nTH1,idum4(4),nexp,ifrth(17),                  &
                   iT_max,idum2(2),xb_exp,dx_exp,ien(4)

     real          acsp,aiT_max,adum,T_bunch,dastr,channels,dumcsp     
     common/acstrf/acsp(5),aiT_max,adum(2),T_bunch,                    &
                   dastr,channels,dumcsp(icstrf-11)        
                                                                       
     real          avsp,counts,background,Pdum,t_shift,dumvsp 
     common/avstrf/avsp,counts,background,Pdum(8),                     &
                   t_shift,dumvsp(ivstrf-12)                           
                                                                       
     logical       b_vs,b_counts,b_background,b_Pdum,                  &
                   b_t_shift,b_dumvsp                       
     common/bvstrf/b_vs,b_counts,b_background,b_Pdum(8),               &
                   b_t_shift,b_dumvsp(ivstrf-12)            
                                                                       
     logical b_total,b_residual 
                                                                       
     real    countsy,dx_the,xb_the,y1,y2,yi,ff,hi   
     integer nthe,iT_max2,invers,jshift,ipnth,ji,i,k,k1,nn,j,mdastr
     integer, save:: ipntho=0
     real, dimension(:), allocatable,save:: x_exp
     real, dimension(:), allocatable,save:: yth

     nexp=channels            
     do i=1,nexp
       real_fr(mlpt+i)=0.0
    end do
    !penalty function required by subroutine fit.f90
                                                                       
!      write(6,'(a,5i6)')'syngl n1,ifrcase,dastr=',                     
!     &                         n1,ifrcase,mdastr                       
      ibmisfit=0 
                                                                        
      nthe=nTH1*2 
      dx_the=abs(T_bunch)/nthe 
      dx_exp=abs(T_bunch)/channels 
      xb_the=t_shift 
      xb_exp=0.0 
      invers=0 
      if(T_bunch.lt.0) invers=nexp+1 
      xb_the=t_shift 

      mdastr=dastr 
      if(b_data)then
       if(mdastr.lt.3)then
        hi=xb_exp-dx_exp 
        do k=1,nexp 
         hi=hi+dx_exp 
         real_fr(mxpt+k)=hi 
        end do 
       end if
      else
       mdastr=1
       hi=xb_exp-dx_exp 
       do k=1,nexp 
        hi=hi+dx_exp 
        real_fr(mxpt+k)=hi 
       end do 
      end if

      i=size(x_exp)
      if(allocated(x_exp).and.i.lt.nexp) deallocate(x_exp)
      if (.not.allocated(x_exp))allocate(x_exp(nexp))
      do i=1,nexp
       x_exp(i)=real_fr(mxpt+i)
      end do
      if(n1.eq.4)goto 310 

      jshift=abs(xb_the/dx_the)+1 
       ji=abs(invers-1) 
      i=int((x_exp(ji)-xb_the)/dx_the) 
      ipnth=(jshift+abs(i))*2
!     write(6,*)'x_exp(1),x_exp(nexp),xb_the,dx_the =',x_exp(1),x_exp(nexp),xb_the,dx_the 

      i=size(yth)
      if(allocated(yth).and.                                            &
         (ipnth.gt.ipntho.or.i-ipntho-1.lt.nthe+ipnth))deallocate(yth)
      if (.not.allocated(yth))allocate(yth(-ipnth:nthe+ipnth))
      ipntho=ipnth

      countsy=counts-background*channels 
!      integral 0-inf is normalized to 1                                
!      write(6,'(a,4f10.2)') 'syndoubleSC counts,background,channels=', 
!     &    counts,background,channels                                   
      iT_max=aiT_max 
      iT_max2=2**iT_max 
!     write(6,'(a,i6,f15.5)') 'iT_max2=',2**iT_max                      
!     write(6,'(8f10.5)') (yth(i)*100.,i=-2,nthe,16)                    
!     write(6,'(8f12.2)') (yth(i)*countsy,i=1,nTH1)                     
!     write(6,'(4(a,f10.5),a,i4)') ' ***synchrotron*** backgr=',        
!    &         background,' aiT_max=',aiT_max,' dx_the=',dx_the,        
!    &         '  t_shift=',t_shift,'  nexp=',nexp                      
!      write(6,'(a,6L5)')',b_total,b_background,b_counts,b_t_shift =',  
!     &             b_total, b_background,b_counts,b_t_shift            
                                                                        
      call syn_doubleSC(b_total,info) 
                                                                        
      k1=n1 
      goto (100,200,300),k1 
                                                                        
  100 continue 
!     calculation of thfk                                               
      nn=nstorTH*2 
      do j =1,nthe 
       yth(j)=real_fr(nn+j) 
      end do 
      do k=0,ipnth
       yth(-k)=0. 
       yth(nthe+k)=yth(nthe) 
      end do                                                                        
!      write(6,'(a,/,2i5,2f10.3,i5,2f10.3)') &                           
!      'frame mdastr,nexp,dx_exp,xb_exp,nthe,dx_the,xb_the=',&          
!             mdastr,nexp,dx_exp,xb_exp,nthe,dx_the,xb_the             
!      write(6,'(6g12.3)') (yth(k),k=1,2*nTH1,16)                       
!      write(6,'(8f10.5)') (yth(k)*100.,k=1,100)                        
                                                                        
      do j=1,nexp 
       ji=abs(invers-j) 
       hi=(x_exp(ji)-xb_the)/dx_the 
       i=int(hi) 
       if(i.le.0)i=i-1 
       hi=hi-float(i) 
!       y2=yth(i-2)+yth(i+2)                                            
!       y1=yth(i-1)+yth(i+1)                                            
!       aa=(2.0*y2-y1-yth(i))/14.0                                      
!       bb=(-2.0*(yth(i-2)-yth(i+2))-yth(i-1)+yth(i+1))/10.0            
!       cc=(-3.0*y2+12.0*y1+17*yth(i))/35.0                             
!       yi=cc+hi*(aa*hi+bb)                                             
       y1=yth(i) 
       y2=yth(i+1) 
       yi=y1+hi*(y2-y1) 
       thfk(j)=yi*countsy+background 
      end do 
                                                                        
      nn=nstorTHyy*2 
      do j=1,nexp 
       real_fr(nn+j)=thfk(j) 
      end do 
!      write(6,'(6g12.2)') (thfk(i),i=1,nexp,8)                              
      b_theory=.true. 
                                                                        
      return 
                                                                        
  200 continue 
      ib_df=0 
                                                                        
!     derivatives                                                       
!     ib_df=1: derivative calculated                                    
!     ib_df=0 happens if a parameter of a set, wich is not currently    
!     fitted, is free. It will be fixed in the routine fit.             
                                                                        
!     analytical and numerical derivatives are handled fdifferently     
!     integer kana (k analytical) = 1 indicates an analytical derivative
                                                                        
!     (the fact that a parameter x can mix up variables type            
!      complicates the situation. An analytical derivative of a variale 
!      can only be calculated, if it is not connected to a different    
!      parameter by the transformation matrix)                          
                                                                        
!     variable background, counts are analytically derived              
!     the total number of variables of the set is contained in b_total  
!     (for all variables of synchrotron, synrock) and the glabal        
!     variables of this routine: counts,background,t_shift              
!     t_shift is numerically derived (enters x_data by xb_the)         
                                                                        
!      common/avstrf/avsp,counts,background,dum0,Pxsi,Peta,Pzeta,            
!     &          PA0,PAxsi,PAeta,PAzeta,t_shift,graz_angle,graz_min,        
!                phi_z,dumvsp(idumvsp)                                  
                                                                        
      b_total=b_total.or.b_t_shift 
                                                                        
      b_residual=.not.(b_total.or.b_counts) 
!     all variables unchanged but background                            
                                                                        
      if(b_background.and.b_residual) then 
!       write(6,'(a)')  '   derivative of background ------------'      
        do j=1,nexp 
         dfdp(j)=1.0 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
      end if 
!     for background derivative the last theory values were not neccessa
      nn=nstorTHyy*2 
      do j=1,nexp 
       thfk(j)=real_fr(nn+j) 
      end do 
!     write(6,'(8f10.5)') (thfk(i),i=1,nexp,18)                         
                                                                        
      b_residual=.not.(b_total.or.b_background) 
!     all variables but counts                                          
      if(b_counts.and.b_residual) then 
!       write(6,'(a)')  '   derivative of counts ------------'          
        do j=1,nexp 
         dfdp(j)=(thfk(j)-background)/countsy 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
      end if 
                                                                        
                                                                        
!     numerical derivatives                                             
      b_residual=.not.(b_total.or.b_background.or.b_counts)         
!     (b_residual=.true.: parameter is connected only to variables      
!     of other sets                                                     
!      write(6,'(a,l5,g15.3)')'fr_synmoss b_resid.,ddpk=',b_residual,ddp
      if(b_residual) goto 250 
                                                                        
      kana=0 
      nn=nstorTH*2 
      do j =1,nthe 
       yth(j)=real_fr(nn+j) 
      end do 
      if(ifrcase.ge.22) then 
       do k=0,jshift 
        yth(-k)=yth(1) 
        yth(nthe+k+1)=yth(nthe) 
       end do 
      else 
       do k=0,jshift+1 
        yth(-k)=yth(nthe-k) 
       end do 
      end if 
                                                                        
      do j=1,nexp 
       ji=abs(invers-j) 
       hi=(x_exp(ji)-xb_the)/dx_the 
       i=int(hi) 
       if(i.le.0)i=i-1 
       hi=hi-float(i) 
       y1=yth(i) 
       y2=yth(i+1) 
       ff=y1+hi*(y2-y1) 
       dfdp(j)=(ff*countsy+background-thfk(j))/ddpk 
               ! j=1,nexp                                               
      end do 
      ib_df=1 
                                                                        
  250 continue 
      return 
                                                                        
  300 continue 
!     calculation of thfk                                               
                                                                        
      if(.not.b_theory) goto 310 
                                                                        
      nn=nstorTH*2 
      do j =1,nthe 
       yth(j)=real_fr(nn+j) 
      end do 
      do k=0,ipnth
       yth(-k)=0. 
       yth(nthe+k)=yth(nthe) 
      end do 
                             
       do j=1,nexp 
        ji=abs(invers-j) 
        hi=(x_exp(ji)-xb_the)/dx_the 
        i=int(hi) 
        if(i.le.0)i=i-1 
        hi=hi-float(i) 
        y1=yth(i) 
        y2=yth(i+1) 
        yi=y1+hi*(y2-y1) 
        thfk(j)=yi*countsy+background 
       end do 
  310 return 
      END                                           
                                                                        
!     #################### calculation of theory #######################
                                                                        
     subroutine syn_doubleSC(b_total,info) 
!    ifrcase=1  ! forward scattering geometry                          
!    ifrcase=2  ! grazing incidence geometry,time differential         
     use glbconst
     use comthe
     implicit none 
     logical, intent(out):: b_total 
     integer, intent(out):: info
                                                                       
                                                                       
     integer     mstruct1,istruct1,istruct2,                           &
                 l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,            &
                 nstorTH,nstorTH1,mpt,iposLG,iaddr
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname 
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),                                        &
                   mpt,iposLG,nstorTH,nstorTH1,iaddr(4)
                                                                       
     integer       idum1,nCP,idum2,nsrw,ifrth,                        &
                   iflag_basis,lfwscat,idum3,nTH,ith_channels,        &
                   idum5,jt0_ch,iT_max,ien 
     common/strLOC/idum1,nCP,idum2,nsrw,ifrth(8),                     &
                   iflag_basis,lfwscat,idum3,nTH,ith_channels,        &
                   idum5(5),jt0_ch,iT_max,ien(8)                       

     real          acsp,wavelength,uthick,uthick_A,unit_chi,dumcsp 
     common/acstrf/acsp,wavelength,uthick,uthick_A,unit_chi,           &
                   dumcsp(icstrf-5)                                    
                                                                       
                                                                       
     real          avsp,Pxsi,Peta,Pzeta,PA0,PAxsi,PAeta,PAzeta,            &
                   adum1,graz_angle,dumvsp  
     common/avstrf/avsp(4),Pxsi,Peta,Pzeta,PA0,PAxsi,PAeta,PAzeta,     &
                   adum1,graz_angle,dumvsp(ivstrf-13) 
                                                                       
     logical       b_avsp,b_Pxsi,b_Peta,b_Pzeta,b_PA0,b_PAxsi,b_PAeta, &
                   b_PAzeta,b_adum1,b_graz_angle,b_dumvsp  
     common/bvstrf/b_avsp(4),b_Pxsi,b_Peta,b_Pzeta,b_PA0,b_PAxsi,b_PAeta,&
                   b_PAzeta,b_adum1,b_graz_angle,b_dumvsp(ivstrf-13)
                                                                       
     real            avfr1,pvfr1,dumvfr1 
     common/avfr1trf/avfr1,pvfr1,dumvfr1(ivfr1trf-2) 
     logical         b_vfr1,b_pvfr1,b_dumvfr1 
     common/bvfr1trf/b_vfr1,b_pvfr1,b_dumvfr1(ivfr1trf-2) 
                                                                       
     real            acfr2,rep_grp,dumcfr2 
     common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2) 
                                                                       
     real            avfr2,thicklay,re_chilay,ai_chilay,roughness,     &
                     dumvfr2                                           
      common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,    &
                     dumvfr2(ivfr2trf-5)                               
     logical         b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,        &
                     b_roughness,b_dumvfr2                             
     common/bvfr2trf/b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,        &
                     b_roughness,b_dumvfr2(ivfr2trf-5)                 
                                                                       
     real           vsstrf,sftr 
     common/avsstrf/vsstrf(ivsstrf)
!                   Axf=vsstrf(2) :  Angstrom*f_factor
     logical        b_vsstrf,b_sftr 
     common/bvsstrf/b_vsstrf(ivsstrf) 
                                                                       
     logical  b_lay,b_isgt1,b_fo 
     logical,dimension(maxfr2):: b_sites
     real,dimension(maxfr1) :: winc
     real,dimension(maxfr2) :: vkd
     real,dimension(maxthss):: wi
                                                                       
     integer   isubthe,nt,inc_pos,                                     &
               lstruct1,lstruct2,lstruct3,iset,is_a,is_e,              &
               i,ii,j,jj,ij,l,n,nn,jftau,jt0,                          &
               k,ll,lay,mlay,layb,laye,isctp,                          &
               npos,mlays                   
                                                                       
     real      grazing,vector_k,h1,h2,sing,sum,relthick
                                                                       
     real,   dimension(maxfr2)    :: thicklayer,roughlay
     integer,dimension(maxfr2)    :: iposlay,laysites
     integer,dimension(2*maxfr2+2):: laystr 
     integer,dimension(0:2*maxfr2):: GEOSTR
                                                                       
     complex   hc,hc1,hci,hc0,trace,R_oo

     complex(kind=4),dimension(4)         :: bb,dd,rho,Arho
     complex(kind=4),dimension(4,maxfr2)  :: ddlay
     complex(kind=4),dimension(2,2,maxfr2):: Cmatrix
     complex(kind=4),dimension(maxfr2)    :: chilay
     complex(kind=4),dimension(2,2)       :: Rmatrix,trv,TSPCA,sph 
                                                                       
     integer,parameter:: mFF=16*maxn,mAL=mFF+8,mcLG=2*maxn,            &
                         idumscrd=maxscrd/2-mFF-mAL-2*mcLG-1-2*maxn-1           
     complex   carray,cLG,POC,dumscrd 
     real      yth 
     common/scrd/POC(mFF),carray(mAL),cLG(-mcLG:mcLG),yth(-1:4*maxn),  &
                 dumscrd(idumscrd)                                     
     real,parameter :: sqrt2r=0.70710678,rad=0.0174533,pi=3.14159 
                                                                       
! *** Definitions of structure variables L. Deak 09.10.2002 ***        
     integer POINTER,GRP,MGRP
     logical b_first,b_fwscat,b_scat12,b_1221 
! ***                                                       ***        
!      thfrcase(1)='Nuclear double FG scattering(11)     v=001'        
!      thfrcase(2)='Nuclear double GF scattering(12)     v=001'        
!      thfrcase(3)='Nuclear double Ff scattering(13)     v=001'        
!      thfrcase(4)='Nuclear double fF scattering(14)     v=001'        

       b_total=.false. 
!------------------------------------------------------------------     
!      L_poincare =0 is used for theories calling optics                
!-------------------------------------------------------------------    
                                                                        
      call mapsub(0,0,0) 
      isubthe=1 
      call get_theory(isubthe,info) 
      b_total= b_total.or.(isubthe.gt.0) 
                                                                        
      hc1=cmplx(1.,0.) 
      hci=cmplx(0.,1.) 
      hc0=cmplx(0.,0.) 
                                                                        
                                    ! /Angstroem                        
      vector_k=2.0*pi/wavelength 
                                                                        
!     fortran notation                                                  
      rho(1)=cmplx(1.+Pzeta,0.)/2. 
      rho(3)=cmplx(Pxsi,-Peta)/2. 
      rho(2)=cmplx(Pxsi,Peta)/2. 
      rho(4)=cmplx(1.-Pzeta,0.)/2. 
                                                                        
      Arho(1)=cmplx(Pa0+PAzeta,0.)/2. 
      Arho(3)=cmplx(PAxsi,-PAeta)/2. 
      Arho(2)=cmplx(PAxsi,PAeta)/2. 
      Arho(4)=cmplx(PA0-PAzeta,0.)/2. 
!     write(6,'(a,8f8.2)') ' rho=', (rho(k),k=1,4)                      
!-----------------------------------------------------------            
       if(iflag_basis.eq.0) then 
!      linear polarization basis                                        
       TSPCA(1,1)=cmplx( sqrt2r,0.) 
       TSPCA(1,2)=cmplx(-sqrt2r,0.) 
       TSPCA(2,1)=cmplx(0.,-sqrt2r) 
       TSPCA(2,2)=cmplx(0.,-sqrt2r) 
                                                                        
       sph(1,1)=rho(1) 
       sph(1,2)=rho(3) 
       sph(2,1)=rho(2) 
       sph(2,2)=rho(4) 
       do i=1,2 
       do k=1,2 
        hc=(0.,0.) 
        do j=1,2 
        do l=1,2 
         hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j)) 
        end do 
        end do 
        trv(i,k)=hc 
       end do 
       end do 
       rho(1)=trv(1,1) 
       rho(3)=trv(1,2) 
       rho(2)=trv(2,1) 
       rho(4)=trv(2,2) 
                                                                        
       sph(1,1)=Arho(1) 
       sph(1,2)=Arho(3) 
       sph(2,1)=Arho(2) 
       sph(2,2)=Arho(4) 
       do i=1,2 
       do k=1,2 
        hc=(0.,0.) 
        do j=1,2 
        do l=1,2 
         hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j)) 
        end do 
        end do 
        trv(i,k)=hc 
       end do 
       end do 
       Arho(1)=trv(1,1) 
       Arho(3)=trv(1,2) 
       Arho(2)=trv(2,1) 
       Arho(4)=trv(2,2) 
       end if 
!-----------------------------------------------------------            
      b_fwscat=.false.
      b_scat12=.false.
      b_1221=.true.
      if(ifrcase.eq.13) then
       b_fwscat=.true.;  b_scat12=.true.
      end if
      if(ifrcase.eq.14) b_fwscat=.true.    

      lstruct1=0 
 1000 continue 
      b_1221=.not.b_1221
      lstruct1=lstruct1+1 
      if(lstruct1.gt.mstruct1) goto 2500 
                                                                        
      if(ifrcase.eq.11)then
        b_fwscat=lstruct1.eq.1; b_scat12=.true.
      end if 
      if(ifrcase.eq.12) b_fwscat=lstruct1.eq.2 

      lfwscat=0 
      relthick=uthick_A 
      if(b_fwscat)then 
       lfwscat=1 
       relthick=uthick 
      end if 
      call mapsub(lstruct1,0,0) 
                                                                        
!      b_fo change of external field and scatterer orientation          
       b_fo=.false. 
       do i=1,6 
        b_fo=b_fo.or.b_dumvfr1(i) 
       end do 
                                                                        
      winc(lstruct1)=pvfr1 
      b_total=b_total.or.b_pvfr1.or.b_fo 
!      write(6,'(a,i1,a2,i8,L5)')                                       
!     &       'synmos l1_put(',lstruct1,')=',l1_put(lstruct1),b_pvfr1   
      inc_pos=l1_put(lstruct1) 
                                                                        
!      write(6,'(a,i4,a,g12.4)')' synmos case=',ifrcase,' graz_angle=',graz_angle                                   
      if(.not.b_fwscat) then 
       grazing=0.001*graz_angle 
       sing=sin(grazing) 
      end if 
       
                                                                 
       layb=istruct1(lstruct1-1) 
       laye=istruct1(lstruct1) 
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
!      ------------------------------------------------------------     
!      layer lay1,2 ... mlay of  absorber                               
!      ---------------------------------------------------------------  
!      The Lorentz curve of the absorber in npq is 1 at resonance so tha
!      for a singl line the exponent at resonance is just -teff (effecti
!      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw
!      normalizes ( to area 1) the Lorentz curve.                       
!                                                                       
!      Sums of absorber curves at the positions Eagd.                   
!                                                                       
!      ----0--------------------------naLG                              
!       naLG--------------------------0-------------        srw8        
!        nTH------------0------------nTH                    srw         
        lay=lstruct2-layb 
                                                                        
        call mapsub(lstruct1,lstruct2,0) 
!        write(6,'(a,3g12.4)')' synmos r,i_chi,unit_chi=',              
!     &        re_chilay,ai_chilay,unit_chi                             
                                                                        
!        external field and scatterer orientation written on fr2        
!        th_22nuclear routines take the field from common/avfr2trf      
         do i=1,6 
          dumvfr2(1+i)=dumvfr1(i) 
         end do 
                                                                        
         b_lay=b_vfr2.or.b_fo 
         b_total=b_total.or.b_lay 
        if(b_fwscat) then 
         thicklayer(lay)=1. 
        else 
         thicklayer(lay)=thicklay 
         if(abs(re_chilay)+abs(ai_chilay).gt.1.0e-10) then 
          chilay(lay)=cmplx(re_chilay,ai_chilay)*unit_chi 
         else 
          chilay(lay)=(0.,0.) 
         end if 
         i=rep_grp 
         laystr(2*lay-1)=i 
         laystr(2*lay)=10*(rep_grp-float(i)+.01) 
         roughlay(lay)=roughness 
        end if 
                                                                        
        b_isgt1=.false. 
        if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then 
         b_isgt1=.true. 
         iposlay(lay)=l2_put(lstruct2) 
         do i=1,8*(nTH+1) 
          carray(i)=(0.,0.) 
         end do 
        end if 
        b_sites(lay)=.false. 
                                                                        
        do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
                                                                        
         iset=lstruct3 
         b_sites(lay)=.true. 
                                                                        
         call mapsub(lstruct1,lstruct2,lstruct3) 
                                                                        
         sftr=vsstrf(2) 
         b_sftr= b_vsstrf(2) 
         wi(iset)=sftr*relthick

!         write(6,'(i3,2x,a,i4,3g10.3)')lstruct1,                       
!     &    'synmos lay,wi,sftr,winc=',lay,wi(iset),sftr,winc(lstruct1)  
                                                                        
                                                                        
         if(.not.b_fwscat) then 
          if(b_sftr.and.enwr(6).eq.'nynn') then 
           if(wi(iset).gt.sing/20..or.sing.gt.0.05)                    &
           write(nwr,'(2(a,g8.1),a)')                                  &
           '** f*unit_thickness=',wi(iset),' << sin(th)=',sing,' << 1 ?'
          end if 
         end if 
         isubthe=0 
         call get_theory(isubthe,info) 
         b_lay=b_lay.or.b_sftr.or.(isubthe.gt.0) 
         b_total=b_total.or.b_lay 
                                                                        
!         write(6,'(8f12.4)')array_fr(l3_get(lstruct3)+1)*1.e4, &        
!                           array_fr(l3_get(lstruct3)+9)*1.e4          
                                                                        
         if(b_isgt1) then 
          isctp=l3_get(lstruct3) 
          do n=0,nTH 
           nn=isctp+8*n 
           ll=8*n 
            do k=1,8 
            carray(ll+k)=carray(ll+k)+ array_fr(nn+k)*wi(iset) 
            end do 
          end do 
!        write(6,'(a)') 'synmoss carray(1..)='                          
!         write(6,'(8f12.4)') (carray(i)*1000,i=1,8)                     
         else 
          iposlay(lay)=l3_get(lstruct3) 
          nn=l3_get(lstruct3)
!          write(6,*)'lstruct1=',lstruct1
!          write(6,'(8f12.4)') (array_fr(nn+i),i=1,64,8) 
!           write(6,'(a,i2,a2,i8)')                                     
!     &       'synmos  iposlay(',lay,')=',iposlay(lay)                  
         end if 
        end do 
                                                                        
        if(b_isgt1.and.b_lay) then 
         ll=iposlay(lay) 
         do i=1,8*(nTH+1) 
          array_fr(ll+i)=carray(i) 
         end do 
!         write(6,'(a,2i6)') 'synmoss carray(1..)  nn=',nn              
!         write(6,'(8f12.4)') (carray(i)*1000,i=1,40)                   
        end if 
                                                                        
       end do 
       mlay=lay 
       laystr(2*lay+2)=-1 
       laystr(2*lay+1)=0 
                                                                        
!-----------------------------------------------------------------------
!     here the matrix R for the layers are given :                      
!     satrlay(n,lay)*1 +  (sapplay(n,lay)  sap(n,lay))                  
!                         (samplay(n,lay) -sapplay(n,lay))              
!                                                                       
!     calculation of the transmittivity matrix T for all channels n     
!     by   T = exp(iR)*rho*exp(-iR+)                                    
                                                                        
!      write(6,'(a,20i3)')'synmos laystr(1..mlay)=',(laystr(i),i=1,mlay)
      b_total=.true.
      if(.not.b_total) goto 2000 
                                                                        
      do k=1,mlay 
       laysites(k)=0 
      end do 
      if(b_fwscat) then 
       mlays=0 
       do lstruct2=layb+1,laye 
        lay=lstruct2-layb 
        is_a=istruct2(lstruct2-1)+1 
        is_e=istruct2(lstruct2) 
        if(b_sites(lay)) then 
         mlays=mlays+1 
         iposlay(mlays)=iposlay(lay) 
         if(is_e.gt.is_a) thicklayer(mlays)=thicklayer(lay) 
         if(is_e.eq.is_a) thicklayer(mlays)=thicklayer(lay)*wi(is_a) 
!        write(6,'(i2,a,i4,2f10.3)')lstruct1, &                          
!        'synmos lay,wi(is_a),thicklayer',lay,wi(is_a),thicklayer(lay)  
        end if 
       end do 
      else 
       mlays=0 
       do lstruct2=layb+1,laye 
        lay=lstruct2-layb 
        is_a=istruct2(lstruct2-1)+1 
        is_e=istruct2(lstruct2) 
!       write(6,'(i2,a,2i2,f10.3)')lstruct1,' is_a,is_e=',is_a,is_e,wi(is_a)
        vkd(lay)=vector_k*thicklayer(lay) 
        if(is_e.lt.is_a) then 
         thicklayer(lay)=0. 
        else 
         if(is_e.gt.is_a) thicklayer(lay)=1./vector_k 
         if(is_e.eq.is_a) thicklayer(lay)=wi(is_a)/vector_k 
        end if 
       end do 
      end if 
                                                                        
!      do lstruct2=layb+1,laye                                          
!       lay=lstruct2-layb                                               
!       write(6,'(i4,2x,L3,a,2g12.4,a,g12.4,a,g12.4)')                  
!     & lay,b_sites(lay),' chilay=',chilay(lay)/unit_chi,               
!     & ' vkd=',vkd(lay),' thicklayer=',thicklayer(lay)                 
!       end do                                                          
                                                                        
                                                                        
      if(.not.b_fwscat) then 
!     ******************************************************************
!     We reconstruct the layer strucrure from the laystr variabale.     
!     ELEMENT(GRP) is the number of layers in group GRP.                
!     *** L. Deak, 09.10.2002 ***                                       
       GRP         =0 
       GEOSTR(GRP) =0 
       MGRP      =0 
!                                                                       
       b_first     =.true. 
       POINTER=1 
       do lay=2,2*mlay,2 
        if(b_first)then 
         if(GRP.eq.laystr(lay))then 
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1 
         else 
          POINTER         =POINTER+GEOSTR(2*GRP) 
          GRP             =GRP+1 
          MGRP          =GRP 
          GEOSTR(2*GRP)   =1 
          GEOSTR(2*GRP-1) =laystr(lay-1) 
         end if 
!                                                                       
         if(vkd(lay/2).lt.0.) then 
          b_first         =.false. 
          vkd(lay/2)      =1.e30 
          GEOSTR(2*GRP-1) =1 
         end if ! VKD < 0  
        end if  ! b_first 
       end do 
!      *****************************************************************
       do lay=1,mlay 
        if(b_sites(lay)) then 
         Cmatrix(1,1,lay)= hc0 
         Cmatrix(2,2,lay)= hc0 
         Cmatrix(1,2,lay)= hc0 
         Cmatrix(2,1,lay)= hc0 
        end if 
       end do 
                                                                        
       call optic(mlay,b_sites,MGRP,GEOSTR,grazing,                &
                     Cmatrix,chilay,roughlay,vkd,Rmatrix)              
       R_oo=Rmatrix(1,1) 
      end if 
                                                                        
!      write(6,'(a,i6)')' iposlay(1)=',iposlay(1)                       
                                                                        
      do n=-nTH,nTH-1 
                                                                        
!      construction of the input for general optics program             
!      here the matrix R for the layers are given :                     
!      satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))             
!                          (samplay(n,lay) -sapplay(n,lay))             
        npos=8*abs(n) 
        if(n.lt.0)npos=npos+4 
                                                                        
         if(b_fwscat) then 
           do lay=1,mlays 
            nn=iposlay(lay)+npos 
            do k=1,4
             ddlay(k,lay)=array_fr(nn+k)*thicklayer(lay)
            end do
           end do
           call fwscattering(mlays,ddlay,dd) 
           if(ifrcase.le.12.or.b_1221)then
            ii=(nTH+n)*4+nstorTH1 
            do k=1,4
             array_fr(ii+k)=dd(k)
            end do 
           else
            nn=(nTH+n)*4 
            do k=1,4
             POC(nn+k)=dd(k)
            end do
           end if
         else  ! b_fwscat 

           do lay=1,mlay 
            if(b_sites(lay)) then 
             nn=iposlay(lay)+npos 
!            effi to Fortran notation                                   
             Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay) 
             Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay) 
             Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay) 
             Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay) 
            end if 
           end do   ! lay=1,mlay 
                                                                        
           call optic(mlay,b_sites,MGRP,GEOSTR,grazing,            &
                      Cmatrix,chilay,roughlay,vkd,Rmatrix)              
                                                                        
!          Fortran notation                                             
           nn=(nTH+n)*4 
           POC(nn+1)=Rmatrix(1,1)-R_oo 
           POC(nn+3)=Rmatrix(1,2) 
           POC(nn+2)=Rmatrix(2,1) 
           POC(nn+4)=Rmatrix(2,2)-R_oo
 
         end if ! reflection (b_fwscat=0) 
        end do   ! n=-nTH,nTH  
                                                                        
 2000   continue 
        if(mstruct1.gt.1) goto 1000 
                                                                        
                                                                        
 2500   continue 
!        product of the F and G matrices                                
!        Fortran  ( 1 3 )     convention                                
!                 ( 2 4 )                                                 
!        c=a*b                                                          
!        c(1)=a(1)*b(1)+a(3)*b(2)                                       
!        c(3)=a(1)*b(3)+a(3)*b(4)                                       
!        c(2)=a(2)*b(1)+a(4)*b(2)                                       
!        c(4)=a(2)*b(3)+a(4)*b(4)                                       
                                                                        
         if(b_scat12)then 
!          fG; fF case                                                      
          do n=-nTH,nTH-1 
           nn=(nTH+n)*4 
           ii=nn+nstorTH1 
           dd(1)=array_fr(ii+1)*POC(nn+1)+array_fr(ii+3)*POC(nn+2) 
           dd(2)=array_fr(ii+1)*POC(nn+3)+array_fr(ii+3)*POC(nn+4) 
           dd(3)=array_fr(ii+2)*POC(nn+1)+array_fr(ii+4)*POC(nn+2) 
           dd(4)=array_fr(ii+2)*POC(nn+3)+array_fr(ii+4)*POC(nn+4) 
           POC(nn+1)=1.0-dd(1) 
           POC(nn+2)=-dd(2) 
           POC(nn+3)=-dd(2) 
           POC(nn+4)=1.0-dd(4) 
          end do 
         else  
!          Gf; Ff case 
          do N=-nTH,nTH-1 
           nn=(nTH+n)*4 
           ii=nn+nstorTH1
           dd(1)=POC(nn+1)*array_fr(ii+1)+POC(nn+3)*array_fr(ii+2) 
           dd(2)=POC(nn+1)*array_fr(ii+3)+POC(nn+3)*array_fr(ii+4) 
           dd(3)=POC(nn+2)*array_fr(ii+1)+POC(nn+4)*array_fr(ii+2) 
           dd(4)=POC(nn+2)*array_fr(ii+3)+POC(nn+4)*array_fr(ii+4) 
           POC(nn+1)=1.0-dd(1) 
           POC(nn+2)=-dd(2) 
           POC(nn+3)=-dd(2) 
           POC(nn+4)=1.0-dd(4) 
          end do 
         end if 
                                                                        
        i=nstorTH1+nCP*4 
        jj=4*nTH 
        do n=-nCP,nCP-1 
         j=4*n 
         nn=jj+j*nsrw 
         ii=i+j 
!        array_fr(...) Fortran Notation                                 
         array_fr(ii+1)=POC(nn+1) 
         array_fr(ii+2)=POC(nn+2) 
         array_fr(ii+3)=POC(nn+3) 
         array_fr(ii+4)=POC(nn+4) 
        end do 
                                                                        
                                                                        
        nn=2*nTH 
        call fourier4r(nn) 
                                                                        
        do n=1,nTH 
!        trace (dd+*dd*rho) is the intensity                            
!        bb=cc+                                                         
          jj=4*(n-1) 
          do i=1,4 
           dd(i)=POC(jj+i) 
          end do 
          bb(1)=conjg(dd(1)) 
          bb(4)=conjg(dd(4)) 
          bb(2)=conjg(dd(3)) 
          bb(3)=conjg(dd(2)) 
                                                                        
         call tracematpro4(Arho,dd,rho,bb,trace) 
         h1=real(trace) 
          jj=4*(nTH+n-1) 
          do i=1,4 
           dd(i)=POC(jj+i) 
          end do 
          bb(1)=conjg(dd(1)) 
          bb(4)=conjg(dd(4)) 
          bb(2)=conjg(dd(3)) 
          bb(3)=conjg(dd(2)) 
                                                                        
         call tracematpro4(Arho,dd,rho,bb,trace) 
         h2=real(trace) 
         yth(n)=h1 
         yth(n+nTH)=h2 
        end do   ! n   
        yth(0)=yth(1) 
                                                                        
!     normalization                                                     
      nt=2*nTH 
      jt0=2*jt0_ch 
      sum=0. 
      do j=jt0+1,nt-1,2 
       sum=sum+yth(j)*4 
      end do 
      do j=jt0+2,nt-2,2 
       sum=sum+yth(j)*2 
      end do 
      sum=sum+yth(jt0)+yth(nt) 
      sum=sum/6.0/ith_channels*(nt-jt0)/2. 
                                                                        
!      write(6,'(a,2i6,f15.5)') ' synmos jt0_ch,nTH,sum=',jt0_ch,nTH,sum                 
      if(sum.eq.0.0) sum=1.0 
      jftau=0 
      nn=nstorTH*2 
!      write(6,'(a,2i8)')'synmos iT_max,nstorTH=',iT_max,nstorTH        
      if(iT_max.gt.0) then 
        nt=nTH*2 
        do k=1,iT_max 
         nt=nt/2 
         do j=1,nt 
          yth(j)=yth(j)+yth(j+nt) 
         end do 
        end do 
        jftau=nt/1024 
!        write(6,'(a,3i6)') '1 synmos nth,nTH,jftau=',                  
!     &             nth,nTH,jftau                                       
        if(jftau.gt.1) then 
         sum=sum/jftau 
         nt=nt/2 
         do i=1,nt 
          ij=i*jftau 
          real_fr(nn+i)=yth(ij)/sum 
         end do 
        else 
         jftau=1 
         ii=nt/2 
         sum=sum*512/ii 
         do i=1,nt 
          real_fr(nn+i)=yth(i)/sum 
         end do 
        end if 
                                                                        
      else 
        jftau=nTH/512 
!        write(6,'(a,2i6,f15.5)') '2 synmos nTH,jf=',nTH,jftau,sum      
        if(jftau.gt.1) then 
         sum=sum/jftau 
         do i=1,nTH/2 
          ij=i*jftau 
          real_fr(nn+i)=yth(ij)/sum 
         end do 
                                                                        
        else 
         sum=sum*512/nTH 
         do i=1,nTH*2 
          real_fr(nn+i)=yth(i)/sum 
         end do 
        end if 
      end if 
                                                                        
      return 
      END                                           

   subroutine fwscattering(mlay,ddlay,dd)
   implicit none
   integer, intent(in) :: mlay
   complex, intent(in) :: ddlay(4,mlay)
   complex, intent(out):: dd(4)
   
   complex, dimension(4,mlay):: aam
   complex(kind=8), dimension(4):: daa,dbb,dcc
   complex  satraceh,satrexp,app,apm,amp
   complex, parameter:: hci=cmplx(0.,1.) 
   integer  k,lay 

           satraceh=cmplx(0.,0.) 
           do lay=1,mlay 
            satraceh=satraceh+ddlay(1,lay)
            app=ddlay(2,lay) 
            apm=ddlay(3,lay) 
            amp=ddlay(4,lay) 
            call expo_22(app,apm,amp,dd) 
            do k=1,4 
             aam(k,lay)=dd(k) 
            end do 
           end do  ! lay=1,mlay  
           satrexp=exp(satraceh*hci) 

!          if(abs(n).lt.5) write(6,'(i6,6g12.4)') n,satrexp,app         
!          multiplication of the matrices exp(iR(mlay))*...*exp(iR(1))  
!          laystr(rep,grp,rep,grp,.....)                                
                                                                        
           if(mlay.gt.1) then 
            do k=1,4 
             dcc(k)=dcmplx(aam(k,mlay)) 
            end do 
            do lay=mlay-1,1,-1 
             do k=1,4 
              daa(k)=dcc(k) 
              dbb(k)=dcmplx(aam(k,lay)) 
             end do 
             call matproD(daa,dbb,dcc) 
            end do 
            do k=1,4 
             dd(k)=dcc(k)
            end do 
           end if 
           do k=1,4 
            dd(k)=dd(k)*satrexp
           end do 
       return
       end  
