!    author : h. spiering                                              
!             Am Damsberg 86                                           
!             D-55130 Mainz                                            
!             last version April 200                                   
                                                                       
!    synchrotron                            
     subroutine fr_texture(cmch,jss,info) 
     use glbconst, only: maxfr1,maxfr2,maxn,maxthss,maxscrd,maxsub,& 
                         icstrf,ivstrf,maxs,ncl
     use comdat, only: data_str,formdata,name_data,b_data,b_theory,   &
                       name_theory,nuofdatas,ichanks,mxpt,mypt,mfpt,mdfpt,mgrpt
!     use complt, only: n_subset
     use comthe, only: thfrcase,theoryname,ifrsto,mGa,thfk
     implicit none 
     character(len=4), intent(inout):: cmch
     integer, intent(in) :: jss
     integer, intent(out):: info  

     integer       mstruct1,istruct1,istruct2,                        &
                   l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,         &
                   nstorTH,mpt,iaddr
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname 
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),                                        &
                   mpt,nstorTH,iaddr(6)
!                  istr=38+4*(maxfr1+maxfr2)+3*maxthss

     real acn,apoints,stepwidth,dastr,dumac   
     common/acstrf/ acn,apoints,stepwidth,dastr,dumac(icstrf-4) 

     real avn,offset,factor,dumav        
     common/avstrf/ avn,offset,factor,dumav(ivstrf-3) 

     integer k1,k2,lstruct1,lstruct2,lstruct3,mdastr,nchanDA,nchansp,  &
             ncloc
     
!***********************************************************************
                                                                        
      if(cmch.eq.'thna') then 
       theoryname='display texture               v=001' 
       thfrcase(1)='weighted_directions(1)          v=001' 
       return 
      end if 
!***********************************************************************
      nchansp=apoints 
      if(.not.b_data)then
         ichanks(0)=2; ichanks(1)=1; ichanks(2)=nchansp
      end if

      ncloc=ncl 
      if(ncloc.gt.132)ncloc=132 
      mdastr=dastr 
!     write(6,'(2a,5i7)')cmch,' ifrcase,mdastr,nchansp=',ifrcase,mdastr,nchansp
      if(cmch.eq.'arr0') then 
!      ++++++++++++++++++++++++ arr0 +++++++++++++++++++++++++++++++++  
!     storage space
!      Data         th_A     th_exp    str_sub
!     |....:.....|.........|.........|..........|
!     ipt ichanDA  ipTH     ipTHyy    ipSI 
      
      mpt=0              ! absolute address incremented in common/struct/
      nchanDA=1*nchansp  ! complex = 2*nchansp of real
                         ! for mfpt,mdfpt

       nstorTH= nchanDA                                                                         
       ifrsto= nchanDA+nchansp+1 
!      the relativ addresses are stored after finishing                 
!      the entries arr0,i,e                                             

       return 
      else if(cmch.eq.'arri')then 
!      ++++++++++++++++++++++++++ arri +++++++++++++++++++++++++++++++++
       ifrsto=0 
       call l_structure(jss,lstruct1,lstruct2,lstruct3) 
       if(lstruct3.eq.0) then 
       if(lstruct2.eq.0) then 
         if(mstruct1.gt.1) ifrsto=0 
        else 
         if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then 
          ifrsto=0
         end if 
        end if 
       end if 
       return 
      else if(cmch.eq.'arre')then 
!       +++++++++++++++++++++++++++ arre +++++++++++++++++++++++++++++++
       ifrsto=0 
       return 
      end if ! arr0,i,e
      mdastr=dastr
!     write(6,'(a,L5,5i7)')' b_data mdastr=',b_data,mdastr             
       mfpt=2*mpt                 ! y data from real_fr (factor 2)

      
       mdfpt=mfpt+nchansp         ! errors of y data (calculated by sqrt
       mxpt=mfpt+2*nchansp        ! x data (angle)                      
       mypt=mfpt+3*nchansp        ! y data (angle)                      
       mgrpt=mfpt+4*nchansp       ! address for x group of angle

!***********************************************************************
   select case(cmch)
    case('dstr')
       call texture_plot(cmch) 
       data_str=formdata(mdastr) 
       call data3dread(0,info) 
    case('data')
      k1=jss 
       call data3dread(k1,info) 
    case('ecic')
       cmch='plot'
    case('test')
       b_theory=.false.
     case('plex') 
      k1=0 
      if(b_theory) k1=1 
      k2=3  ! 0: only plot and return, 1: interactive plot 
      call xmosplo(k1,k2) 
    case('ple2') 
       cmch='plot'
    case('ple3') 
       cmch='plot'
     case('dmod') 
      
     case('plot')
       call texture_plot('plot') 
    case('punc')          
      k1=jss 
      call punch3d(k1,info)
      cmch='dim2' 
    end select 
    return 
    END                                           
                                                                        
                                                                        
                                                                        
     subroutine texture_the2exp(n1,info) 
     use glbconst, only: maxfr1,maxfr2,maxn,maxthss,icstrf,ivstrf,max8
     use comdat, only: mxpt,b_data,b_theory
     use comthe, only: real_fr,thfk,dfdp,ib_df
!     use complt, only: n_subset
! ****************************************************************     
!    n1 = 0 error return                                               
!    n1 = 1 call of theory                                             
!    n1 = 2 derivatives                                                
!    n1 = 3 call of theory , calpl is not called                       
! ****************************************************************     
     implicit none 
     integer, intent(in) :: n1
     integer, intent(out):: info
                                                                       
     integer, parameter:: istr=38+4*(maxfr1+maxfr2)+3*maxthss
     integer       dstr,nstorTH,iaddr
     common/struct/dstr(istr+1),nstorTH,iaddr(6)

     real acn,apoints,stepwidth,dastr,dumac   
     common/acstrf/ acn,apoints,stepwidth,dastr,dumac(icstrf-4) 

     real           avn,offset,factor,dumav        
     common/avstrf/ avn,offset,factor,dumav(ivstrf-3) 
     logical         b_vn,b_offset,b_factor,b_dumav        
     common/bvstrf/  b_vn,b_offset,b_factor,b_dumav(ivstrf-3) 

     integer k1                                                                 

!----------------------------------------------------------------------                                                                       
       call mapsub(0,0,0)                                                                        
!----------------------------------------------------------------------
                                                           
      k1=n1 
      goto (100,200,300),k1 
                                                                        
  100 continue 
!     calculation of thfk                                               
      b_theory=.false. 
      return 
                                                                        
  200 continue 
      ib_df=0 
      !     derivatives
      print'(a)',' this function cannot be fitted'
      return 
                                                                        
  300 continue 
!     calculation of thfk 
      END                                           
                                                                        

     subroutine texture(b_total,info) 
     use glbconst, only: maxfr1,maxfr2,maxn,maxthss,maxscrd,&
                         icstrf,icfr2trf,&  
                         ivstrf,ivfr1trf,ivfr2trf,ivsstrf    
     use comthe, only: mLG,array_fr,real_fr
     implicit none 
     logical, intent(out):: b_total 
     integer, intent(out):: info  
                                                                       
     integer     mstruct1,istruct1,istruct2,                           &
                 l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,            &
                 nstorTH,mpt,iaddr
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname 
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),mpt,nstorTH,iaddr(6)


     real           acn,apoints,stepwidth,dastr,dumac   
     common/acstrf/ acn,apoints,stepwidth,dastr,dumac(icstrf-4) 

     real avn,offset,factor,dumav        
     common/avstrf/ avn,offset,factor,dumav(ivstrf-3) 
                                                                       
     real           vsstrf 
     common/avsstrf/vsstrf(ivsstrf) 
     logical        b_vsstrf
     common/bvsstrf/b_vsstrf(ivsstrf) 
                                                                       
     integer npoints,isubthe,lstruct1,lstruct2,lstruct3
                                                                         
!------------------------------------------------------------------     
      npoints=apoints
      isubthe=1 
      call get_theory(isubthe,info) 

      lstruct1=1 
      call mapsub(lstruct1,0,0) 
      call get_theory(isubthe,info)
      b_total=b_total.or.(isubthe.gt.0) 

      do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
!      ------------------------------------------------------------     
        call mapsub(lstruct1,lstruct2,0) 
                                                                        
       do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
        call mapsub(lstruct1,lstruct2,lstruct3) 
       end do 
!-----------------------------------------------------------------------
      end do 
      return 
    END subroutine texture
                                                                        
