subroutine frstr_mossbauer(l_nfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
      use comstr,only: ntheory,nstruct,istruct,ndev,device_n,    &
                       strcmt,thco,ntrmt,ctrmt,thpa,thvr,itheoset
      implicit none
      integer,intent(in):: l_nfrtheo,lstruct1,lstruct2
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      character(len=8)  :: chth 
      character(len=4)  :: cova 
      integer   jc,jv,jm,jp,number_device
      logical   l_standardtrm,l_advancedtrm,l_standardree,l_reemission,l_mosaic

      if(cmch.eq.'name') then 
!#######################################################################
       itheoset=0
       nhelpentry  ='Mossbauer spectrum' 
       ntheory(1)='Mossbauer radioactive source' 
       ntheory(2)='>    restricted to single line source '
       ntheory(3)='>               to single line source & scalar theories'
       ntheory(4)=' '
       
       ndev(1)='source' 
       ndev(2)='absorber/scatterer' 
       ndev(3)='detector'
       
       itheoset(1:13,2)=(/2,0,9,9,9,9,9,9,9,9,9,-1,0/)       
       itheoset(1:24,3)=(/2,0,9,9,9,9,9,9,9,9,9,-1,0,  &
                              9,9,9,0,0,9,0,0,2,2,0/)       
!#######################################################################
       return 
      end if 
!     nhelpentry defines the name of the helpfile: Mossbauer_spectrum.he
                                                                        
!     the different cases of theories are selected by the subroutine    
!     thstr_frmossbauer:                                                

!     Constants and parameters defined in thstr_frmossbauer are global  
!     (may be different for each of the theories) and therefore the same
!     for all devices. The devices are addressed by lstruct1=1,2,3 which
!     only available in the frstr_...() routine.                        
!     For lstruct1=0 Constants and parameters are also global.          
                                                                        
!     The choice of the theories follows the sequence defined in        
!     thstr_mossbauer, which is allowed to be different from the list   
!     in the routine fr_mossbauer.                                      
!     The sequence in thstr_mossbauer has been changed in order         
!     to have first the transmission theories and then the reemission   
!     theories.                                                         

       !  nameth(1)  ='Mossbauer transmission_vA'                 
       !  nameth(2)  ='Mossbauer reemission_vA'                  
       !  nameth(3)  ='Mossbauer transmission_vB'                
       !  nameth(4)  ='Mossbauer reemission_vB'                  
       !  nameth(5)  ='Mossbauer transmission_vD' 
       !  nameth(6)  ='Mossbauer transmission_vS'                
       !  nameth(7)  ='Mossbauer transmission_vC'                
       !  nameth(8)  ='Mossbauer reemission_vS'                                                                        
!      The numbers l_nfrtheo are used for selection of constants and    
!      variables (defined by parameters and transformation matrices)     
!      for the common blocks from which the theories (1,...,7) take     
!      the values.                                                      

!      lstruct1=0                common/acstrf/    /avstrf/             
!                                applies to all devices                 
!      lstruct1=1  lstruct2=0    common/acfr1trf/    /avfr1trf/         
!                  lstruct2=1    common/acfr2trf/    /avfr2trf/         
!                                device: source                         
!      lstruct1=2  lstruct2=0    common/acfr1trf/    /avfr1trf/         
!                  lstruct2=1    common/acfr2trf/    /avfr2trf/         
!                                device: absorber/scatterer             
!      lstruct1=2  lstruct2=0    common/acfr1trf/    /avfr1trf/         
!                  lstruct2=1    common/acfr2trf/    /avfr2trf/         
!                                device: detector                       
                                                                        
!     In the list of the frame routine fr_mossbauer the numbers         
!     in brackets (without any blanks!) at the end of the names are arbitrary
!     (different for each case). These numbers are accessible as ifrcase
!     in routines fr_mossbauer and th_mossbauer.
                                                                        
!--------------------------------------------------------               
                                                                        
      chth='fr'//nhelpentry(1:6) ! defines an entry: first command

      l_standardtrm=l_nfrtheo.eq.1
      l_mosaic=l_nfrtheo.eq.7
      l_advancedtrm=l_nfrtheo.eq.3.or.l_nfrtheo.eq.5.or.l_nfrtheo.eq.6  &
                                                    .or.l_nfrtheo.eq.8
      l_standardree=l_nfrtheo.eq.2
      l_reemission=l_standardree.or.l_nfrtheo.eq.4.or.l_nfrtheo.eq.8
      
      if(lstruct1.eq.0) then 
       if(cmch.eq.'hdbk') then 
         ! hdbk for handbook , no information called at this place
          nstruct=' '
        return 
       end if
!      M=number of devices
!      name_(of_devices) n_set=sp    M          == sp [M] M=number of devices

!      name_(of_devices) n_set=[sp]  M
!      name for the spectrum [sp]

!      name_(of_devices) n_set=[sp] [M]
!      name for the spectrum [sp]
!      additional devices (1:y, 2:Y, <=3) [n]

!      name_(of_devices) n_set=[sp] [M] N
!      name for the spectrum [sp]
!      number of devices of type N <=M  [4]
       
!      strcmt(4) is the entry for help(): information about the theory
!      strcmt(5) is the entry for help(): information for detector device 
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
      if(l_standardtrm.or.l_advancedtrm) then
        ! devices - name of set - def. [2] devices + detector device [y/n]
        !                              [2] n => 2 devices + [n] absorber devices 
        strcmt(1)='source_absorber_detector n_set=[sp] [2] ' 
        strcmt(2)='name for the spectrum ' 
        strcmt(3)='detector device  ' 
        strcmt(4)='theory/'//chth//'/Mossbauer transmission/go' 
        strcmt(5)='theory/'//chth//'/detector/layer_v0' 
       else if(l_reemission) then 
        strcmt(1)='source_scatterer  n_set=[sr]   [2]    ' 
        strcmt(2)='name for the spectrum of the scatterer ' 
        strcmt(3)='no detector device: go  '  
        strcmt(4)='theory/'//chth//'/Mossbauer reemission/go' 
        strcmt(5)='theory/'//chth//'/layer/CEMS' 
       else if(l_mosaic) then 
        strcmt(1)='source_absorber   n_set=[sp] [2] 2 ' 
        strcmt(2)='name for the mosaic spectrum  ' 
        strcmt(3)='number of incoherent parts of the mosaic absorber' 
        strcmt(4)='theory/'//chth//'/Mossbauer mosaic-absorber/go' 
        strcmt(5)='theory/'//chth//'/absorber/mosaic_layer' 
       end if
       cova='____'
       call convarmatpar('coll',jc,jv,jm,jp,chth)                                                                       
       return 
      end if 

      goto(100,200,300)number_device(lstruct1) 
!-----------------------------------------------------------------------
!     device number 1:Mossbauer source                                  
  100 continue
      device_n=1
!     device  common/acfr1trf/    /avfr1trf/                            
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if

      if(lstruct2.gt.0) goto 110 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
!                name of device      short name   n modules  n=l_limit          
      strcmt(1)='source_layer   n_device=[sc] mij=AA;BB [1] 1 ' 
      strcmt(2)='name of source ' 
      strcmt(3)='the source has normally 1 layer (>1 make sure!)'
!                the source layer'            
      strcmt(4)='distribution of parameters at sites of the source' 
      strcmt(5)='theory/'//chth//'/source/layer' 
                                                                        
       call convarmatpar('cova',jc,jv,jm,jp,chth) 
      return 
!     --------------------------------------------------                
  110 continue 
!     layers of device source  common/acfr2trf/    /avfr2trf/           
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
!     name of device  name of component   n components  n>=         
      strcmt(1)='source   n_cmpt=[s] [1] 1' 
      strcmt(2)='one character for name of the site ' 
      strcmt(3)='number of inequivalent sites of the source ' 
      strcmt(4)='distribution of parameters of site number' 
      strcmt(5)='theory/'//chth//'/source/sites' 


           
       if(l_reemission) cova='_511'  
                                                                        
!       common/avfr2trf/ avfr2,th_factor,dumx(4),Hext,thetaHe,phiHe
!       include=[n] => th_factor(Sc_factor=0; only used if >0
        ntrmt(jm+1)='Sc_factor           matrix=(1,1) include=[n]' 
        ctrmt(jm+1)='factor  for all source sites ' 
         thpa(jp+1)='Sc_factor           1.0  0.0 0.0  0.1' 
         thvr(jv+1)='Sc_factor             1    1  ' 
        jm=jm+1 
        jp=jp+1 
        jv=jv+1                                                                         

        ntrmt(jm+1)='Hextern_sc  matrix=(3,3) include=[n]' 
        ctrmt(jm+1)='external magnetic field (lab) at the source' 
         thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0' 
         thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0' 
         thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 ' 
         thvr(jv+1)='Hext                     6    1 0 0  ' 
         thvr(jv+2)='thetaHe                  7    0 1 0 ' 
         thvr(jv+3)='phiHe                    8    0 0 1' 
        jm=jm+1 
        jp=jp+3 
        jv=jv+3 

        ntrmt(jm+1)='euler_source matrix=(3,3) include=[n]' 
        ctrmt(jm+1)='orientation of the source (lab)' 
         thpa(jp+1)='phi              , 0.0  0.0 0.0  1.0' 
         thpa(jp+2)='theta            , 0.0 0.0 0.0   1.0' 
         thpa(jp+3)='psi              , 0.0 0.0 0.0   1.0 ' 
         thvr(jv+1)='phi                       9    1 0 0  ' 
         thvr(jv+2)='theta                    10    0 1 0 ' 
         thvr(jv+3)='psi                      11    0 0 1' 
        jm=jm+1 
        jp=jp+3 
        jv=jv+3 
        cova='_511'
       if(l_advancedtrm.or.l_mosaic)then 
!       l_nfrtheo=2 :'Mossbauer transmission_vB'                         
!                  call of subroutine th_hdeqf                         
!       common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi,thetaz,phiz   
!       common/avfr2trf/avfr2,th_factor,dum(4),Hext,thetaHe,phiHe,       
!                      phi,theta,psi                                    
                                                                        
        thco(jc+1)='iset_powder  i_pos=2  include=[n]  0' 
                ! iset=1-6 for 4-128 points on 1/48 of the sphere       
        thco(jc+2)='isymmetry  i_pos=3  include=[n]  10' 
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)          
        thco(jc+3)='n_psi_powder  i_pos=4  include=[n]  0' 
                ! 3rd Euler angle, rotation around S_lab(z)             
                ! neccessary if Hext not parallel S_lab(z)              
        jc=jc+3 

        ntrmt(jm+1)='thickn_factor  matrix=(1,1) include=[n]' 
        ctrmt(jm+1)='thickness factor for all sites of the layer' 
         thpa(jp+1)='th_factor           , 1.0  0.0 0.0  0.1' 
         thvr(jv+1)='th_factor               1    1  ' 
                                                                        
        ntrmt(jm+2)='x2_anisotropy  matrix=(2,2) include=[n] ' 
        ctrmt(jm+2)='mean square <x2> of a crystal (source)' 
         thpa(jp+2)='d_x2                  ,  0.0  0.0 0.0  0.1' 
         thpa(jp+3)='x2_eta                ,  0.0  0.0 0.0  0.1' 
         thvr(jv+2)='d_x2                     12    1 0  ' 
         thvr(jv+3)='x2_eta                   13    0 1  ' 
                                                                        
        ntrmt(jm+3)='x2_orientation    matrix=(3,3) include=[n] ' 
        ctrmt(jm+3)='x2_orientation   with ref. to a crystal (source)' 
         thpa(jp+4)='x2_phi                , 0.0  0.0 0.0  1.0' 
         thpa(jp+5)='x2_theta              , 0.0  0.0 0.0  1.0' 
         thpa(jp+6)='x2_psi                , 0.0  0.0 0.0  1.0' 
         thvr(jv+4)='x2_phi                   14    1 0 0 ' 
         thvr(jv+5)='x2_theta                 15    0 1 0 ' 
         thvr(jv+6)='x2_psi                   16    0 0 1 ' 

          
        ntrmt(jm+4)='Y1m_texture   matrix=(3,3) include=[n]' 
        ctrmt(jm+4)='Y1m-texture - source layer (M1/E1)' 
         thpa(jp+7)='t100                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+8)='t11s                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+9)='t11c                   , 0.0  0.0 0.0  0.1'
         thvr(jv+7)='t100                     18    1 0 0' 
         thvr(jv+8)='t11s                     19    0 1 0' 
         thvr(jv+9)='t11c                     20    0 0 1' 

        ntrmt(jm+5)='Y2m_texture  matrix=(6,6) include=[n] ' 
        ctrmt(jm+5)='Y2m-texture - source layer (M1/E1)' 
         thpa(jp+10)='t00                    , 1.0  0.0 0.0  0.1'
         thpa(jp+11)='t200                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+12)='t21s                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+13)='t21c                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+14)='t22s                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+15)='t22c                   , 0.0  0.0 0.0  0.1' 
         thvr(jv+10)='t00                      17   1 0 0 0 0 0'  
         thvr(jv+11)='t200                     21   0 1 0 0 0 0' 
         thvr(jv+12)='t21s                     22   0 0 1 0 0 0'
         thvr(jv+13)='t21c                     23   0 0 0 1 0 0' 
         thvr(jv+14)='t22s                     24   0 0 0 0 1 0' 
         thvr(jv+15)='t22c                     25   0 0 0 0 0 1' 

        ntrmt(jm+6)='Y30_texture  matrix=(2,2) include=[n] ' 
        ctrmt(jm+6)='Y30/40-texture - absorber layer (M2/E2)' 
         thpa(jp+16)='t300                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+17)='t400                   , 0.0  0.0 0.0  0.1' 
         thvr(jv+16)='t300                     26    1 0' 
         thvr(jv+17)='t400                     27    0 1' 

        jm=jm+6
        jp=jp+17 
        jv=jv+17 
        cova='_627'
       end if  
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
!--------------------------------------------------------------------   
!     device number 2:Mossbauer absorber/scatterer                      
  200 continue
      device_n=2
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
      if(lstruct2.gt.0) goto 210 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        

      if(l_standardtrm.or.l_advancedtrm)then 
       strcmt(1)='absorber n_device=[ab] mijk=po;sw;an [1]  1' 
       strcmt(2)='name of the absorber ' 
       strcmt(3)='number of layers of the absorber ' 
       strcmt(4)='distribution of parameters at sites of the layer' 
       strcmt(5)='theory/'//chth//'/absorber/layer' 
       cova='cova'
      else if(l_reemission)then 
       strcmt(1)='scatterer n_device=[sr]  mijk=to;md;bk  [1]  1' 
       strcmt(2)='name of the scatterer ' 
       strcmt(3)='number of layers of the scatterer' 
       strcmt(4)='distribution of parameters at sites of the scatterer' 
       strcmt(5)='theory/'//chth//'/scatterer/layer' 
                                                                        
       ntrmt(jm+1)='Hextern_dv     matrix=(3,3) include=[n]' 
       ctrmt(jm+1)='external magnetic field (lab) at all scatterer layers'
        thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0' 
        thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+1)='Hext                     2    1 0 0  ' 
        thvr(jv+2)='thetaHe                  3    0 1 0 ' 
        thvr(jv+3)='phiHe                    4    0 0 1' 
       jm=jm+1 
       jp=jp+3 
       jv=jv+3 
       ntrmt(jm+1)='euler_dv  matrix=(3,3) include=[n]' 
       ctrmt(jm+1)='orientation of the scatterer (lab)' 
        thpa(jp+1)='phi_dv              , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='theta_dv            , 0.0 0.0 0.0   1.0' 
        thpa(jp+3)='psi_dv              , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+1)='phi_dv                       5    1 0 0  ' 
        thvr(jv+2)='theta_dv                     6    0 1 0 ' 
        thvr(jv+3)='psi_dv                       7    0 0 1' 
       jm=jm+1 
       jp=jp+3 
       jv=jv+3 
       cova='___7' 
      else if(l_mosaic)then
!      device name     short  module names   def: n modules  n>=
       strcmt(1)='absorber n_device=[Mj] mij=l1;ln [2]  1' 
       strcmt(2)='name of the mosaic area section' 
       strcmt(3)='number of layers of the  mosaic area section' 
       strcmt(4)='distribution of parameters at sites of the area section'
       strcmt(5)='theory/'//chth//'/mosaicabsorber/layer' 
                                                                        
                                                                        
       ntrmt(jm+1)='device_factor  intensity' 
       ctrmt(jm+1)='device factor for all sites of the device' 
        thpa(jp+1)='dev_factor           , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='dev_factor               1    1  ' 
        jm=jm+1 
        jp=jp+1 
        jv=jv+1 
       ntrmt(jm+1)='Hextern_dev   matrix=(3,3) include=[n]' 
       ctrmt(jm+1)='external magnetic field (lab) at the absorber' 
        thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0' 
        thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+1)='Hext                     2    1 0 0  ' 
        thvr(jv+2)='thetaHe                  3    0 1 0 ' 
        thvr(jv+3)='phiHe                    4    0 0 1' 
       jm=jm+1 
       jp=jp+3 
       jv=jv+3 
       cova='___7'                                                                 
      end if 
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
!     --------------------------------------------                      
  210 continue 
!     layers of device absorber/scatterer  common/acfr2trf/  /avfr2trf/ 
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!      thco(jc+1) ='temperature  i_pos=5 include=[n]  300.0 ' 
!                ! temperatue of the layer                               
!      jc=jc+1 
                                                                        

       if( l_reemission.or.l_standardtrm.or.l_advancedtrm)then

        thco(jc+1)='iset_powder  i_pos=2 include=[n] 0 ' 
                 !iset=0 single crystal
                 ! iset=1-6 for 4-128 points on 1/48 of the sphere      
        thco(jc+2)='isymmetry   i_pos=3 include=[n] 10 ' 
                 ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)         
        thco(jc+3)='n_psi_powder i_pos=4 include=[n] 0 ' 
                ! 3rd Euler angle, rotation around S_lab(z)             
                ! neccessary if Hext not parallel S_lab(z)              
        jc=jc+3 
!       name of components short name  n components  n>=         
        strcmt(1)='absorber_site   n_cmpt=[s]  [1]  1' 
        strcmt(2)='one letter for name of the site ' 
        strcmt(3)='number of inequivalent sites of the absorber layer' 
        strcmt(4)='distribution of parameters of site number' 
        strcmt(5)='theory/'//chth//'/absorber/layer/sites' 

        ntrmt(jm+1)='Hextern_layer   matrix=(3,3) include=[n]' 
        ctrmt(jm+1)='external magnetic field (lab) at the absorber' 
         thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0' 
         thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0' 
         thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 ' 
         thvr(jv+1)='Hext                     6    1 0 0  ' 
         thvr(jv+2)='thetaHe                  7    0 1 0 ' 
         thvr(jv+3)='phiHe                    8    0 0 1' 
                                                                        
        ntrmt(jm+2)='euler_layer    matrix=(3,3) include=[n]' 
        ctrmt(jm+2)='orientation of the absorber (lab)' 
         thpa(jp+4)='phi              , 0.0  0.0 0.0  1.0' 
         thpa(jp+5)='theta            , 0.0 0.0 0.0   1.0' 
         thpa(jp+6)='psi              , 0.0 0.0 0.0   1.0 ' 
         thvr(jv+4)='phi                       9    1 0 0  ' 
         thvr(jv+5)='theta                    10    0 1 0 ' 
         thvr(jv+6)='psi                      11    0 0 1' 
        jm=jm+2
        jp=jp+6 
        jv=jv+6 

       else if(l_reemission)then 
        strcmt(1)='scatterer_site   n_cmpt=s  [1]  0' 
        strcmt(2)='one letter for name of the site ' 
        strcmt(3)='number of inequivalent sites of the scatterer' 
        strcmt(4)='distribution of parameters of site number' 
        strcmt(5)='theory/'//chth//'/scatterer/sites' 
       end if 
       cova='_611' 
                                                                        
       if(l_mosaic) then                                                                  
        strcmt(1)='mosaic_absorber_site   n_cmpt=[s] [1] 0' 
        strcmt(2)=' one letter for name of the site ' 
        strcmt(3)='number of inequivalent sites of the piece of mosaic layer' 
        strcmt(4)='distribution of parameters of site number' 
        strcmt(5)='theory/'//chth//'/absorber/part/sites' 
       end if

!      common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi  
!      common/avfr2trf/avfr2,th_factor,dum(4),Hext,thetaHe,phiHe,       
!                      phi,theta,psi                                    
                                                                        
        ntrmt(jm+1)='thickn_factor   matrix=(1,1) include=[n]' 
        ctrmt(jm+1)='thickness factor for all sites of the layer' 
         thpa(jp+1)='th_factor             , 1.0  0.0 0.0  0.1' 
         thvr(jv+1)='th_factor               1    1  ' 
                                                                        
       ntrmt(jm+2)='x2_anisotropy  matrix=(2,2) include=[n]' 
       ctrmt(jm+2)='mean square <x2> of a crystal of the absorber layer'
       if(l_reemission) &
       ctrmt(jm+2)='mean square <x2> of a crystal of the scatterer layer'
        thpa(jp+2)='d_x2                  ,  0.0  0.0 0.0  0.1' 
        thpa(jp+3)='x2_eta                ,  0.0  0.0 0.0  0.1' 
        thvr(jv+2)='d_x2                     12    1 0  ' 
        thvr(jv+3)='x2_eta                   13    0 1  ' 
                                                                        
       ntrmt(jm+3)='x2_orientation    matrix=(3,3) include=[n]' 
       ctrmt(jm+3)='x2_orientation with ref. to a crystal (absorber layer)'
       if(l_reemission) &
       ctrmt(jm+3)='x2_orientation with ref. to a crystal (scatterer layer)'
        thpa(jp+4)='x2_phi                , 0.0  0.0 0.0  1.0' 
        thpa(jp+5)='x2_theta              , 0.0  0.0 0.0  1.0' 
        thpa(jp+6)='x2_psi                , 0.0  0.0 0.0  1.0' 
        thvr(jv+4)='x2_phi                   14    1 0 0 ' 
        thvr(jv+5)='x2_theta                 15    0 1 0 ' 
        thvr(jv+6)='x2_psi                   16    0 0 1 '
       jm=jm+3 
       jp=jp+6 
       jv=jv+6
       cova='_616'
       
       if(l_standardtrm.or.l_mosaic) goto 211  ! notexture; single crystal mosaic
        
        ntrmt(jm+1)='Y1m_texture   matrix=(3,3) include=[n]' 
        ctrmt(jm+1)='Y1m-texture - source layer (M1/E1)' 
         thpa(jp+1)='t100                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+2)='t11s                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+3)='t11c                   , 0.0  0.0 0.0  0.1'
         thvr(jv+1)='t100                     18    1 0 0' 
         thvr(jv+2)='t11s                     19    0 1 0' 
         thvr(jv+3)='t11c                     20    0 0 1' 

        ntrmt(jm+2)='Y2m_texture  matrix=(6,6) include=[n] ' 
        ctrmt(jm+2)='Y2m-texture - source layer (M1/E1)' 
         thpa(jp+4)='t00                    , 1.0  0.0 0.0  0.1'
         thpa(jp+5)='t200                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+6)='t21s                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+7)='t21c                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+8)='t22s                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+9)='t22c                   , 0.0  0.0 0.0  0.1' 
         thvr(jv+4)='t00                      17    1 0 0 0 0 0'
         thvr(jv+5)='t200                     21    0 1 0 0 0 0' 
         thvr(jv+6)='t21s                     22    0 0 1 0 0 0'
         thvr(jv+7)='t21c                     23    0 0 0 1 0 0' 
         thvr(jv+8)='t22s                     24    0 0 0 0 1 0' 
         thvr(jv+9)='t22c                     25    0 0 0 0 0 1' 

        ntrmt(jm+3)='Y30_texture  matrix=(2,2) include=[n] ' 
        ctrmt(jm+3)='Y30/40-texture - absorber layer (M2/E2)' 
         thpa(jp+10)='t300                   , 0.0  0.0 0.0  0.1' 
         thpa(jp+11)='t400                   , 0.0  0.0 0.0  0.1'
         thvr(jv+10)='t300                     26    1 0' 
         thvr(jv+11)='t400                     27    0 1' 

        jm=jm+3 
        jp=jp+11 
        jv=jv+11
        cova='_627'
211    continue  
                                                                        
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
!--------------------------------------------------------------------   
!      common/avfr1trf/pvfr1,Hext,thetaHe,phiHe                         
!      device number 3:detector                                         
  300 continue
      device_n=3
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
      if(lstruct2.gt.0) goto 310 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
      strcmt(1)='detector_layer  n_device=[dt]  1  1' 
      strcmt(2)='name of the detector layer' 
      strcmt(3)=' ' 
      strcmt(4)=' ' 
      strcmt(5)='theory/'//chth//'/detector/layer' 
                                                                        
      call convarmatpar('cova',jc,jv,jm,jp,chth) 
      return 
!-----------------------------------------------------------------------
  310 continue 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth)
      ! def def lower limit                          
      strcmt(1)='detector_site/analyser   n_cmpt=[s] [0]  0' 
      strcmt(2)='one letter for name of the site/analyser ' 
      strcmt(3)='number of inequivalent sites of the detector' 
      strcmt(4)='distribution of parameters of site number' 
      strcmt(5)='theory/'//chth//'/detector/sites' 
                                                                        
                           
      cova='___5'                                             
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
      END                                           
                                                                        
                                                                       
      subroutine thstr_mossbauer(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission and   Mossbauer resonance reflection theori
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth 
      character(len=4) :: cova 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo

      if(cmch.eq.'name')then 
       nhelpentry='Mossbauer radioactive source (distribute)' 
!      names for child theories, sequence l_frtheo=1,2,3,.. , mthchild=6
       nameth(1)  ='Mossbauer transmission_vA' 
       nameth(2)  ='Mossbauer reemission_vA' 
       nameth(3)  ='Mossbauer transmission_vB' 
       nameth(4)  ='Mossbauer reemission_vB' 
       nameth(5)  ='Mossbauer transmission_vD' 
       nameth(6)  ='Mossbauer transmission_vS' 
       nameth(7)  ='Mossbauer transmission_vC' 
       nameth(8)  ='Mossbauer reemission_vS'  
       return 
      else if(cmch.eq.'theo') then
!      look for ntheory, mthparent=1 <=max_nth                          
       ntheory(1)='Mossbauer radioactive source' 
       if(name_eq_ntheo(1))l_jth=8
       return 
      end if

!    common/acstrf/acsp,uthick_w,dum,flag_basis,dum1,channels,vm_SC,
!                  lambda,drive_mode,channels_vmax,c_nonlinear,          
!                  com_samp,Dsource,Dabsorber,                            
!                  sc2absorber,sc2aperture,Daperture,dumcs(icstrf-18)
    
                                                                        
                                                                        
    chth='th'//nhelpentry(1:6)
     if(cmch.eq.'hdbk') then
      if(l_jth.eq.2.or.l_jth.eq.4.or.l_jth.eq.8) then  
         nstruct='handbook=nucleus.hdb   list=0  chth='//chth 
      else
         nstruct='handbook=nucleus.hdb   list=1  chth='//chth
      end if
       return 
      end if 

     call convarmatpar('coll',jc,jv,jm,jp,chth)
     if(l_jth.eq.2.or.l_jth.eq.4.or.l_jth.eq.8) then        
      ! If handbook is call with list>0 the i_pos values are increased. See 
      ! the declarations below (with description) for an absorption spectrum 
      thco(jc+1)='vm_SC          i_pos=6   include=y    0.0' 
      thco(jc+2)='i_convol       i_pos=7   include=y    128' 
      thco(jc+3)='nu_channels    i_pos=5   from_data=y  1024 ' 
      thco(jc+4)='channels_vmax  i_pos=10  from_data=[y] 256 ' 
      thco(jc+5)='drive_mode     i_pos=9   from_data=[y]   1 ' 
      thco(jc+6)='c_nonlinear    i_pos=11  include=y  0' 
      thco(jc+7)='flag_basis     i_pos=3   include=y  0' 
      jc=jc+7
      cova='11__'     
     else
      thco(jc+1)='vm_SC   i_pos=5  include=y     0.0' 
!               ! value of source splitting'                            
!                 >0  gt absorber splitting                             
!                 =0  single line source                                
!                 <0  lt absorber splitting                             
                                                                        
      thco(jc+2)='i_convol  i_pos=6  include=y  128' 
                  ! limits of convolution integrals +/- 128             
      thco(jc+3)='nu_channels    i_pos=4   from_data=y  1024 ' 
                ! channel number of the spectrum                        
      thco(jc+4)='channels_vmax  i_pos=9 from_data=y  256 ' 
                ! period of the drive unit                              
      thco(jc+5)='lambda         i_pos=7 include=y  1.0 ' 
                ! Lagrange multiplier  for nonlinearity function  
      thco(jc+6)='drive_mode     i_pos=8 from_data=[n]  1 ' 
                ! determines channel to velocity function/data structure    
      thco(jc+7)='c_nonlinear    i_pos=10  include=y  0' 
                ! 7 cases for correction of non linearity  
      thco(jc+8)='flag_basis      i_pos=2 include=[n]  0' 
                ! calculation using linear (0) or circular (1) basis        
      jc=jc+8
      cova='10__'     
     end if    
!-----------------------------------------------------------------------
!     variables of frame theory: source,absorber and detector orientatio
!      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,              
!     &        channel_v0,geo,vnl(18)
     if(l_jth.eq.2.or.l_jth.eq.4.or.l_jth.eq.8) then
       ntrmt(jm+1)='counts  matrix=(1,1) include=y' 
       ctrmt(jm+1)='counts for all sites '
        thpa(jp+1)='counts           100000.0  0.0 0.0  100.0' 
        thvr(jv+1)='counts                3    1  ' 
       ntrmt(jm+2)='baseline  matrix=(1,1) include=y ' 
       ctrmt(jm+2)='(1) parameter base line ' 
        thpa(jp+2)='base            , 1000.0  0.0 0.0 10.0' 
        thvr(jv+2)='base                    2    , 1 '          
       ntrmt(jm+3)='source   matrix=(1,1) from_data=y ' 
       ctrmt(jm+3)='(1) variable f_factor of the source' 
        thpa(jp+3)='source_frac          , 1.0  0.0  1.0  0.0' 
        thvr(jv+3)='source_frac                  1    , 1  ' 
     else
      ntrmt(jm+1)='baseline  matrix=(1,1) include=y ' 
      ctrmt(jm+1)='(1) parameter base line ' 
       thpa(jp+1)='base            , 100000.0  0.0 0.0 1000.0' 
       thvr(jv+1)='base                    2    , 1 ' 
      ntrmt(jm+2)='source   matrix=(1,1) from_data=[n] ' 
      ctrmt(jm+2)='(1) variable f_factor of the source' 
       thpa(jp+2)='f_source        , 0.75  0.0  1.0  0.02' 
       thvr(jv+2)='f_source                1    , 1  ' 
      ntrmt(jm+3)='background   matrix=(1,1) from_data=[n] ' 
      ctrmt(jm+3)='(1) variable back ground fraction ' 
       thpa(jp+3)='bg_fraction     , 0.2  0.0  1.0  0.01' 
       thvr(jv+3)='bg_fraction             3    , 1 ' 
     end if
      ntrmt(jm+4)='geometry  matrix=(1,1) from_data=[n] ' 
      ctrmt(jm+4)='(1) variable geo=v_max/(2pi;8 f scap)' 
       thpa(jp+4)='geo              ,  0.000e-4   0.0 0.0 0.001' 
       thvr(jv+4)='geo              ,      6     , 1 ' 
      jm=jm+4 
      jp=jp+4 
      jv=jv+4 
      ntrmt(jm+1)='calibration  matrix=(2,2) from_data=[n] ' 
      ctrmt(jm+1)='(2) variables for calibration v_max,channel_v0' 
       thpa(jp+1)='v_max             ,  8.0   0.0 0.0 0.05 ' 
       thpa(jp+2)='channel_v0        , 256.0  0.0 0.0 0.1 ' 
       thvr(jv+1)='v_max                   4     , 1 0' 
       thvr(jv+2)='channel_v0              5     , 0 1 ' 
                                                                        
      ntrmt(jm+2)='non_linearity    matrix=(6,6) include=[y]' 
      ctrmt(jm+2)='(6) variables for calibration of non-linearity' 
       thpa(jp+3)='vnl1              0.0000  0.0 0.0 0.001 ' 
       thpa(jp+4)='vnl2              0.0000  0.0 0.0 0.001 ' 
       thpa(jp+5)='vnl3              0.0000  0.0 0.0 0.001 ' 
       thpa(jp+6)='vnl4              0.0000  0.0 0.0 0.001 ' 
       thpa(jp+7)='vnl5              0.0000  0.0 0.0 0.001 ' 
       thpa(jp+8)='vnl6              0.0000  0.0 0.0 0.001 ' 
       thvr(jv+3)='vnl1               7     1 0 0 0 0 0' 
       thvr(jv+4)='vnl2               8     0 1 0 0 0 0 ' 
       thvr(jv+5)='vnl3               9     0 0 1 0 0 0 ' 
       thvr(jv+6)='vnl4               10    0 0 0 1 0 0 ' 
       thvr(jv+7)='vnl5               11    0 0 0 0 1 0  ' 
       thvr(jv+8)='vnl6               12    0 0 0 0 0 1  ' 

      jm=jm+2 
      jp=jp+8 
      jv=jv+8 

      ntrmt(jm+1)='12non_linear  matrix=(6,6) include=[n]' 
      ctrmt(jm+1)='variables (7-12) for calibration of non-linearity' 
       thpa(jp+1)='vnl_7            0.0000    0.0 0.0 0.001' 
       thpa(jp+2)='vnl_8            0.0000    0.0 0.0 0.001' 
       thpa(jp+3)='vnl_9            0.0000    0.0 0.0 0.001' 
       thpa(jp+4)='vnl10            0.0000    0.0 0.0 0.001' 
       thpa(jp+5)='vnl11            0.0000    0.0 0.0 0.001' 
       thpa(jp+6)='vnl12            0.0000    0.0 0.0 0.001' 
       thvr(jv+1)='vnl_7               13     1 0 0 0 0 0' 
       thvr(jv+2)='vnl_8               14     0 1 0 0 0 0 ' 
       thvr(jv+3)='vnl_9               15     0 0 1 0 0 0 ' 
       thvr(jv+4)='vnl10               16     0 0 0 1 0 0 ' 
       thvr(jv+5)='vnl11               17     0 0 0 0 1 0  ' 
       thvr(jv+6)='vnl12               18     0 0 0 0 0 1  ' 
      jm=jm+1 
      jp=jp+6 
      jv=jv+6 

      ntrmt(jm+1)='18non_linear    matrix=(6,6) include=[n]' 
      ctrmt(jm+1)='variables (13-18) for calibration of non-linearity' 
       thpa(jp+1)='vnl13            0.0000   0.0 0.0 0.001' 
       thpa(jp+2)='vnl14            0.0000   0.0 0.0 0.001' 
       thpa(jp+3)='vnl15            0.0000   0.0 0.0 0.001' 
       thpa(jp+4)='vnl16            0.0000   0.0 0.0 0.001' 
       thpa(jp+5)='vnl17            0.0000   0.0 0.0 0.001' 
       thpa(jp+6)='vnl18            0.0000   0.0 0.0 0.001' 
       thvr(jv+1)='vnl13               19     1 0 0 0 0 0' 
       thvr(jv+2)='vnl14               20     0 1 0 0 0 0 ' 
       thvr(jv+3)='vnl15               21     0 0 1 0 0 0 ' 
       thvr(jv+4)='vnl16               22     0 0 0 1 0 0 ' 
       thvr(jv+5)='vnl17               23     0 0 0 0 1 0  ' 
       thvr(jv+6)='vnl18               24     0 0 0 0 0 1  ' 
      jm=jm+1 
      jp=jp+6 
      jv=jv+6 

      cova(3:4)='24'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine thstr_11indexmoss(l_jth,cmch,nhelpentry) 
        use comstr,only: nameth,namepg,ntheory,jtheory,nstruct,device_n, &
                         thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission , powder, anisotropic f-factor             
!     level 3 theory                                                    
                                                                        
!     sad= source,absorber,detector : lstr1case=1,2,3                   
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      character(len=4)  :: cova 

      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo

      if(cmch.eq.'name')then 
       nhelpentry='scalar refraction index (sad)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='scalar refraction index (static,sad)' 
       namepg(1)='1x1_ref_index_static_sad  scal,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=5 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vA_3b' 
       ntheory(2)='Mossbauer reemission_vA_3' 
       ntheory(3)='Mossbauer transmission_vB_3' 
       ntheory(4)='Mossbauer reemission_vB_3' 
       ntheory(5)='Mossbauer transmission_vC_3' 
       ntheory(6)='Mossbauer transmission_vS_32' 
       ntheory(7)='Mossbauer reemission_vS_32' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(7))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
        nstruct='handbook=nucleus.hdb   list=3   chth='//chth 
       ! list3 adds 2 constants
       return 
      end if 
                                                                        

      call convarmatpar('coll',jc,jv,jm,jp,chth) 
      thco(jc+1)='flag_SAMP     i_pos=1   include=y  0' 
               ! discrete (1) , continuous(0) LG-curves                 
      thco(jc+2)='flag_Voigt    i_pos=2   include=n  0' 
                ! LG-convolution (1) , Voigt profile (0)                
      jc=jc+2 
      cova='_2__'      ! ipos is incremented => 2(hdbk) +2

       ntrmt(jm+1)='t_eff  intensity     ' 
      if(device_n.eq.1)then
       ctrmt(jm+1)='fraction of the site ' 
        thpa(jp+1)='sc_fraction           , 1.  0.0 0.0  0.' 
        thvr(jv+1)='sc_fraction                1     1  '
      else
       if(jtheory.eq.2.or.jtheory.eq.4.or.l_jth.eq.7)then
        ctrmt(jm+1)='fraction of the site' 
         thpa(jp+1)='fraction          , 1.  0.0 0.0  0.0' 
         thvr(jv+1)='fraction                 1     1  '
       else
        ctrmt(jm+1)='effective thickness of the site' 
         thpa(jp+1)='mg/cm2xf          , 1.00  0.0 0.0  0.1' 
         thvr(jv+1)='mg/cm2xf                 1     1  '
       end if
      end if
       jm=jm+1 
       jp=jp+1 
       jv=jv+1

       ntrmt(jm+1)='isomer_shift  matrix=(1,1)   include=y' 
       ctrmt(jm+1)='isomer shift of the spectrum' 
        thpa(jp+1)='shift            , 0.00  0.0 0.0  0.1' 
        thvr(jv+1)='shift                   2     1 ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
      cova='_2_2'       
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_11indexmossdyn(l_jth,cmch,nhelpentry) 
        use comstr,only: nameth,namepg,ntheory,nstruct,device_n,nfrtheo,   &
                         thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission , powder, anisotropic f-factor             
!     level 3 theory                                                    
                                                                        
!     sad= source,absorber,detector : lstr1case=1,2,3                   
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      character(len=4)  :: cova 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo,l_reemission

      if(cmch.eq.'name')then 
       nhelpentry='scalar refraction index (dynamic)' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='scalar refraction index (dynamic,sad)' 
       namepg(1)='1x1_ref_index_dynamic_sad  scal,2 ' 
!      nameth(2)='scalar refraction index (dynamic,sad-interpol.)' 
!      namepg(2)='1x1_ref_index_dynamic_sad  scal,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=5 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vA_3b' 
       ntheory(2)='Mossbauer transmission_vB_3b' 
       ntheory(3)='Mossbauer reemission_vA_3' 
       ntheory(4)='Mossbauer reemission_vB_3' 
       ntheory(5)='Mossbauer transmission_vC_3b' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(5))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
      l_reemission=nfrtheo.eq.2.or.nfrtheo.eq.4

      call convarmatpar('coll',jc,jv,jm,jp,chth) 
      thco(jc+1)='flag_SAMP     i_pos=1   include=y  1' 
               ! discrete (1) , continuous(0) LG-curves                 
      thco(jc+2)='flag_Voigt    i_pos=2   include=n  0' 
                ! LG-convolution (1) , Voigt profile (0)                
      jc=jc+2 
                                                                        
       ntrmt(jm+1)='t_eff  intensity     ' 
      if(device_n.eq.1)then
       ctrmt(jm+1)='fraction of the site ' 
        thpa(jp+1)='sc_fraction           , 1.  0.0 0.0  0.0' 
        thvr(jv+1)='sc_fraction                1     1  '
      else
       if(l_reemission) then
        ctrmt(jm+1)='reemission strenght of the site' 
         thpa(jp+1)='fraction              1.  0.0 0.0 0.0' 
         thvr(jv+1)='fraction               1     1  ' 
       else
        ctrmt(jm+1)='effective thickness of the site' 
         thpa(jp+1)='mg/cm2xf          , 1.00  0.0 0.0  0.1' 
         thvr(jv+1)='mg/cm2xf                 1     1  '
       end if 
      end if
       jm=jm+1 
       jp=jp+1 
       jv=jv+1
      cova='_2_1'
      if(l_jth.eq.2) then 
       ntrmt(jm+1)='isomer_shift  matrix=(1,1)   include=n' 
       ctrmt(jm+1)='isomer shift of the spectrum' 
        thpa(jp+1)='shift            , 0.00  0.0 0.0  0.1' 
        thvr(jv+1)='shift                   2     1 ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
      cova='_2_2'
      end if 

      call convarmatpar(cova,jc,jv,jm,jp,chth)  ! no co/pa information
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_11indexMB(l_jth,cmch,nhelpentry) 
        use comstr,only: nameth,namepg,ntheory,nstruct,device_n,   &
                         thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission , powder, anisotropic f-factor             
!     level 3 theory                                                    
                                                                        
!     sad= source,absorber,detector : lstr1case=1,2,3                   
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth 
      character(len=4) :: cova 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='scalar refraction index MB' 
                                                                        
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='scalar refraction index (static,sad)' 
       namepg(1)='1x1_ref_index_static_sad  scal,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=1 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vD_3' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3   chth='//chth 
!      2 constants   width,E1,E2 dispersion                          
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
       thco(jc+1)='flag_SAMP   i_pos=1   include=[y]  0' 
                 ! discrete (1) , continuous(0) LG-curves               
       thco(jc+2)='flag_Voigt  i_pos=2   include=[n]  0' 
                 ! LG-convolution (1) , Voigt profile (0)               
       jc=jc+2 
                                                                        
      ntrmt(jm+1)='t_eff   intensity ' 
      ctrmt(jm+1)='effective thickness by the f-factor at the site' 
       if(device_n.eq.1)then
        thpa(jp+1)='sc_fraction           , 1.  0.0 0.0  0.0' 
        thvr(jv+1)='sc_fraction                1     1  ' 
       else
        thpa(jp+1)='mg/cm2xf           , 1.00  0.0 0.0  0.1' 
        thvr(jv+1)='mg/cm2xf                 1     1  ' 
       end if
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
      ntrmt(jm+1)='isomer_shift    matrix=(1,1)   include=y' 
      ctrmt(jm+1)='isomer shift of the spectrum' 
       thpa(jp+1)='shift            , 0.00  0.0 0.0  0.1' 
       thvr(jv+1)='shift                   2     1 ' 
      jm=jm+1 
      jp=jp+1 
      jv=jv+1 
      cova='_2_2'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_22indexmoss(l_jth,cmch,nhelpentry) 
        use comstr,only: nameth,namepg,ntheory,nstruct,device_n,nfrtheo,   &
                         thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission and   Mossbauer resonance reflection theories
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      character(len=4) :: cova 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo,l_reemission

      if(cmch.eq.'name')then 
       nhelpentry='2x2 refraction index (sad)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='2x2 refraction index (static,sad)' 
       namepg(1)='2x2_ref_index_static_sad plrs,1 ' 
       nameth(2)='2x2 refraction index (width,static,sad)' 
       namepg(2)='2x2_ref_index_static_sad plrs,3 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=5 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vA_3b' 
       ntheory(2)='Mossbauer reemission_vA_3' 
       ntheory(3)='Mossbauer transmission_vB_3b' 
       ntheory(4)='Mossbauer reemission_vB_3' 
       ntheory(5)='Mossbauer transmission_vC_3b' 
       ntheory(6)='Mossbauer transmission_vS_32'                    
       ntheory(7)='Mossbauer reemission_vS_32'                                                                         
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(7))l_jth=2 
       return 
      end if 

      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3   chth='//chth 
       return 
      end if 
      l_reemission=nfrtheo.eq.2.or.nfrtheo.eq.4

      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       thco(jc+1)='flag_SAMP        i_pos=1  include=y   0 ' 
                 ! discrete (1) , continuous(0) LG-curves               
       thco(jc+2)='flag_Voigt       i_pos=2  include=n   0' 
                 ! LG-convolution (1) , Voigt profile (0)               
       jc=jc+2 
                                                                        
!                     123456789012345678901234567                       
       ntrmt(jm+1)='t_eff  intensity     ' 
      if(device_n.eq.1)then
       ctrmt(jm+1)='fraction of the site ' 
        thpa(jp+1)='sc_fraction           , 1.  0.0 0.0  0.0' 
        thvr(jv+1)='sc_fraction                1     1  '
      else
       if(l_reemission) then
        ctrmt(jm+1)='reemission strenght of the site' 
         thpa(jp+1)='counts               10000.0  0.0 0.0  100.0' 
         thvr(jv+1)='counts                 1     1  ' 
       else
        ctrmt(jm+1)='effective thickness of the site' 
         thpa(jp+1)='mg/cm2xf          , 1.00  0.0 0.0  0.1' 
         thvr(jv+1)='mg/cm2xf                 1     1  '
       end if 
      end if
       ntrmt(jm+2)='position  matrix=(1,1)   include=y' 
       ctrmt(jm+2)='position of the spectrum' 
        thpa(jp+2)='is_shift         , 0.00  0.0 0.0  0.1' 
        thvr(jv+2)='is_shift                2    1  ' 
       jm=jm+2 
       jp=jp+2 
       jv=jv+2
      if(l_jth.eq.1)then 
       ntrmt(jm+1)='broadening  matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='broadening of the lines of the spectrum' 
        thpa(jp+1)='G_width          , 0.0  0.0 0.0  0.1' 
        thpa(jp+2)='L_width          , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='G_width                 3      1 0 ' 
        thvr(jv+2)='L_width                 4      0 1 ' 
       jm=jm+1 
       jp=jp+2 
       jv=jv+2
       cova='_2_4'
      else if(l_jth.eq.2)then
      ntrmt(jm+1)='L_broadening  matrix=(8,4)   include=[n]' 
      ctrmt(jm+1)='Lorentz line shaping of the source' 
       thpa(jp+1)='L_width18          , 0.00  0.0 0.0  0.1' 
       thpa(jp+2)='L_width27          , 0.00  0.0 0.0  0.1' 
       thpa(jp+3)='L_width36          , 0.00  0.0 0.0  0.1' 
       thpa(jp+4)='L_width45          , 0.00  0.0 0.0  0.1' 
       thvr(jv+1)='L_width_1          4   1 0 0 0 ' 
       thvr(jv+2)='L_width_2          5   0 1 0 0 ' 
       thvr(jv+3)='L_width_3          6   0 0 1 0 ' 
       thvr(jv+4)='L_width_4          7   0 0 0 1 ' 
       thvr(jv+5)='L_width_5          8   0 0 0 1 ' 
       thvr(jv+6)='L_width_6          9   0 0 1 0 ' 
       thvr(jv+7)='L_width_7         10   0 1 0 0 ' 
       thvr(jv+8)='L_width_8         11   1 0 0 0 ' 
      jm=jm+1 
      jp=jp+4 
      jv=jv+8
 
      ntrmt(jm+1)='G_broadening matrix=(8,4)   include=[y]' 
      ctrmt(jm+1)='Gauss line shaping of the source' 
       thpa(jp+1)='G_width18          , 0.00  0.0 0.0  0.1' 
       thpa(jp+2)='G_width27          , 0.00  0.0 0.0  0.1' 
       thpa(jp+3)='G_width36          , 0.00  0.0 0.0  0.1' 
       thpa(jp+4)='G_width45          , 0.00  0.0 0.0  0.1' 
       thvr(jv+1)='G_width_1         12   1 0 0 0 ' 
       thvr(jv+2)='G_width_2         13   0 1 0 0 ' 
       thvr(jv+3)='G_width_3         14   0 0 1 0 ' 
       thvr(jv+4)='G_width_4         15   0 0 0 1 ' 
       thvr(jv+5)='G_width_5         16   0 0 0 1 ' 
       thvr(jv+6)='G_width_6         17   0 0 1 0 ' 
       thvr(jv+7)='G_width_7         18   0 1 0 0 ' 
       thvr(jv+8)='G_width_8         19   1 0 0 0 ' 
      jm=jm+1 
      jp=jp+4 
      jv=jv+8

       cova='_219'
      end if  
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine thstr_22indexfmoss(l_jth,cmch,nhelpentry) 
        use comstr,only: nameth,namepg,ntheory,nstruct,device_n,nfrtheo,   &
                         ntrmt,ctrmt,thco,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission , powder, anisotropic f-factor             
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth 
      character(len=4) :: cova 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo,l_reemission

      if(cmch.eq.'name')then 
       nhelpentry='2x2 refraction index_f (sad)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='2x2 refraction index (static,f_anisotrop,sad)' 
       namepg(1)='2x2_ref_index_static_sad plrs,1 ' 
       nameth(2)='2x2 refraction index (Lwidth,f_anisotrop,sad)' 
       namepg(2)='2x2_ref_index_static_sad plrs,2 ' 
       nameth(3)='2x2 refraction index (Gwidth,f_anisotrop,sad)' 
       namepg(3)='2x2_ref_index_static_sad plrs,3 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=3 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vB_3b' 
       ntheory(2)='Mossbauer reemission_vB_3' 
       ntheory(3)='Mossbauer transmission_vC_3b'
       ntheory(4)='Mossbauer transmission_vS_32'  
       ntheory(5)='Mossbauer reemission_vS_32'
       if(name_eq_ntheo(5))l_jth=3     
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth 
       return 
      end if 

      l_reemission=nfrtheo.eq.2.or.nfrtheo.eq.4
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 

      thco(jc+1)='flag_SAMP  i_pos=1  include=y  0 ' 
                 ! discrete (1) , continuous(0) LG-curves               
      thco(jc+2)='flag_Voigt  i_pos=2    include=n  0 ' 
                 ! LG-convolution (1) , Voigt profile (0)               
      jc=jc+2 
                                                                        
       ntrmt(jm+1)='t_eff  intensity     ' 
      if(device_n.eq.1)then
       ctrmt(jm+1)='fraction of the site ' 
        thpa(jp+1)='sc_fraction           , 1.  0.0 0.0  0.0' 
        thvr(jv+1)='sc_fraction                1     1  '
      else
       if(l_reemission) then
        ctrmt(jm+1)='reemission strenght of the site' 
         thpa(jp+1)='counts               10000.0  0.0 0.0  500.0' 
         thvr(jv+1)='counts                 1     1  ' 
       else
        ctrmt(jm+1)='effective thickness of the site' 
         thpa(jp+1)='mg/cm2xf          , 1.00  0.0 0.0  0.1' 
         thvr(jv+1)='mg/cm2xf                 1     1  '
       end if 
      end if
      ntrmt(jm+2)='position  matrix=(1,1)   include=y' 
      ctrmt(jm+2)='position of the spectrum' 
       thpa(jp+2)='is_shift         , 0.00  0.0 0.0  0.1' 
       thvr(jv+2)='is_shift                 2    1  ' 
       jm=jm+2 
       jp=jp+2 
       jv=jv+2

      if(l_jth.eq.1)then                   
       ntrmt(jm+1)='broadening  matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='broadening of the lines of the spectrum' 
        thpa(jp+1)='G_width          , 0.0  0.0 0.0  0.1' 
        thpa(jp+2)='L_width          , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='G_width                 3      1 0 ' 
        thvr(jv+2)='L_width                 4      0 1 ' 
       jm=jm+1 
       jp=jp+2 
       jv=jv+2
       cova='_2_4'
      else if(l_jth.eq.2)then 

       thco(jc+1)='ioffset         i_pos=3  include=y   0' 
                 ! if more then 8 lines > L(ioffset),...,L(ioffset-1)
       jc=jc+1 
       ntrmt(jm+1)='broadening  matrix=(1,1)   include=[n]' 
       ctrmt(jm+1)='Gauss broadening of all  lines of the spectrum' 
        thpa(jp+1)='G_width            , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='G_width                 3  1 ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1

       ntrmt(jm+1)='broadening  matrix=(8,8)   include=[n]' 
       ctrmt(jm+1)='Lorentz broadening of 8  lines of the spectrum' 
        thpa(jp+1)='L_width_1          , 0.0  0.0 0.0  0.1' 
        thpa(jp+2)='L_width_2          , 0.0  0.0 0.0  0.1' 
        thpa(jp+3)='L_width_3          , 0.0  0.0 0.0  0.1' 
        thpa(jp+4)='L_width_4          , 0.0  0.0 0.0  0.1' 
        thpa(jp+5)='L_width_5          , 0.0  0.0 0.0  0.1' 
        thpa(jp+6)='L_width_6          , 0.0  0.0 0.0  0.1' 
        thpa(jp+7)='L_width_7          , 0.0  0.0 0.0  0.1' 
        thpa(jp+8)='L_width_8          , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='L_width_1            4  1 0 0 0 0 0 0 0' 
        thvr(jv+2)='L_width_2            5  0 1 0 0 0 0 0 0' 
        thvr(jv+3)='L_width_3            6  0 0 1 0 0 0 0 0' 
        thvr(jv+4)='L_width_4            7  0 0 0 1 0 0 0 0' 
        thvr(jv+5)='L_width_5            8  0 0 0 0 1 0 0 0' 
        thvr(jv+6)='L_width_6            9  0 0 0 0 0 1 0 0' 
        thvr(jv+7)='L_width_7           10  0 0 0 0 0 0 1 0' 
        thvr(jv+8)='L_width_8           11  0 0 0 0 0 0 0 1' 
       jm=jm+1 
       jp=jp+8 
       jv=jv+8
       cova='_311'
      else if(l_jth.eq.3)then 

       thco(jc+1)='ioffset         i_pos=3  include=y   0' 
                 ! if more then 8 lines > L(ioffset),...,L(ioffset-1)
       jc=jc+1 
       ntrmt(jm+1)='broadening  matrix=(1,1)   include=[n]' 
       ctrmt(jm+1)='Lorentz broadening of all  lines of the spectrum' 
        thpa(jp+1)='L_width            , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='L_width                 4  1 ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1

       ntrmt(jm+1)='broadening  matrix=(8,8)   include=[n]' 
       ctrmt(jm+1)='Gauss broadening of 8  lines of the spectrum' 
        thpa(jp+1)='Gwidth_1          , 0.0  0.0 0.0  0.1' 
        thpa(jp+2)='Gwidth_2          , 0.0  0.0 0.0  0.1' 
        thpa(jp+3)='Gwidth_3          , 0.0  0.0 0.0  0.1' 
        thpa(jp+4)='Gwidth_4          , 0.0  0.0 0.0  0.1' 
        thpa(jp+5)='Gwidth_5          , 0.0  0.0 0.0  0.1' 
        thpa(jp+6)='Gwidth_6          , 0.0  0.0 0.0  0.1' 
        thpa(jp+7)='Gwidth_7          , 0.0  0.0 0.0  0.1' 
        thpa(jp+8)='Gwidth_8          , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='Gwidth_1           12  1 0 0 0 0 0 0 0' 
        thvr(jv+2)='Gwidth_2           13  0 1 0 0 0 0 0 0' 
        thvr(jv+3)='Gwidth_3           14  0 0 1 0 0 0 0 0' 
        thvr(jv+4)='Gwidth_4           15  0 0 0 1 0 0 0 0' 
        thvr(jv+5)='Gwidth_5           16  0 0 0 0 1 0 0 0' 
        thvr(jv+6)='Gwidth_6           17  0 0 0 0 0 1 0 0' 
        thvr(jv+7)='Gwidth_7           18  0 0 0 0 0 0 1 0' 
        thvr(jv+8)='Gwidth_8           19  0 0 0 0 0 0 0 1' 
       jm=jm+1 
       jp=jp+8 
       jv=jv+8
       cova='_319'
      end if
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_22indexMB(l_jth,cmch,nhelpentry) 
        use comstr,only: nameth,namepg,ntheory,nstruct,device_n,   &
                         thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission , powder, anisotropic f-factor             
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth 
      character(len=4) :: cova 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 
                                                                          
      if(cmch.eq.'name')then 
       nhelpentry='2x2 refraction index MB' 
                                                                        
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='2x2 refraction index (static,sad)' 
       namepg(1)='2x2_ref_index_static_sad plrs,1 ' 
       nameth(2)='2x2 refraction index (f,t,spinham,sad)' 
       namepg(2)='2x2_ref_index_static_sad plrs,1 ' 
       nameth(3)='2x2 ref_index 2 state relaxation(f,sad)' 
       namepg(3)='2x2_ref_index_dynamic_sad plrs,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=1 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vD_3b' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=3
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       thco(jc+1)='flag_SAMP   i_pos=1    include=[n]  0 ' 
                 ! discrete (1) , continuous(0) LG-curves               
       thco(jc+2)='flag_Voigt  i_pos=2    include=n  0 ' 
                 ! LG-convolution (1) , Voigt profile (0)               
       jc=jc+2 
                                                                        
!                     123456789012345678901234567                       
       ntrmt(jm+1)='t_eff    intensity' 
       ctrmt(jm+1)='effective thickness by the f-factor at the site' 
        if(device_n.eq.1)then
         thpa(jp+1)='sc_fraction        , 1.  0.0 0.0  0.0' 
         thvr(jv+1)='sc_fraction                 1     1  ' 
        else
         thpa(jp+1)='mg/cm2xf         , 1.00  0.0 0.0  0.1' 
         thvr(jv+1)='mg/cm2xf                 1     1  ' 
        end if                                                                       
       ntrmt(jm+2)='position   matrix=(1,1)   include=y' 
       ctrmt(jm+2)='position of the spectrum' 
        thpa(jp+2)='is_shift         , 0.00  0.0 0.0  0.1' 
        thvr(jv+2)='is_shift                 2    1  ' 
       jm=jm+2 
       jp=jp+2 
       jv=jv+2
       if(l_jth.eq.3)then
        ntrmt(jm+1)='broadening  matrix=(1,1)   include=[n]' 
        ctrmt(jm+1)='Gauss broadening of the lines ' 
         thpa(jp+1)='G_width          , 0.00  0.0 0.0  0.1' 
         thvr(jv+1)='G_width                  3      1  ' 
        jm=jm+1 
        jp=jp+1 
        jv=jv+1
        cova='_2_3'
       else                                                                         
        ntrmt(jm+1)='broadening  matrix=(2,2)   include=[n]' 
        ctrmt(jm+1)='broadening of the lines of the spectrum' 
         thpa(jp+1)='G_width          , 0.00  0.0 0.0  0.1' 
         thpa(jp+2)='L_width          , 0.00  0.0 0.0  0.01' 
         thvr(jv+1)='G_width                  3      1 0 ' 
         thvr(jv+2)='L_width                  4      0 1 ' 
        jm=jm+1 
        jp=jp+2 
        jv=jv+2
        cova='_2_4'                                                                        
       end if
       call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_sampleorient(l_jth,cmch,nhelpentry) 
        use comstr,only: nameth,namepg,ntheory,nstruct,thco,  &
                         ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission                                            
!     level 2 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth 
      character(len=4) :: cova 
      integer   jc,jv,jm,jp,i0 
      logical   name_eq_ntheo 
      
      i0=ichar('0')                                                                  
      if(cmch.eq.'name')then 
       nhelpentry='sample orientation' 
                                                                        
!      names for child theories , mthchild=5 <= max_nth                 
       nameth(1)='nocall (angle(sample)=0)' 
       namepg(1)='sample_orientation    nono,1 ' 
       nameth(2)='sample orient.(rot-axis)' 
       namepg(2)='sample_orientation    nono,2 ' 
       nameth(3)='sample orient.(rot-axis & thickness)' 
       namepg(3)='sample_orientation    nono,3 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=3 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vB_2' 
       ntheory(2)='Mossbauer transmission_vC_1' 
       ntheory(3)='Mossbauer transmission_vD_2'
       ntheory(4)='Mossbauer transmission_vS_2' 
       ntheory(5)='Mossbauer reemission_vS_2'
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(5))l_jth=3 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
      
      if(l_jth.gt.1) then 
       thco(jc+1)='phi-a     i_pos=1  include= n  0 ' 
                ! not used yet    
       thco(jc+2)='theta-a   i_pos=2  include=[n]  90.0 ' 
        ! euler angle for rotation axes direction crystal system
       thco(jc+3)='psi-a     i_pos=3   include=[n]  42.18 ' 
        ! euler angle for rotation axes direction crystal system
        ! default values for fas
        jc=jc+3

        ntrmt(jm+1)='orient_euler   matrix=(3,3)   include=y' 
       ctrmt(jm+1)='orientation of the sample in the lab' 
        thpa(jp+1)='phi                  , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='theta                , 0.0  0.0 0.0  1.0' 
        thpa(jp+3)='psi                  , 0.0  0.0 0.0  1.0' 
        thvr(jv+1)='phi                      1    1 0 0 ' 
        thvr(jv+2)='theta                    2    0 1 0 ' 
        thvr(jv+3)='psi                      3    0 0 1 ' 
                                                                        
       ntrmt(jm+2)='rotation  matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='rotation axes in the lab system, rot.angle' 
        thpa(jp+4)='axtheta               , 0.0  0.0 0.0  0.1' 
        thpa(jp+5)='axphi                 , 0.0  0.0 0.0  0.1' 
        thpa(jp+6)='omega                 , 0.0  0.0 0.0  0.1' 
        thvr(jv+4)='axtheta                  4    1 0 0 ' 
        thvr(jv+5)='axphi                    5    0 1 0 ' 
        thvr(jv+6)='omega                    6    0 0 1 ' 
       jm=jm+2 
       jp=jp+6 
       jv=jv+6 
       cova='_3_6'                                                              
      end if 
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
      END                                           
                                                                        
      subroutine thstr_aperture(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none

      integer,intent(out):: l_jth
      character(len=4),   intent(inout)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth
      character(len=4) :: cova  
      integer   jc,jv,jm,jp
      logical   name_eq_ntheo 
                                                                        
!     theoryname=namepg()  is not defined. The theory: subroutine geometry(...)
!     is not called by name but simple by the condition  N_om_samp >0. 
      if(cmch.eq.'name')then 
       nhelpentry='Mossbauer geometry' 
!      names for child theories , mthchild=4 <= max_nth                 
       nameth(1)='source-absorber distance=large' 
       nameth(2)='point source cosine-smearing' 
       nameth(3)='extended circular source cosine-smearing' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=6 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vA_0' 
       ntheory(2)='Mossbauer transmission_vB_0' 
       ntheory(3)='Mossbauer reemission_vA_0' 
       ntheory(4)='Mossbauer reemission_vB_0' 
       ntheory(5)='Mossbauer transmission_vC_0' 
       ntheory(6)='Mossbauer transmission_vD_0' 
       ntheory(7)='Mossbauer transmission_vS_0'
       ntheory(8)='Mossbauer reemission_vS_0'
       
!      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(8))l_jth=3
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
!     geometry effects are only calculated if N_om_samp > 0             
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
      
      if(l_jth.eq.1)then 
       thco(jc+1)='N_om_samp    i_pos=1  include=n  0 ' 
       jc=jc+1 
      else 
!      common/acstrf/acsp,uthick_w,dum,flag_basis,dum1,channels,vm_SC,
!                   lambda,drive_mode,channels_vmax,c_nonlinear,      
!       om_samp,sc2aperture,abmue,Dsource,ring1to7,scmue,
!       Daperture,Dabsorber,sc2absorber,A_aperture,B_aperture,phicone,alpha
                                                                        
                                                                        
       thco(jc+1)='N_om_samp   i_pos=1  include= [y]  0 ' 
                ! determines the number of ring sections of the solid angle    
       thco(jc+2)='sc-aperture i_pos=2  from_data=[y]  15.0 ' 
                ! distance source to aperture/detector,cm                  
        thco(jc+3)='abmue      i_pos=3  from_data=[y]  1.29 ' 
             ! exp(-abmue)=0.27 for 14.4 kev and 25mue Fe
        jc=jc+3
       if(l_jth.eq.3)then 
        thco(jc+1)='Dsource  i_pos=4   from_data=[y]  0.25 ' 
                ! diameter of the source (point source 0.0cm)          
        thco(jc+2)='ring1-8    i_pos=5  from_data=[n]  3 ' 
                 ! source ring 1(point)-5)         
        thco(jc+3)='scmue      i_pos=6  from_data=[n]  0.50 ' 
        ! absorption of resonance energy exp(-scmue),
        ! 0.372/mue; 
        jc=jc+3
       end if
      end if

!      variables of frame theory: source,absorber and detector orientation
!      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,              
!                    channel_v0,geo,vnl(18),dummy,ctauN,ctauP 
                                                                        
!                    1                  012345                          
       ntrmt(jm+1)='deadtimeN matrix=(1,1) include=[n]'
       ctrmt(jm+1)='variable nonparalyzable deadtime'
        thpa(jp+1)='ctauN             0.00 0.0 0.0 0.1' 
        thvr(jv+1)='ctauN                  2 , 1 '
       ntrmt(jm+2)='deadtimeP matrix=(1,1) include=[n]'
       ctrmt(jm+2)='variable paralyzable deadtime'
        thpa(jp+2)='ctauP             0.00 0.0 0.0 0.1' 
        thvr(jv+2)='ctauP                  3 , 1'
       jm=jm+2 
       jp=jp+2 
       jv=jv+2
       cova='6_3_' 
      call convarmatpar(cova,jc,jv,jm,jp,chth)
                                                                        
      return 
      END                                           

      subroutine thstr_geoshape(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,ntheory,nstruct,ntrmt,ctrmt,thco,thpa,thvr
      implicit none

      integer,intent(out):: l_jth
      character(len=4),   intent(inout)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth
      character(len=4) :: cova  
      integer   jc,jv,jm,jp
      logical   name_eq_ntheo 
                                                                        
!     theoryname=namepg()  is not defined. The theory: subroutine geometry(...)
!     is not called by name but simple by the condition  N_om_samp >0. 

      if(cmch.eq.'name')then 
       nhelpentry='Mossbauer aperture' 
       nameth(1)='circular aperture' 
       nameth(2)='rectangular aperture' 
       nameth(3)='cone section elliptical aperture' 
       return 
      else if(cmch.eq.'theo') then
!      look for ntheory,mthparent=6 <=max_nth                           
       ntheory(1)='point source cosine-smearing'
       ntheory(2)='extended circular source cosine-smearing'
       if(name_eq_ntheo(2))l_jth=3
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
!     geometry effects are only calculated if abs(N_om_samp) > 0             
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!      common/acstrf/acsp,uthick_w,dum,flag_basis,dum1,channels,vm_SC,
!                    lambda,drive_mode,channels_vmax,c_nonlinear,      
!       om_samp,sc2aperture,abmue,Dsource,ring1to7,scmue,
!       Daperture,Dabsorber,sc2absorber,A_aperture,B_aperture,
!       phicone,alpha
                                                                        
      if(l_jth.eq.1) then
        thco(jc+1)='Daperture   i_pos=1  from_data=[y]  3.0 ' 
                ! diameter of aperture/detector                  
        thco(jc+2)='Dabsorber   i_pos=2  from_data=[y]  1.5 ' 
                ! diameter of the absorber
        thco(jc+3)='sc-absorber i_pos=3   from_data=[y]  10.0 ' 
                ! distance source to absorber                           
       jc=jc+3
       cova='0300'   
      else if(l_jth.eq.2) then
         thco(jc+1)='A-aperture   i_pos=4  from_data=[y]  3.0 ' 
                ! length A   area = AxB                  
        thco(jc+2)='B-aperture    i_pos=5  from_data=[y]  1.5 ' 
                ! length B    area = AxB
        jc=jc+2
       cova='0500'   
      else if(l_jth.eq.3) then
        ! single crystal calculation with N_om_samp < 0        
        thco(jc+1)='Dtube    i_pos=6  from_data=[y]  0.6 '  
                ! diameter of the tube of the cone section                 
        thco(jc+2)='alpha   i_pos=7       from_data=[y]  45.0 ' 
                ! conic section at angle alpha
        jc=jc+2
        ! single crystal calculation with N_om_samp < 0
        ntrmt(jm+1)='phicone        matrix=(1,1)   include=[y]' 
        ctrmt(jm+1)='phicone defines the relative position around ez(gamma)' 
         thpa(jp+1)='phicone              0.00  0.0 0.0  0.03' 
         thvr(jv+1)='phicone             1   1  '
        jm=jm+1
        jp=jp+1 
        jv=jv+1  
       cova='0701'   
      end if
      call convarmatpar(cova,jc,jv,jm,jp,chth)
                                                                        
      return 
      END                                           


      subroutine thstr_22source(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,ntrmt,ctrmt,thco,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer source, parameterization of selfabsorption of a polarized source             
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth 
      character(len=4) :: cova 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 

      if(cmch.eq.'name')then 
       nhelpentry='2x2 density matrix of the source'
!      names for child theories , mthchild=1 <= max_nth
       nameth(1)='2x2 refraction index (static,f_anisotrop,sad)' 
       namepg(1)='2x2_rho_matrix_source plrs, 1 '
       nameth(2)='2x2 rho-source selfabsorption (homogeneous distr)'
       namepg(2)='2x2_rho_matrix_source plrs, 2 '  
       nameth(3)='2x2 rho-source selfabsorption (diffusion profile)'
       namepg(3)='2x2_rho_matrix_source plrs, 3 '
       nameth(4)='2x2 rho-source selfabsorption matrix(Delta distr)'
       namepg(4)='2x2_rho_matrix_source plrs, 4 ' 
       nameth(5)='2x2 rho-source selfabsorption matrix(diffusion profile)'
       namepg(5)='2x2_rho_matrix_source plrs, 5 '
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=1 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vS_31' 
       ntheory(2)='Mossbauer reemission_vS_31'
       if(name_eq_ntheo(2))l_jth=5      !mthparent=1,mthchild=4
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 

      thco(jc+1)='flag_SAMP  i_pos=1  include=n  0 ' 
                 ! discrete (1) , continuous(0) LG-curves               
      thco(jc+2)='flag_Voigt  i_pos=2    include=n  0 ' 
                 ! LG-convolution (1) , Voigt profile (0)               

      ntrmt(jm+1)='fraction  intensity' 
      ctrmt(jm+1)='strength of the source (1 or fraction)' 
       thpa(jp+1)='sc_fraction         , 1.0  0.0 0.0  0.1' 
       thvr(jv+1)='sc_fraction                 1     1  ' 
      jm=jm+1
      jp=jp+1 
      jv=jv+1
      ntrmt(jm+1)='position  matrix=(1,1)   include=y' 
      ctrmt(jm+1)='relative shift of the source' 
       thpa(jp+1)='is_shift            0.00  0.0 0.0  0.1' 
       thvr(jv+1)='is_shift                 2    1  '
      jm=jm+1
      jp=jp+1 
      jv=jv+1
      cova='02va'

      if(l_jth.ge.2) then    
       !case 2: calculation to a depth = dsfoil ,
       !        homogeneous distribution of 57Co/57Fe
       ! case 3: 57Fe distribution emerge from 57Co distribution
       ! calculation to a depth of 2.*d1_ov_e <= dsfoil
       !                deff=t_depth*intprop(jz)*mu_57Fe
       thco(jc+3)='ioffset         i_pos=3  include=y   0' 
              ! if more then 8 lines > L(ioffset),...,L(ioffset-1) 

       thco(jc+4)='muRh_electronic     i_pos=5  include=y  0.0499' 
                 ! electronic attenuation mu/g of Rh     
       thco(jc+5)='nz_sampling       i_pos=6  include=y   32' 
                 ! sampling of the integral over z (mue)
       if(l_jth.eq.4) &
       ! icase 4: Delta-distribution at depth= d1_ov_e
       thco(jc+5)='nz_sampling       i_pos=6  include=y   1' 

       if(l_jth.eq.5) &
       ! case 5: 57Fe distribution is constant (57Co in iron)
            !                                deff=jz*t_depth/float(nz)
       thco(jc+4)='muFe_electronic    i_pos=5  include=y  0.0515' 
                 ! electronic attenuation mu/g of Fe
       jc=jc+5
       cova='07va' 
                                                                       
       if(l_jth.eq.2) then
        !(homogeneous distr)     
        thco(jc+1)='foil_d      i_pos=7  include=y  6.0' 
                 ! mu thickness of the source foil 
        jc=jc+1
        ntrmt(jm+1)='mu_thickness   matrix=(1,1)   include=y' 
        ctrmt(jm+1)=' thickness of 1mu iron with f_factor=1' 
         thpa(jp+1)='t57Fe/Rh          0.050  0.0 0.0  0.03' 
         thvr(jv+1)='t57Fe/Rh             3   1  '
        jm=jm+1 
        jp=jp+1 
        jv=jv+1         
       end if
       if(l_jth.eq.3) then       
        ! (diffusion profile)
        thco(jc+1)='foil_d      i_pos=7  include=y  6.0' 
                 ! source foil (alpha_Fe) thickness in case of reverse
        jc=jc+1
        ntrmt(jm+1)='mu_thickness   matrix=(1,1)   include=y' 
        ctrmt(jm+1)=' thickness of 1mu iron with f_factor=1' 
         thpa(jp+1)='t57Fe/Rh          0.050  0.0 0.0  0.03' 
         thvr(jv+1)='t57Fe/Rh             3   1  '
        ntrmt(jm+2)='depth_1oe  matrix=(1,1)   include=y'  
        ctrmt(jm+2)='depth(mue) 1/e-propability of density of nuclei(Co57)' 
         thpa(jp+2)='depth_1oe           3.5  0.0 0.0  0.1' 
         thvr(jv+2)='depth_1oe              5  1 ' 
        jm=jm+2 
        jp=jp+2 
        jv=jv+2
       end if
       if(l_jth.eq.4) then       
        ! selfabsorption matrix(Delta distr )'
        ntrmt(jm+1)='mu_thickness   matrix=(1,1)   include=y' 
        ctrmt(jm+1)=' thickness of 1mu iron with f_factor=1' 
         thpa(jp+1)='tmuFe          0.465  0.0 0.0  0.1' 
         thvr(jv+1)='tmuFe             3   1  '
        ntrmt(jm+2)='depth_1oe  matrix=(1,1)   include=y'  
        ctrmt(jm+2)='depth(mu) of Delta distribution of nuclei(57Co)' 
         thpa(jp+2)='depth             3.5  0.0 0.0  0.1' 
         thvr(jv+2)='depth              5  1 ' 
        jm=jm+2 
        jp=jp+2 
        jv=jv+2
       end if 
       if(l_jth.eq.5) then       
        ! matrix(diffusion profile)
        thco(jc+1)='foil_d      i_pos=7  include=[n]  25.0' 
                 ! source foil (alpha_Fe) thickness in case of reverse
        jc=jc+1
        ntrmt(jm+1)='thickness   matrix=(2,2)   include=y' 
        ctrmt(jm+1)='effective thickness 57Co/iron source' 
         thpa(jp+1)='t57Fe/Rh         0.050  0.0 0.0  0.03' 
         thpa(jp+2)='tmuFe            0.465  0.0 0.0  0.0'
         thvr(jv+1)='t57Fe/Rh           3  1  0 ' 
         thvr(jv+2)='tmuFe              4  0  1 '
        ntrmt(jm+2)='depth_1oe  matrix=(1,1)   include=y'  
        ctrmt(jm+2)='depth(mue) 1/e-propability of density of nuclei(Co57)' 
         thpa(jp+3)='depth_1oe             3.5  0.0 0.0  0.1' 
         thvr(jv+3)='depth_1oe              5  1 ' 
        jm=jm+2 
        jp=jp+3 
        jv=jv+3
       end if
      end if
      ntrmt(jm+1)='L_broadening  matrix=(8,4)   include=[y]' 
      ctrmt(jm+1)='Lorentz line shaping of the source' 
       thpa(jp+1)='L_width18          , 0.00  0.0 0.0  0.1' 
       thpa(jp+2)='L_width27          , 0.00  0.0 0.0  0.1' 
       thpa(jp+3)='L_width36          , 0.00  0.0 0.0  0.1' 
       thpa(jp+4)='L_width45          , 0.00  0.0 0.0  0.1' 
       thvr(jv+1)='L_width_1          14   1 0 0 0 ' 
       thvr(jv+2)='L_width_2          15   0 1 0 0 ' 
       thvr(jv+3)='L_width_3          16   0 0 1 0 ' 
       thvr(jv+4)='L_width_4          17   0 0 0 1 ' 
       thvr(jv+5)='L_width_5          18   0 0 0 1 ' 
       thvr(jv+6)='L_width_6          19   0 0 1 0 ' 
       thvr(jv+7)='L_width_7          20   0 1 0 0 ' 
       thvr(jv+8)='L_width_8          21   1 0 0 0 ' 
      jm=jm+1 
      jp=jp+4 
      jv=jv+8
 
      ntrmt(jm+1)='G_broadening matrix=(8,4)   include=[y]' 
      ctrmt(jm+1)='Gauss line shaping of the source' 
       thpa(jp+1)='G_width18          , 0.00  0.0 0.0  0.1' 
       thpa(jp+2)='G_width27          , 0.00  0.0 0.0  0.1' 
       thpa(jp+3)='G_width36          , 0.00  0.0 0.0  0.1' 
       thpa(jp+4)='G_width45          , 0.00  0.0 0.0  0.1' 
       thvr(jv+1)='G_width_1            6  1 0 0 0 ' 
       thvr(jv+2)='G_width_2            7  0 1 0 0 ' 
       thvr(jv+3)='G_width_3            8  0 0 1 0 ' 
       thvr(jv+4)='G_width_4            9  0 0 0 1 ' 
       thvr(jv+5)='G_width_5           10  0 0 0 1 ' 
       thvr(jv+6)='G_width_6           11  0 0 1 0 ' 
       thvr(jv+7)='G_width_7           12  0 1 0 0 ' 
       thvr(jv+8)='G_width_8           13  1 0 0 0 ' 
      jm=jm+1 
      jp=jp+4 
      jv=jv+8
      cova=cova(1:2)//'21'
     call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_22indexSPL(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,istruct,device_n,nfrtheo,&
                       thco,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission and Mossbauer resonance reflection theories
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      character(len=4) :: cova 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo,l_reemission 

      if(cmch.eq.'name')then 
       nhelpentry='Single polarized Line' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='2x2 single polarized line (sad)'
       namepg(1)='2x2_ref_index_static_sad plrs,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=5 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vA_3b' 
       ntheory(2)='Mossbauer transmission_vB_3b' 
       ntheory(3)='Mossbauer reemission_vA_3b' 
       ntheory(4)='Mossbauer reemission_vB_3b' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(4))l_jth=1 
       return 
      end if 
      chth='th'//nhelpentry(1:6)  
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3   chth='//chth 
       return 
      end if 

      l_reemission=nfrtheo.eq.2.or.nfrtheo.eq.4

      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       thco(jc+1)='flag_SAMP        i_pos=1  include=y   0 ' 
                 ! discrete (1) , continuous(0) LG-curves               
       thco(jc+2)='flag_Voigt       i_pos=2  include=[n]   0' 
                 ! LG-convolution (1) , Voigt profile (0)               
       jc=jc+2 
                                                                        
!                     123456789012345678901234567                       
       ntrmt(jm+1)='intensity   ' 
       if(device_n.eq.1)then
        ctrmt(jm+1)='source intensity normalized to 1' 
         thpa(jp+1)='I_beam         , 1.  0.0 0.0  0.0' 
         thvr(jv+1)='I_beam                 1     1  ' 
       else
        if(l_reemission) then
         ctrmt(jm+1)='reemission strenght of the site' 
          thpa(jp+1)='counts               50000.0  0.0 0.0  500.0' 
          thvr(jv+1)='counts                 1     1  ' 
        else
         ctrmt(jm+1)='effective thickness of the site'          
          thpa(jp+1)='mg/cm2xf        , 1.  0.0 0.0  0.1' 
          thvr(jv+1)='mg/cm2xf                  1     1  ' 
        end if
       end if
       jm=jm+1 
       jp=jp+1 
       jv=jv+1
       ntrmt(jm+1)='position  matrix=(1,1)   include=y' 
       ctrmt(jm+1)='position of the spectrum' 
        thpa(jp+1)='is_shift         , 0.00  0.0 0.0  0.1' 
        thvr(jv+1)='is_shift                2    1  ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1
       ntrmt(jm+1)='broadening  matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='broadening of the lines of the spectrum' 
        thpa(jp+1)='G_width          , 0.00 0.0 0.0  0.1' 
        thpa(jp+2)='L_width          , 0.00  0.0 0.0  0.1' 
        thvr(jv+1)='G_width                 3      1 0 ' 
        thvr(jv+2)='L_width                 4      0 1 ' 
       jm=jm+1 
       jp=jp+2 
       jv=jv+2
      cova='_2_4'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           

      subroutine thstr_detector(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,istruct,device_n,  &
                       thco,ntrmt,ctrmt,thpa,thvr
      implicit none

      integer,intent(out):: l_jth
      character(len=4),   intent(inout)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth
      character(len=4) :: cova  
      integer   jc,jv,jm,jp
      logical   name_eq_ntheo 
                                                                        
!     theoryname=namepg()  is not defined. The theory: subroutine geometry(...)
!     is not called by name but simple by the condition  N_om_samp >0. 

      if(cmch.eq.'name')then 
       nhelpentry='Mossbauer spectrum' 
!      names for child theories , mthchild=4 <= max_nth                 
       nameth(1)='v=0 between source and detector' 
       namepg(1)='1x1_ref_index_static_sad  scal,1 '
       nameth(2)='polarization analyser' 
       namepg(2)='poincare        nono,1 '
       return 
      else if(cmch.eq.'theo') then 
!      look for ntheory,mthparent=6 <=max_nth                           
       ntheory(1)='Mossbauer transmission_vA_33' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=2 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
    call convarmatpar('coll',jc,jv,jm,jp,chth) 

    if(l_jth.eq.1)then
      thco(jc+1)='flag_SAMP     i_pos=1   include=y  1' 
               ! discrete (1) , continuous(0) LG-curves                 
      thco(jc+2)='flag_Voigt    i_pos=2   include=n  0' 
                ! LG-convolution (1) , Voigt profile (0)                
      jc=jc+2 
                                                                        
      ntrmt(jm+1)='t_eff  intensity     ' 
      ctrmt(jm+1)='effective thickness by the f-factor at the site' 
       if(device_n.eq.1)then
        thpa(jp+1)='sc_fraction           , 1.  0.0 0.0  0.0' 
        thvr(jv+1)='sc_fraction                1     1  ' 
       else
        thpa(jp+1)='mg/cm2xf          , 1.00  0.0 0.0  0.1' 
        thvr(jv+1)='mg/cm2xf                 1     1  ' 
       end if
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
      cova='_2_1'
      ntrmt(jm+1)='isomer_shift  matrix=(1,1)   include=y' 
      ctrmt(jm+1)='isomer shift of the spectrum' 
       thpa(jp+1)='shift            , 0.00  0.0 0.0  0.1' 
       thvr(jv+1)='shift                   2     1 ' 
      jm=jm+1 
      jp=jp+1 
      jv=jv+1 
      cova='_2_2'

     else if(l_jth.eq.2)then
      ntrmt(jm+1)='Poincare_analyser   matrix=(3,3) include=y' 
      ctrmt(jm+1)='(3) Poincare vector of the analyser' 
       thpa(jp+1)='PAxsi             , 1.0  0.0 0.0  0.05' 
       thpa(jp+2)='PAeta             , 0.0  0.0 0.0   0.05' 
       thpa(jp+3)='PAzeta            , 0.0  0.0 0.0   0.05' 
       thvr(jv+1)='PAxsi                    1    1 0 0' 
       thvr(jv+2)='PAeta                    2     0 1 0' 
       thvr(jv+3)='PAzeta                   3    0 0 1' 
      jm=jm+1 
      jp=jp+3
      jv=jv+3 
      cova='co03'
     end if
     call convarmatpar(cova,jc,jv,jm,jp,chth)
                                                                        
      return 
      END                                           


 
