     subroutine frstr_texture(l_nfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
      use comstr, only: ntheory,nstruct,istruct,ndev,device_n,              &
                        strcmt
      implicit none 
      integer,intent(in):: l_nfrtheo,lstruct1
      integer,intent(inout):: lstruct2
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      character(len=8)  :: chth  
      character(len=4)  :: cova 
      integer number_device
      integer jc,jv,jm,jp
      
      if(cmch.eq.'name') then 
!####################################################                   
       nhelpentry ='effi' 
       ntheory(1)='display texture' 
       ntheory(2)=' '                                                                        
       ndev(1)='device' 
       ndev(2)=' '
       ndev(3)=' '
!####################################################                   
       return 
      end if 
      chth='fr'//nhelpentry(1:6) 
      if(lstruct1.eq.0) then 
       if(cmch.eq.'hdbk') then 
          nstruct=' '
        return 
       end if                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
       strcmt(1)='texture       n_set=[tx] 1  '    ! device 1 , not asked
       strcmt(2)='function name'                   ! tx is default
       strcmt(3)='further device'                  ! not asked: since restricted to 1 
       strcmt(4)='theory/'//chth//'/texture/go'    ! helpfile function /go:leave he
       strcmt(5)='theory'//chth//'no_help'         ! he entry for strcmt(3)
       cova='____'
      call convarmatpar('cova',jc,jv,jm,jp,chth)        
      return 
     end if
    goto(100)number_device(lstruct1) 
!-----------------------------------------------------------------------
100  continue      ! first device
      device_n=1
      if(cmch.eq.'hdbk') then 
         nstruct=' '
       return  
      end if

     if(lstruct2.gt.0) goto 110 
      call convarmatpar('coll',jc,jv,jm,jp,chth)     
      strcmt(1)='texture     n_device=[tx] 1 1 ' 
      strcmt(2)='name of function ' 
      strcmt(3)=' '               
      strcmt(4)='theory/'//chth//'/directions_sphere' 
      strcmt(5)='theory/'//chth//'/directions_sphere' 
      cova='____'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      lstruct2=-1

      return 
!     --------------------------------------------------                
  110 continue    ! modules of first device
!     common/acfr1trf/    /avfr1trf/           
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
      ! since entry 110 carries no information  => lstruct2 is put to -1
      ! any further questions (answers) of effi are stopped 
                                                                        
      lstruct2=-1
      return 
      END                                           

      
      subroutine thstr_texture(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory,nstruct,thco
      implicit none
      integer, intent(out)::  l_jth
      character(len=132),intent(inout):: nhelpentry
      character(len=4),  intent(in):: cmch

      character(len=8)  :: chth 
      character(len=4) :: cova       
      logical   name_eq_ntheo
      integer jc,jv,jm,jp

!     ----------------
!     global variables, constant : string nhelpentry contains "(distribute)" 
!     ----------------
      if(cmch.eq.'name')then 
       nhelpentry='display texture (distribute)' 
       nameth(1)='weighted_directions' 
       return 
      else if(cmch.eq.'theo') then 
       ntheory(1)='display texture' 
       if(name_eq_ntheo(1))l_jth=1 
       return
      end if

      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if
    
       call convarmatpar('coll',jc,jv,jm,jp,chth) 
      nhelpentry='theory/'//chth(1:6)//'ex'
      thco(jc+1)='nu_channels       i_pos=1  from_data=y  96'           
      thco(jc+2)='scale_factor     i_pos=2   include=y  1'
      thco(jc+3)='datastructure    i_pos=3   include=y  1'      
              
      jc=jc+3 
      cova='0300'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
   
      return 
      END                                           
                                                                        
      subroutine thstr_direction(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,namepg,nstruct,ntheory, &
                        ntrmt,ctrmt,thpa,thvr
      implicit none
      integer, intent(out)::  l_jth
      character(len=4),  intent(in):: cmch
      character(len=132),intent(inout):: nhelpentry

      character(len=8)  :: chth
      character(len=4) :: cova   
      logical   name_eq_ntheo
      integer jc,jv,jm,jp

      if(cmch.eq.'name')then 
       nhelpentry='texture' 
       nameth(1)='directions on sphere' 
       namepg(1)='th_sphere real, 1'
       return 
      else if(cmch.eq.'theo') then 
       ntheory(1)='weighted_directions_1' 
       if(name_eq_ntheo(1))l_jth=1 
       return 
      end if

      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if

      call convarmatpar('coll',jc,jv,jm,jp,chth)
      ntrmt(jm+1)='txtucoefficient     matrix=(1,1) include=y'  
      ctrmt(jm+1)='polynom coefficient to be fitted' 
       thpa(jp+1)='Pdummy            , 0  0 0 0 '  
       thvr(jv+1)='Vdummy               1     1   ' 
      jm=jm+1
      jp=jp+1
      jv=jv+1
      cova='0001'
       call convarmatpar(cova,jc,jv,jm,jp,chth) 
      
      return 
      END                                           
                                                                        
                                                                        
