     subroutine hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hv,efgm,      &
                                                 je,jg,jge,Eagd,V1,V2)
     implicit none 
     logical, intent(in):: b_integer 
     integer, intent(in):: jg,je,jge
     real,    intent(in):: amueg,amuee,QgdQe,cTms
     complex, intent(in):: hv(-1:1),efgm(-2:2)

     real,    intent(out):: Eagd(jge)
     complex, intent(out):: V1(-1:1,jge),V2(-2:2,jge)


     real,    dimension(-je:je,-1:1,-jg:jg):: Vje_1_jg              
     real,    dimension(-je:je,-2:2,-jg:jg):: Vje_2_jg 
     real,    dimension(-jg:jg):: wpjg
     real,    dimension(-je:je):: wpje
     complex, dimension(-jg:jg,-jg:jg):: Evg
     complex, dimension(-je:je,-je:je):: Eve
     real,    dimension(-jg:jg):: Eg  
     real,    dimension(-je:je):: Ee
     integer, dimension(jge)   :: indx,jndx 

                                                                 
     integer  :: m,n,ieg,jeg,ie,ig,j,jm,me,mg 
     complex  :: C20,C2m1,C2m2,H10,H1m1,hc1 
     real     :: Qjg,Qje,sq2,sq3d8,hmag,h,hi2im1,q20,q21,q22 
     complex, parameter:: C0=cmplx(0.,0.)
     complex, dimension(:,:), allocatable :: hm   !,HIN

     jm=je
     if(jg.gt.jm) jm=jg
     allocate(hm(-jm:jm,-jm:jm))

!       write(6,'(a,6f10.2,/,a,10f8.2)')'  hv=',hv,'efgm=',efgm         
!      magnetic energy                                                  
!      E(B)= - mue*(Bx*Ix+By*Iy+Bz*Iz)/I                                
!              (largest moment is mue - not mue*I(=3/2)-)               
!          = - mue*(Bz*Iz-B(+1)/sq2*I(-) + B(-1)/sq2*I(+))/I            
!      electric energy                                                  
!      E(Vik)= 3/4 eQ /I(2I-1) * Sum;ik Vik*Ii*Ik                       
!              Sum;k q2k*C2-k*(-1)**k                                   
!                                                                       
!      Abragam and Bleaney chapter 17 ,p. 680                           
!              q20=eQ/I(2I-1)*1/2*(3*Iz*Iz-I(I+1))                      
!              q21=-eQ/I(2I-1)*(Iz*(I+) + (I+)*Iz)sqrt(3/8)             
!             q2-1= eQ/I(2I-1)*(Iz*(I-) + (I-)*Iz)sqrt(3/8)             
!              q22= eQ/I(2I-1)*(I+)**2*sqrt(3/8)                        
!             q2-2= eQ/I(2I-1)*(I-)**2*sqrt(3/8)                        
!              C20= 1/2*Vzz                                             
!              C21=-2/3*(Vxz+iVyz)*sqrt(3/8)                            
!             C2-1= 2/3*(Vxz-iVyz)*sqrt(3/8)                            
!              C22= (Vxx-Vyy+2iVxy)*sqrt(3/8)/3                         
!             C2-2= (Vxx-Vyy-2iVxy)*sqrt(3/8)/3                         
!     the potential V= -e/|r-R| of a negative charge -e ( e=|e|)        
                                                                        
!     exited state                                                      
      call symbol3j(b_integer,je,jg,Vje_1_jg,Vje_2_jg,wpje,wpjg) 

      sq3d8=sqrt(3./8.) 
      sq2=sqrt(2.) 
      if(QgdQe.gt.9999)then 
        Qjg=1. 
        Qje=0. 
      else 
        Qjg=QgdQe 
        Qje=1. 
      end if 
      if(.not.b_integer)then 
!      ------------------------half integral spin----------------       
       j=je 
       hm=C0                                                                
                                                                        
       hmag=amuee/float(j)/cTms 
       H10=-hmag*hv(0) 
       H1m1=-hmag*hv(-1) 
                                                                        
       if(j.gt.1) then 
        hI2IM1=float(j*(2*j-2))/4. 
        C20=efgm(0)/hI2IM1*Qje 
        C2m1=efgm(-1)/hI2IM1*Qje 
        C2m2=efgm(-2)/hI2IM1*Qje 
        h=float(j*(j+2)) 
        do m=-j,j,2 
         q20=(float(3*m**2)-h)/8. 
         hm(m,m)= C20*q20 + m*H10 
        end do 
                                                                        
        do m=j-2,-j,-2              !  m+1= (m+2 + m)/2 
         q21=-float(m+1)*wpje(m)*sq3d8 
         hm(m+2,m)= -C2m1*q21 + H1m1*wpje(m)*sq2 
        end do 
       else 
         hm(1,1)= H10 
         hm(-1,-1)= -H10 
         hm(1,-1)=H1m1*sq2 
       end if 
                                                                        
       if(j.ge.2) then 
        do m=j-4,-j,-2 
         q22=wpje(m+2)*wpje(m)*sq3d8 
         hm(m+4,m)= C2m2*q22 
        end do 
       end if 
!      write(6,'(a,i4,8g12.4)') ' jacobi',j,cTms,hv                              
!      do m=-j,j,2                                                      
!       write(6,'(8g12.4)') (hm(n,m),n=-j,j,2)                          
!      end do                                                           
      call jacobihf(b_integer,jm,hm,j,Ee,Eve,j+1) 
!      j=je                                                             
!       write(6,'(8f10.6)') Ee                                          
!       do m=-j,j,2                                                     
!        write(6,'(8f10.6)') (Eve(n,m),n=-j,j,2)                        
!       end do                                                          
!      groundstate                                                      
         j=jg 
         do m=-j,j,2 
         do n=-j,j,2 
          hm(n,m)=(0.,0.) 
         end do 
         end do 
                                                                        
         hmag=amueg/float(j)/cTms 
         H10=-hmag*hv(0) 
         H1m1=-hmag*hv(-1) 
                                                                        
         if(j.gt.1) then 
          hI2IM1=float(j*(j-1))/2. 
          C20=efgm(0)/hI2IM1*Qjg 
          C2m1=efgm(-1)/hI2IM1*Qjg 
          C2m2=efgm(-2)/hI2IM1*Qjg 
          h=float(j*(j+2)) 
          do m=-j,j,2 
           q20=(float(3*m**2)-h)/8. 
           hm(m,m)= C20*q20 + m*H10 
          end do 
                                                                        
          do m=j-2,-j,-2         !  m+1= (m+2 + m)/2     
           q21=-float(m+1)*wpjg(m)*sq3d8 
           hm(m+2,m)= -C2m1*q21 + H1m1*wpjg(m)*sq2 
          end do 
         else 
           hm(1,1)= H10 
           hm(-1,-1)= -H10 
           hm(1,-1)=H1m1*sq2 
         end if 
                                                                        
         if(j.ge.2) then 
           do m=j-4,-j,-2 
            q22=wpjg(m+2)*wpjg(m)*sq3d8 
            hm(m+4,m)= C2m2*q22 
           end do 
         end if 
                                                                        
         call jacobihf(b_integer,jm,hm,j,Eg,Evg,j+1) 
!         write(6,'(8f10.6)') Eg                                        
!         do m=-j,j,2                                                   
!          write(6,'(8f10.6)') (Evg(n,m),n=-j,j,2)                      
!         end do                                                        
        ieg=0 
        do ie=-je,je,2 
        do ig=-jg,jg,2 
         ieg=ieg+1 
         Eagd(ieg)=Ee(ie)-Eg(ig) 
        end do
        end do
        call INDEXX(jge,Eagd,indx) 
        do m=1,jge
         jndx(indx(m))=m
        end do
!        ie , ig count the exited and ground states                     
                                                                        
        jeg=0 
        do ie=-je,je,2 
        do ig=-jg,jg,2 
         jeg=jeg+1
         ieg=jndx(jeg)
         Eagd(ieg)=Ee(ie)-Eg(ig) 
!      aM= <Je,ie|Htr(M)|Jg,ig>                                         
!      eigenstates are |Je,ie>= Sum;me  UE(me,ie)*|Je,me>  ;  Eve=UE+   
!      eigenstates are |Jg,ig>= Sum;mg  UG(mg,ig)*|Jg,mg>  ;  Evg=UG+   
!      <Je,ie|Htr(M)|Jg,ig>=                                            
!               Sum;me conjg(UE(me,ie))*UG(mg,ig)*<Je,me|Htr(M)|Jg,mg>  
!               Sum;me Eve(ie,me)*conjg(Evg(ig,mg))*<Je,me|Htr(M)|Jg,mg>
                                                                        
         do M=-1,1 
           hc1=(0.,0.) 
          do me=je,-je,-2 
          do mg=jg,-jg,-2 
           hc1=hc1+ Eve(ie,me)*conjg(Evg(ig,mg))*                       &
                         Vje_1_jg(me,M,mg)                             
!           write(6,'(6f10.4)')Eve(ie,me),Evg(ig,mg),Vje_L_jg(me,M,mg)  
!           read(5,'(a)')                                               
          end do 
          end do 
          V1(M,ieg)=hc1         
         end do 
!        write(6,*) Eagd(ieg), V1(1,ieg), V1(0,ieg), V1(-1,ieg)
!        write(6,*) Eagd(ieg),real( V1(1,ieg)*conjg( V1(1,ieg))),&
!                   real( V1(0,ieg)*conjg( V1(0,ieg))),          &
!                   real( V1(-1,ieg)*conjg( V1(-1,ieg)))
         do M=-2,2 
           hc1=(0.,0.) 
          do me=je,-je,-2 
          do mg=jg,-jg,-2 
           hc1=hc1+ Eve(ie,me)*conjg(Evg(ig,mg))*                       &
                         Vje_2_jg(me,M,mg)                             
!           write(6,'(6f10.4)')Eve(ie,me),Evg(ig,mg),Vje_L_jg(me,M,mg)  
!           read(5,'(a)')                                               
          end do 
          end do 
          V2(M,ieg)=hc1 
         end do 
        end do        ! ig  
        end do        ! ie 

!        allocate(HIN(-2:2,-2:2))
!        HIN=(0.,0.)
!        do ieg=1,jeg
!         do M=-2,2 
!           do N=-2,2
!            HIN(M,N)= HIN(M,N)+V2(M,ieg)*conjg(V2(N,ieg))
!           end do          
!         end do          
!        end do
!        do M=-2,2 
!         write(6,'(10f8.2)')(HIN(M,N),N=-2,2)
!        end do   
!        deallocate(HIN)                                        
       else 
!      ---------------integral spin -----------------------------       
       j=je 
       if(j.eq.0) goto 10 
                                                                        
       do m=-j,j,1 
       do n=-j,j,1 
        hm(n,m)=(0.,0.) 
       end do 
       end do 
                                                                        
       hmag=amuee/float(j)/cTms 
       H10=-hmag*hv(0) 
       H1m1=-hmag*hv(-1) 
                                                                        
        hI2IM1=float(j*(2*j-1)) 
        C20=efgm(0)/hI2IM1*Qje 
        C2m1=efgm(-1)/hI2IM1*Qje 
        C2m2=efgm(-2)/hI2IM1*Qje 
        h=float(j*(j+1)) 
        do m=-j,j,1 
         q20=(float(3*m**2)-h)/2. 
         hm(m,m)= C20*q20 + m*H10 
        end do 
                                                                        
        do m=j-1,-j,-1 
                                                !  m+1+m =< m+1         
         q21=-float(2*m+1)*wpje(m)*sq3d8 
         hm(m+1,m)= -C2m1*q21 + H1m1*wpje(m)/sq2 
        end do 
                                                                        
       if(j.ge.2) then 
        do m=j-2,-j,-1 
         q22=wpje(m+1)*wpje(m)*sq3d8 
         hm(m+2,m)= C2m2*q22 
        end do 
       end if 
!      write(6,'(a,4i4)') ' jacobi',maxj,j                              
!      do m=-j,j,2                                                      
!       write(6,'(8f10.6)') (hm(n,m),n=-j,j,2)                          
!      end do                                                           
                                                                        
       call jacobihf(b_integer,jm,hm,j,Ee,Eve,2*j+1) 
       j=je 
!       write(6,'(8f10.6)')Ee
!       do m=-j,j,1                                                     
!        write(6,'(8f10.6)') (Eve(n,m),n=-j,j,1)                        
!       end do                                                          
       goto 11 
   10  continue 
       Ee(0)=0. 
       Eve(0,0)=(1.,0.) 
                                                                        
!      groundstate                                                      
   11  j=jg 
        if(j.eq.0) goto 20 

         hm=C0
                                                                        
         hmag=amueg/float(j)/cTms 
         H10=-hmag*hv(0) 
         H1m1=-hmag*hv(-1) 
                                                                        
          hI2IM1=float(j*(2*j-1)) 
          C20=efgm(0)/hI2IM1*Qjg 
          C2m1=efgm(-1)/hI2IM1*Qjg 
          C2m2=efgm(-2)/hI2IM1*Qjg 
          h=float(j*(j+1)) 
          do m=-j,j,2 
           q20=(float(3*m**2)-h)/2. 
           hm(m,m)= C20*q20 + m*H10 
          end do 
                                                                        
          do m=j-1,-j,-1 
                                                  !  m+1= (m+2 + m)/2   
           q21=-float(2*m+1)*wpjg(m)*sq3d8 
           hm(m+1,m)= -C2m1*q21 + H1m1*wpjg(m)/sq2 
          end do 
                                                                        
         if(j.ge.2) then 
           do m=j-2,-j,-1 
            q22=wpjg(m+1)*wpjg(m)*sq3d8 
            hm(m+2,m)= C2m2*q22 
           end do 
         end if 
                                                                        
         call jacobihf(b_integer,jm,hm,j,Eg,Evg,2*j+1) 
!         write(6,'(8f10.6)') Eg                          
!         do m=-j,j,2                                                   
!          write(6,'(8f10.6)') (Evg(n,m),n=-j,j,2)                      
!         end do                                                        
                                                                        
!        ie , ig count the exited and ground states                     
        goto 21 
   20   continue 
        Eg(0)=0. 
        Evg(0,0)=(1.,0.) 
                                                                        
   21   ieg=0 
        do ie=-je,je,1
        do ig=-jg,jg,1 
         ieg=ieg+1 
         Eagd(ieg)=Ee(ie)-Eg(ig) 
        end do
        end do
        call INDEXX(jge,Eagd,indx)                                                               
        do m=1,jge
         jndx(indx(m))=m
        end do
!        ie , ig count the exited and ground states                     
                                                                        
        jeg=0 
        do ie=-je,je,1 
        do ig=-jg,jg,1 
         jeg=jeg+1
         ieg=jndx(jeg)
         Eagd(ieg)=Ee(ie)-Eg(ig) 
                                                                        
!      aM= <Je,ie|Htr(M)|Jg,ig>                                         
!      eigenstates are |Je,ie>= Sum;me  UE(me,ie)*|Je,me>  ;  Eve=UE+   
!      eigenstates are |Jg,ig>= Sum;mg  UG(mg,ig)*|Jg,mg>  ;  Evg=UG+   
!      <Je,ie|Htr(M)|Jg,ig>=                                            
!               Sum;me conjg(UE(me,ie))*UG(mg,ig)*<Je,me|Htr(M)|Jg,mg>  
!               Sum;me Eve(ie,me)*conjg(Evg(ig,mg))*<Je,me|Htr(M)|Jg,mg>
                                                                        
         do M=-1,1 
           hc1=(0.,0.) 
          do me=je,-je,-1 
          do mg=jg,-jg,-1 
           hc1=hc1+ Eve(ie,me)*conjg(Evg(ig,mg))*                       &
                         Vje_1_jg(me,M,mg)                             
          end do 
          end do 
          V1(M,ieg)=hc1 
         end do 
         do M=-2,2 
           hc1=(0.,0.) 
          do me=je,-je,-1 
          do mg=jg,-jg,-1 
           hc1=hc1+ Eve(ie,me)*conjg(Evg(ig,mg))*                       &
                         Vje_2_jg(me,M,mg)                             
          end do 
          end do 
          V2(M,ieg)=hc1 
         end do 
        end do  ! ig  
        end do   ! ie  
       end if  ! n/2 and n spin  
       return 
      END                                           
                                                                        
                                                                        
      subroutine jacobihf(b_integer,jm,Hm,j,EE,Evec,jm1b) 
      implicit none 
      logical, intent(in) :: b_integer 
      integer, intent(in) :: j,jm,jm1b 
      complex, intent(in) :: Hm(-jm:jm,-jm:jm)
      complex, intent(out):: Evec(-j:j,-j:j)
      real,    intent(out):: EE(-j:j)

      complex,dimension(jm1b,jm1b):: A,V
      real,   dimension(jm1b)   :: D
      integer        :: i,k,m,n,nrot 
      real,parameter :: OUTJ=10000. 
                                                                        
      if(.not.b_integer)then 
!      ---------------half integral spin ------------------------       
       m=0 
       do i=j,-j,-2 
        m=m+1 
        A(m,m)=Hm(i,i) 
       end do 
!      write(6,'(10f8.3)')(A(n,n),n=1,jm1b)                               
       n=0 
       do k=j,-j+2,-2 
        n=n+1 
        m=n 
        do i=k-2,-j,-2 
        m=m+1 
         A(n,m)=Hm(k,i) 
!        write(6,'(2i4,2f10.3)')n,m,A(n,m)                              
        end do 
       end do 
                                                                        
       call jacHermite(jm1b,OUTJ,A,D,V,nrot) 
                                                                        
        m=0 
        do i=j,-j,-2 
        m=m+1 
        EE(i)=D(m) 
         n=0 
         do k=j,-j,-2 
          n=n+1 
          Evec(i,k)=V(m,n) 
!         write(6,'(2i4,2f10.3)')n,m,V(n,m)                             
         end do 
        end do 
!        do i=-j,j,2                                                    
!         write(6,'(10f8.3)')(Evec(i,k),k=-j,j,2)                       
!        end do                                                         
                                                                        
!        write(6,'(a,i6)')' nrot=',nrot                                 
!        m=0                                                            
!        do i=j,-j,-2                                                   
!         m=m+1                                                         
!         A(m,m)=Hm(i,i)                                                
!        end do                                                         
                                                                        
!        n=0                                                            
!        do k=j,-j+2,-2                                                 
!         n=n+1                                                         
!         m=n                                                           
!         do i=k-2,-j,-2                                                
!         m=m+1                                                         
!          A(n,m)=Hm(k,i)                                               
!          A(m,n)=conjg(A(n,m))                                         
!         write(6,'(2i4,2f10.3)')n,m,A(n,m)                             
!         end do                                                        
!        end do                                                         
                                                                        
!        do i=1,jm1b                                                      
!         do j=1,jm1b                                                     
!          hc=(0.,0.)                                                   
!          do n=1,jm1b                                                    
!           do m=1,jm1b                                                   
!            hc=hc+ conjg(V(n,i))*A(n,m)*V(m,j)                         
!           end do                                                      
!          end do                                                       
!          write(6,'(a,2i3,a,2f12.3)')' h(',i,j,')=',hc                 
!         end do                                                        
!        end do                                                         
                                                                        
       else 
!       --------------- integral spin ------------------------          
        m=0 
        do i=j,-j,-1 
         m=m+1 
         A(m,m)=Hm(i,i) 
        end do 
                                                                        
        n=0 
        do k=j,-j+1,-1 
         n=n+1 
         m=n 
         do i=k-1,-j,-1 
         m=m+1 
          A(n,m)=Hm(k,i) 
!         write(6,'(2i4,2f10.3)')n,m,A(n,m)                             
         end do 
        end do 
                                                                        
        call jacHermite(jm1b,OUTJ,A,D,V,nrot) 
                                                                        
        m=0 
        do i=j,-j,-1 
         m=m+1 
         EE(i)=D(m) 
         n=0 
         do k=j,-j,-1 
          n=n+1 
          Evec(i,k)=V(m,n) 
!         write(6,'(2i4,2f10.3)')n,m,V(n,m)                             
         end do 
        end do 
       end if 
!     eigenstates are |J>= Sum; i U(iJ)*|i>  ;  Evec=U+                 
!     U+HU is diagonal                                                  
!     <I|H|J> = Sum; i,k conjg(U(kI))*U(iJ)*<k|H|i>                     
!     <I|H|J> = Sum; i,k U(Ik)*<k|H|i>*U(iJ)                            
!     <I|H|J> = Sum; i,k Evec(I,k)*<k|H|i>*Evec(i,J)+                   
                                                                        
                                                                        
!      write(6,'(a,i6)')' nrot=',nrot                                   
!      m=0                                                              
!      do i=j,-j,-2                                                     
!       m=m+1                                                           
!       A(m,m)=Hm(i,i)                                                  
!      end do                                                           
                                                                        
!      n=0                                                              
!      do k=j,-j+2,-2                                                   
!       n=n+1                                                           
!       m=n                                                             
!       do i=k-2,-j,-2                                                  
!       m=m+1                                                           
!        A(n,m)=Hm(k,i)                                                 
!        A(m,n)=conjg(A(n,m))                                           
!       write(6,'(2i4,2f10.3)')n,m,A(n,m)                               
!       end do                                                          
!      end do                                                           
                                                                        
!      do i=1,jm1b                                                        
!       do j=1,jm1b                                                       
!        hc=(0.,0.)                                                     
!        do n=1,jm1b                                                      
!         do m=1,jm1b                                                     
!          hc=hc+ conjg(V(n,i))*A(n,m)*V(m,j)                           
!         end do                                                        
!        end do                                                         
!        write(6,'(a,2i3,a,2f12.3)')' h(',i,j,')=',hc                   
!       end do                                                          
!      end do                                                           
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine symbol3j(b_integer,je,jg,Vje_1_jg,Vje_2_jg,wpje,wpjg)
      implicit none 
      logical, intent(in):: b_integer 
      integer, intent(in):: je,jg 
      real,intent(out),dimension(-je:je,-1:1,-jg:jg):: Vje_1_jg 
      real,intent(out),dimension(-je:je,-2:2,-jg:jg):: Vje_2_jg
      real,intent(out),dimension(-je:je):: wpje
      real,intent(out),dimension(-jg:jg):: wpjg
      integer   i,j,Lp,M,mj 
      real      aje,ajg,hLJe,em,gm,clebsch 
                                                                        
      if(b_integer) then 
!      integer spin                                                     
       Lp=1 
       hLJe=sqrt(float(2*Lp+1))/sqrt(float(2*je+1))*(-1.)**Lp 
       ajg=float(jg) 
       aje=float(je) 
       do i=-je,je,1 
        em=float(i) 
        do j=-jg,jg,1 
         gm=float(j) 
         do M=-Lp,Lp 
          Vje_1_jg(i,M,j)=clebsch(float(Lp),float(M),ajg,gm,aje,em)*hLJe 
         end do 
        end do 
       end do 
                                                                        
       Lp=2 
       hLJe=sqrt(float(2*Lp+1))/sqrt(float(2*je+1))*(-1.)**Lp 
       ajg=float(jg) 
       aje=float(je) 
       do i=-je,je,1 
        em=float(i) 
        do j=-jg,jg,1 
         gm=float(j) 
         do M=-Lp,Lp 
          Vje_2_jg(i,M,j)=clebsch(float(Lp),float(M),ajg,gm,aje,em)*hLJe 
         end do 
        end do 
       end do 
!      write(6,'(a,f4.1,i3,f4.1,4x,4i3)')                               
!    & '...aje,La,ajg je,Lp,jg,jge=',aje,La,ajg,je,Lp,jg,jge            
!      <jm+1|S+|jm> matrix elements                                     
       do mj=-jg,jg,1 
        wpjg(mj)=sqrt(float((jg+mj+1)*(jg-mj))) 
       end do 
       do mj=-je,je,1 
        wpje(mj)=sqrt(float((je+mj+1)*(je-mj))) 
       end do 
                                                                        
      else 
!      half integer spin                                                
       Lp=1 
       hLJe=sqrt(float(2*Lp+1))/sqrt(float(je+1))*(-1.)**Lp 
       ajg=float(jg)/2. 
       aje=float(je)/2. 
       do i=-je,je,2 
        em=float(i)/2. 
        do j=-jg,jg,2 
         gm=float(j)/2. 
         do M=-Lp,Lp 
          Vje_1_jg(i,M,j)=clebsch(float(Lp),float(M),ajg,gm,aje,em)*hLJe
!         if(M.eq.0) write(6,'(a,i2,a3,i2,a,f15.4)')' Vje_1_jg(',i,',0,',j,')=', &
!          Vje_1_jg(i,M,j)      
         end do 
        end do 
       end do 
       Lp=2 
       hLJe=sqrt(float(2*Lp+1))/sqrt(float(je+1))*(-1.)**Lp 
       ajg=float(jg)/2. 
       aje=float(je)/2. 
       do i=-je,je,2 
        em=float(i)/2. 
        do j=-jg,jg,2 
         gm=float(j)/2. 
         do M=-Lp,Lp 
          Vje_2_jg(i,M,j)=clebsch(float(Lp),float(M),ajg,gm,aje,em)*hLJe 
!         write(6,'(a,f15.4)')' Vje_L_jg(i,M,j)=', Vje_L_jg(i,M,j)      
         end do 
        end do 
       end do 
!      write(6,'(a,2(f4.1,i3,f4.1,4x),i3)')                             
!    & '...aje,La,ajg je,Lp,jg,jge=',aje,La,ajg,a_je,Lp,a_jg,jge        
                                                                        
       do mj=-jg,jg,2 
        wpjg(mj)=sqrt(float((jg+mj+2)*(jg-mj)))/2. 
       end do 
       do mj=-je,je,2 
        wpje(mj)=sqrt(float((je+mj+2)*(je-mj)))/2. 
       end do 
      end if 
                                                                        
      return 
      END                                           
                                                                        
      subroutine sphere(iset,isym,b_vector,iOM,phih,tetah) 
      implicit none 
      integer, intent(in) :: iset,isym 
      logical, intent(in) :: b_vector 
      integer, intent(out):: iOM
      real,    intent(out), dimension(6144):: phih,tetah 
                                                                        
      integer   isym1,isym2,nkl,npt,i,k,j,m,l,in,inv,isy,kk,isetp 
      real      arcos,                                                 &
                alpha,beta,gamma,tet,ph,h,snt                           
      integer,dimension(24) :: nel(24)
      real,dimension(3,3,24):: mat
      real,dimension(3,3)   :: tritra,hmat
      real,dimension(3)     :: vecx,vecy,vecz,vx,vy,vz
      real,dimension(3,128) :: eh
      integer,parameter     :: C4maxsym2=4, C3maxsym2=4 
      real,parameter:: pi=3.14159265, rad=pi/180.0,                    &
                       sq2r=1.0/sqrt(2.0), sq3r=1.0/sqrt(3.0) 
                                                                         
                                                                        
!     symmetry of the hamiltonian (subgroup of O)                       
!     The nd.. and nc2y arrays list the 1-element and one of the        
!     generating element of the right cosets.
                           
!     nd4/3,1,5,8/                           D4 (C4z,C4x*,...,C2xy)
!     nd4/3,1,2,5/                           D4 (C4y,C4x*,...,C2xz)
!     nd4/3,1,2,8/                           D4 (C4x,C4z*,...,C2yz)
!     nd2/6,1,2,5,8,17,18/                   D2 (C4z*,C4y*,C4x*)
!     nd2/6,1,2,5,7,8,10/                    D2 (C4z*,C2xy,C2-xy)
!     nd2/6,1,2,3,4,5,7/                     D2 (C4y*,C2xz,C2-xz)
!     nd2/6,1,2,3,4,8,10/                    D2 (C4x*,C2yz,C2-yz)
!     nc2/12,1,2,3,4,5,7,8,13,17,18,20,21/   C2 (C4y*)
!
!     nd3/4,1,2,3,4/                         D3 (C3Z, C2Y)
!     nc2y/12,1,2,3,4,5,7,8,10,13,14,15,16/  C2 (C2Y)
!     nC4zXZ/6,1,5,6,7,8,10/                 C4 (C4zXZ,...,C4zXZ**) 
!                                                                        
      integer,parameter,dimension(0:3) :: nd4=(/3,1,5,8/) 
      integer,parameter,dimension(0:6) :: nd2=(/6,1,2,5,8,17,18/) 
      integer,parameter,dimension(0:12):: &
                          nc2=(/12,1,2,3,4,5,7,8,13,17,18,20,21/) 
      integer,parameter,dimension(0:4) :: nd3=(/4,1,2,3,4/) 
      integer,parameter,dimension(0:12):: & 
                          nc2y=(/12,1,2,3,4,5,7,8,10,13,14,15,16/) 
      integer,parameter,dimension(0:6) :: nC4zXZ=(/6,1,5,6,7,8,10/) 
                                                                        
!     Directions  whi(teta,phi)  for the integration                    
!     over the sphere.                                                  
!     Optimized values are calculated by K. Knese and H. Spiering       
                                                                        
!     definition of isym (spezified by the calling routine):            
!     C4 || z-axis                          C3 || z-axis                
!     C1 (24)      isym=10                 C1  (24)      isym=20        
!     O  ( 1)           11                 O   ( 1)           21        
!     D4 ( 3)      isym=12                 D3  ( 4)           22        
!     D2 ( 6)           13                 C2  (12)           23        
!     C2 (12)           14                 C4   (6)           24        
                                                                        
!     iOM  (i-Omega) number of points, equal weights                    
                                                                        
!     npt: number of points on 1/48 sphere,  npt=2**(iset+1)            
                                                                        
!   iset=1   npt=1                                                      
     real,parameter,dimension(1:2):: wh1=(/0.589,0.600/) 
                                                                        
!   iset=2,  npt=4                                                      
     real,parameter,dimension(1:8):: wh4=(/0.50931527,0.50792264,      &
     0.27489180,0.37415606,0.76289238,0.61459026,0.66616440,0.19291352/)
                                                                        
!   iset=3,   npt=8                                                     
     real,parameter,dimension(1:16):: &
          wh8=(/0.45014353,0.59730703,0.36578153,0.23969338,           &
     0.62724937,0.62785053,0.70269323,0.14007076,0.54217478,0.21585054,&
     0.19518280,0.41244099,0.73632017,0.41330862,0.81652321,0.67248618/)
                                                                        
!   iset=4, npt=16                                                      
     real,parameter,dimension(1:32):: wh16=(/0.44673522,0.65209063,    &
     0.39882402,0.37679617,0.66592311,0.50161547,0.72801832,0.10382966,&
     0.53239609,0.41141732,0.28698129,0.59693000,0.75673269,0.33122264,&
     0.79638500,0.53217095,0.58130750,0.67222854,0.28851947,0.18442790,&
     0.72069964,0.69437716,0.59086681,0.10398588,0.45959846,0.13273056,&
     0.14011330,0.39225235,0.64118008,0.28631739,0.85637326,0.70762098/)
                                                                        
!   iset=5  npt=32                                                      
     real,parameter,dimension(1:64):: &
        wh32=(/0.64071190,0.57645950,0.43123850,0.29009320,            &
     0.68319750,0.33438050,0.64283800,0.06647810,0.60681060,0.41737370,&
     0.54348980,0.53527600,0.49121940,0.69436360,0.74206620,0.60510160,&
     0.84010800,0.61987350,0.18823200,0.21923990,0.78556260,0.72596070,&
     0.59067880,0.24252720,0.36540130,0.11822190,0.34844340,0.40180900,&
     0.67767340,0.18925870,0.77554080,0.36778110,0.58697670,0.70703960,&
     0.27727140,0.18847500,0.68505590,0.71814090,0.55002870,0.09153870,&
     0.46414670,0.10052610,0.09804880,0.40776720,0.51761790,0.33132110,&
     0.88470430,0.73266380,0.75839300,0.22549150,0.21570320,0.59234190,&
     0.30300640,0.63100620,0.70765100,0.47355060,0.80387460,0.49811190,&
     0.74295690,0.06978730,0.39446290,0.67054710,0.45089600,0.49737200/)
                                                                        
!   iset=6  npt=64                                                      
     real,parameter,dimension(1:128):: wh64=(/0.63796252,0.53536674,   &
     0.43132552,0.25423716,0.66434956,0.34897385,0.63427965,0.05507200,&
     0.61596048,0.41967759,0.52887425,0.60610974,0.49053477,0.71922206,&
     0.70652064,0.55807979,0.80360321,0.66266284,0.19304277,0.19332170,&
     0.76608774,0.74184447,0.55313133,0.20711391,0.38654876,0.08285910,&
     0.30415234,0.31653168,0.61453987,0.16012202,0.79721312,0.41374436,&
     0.62728671,0.73358423,0.36657497,0.24368229,0.66504418,0.64140135,&
     0.51225205,0.06519040,0.31838616,0.09815862,0.06909730,0.41077964,&
     0.49712415,0.32275885,0.90530416,0.74865003,0.76658952,0.22685795,&
     0.21717801,0.63759705,0.32314606,0.51268954,0.72964951,0.38239621,&
     0.77518581,0.57461502,0.75500166,0.04699499,0.35152909,0.69872575,&
     0.46270878,0.57649591,0.59642637,0.62597909,0.44453941,0.41853262,&
     0.81864237,0.50299907,0.69228551,0.15725422,0.55436258,0.37081089,&
     0.37994344,0.40647581,0.71546056,0.27639648,0.84380538,0.58888644,&
     0.57134376,0.50592583,0.24569803,0.40726979,0.73434775,0.65349403,&
     0.75604333,0.13910419,0.49104284,0.19158298,0.13080068,0.22909680,&
     0.65638496,0.23961491,0.87245581,0.67109409,0.55853163,0.72777777,&
     0.25347990,0.12665297,0.69651588,0.73818578,0.57187492,0.06495971,&
     0.44776407,0.07780694,0.15511034,0.59363643,0.59926215,0.29188063,&
     0.83571615,0.74475490,0.78011876,0.32155618,0.50746948,0.46897202,&
     0.28191180,0.67261738,0.68296148,0.45638684,0.75043819,0.48129129,&
     0.69408491,0.05420525,0.42327717,0.71275927,0.39666205,0.56559666/)
                                                                        
!   iset=7  npt=128                                                     
     real,parameter,dimension(1:256)::  &
         wh128=(/0.67050290,0.61282610,0.48391970,0.24785680,          &
     0.69689350,0.30456670,0.61363770,0.03812250,0.66928050,0.42315660,&
     0.50950930,0.56013640,0.45057980,0.73327000,0.72396550,0.62350130,&
     0.84768110,0.70053150,0.23324840,0.29368850,0.75128880,0.69010590,&
     0.56456020,0.27758250,0.36164060,0.18813310,0.36034330,0.33033460,&
     0.68710530,0.09008540,0.79344900,0.35069060,0.63445610,0.74894360,&
     0.40166240,0.26732920,0.65874330,0.67974170,0.54354150,0.12120870,&
     0.33681580,0.07318720,0.09108610,0.54076460,0.52264390,0.31170490,&
     0.89592780,0.70518090,0.72720200,0.19075880,0.20894070,0.45764660,&
     0.34126540,0.57795870,0.75584090,0.39519840,0.80487640,0.58187560,&
     0.76507620,0.09197010,0.35993360,0.71985180,0.47748480,0.63947290,&
     0.61442060,0.59795630,0.44854860,0.42381200,0.81978070,0.47275870,&
     0.60728430,0.24180890,0.58111580,0.44630160,0.40592960,0.38519000,&
     0.68762450,0.23155610,0.82501750,0.64173190,0.63284990,0.47620550,&
     0.25238410,0.51098920,0.77509270,0.63354460,0.76926130,0.15873270,&
     0.49576360,0.13970320,0.11181730,0.19033350,0.65040310,0.26981800,&
     0.85414490,0.59124070,0.57013370,0.66035070,0.27690100,0.22426730,&
     0.72889670,0.75214290,0.56671790,0.04147380,0.47299710,0.05209460,&
     0.16794770,0.38244340,0.61143530,0.32277650,0.87161580,0.75714550,&
     0.78331720,0.28758850,0.54310210,0.49514530,0.22555590,0.68356940,&
     0.68374870,0.49377820,0.76975510,0.45883750,0.72573650,0.11922250,&
     0.43131460,0.62505610,0.41557770,0.50840510,0.64937260,0.54759890,&
     0.40929930,0.15781030,0.65827610,0.34867440,0.66222070,0.03287810,&
     0.62038820,0.40086740,0.52399800,0.65116060,0.49613330,0.73757630,&
     0.70255790,0.56008600,0.79925390,0.69576790,0.20107320,0.12800860,&
     0.77595840,0.75397790,0.52764260,0.21309610,0.38208280,0.05836410,&
     0.32614470,0.42042810,0.64038110,0.10745030,0.80554150,0.41231200,&
     0.58727730,0.74519920,0.32083610,0.24758130,0.61467060,0.67262690,&
     0.51866300,0.04393740,0.29396580,0.07751370,0.04866540,0.37280360,&
     0.48332240,0.35897110,0.92000360,0.75954530,0.77500880,0.22351860,&
     0.17990620,0.66234960,0.29735010,0.55203310,0.70668450,0.37529250,&
     0.75454530,0.57142910,0.76118960,0.03065280,0.31539570,0.71096360,&
     0.46148630,0.53636630,0.55989470,0.57900320,0.44401370,0.29774320,&
     0.78636590,0.52078030,0.63517530,0.18413320,0.53022810,0.40558420,&
     0.37037040,0.46985620,0.73509500,0.26069540,0.83602680,0.53245390,&
     0.59540510,0.52526850,0.28283240,0.38179190,0.70432910,0.68407180,&
     0.68002900,0.16225090,0.45228860,0.17178010,0.15688830,0.13550300,&
     0.57434520,0.18776060,0.87406790,0.64876980,0.54162850,0.74112360,&
     0.24537610,0.08801680,0.68200380,0.75059850,0.59501910,0.11728470,&
     0.42964940,0.05476270,0.13502290,0.60627190,0.57040280,0.36378110,&
     0.82353760,0.75565680,0.74468360,0.32913840,0.49409160,0.46347000,&
     0.27053210,0.69931900,0.71926570,0.44336370,0.73543600,0.50839710,&
     0.71513670,0.03420950,0.40503050,0.72764940,0.38569990,0.60504190/)
                                                                        
      isetp=abs(iset)
      ! decission z||C4 or C3
      if(isym.eq.0)then                                                                  
       isym1=abs(isym+10)/10                                                
       isym2=abs(isym+10)-10*isym1                                          
      else
       isym1=abs(isym)/10                                                
       isym2=abs(isym)-10*isym1   
      end if
!     iset>0 (H external=0) does not need isym, isym =0 -> return with OM=0
!     which leads to an error message
      if(isetp.eq.0) then                                               
       iOM=1                                                            
       phih(1) =0.                                                      
       tetah(1)=0.                                                      
       return                                                           
      end if                                                            
                                                                        
      iOM=0                                                             
      if(isetp.gt.7.or.isym1.lt.1.or.isym1.gt.2) return                 
                                                                        
      if(isym1.eq.1)then                                                
       if(isym2.gt.C4maxsym2) return                                    
!------------- C4 || z ------------------------------------             
       if(isym2.eq.0)then                                               
        nkl=24                                                          
        do i=1,nkl                                                      
         nel(i)=i                                                       
        end do                                                          
       else if(isym2.eq.1)then                                          
        nkl=1                                                           
        nel(1)=1                                                        
       else if(isym2.eq.2)then                                          
        nkl=nd4(0)                                                      
        do i=1,nkl                                                      
         nel(i)=nd4(i)                                                  
        end do                                                          
       else if(isym2.eq.3)then                                          
        nkl=nd2(0)                                                      
        do i=1,nkl                                                      
         nel(i)=nd2(i)                                                  
        end do                                                          
       else if(isym2.eq.4)then                                          
        nkl=nc2(0)                                                      
        do i=1,nkl                                                      
         nel(i)=nc2(i)                                                  
        end do                                                          
!       else if(isym2.eq.C4maxsym2)then                                 
!        nkl=nAB(0)                                                     
!        do i=1,nkl                                                     
!         nel(i)=nAB(i)                                                 
!        end do                                                         
       end if                                                           
      else if(isym1.eq.2)then                                           
       if(isym2.gt.C3maxsym2) return                                    
!------------- C3 || z ------------------------------------             
       if(isym2.eq.0)then                                               
        nkl=24                                                          
        do i=1,nkl                                                      
         nel(i)=i                                                       
        end do                                                          
       else if(isym2.eq.1)then                                          
        nkl=1                                                           
        nel(1)=1                                                        
       else if(isym2.eq.2)then                                          
        nkl=nd3(0)                                                      
        do i=1,nkl                                                      
         nel(i)=nd3(i)                                                  
        end do                                                          
       else if(isym2.eq.3)then                                          
        nkl=nc2y(0)                                                     
        do i=1,nkl                                                      
         nel(i)=nc2y(i)                                                 
        end do                                                          
       else if(isym2.eq.4)then                                          
        nkl=nC4zXZ(0)                                                   
        do i=1,nkl                                                      
         nel(i)=nC4zXZ(i)                                               
        end do                                                          
       end if                                                           
      end if                                                            
                                                                        
      iOM=2**isetp                                                      
      if(isetp.eq.1)iOM=1                                               
      iOM=iOM*nkl                                                       
      if(isym.lt.0)  iOM=iOM*2                                          
      if(iset.lt.0) return                                              
                                                                        
      npt=2**isetp                                                      
      if(isetp.eq.1)npt=1                                               

      goto(11,12,13,14,15,16,17) isetp                                  
                                                                        
   11 tetah(1)=wh1(1)                                                   
      phih(1) =wh1(2)                                                   
      goto 18                                                           
   12 do i=1,npt                                                        
       tetah(i)=wh4(2*i-1)                                              
       phih(i) =wh4(2*i)                                                
      end do                                                            
      goto 18                                                           
   13 do i=1,npt                                                        
       tetah(i)=wh8(2*i-1)                                              
       phih(i) =wh8(2*i)                                                
      end do                                                            
      goto 18                                                           
   14 do i=1,npt                                                        
       tetah(i)=wh16(2*i-1)                                             
       phih(i) =wh16(2*i)                                               
      end do                                                            
      goto 18                                                           
   15 do i=1,npt                                                        
       tetah(i)=wh32(2*i-1)                                             
       phih(i) =wh32(2*i)                                               
      end do                                                            
      goto 18                                                           
   16 do i=1,npt                                                        
       tetah(i)=wh64(2*i-1)                                             
       phih(i) =wh64(2*i)                                               
      end do                                                            
      goto 18                                                           
   17 continue                                                          
      do i=1,npt                                                        
       tetah(i)=wh128(2*i-1)                                            
       phih(i) =wh128(2*i)                                              
      end do                                                            
   18 continue                                                          
                                                                        
      do i=1,npt                                                        
       snt=sin(tetah(i))                                                
       eh(1,i)=snt*cos(phih(i))                                         
       eh(2,i)=snt*sin(phih(i))                                         
       eh(3,i)=cos(tetah(i))                                            
      end do                                                            
                                                                        
                                                                        
!     rotation matrices of the cubic group O                            
                                                                        
         do k=1,24                                                      
          do i=1,3                                                      
           do j=1,3                                                     
            mat(i,j,k)=0.0                                              
           end do                                                       
          end do                                                        
         end do                                                         
                                                                        
                                                                        
!  1       1-element                                                    
          do i=1,3                                                      
           mat(i,i,1)=1.0                                               
          end do                                                        
!  2       c4-rotation z-axis                                           
          mat(1,2,2)=-1.                                                
          mat(2,1,2)=1.                                                 
          mat(3,3,2)=1.                                                 
!  3       C4z**2                                                       
          mat(1,1,3)=-1.                                                
          mat(2,2,3)=-1.                                                
          mat(3,3,3)=1.                                                 
!  4       C4z**3                                                       
          mat(1,2,4)=1.                                                 
          mat(2,1,4)=-1.                                                
          mat(3,3,4)=1.                                                 
!  5       C4x-rotation x-axis                                          
          mat(1,1,5)=1.                                                 
          mat(2,3,5)=-1.                                                
          mat(3,2,5)=1.                                                 
!  6       C4x**2                                                       
          mat(1,1,6)=1.                                                 
          mat(2,2,6)=-1.                                                
          mat(3,3,6)=-1.                                                
!  7       C4x**3                                                       
          mat(1,1,7)=1.                                                 
          mat(2,3,7)=1.                                                 
          mat(3,2,7)=-1.                                                
!  8       C4y-rotation y-axis                                          
          mat(1,3,8)=1.                                                 
          mat(2,2,8)=1.                                                 
          mat(3,1,8)=-1.                                                
!  9       C4y**2                                                       
          mat(1,1,9)=-1.                                                
          mat(2,2,9)=1.                                                 
          mat(3,3,9)=-1.                                                
!  10      C4y**3                                                       
          mat(1,3,10)=-1.                                               
          mat(2,2,10)=1.                                                
          mat(3,1,10)=1.                                                
!  11      C2xy-rotation xy-axis                                        
          mat(1,2,11)=1.                                                
          mat(2,1,11)=1.                                                
          mat(3,3,11)=-1.                                               
!  12      C2-xy-rotation -xy-axis                                      
          mat(1,2,12)=-1.                                               
          mat(2,1,12)=-1.                                               
          mat(3,3,12)=-1.                                               
!  13      C2xz-rotation xz-axis                                        
          mat(1,3,13)=1.                                                
          mat(2,2,13)=-1.                                               
          mat(3,1,13)=1.                                                
!  14       C2-xz-rotation -xz-axis                                     
          mat(1,3,14)=-1.                                               
          mat(2,2,14)=-1.                                               
          mat(3,1,14)=-1.                                               
!  15       C2yz-rotation yz-axis                                       
          mat(1,1,15)=-1.                                               
          mat(2,3,15)=1.                                                
          mat(3,2,15)=1.                                                
!  16       C2-yz-rotation -yz-axis                                     
          mat(1,1,16)=-1.                                               
          mat(2,3,16)=-1.                                               
          mat(3,2,16)=-1.                                               
!  17      C3-rotation {1,1,1}-axis                                     
          mat(1,3,17)=1.                                                
          mat(2,1,17)=1.                                                
          mat(3,2,17)=1.                                                
!  18      C3**2                                                        
          mat(1,2,18)=1.                                                
          mat(2,3,18)=1.                                                
          mat(3,1,18)=1.                                                
!  19      C3-rotation {-1,1,1}-axis                                    
          mat(1,2,19)=-1.                                               
          mat(2,3,19)=1.                                                
          mat(3,1,19)=-1.                                               
!  20      C3**2                                                        
          mat(1,3,20)=-1.                                               
          mat(2,1,20)=-1.                                               
          mat(3,2,20)=1.                                                
!  21       C3-rotation {1,-1,1}-axis                                   
          mat(1,2,21)=-1.                                               
          mat(2,3,21)=-1.                                               
          mat(3,1,21)=1.                                                
!  22      C3**2                                                        
          mat(1,3,22)=1.                                                
          mat(2,1,22)=-1.                                               
          mat(3,2,22)=-1.                                               
!  23      C3-rotation {-1,-1,1}-axis                                   
          mat(1,3,23)=-1.                                               
          mat(2,1,23)=1.                                                
          mat(3,2,23)=-1.                                               
!  24      C3**2                                                        
          mat(1,2,24)=1.                                                
          mat(2,3,24)=-1.                                               
          mat(3,1,24)=-1.                                               
                                                                        
        if(isym1.eq.2)then                                              
!--------C3 || z-axis --------------                                    
!        trigonal coordinate system                                     

         tritra(1,1)=sq2r*sq3r                                            
         tritra(1,2)=-sq2r                                               
         tritra(1,3)=sq3r                                                
         tritra(2,1)=sq2r*sq3r                                           
         tritra(2,2)=sq2r                                                
         tritra(2,3)=sq3r                                                
         tritra(3,1)=-sq3r/sq2r                                           
         tritra(3,2)=0.                                                 
         tritra(3,3)=sq3r                                                
                                                                        
!        transformation of the matrices to the koordinate system z={1,1,
         do m=1,nkl                                                     
           l=nel(m)                                                     
           do i=1,3                                                     
           do j=1,3                                                     
            h=0.                                                        
            do k=1,3                                                    
            do kk=1,3                                                   
             h=h+tritra(k,i)*mat(k,kk,l)*tritra(kk,j)                   
            end do                                                      
            end do                                                      
            hmat(i,j)=h                                                 
           end do                                                       
           end do                                                       
           do i=1,3                                                     
           do j=1,3                                                     
            mat(i,j,l)=hmat(i,j)                                        
           end do                                                       
           end do                                                       
         end do                                                         
                                                                        
!        transformation of the vectors to the trigonal system           
         do k=1,npt                                                     
           do i=1,3                                                     
            h=0.                                                        
            do j=1,3                                                    
             h=h+eh(j,k)*tritra(j,i)                                    
            end do                                                      
            vecz(i)=h                                                   
           end do                                                       
           do i=1,3                                                     
            eh(i,k)=vecz(i)                                             
           end do                                                       
         end do                                                         
                                                                        
        end if                                                          
                                                                        
     if(b_vector) then                                                 
!      calculation of polar angles of vectors                           
       iOM=0                                                            
       do k=1,npt                                                       
        do m=1,nkl                                                      
          iOM=iOM+1                                                     
          l=nel(m)                                                      
          do j=1,3                                                      
           h=0.                                                         
           do i=1,3                                                     
            h=h+eh(i,k)*mat(i,j,l)                                      
           end do                                                       
           vecz(j)=h                                                    
          end do
!          vhh=vecz
!          do j=1,3                                                      
!           h=0.                                                         
!           do i=1,3                                                     
!            h=h+vhh(i)*mat(i,j,1)                                      
!           end do                                                       
!           vecz(j)=h                                                    
!          end do
              
          snt=sqrt(1.-vecz(3)**2)/vecz(3)                               
          tet=atan(snt)                                                 
          if(snt.lt.0.) tet=pi+tet                                      
          tetah(iOM)=tet                                                
          ph=atan(vecz(2)/vecz(1))                                      
          if(vecz(1).lt.0.) ph=ph+pi                                    
          phih(iOM)=ph                                                  
          if(isym.lt.0)then                                             
           iOM=iOM+1                                                    
           tetah(iOM)=pi-tet                                            
           phih(iOM)=ph+pi                                              
          end if                                                        
!          write(6,'(i3,3f6.2,5x,2f6.1)')iOM, vecz(1),vecz(2),vecz(3),  &
!                          tetah(iOM)/rad, phih(iOM)/rad                            
!         write(6,'(i3,a,3f6.2,a,3f9.3)')l,' v(IOM)=',  &
!                 cos(phih(iOM))*sin(tetah(iOM))-vecz(1),         &
!                 sin(phih(iOM))*sin(tetah(iOM))-vecz(2),   &
!                 cos(tetah(iOM))-vecz(3),                   &
!                 '  vecz=',vecz     
        end do                                                          
       end do                                                           
     else                                                              
!      calculation of a orthonormal sytem with vector eh || z           
!      and the y-vector is choosen to be in the xy plane (-x,y).        
!      The coordinate system is transformed defining 3 Euler            
!      angles.                                                          
!      This way the group relations can be tested and used.             
       in=1                                                             
       if(isym.lt.0) in=2                                               
       iOM=0                                                            
       do k=1,npt                                                       
        inv=-1                                                          
        do isy=1,in                                                     
         inv=-inv                                                       
         do i=1,3                                                       
          vecz(i)=eh(i,k)*inv                                           
         end do                                                         
                                                                        
         h=sqrt(vecz(1)**2+vecz(2)**2)                                  
         vecy(1)=-vecz(2)/h                                             
         vecy(2)=vecz(1)/h                                              
         vecy(3)=0.                                                     
         !        vecx = vecy x vecz   ,  vecy* vecz =0
         call crospr(vecy,vecz,vecx)                                    
                                                                        
         do m=1,nkl                                                     
           iOM=iOM+1                                                    
           l=nel(m)                                                     
                                                                        
           do j=1,3                                                     
            h=0.                                                        
            do i=1,3                                                    
             h=h+vecz(i)*mat(i,j,l)                                     
            end do                                                      
            vz(j)=h                                                     
           end do                                                       
           do j=1,3                                                     
            h=0.                                                        
            do i=1,3                                                    
             h=h+vecy(i)*mat(i,j,l)                                     
            end do                                                      
            vy(j)=h                                                     
           end do                                                       
           do j=1,3                                                     
            h=0.                                                        
            do i=1,3                                                    
             h=h+vecx(i)*mat(i,j,l)                                     
            end do                                                      
            vx(j)=h                                                     
           end do                                                       
           beta=arcos(vz(3))                                            
           snt=sqrt(1.-vz(3)**2)                                        
           alpha=arcos(vz(1)/snt)                                       
           if(vz(2).lt.0.0) alpha=2.0*pi-alpha                          
           gamma=arcos(-vx(3)/snt)                                      
           if(vy(3).lt.0.0) gamma=2.0*pi-gamma                          
           phih(iOM)=alpha                                              
           tetah(iOM)=beta                                              
!          write(6,'(/,a,3f8.3,a1)') ' ex= (',vx,')'                      
!          write(6,'(a,3f8.3,a1)') ' ey= (',vy,')'                      
!          write(6,'(3i3,a,3f8.3,a1)')npt,in,iOM, ' ez= (',vz,')'                    
!          write(6,'(i2,a,3f12.4)')l,'al,be,ga=',alpha/rad,beta/rad
         end do                                                         
        end do                                                          
       end do                                                           
      end if                                                            
      return                                                            
                ! invers direction pi-theta,phi+2*pi
                ! return iOM for storage reservation 
                ! nkl                                                   
                ! in                                                    
      END                                           
                                                                        
      subroutine sym_equiv(ncase,maxloop,nloop,timeinvers,ctimeinv,d1,d2) 
      implicit none 
      integer, intent(in) :: ncase,maxloop
      real,    intent(in) :: timeinvers
      integer, intent(out):: nloop 
      complex, intent(out), dimension(-1:1,-1:1,maxloop):: d1
      complex, intent(out), dimension(-2:2,-2:2,maxloop):: d2 
      complex, intent(out), dimension(maxloop)  :: ctimeinv
      real,   dimension(-1:1,-1:1):: dr1
      real,   dimension(-2:2,-2:2):: dr2              
      real,   dimension(maxloop)  :: alpha,beta,gamma                  
      integer,dimension(maxloop)  :: isym

      real      fn,fm
      integer   m,n,j,i,k,itime,i0,nloop_p,ncasep
      character(len=8):: ch 
      logical   b_casep 
      real,parameter:: rad=atan(1.)/45. 
                                                                  
!                     sym_case  point group   tensor symmetry
!     iO4a/3,3,11,12/        1  D2(C2z,C2xy): general
!     iO4b/3,3,6,9/          2  D2(C2z,C2x):  general 
!     iO4c/5,2,5,7,8,10/     3  O :           C2z,C2-xy 
!     iO4d/1,3/              4  C2z=C4z*:     general  
!     iO4e/1,9/              5  C2y=C4y*:     general  
! 
!     iO3a/2,14,16/          6  D3:           C2Y  
!     iO3b/5,12,14,16,17,18/ 7  D3:           general       
!     iO3c/1,12/             8  C2Y:          general 
!     iO3d/3,2,3,4/          9  C4 :          C3 
!
!     iAXa/2,5,9/            10 C3z :         general      
!     iAXb/5,3,5,7,9,11/     11 C6z :         general

      integer,parameter,dimension(0:3):: iO4a=(/3,3,11,12/) 
      integer,parameter,dimension(0:3):: iO4b=(/3,3,6,9/) 
      integer,parameter,dimension(0:5):: iO4c=(/5,2,5,7,8,10/) 
      integer,parameter,dimension(0:1):: iO4d=(/1,3/) 
      integer,parameter,dimension(0:1):: iO4e=(/1,9/) 
      integer,parameter,dimension(0:2):: iO3a=(/2,14,16/) 
      integer,parameter,dimension(0:5):: iO3b=(/5,12,14,16,17,18/) 
      integer,parameter,dimension(0:1):: iO3c=(/1,12/) 
      integer,parameter,dimension(0:3):: iO3d=(/3,2,3,4/) 
      integer,parameter,dimension(0:2):: iAXa=(/2,5,9/) 
      integer,parameter,dimension(0:5):: iAXb=(/5,3,5,7,9,11/) 
                                                                        
!     Euler angles obtained with helproutine: group_O                   
                                                                        
                                           !  1    E                    
         real,parameter,dimension(1:72)::  &
          C_O4=(/  0.0,   0.0,   0.0,      &        !  1    E 
                  90.0,   0.0,   0.0,      &        !  2    C4z     
                 180.0,   0.0,   0.0,      &        !  3    C4z*    
                 270.0,   0.0,   0.0,      &        !  4    C4z**   
                 270.0,  90.0,  90.0,      &        !  5    C4x     
                 180.0, 180.0,   0.0,      &        !  6    C4x*    
                  90.0,  90.0, 270.0,      &        !  7    C4x**   
                   0.0,  90.0,   0.0,      &        !  8    C4y     
                   0.0, 180.0,   0.0,      &        !  9    C4y*    
                 180.0,  90.0, 180.0,      &        ! 10    C4y**   
                 270.0, 180.0,   0.0,      &        ! 11    C2xy    
                  90.0, 180.0,   0.0,      &        ! 12    C2-xy   
                   0.0,  90.0, 180.0,      &        ! 13    C2xz    
                 180.0,  90.0,   0.0,      &        ! 14    C2-xz   
                  90.0,  90.0,  90.0,      &        ! 15    C2yz    
                 270.0,  90.0, 270.0,      &        ! 16    C2-yz   
                   0.0,  90.0,  90.0,      &        ! 17    C3111   
                  90.0,  90.0, 180.0,      &        ! 18    C3111*  
                  90.0,  90.0,   0.0,      &        ! 19    C3-11   
                 180.0,  90.0,  90.0,      &        ! 20    C3-11*  
                 270.0,  90.0, 180.0,      &        ! 21    C31-1   
                   0.0,  90.0, 270.0,      &        ! 22    C31-1*  
                 180.0,  90.0, 270.0,      &        ! 23    C3--1   
                 270.0,  90.0,   0.0/)              ! 24    C3--1*  
                                                      

        real,parameter,dimension(1:72)::  &     
        C_O3=(/   0.0,   0.00,   0.0,     &         !  1    E   
                120.0,  70.53, 300.0,     &         !  2    C4zXZ  
                180.0, 109.47, 360.0,     &         !  3    C4zXZ* 
                240.0,  70.53,  60.0,     &         !  4    C4zXZ**
                240.0,  70.53, 180.0,     &         !  5    C4xYx  
                300.0, 109.47, 240.0,     &         !  6    C4xYx* 
                  0.0,  70.53, 300.0,     &         !  7    C4xYx**
                  0.0,  70.53,  60.0,     &         !  8    C4yYx  
                 60.0, 109.47, 120.0,     &         !  9    C4yYx* 
                120.0,  70.53, 180.0,     &         ! 10    C4yYx**
                  0.0,  70.53, 180.0,     &         ! 11    C2xyXZ 
                  0.0, 180.00,   0.0,     &         ! 12    C2Y    
                240.0,  70.53, 300.0,     &         ! 13    C2xz   
                120.0, 180.00,   0.0,     &         ! 14    C2-xz  
                120.0,  70.53,  60.0,     &         ! 15    C2yz   
                240.0, 180.00,   0.0,     &         ! 16    C2-yz  
                120.0,   0.00,   0.0,     &         ! 17    C3Z    
                240.0,   0.00,   0.0,     &         ! 18    C3Z*   
                 60.0, 109.47,   0.0,     &         ! 19    C3Yz   
                180.0, 109.47, 120.0,     &         ! 20    C3Yz*  
                180.0, 109.47, 240.0,     &         ! 21    C3z-Y  
                300.0, 109.47, 360.0,     &         ! 22    C3z-Y* 
                 60.0, 109.47, 240.0,     &         ! 23    C3Zz   
                300.0, 109.47, 120.0/)              ! 24    C3Zz*  
                                                      
 !    some spezial rotations                                             
        real,parameter,dimension(1:48)::  &                        
        C_AX=(/   0.0,   0.00,   0.0,     &          !  1    E
                 30.0,   0.00,   0.0,     &          !  2    C12     
                 60.0,   0.00,   0.0,     &          !  3    C6      
                 90.0,   0.00,   0.0,     &          !  4    C4      
                120.0,   0.00,   0.0,     &          !  5    C3      
                150.0,   0.00,   0.0,     &          !  6    C12**5  
                180.0,   0.00,   0.0,     &          !  7    C2      
                210.0,   0.00,   0.0,     &          !  8    C6**3   
                240.0,   0.00,   0.0,     &          !  9    C3**2   
                270.0,   0.00,   0.0,     &          ! 10    C12**9  
                300.0,   0.00,   0.0,     &          ! 11    C6**5   
                330.0,   0.00,   0.0,     &          ! 12    C12**11 
                  0.0,  180.0,   0.0,     &          ! 13    C4y*    
                270.0,  180.0,   0.0,     &          ! 14    C2xy    
                  0.0,   90.0, 180.0,     &          ! 15    C2xz    
                  90.0,  90.0,  90.0/)               ! 16    C2yz    
                                                    
      i0=ichar('0') 
      if(ncase.eq.0) then 
!      default value                                                    
       nloop=0 
       do n=1,maxloop 
        ctimeinv(n)=cmplx(1.0,0.0) 
       end do 
       return 
      end if 
                                                                        
      ncasep=abs(ncase) 
      b_casep=ncase.gt.0 
!                                                                       
!      write(6,'(a,5i7)')'sym_equiv ncase,timeinvers=',ncase,int(timeinvers)
!     sites are equivalent by rotations(timeinversion) about a single ax
!     the axes are defined in two coordinate systems C4||z and C3||z    
                                                                        
      nloop=0 
!----------------------  C4 || z  ---------------------------------     
                                        ! O4a                           
      if(ncasep.eq.1)then 
       nloop=iO4a(0) 
       if(b_casep)then 
        do j=1,nloop 
         isym(j)=iO4a(j) 
         i=(isym(j)-1)*3 
         alpha(j)=C_O4(i+1) 
         beta(j) =C_O4(i+2) 
         gamma(j)=C_O4(i+3) 
        end do 
       end if 
                                        ! O4b                           
      else if(ncasep.eq.2)then 
       nloop=iO4b(0) 
       if(b_casep)then 
        do j=1,nloop 
         isym(j)=iO4b(j) 
         i=(isym(j)-1)*3 
         alpha(j)=C_O4(i+1) 
         beta(j) =C_O4(i+2) 
         gamma(j)=C_O4(i+3) 
        end do 
       end if 
                                        ! O4c                           
      else if(ncasep.eq.3)then 
       nloop=iO4c(0) 
       if(b_casep)then 
        do j=1,nloop 
         isym(j)=iO4c(j) 
         i=(isym(j)-1)*3 
         alpha(j)=C_O4(i+1) 
         beta(j) =C_O4(i+2) 
         gamma(j)=C_O4(i+3) 
        end do 
       end if 
                                        ! O4d                           
      else if(ncasep.eq.4)then 
       nloop=iO4d(0) 
       if(b_casep)then 
        do j=1,nloop 
         isym(j)=iO4d(j) 
         i=(isym(j)-1)*3 
         alpha(j)=C_O4(i+1) 
         beta(j) =C_O4(i+2) 
         gamma(j)=C_O4(i+3) 
        end do 
       end if 
                                        ! O4e                           
      else if(ncasep.eq.5)then 
       nloop=iO4e(0) 
       if(b_casep)then 
        do j=1,nloop 
         isym(j)=iO4e(j) 
         i=(isym(j)-1)*3 
         alpha(j)=C_O4(i+1) 
         beta(j) =C_O4(i+2) 
         gamma(j)=C_O4(i+3) 
        end do 
       end if 
                                                                        
!----------------------  C3111 || z  ---------------------------------  
                                        ! O3a                           
      else if(ncasep.eq.6)then 
       nloop=iO3a(0) 
       if(b_casep)then 
        do j=1,nloop 
         isym(j)=iO3a(j) 
         i=(isym(j)-1)*3 
         alpha(j)=C_O3(i+1) 
         beta(j) =C_O3(i+2) 
         gamma(j)=C_O3(i+3) 
        end do 
       end if 
                                        ! O3b                           
      else if(ncasep.eq.7)then 
       nloop=iO3b(0) 
       if(b_casep)then 
        do j=1,nloop 
         isym(j)=iO3b(j) 
         i=(isym(j)-1)*3 
         alpha(j)=C_O3(i+1) 
         beta(j) =C_O3(i+2) 
         gamma(j)=C_O3(i+3) 
        end do 
       end if 
                                        ! O3c                           
      else if(ncasep.eq.8)then 
       nloop=iO3c(0) 
       if(b_casep)then 
        do j=1,nloop 
         isym(j)=iO3c(j) 
         i=(isym(j)-1)*3 
         alpha(j)=C_O3(i+1) 
         beta(j) =C_O3(i+2) 
         gamma(j)=C_O3(i+3) 
        end do 
       end if 
                                        ! O3d                           
      else if(ncasep.eq.9)then 
       nloop=iO3d(0) 
       if(b_casep)then 
        do j=1,nloop 
         isym(j)=iO3d(j) 
         i=(isym(j)-1)*3 
         alpha(j)=C_O3(i+1) 
         beta(j) =C_O3(i+2) 
         gamma(j)=C_O3(i+3) 
        end do 
       end if 
                                                                        
!----------------------  Cn || z  ---------------------------------     
                                         ! AXa                          
      else if(ncasep.eq.10)then 
       nloop=iAXa(0) 
       if(b_casep)then 
        do j=1,nloop 
         isym(j)=iAXa(j) 
         i=(isym(j)-1)*3 
         alpha(j)=C_AX(i+1) 
         beta(j) =C_AX(i+2) 
         gamma(j)=C_AX(i+3) 
        end do 
       end if 
                                         ! AXb                          
      else if(ncasep.eq.11)then 
       nloop=iAXb(0) 
       if(b_casep)then 
        do j=1,nloop 
         isym(j)=iAXb(j) 
         i=(isym(j)-1)*3 
         alpha(j)=C_AX(i+1) 
         beta(j) =C_AX(i+2) 
         gamma(j)=C_AX(i+3) 
        end do 
       end if 
!----------------------  one transformation------------------------     
      else if(ncasep.gt.100.and.ncasep.le.116)then 
       nloop=-1 
       i=(ncasep-101)*3 
       alpha(1)=C_AX(i+1) 
       beta(1) =C_AX(i+2) 
       gamma(1)=C_AX(i+3) 
      else if(ncasep.eq.200)then
         nloop=1
       call wigner(2,0.0,dr2)    
       do m=-2,2 
        do n=-2,2 
         d2(m,n,1)=dr2(m,n) 
        end do 
       end do
       call wigner(1,0.0,dr1) 
       do m=-1,1 
        do n=-1,1 
         d1(m,n,1)=dr1(m,n) 
        end do 
       end do
       ctimeinv(1)=cmplx(-1.0,0.0)
       goto 200
      end if
                                                                        
      if(nloop.eq.0)then 
       print'(a,i4,a)',' sym_case=',abs(ncase),' out of limits (put to zero)'
       do n=1,maxloop 
        ctimeinv(n)=cmplx(1.0,0.0) 
       end do 
       return 
      end if 
      if(.not.b_casep) return     !  b_casep=ncase.gt.0 
                                                                        
      nloop_p=abs(nloop) 
!     invers transformation according to eq.16 in euler.xdvi            
      do j=1,nloop_p 
!       write(6,'(a,3f12.3)')' al,be,ga=',alpha(j),beta(j),gamma(j)  
       call wigner(2,-beta(j)*rad,dr2) 
       do m=-2,2 
        do n=-2,2 
         fm=-float(n)*alpha(j)*rad 
         fn=-float(m)*gamma(j)*rad 
         d2(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dr2(m,n) 
        end do 
       end do 
       call wigner(1,-beta(j)*rad,dr1) 
       do m=-1,1 
        do n=-1,1 
         fm=-float(n)*alpha(j)*rad 
         fn=-float(m)*gamma(j)*rad 
         d1(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dr1(m,n) 
        end do 
       end do 
      end do 
                                                                        
      do m=1,nloop_p 
       ctimeinv(m)=cmplx(1.0,0.0) 
      end do 
      itime=timeinvers 
      if(timeinvers.gt.1999999.) then 
       print'(a,i8,a)','the number ',itime,' cannot be interpreted' 
       print'(a)','see the help for constant time_invers {he ci}' 
       print'(a)','constant time_invers is set to zero !' 
      end if 
      if(itime.eq.1) then 
       do m=1,nloop_p 
        ctimeinv(m)=cmplx(-1.0,0.0) 
       end do 
       goto 200 
      end if 
      call itoc8(ch,itime) 
       m=8 
      do while(ch(m:m).eq.' '.and.m.gt.1) 
       m=m-1 
      end do 
!      write(6,'(a,i10,2x,a8)')' itime,ch=',itime,ch                    
                                                                        
      do n=3,m,2 
       j=(ichar(ch(n:n))-i0)*10+ichar(ch(n+1:n+1))-i0 
       k=0 
       do i=1,nloop_p 
        if(j.eq.isym(i)) k=i 
!        write(6,'(a,2i3)')' number ',isymt(i),k                        
       end do 
       if(k.gt.0)then 
         ctimeinv(k)=cmplx(-1.0,0.0) 
       else 
        print'(a,i2,a,/,a)',' number ',j,                          &
          ' does not belong to the selected subgroup',                 &
         ' (see {he ci} of ci  ...__time_invers)'                      
       end if 
      end do 
!      write(6,'(10f5.0)')(real(ctimeinv(m)),m=1,nloop_p)               
  200 return 
      END                                           
