
MODULE compar
use glbconst , only : maxthss,maxc,maxp,maxpl,maxco,maxs,maxcom,icstrf,      &
                      maxfr1,maxfr2,maxvaco,maxscr,maxsto,maxcvsp,maxc_sp,   &
                      maxp_sp,maxthlv,MDBPLFT
implicit none
integer, parameter :: maxtheo=12,maxdimco=maxthss/2,maxmemth=12,icr=6,       &
                      maxcb=maxcom*icr+2*maxs,maxthsp=maxs*2,                &
                      maxpart=maxthss*maxs,                                  &
                      maxvca =2*(12*maxvaco+maxc),                            &
                      maxscrs=5+maxco*6+(14+maxthlv)*(maxthss+1)*maxs+        &
                              6*(maxs+1)+9*maxp+15*maxp+4*maxpl+              &
                              (maxp_sp+1)*maxs+16*maxpl+(maxc_sp+1)*maxs+     &
                              3*maxc+10*maxc+2*maxdimco*maxdimco+2*maxsto+    &
                              4*maxco+33*maxs+18*maxs*maxcvsp+                &
                              4*maxs*maxcvsp+2*maxs*(1+maxcvsp)+maxs+         &
                              maxvca*20+(maxthss+1)*17+maxs*maxfr1            
integer, parameter :: idumplot=2*MDBPLFT-maxscrs

! maxco    =     "     "    of correlation matrices
! maxprd   =  maximum number of storage for parameter products
! maxsto   =     "     "    of elements of the storage vector for the
!                           correlation matrices, average 8*8 matrix *maxco
! maxvaco  =  "     "       of elements (constants or parameter) taken over
!                           from frtheory or theory each call
! maxc     =  "     "       of theory constants
! maxpl    =  "     "       of theory parameters (rows of the correlation
!                            matrices)
! maxsub   =  "     "       of subspectra for the plot common block
! maxthsp  =  "     "       of frame theories to be linked to the program
! maxthss  =  "     "       of theories to be linked to the program
! maxdimco =                maximal dimension of a correlation matrix to be inserted
! maxscrs  =  "     "       of scratch elements

integer,public                        :: nwrwin,ncolwin
character(len=16),dimension(8),public :: chterm
END MODULE compar

MODULE comdas
use glbconst, only: maxs,maxthss,maxthlv,maxcvsp
implicit none

integer, public:: i_cdata,i_vdata,istrss,ktheo,icdata,ivdata,ip_chan
      common/dasi/i_cdata(maxs,0:maxcvsp),i_vdata(maxs,0:maxcvsp),        &
                  istrss(maxs,0:maxthss),ktheo(maxs,0:maxthss,0:maxthlv), &
                  icdata(0:maxcvsp),ivdata(0:maxcvsp),ip_chan(maxs)
!,nchndat(1:2*(maxs+1)) 
real, public   :: cdata,vdata
      common/dasr/cdata(maxs,maxcvsp),vdata(maxs,maxcvsp)           

character(len=40), public :: n_cdata,n_vdata,ncdata,nvdata
character(len=132),public :: nametheory,namedata,datfilesp
      common/dasc/n_cdata(maxs,maxcvsp),n_vdata(maxs,maxcvsp),       &
                  nametheory(maxs),namedata(maxs),datfilesp(maxs),   &
                  ncdata(maxcvsp),nvdata(maxcvsp)

logical, public::     b_cdata,b_vdata
      common/dasb/b_cdata(maxs,maxcvsp),b_vdata(maxs,maxcvsp)
logical, dimension(maxs), public::bprocstore_rd  

END MODULE comdas

MODULE comscd
use glbconst, only : maxss,maxco,maxvaco,      &
                     maxc,maxp,maxpl,maxs,maxsto,maxscr,maxscrd,jc_scrd
use compar  , only : maxdimco
implicit none

integer, public :: npanum,kcpst,nmkcp,nmr,nmc,natcon,               &
                   ld,lw,laenge,lpart,l_sc,l_nm,lencl,iconwr
real, public ::    conwr,conwro,scratch,pp_sc

character(len=256),public :: ch256,chflen
character(len=132),public :: type,helpar,queryar,thstring
character(len=80), public :: scrstring
character(len=40), public :: nconwr
character(len=16), public :: np_sc,np_nm,ext
character(len=4),  public :: fscratch,fp_sc
character(len=4),  private:: cdum    

     common/scrd/ npanum(maxscr),                                     & 
                  kcpst(maxpl),nmkcp(maxpl),nmr(maxp),nmc(maxp),      &
                  natcon(maxc),					      &
                  ld(maxco),lw(maxco),laenge(maxco),lpart(0:maxco),   &
                  l_sc(maxdimco),l_nm(maxdimco),lencl(maxdimco),      &
                  iconwr(maxvaco),                                    &
                  conwr(maxvaco),conwro(maxvaco),scratch(maxsto),     & 
                  pp_sc(maxdimco),                                    &
                  helpar(maxco),queryar(maxco),ext(maxco),type(maxco),& 
                  fscratch(maxsto),nconwr(maxvaco),                   &
                  np_sc(maxdimco),np_nm(maxdimco),fp_sc(maxdimco),    &
                  thstring(maxs,8),scrstring(maxvaco),ch256,chflen,   &
                  cdum(jc_scrd)

!                      ii_scrd=maxscr+2*maxpl+2*maxp+maxc+4*maxco+1+   &
!                              3*maxdimco+maxvaco,                     &
!                      ir_scrd=2*maxvaco+maxsto+maxdimco,              &
!                      ic_scrd=3*maxco*33+4*maxco+maxsto+10*maxvaco+   &
!                              9*maxdimco+8*33*maxs+128+20*maxvaco     &
!                  pp_sc(maxdimco)           added 1.06.07
!                  fp_sc(maxdimco)           added 1.06.07

END MODULE comscd


MODULE comeff
use glbconst, only: maxfr1,maxs,maxss,maxthss,maxsub,maxvaco,maxco,   &
                    max_ctrf
implicit none
integer,            public :: i_file
integer, parameter, public :: maxfc=14
character(len=40),  public :: nfitcond(maxfc)
character(len=132), public :: nftc
real,               public :: pathwidth,converg 

character(len=64) :: effihome,utpath,logname,colfile

character(len=64),  public :: displaymode(maxs,16)
integer, parameter, public :: nint=maxsub*(maxss+1)*maxs/8
integer, public            :: n_subspect(maxs),ndispmode(maxs),       & 
                              nintset(0:nint),icolorsub(maxsub,maxs)

character(len=80), public   :: strco(4*maxvaco),strth(4*maxvaco,2),    &
                               strtm(4*maxco,2)
character(len=24), public   :: dpmat(8,0:3)
character(len=1),  public   :: chsite,chxxx
character(len=2),  public   :: chlay
integer, public             :: idistsites(0:maxthss),idpmat(0:8),imat(0:8),&
                               jcb,jmb,jpb,jvb

character(len=16),  public  :: winfile,version
integer,            public  :: id1,npl,led,nwrf,nhist
integer, dimension(8),public:: ncol,nrows,ixpixel,iypixel

common/term/id1,npl,ncol,nrows,ixpixel,iypixel,winfile

integer, parameter :: maxpoistr=maxs*maxthss/8
integer, parameter :: maxintbl=maxs*(2*maxs+1),             &
                      nblockstr=maxintbl+maxs*4+4+          &
                                maxs*maxfr1+maxpoistr*33+maxthss+28
character(len=132), public :: pointerstr
character(len=4),   public :: chiss,cdumbstr
integer,            public :: nu_sdevice,intblock,iblockpt,         &
                              nblock,mblock,jblock,nseqsto,pointerks
      common/blockstr/intblock(maxintbl),iblockpt(maxs),            &
                      nblock,mblock,jblock(maxs),nseqsto(maxs),     &
                      nu_sdevice(maxs,maxfr1),                      &
                      pointerks(0:maxs),pointerstr(maxpoistr),      &
                      chiss(0:maxthss),cdumbstr(28)
real,   dimension(max_ctrf),      public :: contrf,ocontrf
integer,dimension(maxs,0:maxthss),public ::  mvadds,mcadds

END MODULE comeff


MODULE comsto
use glbconst, only: maxfr1,maxs,maxc,maxp,maxco,maxthss,maxprd,     &
                    marray_sp,maxthlv,maxpl,maxc_sp,maxp_sp,maxsto,MDBPLFT 
use compar, only: maxscrs,maxcvsp,maxdimco,maxmemth,maxvca,idumplot
implicit none


integer, public:: mrh,mch,mrsh,mcsh,mrceh,mrcesh,mrceth,ktheoh,     &
             mplh,mclh,mph,mcoh,                                    &
             istrssh,mplthsh,mplthsph,mplthssh,mpaddsh,	            &
             mpaddsph,mpaddssh,mvaddsh,mvaddsph,mvaddssh,mcthsh,    &
             mcthsph,mcthssh,mkaddsh,mkaddsth,mkaddssh,mcaddsh,	    &
             mcaddsph,mcaddssh,kcph,kph,numkcp,numr,numc,	    &
             kplh,ivaddh,ipladdh,ivaddsph,icaddsph,		    &
             icaddh,icladdh,i_cdatah,i_vdatah,nu_sdeviceh,	    &
             ip_chanh,nstrco,nstrth,nstrtm,nstra,idumar
real,public :: ph,uph,oph,ddph,plh,conh,cph,cpstorh,cdatah,vdatah


character(len=32),public :: nthplh,nvarh
character(len=40),public :: nconh,n_cdatah,n_vdatah
character(len=4),public  :: fph,fpstorh
character(len=16),public :: ncorh
character(len=60),public :: nph
character(len=132),public:: nametheoryh
character(len=80),public :: stra
character(len=48),public :: strmss
      common/plot/mrh(maxco),mch(maxco),mrsh(maxco),mcsh(maxco),     &
                  mrceh(maxco),mrcesh(maxco),			     &
                  mrceth,mplh,mclh,mph,mcoh,			     &
                  ktheoh(maxs,0:maxthss,0:maxthlv),		     &
                  istrssh(maxs,0:maxthss),			     &
                  mplthsh(maxs,0:maxthss),mplthsph(0:maxs),	     &
                  mplthssh(maxs,0:maxthss),			     &
                  mpaddsh(maxs,0:maxthss),mpaddsph(0:maxs),	     &
                  mpaddssh(maxs,0:maxthss),			     &
                  mvaddsh(maxs,0:maxthss),mvaddsph(0:maxs),	     &
                  mvaddssh(maxs,0:maxthss),			     &
                  mcthsh(maxs,0:maxthss),mcthsph(0:maxs),	     &
                  mcthssh(maxs,0:maxthss),			     &
                  mkaddsh(maxs,0:maxthss),mkaddsth(0:maxs),	     &
                  mkaddssh(maxs,0:maxthss),			     &
                  mcaddsh(maxs,0:maxthss),mcaddsph(0:maxs),	     &
                  mcaddssh(maxs,0:maxthss),			     &
                  kcph(maxp),kph(maxp),				     &
                  numkcp(maxp),numr(maxp),numc(maxp),		     &
                  ph(maxp),uph(maxp),oph(maxp),ddph(maxp),nph(maxp), &
                  kplh(maxpl),ivaddh(maxpl),ipladdh(maxpl),	     &
                  ivaddsph(maxs,0:maxp_sp),plh(maxpl),		     &
                  nvarh(maxpl),nthplh(maxpl),			     &
                  icaddsph(maxs,0:maxc_sp),			     &
                  icaddh(maxc),icladdh(maxc),conh(maxc),nconh(maxc), &
                  cph(maxdimco,maxdimco),fph(maxdimco,maxdimco),     &
                  cpstorh(maxsto),fpstorh(maxsto),ncorh(maxco),	     &
                  nametheoryh(maxs),				     &
                  n_cdatah(maxs,maxcvsp),n_vdatah(maxs,maxcvsp),     &
                  cdatah(maxs,maxcvsp),vdatah(maxs,maxcvsp),	     &
                  i_cdatah(maxs,0:maxcvsp),i_vdatah(maxs,0:maxcvsp), &
                  ip_chanh(maxs),nu_sdeviceh(maxs,maxfr1),           &
                  nstrco(0:maxthss),nstrth(0:maxthss,2),	     &
                  nstrtm(0:maxthss),nstra(0:maxthss),		     &
                  stra(maxvca),strmss(0:maxthss),idumar(idumplot)

END MODULE comsto
