      subroutine efficmd(version_date) 
!     simulating and data fitting environment                           
!     author: h. spiering                                               
!             am damsberg 86                                            
!             55130  mainz                                              
!             version 2011                                              
      use glbconst, only: maxn,maxsub,maxtrf,maxprd,maxcom,MDBPLFT,      & 
                          b_noask,infotext,infplot,enwr,nwr,nrd,ncl,&
                          maxp,maxc,maxco,maxthss,maxs,maxss,            &
                          iseed,pathvariable,iwritear,ipostxtu,sessfile
      use compar, only: maxscr,ncolwin,nwrwin,maxcb,chterm
      use comfrm, only: p,np,con,ncon,mp,mpart,pmin,plast,pabsmin,pst,   &
                        pold,kp,minsets
      use comdat, only: ks_set,b_datset,b_theoset,ibadchan,b_theory,b_procstore
      use comdas, only: ktheo,namedata,datfilesp,nametheory,bprocstore_rd
      use comscd, only: npanum,queryar,helpar,ext,thstring,conwr,     &
                        chflen,ch256
      use comths, only: kf,boundary,                       &
                        fixf,ftol,i_confine,iBR_DBR,ibx_calc,         &
                        idf_min,iterations,iterbrake,limit,tolimit
      use complt, only: n_int
      use comeff, only: icolorsub,n_subspect,ndispmode,displaymode,   &
                        iblockpt,jblock,nseqsto,intblock,maxintbl,    &
                        mblock,nblock,ncol,npl,id1,led,winfile,       &
                        nfitcond,converg,pathwidth,nftc,i_file,       &
                        nwrf,version,maxfc,                           &
                        effihome,colfile,logname,utpath,ocontrf
      use comthe,   only:real_fr,ovartrf,nproc
      implicit none 
                                                                        
       character(len=24), intent(in):: version_date             
       character(len=132):: plotstrpu,allbat             
       character(len=8)  :: chistring
       character(len=4)  :: chara,charb,charc
       integer,parameter:: icdb=176*maxn+8*39+maxsub+5*infplot+100,      &
                           icda=MDBPLFT*2-icdb-15*33-68                       
       common/plot/ charb(icdb),plotstrpu,charc(68),allbat(14),         &
                    chara(icda)                                         
                                                                        
      integer iter,info,i0,jexe,                                 &
              ks,kwin,                                                  &
              lq,lk,ledit,leditbe,lfn,loop,                             &
              loopmax,loopwarning,lth,lwin,                             &
              mfit,mpf,mf,                                              &
              npar,nout,npunch,nn,nth,n1,nini,                          &
              ienter                                                    
      real    alowlimit,uplimit,                                        &
              pathw,path1_last,path2_last,                              &
              chisqmin,chisq,chisq_1,chi_p,value                        
                                                                        
      real     array_tr 
      integer  inf_tr 
      common/comtr/array_tr(maxtrf),inf_tr(maxprd) 
      integer   mcom,mexe 
      character(len=132):: comln
      common /efstat/ mcom,mexe,comln(maxcb) 
!     comln(icb)         = buffer for commands ;icb=icl* number of comma
!                          icl: dimension of ringbuffer for each command
                                                                        
      integer   kshandle,whandle,sizex,sizey,posx,posy,hold,plotyp,       &
                b_plot,v_plot                                             
      real      r_plot 
      character(len=80):: wdescript,chdf
      character(len=32):: intptr,filetype
      character(len=24):: tabcolor,chl,chr
 
      common/wptr/intptr(maxs) 
      common/win/kshandle,hold,whandle(maxs),                           &
                 sizex(maxs),sizey(maxs),                               &
                 posx(maxs),posy(maxs),plotyp(maxs),                    &
                 v_plot(3,maxs),b_plot(2,maxs),r_plot(8,maxs),          &
                 wdescript,tabcolor(64)                                 
!                b_plot(i,k) == win.b_plot[k-1][i-1]                    

      integer, parameter:: maxbuf=32   
      integer i,ia,id,ii,ic2,ih,il,i1,i10,lscr,                         &
              iout,ipos,iset,iss,isub,isc,ith,k_fc,                          &
              j,jj,k,l,lines,                                           &
              mbuf,ms,npa,n2,jb,ios,ipc,ieq,ntrimto0,whichprogram
      integer,dimension(1:maxs):: iseq,icomln
      integer,dimension(0:maxs):: jseq
               
      real    out(32),rn,spc
      real, save  :: start,finish,wstart,wfinish 
      character(len=132):: chstr,ct132,ch132,cp132,querytype,          &
                           scriptfile,batfile,punfile,                 &
                           chcom,chin,chsto,comline,                   &
                           parfile,historyfile
      character(len=132),save:: chstring 
      character(len=132),dimension(1:maxs)  :: parfilesp
      character(len=132),dimension(1:maxbuf):: cmdbuff
      character(len=16), dimension(1:8)     :: chkill
      character(len=4),  dimension(1:32)    :: chf
      character(len=4),  dimension(1:6)     :: ftrt
      character(len=2),  dimension(1:6)     :: ft_2 
      character(len=2) :: ch2,cb2,command,ci2   
                                                                        
      logical boolstat,boolcom,b_unify,b_dataone,lappendres,b_nd,       &
              b_ufile,b_file,b_session,b_quit,b_win(8),                 &
              b_xdotool,b_xwininfo,b_getcmd,b_bool,b_fc

      character(len=48):: chwindim
!     character(len=32), save:: retwindowfocus
      character(len=48), dimension(8) :: storewin 
      character(len=20):: lck
      character(len=16):: exten
      character(len=8) :: ch8
      character(len=7) :: form 
      character(len=6) :: ch6
      character(len=6), dimension(8) :: namewin
      character(len=5) :: chcol,chnorm                           
      character(len=4) :: cmch,chft,chft_last,chbold                       
      character(len=1) :: ch1,ch0
      character(len=24),dimension(1:16):: defcolor=& 
     (/'black                   ','white                   ',          &
       'red                     ','green                   ',          &
       'blue                    ','yellow                  ',          &
       'magenta                 ','cyan                    ',          &
       'orange                  ','gold                    ',          &
       'brown                   ','violet                  ',          &
       'purple                  ','lavender                ',          &
       'Cornsilk                ','Ivory                   '/)          
      character(len=64) :: retwindowfocus
      common/winid/retwindowfocus

      !     ******************************************************************
!     write(6,'(a,i8)')'main: 4bytes left in common/scrd/ =',idumscrd   
!     write(6,'(a,i8)')'main: size of common/scrs/ ='           
!      write(6,'(4i8)')mi_scrd,mr_scrd,mc_scrd                          
                                                                        
!     &           iterations,pathwidth,converg,tolimits,limit,          
!     &           df_er,idf_min,ftol,iterbrake,iBR_DBR,ibx_calc,        
!     &           i_wfix,i_file,nfitcond(11)                            
      CALL get_command(ch132); scriptfile=ch132(6:)
      b_getcmd=LEN_TRIM(scriptfile).gt.0
      CALL GET_ENVIRONMENT_VARIABLE(NAME='EFFIUTPATH',value=utpath,STATUS=i)
      if(i.eq.1) call help('effi/effiutpath')
      CALL GET_ENVIRONMENT_VARIABLE(NAME='LOGNAME',value=logname,STATUS=i)
      CALL GET_ENVIRONMENT_VARIABLE(NAME='NPROC',value=ch8,STATUS=i)
      if(i.eq.1) call help('effi/nproc'); call c8toi(ch8,nproc)
      CALL GET_ENVIRONMENT_VARIABLE(NAME='COLORFILE',value=colfile,STATUS=i)
      if(i.eq.1) call help('effi/colfile')
      CALL GET_ENVIRONMENT_VARIABLE(NAME='EFFIHOME',value=effihome,STATUS=i)
      if(i.eq.1) call help('effi/effihome')

      ipostxtu=0
      b_xwininfo=.false.
      exten='xwininfo'//char(0)
      if(whichprogram(exten).eq.1) b_xwininfo=.true.
      b_xdotool=.false.
      exten='xdotool'//char(0)
      if(whichprogram(exten).eq.1) b_xdotool=.true.
       call whichwindow 
!      ch132='xprop -root _NET_ACTIVE_WINDOW > whichwindow'//char(0)
!      call systemcmd(ch132)
!      open(unit=1,file='whichwindow',status='old',&
!                        access='sequential'       &
!                        ,form='formatted')
!      read(1,'(a)'),ch132
      !      close(unit=1)
      if(b_xdotool) then
       ch132='0x'//retwindowfocus(:60)//char(0)
       retwindowfocus='xdotool windowfocus  '//ch132   
      else
        retwindowfocus=' '
       end if
!      apt-get install xdotool
!      apt-get install xwininfo
!      call testcommon
      i=index(version_date,'(')
      version=version_date(1:i-1)
      pathvariable='EFFIHEPATH'     
      historyfile= 'history.txt' 
      open(unit=4,file= historyfile                                    &
                ,status='unknown'                                      &
                ,access='sequential'                                   &
                ,form='formatted')
      do i=1,5
       read(4,'(a)')infotext(i)
      end do
      rewind 4
      infotext(1)='version '//version(1:8)
      do i=1,5
       write(4,'(a)')infotext(i)(1:60)
      end do
      close (unit=4)
      infotext=' '
      p(0)=-1.
      pold(0)=-1.; plast(0)=-1.; pmin(0)=-1.; pabsmin(0)=1.0e10; pst(0)=-1.

      k=1                                                               
      call window(k) 
      npl=ncol(1)                                                       
      if(npl.gt.130) npl=130   
!     common blocks:
      call zerosto
!     call tscrd
      id1=1
      nwr=6
      nrd=5
      iseed=9199
      ncolwin=npl 
      nwrwin=nwr 

      bprocstore_rd=.true. 
      real_fr=9999.                                                                 
      ch0=char(0) 
      chbold=char(27)//'[1m' 
      chcol=char(27)//'[34m' 
      chnorm=char(27)//'[0m' 
      b_procstore=.false.
                                                                 
      ftrt(1)='marq' 
      ftrt(2)='newt' 
      ftrt(3)='grad' 
      ftrt(4)='powe' 
      ftrt(5)='dfpm' 
      ftrt(6)=' ' 
      ft_2(1)='mq' 
      ft_2(2)='ne' 
      ft_2(3)='gr' 
      ft_2(4)='pw' 
      ft_2(5)='df' 
      ft_2(6)=' ' 
      nftc=',iter,path,conv,toli,limi,fixf,idfm,ftol' 
      nftc(41:)=',ibra,deri,brac,bdry,conf,file' 
      iterations=10 
      pathwidth=1.0 
      converg=1.0e-5 
      tolimit=0.30 
      limit=0 
      fixf=1.0e-4 
      idf_min=15 
      ftol=1.0e-4 
      iterbrake=6 
      iBR_DBR=0 
      ibx_calc=0 
      boundary=0.0 
      i_confine=0 
      i_file=0 
      chstring='iter=10 path=1.0 conv=1.0e-5 toli=0.3 limi=1 '//          &
     & 'fixf=1.0e-4 idfm=15 ftol=1.0e-4 ibra=6 deri=0 brac=0 bdry=0.0 '//&
     & 'conf=0 file=0 '                                                 
                                                                        
!                  1       901       901       901234567890             
      nfitcond(1)='iterations                      i03)' 
      nfitcond(2)='pathwidth                       f04.1)' 
      nfitcond(3)='convergence_crit.               e06.1)' 
      nfitcond(4)='to_limit                        f04.2)'  
      nfitcond(5)='limit(min-chi2)                 i01)'       ! not pw 
      nfitcond(6)='fixf                            e06.1)'     ! not pw 
      nfitcond(7)='fix_condition                   i03)'       ! not pw 
      nfitcond(8)='ftol_powell                     e06.1)'     ! pw     
      nfitcond(9)='iterbrake_powell                i03)'       ! pw     
      nfitcond(10)='on_off_derivative               i01)'      ! pw     
      nfitcond(11)='on_off_bracket                  i01)'      ! pw     
      nfitcond(12)='boundary                        f04.1)'    ! ne     
      nfitcond(13)='on_off_confine                  i01)'      ! ne     
      nfitcond(14)='on_off_wfile                    i01)'     
                                                                        
      storewin(1)='124x24+10+10 -bg khaki1 -fg black'  ! re 
      storewin(2)='80x24+430+10 -bg bisque -fg black'  ! sh
      storewin(3)='80x24+5+5 -bg LightGreen -fg black' ! tr
      storewin(4)='80x36+750+5 -bg  khaki1 -fg black'  ! li
      storewin(5)='80x36+750+5 -bg Yellow1 -fg black'  ! he
      storewin(6)='100x24+5+5 -bg LightGreen -fg black'! ft te
!     not yet transfered to subroutine termprocess(chwindim,chkill,kwin) 
      namewin(1)='cmd_re'
      namewin(2)='cmd_sh'
      namewin(3)='cmd_tr'
      namewin(4)='cmd_li'
      namewin(5)='cmd_he'
      namewin(6)='cmd_ft'
      
      do i=1,16 
       enwr(i)='nnnn' 
      end do 
      do i=1,maxs 
       icomln(i)=i 
      end do 
      led=0 
      nini=7 
      npar=1 
      lappendres=.false.; b_noask=.false. 
      lck='effi/license/check' 
      ledit=0; leditbe=0; ! ift=0 
      i0=ichar('0') 
      b_dataone=.false. 
      comline=' ' ; ch132=' '; cp132=' '; ct132=' '; chft_last=' ' 
      do i=1,8 
       chkill(i)=' ' 
       b_win(i)=.false. 
      end do 
!      b_win(3)=.true.                                                  
                                                                        
      do i=1,maxs 
       do j=1,8 
        thstring(i,j)=' ' 
        r_plot(j,i)=0. 
       end do 
       do j=1,2 
        b_plot(j,i)=0 
       end do 
       do j=1,3 
        v_plot(j,i)=0 
       end do 
      end do 
                                                                        
      k=0 
      j=0 
      do i=1,maxs 
       j=j+1 
       whandle(i)=-i 
       sizex(i)=400 
       sizey(i)=250 
       posx(i)=5+(j-1)*415 
       posy(i)=10 +k*280 
       if(j.eq.3) then 
        k=k+1 
        j=0 
       end if 
      end do 
                                                                        
      do k=1,maxbuf 
       cmdbuff(k)=' ' 
      end do 
      do k=1,maxcb 
       comln(k)=' ' 
      end do 
      chisqmin=0.0 
      chisq_1=1.0e10 
      chft=' ' 
      mfit=0 
      iter=0 
      info=0 
      chcom='r*7M3OP!RvTUo>XA7K\E^0QvfGgl`gcilELmn<p+ks6uv2hy' 
      infotext(8)='*&,Cy/5x2(4=Fx8.:y}/9?NvBk}EfGHY'//chcom 
      boolstat=.true. 
      boolcom=.true. 
      b_nd=.false. 
      parfile=' ' 
      do k=1,maxs 
       b_datset(k)=.false. 
       b_theoset(k)=.false. 
       ktheo(k,0,0)=0 
       datfilesp(k)=' ' 
       parfilesp(k)=' ' 
      end do 
                                                                        
      mp=0 
      mpf=0 
      mpart=0 
      npunch=0 
                                                                        
 !    1 ='th'      theory and structure of the spectrum           
 !    2 ='rs'      read structure and parameters of the spectra   
 !    3 ='tr'      transformation matrix                          
 !    4 ='pc'      parameter and constants                        
 !    5 ='ws'      write structure                                
 !    6 ='rd'      read data                                      
 !    7 ='ed'      edit mode (terminal, editor)                   
 !    8 ='pl'      plot                                           
 !    9 ='wi'      window handling                                
 !    10='te'     test                                           
 !    11='dm'     toggle display mode                            
 !    12='fi'     fix parameters                                 
 !    13='fr'     free parameters                                
 !    14='dr'     data regions for fitting and display           
 !    15='fc'     fit conditions                                 
 !    16='ft'     fit (gradient,Newton,Marquardt)                
 !    17='se'     search                                         
 !    18='li'     list theories and data                         
 !    19='lo'     limitation of loop                             
 !    20='sh'     show a selction of parameters                  
 !    21='rm'     rm spectrum                                    
 !    22='ss'     subspectra                                     
 !    23='su'     subtract subspectra                            
 !    24='wr'     print results                                  
 !    25='wd'     punch display buffer                           
 !    26='st'     status                                         
 !    27='he'     help                                           
 !    28='ex'     exit program                                   
 !    29='qu'     quit program                                   
 !    30='mc'     Monte Carlo synthetic spectrum                 
 !    31='ae'     author, about effi                             
 !    32='eu'     Euler angle                                    
 !    33='na'     b_noask                                        
 !    34='tn'     EFG,MSD, eta out of range                      
 !    35='ts'     all theory structures                          
 !    36='re'     restore                                        
 !    37='pa'     parameters                                     
 !    38='co'     constants                                      
 !    39='un'     unify two par files                            
 !    40='sd'     session data to read again                     
 !    41='tp'     collection of topics  
 !    42='sm'     summation of spectra

!     colors                                                            
      do k=1,16                                                         
       tabcolor(k)=defcolor(k)                                          
       i=index(tabcolor(k),' ')                                         
       tabcolor(k)(i:i)=char(0)                                         
      end do                                                            
      if(colfile.ne.' ')then                                            
       inquire(file=colfile,exist=b_file)                               
       if(b_file) then                                                  
        open(unit=2,file=colfile                                & 
                 ,status='old'                                  &       
                 ,access='sequential'                           &       
                 ,form='formatted')                                    
                                                                        
        do k=6,64                                                       
         read(2,'(a)',end=40) tabcolor(k)                               
         i=index(tabcolor(k),' ')                                       
         if(i.eq.1) goto 40                                             
         tabcolor(k)(i:i)=char(0)                                       
        end do                                                          
   40   continue                                                        
       end if
       close(unit=2)                                                    
      end if                                                            
      do i=k-1,64                                                       
       tabcolor(i)='black'//char(0)                                     
      end do                                                            
      k=0
      do while(k.lt.maxsub)
        k=k+1
!       icolorsub for subsets starting with red = number 3           
!       (c code array starts with 0 -> number 2)                     
!       if there is a color file the default colors are              
!       over written from color yellow.                              
         if(k.eq.4)k=k+1    
         do jj=1,maxs 
         icolorsub(k,jj)=k+1 
        end do 
       end do 
!    end colors

      write(nwr,'(a)') 
!      write(6,'(a,3i4)') ' effi askvalue nwr,nrd,npl=',nwr,nrd,npl     
!      npl=80                                                           
      ch1=' ' 
      chin='*********************************************************' 
      call chcenter(chin,ch1,npl) 
      write(nwr,'(a)') chin(:npl) 
      cp132='*                                                       *' 
      call chcenter(cp132,ch1,npl) 
      write(nwr,'(a)') cp132(:npl) 
      ch132='*            Environment For FItting                    *' 
      call chcenter(ch132,ch1,npl) 
      write(nwr,'(a)') ch132(:npl) 
      write(nwr,'(a)') cp132(:npl) 
      ch132='    '//char(27)//'[1m'//'E F F I'&
                     //char(27)//'[0m'//'                             ' 
      call chcenter(ch132,ch1,npl) 
      write(nwr,'(a)') ch132(:npl) 
      write(nwr,'(a)') cp132(:npl) 
      ch132='*            Version '//TRIM(version_date)//'                   *' 
      call chcenter(ch132,ch1,npl) 
      write(nwr,'(a)') ch132(:npl) 
      write(nwr,'(a)') cp132(:npl) 
       chin='author:ae********************************************' 
      call chcenter(chin,ch1,npl) 
      write(nwr,'(a)') chin(:npl) 
                                                                        
!     define type of console, terminal type number                      
!     ch132=terminal                                                   
!     call askterm(nct,ch132)                                          
      inquire(file='noask.cmd',exist=b_session)
      write(nwr,'( /,a)') 'command files of the current directory of previous sessions:'  
      call systemcmd('ls *.cmd'//ch0)
      write(nwr,'(a)')
      inquire(file='def_session',exist=b_file)
      if(b_file)then
         open(unit=1,file='def_session'); read(1,'(a)')sessfile
         close(unit=1)
      else   
       sessfile='session.cmd' 
      end if
      id1=1 
      chcom='effi/session/file' 
      filetype='session' 
      exten='cmd'
   80 if(.not.b_session.and..not.b_getcmd)call rdfname(filetype,sessfile,exten,chcom,npl,nwr)
      if(exten(1:1).eq.'*'.or.exten(1:1).eq.'q')then
        inquire(file='history.txt',exist=b_file)       
        if(b_file)call rmfile('history.txt'//ch0)
        inquire(file='storage.am',exist=b_file); if(b_file)call rmsto
        goto 2900 
       end if
       i=index(sessfile,'/') 
       if(i.gt.1) then 
        if(sessfile(i+1:i+1).eq.'.') sessfile(i+1:)='session.cmd' 
       end if 
                                                                        
       inquire(file=sessfile,exist=b_file) 
       if(b_file) then 
        open(unit=nini,file=sessfile                                   &
                 ,status='old'                                         &
                 ,access='sequential'                                  &
                 ,form='formatted')                                    
       else 
                                                                        
        querytype=TRIM(sessfile)//' not found- create standard file' 
        ch1='n' 
        chcom='effi/sessfile/create' 
        call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
        if(ch1.eq.'n') goto 80 
                                                                        
        open(unit=nini,file=sessfile                                   &
                 ,status='new'                                         &
                 ,access='sequential'                                  &
                 ,form='formatted')                                    
        comln(1)='te s1 && pl s1' 
        comln(2)='fc '//chstring 
        comln(3)='dm s1 d4' 
        comln(4)='dr  s1  exc 1-20 ' 
        comln(5)='wd  s1 fmt: (x,y)' 
        comln(6)='ft  ne s1 ' 
        comln(7)='sh ma 1 3'
        comln(8)='re 0'        
        comln(9)='bad_data=    0' 
        do i=1,9 
         write(nini,'(a)') comln(i) 
        end do 
        rewind nini 
       end if 
                                                                 
       mcom=0 
       i=0 
       ncl=130 
       b_fc=.true.
       do while(i.lt.maxcb) 
        i=i+1 
        mcom=mcom+1 
        read(nini,'(a)',end=32) comln(i) 
!        write(6,'(a)') comln(i)                                        
        if(comln(i)(1:1).eq.'#') then 
          i=i-1 
          mcom=mcom-1 
        end if
        if(comln(i)(1:2).eq.'fc'.and.b_fc) then
           b_fc=.false.
           k_fc=i
        end if   
        if(index(comln(i),'sets with subsets=').gt.0) then 
         mcom=mcom-1 
         ch132=comln(i)(6:)
!        write(6,'(a)') TRIM(comln(i))           
         call trlch(ncl,ch132,nn,out) 
         lines=int(out(1)) 
         do j=1,lines 
          read(nini,'(a)',end=32) chin 
          ch132=chin(8:) 
          call trlch(ncl,ch132,nn,out) 
          if(nn.eq.2) then 
           jb=1 
          else 
           jb=int(out(3)) 
          end if 
          do k=1,jb 
           read(nini,'(a)',end=32) thstring(j,k) 
          end do 
          thstring(j,1)(132:132)=char(jb+i0) 
                                                                        
          do  k=1,maxsub 
           do jj=0,maxss 
            n_int(k,jj)=0 
           end do 
          end do 
                                                                        
          do k=1,int(out(2)) 
           read(nini,'(a)',end=32) ch132 
!           write(6,'(a)') ch132                                        
           jj=0 
           isc=0 
           do while(jj.le.32.and.isc.lt.131) 
            jb=1 
            do while(ch132(jb:jb).eq.' ') 
             jb=jb+1 
            end do 
            do while(ch132(jb:jb).ne.' ') 
             jb=jb+1 
            end do 
            isc=isc+jb-1 
            jj=jj+1 
           end do 
!           write(6,'(a,2i4,a)')' jj,isc=',jj,isc,ch132(isc:)           
           cp132=ch132(:isc-1) 
           ct132=ch132(isc-1:130) 
           call trlch(ncl,cp132,nn,out)
           iset=int(out(1)) 
           n_subspect(iset)=int(out(2)) 
           isub=int(out(3)) 
           isc=int(out(4)) 
           n_int(isub,0)=isc 
           do jj=1,nn-4 
            n_int(isub,jj)=int(out(4+jj)) 
           end do 
           if(nn-4.lt.isc)then 
            call trlch(ncl,ct132,ii,out) 
            do jj=1,ii 
             n_int(isub,jj+nn-4)=int(out(jj)) 
            end do 
           end if 
          end do 
!          write(6,'(32i3)') (n_int(1,jj),jj=1,isc)                     
!          write(6,'(32i3)') (n_int(2,jj),jj=1,isc)                     
          call nintstore(iset,0) 
         end do 
!         read(nini,'(a)',end=32) comln(i)                              
        end if 
                                                                        
        if(index(comln(i),'pos_win=').gt.0) then 
         mcom=mcom-1 
         ch132=comln(i)(9:) 
         call trlch(ncl,ch132,nn,out) 
         do k=1,nn 
          iseq(k)=int(out(k)) 
         end do 
!         write(6,'(a,16i5)') 'efficmd iseq=',(iseq(k),k=1,nn)          
                                                                        
!        sizex(i)=400                                                   
!        sizey(i)=250                                                   
!        posx(i)=5+(j-1)*415                                            
!        posy(i)=10 +k*280                                              
         do k=1,nn 
          read(nini,'(a)',end=32) ch132 
          call trlch(ncl,ch132,jj,out) 
          ii=iseq(k) 
          ndispmode(ii)=int(out(1)) 
          sizex(ii)=out(2); sizey(ii)=out(3) 
          posx(ii) =out(4); posy(ii) =out(5) 
          if(jj.gt.5)then 
           v_plot(1,ii)=out(6); 
           v_plot(2,ii)=out(7); 
           v_plot(3,ii)=out(8); 
           if(jj.gt.8) then 
            b_plot(1,ii)=int(out(9))  
            b_plot(2,ii)=int(out(10)) 
            do l=11,jj 
             r_plot(l-10,ii)=out(l); 
            end do 
           end if 
          end if 
         end do 
        end if
      
        if(index(comln(i),'extra_window=').gt.0) then
         mcom=mcom-1 
           do k=1,6
              read(nini,'(a)',end=32) comln(i+k) 
              storewin(k)=comln(i+k)
           end do
           i=i+6
        end if
        
        if(index(comln(i),'bad_data=').gt.0) then 
         mcom=mcom-1 
         ch132=comln(i) 
         call trlch(ncl,ch132,nn,out) 
         iseq(1)=0 
         do k=1,nn 
          iseq(k)=int(out(k)) 
         end do 
         if(nn.gt.1.and.iseq(1).gt.0)then 
          do k=2,nn,2 
           ks=iseq(k-1) 
           ibadchan(0,ks)=iseq(k) 
           read(nini,'(16i6)',end=32)(ibadchan(j,ks),j=1,iseq(k)) 
          end do 
         end if 
         i=maxcb 
        end if 
       end do 
                                                                        
   32  continue 
       mexe=0 
       do k=1,mcom 
        comln(k)=ADJUSTL(comln(k))
        ch2=comln(k)(1:2) 
        if(ch2.eq.'rs'.or.ch2.eq.'rd') mexe=mexe+1 
       end do 
       if(mexe.gt.0)then 
        l=ntrimto0(comln(mexe)) 
        if(b_session)comln(mexe)(l+1:)='  && na noask.cmd' 
       else 
        if(b_session)then 
         mexe=1 
         comln(mexe)='xx  && na noask.cmd' 
        end if 
       end if 
!      write(6,'(2a)')'comln=',comln(mexe)                              
                                                                        
       close(unit=nini) 
!      write(6,'(a,2i4)') '  mcom, mexe=',mcom,mexe                     
      k=1 
   33 continue
      do while(k.le.mcom) 
       k=k+1 
      end do 
      if(k.eq.mcom+1.and.b_fc)then
        comln(k)='fc '//chstring 
        mcom=k
        k_fc=k
      end if 
35    continue
      chin=comln(k_fc) 
      
      conwr(1) = iterations 
      conwr(2) = pathwidth 
      conwr(3) = converg 
      conwr(4) = tolimit 
      conwr(5) = limit 
      conwr(6) = fixf 
      conwr(7) = idf_min 
      conwr(8) = ftol 
      conwr(9) = iterbrake 
      conwr(10)= iBR_DBR 
      conwr(11)= ibx_calc 
      conwr(12)= boundary 
      conwr(13)= i_confine 
      conwr(14)= i_file 
                                                                        
      ii=0 
      do jb=1,maxfc 
       j=index(chin,nftc(jb*5-3:jb*5)) 
       if(j.gt.0) then 
        ii=ii+4 
        call itoc8(ch8,jb) 
!        write(6,'(a,5x,a)')ch8(1:4),nftc(jb*5-3:jb*5)                 
        ch132=chin(j:)
        call nextchar(ch132,0,ipos,cp132,ih)
        i=index(cp132(1:ih),'=') 
        if(.not.(ih.lt.6.or.i.eq.0)) then 
         j=index(cp132(i:),' ') 
         chstr=cp132(i+1:i+j) 
         cp132=chstr 
         call fout_a(cp132,chf,nn) 
         ch6=chf(1)(1:3) 
         if(ch6(1:1).eq.'i') then 
          ch6(4:6)=')  ' 
         else 
          ch6(4:6)='.'//chf(1)(4:4)//')' 
         end if 
         nfitcond(jb)(33:38)=ch6 
!        write(6,'(2a)')'comsub chstr=',chstr(1:j)                      
         call trlch(10,chstr,nn,out) 
         conwr(jb)=out(1) 
        else 
         comln(k_fc)='fc '//chstring 
         write(nwr,'(a)')' fc string incorrect, replaced by default string (exit by ex)'
          write(nwr,'(2a)')nftc(jb*5-3:jb*5),' found but - =value - is missing' 
         goto 35 
        end if
       else
         comln(k_fc)='fc '//chstring 
         write(nwr,'(a)')' fc string incorrect, replaced by default string (exit by ex)'
         write(nwr,'(2a)')nftc(jb*5-3:jb*5),'  not found'
         goto 35         
       end if 
      end do 
      k=k+1 
      if(k.le.mcom) goto 33 
                                                                        
       iterations=conwr(1) 
       pathwidth =conwr(2) 
       converg   =conwr(3) 
       tolimit   =conwr(4) 
       limit     =conwr(5) 
       fixf      =conwr(6) 
       idf_min   =conwr(7) 
       ftol      =conwr(8) 
       iterbrake =conwr(9) 
       iBR_DBR   =conwr(10) 
       ibx_calc  =conwr(11) 
       boundary  =conwr(12) 
       i_confine =conwr(13) 
       i_file    =conwr(14) 
                                                                        
      chstring=' ' 
      boolcom=.false. 
      if(b_getcmd) then
         chstring='&& '//scriptfile
!         goto 1
      end if   
      if(mexe.gt.0) then 
       querytype='execution of read commands' 
       ch1='y'; if(b_getcmd)ch1='n'
       chcom='effi/execution/rd' 
       if(.not.b_session.and..not.b_getcmd)call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
       if(ch1.eq.'y') then 
        boolcom=.true. 
       else 
        do k=1,mcom 
         comln(k)=comln(mexe+k) 
!         write(6,'(i3,a)')k,comln(k)(1:60)                             
        end do 
        mcom=mcom-mexe 
        mexe=0 
       end if 
      end if 
      cmdbuff(1)='te s1'//ch0 
      cmdbuff(2)='he'//ch0  
      cmdbuff(3)=':>pwd'//ch0  
      cmdbuff(4)=':>ls *.cmd'//ch0 
      cmdbuff(5)=':>ls *.par'//ch0 
      mbuf=5
      nwrf=nwr 
!     ******************************************************************
!     read command                                                      
!     ******************************************************************
      id1=1; jexe=0; loop=0; loopmax=1000; loopwarning=100 
      call zerotrfarr
    1 continue 
      comline=chstring
!      write(6,'(i3,a)')(i,datfilesp(i)(:50),i=1,3)                     
!      write(6,'(a,i3)') '1 continue comline(:80),jexe',jexe            
!      write(6,'(2a)') 'at 1:',comline(:80)
      ncl=npl 
      if(abs(info).ge.1.and..not.b_noask) then 
       call errormessage(info) 
       info=0 
       if(cmch.eq.'mdfy')then
        command='qu'
        goto 10
       end if
       goto 1 
      end if 
!      if(info.lt.0) comline=' && qu'                                   
      i=index(comline,'&&') 
      if(index(comline,'&&&&').eq.1)read(12,'(a)',err=1)comline 
!      write(6,'(2a)') 'at &&&&:',comline(:80)                          
      if(jexe.ge.maxcb)jexe=0
      if(jexe.gt.0)then
       j=index(comln(jexe),'&& na')
       if(j.gt.0)comln(jexe)(j:)=' '
      end if

      if(b_noask) then 
       if(i.eq.0) then 
         close(unit=12) 
         close(unit=13) 
         b_noask=.false.
         nwr=6 
       end if 
!       if(comline.eq.' ')read(12,'(a)',err=1)comline                   
       i=1 
      end if 
      if(i.gt.0) then 
       ch132=comline(i+2:) 
       call nextchar(ch132,0,ipos,cp132,ih) 
       comline=cp132 
       command=comline(1:2) 
!                                                                       
!      write(6,'(3a)') ' ***',comline(:70)                             
!      write(6,'(3a)') ' ***',command,'***                          '   
       loop=loop+1 
       if(loop.eq.loopwarning.or.loop.ge.loopmax) then 
        if(b_noask.and.loop.eq.loopwarning) then
         loopwarning=loopmax
         loopmax=2*loopmax
        end if 
        form='i5' 
        alowlimit=1 
        uplimit=loopmax 
        value=float(loopmax) 
        print'(a,/,a,i3,a)','you are probably catched in an endless loop',&
        'n=',loop,' commands have been executed in a chain'             
        querytype=' quit (q,*) or continue loops up to ' 
        chcom='effi/command/chain/limits' 
        call askvallim(querytype,form,                                  &
                        alowlimit,uplimit,value,chcom,npl,nrd,6)      
        if(querytype(1:1).eq.'*'.or.querytype(1:1).eq.'q') then 
         chstring=' ' 
         loop=0 
         goto 1 
        end if 
        loopwarning=int(value) 
       end if 
       goto 10 
      end if 
      loop=0 
!      ch132(:npl)=' '                                                  
!      write(6,'(a,a)') ' ****command****',trim(ch132)             

      jexe=jexe+1 
      if(jexe.ge.mexe+1) then
        boolcom=.false. 
      end if
      if(boolcom) then 
       cp132=comln(icomln(jexe)) 
       call nextchar(cp132,0,ipos,ch132,ih) 
       command=ch132(1:2) 
       comline=ch132 
       goto 10 
      else 
       inquire(file='storage.cb',exist=b_file) 
       if(b_file) then 
        querytype='read interim results from file' 
        ch1='n' 
        chcom='effi/interim_results' 
        call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
        if(ch1.eq.'y') then
         call procstore('rd') 
         do ks=1,maxs
          if(ktheo(ks,0,0).gt.0)bprocstore_rd(ks)=.false.
         end do
        end if
        call rmfile(' storage.cb'//ch0) 
       end if 
!       comline=' ' 
!---------------------command buffer ---------------------------------- 
       call window(1) 
       call buffer(cmdbuff,maxbuf,comline,mbuf)
       comline=ADJUSTL(comline)
       command=comline(1:2) 
       if(command.eq.' ')write(nwr,'(1x,a1,a3)') char(27),'[2A' 
!-------------------------------------------------------------          
       goto 10 
      end if 
                                                                        
   10 continue 
      i=index(comline,'&&') 
      if(i.eq.0) then 
       chstring=' ' 
      else 
       chstring=comline(i:) 
       comline(i:)=' ' 
      end if 
                                                                        
      if((command.eq.'rs'.or.command.eq.'rd').and..not.boolcom.and.b_theory)&
      write(nwr,'(a4,a)')chbold,                                       &
      'storage space may have changed, re-read the data by: {sd}'//chnorm
                                                                        
!     command identification                                            
      if(command.ne.'ft')chft=' ' 
      if(command.eq.' ') goto 1
      if(command.eq.':>') then 
       comline(1:2)='  ' 
       l=LEN_TRIM(comline) 
       comline(l+1:)=char(0) 
       call systemcmd(comline) 
       goto 1 
      end if 

      i=index(comline,' >')
      if(i.gt.0) then 
       ch132=comline(i+2:)
       call nextchar(ch132,0,ipos,cp132,ih) 
       if(ih.eq.0) cp132(1:60)='print_out.txt'
       nwrf=2 
       open(unit=nwrf,file=cp132(1:60)                  &
                 ,status='unknown'                      &
                 ,access='sequential'                   &
                 ,form='formatted')                                    
      end if 

  select case(command)
!     ******************************************************************
    case('sm')        ! sum of two spectra 
!     ******************************************************************
       call sum2datasets(namedata(ks_set),datfilesp(ks_set),info)
!     ******************************************************************
    case('th')        ! definition of the structure of the spectrum 
!     ******************************************************************
!            structure of the spektra and the theories used             
!            for the (sub)spectrum(a) are defined.                      
!            the standard transformation matrix is constructed in the   
!            subroutine theory.                                         
!                                                                       
      call zerotrf 
      do i=1,maxs 
       iblockpt(i)=0 
       jblock(i)=0 
       nseqsto(i)=0 
       b_theoset(i)=.false. 
      end do 
      iblockpt(1)=1 
      do i=1,maxintbl 
       intblock(i)=0 
      end do 
      mblock=1 
      nblock=1 
      ms=maxs 
      do ks=1,maxs 
       if(ktheo(ks,0,0).le.0) ms=ms-1 
      end do 
      if(ms.eq.maxs) then 
       write(nwr,'(a,i2,a)') '** maximum number',maxs,                  &
                            ' of sets already in use'                  
       goto 1 
      end if 
                                                                        
      i=index(comline,'&&') 
      if(i.eq.0) then 
       cp132=comline 
      else 
       cp132=comline(:i-1) 
      end if 
      chin=cp132 
      call nextchar(chin,2,ipos,ch132,ih) 
                                                                        
       id=0 
       lscr=0 
       if(ih.gt.0) then 
        i=ih+1 
        do while(id.eq.0.and.i.gt.0) 
         if(ch132(i:i).eq.'.') id=i 
         i=i-1 
        end do 
        if(id.eq.0) then 
         scriptfile=ch132(:ih)//'.scr' 
         lscr=id+4 
        else 
         scriptfile=ch132(1:ih) 
         lscr=ih 
        end if 
        if(b_noask) then 
         write(nwr,'(a)')' ***th '//ch132(1:ih)//'***' 
         nwr=6 
        end if 
       else 
        scriptfile=' ' 
       end if 
                                                                        
      ks=ms+1 
      cmch='stri' 
                                                                        
      call theostr(ks,cmch,scriptfile,info) 
      if(info.eq.13)then
       chstring='&& rm'
       goto 1
      end if
      if(info.gt.0) goto 1 
      if(b_noask)nwr=13 
                                                                        
      iset=ks 
      do  k=1,maxsub 
       do jj=0,maxss 
        n_int(k,jj)=0 
       end do 
      end do 
      call nintstore(iset,0) 
      n_subspect(iset)=0 
                                                                        
      call calpl('test') 
      call getprop(info) 
      do k=1,mp 
       pst(k)=p(k) 
      end do 
      call comtrans 
                                                                        
      mexe=0 
      do k=1,maxs 
       if(index(comln(k),'rd').gt.0)then 
        mexe=mexe+1 
        icomln(mexe)=k 
       end if 
      end do 
!      boolcom=.false. 
!      jexe=0
      do ii=1,mp
       pmin(ii)=p(ii)
       plast(ii)=p(ii)
      end do     

!     ******************************************************************
    case('rs')        ! read structure and parameters of the spectra 
!     ******************************************************************
      b_bool= b_noask
      if(index(comline,' q ').gt.0) b_noask=.true. 
      iwritear=0
      b_unify=.false. 
      call strcmd(comline,parfilesp,boolcom,b_unify,info)
      b_noask=b_bool
      parfile=parfilesp(1) 
      chisqmin=0.0 
      do ii=1,mp
       pmin(ii)=p(ii)
       plast(ii)=p(ii)
      end do 
      if(chstring(:24).eq.' '.and.jexe.eq.0) chstring= '&& sd'
      call comtrans 
!     ******************************************************************
    case('un')        ! unify two par files
!     ******************************************************************
      b_unify=.true. 
      b_ufile=.false. 
      if(index(comline,' q ').gt.0) b_ufile=.true. 
      call strcmd(comline,parfilesp,boolcom,b_unify,info) 
      write(nwr,'(a,/,a,/)')                                           &
      'the unified .par files are written on a new .par file',         &
      '(there is no representation of the unified files in the memory)'

       j=0 
       do k=1,maxs 
        if(parfilesp(k).ne.' ') then 
          j=j+1 
          queryar(j)=parfilesp(k) 
          helpar(j)='effi/structure/file/save' 
        end if 
       end do 
                                                                        
!       parfile='par.par'                                               
       if(j.gt.1) then 
        lq=j 
        lk=lq 
        do k=1,lq 
         ext(k)=' ' 
        end do 
        chdf=' ' 
        chin='parameter files used' 
        call query(lq,lk,chin,chdf) 
        if(lq.le.0)then 
         info=1 
         infotext(1)='effi/query' 
         infotext(2)='no substring selected or exited with (q/*)' 
         infotext(3)=' ' 
         goto 1 
        end if 
        parfile=queryar(lq) 
       else 
        if(j.eq.1)parfile=queryar(1) 
       end if 
       ch132=parfile 
       call nextchar(ch132,0,ipos,parfile,lfn) 
       if(lfn.eq.0) then 
        parfile='par.par' 
       end if 
       filetype='parameter' 
       exten='par' 
       if(b_unify)then 
        ch132=parfile 
        parfile='U'//ch132 
        chcom='effi/unify/file' 
       end if 
       call rdfname(filetype,parfile,exten,chcom,npl,nwr)                    
       if(parfile.eq.' ') goto 220 
       n1=2 
       open(unit=n1,file=parfile                                       &
                 ,status='unknown'                                     &
                 ,access='sequential'                                  &
                 ,form='formatted'                                     &
                 ,err= 220)                                            
       call save(n1,n2,cmch,b_unify) 
       close(unit=n1) 
       if(b_unify) return
  220 continue 

!     ******************************************************************
    case('tr')        ! handling of the matrix which coorelates variables
                      ! and parameters  of the theory
                      ! vj=Sum;aji*pi+Sum;bjik*pi*pk
!     ******************************************************************
      kwin=3 
      if(.not.b_win(kwin-1)) then 
       kwin=1 
       goto 310 
      end if 
      chwindim=storewin(3)

      call termprocess(chwindim,chkill(kwin),kwin) 
      if(chterm(kwin).eq.' ') then 
       kwin=1 
       goto 310 
      end if 
      winfile=chterm(kwin) 
      call window(kwin) 
      nwrwin=10+kwin 
      ncolwin=ncol(kwin) 
      if(ncolwin.gt.256) ncolwin=256 
                                                                        
      open(nwrwin,file=winfile                                         &
                 ,status='old'                                         &
                 ,access='sequential'                                  &
                 ,form='formatted'                                     &
                 ,err=310)                                             
                                                                        
      goto 320 
  310 continue 
      nwrwin=nwr 
      ncolwin=npl 
      ledit=leditbe+1 
  320 i=3 
      do while(comline(i:i).eq.' '.and.i.lt.30) 
       i=i+1 
      end do 
      ch2=comline(i:i+1) 
      call transmatrix(ch2,kwin,ledit,info) 
      if(nwrwin.ne.nwr) then 
       close(unit=nwrwin) 
       call killwin(chkill(3)) 
       chkill(3)=' ' 
      end if 
      call calpl('test') 

      call systemcmd(retwindowfocus)

!     ******************************************************************
    case('pa','co')   ! change of parameter and constants and their names
!     ******************************************************************
  400  continue 
       if(index(comline,' cs').gt.0) then
         call trlch(ncl,comline,k,out)
         do i=1,k
            jj=out(i)
            p(jj)=-p(jj)
         end do
         goto 410
       end if
    
       if(index(comline,' q').gt.0) then 
        call trlch(ncl,comline,k,out) 
        ch132=comline(3:) 
        i=k/2
        if(2*i.eq.k)then 
         do j=1,i 
          call nextchar(ch132,1,ipos,cp132,l) 
!          write(6,'(a,f10.1)')TRIM(cp132), out(2*j-1)
          jj=int(out(2*j-1)) 
          if(index(comline(1:2),'pa').gt.0)then 
           ii=l-index(cp132(:l),'.') 
           p(jj)=out(2*j) 
           i1=ii-(ichar(np(jj)(32:32))-i0) 
           if(i1.gt.0) then 
            ch2=np(jj)(29:30) 
            i10=ic2(ch2)+i1 
            np(jj)(29:30)=ci2(i10) 
            np(jj)(32:32)=char(ii+i0) 
           end if 
          end if 
          if(index(comline(1:2),'co').gt.0) then 
           con(jj)=out(2*j) 
!          write(6,'(a)') ncon(jj)                                      
           if(ncon(jj)(33:33).eq.'f')then 
            ii=l-index(cp132(:l),'.') 
            i1=ii-(ichar(ncon(jj)(37:37))-i0) 
            if(i1.gt.0) then 
             ch2=ncon(jj)(34:35) 
             i10=ic2(ch2)+i1 
             ncon(jj)(34:35)=ci2(i10) 
             ncon(jj)(37:37)=char(ii+i0) 
            end if 
           end if 
          end if 
          call nextchar(cp132,1,ipos,ch132,l) 
         end do 
        end if 
        goto 410 
       end if 
                                                                        
                                                                        
       do k=1,maxscr 
        npanum(k)=0 
       end do 
       chcom='effi/change/parameter' 
!     write(6,'(2a)') ' effi pc vor comln1:',comline(1:50)             
       ienter=1 
       call comln1(comline,chcom,ienter) 
       if(comline(1:1).eq.'*') goto 1 
       cb2=comline 
       if(comline.ne.' '.and.comline(1:1).ne.'b') then 
        chflen=TRIM(comline)//' '//chstring 
        chstring=chflen 
       end if 
                                                                        
        i=index(comline,'&&') 
        if(i.gt.0) then 
         if(cb2.eq.'pa') chin='p '//comline(3:i-1) 
         if(cb2.eq.'co') chin='c '//comline(3:i-1) 
        else 
         if(cb2.eq.'pa') chin='p '//comline(3:) 
         if(cb2.eq.'co') chin='c '//comline(3:) 
        end if 
!       direct change of 1 parameter                                    
        ieq=index(chin,'=') 
        if(ieq.gt.0) then 
         ch132=chin(ieq+1:) 
         chin(ieq:)=' ' 
         call trlch(20,ch132,k,out) 
         spc=out(1) 
        end if 
                                                                        
        if(cb2.eq.'pa') then 
         ledit=leditbe+1 
         ipc=1 
        end if 
        if(cb2.eq.'co') then 
         ledit=leditbe+2  
         ipc=2 
        end if 
       call paident(info,chin) 
       if(info.gt.0) goto 1 
                                                                        
       if(ieq.gt.0)then 
        k=maxc+maxp 
        if(ipc.eq.1.and.npanum(maxc+2).eq.1)p(npanum(maxc+3))=spc 
        if(ipc.eq.2.and.npanum(k+2).eq.1)con(npanum(k+3))=spc 
        goto 410 
       end if 
                                                                        
       if(ienter.eq.3) then 
        chin=comline(3:) 
        comline=cb2//' '//cb2//chin 
        call comln1(comline,chcom,ienter) 
        goto 400 
       end if 
       if(ienter.eq.2) then 
         call comln1(comline,chcom,ienter) 
         ienter=0 
       end if 
      if(ienter.eq.0) then 
       ienter=1 
       chin=cb2//' b1l' 
       call comln1(chin,chcom,ienter) 
      end if 
!      write(6,'(2a)') ' pc nach comln1(2):',comline                    
       nn=2 
       call parm(nn,ledit,chisqmin) 
       if(nn.lt.0) info=abs(nn) 
  410  call calpl('test') 
                                                                        
!     ******************************************************************
    case('pc')        ! parameter, constants                         
!     ******************************************************************
      ledit=leditbe+3 
      if(ledit.gt.10) then 
       chin='c all' 
       call paident(info,chin) 
       if(info.gt.0) goto 1 
       nn=2 
       call parm(nn,ledit,chisqmin) 
       chin='p all' 
       call paident(info,chin) 
       if(info.gt.0) goto 1 
       nn=2 
       call parm(nn,ledit,chisqmin) 
      else 
       chcom='effi/editor/pc' 
       call help(chcom) 
      end if 

!     ******************************************************************
    case('ws')        ! write structure                                   
!     ******************************************************************
      n2=1 

      i10=index(comline,'yes') 
      if(i10.gt.3)then 
       ch1='y' 
       b_unify=.false. 
       n2=10 
       goto 510 
      end if 
      i10=index(comline,'no') 
      if(i10.gt.3)then 
       ch1='n' 
       b_unify=.false. 
       goto 510 
      end if 

      i10=index(comline,'.par')
      if(i10.gt.0)then
       parfile=TRIM(comline(4:i10+3))
       goto 515
      end if                                                                  
      querytype='write structure on file' 
      ch1='y' 
      chcom='effi/write/structure' 
      call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
      b_unify=.false. 
                                                                        
 510  continue
       if(ch1.eq.'n')then
         call save(nwr,1,cmch,b_unify) 
         goto 520
       end if
       j=0 
       do k=1,maxs 
        if(parfilesp(k).ne.' ') then 
          j=j+1 
          queryar(j)=parfilesp(k) 
          helpar(j)='effi/structure/file/save' 
        end if 
       end do 
                                                                        
       if(i10.gt.0.and.j.eq.1)then 
        parfile=queryar(1) 
        goto 515 
       end if 
                                                                        
!       parfile='par.par'                                               
       lq=0
       if(j.gt.1) then 
        lq=j 
        lk=lq 
        do k=1,lq 
         ext(k)=' ' 
        end do 
        chdf=' ' 
        chin='parameter files used' 
        call query(lq,lk,chin,chdf)
        
        if(lq.le.0)then 
         info=1 
         infotext(1)='effi/query' 
         infotext(2)='no substring selected or exited with (q/*)' 
         infotext(3)=' ' 
         goto 520 
        end if 
        parfile=queryar(lq)
        chcom='effi/unify/auto'
       else 
        if(j.eq.1)parfile=queryar(1) 
       end if 
       ch132=parfile 
       call nextchar(ch132,0,ipos,parfile,lfn) 
       if(lfn.eq.0) then 
        parfile='par.par' 
       end if 
       filetype='parameter' 
       exten='par' 
       if(b_unify)then 
        ch132=parfile 
        parfile='U'//ch132 
        chcom='effi/unify/file' 
       end if 
       call rdfname(filetype,parfile,exten,chcom,npl,nwr)
       if(lq.gt.1)call help(chcom)
       i10=LEN_TRIM(parfile)
       cmch=' '
       if(parfile(i10:i10).eq.'#')then
        cmch='ccor'
        parfile(i10:i10)=' '
       end if
  
       if(parfile.eq.' ') goto 520 
  515  n1=2 
       open(unit=n1,file=parfile                                       &
                 ,status='unknown'                                     &
                 ,access='sequential'                                  &
                 ,form='formatted'                                     &
                 ,err= 520)                                            
       call save(n1,n2,cmch,b_unify) 
       close(unit=n1) 
       if(b_unify) return

  520 continue 

!     ******************************************************************
    case('rd')        ! read data                                        
!     ******************************************************************
!     n1=input unit                                                     
!     data can only be read, if a frame theory is selected              
!     n1=0 no new input of data (change of structure elements)          
      if(b_nd) then 
        comline=' ' 
        goto 1 
      end if
      call datcmd(comline,parfilesp,boolcom,info) 
!     ******************************************************************
    case('sd')        ! read data of the session again 
!     ******************************************************************
      mexe=0 
      do k=1,maxs 
       if(ktheo(k,0,0).gt.0)then
        mexe=mexe+1 
        icomln(mexe)=k
        call itoc8(ch8,k) 
        comln(k)='rd '//TRIM(datfilesp(k))//'  ks='//ch8
       end if
      end do 
      boolcom=.true. 
      comline=' ' 
      jexe=0 
                                                                        
!     ******************************************************************
    case('ed')        ! editoren                           
!     ******************************************************************
  700  continue 
       chcom='effi/editor/pa_co' 
!      write(6,'(2a)') ' effi pc vor comln1:',comline(1:50)             
       ienter=1 
       call comln1(comline,chcom,ienter) 
       if(comline(1:1).eq.'*') goto 1 
       cb2=comline 
       if(comline.ne.' '.and.comline(1:1).ne.'b') then 
        chflen=TRIM(comline)//' '//chstring 
        chstring=chflen 
       end if 
                                                                        
        i=index(comline,'&&') 
        if(i.gt.0) then 
         chin=comline(3:i-1) 
        else 
         chin=comline(3:) 
        end if 
                                                                        
       if(ienter.eq.3) then 
        chin=comline(3:) 
        comline=cb2//' '//cb2//chin 
        call comln1(comline,chcom,ienter) 
        goto 700 
       end if 
       if(ienter.eq.2) then 
         call comln1(comline,chcom,ienter) 
         ienter=0 
       end if 
      if(ienter.eq.0) then 
       ienter=1 
       chin=cb2//' b1l' 
       call comln1(chin,chcom,ienter) 
      end if 
                                                                        
      call nextchar(chin,0,ipos,cp132,ia) 
      if(cp132(1:2).eq.'jo')leditbe=10 
      if(cp132(1:2).eq.'em')leditbe=20 
      if(cp132(1:2).eq.'ed')leditbe=30   ! editor $EDITOR
      if(cp132(1:2).eq.'no'.or.cp132(1:2).eq.'le')leditbe=0 

!     ******************************************************************
    case('pl')        ! plot
!     ******************************************************************
      call plot_punch(comline,info) 
      if(comline(1:1).eq.'*'.or.info.gt.0) goto 810 
      b_quit=.false. 
      if(index(comline,' q').gt.0)b_quit=.true. 
      if(comline.ne.' ') then 
       chflen=TRIM(comline)//chstring 
       chstring=chflen 
      end if 
      jseq(0)=npanum(2)
      do i=1,jseq(0) 
       jseq(i)=npanum(i+2) 
      end do 
      if(jseq(0).gt.maxs) then 
       write(nwr,'(i3,a)')jseq(0),' spectra are in the plot list' 
       write(nwr,'(a,i2,a)')' the plot list is limited to ',maxs,' spectra'
       jseq(0)=maxs 
      end if 

     if(jseq(0).eq.0) then 
       call plotexita() 
       do i=1,maxs 
        do j=1,4 
         thstring(i,j)=' ' 
        end do 
        whandle(i)=-i 
       end do
       print'(a)','nothing to plot'
       goto 1 
      end if 
      do i=1,jseq(0) 
       ks=jseq(i) 
       hold=0 
       if(i.eq.jseq(0)) hold=1 
       if(b_quit) hold=0 
  806  if(abs(ktheo(ks,0,0)).gt.0.or.b_datset(ks)) then 
        n1=ndispmode(ks) 

        cmch='plot'
        call frametheory(ks,cmch,n1,info) 
       end if 
       if(info.gt.0) goto 1 
       n1=1 
       if(abs(ktheo(ks,0,0)).gt.0) n1=0 
       nth=ktheo(ks,0,1) 
       lth=ktheo(ks,0,2) 
       call getname(0,nth,lth,chin,nametheory(ks)) 
       
       ia=ks/10 
       ch2=char(ia+i0)//char(i0+ks-10*ia) 
       wdescript='set='//ch2//nametheory(ks) 
       kshandle=ks 
       cmch='plex'
       call frametheory(ks,cmch,n1,info) 
!        write(6,'(a,6i6)') 'ks  sizex,sizey,posx,posy=', &              
!                       ks, sizex(ks),sizey(ks),posx(ks),posy(ks)     
       if(kshandle.eq.-1) goto 810 
       if(kshandle.gt.0) then 
         ks=kshandle 
         goto 806 
       end if
      end do 
  810 continue 
!     ******************************************************************
    case('wi')        ! window handling 
!     ******************************************************************
      chcom='effi/window/number' 
      lwin=5 
      queryar(1)=' output window for command  {sh}' 
      queryar(2)=' output window for transformation matrices {tr}' 
      queryar(3)=' output window for commands {li}' 
      queryar(4)=' output window for commands {he}, {he ab}' 
      queryar(5)=' output window for fit results {ft ...}' 
      do i=1,lwin 
       if(b_win(i)) then 
        queryar(i)(73:75)='[y]' 
       else 
        queryar(i)(73:75)='[n]' 
       end if 
      end do 
      nwrwin=nwr 
      call readyn(comline,lwin) 
      do i=1,lwin 
       if(queryar(i)(74:74).eq.'y')then 
        b_win(i)=.true. 
       else 
        b_win(i)=.false. 
       end if 
      end do 
      do i=1,lwin
       if(.not.b_win(i)) then 
        if(chkill(i+1).ne.' ') then 
         call killwin(chkill(i+1)) 
         chkill(i+1)=' ' 
        end if 
        nwrwin=nwr 
        ncolwin=npl 
        if(i.eq.3) id1=1 
       end if 
      end do 
      if(index(comline,'&&').gt.0)chstring=comline 

!     ******************************************************************
    case('te')        ! test  chi**2                            
!     ******************************************************************
      kwin=6 
      if(.not.b_win(kwin-1)) goto 1010
      
      chwindim=storewin(6)
      if(chkill(kwin).eq.' ') then 
       call termprocess(chwindim,chkill(kwin),kwin) 
      end if 
      if(chterm(kwin).eq.' ') goto 1010 
                                                                        
      winfile=chterm(kwin) 
      call window(kwin) 
      nwrwin=10+kwin 
      ncolwin=ncol(kwin) 
      if(ncolwin.gt.256) ncolwin=256 
      open(nwrwin,file=winfile                                         &
                 ,status='old'                                         &
                 ,access='sequential'                                  &
                 ,form='formatted'                                     &
                 ,err=1010)                                            
                                                                        
      goto 1020 
 1010 continue 
       if(chkill(kwin).ne.' ') then 
        call killwin(chkill(kwin)) 
        chkill(kwin)=' ' 
       end if 
      nwrwin=nwr 
      ncolwin=npl 
                                                                        
 1020 continue
      call cpu_time(start)
      call wall_time(wstart)      
      call subtest(comline,chisqmin,info)
      if(nwrwin.ne.nwr) close(unit=nwrwin) 
      if(index(comline,'&&').gt.0)chstring=comline 
      if(nwrf.eq.2) then 
       close(unit=nwrf) 
       nwrf=nwr 
      end if
      call cpu_time(finish)
      call wall_time(wfinish)
     call systemcmd(retwindowfocus)

      print '(" cpu/wall time = ",2f8.3," seconds.")',finish-start,wfinish-wstart 
!     ******************************************************************
    case('dm')        ! change  display mode 
!     ******************************************************************
 1100 continue 
      call lc_character(comline) 
      ienter=1 
      call comln1(comline,chcom,ienter) 
      if(comline(1:1).eq.'*') goto 1 
      cb2=comline 
!     write(6,'(2a)') ' comline=',comline(1:50)                         
      if(comline.ne.' '.and.comline(1:1).ne.'b') then 
        chflen=TRIM(comline)//' '//chstring 
        chstring=chflen 
       end if 
       
       i=index(comline,'&&') 
       if(i.gt.0) then 
        chin=comline(3:i-1) 
       else 
        chin=comline(3:) 
       end if 
                                                                        
       if(ienter.eq.3) then 
        chin=comline(3:) 
        comline=cb2//' '//cb2//chin 
        call comln1(comline,chcom,ienter) 
        goto 1100 
       end if 
       if(ienter.eq.2) then 
         call comln1(comline,chcom,ienter) 
         ienter=0 
       end if 
      if(ienter.eq.0) then 
       ienter=1 
       chin=cb2//' b1l' 
       call comln1(chin,chcom,ienter) 
      end if 
                                                                        
!
      do ks=1,maxs 
       if(abs(ktheo(ks,0,0)).gt.0) then 
        chdf=displaymode(ks,ndispmode(ks)) 
        cmch='dmod'                                   
        if(chdf.eq.' ') call frametheory(ks,cmch,n1,info)
        
        if(cmch.ne.'dmod')then
          call itoc8(ch8,ks)
          chstring=' && '//cmch(1:2)//' '//ch8 
          goto 1
        end if  
        if(info.gt.0) goto 1 
       end if 
      end do 
      call disp_mode(comline,info) 
      comline=chstring 

!     ******************************************************************
    case('fi')        ! fix  parameter
!     ******************************************************************
      n1=3 
      chcom='effi/command/fi' 

      ch132=chstring 
      j=132 
      do while(comline(j:j).eq.' ') 
       j=j-1 
      end do 
      chstring=comline(1:j+1)//ch132 
      comline(j+1:)=' ' 
                                                                        
 1215 continue 
      mfit=0 
      ch2=comline 
      call lc_character(comline) 
      ienter=1 
      call comln1(comline,chcom,ienter) 
      if(comline(1:1).eq.'*') goto 1 
      cb2=comline 
                                                                        
      i=index(comline,'&&') 
      if(i.eq.0) then 
       ch132='p '//comline(3:) 
      else 
       ch132='p '//comline(3:i-1) 
       chstring=comline 
      end if 
      chin=ch132 
      call paident(info,chin) 
      if(info.gt.0) goto 1 
                                                                        
      if(ienter.eq.3) then 
       chin=comline(3:) 
       comline=ch2//' '//cb2//chin 
       call comln1(comline,chcom,ienter) 
       goto 1215 
      end if 
      if(ienter.eq.2) then 
        call comln1(comline,chcom,ienter) 
        ienter=0 
      end if 
      if(ienter.eq.0) then 
       ienter=1 
       chin=ch2//' b1l' 
       call comln1(chin,chcom,ienter) 
      end if 
      call parm(n1,ledit,chisqmin) 
      if(n1.lt.0) info=abs(n1) 
      comline=chstring 

 
!     ******************************************************************
    case('fr')        ! free  parameter
!     ******************************************************************
      n1=4 
      chcom='effi/command/fr' 
       ch132=chstring 
       j=132 
       do while(comline(j:j).eq.' ') 
        j=j-1 
       end do 
!       write(6,'(2a)') ' comline=',comline(1:50)                       
       chstring=comline(1:j+1)//ch132 
       comline(j+1:)=' ' 
                                                                        
 1300 continue 
      mfit=0 
      ch2=comline 
                                                                        
!      write(6,'(2a)') ' free effi comline=',comline(1:50)              
      call lc_character(comline) 
      ienter=1 
      call comln1(comline,chcom,ienter) 
      if(comline(1:1).eq.'*') goto 1 
!     write(6,'(a,i2,a)') 'ienter,comline=',ienter,comline(1:50)        
      cb2=comline 
                                                                        
      i=index(comline,'&&') 
      if(i.eq.0) then 
       ch132='p '//comline(3:) 
      else 
       ch132='p '//comline(3:i-1) 
       chstring=comline 
      end if 
      chin=ch132 
      call paident(info,chin) 
      if(info.gt.0) goto 1 
                                                                        
      if(ienter.eq.3) then 
       chin=comline(3:) 
       comline=ch2//' '//cb2//chin 
       call comln1(comline,chcom,ienter) 
       goto 1300 
      end if 
      if(ienter.eq.2) then 
        call comln1(comline,chcom,ienter) 
        ienter=0 
      end if 
      if(ienter.eq.0) then 
       ienter=1 
       chin=ch2//' b1l' 
       call comln1(chin,chcom,ienter) 
      end if 
                                                                        
      call parm(n1,ledit,chisqmin) 
      if(n1.lt.0) info=abs(n1) 
      comline=chstring 

!     ******************************************************************
    case('dr')        ! data regions inc,exc
!     ******************************************************************
       chisqmin=0.0
       call ft_excinc(comline,info)
       i=index(comline,'dr')+2
       l=index(comline,'c')-1;  
!     ******************************************************************
    case('fc')        ! fit conditions
!     ******************************************************************
      ienter=1 
      i=0 
      k=1 
      do while(i.eq.0.and.k.le.6) 
       chft=ftrt(k) 
       i=index(comline,ft_2(k)) 
       k=k+1 
      end do 
      call ft_condition(comline,ienter,chft,info) 
!     ******************************************************************
    case('ft')        ! fit newton's, gradient, and Marquardt  methods
!     ******************************************************************
      kwin=6 
      if(.not.b_win(kwin-1)) goto 1610 
      chwindim=storewin(6)
      if(chkill(kwin).eq.' ') then 
       call termprocess(chwindim,chkill(kwin),kwin) 
      end if 
      if(chterm(kwin).eq.' ') goto 1610 
                                                                        
      winfile=chterm(kwin) 
      call window(kwin) 
      nwrwin=10+kwin 
      ncolwin=ncol(kwin) 
      if(ncolwin.gt.256) ncolwin=256 
      open(nwrwin,file=winfile                                         &
                 ,status='old'                                         &
                 ,access='sequential'                                  &
                 ,form='formatted'                                     &
                 ,err=1610)                                            
                                                                        
      goto 1620 
 1610 continue 
       if(chkill(kwin).ne.' ') then 
        call killwin(chkill(kwin)) 
        chkill(kwin)=' ' 
       end if 
      nwrwin=nwr 
      ncolwin=npl 

 1620 continue
       call cpu_time(start)
       call fitcmd(comline,chft,chft_last,path1_last,path2_last,        &
                   iter,chisqmin,chisq_1,chisq,chi_p,info)               
      if(nwrwin.ne.nwr) close(unit=nwrwin) 
      
      call cpu_time(finish) 
      print '(" runtime = ",f15.3," seconds.")',finish-start 
      call systemcmd(retwindowfocus)
                                                                  
      if(info.eq.0) mfit=1 
!     ******************************************************************
    case('ep')        ! explore
!     ******************************************************************
      call explore(comline,chisqmin,kshandle,info) 
      if(comline(1:1).eq.'*') goto 1 
      if(comline.ne.' ') then 
       chflen=TRIM(comline)//' '//chstring 
       chstring=chflen
      end if 
!     ******************************************************************
    case('se')        ! search
!     ******************************************************************
      call search(comline,chisqmin,kshandle,info) 
      if(comline(1:1).eq.'*') goto 1 
      if(comline.ne.' ') then 
       chflen=TRIM(comline)//' '//chstring 
       chstring=chflen
      end if 

!     ******************************************************************
    case('li')        ! list of theories and spectra
!     ******************************************************************
       if(index(comline(4:),'bf').gt.0) then
        print'(a)',(TRIM(cmdbuff(i)),i=1,mbuf)
        goto 1
       end if 
      id1=4 
      kwin=4 
      if(index(comline,'wi').gt.0)then 
       queryar(1)=' output window for command  {sh}' 
       queryar(2)=' output window for transformation matrices {tr}' 
       queryar(3)=' output window for commands {li}' 
       queryar(4)=' output window for commands {he}, {he ab}' 
       queryar(5)=' output window for fit results {ft ...}' 
       do i=1,5 
        if(b_win(i)) then 
         queryar(i)(73:75)='[y]' 
        else 
         queryar(i)(73:75)='[n]' 
        end if 
       end do 
      end if 
      if(.not.b_win(kwin-1)) goto 1810 
                                                                        
      chwindim=storewin(4)
      if(chkill(kwin).eq.' ') then 
       call termprocess(chwindim,chkill(kwin),kwin) 
       if(chterm(kwin).eq.' ') id1=1 
      end if 
                                                                        
      winfile=chterm(kwin) 
      call window(kwin) 
      nwrwin=10+kwin 
      ncolwin=ncol(kwin) 
      if(ncolwin.gt.256) ncolwin=256 
      open(nwrwin,file=winfile                                          &
                  ,status='old'                                         &
                  ,access='sequential'                                  &
                  ,form='formatted'                                     &
                  ,err=1810)                                            
      goto 1820 
 1810 continue 
       if(chkill(kwin).ne.' ') then 
        call killwin(chkill(kwin)) 
        chkill(kwin)=' ' 
       end if 
       nwrwin=nwr 
       ncolwin=npl 
       id1=1 
 1820 call list(comline,1,info) 
      call systemcmd(retwindowfocus)

!     ******************************************************************
    case('lo')        ! loop limit loopmax, loopwarning
!     ******************************************************************
      if(index(comline,'off').gt.0) then
       loopwarning=loopmax
      else 
       querytype='limit of the loop count loop_max' 
       form='i5' 
       chcom='effi/loop/loopmax' 
       value=float(loopmax) 
       call askvalue(querytype,form,value,chcom,npl,nrd,nwr) 
       loopmax=int(value) 
       querytype='loop warning number ' 
       form='i5' 
       chcom='effi/loop/loopwarn' 
       value=float(loopwarning) 
       call askvalue(querytype,form,value,chcom,npl,nrd,nwr) 
       loopwarning=int(value) 
      end if
!     ******************************************************************
    case('sh')        ! show parameters and matrices 
!     ******************************************************************
 2000 continue 
      call lc_character(comline) 
      chcom='effi/command/sh' 
      ienter=1 
      call comln1(comline,chcom,ienter) 
!      write(6,'(2a)') ' fi,fr comline=',comline(1:50)                  
      if(comline(1:1).eq.'*') goto 1 
      cb2=comline 
      i=index(comline,'&&') 
      if(i.eq.0) then 
       j=index(comline,'ma') 
       if(j.eq.0) then 
        ch132='p '//comline(3:) 
        n1=5 
       else 
        ch132=comline(j+2:) 
        n1=6 
       end if 
      else 
       j=index(comline(1:i-1),'ma') 
       if(j.eq.0) then 
        ch132='p '//comline(3:i-1) 
        n1=5 
       else 
        ch132=comline(j+2:i-1) 
        n1=6 
       end if 
      end if 
!      write(6,'(2a)') ' vor pai ch132=',ch132(1:50)                    
      if(j.eq.0) then 
       infotext(8)=comline 
       chin=ch132 
       call paident(info,chin) 
      else 
       chsto=ch132 
       call trlch(80,ch132,k,out) 
       if(index(ch132,' a').gt.0) k=1 
       if(k.eq.0)then 
        info=1 
        infotext(1)=' ' 
        infotext(2)='no numbers defined (see {he sh})' 
        infotext(3)=' ' 
        goto 1 
       end if 
       chin='p all' 
       call paident(info,chin) 
       i=1
       call panum(chsto,maxco,npanum,i) 
       if(i.ne.1) then
        print'(2a)','error in the list:',TRIM(chsto)
        goto 1
       end if         
      end if 
      if(info.gt.0) goto 1 
                                                                        
!     write(6,'(2a)') ' mos comline=',comline(1:50)                     
       if(ienter.eq.3) then 
        chin=comline(3:) 
        comline='sh '//cb2//chin 
        call comln1(comline,chcom,ienter) 
        goto 2000 
       end if 
       if(ienter.eq.2) then 
         call comln1(comline,chcom,ienter) 
         ienter=0 
       end if 
      if(ienter.eq.0) then 
       ienter=1 
       chin='sh b1l' 
       call comln1(chin,chcom,ienter) 
      end if 
                                                                        
      kwin=2 
      if(.not.b_win(kwin-1)) goto 2010 
      call itoc8(ch8,npl) 
      chwindim=storewin(2)
      if(chkill(kwin).eq.' ') then 
       call termprocess(chwindim,chkill(kwin),kwin) 
      end if 
      if(chterm(kwin).eq.' ') goto 2010 
                                                                        
      winfile=chterm(kwin) 
      call window(kwin) 
      nwrwin=10+kwin 
      ncolwin=ncol(kwin) 
      if(ncolwin.gt.256) ncolwin=256 
      open(nwrwin,file=winfile                       &
                 ,status='old'                       &
                 ,access='sequential'                &
                 ,form='formatted'                   &
                 ,err=2010)                                            
!      write(nwrwin,'(a1,a3,a,a1,a3)')char(27),'[1m',comline,char(27),'[0m'
      goto 2020 
 2010 continue
      if(chkill(kwin).ne.' ') then 
       call killwin(chkill(kwin)) 
       chkill(kwin)=' ' 
      end if 
      nwrwin=nwr 
      ncolwin=ncol(1) 
 2020 continue 
      call parm(n1,ledit,chisqmin) 
      if(n1.lt.0) info=abs(n1) 
      if(nwrwin.ne.nwr) then 
       write(nwrwin,'(/)') 
       close(unit=nwrwin) 
      end if 
      call systemcmd(retwindowfocus)
    
!     ************************************************************      
    case('rm')        ! remove                                
!     ************************************************************      
      if(index(comline(3:5),'a').gt.0)then 
       call zerotrf 
       call zeroall 
       comline=chstring 
       goto 1 
      end if 
      lk=0 
      do ks=1,maxs 
       if(abs(ktheo(ks,0,0)).gt.0) lk=ks 
      end do 
      if(b_noask) then 
       ks=lk 
      else 
       comline='li sets' 
       call list(comline,0,info) 
                                                                        
       querytype=                                                       &
     &  'remove component/module/complete theory with data of set'      
       form='i3' 
       chcom='effi/set/remove' 
       value=float(lk) 
       call askvalue(querytype,form,value,chcom,npl,nrd,nwr) 
       if(querytype(1:1).eq.'*'.or.querytype(1:1).eq.'q') goto 1 
       ks=int(value) 
       if(ks.gt.maxs) ks=lk 
      end if 
      if(ks.eq.0) goto 1 
                                                                        
      do j=1,4 
                                                     ! 18.5.06          
       thstring(ks,j)(132:132)=char(0+i0) 
      end do 
      lq=0 
       call del_o(ks,lq) 
       write(nwr,'(a,i2,a)')' set number ',ks,' removed' 
       b_theoset(ks)=.false. 
       do i=0,maxthss 
         ktheo(ks,i,0)=0 
       end do  
      call calpl('test')                             ! 13.4.99    
      call getprop(info) 
                                                                        
      if(info.gt.0) goto 1 
                                                                        
!     remove data set ks                                                
      b_datset(ks)=.false. 
      ndispmode(ks)=1 
                                                                        
      do i=1,16 
       displaymode(ks,i)=' ' 
      end do 
      datfilesp(ks)=' ' 
      comline='&& sd '//chstring 

!     ******************************************************************
    case('ss')        ! subspectra
!     ******************************************************************
      call plot_punch(comline,info) 
      if(comline(1:1).eq.'*'.or.info.gt.0) goto 2201 
      if(comline.ne.' ') then 
       chflen=TRIM(comline)//' '//chstring 
       chstring=chflen 
      end if 
!     write(6,'(a,10i4)') ' npanum=',(npanum(i),i=1,10)                 
                                                                        
      jseq(0)=npanum(2) 
      do i=1,jseq(0) 
       jseq(i)=npanum(i+2) 
      end do 
      do i=1,jseq(0) 
       ks=jseq(i) 
!      write(6,'(a,i4,2x,L5)')'ks,b_theoset(ks)=',ks,b_theoset(ks)      
       if(b_theoset(ks)) then 
        n1=ndispmode(ks) 
        cmch= 'subs'; call frametheory(ks,cmch,n1,info) 
        if(info.gt.0) goto 2201 
       else 
        form='i2' 
        rn=ks 
        call trlnu(form,rn,chr,nn,chl,il) 
        info=1 
        infotext(1)='effi/subsets' 
        infotext(2)='theory is not calculated yet for data set s'//chl(:il)  
        infotext(2)='use the command {te s'//chl(:il)//'}' 
        infotext(3)=' ' 
        goto 1 
       end if 
      end do 
 2201 continue 

!     ******************************************************************
    case('su')        ! subtract subspectra
!     ******************************************************************
 2300 continue 
      ienter=1 
      call comln1(comline,chcom,ienter) 
      if(comline(1:1).eq.'*') goto 1 
!      write(6,'(i3,2a)')ienter,'=ienter comline=',comline(:60)         
      cb2=comline 
      i=index(comline,'&&') 
      if(i.eq.0) then 
       chin=comline(3:) 
      else 
       ch132=chstring 
       j=132 
       do while(comline(j:j).eq.' ') 
        j=j-1 
       end do 
       chstring=comline(i:j+1)//ch132 
       chin=comline(3:i-1) 
      end if 
      do k=3,i-1 
       if(chin(k:k).eq.'s')chin(k:k)=' ' 
      end do 
      i=1
      call panum(chin,maxs,npanum,i) 
      if(i.ne.1) then
       print'(2a)','error in the list:',TRIM(chin)
       goto 1
      end if         
      do j=1,npanum(2) 
       npa=npanum(j+2) 
       if(.not.b_theoset(npa)) then 
        npanum(j+2)=0 
        npanum(2)=npanum(2)-1 
        write(nwr,'(a,i2,a)')'** set ',npa,':theory not calculated **' 
       end if 
      end do 
      j=npanum(2)
       i=-1
       call panum(chin,j,npanum,i) 
       if(i.ne.-1) then
        print'(2a)','error in the list:',TRIM(chin)
        goto 1
       end if         
       if(ienter.eq.3) then 
        chin='su '//cb2//comline(3:) 
        call comln1(chin,chcom,ienter) 
        goto 2300 
       end if 
       if(ienter.eq.2) then 
        call comln1(comline,chcom,ienter) 
        ienter=0 
       end if 
       if(ienter.eq.0) then 
        ienter=1 
        chin='su b1l' 
        call comln1(chin,chcom,ienter) 
       end if 
                                                                        
                                                                        
       hold=1 
       jseq(0)=npanum(2) 
       do i=1,jseq(0) 
        jseq(i)=npanum(i+2) 
       end do 
!      write(6,'(a,10i4)') ' jseq=',(jseq(i),i=1,jseq(0))               
       do i=1,jseq(0) 
        ks=jseq(i) 
!       write(6,'(a,10i4)') ' ks=',ks                                   
 2306   if(b_datset(ks)) then 
         n1=ndispmode(ks) 
         kshandle=ks 
         n1=1 
         if(abs(ktheo(ks,0,0)).gt.0) n1=0 
         nth=ktheo(ks,0,1) 
         lth=ktheo(ks,0,2) 
         call getname(0,nth,lth,chin,nametheory(ks)) 
         ia=ks/10 
         ch2=char(ia+i0)//char(i0+ks-10*ia) 
         wdescript='set='//ch2//nametheory(ks) 
         cmch='subt'; call frametheory(ks,cmch,n1,info) 
         if(info.gt.0) goto 1 
         kshandle=ks 
         cmch='plex' ; call  frametheory(ks,cmch,n1,info) 
!        write(6,'(a,10i4)') ' info,n1=',info,n1,kshandle               
         if(kshandle.gt.0) then 
          ks=kshandle 
          goto 2306 
         end if 
        else 
         write(nwr,'(a,i2,a2)') '** no data available for set ',ks,'**' 
        end if 
       end do 
                                                                        
!     ******************************************************************
    case('wr')        ! printout of results
!     ******************************************************************
      if(mfit.eq.0) then 
        write(nwr,'(a)') ' no results ' 
        goto 1 
      end if 
      mf=0 
      do k=1,mp 
       if(kp(k).eq.1) then 
        mf=mf+1 
        kf(mf)=k 
       end if 
      end do 
      call pricmd(comline,parfile,mf,chisq,chi_p,lappendres,info) 

!     ******************************************************************
    case('wd')        ! punch display buffer 
!     ******************************************************************
      call punch_str(comline,info) 
!       write(6,'(2a)') 'ecmd comline=',comline(1:80)                   
      i=index(comline,'&&') 
      if(i.gt.0) then 
       ch132=chstring 
       j=132 
       do while(comline(j:j).eq.' ') 
        j=j-1 
       end do 
       chstring=comline(i:j+1)//ch132 
       comline(i:)=' ' 
      end if 
                                                                        
      if(info.gt.0.or.comline(1:1).eq.'*'.or.comline(1:1).eq.'q')goto 1 
                                                                        
      ch132=comline 
      call lc_character(ch132) 
                                                                        
      i=index(ch132,'fmt:')-1 
      chin=ch132(3:i)                ! contains the set numbers
      chstr=ch132(i+5:) 

      do k=1,i 
       if(chin(k:k).eq.'s')chin(k:k)=' ' 
      end do 
      i=1
      call panum(chin,maxs,npanum,i) 
      if(i.ne.1) then
       print'(2a)','error in the list:',TRIM(chin)
       goto 1
      end if         
      jseq(0)=npanum(2) 
      do i=1,jseq(0) 
       jseq(i)=npanum(i+2) 
      end do 
!      write(6,'(a,20i3)') ' jseq=',(jseq(jj),jj=1,jseq(0))             
      querytype='extension of the files (display) '
      ch132='dsp'
      chcom='effi/display/ext' 
      call askstring(querytype,ch132,chcom,ncl,nwr)
      exten=ch132                                              

      do i=1,jseq(0) 
       ks=jseq(i) 
       if(abs(ktheo(ks,0,0)).gt.0) then 
        cmch='dmod' ; call frametheory(ks,cmch,n1,info) 
        cmch='plot' ; call frametheory(ks,cmch,n1,info) 
        if(info.gt.0) goto 1 

        if(b_datset(ks))then 
         punfile=datfilesp(ks) 
!         write(6,'(i3,2a)')ks,' punfile=',punfile                      
         ih=0 
         lfn=0 
!        only filename for current directory                            
         j=132 
         do while(ih.eq.0.and.j.gt.0) 
          if(punfile(j:j).eq.'/') ih=j 
          j=j-1 
         end do 
         if(ih.gt.0) then 
          ct132=punfile 
          punfile=ct132(ih+1:) 
         end if 
         id=index(punfile,'.') 
         if(id.gt.1) then 
          ct132=punfile 
          punfile=ct132(:id)//exten 
          lfn=id+3 
         end if 
         if(lfn.eq.0) then 
          punfile='data.'//exten 
          filetype='display' 
          call rdfname(filetype,punfile,exten,chcom,npl,nwr) 
          if(punfile.eq.' ') goto 1 
         end if 
         write(nwr,'(a,i2,a2,a)')' file of set ',ks,': ',TRIM(punfile) 
        else if(b_theoset(ks)) then 
         punfile=parfilesp(ks)
         k=index(punfile,'.'); 
         if(k.eq.0)then
          punfile=parfilesp(1); k=index(punfile,'.')
         end if
         punfile(k+1:)=exten 
         filetype='display' 
         call rdfname(filetype,punfile,exten,chcom,npl,nwr)
         if(punfile.eq.' ') goto 1 
         if(jseq(0).gt.1) then 
          k=index(punfile,'.') 
          exten=punfile(k+1:k+3) 
          i10=ks/10 
          if(i10.gt.0)then 
           i1=ks-i10*10 
           ch2=char(i10+i0)//char(i1+i0) 
           punfile(k:)='_'//ch2//'.'//exten 
           write(nwr,'(a,i2,a2,a)')'file of set ',ks,': ',TRIM(punfile) 
          else 
           ch2='_'//char(ks+i0) 
           punfile(k:)=ch2//'.'//exten 
           write(nwr,'(a,i2,a2,a)')'file of set ',ks,': ',TRIM(punfile) 
          end if 
         end if 
        else 
         write(nwr,'(a,i2,a,/)')' set number ',ks,': no data or theory' 
         goto 2510 
        end if 
        nout=2 
        open(unit=nout,file=punfile                                     &
                   ,status='unknown'                                    &
                   ,access='sequential'                                 &
                   ,form='formatted')                                   
                                                                        
        plotstrpu=chstr 
        cmch='punc'
        call frametheory(ks,cmch,nout,info) 
        close(unit=nout) 
        k=index(punfile,'.')
        if(cmch.eq.'dim2') then 
         batfile=punfile(:k)//'bat' 
         open(unit=nout,file=batfile                                     &
                   ,status='unknown'                                    &
                   ,access='sequential'                                 &
                   ,form='formatted')                                   
         call writeallplobat(nout,punfile,allbat) 
         close(unit=nout)
        end if 
        if(info.gt.0) goto 1 
       end if 
 2510  continue 
      end do 
      comline=chstring 

!     ******************************************************************
    case('st')        ! status                                      
!     ******************************************************************
       call status(comline)
       i=index(comline,'9_plot')
       if(i.gt.0)chstring=comline(i+6:)
       print*,TRIM(chstring)
!     ******************************************************************
    case('he')        ! help                                       
!     ******************************************************************
      write(nwr,'(1x,a1,a3)') char(27),'[1A' 
      write(nwr,'(a)')' ***'//TRIM(comline)//'***' 
      ch132=comline(3:) 
      if(ch132.ne.' ')then 
       call nextchar(ch132,0,ipos,cp132,ia) 
       if(cp132(1:1).ne.'<')call lc_character(cp132)
       if(index(cp132,'/').gt.0) then 
        chcom=cp132 
       else 
        chcom='effi/command/'//cp132 
       end if 

       if(index(cp132,'*').gt.0) then
        cp132(1:1)=' '    ;if(index(cp132(2:2),'*').gt.0)cp132(2:2)=' ' 
        i=index(cp132,'*'); if(i.gt.0)cp132(i:)=' '
        chcom='effi/subject/'//TRIM(ADJUSTL(cp132))
       end if     
      else 
        chcom='effi/command/command' 
      end if 
      id1=5 
      kwin=id1
      if(.not.b_win(kwin-1)) goto 2710 
      chwindim=storewin(5)
      if(chkill(kwin).eq.' ') then 
       call termprocess(chwindim,chkill(kwin),kwin) 
       if(chterm(id1).eq.' ') id1=1 
      end if 
      goto 2720 
 2710 continue 
       if(chkill(kwin).ne.' ') then 
        call killwin(chkill(kwin)) 
        chkill(kwin)=' ' 
       end if 
      nwrwin=nwr 
      ncolwin=npl 
      id1=1 
 2720 call help(chcom) 
      call systemcmd(retwindowfocus)

!     *********************************************************         
    case('mc')        ! synthetik spectra by Monte Carlo          
!     ******************************************************************
      call  mc_command(comline,iseed,info)
      chft=' '
!     *********************************************************         
    case('ae')        ! author                              
!     *********************************************************         
       write(nwr,'(a,/)')'Hartmut Spiering, Email: spiering@uni-mainz.de'  
       chcom='effi/command/ae' 
       call help(chcom) 

!     *********************************************************         
    case('tp')        ! collected help topics                
!     *********************************************************         
       chcom='<effi>/tp][' 
       call help(chcom) 
       i=index(ch256(2:),'/')
       pathvariable=ch256(3:i)
       chcom='<'//TRIM(ch256(i+2:))//']['
       if(pathvariable.ne.' ')call help(chcom) 
       pathvariable='EFFIHEPATH'

!     *********************************************************         
    case('eu')        ! Euler angle                      
!     *********************************************************         
      write(nwr,'(a)')' see program effi/helproutines/euler/euler' 

!     *********************************************************         
    case('na')        ! command sequence from file       
!     *********************************************************         
     b_noask=.not.b_noask
     ii=index(comline,'noask.cmd') 
     call nextchar(comline,2,ipos,ct132,ih); print*,ipos,TRIM(ct132)   
     inquire(file=ct132,exist=b_file)
     if(.not.b_file)then 
      comline='na'
      write(nwr,'(a)') '**noask mode**' 
      write(nwr,'( /,a)')                                               &
        'command sequence from file:'                                  
      ct132='noask.cmd' 
      chcom='effi/noask/file' 
      filetype='noask' 
      exten='cmd' 
      if(ii.eq.0)call rdfname(filetype,ct132,exten,chcom,npl,nwr)
      inquire(file=ct132,exist=b_file)
     end if 
     if(b_file) then 
      open (unit=12,file=ct132                                         &
                         ,status='old'                                 &
                         ,access='sequential'                          &
                         ,form='formatted')                            
      chstring='&&&&' 
      write(nwr,'( /,a)')                                              &
        'result of command sequence to file:'                          
      ct132='noask.res' 
      chcom='effi/noask/file' 
      filetype='noask_result' 
      exten='res' 
      if(ii.gt.0)then 
       ct132=TRIM(effihome)//'/noask.res' 
!      write(6,'(a)')ct132                                             
       nwr=13 
       open (unit=13,file=ct132                                       &
                         ,status='unknown'                             &
                         ,access='sequential'                          &
                         ,form='formatted')                            
       ios=0 
       do while(ios.eq.0) 
        read(13,'(a)',IOSTAT=ios)ch132 
!        write(6,'(a)')ch132                                           
       end do 
       backspace(13) 
      else 
       call rdfname(filetype,ct132,exten,chcom,npl,nwr)
       nwr=13 
       open (unit=13,file=ct132                                        &
                         ,status='unknown'                             &
                         ,access='sequential'                          &
                         ,form='formatted')                            
      end if 
     else 
      b_noask=.not.b_noask 
     end if 

!     *********************************************************  
    case('tn')        ! readjust tensor to PAS
!     *********************************************************         
      call tensor(maxp,mp,p,nwr,nrd,ncl,info) 

 !     *********************************************************         
    case('ts')        ! theory structures printout 
!     *********************************************************         
      b_file=index(comline,' >').gt.0 
      i=index(comline,' >') 
      if(b_file)then 
       if(comline(3:i).eq.' ') comline(3:)=' menu' 
      else 
       if(comline(3:16).eq.' ') comline(3:)=' menu' 
      end if 
      ienter=1 
      call comln1(comline,chcom,ienter) 
      if(comline(1:1).eq.'*') goto 1 
      cb2=comline 
      i=index(comline,'&&') 
      if(i.eq.0) then 
       ch132=comline(3:) 
      else 
       ch132=comline(3:i-1) 
       ct132=comline(i:) 
      end if 
      call trlch(npl,ch132,nn,out) 
      iout=0 
      ih=0 
      il=0 
      if(nn.gt.0) iout=int(out(1)) 
      if(nn.gt.1) ih=int(out(2)) 
      if(nn.gt.2) il=int(out(3)) 
      if(comline(5:8).eq.'menu')iout=-1 
                                                                        
      call analysestr(iout,ih,il,b_file,info) 
      if(i.gt.0) comline=ct132 

!     *********************************************************         
    case('$g')        ! grep                             
!     *********************************************************         
      call grepR

!     *********************************************************         
    case('re')        ! restore/reset                             
!     *********************************************************         
      ienter=1 
      if(comline(3:).eq.' ') comline(4:4)='0'      
      call comln1(comline,chcom,ienter) 
!      if(comline(1:1).eq.'*') goto 1 
      cb2=comline

      i=index(comline,'&&') 
      if(i.gt.0) then 
       ch132=chstring 
       j=132 
       do while(comline(j:j).eq.' ') 
        j=j-1 
       end do 
       chstring=comline(i:j+1)//ch132 
      end if

!      if(ienter.eq.3) then 
!        chin=comline(3:) 
!        comline=cb2//' '//cb2//chin 
!        call comln1(comline,chcom,ienter) 
!        goto 2700 
!       end if 
!       if(ienter.eq.2) then 
!         call comln1(comline,chcom,ienter) 
!         ienter=0 
!       end if 
!      if(ienter.eq.0) then 
!       ienter=1 
!       chin=cb2//' b1l' 
!       call comln1(chin,chcom,ienter) 
!      end if 

      ch8=comline(3:)
!      write(6,*)i,'comline=',comline,'ch8=',ch8
      call c8toi(ch8,lq)
      if(lq.gt.0.and.lq.le.6) goto 2701
      lq=6 
      lk=6 
      chdf='ne' 
      chdf(80:80)='#' 
      if(index(comline,' q').gt.0) chdf(4:7)='quit' 
      helpar(1)='effi/parm/erase' 
      helpar(2)='effi/parm/last' 
      helpar(3)='effi/parm/minimum'
      helpar(4)='effi/parm/absminimum'
      helpar(5)='effi/parm/start' 
      helpar(6)='effi/pc/reset' 
                                                                
      queryar(1)='new fit steps'
      ch8=' ';if(plast(0).gt.0)ch8=chistring(plast(0)) 
      queryar(2)='last iteration step'//ch8 
      ch8=' ';if(pmin(0).gt.0)ch8=chistring(pmin(0)) 
      queryar(3)='minimum of last iteration'//ch8 
      ch8=' ';if(pabsmin(0).lt.1.0e10)ch8=chistring(pabsmin(0)) 
      queryar(4)='lowest minimum found'//ch8
      ch8=' ';if(pst(0).gt.0)ch8=chistring(pst(0)) 
      queryar(5)='start parameters'//ch8 
      queryar(6)='reset (all routines)' 
      chin='select by a substring' 
      do k=1,lk 
       ext(k)=' ' 
      end do 
      call query(lq,lk,chin,chdf) 
      if(lq.eq.0) then 
       info=1 
       infotext(1)='effi/query' 
       infotext(2)='no substring selected or exited with (q/*)' 
       infotext(3)=' ' 
       goto 1 
      end if 

2701  continue
      if(lq.eq.1) then 
       chisqmin=1.0e10
       p(0)=1.0e10 
       pathw=pathwidth 
       path1_last=pathw;  path2_last=pathw
       chft_last=' '
       write(nwr,'(a)')' value of chi**2 set to 1.0e10' 
       goto 1 
      else if(lq.eq.2) then 
       do ii=1,mp 
        p(ii)=plast(ii) 
       end do
       write(nwr,'(a)') 'back to last iteration '  
      else if(lq.eq.3) then 
       if( minsets(0).gt.0)then
        do ii=1,mp 
         p(ii)=pmin(ii) 
        end do
        write(nwr,'(a)')'chi**2 of optimal set belongs to the number of sets:'
        write(nwr,'(32i3)')(minsets(ii),ii=1,minsets(0)) 
        write(nwr,'(a)')'!! optimal set may get lost by change of sets/dr exc(lude)'
       else
        write(nwr,'(a)')'min chi**2 still belongs to the start parameter' 
       end if      
      else if(lq.eq.4) then
       if(index(ch8,'y').eq.0)then
        if(pabsmin(0).lt.1.0e10)then
         querytype='remove chi**2 value of lowest minimum' 
         ch1='n' 
         chcom='effi/yparm/absminimum' 
         call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
         if(ch1.eq.'y')then 
          pabsmin(0)=1.0e10
          write(nwr,'(a)') '  value of chi**2 set to 1.0e10'
         else       
          do ii=1,mp 
           p(ii)=pabsmin(ii) 
          end do
          write(nwr,'(a)') ' back to lowest minimum found'
         end if
        end if
       else
        chisqmin=100.
        pabsmin(0)=1.0e10;  p(0)=1.0e10
        pathw=pathwidth 
        path1_last=pathw;  path2_last=pathw
        chft_last=' '
        write(nwr,'(a)') '  value of chi**2 set to 1.0e10'   
       end if        
      else if(lq.eq.5) then 
       do ii=1,mp 
        p(ii)=pst(ii) 
       end do 
       write(nwr,'(a)') 'back to start parameters' 
!       chstring='&& te a'
       pst(0)=-2.0
      else if(lq.eq.6)then
       ocontrf=9999.
       ovartrf=9999.
       write(nwr,'(a)') 'reset of all routines'       
      end if 
      call zerotrf 
      call calpl('test') 
      comline=chstring
!     *********************************************************         
    case('ex')        ! exit                              
!     *********************************************************         
     write(nwr,'(a)') ' some commands of the session are stored '
     b_file=.false.  
     if(b_xwininfo) then
      call system("xwininfo -root -tree > treewindow")
      inquire(file='treewindow',exist=b_file)
     end if
     if(b_file)then
      open (unit=1,file='treewindow',status='old',        &
                    access='sequential',form='formatted')

      k=0
2800  read(1,'(a)',end=2804)ch132
      j=index(ch132,'cmd_')
      if(j.gt.0) then
         chl=ch132(j:j+5)
         k=k+1
         ii=LEN_TRIM(ch132)
         i=ii
         do while(ch132(i:i).ne.' ')
            i=i-1
         end do
         ! i-ii the new position +756+29 
         chr=ch132(i:ii)  !length lq=ii-i+1
         lq=ii-i+1
         call nextchar(ch132,0,ipos,cp132,ih)
         ch132='xwininfo -id '//cp132(:ih)//'  > result'
         call system(ch132)
         open (unit=2,file='result',status='old',        &
                    access='sequential',form='formatted')
2801     read(2,'(a)',end=2802)ch132
         l=index(ch132,'Absolute upper-left X:')
         if(l.gt.0) then
            ch8=ch132(l+22:l+29); call c8toi(ch8,lq);
            lq=lq-6; call itoc8(ch8,lq); ch6=ch8; ch6(1:1)='+'
         end if
         l=index(ch132,'Absolute upper-left Y:')
         if(l.gt.0) then
            ch8=ch132(l+22:l+29); call c8toi(ch8,lq);
            lq=lq-24; call itoc8(ch8,lq); ch8(1:1)='+'
         end if
         l=0
         if(index(ch132,'geometry').eq.0) goto 2801 
 2802    close(unit=2)         
         call nextchar(ch132,5,ipos,cp132,ih)
         l=index(cp132(:ih),'x')+2
         exten=cp132(:l)//TRIM(ch6)//TRIM(ch8)         
         lk=0
         do l=1,6
          if(namewin(l).eq.chl(1:6))lk=l
         end do
         if(lk.gt.0) then
          j=index(storewin(lk),' ')
          ch132=storewin(lk)(j:)
          storewin(lk)=TRIM(exten)//ch132          
        end if  
      end if   
      goto 2800
2804  continue
      close(unit=1)
      inquire(file='treewindow',exist=b_file)
      if(b_file)then
         print*,'tree'
         call execute_command_line('rm treewindow')
      end if
      end if

     open(unit=1,file='def_session'); write(1,'(a)')sessfile
     close(unit=1)

      chcom='effi/session/file' 
      filetype='session' 
      exten='cmd' 
      call rdfname(filetype,sessfile,exten,chcom,npl,nwr)
      if(sessfile.eq.' ') goto 1 
       open (unit=nini,file=sessfile                                   &
                         ,status='unknown'                             &
                         ,access='sequential'                          &
                         ,form='formatted')                            
      do k=1,mcom 
!      write(6,'(a)') comln(k)(1:npl)                                   
       jb=ntrimto0(comln(k)) 
       if(jb.eq.0)jb=1 
       write(nini,'(a)') comln(k)(1:jb) 
      end do 
      lines=0 
      do iset=1,maxs 
       if(ktheo(iset,0,0).gt.0) then 
        call nintstore(iset,1) 
                                                                        
        npanum(iset)=0 
        do isub=1,maxsub 
         if(n_int(isub,0).gt.0) npanum(iset)=isub 
        end do 
        if(npanum(iset).gt.0) lines=lines+1 
        ms=iset 
       end if 
      end do 
      if(lines.gt.0) then 
       write(nini,'(a,i5)') 'sets with subsets=',lines 
       do iset=1,ms 
        if(npanum(iset).gt.0) then 
!        analyse number of lines                                        
         ith=0 
         iss=0 
         k=ktheo(iset,0,0) 
         jb=1 
 2810    do while(ith.lt.jb*64.and.ktheo(iset,iss,0).gt.0) 
          ith=ith+ktheo(iset,iss,0) 
          iss=iss+1 
         end do 
         if(ith.gt.jb*64)then 
           iss=iss-1 
           ith=ith-ktheo(iset,iss,0) 
         end if 
         if(ktheo(iset,iss,0).gt.0) then 
          jb=jb+1 
          if(jb.gt.8) then 
           info=jb 
           infotext(1)='effi/structure/theory/write_sess' 
           infotext(2)='**fatal error** too many structure elements'
           infotext(3)='caused by the subspectra ({qu} program)  ' 
           infotext(4)=' ' 
           goto 1 
          end if 
          goto 2810 
         end if 
         write(nini,'(a,3i2)')'k_theo:',iset,npanum(iset),jb 
         ith=0 
         iss=0 
         ii=0 
         k=ktheo(iset,0,0) 
         jb=1 
 2811    do while(ith.lt.jb*64.and.ktheo(iset,iss,0).gt.0) 
          ith=ith+ktheo(iset,iss,0) 
          iss=iss+1 
         end do 
         if(ith.gt.jb*64)then 
           iss=iss-1 
           ith=ith-ktheo(iset,iss,0) 
         end if 
         write(nini,'(64i2)')                                           &
         ((ktheo(iset,i,j),j=1,ktheo(iset,i,0)),i=ii,iss-1)             
         if(ktheo(iset,iss,0).gt.0) then 
          jb=jb+1 
          ii=iss 
          goto 2811 
         end if 
                                                                        
         call nintstore(iset,1) 
         do isub=1,npanum(iset) 
          isc=n_int(isub,0) 
          write(nini,'(4i3,i4,38i3)')                                   &
          iset,n_subspect(iset),isub,isc,(n_int(isub,i),i=1,isc)        
         end do 
        end if 
       end do 
      end if 
!     write window positions                                            
      call plotexita() 
      j=0 
      do i=1,maxs 
       if(whandle(i).ge.0) then 
        j=j+1 
        iseq(j)=i 
       end if 
      end do 
      write(nini,'(a,16i5)') 'pos_win=',(iseq(i),i=1,j) 
      do k=1,j 
      ii=iseq(k) 
       write(nini,'(i2,4i5,i4,2i5,2i2,2f7.1,6g12.5)')                   &
           ndispmode(ii),sizex(ii),sizey(ii),posx(ii),posy(ii),         &
           v_plot(1,ii),v_plot(2,ii),v_plot(3,ii),                      &
           b_plot(1,ii),b_plot(2,ii),(r_plot(i,ii),i=1,8)               
      end do 
                                                                        
      write(nini,'(a,i5)') 'extra_window=',6 
      do k=1,6
         write(nini,'(a)')storewin(k)
      end do 
                                                                        
      i=0 
      do ks=1,maxs 
       j=ibadchan(0,ks) 
       if(j.gt.0) then 
        i=i+1 
        i10=j/16 
        i1=j-16*i10 
        iseq(2*i-1)=ks 
        iseq(2*i)=i10*16+i1 
       end if 
      end do 
      ii=i 
      if(ii.gt.0) then 
       write(nini,'(a,32i3)') 'bad_data=',(iseq(j),j=1,2*ii) 
       do i=1,ii 
        ks=iseq(2*i-1) 
        write(nini,'(16i6)')(ibadchan(j,ks),j=1,iseq(2*i)) 
       end do 
      else 
       write(nini,'(a,32i3)') 'bad_data=',0,0 
      end if 

      endfile nini 
      close(unit=nini) 
      close(unit=1) 
      if(iwritear.gt.0)then
       ch1='n'
       goto 2900
      end if                                                                  
      querytype='write interim results on file' 
      ch1='n' 
      chcom='effi/interim_results' 
      call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
      if(ch1.eq.'y')then
        b_procstore=.true.
        call procstore('wr') 
      end if
      goto 2900 

!     ******************************************************************
    case('qu')        ! exit with quit                  
!     ******************************************************************
      ch1='n' 
     goto 2900
  end select
     goto 1

 2900 continue
      do i=1,8 
       chwindim=chkill(i) 
       if(chwindim.ne.' ') then 
         close(unit=kwin+10) 
         call killwin(chwindim) 
       end if 
      end do
      inquire(file='storage.am',exist=b_file)    
      if(ch1.eq.'n'.and.b_file) call rmsto 
                                                                        
      return 
      END                                           
                                                                        
      subroutine forplotest 
      use glbconst,only: maxs,MDBPLFT
      implicit none 
     
      character(len=4):: chardum,cdum 
      integer, parameter:: idumplot=MDBPLFT*2 
      common/plot/ chardum(idumplot) 
      common/win/  cdum(19*maxs+406) 
                                                                        
      return 
      END                                           
                                                                        
     subroutine writeallplobat(nout,punfile,allbat) 
     implicit none 
     integer nout 
     character(len=132):: punfile,allbat 
     dimension allbat(14) 
                                                                       
     write(nout,'(a)')'     ***ALLPLO command file *** ' 
     write(nout,'(a)')'origin  x,y                 [0.0,0.0]         width xw,yw   [15.0,10.0]'
     write(nout,'(a)')'    borderwidth bx,by       [0.40,0.40]   character cw,ch   [0.40,0.40]'
     write(nout,'(a)')Trim(allbat(1)) 
     write(nout,'(a)')Trim(allbat(2)) 
     write(nout,'(a)')Trim(allbat(3))
     write(nout,'(a)')Trim(allbat(4)) 
     write(nout,'(a)')Trim(allbat(5)) 
     write(nout,'(a)')'data             file name  ['//TRIM(punfile)//']' 
     write(nout,'(a)')'    structure                                (allplo,effi)  [effi]'
     write(nout,'(a)')'    error bars (y/n)        [y]              clipping (y/n) [y]'      
     write(nout,'(a)')Trim(allbat(6)) 
     write(nout,'(a)')Trim(allbat(7)) 
     write(nout,'(a)')Trim(allbat(8)) 
     write(nout,'(a)')'    symbol sw,sh            [0.04,0.04]           pen width [0.03]'    
     write(nout,'(a)')'    symbols                 []' 
     write(nout,'(a)')'x-data                        (x ,log(x),10**x:  /lgx/pwx)  []'      
     write(nout,'(a)')Trim(allbat(9)) 
     write(nout,'(a)')Trim(allbat(10)) 
     write(nout,'(a)')'y-data                        (y ,log(y),10**y:  /lgy/pwy)  []'       
     write(nout,'(a)')Trim(allbat(11)) 
     write(nout,'(a)')Trim(allbat(12)) 
     write(nout,'(a)')'x-axis text size*           [1.0]       values, scale (y,n) [y,y]'  
     write(nout,'(a)')Trim(allbat(13)) 
     write(nout,'(a)')'y-axis text size*           [1.0]       values, scale (y,n) [y,y]'
     write(nout,'(a)')Trim(allbat(14))
     write(nout,'(a)')'text: c/x,y,hx,hy,angle,dist,b,$,@,u,o,f,F/n; text    file= []'
     write(nout,'(a)')'* termination line for extra text  (first letter  *)'
     write(nout,'(a)')'more                    y/n [n]       use old frame/scaling [n]'
     return 
     END                                           


     subroutine rmgnuplot 
!2759   pts/1    00:00:00 gnuplot_x11
     implicit none
     character(len=132)::comline
     character(len=6), dimension(32):: cps
     integer i,j
     
     comline='ps > gnuplot_x11.txt'
     call systemcmd(comline)
     
     open(unit=2,file='gnuplot_x11.txt',status='unknown'  &
          ,access='sequential',form='formatted')
     j=0
10   read(2,'(a)', end=100)comline
     if(index(comline,'gnuplot').gt.0)then
        j=j+1
        cps(j)=comline(1:6)
     end if
     goto 10
100  continue
     do i=1,j-3
        comline='kill '//cps(i)
       call systemcmd(comline)        
    end do
    comline='rm gnuplot_x11.txt'
    call systemcmd(comline)
    return
  end subroutine rmgnuplot
      
