	subroutine D10R6(NDIM)
        PARAMETER(FTOL=1.0E-6)
	DIMENSION P(NDIM),XI(NDIM,NDIM)
  real,    dimension(NDIM+1) :: thick
  real, dimension(NDIM+1,NDIM+1 ) :: att

  real, dimension(16):: el
  real, dimension(48):: Mecoeff
  integer, dimension(8):: ik,lk 
  character(len=12), dimension(8)::enel
  integer :: iP,ncol,nrd,nwr
  common/coeff/Mecoeff,el,ik,lk,enel,iP,ncol,nrd,nwr

  character(len=132):: querytype,chcom
  character(len=7)::form
  real value
  value=1.0 
        NP=NDIM
        XI=0.0
        do i=1,NDIM
           P(i)=0.005*float(i)
           XI(i,i)=1.0
        end do   
 1      do i=1,NDIM
           P(i)=P(i)*value
        end do
        do i=1,NDIM
         thick(i)=abs(P(i))
        end do
        nd=NDIM+1
        thick(nd)=0.0     
!    check of start values
     do k=1,nd        
      m=lk(k); i=ik(m)  
      do j=1,nd
       att(j,k)=exp(-thick(j)*Mecoeff(i+iP))*el(i)+exp(-thick(j)*Mecoeff(i+iP+1))*el(i+1)
      end do
     end do

     print'(/,16x,8f8.3)',(abs(P(i)),i=1,NDIM),0.0
     print'(a)'
     do k=1,nd
      print'(4x,a12,8f8.3)',enel(lk(k)),(att(j,k),j=1,nd)
     end do
     print'(a)'

     querytype=' common factor multiplied to start values of thickness'
     value=10.0
     chcom='background/start'
     form='f10.3'
     call askvalue(querytype,form,value,chcom,80,5,6) 
     if(value.ne.1.0) goto 1
     
     print*, 'FUNC=',FUNC(P,NDIM)
  
       FRET=FUNC(P,NDIM)

      CALL POWELL(P,XI,NDIM,NP,FTOL,ITER,FRET)        

      WRITE(*,'(/,A,I3)') ' Iterations:',ITER
      WRITE(*,'(A,8F12.6)')' Minimum at (mm thickness): ',(abs(P(I)),I=1,NDIM)
      WRITE(*,'(A,g12.3)') ' Minimized fuction row/det*column/det =',FRET

      nd=NDIM+1
      do i=1,NDIM
       thick(i)=abs(P(i))
      end do
      thick(nd)=0.0     
      do k=1,nd        
       m=lk(k); i=ik(m)  
       do j=1,nd
        att(j,k)=exp(-thick(j)*Mecoeff(i+iP))*el(i)+exp(-thick(j)*Mecoeff(i+iP+1))*el(i+1)
       end do
      end do

     print'(//,a)',' attenuation matrix (energy versus thickness):'
     print'(/,16x,8f8.3)',(abs(P(i)),i=1,NDIM),0.0
     print'(a)'
     do k=1,nd
      print'(4x,a12,8f8.3)',enel(lk(k)),(att(j,k),j=1,nd)
     end do
     print'(a)'
    end subroutine D10R6
      
 
     real FUNCTION FUNC(X,NDIM)
       implicit none
        integer, intent(in):: NDIM
	real, DIMENSION(NDIM), intent(inout):: X
        real, dimension(NDIM+1,NDIM+1)::wm
        real*8, dimension(NDIM+1,NDIM+1):: A
        real hv,hw,hdet,det3,scalar_uv
        real*8  eps      !desired precision
        real*8  DMGT     !Calculate determinant
        real, dimension(NDIM+1):: thick
        integer i,j,n

        n=NDIM+1
        do i=1,NDIM
         thick(i)=abs(X(i))
        end do
        thick(n)=0.0
        call  rintensities(n,thick,wm)
        
!        print*,'  X=',X
!        print'(4g10.3)',wm
!        read(5,*)
        hv=0.
      do i=1,n-1
         do j=i+1,n
            hv=hv+scalar_uv(n,wm(:,i),wm(:,j))
         end do
      end do
      hw=0.0
      do i=1,n-1
         do j=i+1,n
            hw=hw+scalar_uv(n,wm(i,:),wm(j,:))
         end do
      end do
        
        eps=1.0d-5
        A=wm
        hdet=DMGT(eps,n,A)
!        print*,hv,hw,hdet
        FUNC=(hv/hdet)*(hw/hdet)
!        FUNC=1./sqrt(abs(hdet))
!        print*, 'FUNC=',FUNC
! 5.222382    0.040314    1.115030    0.144308    0.383218   v*h/det**2
! 5.398673    0.045418    1.159403    0.154257    0.412197   v*h/abs
! 5.769784    0.055692    1.227029    0.170578    0.438277  v*h/sqrt
! 5.083165    0.036337    1.095197    0.138194    0.389591  1/sqrt
      end FUNCTION FUNC

        function scalar_uv(n,u,v)
          integer, intent(in)::n
          real, dimension(n), intent(in)::u,v
          real h
          integer i
          h=0.0
          do i=1,n
             h=h+u(i)*v(i)
          end do
          scalar_uv=h 
         end function scalar_uv
        



!The subroutine TSRGT applies to input real square matrix A(n,n) the upper
!triangularization algorithm of Gauss method with full pivoting and keeps
!trace of successive transformations done in integer vectors KP and LP.
!-----------------------------------------------------------------------------
!  Input parameters:
!  eps        precision (real*8)
!  n          size of A matrix (integer)
!  A          pointer to input real square matrix (real*8)
!  Output parameters:
!  it         flag=1 if A matrix ok, =0 if A matrix is singular (integer)
!  C          pointer to table storing main diagonal elements and supra-
!             diagonal elements of upper triangular matrix and the multi-
!             plying coefficients used during triangularization process
!  KP         table storing informations concerning the column exchanges
!             during process (integer)
!  LP         table storing informations concerning the line exchanges
!             during process (integer)
!-----------------------------------------------------------------------------
!The table C is first initialized to A matrix, then receives at each step k
!of the triangularization process, usefull elements of A matrix at step k for
!k=1,2,...n.
!The variables po(real*8), lo and ko(integer) store respectively pivot at step k,
!its line number and its column number.
!------------------------------------------------------------------------------
Subroutine TSRGT(eps, n, A, it, C, Kp, Lp)
  real*8 eps
  integer n,it
  real*8 A(n,n), C(n,n)
  integer Kp(n),Lp(n) 
  real*8  po,t0
  C=A; it=1; k=1
  do while (it==1.and.k<n)
    po=C(k,k); lo=k; ko=k
    do i=k, n
      do j=k, n
        if (dabs(C(i,j))>dabs(po)) then
          po=C(i,j); lo=i; ko=j
        end if
      end do
    end do
    Lp(k)=lo; Kp(k)=ko
    if (dabs(po)<eps) then
      it=0
    else
      if (lo.ne.k) then
        do j=k, n
          t0=C(k,j); C(k,j)=C(lo,j); C(lo,j)=t0
        end do
      end if
      if (ko.ne.k) then
        do i=1, n
          t0=C(i,k); C(i,k)=C(i,ko); C(i,ko)=t0
        end do
      end if 
      do i=k+1, n
        C(i,k)=C(i,k)/po
        do j=k+1, n
          C(i,j)=C(i,j)-C(i,k)*C(k,j)
        end do 
      end do
      k=k+1
    end if
  end do
  if (it==1.and.dabs(C(n,n))<eps)  it=0
  return
End !TSRGT

!The function DMGT returns the determinant of a real square matrix
!A(n,n) by Gauss method with full pivoting.
!----------------------------------------------------------------------------
!  Input parameters:
!  eps        precision (real*8)
!  n          size of A matrix (integer)
!  A          pointer to input real square matrix
!  Output parameters:
!  None
!-----------------------------------------------------------------------------
!The procedure TSRGT is used to reduce A matrix to an upper triangular matrix.
!Output variables are it(integer), C(n,n), Kp(n) and Lp(n).
!If it=0, matrix A is singular, if it=1, matrix A is regular. Table C contains
!at location i,j (j>=i) the corresponding element of the upper triangular matrix.
!Tables Lp and Kp contain informations relative to exchanges of line or column
!that occured during the process. For instance, the element number k of Lp is
!an integer <> k if an exchange of line has been made at step k (k=1,2,...,n).
!The number of exchanges of lines and columns is stored in integer L. the
!determinant of A matrix is stored in d0 (real*8).
!-----------------------------------------------------------------------------
real*8 Function DMGT(eps, n, A)
integer n
real*8 eps, A(n,n)
real*8 d0

real*8, pointer :: C(:,:)
integer,pointer :: Kp(:), Lp(:)

!allocate local matrix C and vectors Kp, Lp
  allocate(C(n,n),STAT=ialloc)
  allocate(Kp(n),STAT=ialloc)
  allocate(Lp(n),STAT=ialloc)

  call TSRGT(eps,n,A,it,C,Kp,Lp)  !call triangularization subroutine
  if (it==0) then
    d0=0.d0  !matrix singular, det=0
  else       !matrix regular, det<>0
    d0=1.d0
    do k=1, n
	  d0=d0*C(k,k)
    end do
    l=0
    do k=1, n-1
      if (Lp(k).ne.k)  l=l+1
      if (Kp(k).ne.k)  l=l+1
    end do
    if (MOD(l,2).ne.0) d0=-d0  !l is odd
  end if
  DMGT=d0   !return determinant
  return
End
