    PROGRAM deadtime
!   Driver for routine POWELL
    character(len=132) chin
    PARAMETER(ndim=2,FTOL=1.0E-6)
    real    P(NDIM),XI(NDIM,NDIM)

    integer ndata,icase
    common/dim/ndata,icase
    real, DIMENSION(ndim)::X
    real, DIMENSION(32)::out
    real, DIMENSION(128)::Yg,Dg
    real hno
    common/xyd/Yg,Dg,hno
    real YY,h,hi
    integer i
    
      open(unit=4,file='dist_count.dat'                              &
                ,status='unknown'                                    &
                ,access='sequential'                                 &
                ,form='formatted')

    read(4,'(a)')chin
    print*,TRIM(chin)
    read(4,'(a)')chin
    print*,TRIM(chin)
    call trlch(80,chin,nn,out) 
    ndata=out(1)
    icase=out(2) 
    do k=1,ndata
       read(4,'(a)') chin
       print*,TRIM(chin)       
       call trlch(80,chin,nn,out) 
       Dg(k)=out(1)
       Yg(k)=out(2)
    end do
    close(unit=4)
    hno=Yg(1)

    NP=NDIM
    
    XI=0.0
    do i=1,NDIM
     XI(i,i)=1.0
    end do

    if(icase.eq.1)then
     P(1)=0.5 
     P(2)=Yg(1)  
    else if(icase.eq.2) then
     P(1)=0.5 
     P(2)=Yg(1)
    else if(icase.eq.3) then  
     P(1)=0.5 
     P(2)=0.5
    end if
   

    CALL POWELL(P,XI,NDIM,NDIM,FTOL,ITER,FRET)
    WRITE(*,'(/1X,A,I3)') 'Iterations:',ITER
    WRITE(*,'(/1X,A/1X,3F12.6)') 'Minimum found at: ',(P(I),I=1,NDIM)
    WRITE(*,'(/1X,A,F12.6)') 'Minimum function value =',FRET

    open(unit=4,file='dist_count.apl'                              &
                ,status='unknown'                                    &
                ,access='sequential'                                 &
                ,form='formatted')
    taup=0.; taun=0.
    if(icase.eq.1)then
     taun=abs(P(1))  
    else if(icase.eq.2) then
     taup=abs(P(1))
    else if(icase.eq.3) then  
     taun=abs(P(1))      
     taup=abs(P(2))
    end if

    write(4,'(2(a,f6.2))')' paralyzable tauP=',taup,'  non-paralyzable tauN=',taun
     write(4,'(a)') 'distance factor'
     write(4,'(a)') 'counts/s [kHz]'
     do i=1,ndata     
      write(4,'(i5,2f8.2)')10, sqrt(Dg(i)),Yg(i)
     end do

     if(icase.le.2)then
      YY=P(2)     
     else
      YY=Yg(ndata)*Dg(ndata)
     end if
     Y=YY/hno
     print*,Y,YY,hno,taup
     h=YY*exp(-Y*taup)/(1.0+Y*taun)
     write(4,'(i5,2f8.2)')34,1.0,h
     do i=2,int(Dg(ndata))*2
      hi=float(i)/2.  
      h=YY/hi*exp(-Y/hi*taup)/(1.0+Y/hi*taun)
      write(4,'(i5,2f8.2)')0,sqrt(hi),h
!      write(4,'(2f10.2)')hi,h
     end do
   
     h=Y
     write(4,'(i5,2f8.2)')34, 1.0,h*hno
     do i=2,int(Dg(ndata))*2
      hi=float(i)/2.    
      h=Y/hi
      write(4,'(i5,2f8.2)')2000, sqrt(hi),h*hno
     END do
    close(unit=4)
  END PROGRAM deadtime

   FUNCTION FUNC(X)
   real, DIMENSION(2)::X
     integer ndata
    common/dim/ndata,icase
    real, DIMENSION(128)::Yg,Dg
    common/xyd/Yg,Dg,hno
    real h,taup,taun,Y,YY,hno

    ! hn0 factor: X(2)*tauP:tauN in the range of exp()
    if(icase.eq.1)then
     taun=abs(X(1))
     taup=0.0  
     YY=X(2)
    else if(icase.eq.2) then
     taup=abs(X(1))
     taun=0.0  
     YY=X(2)
    else if(icase.eq.3) then  
     taun=abs(X(1))
     taup=abs(X(2))  
     YY=Yg(ndata)*Dg(ndata)
    end if
    Y=YY/hno
     
    h=0.
    do i=1,ndata
       h=h+(Yg(i) -YY/Dg(i)*exp(-Y/Dg(i)*taup)/(1.0+Y/Dg(i)*taun))**2
!    print*,i,h,taup,taun, X(2)/Dg(i)*exp(-Y/Dg(i)*taup)/(1.0+Y/Dg(i)*taun)
    END do
    FUNC=h/3
    end


    subroutine trlch(n_ch,chin,iout,out) 
      implicit none
      character chin*132,ch*132 
      real      out(32),pt 
      integer nch,n_ch, &
              i,ic,i0,nsig,k,k1,k2,nex,nnum,iout 
!     program translates numbers (all possible fortran formates,        
!     separated by at least one blank or other character) given as ch*13
!     to iout real numbers (max.32) stored in the vector out.           
!     nch characters of ch(1:nch) are analysed.                         
      nch=n_ch 
      if(nch.gt.132) nch=132 
      ch=chin 
      i0=ichar('0') 
      nsig=1 
      pt=1. 
      k1=0 
      k2=0 
      nex=0 
      nnum=0 
      iout=0 
      do k=1,32 
       out(k)=0. 
      end do 
                                                                        
      k=0 
   10 k=k+1 
      i=ichar(ch(k:k))-i0 
      if(i.ge.0.and.i.lt.10) then 
       nnum=1 
       if (pt.eq.1.) then 
        out(iout+1)=out(iout+1)*10.+float(i) 
       else 
        out(iout+1)=out(iout+1)+float(i)*pt 
        pt=pt/10. 
       end if 
       if(k.eq.nch) goto 50 
       goto 100 
      end if 
                                                                        
      if(ch(k:k).eq.'e'.or.ch(k:k).eq.'E') then 
       if(nex.eq.1) goto 50 
       do i=k-1,1,-1 
        if(ch(i:i).eq.'.') then 
         nex=-1 
         goto 50 
        end if 
        ic=ichar(ch(i:i))-i0 
        if(ic.lt.0.or.ic.gt.9) goto 100 
       end do 
      end if 
                                                                        
      if(pt.lt.1.)then 
       k=k-1 
       goto 50 
      end if 
                                                                        
      if (ch(k:k).eq.'.') then 
        pt =0.1 
        goto 100 
      end if 
      if(ch(k:k).eq.'-') then 
        if(nsig.eq.1) k1=k 
        if(nsig.eq.-1) k2=k 
        nsig=-1 
      end if 
      if(nnum.eq.1) goto 50 
      if(nex.eq.1.and.ch(k:k).eq.' ') nex=0 
      goto 100 
                                                                        
   50 if(k1.lt.k) then 
       out(iout+1)=nsig*out(iout+1) 
       if(k2.lt.k1) then 
        nsig=1 
       else 
        k1=k2 
       end if 
      end if 
      nnum=0 
      pt=1. 
      if (nex.le.0) goto 60 
      out(iout)=out(iout)*10.**out(iout+1) 
      nex=0 
      out(iout+1)=0. 
      iout=iout-1 
   60 if (iout.eq.32) goto 110 
      iout=iout+1 
      k1=0 
      k2=0 
      if(nex.eq.-1) nex=1 
                                                                        
  100 if(k.lt.nch) goto 10 
  110 return 
      END                                           
                                                                        
 
