
     PROGRAM lorentz 

     CHARACTER TEXT*18 
     write(6,'(/,a,/)') 'calculation of % effect and  area of a single Lorentz absorption line' 
       write(6,'(a)') ' TYPE efective Thickness t_eff' 
     READ(5,*) X 
     WRITE(*,'(a,F12.4)')'t_eff=', X
      h0=BESSI0(X/2.)
      h1=BESSI1(X/2.)
      hn=X*EXP(-X/2)*(h0+h1)
      hd=1.-EXP(-X/2.)*h0
     WRITE(6,'(2(a,f12.6))')' BESSI0(X/2)=',h0, '        BESSI1(X/2)=',h1

     WRITE(6,'(2(a,f12.6))') ' effect                  1.- EXP(-X/2)*BESSI0(X/2)=',hd
     WRITE(6,'(2(a,f12.6))') ' G_exp/G=X*EXP(-X/2)*(BESSI0(X/2)+BESSI1(X/2))/(1.- EXP(-X/2)*BESSI0(X/2))'
     WRITE(6,'(2(a,f12.6))') ' G_exp/G=',hn/hd   

     END                                           
                                                                       
     FUNCTION BESSI0(X) 
     REAL(kind=8):: Y,P1,P2,P3,P4,P5,P6,P7,                            &
                    Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9                                    
     DATA P1,P2,P3,P4,P5,P6,P7/1.0D0,3.5156229D0,3.0899424D0,  &
                               1.2067492D0,                    &
                               0.2659732D0,0.360768D-1,0.45813D-2/                           
     DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,0.1328592D-1,        &
         0.225319D-2,-0.157565D-2,0.916281D-2,-0.2057706D-1,           &
         0.2635537D-1,-0.1647633D-1,0.392377D-2/                       
     IF (ABS(X).LT.3.75) THEN 
       Y=(X/3.75)**2 
       BESSI0=P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7))))) 
     ELSE 
       AX=ABS(X) 
       Y=3.75/AX 
       BESSI0=(EXP(AX)/SQRT(AX))*(Q1+Y*(Q2+Y*(Q3+Y*(Q4                 &
           +Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9))))))))                       
     ENDIF 
     RETURN 
     END                                           

     FUNCTION BESSI1(X)
      REAL*8 Y,P1,P2,P3,P4,P5,P6,P7,&
         Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9
      DATA P1,P2,P3,P4,P5,P6,P7/0.5D0,0.87890594D0,0.51498869D0,&
         0.15084934D0,0.2658733D-1,0.301532D-2,0.32411D-3/
      DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,-0.3988024D-1,&
         -0.362018D-2,0.163801D-2,-0.1031555D-1,0.2282967D-1,&
         -0.2895312D-1,0.1787654D-1,-0.420059D-2/
      IF (ABS(X).LT.3.75) THEN
        Y=(X/3.75)**2
        BESSI1=X*(P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7))))))
      ELSE
        AX=ABS(X)
        Y=3.75/AX
        BESSI1=(EXP(AX)/SQRT(AX))*(Q1+Y*(Q2+Y*(Q3+Y*(Q4+  &
           Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9))))))))
      ENDIF
      RETURN
      END

      FUNCTION BESSJ1(X)
      REAL*8 Y,P1,P2,P3,P4,P5,Q1,Q2,Q3,Q4,Q5,R1,R2,R3,R4,R5,R6,&
             S1,S2,S3,S4,S5,S6
      DATA R1,R2,R3,R4,R5,R6/72362614232.D0,-7895059235.D0,242396853.1D0,&
           -2972611.439D0,15704.48260D0,-30.16036606D0/,                  &
           S1,S2,S3,S4,S5,S6/144725228442.D0,2300535178.D0,               &
           18583304.74D0,99447.43394D0,376.9991397D0,1.D0/
      DATA P1,P2,P3,P4,P5/1.D0,.183105D-2,-.3516396496D-4,.2457520174D-5, &
          -.240337019D-6/, Q1,Q2,Q3,Q4,Q5/.04687499995D0,-.2002690873D-3, &
          .8449199096D-5,-.88228987D-6,.105787412D-6/
      IF(ABS(X).LT.8.)THEN
        Y=X**2
        BESSJ1=X*(R1+Y*(R2+Y*(R3+Y*(R4+Y*(R5+Y*R6)))))  &
               /(S1+Y*(S2+Y*(S3+Y*(S4+Y*(S5+Y*S6)))))
      ELSE
        AX=ABS(X)
        Z=8./AX
        Y=Z**2
        XX=AX-2.356194491
        BESSJ1=SQRT(.636619772/AX)*(COS(XX)*(P1+Y*(P2+Y*(P3+Y*(P4+Y &
            *P5))))-Z*SIN(XX)*(Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*Q5)))))       &
           *SIGN(1.,X)
      ENDIF
      RETURN
      END


      FUNCTION BESSJ0(X)
      REAL*8 Y,P1,P2,P3,P4,P5,Q1,Q2,Q3,Q4,Q5,R1,R2,R3,R4,R5,R6,    &
         S1,S2,S3,S4,S5,S6
      DATA P1,P2,P3,P4,P5/1.D0,-.1098628627D-2,.2734510407D-4,            &
         -.2073370639D-5,.2093887211D-6/, Q1,Q2,Q3,Q4,Q5/-.1562499995D-1, &
         .1430488765D-3,-.6911147651D-5,.7621095161D-6,-.934945152D-7/ 
      DATA R1,R2,R3,R4,R5,R6/57568490574.D0,-13362590354.D0,651619640.7D0, &
         -11214424.18D0,77392.33017D0,-184.9052456D0/, &
         S1,S2,S3,S4,S5,S6/57568490411.D0,1029532985.D0, &
         9494680.718D0,59272.64853D0,267.8532712D0,1.D0/
      IF(ABS(X).LT.8.)THEN
        Y=X**2
        BESSJ0=(R1+Y*(R2+Y*(R3+Y*(R4+Y*(R5+Y*R6))))) &
           /(S1+Y*(S2+Y*(S3+Y*(S4+Y*(S5+Y*S6)))))
      ELSE
        AX=ABS(X)
        Z=8./AX
        Y=Z**2
        XX=AX-.785398164
        BESSJ0=SQRT(.636619772/AX)*(COS(XX)*(P1+Y*(P2+Y*(P3+Y*(P4+Y &
           *P5))))-Z*SIN(XX)*(Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*Q5)))))
      ENDIF
      RETURN
      END
