 real*8 function omega(Asv,alpha,rQ,nQ,rB,nb)
  implicit none
  real*8, intent(in):: ASv,alpha
  real*8, intent(inout):: rB,rQ
  integer,intent(in):: nb
  integer,intent(inout):: nQ

  real*8 hv,pv,qv,rA,rA2,rB2,phi,dPhi,phimax8,phimax9,sinphi,cosphi,   &
         sinphi2,cosphi2,pv2,hn,hd,psi,dpsi,rho,drho,frQ,dfrQ,  &
        r8phi,r9phi,sinpsi,cospsi,cosalp,cosalp2,sinalp,sinalp2,pv2rA2
  real*8, dimension(0:nb):: t89phi
  real, parameter :: rad=0.01745329
  integer i,jr,kr
  real, dimension(8) :: phi0=(/0.0,60.0,30.0,19.0,14.0,11.0,9.0,7.0/)
  real, dimension(0:8)::rho0=(/0.0,1.0,sqrt(7.0),sqrt(19.0),   &
             sqrt(37.0),sqrt(61.0),sqrt(91.0),sqrt(127.0),sqrt(170.0)/)
  integer,dimension(8)::nphi=(/1,7,19,37,61,91,127,170/)

  jr=1
  kr=7
  do i=1,8
     if(nphi(i).le.nQ)then
      jr=nphi(i)
print*,jr,i
      kr=i
     end if 
  end do
  nQ=nphi(kr)
  drho=sqrt(rQ**2/float(nQ))
  
  omega=0.0; frq=0.0
  sinalp=sin(alpha*rad)**2; sinalp2=sinalp**2;
  cosalp=cos(alpha*rad);  cosalp2=cosalp**2
  rA=rB/sinalp; ra2=rA**2; rB2=rB**2

  dpsi=3.141583/32.0; drho=rQ/8.0

 do jr=0,31
  psi=dpsi*dfloat(jr)
  cospsi=cos(psi); sinpsi=sin(psi)

  do kr=0,7 
   rho=drho/2.0d0+drho*dfloat(kr)
   dfrQ=rho*drho*dpsi  
   frQ=frQ+dfrQ
   
   hv=(ASv+rho*cospsi)*sinalp
   pv=(ASv-rho*cospsi)*cosalp; pv2=pv**2
   rA=rB/sinalp
   qv=rho*sinpsi 

  
!  hv=1.d0; pv=6.0d0; rA=5.0; rB=1.d0; qv=0.5; ra2=rA**2; rB2=rB**2; pv2=pv**2

   pv2rA2=pv2-rA2
   hn=sqrt(rB2* pv2rA2+(rA*qv)**2)
  
   phimax8=atan((pv*qv-hn)/pv2rA2)
   phimax9=atan((pv*qv+hn)/pv2rA2)

!   print'(a,6f12.4)','phimax=',phimax8/rad,phimax9/rad
   dphi= (phimax9-phimax8)/dfloat(nb)

   do i=0,nb
    phi=phimax8+float(i)*dphi
    sinphi=sin(phi); cosphi=cos(phi); sinphi2=sinphi**2; cosphi2=cosphi**2
    hd=rA2*sinphi2+rB2*cosphi2

    hn=dabs(rB2*cosphi2- pv2rA2*sinphi2-(qv*cosphi)**2 &
              +2.d0*qv*cosphi*pv*sinphi)
    hn=rA*rB*sqrt(hn)

    r8phi=(rB2*cosphi*pv+rA2*qv*sinphi-hn)/hd
    r9phi=2.0*hn/hd
    t89phi(i)= 1.0d0/sqrt(1.0d0+(r8phi/hv)**2)     &
                      -1.0/sqrt(1.0+((r8phi+r9phi)/hv)**2)
   end do

   hn=0
   do i=1,nb-1,2 
    hn=hn+ t89phi(i)*2.0d0 
   end do 
   do i=2,nb-2,2 
    hn=hn+ t89phi(i) 
   end do
   omega=omega+(hn*2.d0+t89phi(0)+t89phi(nb))/3.d0*dphi*dfrQ
  end do
 end do
 omega=omega/frQ
! print*,'omega=',omega,frQ
 return
end function omega


