program attmat
 implicit none
  integer, dimension(12):: inth
  real, dimension(13):: thick,Cm
  character(len=12), dimension(8)::enel=(/'    57Fe14.4','   Fe122/136', &
        ' Rh20.2/22.7','   Fe6.4/7.0','   Cu8.0/8.9','   Zn8.6/9.6',&
        ' Pb10.5/12.6',' Pb72.8/75.0'/)
 integer, dimension(8)::lk=(/1,2,3,4,5,6,7,8/)

 integer :: nd,nt,n_ch,iout,ld,ncol,nrd,nwr,i,j
 character(len=132):: chin,querytype,deffile,chcom
 character(len=32) :: filetype,chdef1,chdef2,chdef3
 character(len=16) :: exten
 character(len=7)  :: form
 character(len=8)  :: ch8
 real :: Ntau,value
 real, dimension(32):: out   
 logical, dimension(8) :: enwr
   
      CALL get_command(chin)
      call nextchar(chin,4,i,querytype,j)
      ncol=80; nwr=6; nrd=5
      enwr=.false.
1      read(nrd,'(a)')chin
      if(index(chin,'he').gt.0) then
       chcom='overview'
       call help(chcom)  
       goto 1
      end if
      if(index(chin,'st').gt.0) then
       if(index(chin,'intcheck').gt.0) then
         enwr(1)=.true.
        else 
         chcom='enwr'
         call help(chcom)  
         goto 1
        end if
       end if
        
      ld=0
      exten='dat'
      filetype='thickness_counts'
       deffile=querytype
       chcom='filestructure'
       call readfile(filetype,deffile,exten,ld,chcom,ncol,nrd,nwr) 

       n_ch=80
       nt=10
        open(unit=4,file=deffile,status='old'        &
           ,access='sequential',form='formatted')
        READ(4,'(a)')chin
        print*,TRIM(chin)
        i=0
        chin=' '
        do while(index(chin,'----').eq.0)
          i=i+1
          READ(4,'(a)')chin
         call trlch(n_ch,chin,iout,out)
         j=out(1)
         if(j.eq.i)then         
          thick(i)=out(2)
          Cm(i)=out(3)
         end if
        end do
         nt=i-1

        do i=1,nt
         print'(i2,f8.4,f12.0)',i, thick(i),Cm(i)
        end do
        READ(4,'(a)')chdef1
        READ(4,'(a)')chdef2
        READ(4,'(a)')chdef3
        backspace(unit=4)
        backspace(unit=4)
        backspace(unit=4)
        
        inth=0
        chcom='selection/thickness'
9       chin=chdef1 
        querytype='select >=2 numbers from the sequence (thickness) n'        
        call askstring(querytype,chin,chcom,ncol,nrd,nwr) 

        call trlch(n_ch,chin,iout,out)
        if(iout.lt.2.or.iout.gt.8)then
           call help(chcom)
           goto 9
        end if
        nd=iout
        call itoc8(ch8,nd)
        do i=1,nd
           inth(i)=out(i)
        end do
        write(4,'(8i4)')(inth(i),i=1,nd)

        form='f6.2'
10      chin=chdef2
        call trlch(n_ch,chin,iout,out)
        value=out(1)
        chcom='deadtime/define'
        querytype='detector deadtime times total(ungated) counts'
        call askvalue(querytype,form,value,chcom,ncol,nrd,nwr)
        if(value.lt.0)then
         call help(chcom)
           goto 10
        end if
        Ntau=value
        write(4,'(f6.2)')Ntau

        print'(i3,4x,a12)',(i,enel(i),i=1,8)
        chcom='selection/energies'
11      chin=chdef3  
        querytype='select'//TRIM(ch8)//' numbers from the sequence of energies'
        call askstring(querytype,chin,chcom,ncol,nrd,nwr) 
        call trlch(n_ch,chin,iout,out)
        if(iout.lt.nd) then
           call help(chcom)
           goto 11
        end if
        do i=1,nd
         lk(i)=out(i)
        end do
        do i=1,nd
           do j=1,nd
              if(lk(i).eq.lk(j).and.i.ne.j)then
                 print*,'each energy only once'
                 goto 11
              end if
           end do
        end do
        write(4,'(8i3)')(lk(i),i=1,nd)       
     close(unit=4)
        
     print'(i3,4x,a12)',(lk(i),enel(lk(i)),i=1,nd)     
   call  rintensities(nd,nt,Ntau,thick,Cm,inth,lk,enel,enwr)     
 stop       
end  program attmat


subroutine rintensities(nd,nt,Ntau,thick,Cm,inth,lk,enel,enwr)
  integer,  intent(in):: nd,nt
  real,     intent(in):: Ntau
  real,    dimension(13), intent(in):: thick,Cm
  integer, dimension(12), intent(in):: inth
  integer, dimension(8),  intent(in)::lk

  real, dimension(16):: Nicoeff=(/79.06,57.43,72.646,72.646,0.286,0.233,28.24,21.39, &
                                  43.33,25.2,272.6,210.7,169.4,109.9,0.838,0.773/) 
  real, dimension(16):: Alcoeff=(/26.52,20.13,2.50,2.50,0.041,0.0391,0.914,0.691, &
                                   13.39,10.29,11.25,8.227,6.38,3.939,0.060,0.058/) 

!  1    2     3,4   5   6       7     8       9    10    11   12    13    14   15   16
!  Fe   Fe    Fe    Fe  Fe      Rh    Rh     Cu    Cu    Zn   Zn    Pb    Pb    Pb   Pb
! 6.40 7.06  14.4   122 136.5   20.15 22.7   8.05  8.905 8.62 9.57  10.5  12.6  72.8 75 
  real, dimension(16):: el=(/0.889,0.111,1.0,0.0,0.889,0.111,0.820,0.180,&
                             0.867,0.133,0.885,0.115,0.675,0.325,1.0,0.0/)
   integer, dimension(8):: ik=(/3,5,7,1,9,11,13,15/)  

   real, dimension(12,12):: att
   real, dimension(12):: RS,CN,EK
   real, dimension(nd,nd):: A,AI
   logical, dimension(8) :: enwr
   character(len=12), dimension(8)::enel
!  Fe64=0.889; Fe122=0.889; Rh20=0.820; Cu80=0.867; Zn96=0.885; Pb10=0.675



        Cm1=Cm(1)
        h=1./Cm1*Ntau
        do i=1,nd
         j=inth(i)
           CN(i)=Cm(j)/(1.-Cm(j)*h)
        end do
        print'(a)',' selected counts:'
        print'(12i4)',(inth(i),i=1,nd)
        print'(a,f6.2)',' corrected for deadtime[Nob/(1-Nob/N*Ntau)], Ntau=',Ntau
        print'(i15)',(int(CN(i)),i=1,nd)

    do k=1,nd        
      m=lk(k); i=ik(m)   
    do l=1,nd
     j=inth(l)
     if(j.lt.nt)then
if(enwr(1))print*,'name i,j=',enel(m),i,j
      att(k,l)=exp(-thick(j)*Alcoeff(i))*el(i)+exp(-thick(j)*Alcoeff(i+1))*el(i+1)
   else
if(enwr(1))print*,'name i,j=',enel(m),i,j      
      att(k,l)=exp(-thick(j)*Nicoeff(i))*el(i)+exp(-thick(j)*Nicoeff(i+1))*el(i+1)      
     end if
    end do
  end do
  
     do j=1,nd
       do i=1,nd
          A(i,j)=att(i,j)
       end do   
    end do

       call D2R1(nd,A,AI,enwr)

 ! calculating the matrix multiplication with small numbers        
        do i=1,nd
           CN(i)=CN(i)/Cm1
        end do
        
!      AI*CN
        do i=1,nd
           h=0.
           do k=1,nd
           h=h+AI(k,i)*CN(k)
           end do
           RS(i)=h
        end do
        h=0.
        do i=1,nd
           h=h+RS(i)
        end do
        print'(/,a,/)',' calculated relative intensities  normalized to 1'
        print'(8(2x,a12))',(enel(lk(i)),i=1,nd) 
        print'(8(2x,F12.5))', (RS(i)/h,i=1,nd)
        do k=1,nd        
         m=lk(k); i=ik(m)         
         if(i.eq.3) j=k
        end do 
        print'(a,f9.3)','     bg_fraction=',1.-RS(j)/h

! comparison with the non-selected counts
!               1    0.0000   5156711.   5162044.       2.3
   do k=1,8         
      m=lk(k); i=ik(m)     
    do j=1,nt-1
      att(k,j)=exp(-thick(j)*Alcoeff(i))*el(i)+exp(-thick(j)*Alcoeff(i+1))*el(i+1)
    end do
     att(k,nt)=exp(-thick(nt)*Nicoeff(i))*el(i)+exp(-thick(nt)*Nicoeff(i+1))*el(i+1)
   end do
     
!     do k=1,nd
!      print'(12f10.5)',(att(k,j),j=1,nt)
!     end do
  
    do j=1,nt
     h=0.
     do k=1,nd
        h=h+att(k,j)*RS(k)
     end do
     EK(j)=h*Cm1
    end do
   print'(/,a)','Nr    mm       counts     calc         *sigma'
    do j=1,nt
      EK(j)=EK(j)/(1.+EK(j)/Cm1*Ntau)
   end do
   print'(i2,f10.4,2f11.0,f10.1)',(i,thick(i),Cm(i),EK(i),(EK(i)-Cm(i))/sqrt(Cm(i)),i=1,nt)

   return
  end 


	subroutine D2R1(nd,A,AI,enwr)
!	Driver program for subroutine GAUSSJ
!	Reads Matrices from file MATRIX.DAT and feeds them to GAUSSJ
	real, DIMENSION(nd,nd) :: A,B,AI,X
        real, DIMENSION(nd,nd) :: U,T
        logical, dimension(8)  :: enwr 

     if(enwr(1)) print'(/,a)', ' internal***********************************'

     do j=1,nd
       B(j,1)=float(j)
     end do 
     N=nd; M=1; NP=nd
     if(enwr(1))then
       WRITE(*,'(a)') '(A(K,L), L=1,N)'
       DO  K=1,N
         WRITE(*,'(1H,(12F12.5))') (A(K,L), L=1,N)
       end do
      end if
!	Save Matrices for later testing of results
	DO 13 L=1,N
		DO 11 K=1,N
			AI(K,L)=A(K,L)
11		CONTINUE
		DO 12 K=1,M
			X(L,K)=B(L,K)
12		CONTINUE
13	CONTINUE

      !	Invert Matrix
	CALL GAUSSJ(AI,N,NP,X,M,NP)

       if(enwr(1)) then
        WRITE(*,*) 'Inverse of Matrix A : '
        DO 14 K=1,N
          WRITE(*,'(1H,(12F12.5))') (AI(K,L), L=1,N)
14	CONTINUE
!	Check Inverse
	WRITE(*,*) 'A times A-inverse (compare with unit matrix)'
	DO 17 K=1,N
		DO 16 L=1,N
			U(K,L)=0.0
			DO 15 J=1,N
				U(K,L)=U(K,L)+A(K,J)*AI(J,L)
15			CONTINUE
16		CONTINUE
		WRITE(*,'(1H,(12F12.5))') (U(K,L), L=1,N)
17	CONTINUE
!	Check Vector Solutions
	WRITE(*,*) 'Check the following vectors for equality:'
	WRITE(*,'(T12,A8,T23,A12)') 'Original','Matrix*Sol''n'
	DO 21 L=1,M
	        WRITE(*,'(1X,A,I2,A)') 'Vector ',L,':'
		DO 19 K=1,N
			T(K,L)=0.0
			DO 18 J=1,N
				T(K,L)=T(K,L)+A(K,J)*X(J,L)
18			CONTINUE
		WRITE(*,'(8X,2F12.6)') B(K,L),T(K,L)
19		CONTINUE
21	CONTINUE
	print'(a,/)', '************************** end internal'
       end if
     return
     END 

  subroutine GAUSSJ(A,N,NP,B,M,MP)
      PARAMETER (NMAX=50)
      DIMENSION A(NP,NP),B(NP,MP),IPIV(NMAX),INDXR(NMAX),INDXC(NMAX)
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (ABS(A(J,K)).GE.BIG)THEN
                  BIG=ABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSE IF (IPIV(K).GT.1) THEN
                print*, 'Singular matrix'
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
        IF (A(ICOL,ICOL).EQ.0.) print*,'Singular matrix.'
        PIVINV=1./A(ICOL,ICOL)
        A(ICOL,ICOL)=1.
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=0.
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN
          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END
